(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)









(* :Title: ComplexMapDrawing *)
(* :Context: DrawGraphics`ComplexMapDrawing` *)
(* :Author: David J. M. Park Jr. djmp@earthlink.net *)
(* :Summary: 
      This is an auxiliary package to DrawingPaper which loads the \
Graphics`ComplexMap` package and provides the drawing routines which go with \
it. *)
(* :Copyright: \[Copyright] 1998, 2000, 2001 by David J. M. Park Jr. *)
(* :Package Version: 2.0 *)
(* :Mathematica Version: 4.0 *)
(* :Keywords: graphics, plot combinations, ComplexMap *)
(* :Requirements: Graphics`ComplexMap` *)





BeginPackage["DrawGraphics`ComplexMapDrawing`",{"Graphics`ComplexMap`"}]

DrawGraphics`ComplexMapDrawing::usage="ComplexMapDrawing is an auxiliary \
package to DrawGraphics that loads the Graphics`ComplexMap` package and \
provides the drawing routines which go with it."



DrawCartesianMap::usage="DrawCartesianMap[f, {x0, x1, (dx)}, {y0, y1, (dy)}, \
opts...] draws the image of the cartesian coordinate lines under the function \
f. The default values of dx and dy are chosen so that the number of lines is \
equal to the value of the option Lines. The primitive Graphics objects are \
extracted from the corresponding CartesianMap routine. Options may be passed \
to CartesianMap through the last arguments.";



DrawPolarMap::usage="DrawPolarMap[f, {r0:0, r1, (dr)}, {phi0, phi1, (dphi)}, \
opts...] draws the image of the polar coordinate lines under the function f. \
The default for the phi range is {0, 2Pi}. The default values of dr and dphi \
are chosen so that the number of lines is equal to the value of the option \
Lines. The primitive Graphics objects are extracted from the corresponding \
PolarMap routine. Options may be passed to PolarMap through the last \
arguments.";



Begin["`Private`"]



DrawCartesianMap[f_,xrange_List,yrange_List,opts___?OptionQ]:=
  First[CartesianMap[f,xrange,yrange,DisplayFunction\[Rule]Identity,
      Evaluate[opts]]]



DrawPolarMap[f_,rrange_List,phirange_List,opts___?OptionQ]:=
  First[PolarMap[f,rrange,phirange,DisplayFunction\[Rule]Identity,
      Evaluate[opts]]];
DrawPolarMap[f_,rrange_List,opts___?OptionQ]:=
  First[PolarMap[f,rrange,DisplayFunction\[Rule]Identity,Evaluate[opts]]]



End[]

Protect[DrawCartesianMap,DrawPolarMap]

EndPackage[]