(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)







(* :Title: DrawingArrows *)
(* :Context: DrawGraphics`DrawingArrows` *)
(* :Author: David J. M. Park Jr. djmp@earthlink.net *)
(* :Summary: Provides routines for drawing 2D and 3D arrows. *)
(* :Copyright: \[Copyright] 1998, 2001 by David J. M. Park Jr. *)
(* :Package Version: 2.0 *)
(* :Mathematica Version: 4.0 *)
(* :Keywords: Graphics, Graphics3D, plot combinations, arrows *)
(* :Requirements: Graphics`Arrow` *)



BeginPackage["DrawGraphics`DrawingArrows`",{"Graphics`Arrow`",
    "DrawGraphics`DrawingPaper`"}]

DrawGraphics`DrawingArrows::usage="DrawingArrows contains routines for drawing 2D and 3D arrows on lines and curves. It loads the standard Graphics`Arrow package. New usages have been added for the Arrow routine.";





AAArrowOptions::usage="AAArrowOptions is an option for AngleArc. It may be used to pass a List of options to prepend the default options passed to the Arrow routine. The default options are {HeadScaling \[Rule] Relative, HeadCenter \[Rule] 1, HeadLength \[Rule] 0.1}";

AAStyleOptions::usage="AAStyleOptions is an option for AngleArc. The angle label is formatted with StyleForm inside a Text statement. This option may be used to pass a List of options to prepend the default options passed to StyleForm. The default options are {FontSize \[Rule] 10, FontColor \[Rule] RGBColor[0,0,0]}.";

AATextOptions::usage="AATextOptions is an option for AngleArc.  The angle label is formatted with StyleForm inside a Text statement. This option may be used to pass a List of options to prepend the default options passed to the Text statement. The default options are {Background \[Rule] Automatic}";

AngleArc::usage="AngleArc[center, {\[Theta]1, \[Theta]2}, radius, label:Null, opts] will draw a directed arc about center from angle \[Theta]1 to \[Theta]2 with the specified radius. The arc will have an arrow at \[Theta]2. If the optional argument label is not Null, the arc will be labeled at the center of the arc. The arcs will be circular only if AspectRatio \[Rule] Automatic. The options are AAArrowOptions, AAStyleOptions and AATextOptions.";\





AngleSquare::usage="AngleSquare[location, \[Theta], size, outlinecolor] will draw a square right angle bracket of the given size. The angle is at the given location and starts at the angle \[Theta]. The square is completed by moving in a counterclockwise direction from \[Theta]. The bracket will be square only if AspectRatio \[Rule] Automatic.\nAngleSquare[location, \[Theta], size, outlinecolor, squarecolor] will fill the bracket with a color. In this case the AngleSquare should be drawn before any other lines that bound it else the color will cover them.";



$NewMessage[Arrow,"usage"]
Arrow::usage=Arrow::usage<>"\nArrow[{start, finish}, opts...] is the same as Arrow[start, finish, opts]\nArrow[start, l, \[Theta], opts...] will draw an arrow from start at an angle \[Theta] to the x axis and of length l.";



Arrow3D::usage="Arrow3D[base, tip, options...] will draw an arrow with a cone for an arrowhead. The options are HeadScaling3D, HeadLength3D, HeadWidth3D and HeadSegments3D.";

HeadScaling3D::usage="HeadScaling3D is an option for Arrow3D. Its default value is Relative which specifies the length of the arrow from base to tip as the scale for the cone. An alternative is to give a specific length in the actual plot scale which will be used as the scale.";

HeadLength3D::usage="HeadLength3D is an option for Arrow3D which gives the cone length as a fraction of the scale established by HeadScaling3D. It default value is 0.10.";

HeadWidth3D::usage="HeadWidth3D is an option for Arrow3D which gives the full cone width as a fraction of the cone length. Its default value is 0.5.";

HeadSegments3D::usage="HeadSegments3D is an option for Arrow3D which specifies the number of polygonal segments used in the cone. The default value is 10. The minimum value of 2 gives a flat arrowhead.";



ArrowCurve::usage="ArrowCurve[graphics, fraction, opts...] will put arrowheads on all the curves (Lines with more than two points) in graphics. The arrowheads are put at a distance fraction*curvelength from the beginning of each curve. The routine uses the first pair of plot points that exceed or equal the fractional distance along the curve. The regular Arrow options can be passed to the underlying Arrow routine. The choice HeadScaling \[Rule] Relative should not be used because the length of the arrow drawn will generally be quite short.";



ArrowCurve3D::usage="ArrowCurve3D[graphics, fraction, opts...] will put arrowheads on all the curves (Lines with more than two points) in graphics. The arrowheads are put at a distance fraction*curvelength from the beginning of each curve. The routine uses the first pair of plot points that exceed or equal the fractional distance along the curve. The regular Arrow3D options can be passed to the underlying Arrow routine. The meaning of HeadScaling3D \[Rule] Relative is taken to mean relative to the length of the curve.";



ArrowLine::usage="ArrowLine[points, opts...] has the same usage as Line but will put an arrowhead at the position of the last point. Options may be passed to the Arrow routine.";



ArrowLine3D::usage="ArrowLine3D[points, opts...] has the same usage as Line but will put an arrowcone at the position of the last point. Options may be passed to the ArrowCurve3D routine which is used to draw the arrowcone.";



ArrowTangent::usage="ArrowTangent[point, vector, opts...] will draw the 2D vector starting at point. Options may be passed to the Arrow routine.";



ArrowTangent3D::usage="ArrowTangent3D[point, vector, opts...] will draw the 3D vector starting at point. Options may be passed to the Arrow3D routine.";



ProportionalArrow::usage="ProportionalArrow[fraction][start, finish, opts...] will draw a directed line segment using the Arrow routine, where the tip of the arrowhead is at the fraction of the distance between start and finish. Any options are passed to the Arrow routine.";



ProportionalArrow3D::usage="ProportionalArrow3D[frac][start, finish, opts...] will draw a directed line segment using the Arrow3D routine, where the tip of the arrowhead is at the fraction of the distance between start and finish. Any options are passed to the Arrow3D routine.";



Arrow2D::usage="Arrow2D[origin, vector, options...] will draw a 2D arrow. Arrow2D is designed to work with plots with Automatic AspectRatio, but it otherwise more verstile and robust.";

HeadLength2D::usage="HeadLength2D is an option for Arrow2D with default value 0.15. It specifies the length of the arrowhead in terms of the base length. If HeadScaling is Relative the base length is the length of the arrow. If HeadScaling has a specific value that is the base length.";

HeadWidth2D::usage="HeadWidth2D is an option for Arrow2D that specifies the width of the arrowhead in terms of its length. The default value is 0.5.";

HeadColor2D::usage="HeadColor2D is an option for Arrow2D with the default value of Black.";

ShaftColor2D::usage="ShaftColor2D is an option for Arrow2D with the default value of Black.";

HeadPosition2D::usage="HeadPosition is an option for Arrow2D that specified the fractional position along the shaft to place the center of the arrow head. It has a default value of Automatic, which places the tip at the end of the shaft.";

HeadScaling2D::usage="HeadScaling2D is an option for Arrow2D. It may specify either Relative or a specific base reference length.";



Begin["`Private`"]



Options[AngleArc]={AAArrowOptions\[Rule]{},
      AAStyleOptions\[Rule]{},
      AATextOptions\[Rule]{}};

AngleArc[center:{_,_},{\[Theta]1_,\[Theta]2_},radius_,label_:Null,
    opts___?OptionQ]:=
  Module[{pts,g,\[Theta],arrowopts,styleopts,textopts},
    
    arrowopts=
      Join[AAArrowOptions/.{opts}/.Options[AngleArc],{HeadScaling\[Rule]
            Relative,HeadCenter\[Rule]1,HeadLength\[Rule]0.1}];
    styleopts=
      Join[AAStyleOptions/.{opts}/.Options[AngleArc],{FontSize\[Rule]10,
          FontColor\[Rule]RGBColor[0,0,0]}];
    textopts=
      Join[AATextOptions/.{opts}/.Options[AngleArc],{Background\[Rule]
            Automatic}];
    If[Head[#]=!=List,#=List[#]]&/@{arrowopts,styleopts,textopts};
    
    pts=Max[5,Ceiling[N[Abs[\[Theta]2-\[Theta]1]/Degree/2.5]]];
    g=Line@
        Table[center+
            radius{Cos[\[Theta]],
                Sin[\[Theta]]},{\[Theta],\[Theta]1,\[Theta]2,(\[Theta]2-\
\[Theta]1)/(pts-1)}];
    {g,
      ArrowCurve[g,1,Sequence@@arrowopts],
      If[label=!=Null,
        Text[StyleForm[label,Sequence@@styleopts],
          center+radius{Cos[\[Theta]1+2/5(\[Theta]2-\[Theta]1)],
                Sin[\[Theta]1+2/5(\[Theta]2-\[Theta]1)]},
          Sequence@@textopts],{}]}
    ]



AngleSquare[location_,\[Theta]_,size_,outlinecolor_]:=
  AngleSquare[location,\[Theta],size,outlinecolor,Null]

AngleSquare[location_,\[Theta]_,size_,outlinecolor_,squarecolor_]:=
  Module[{pt2,pt3,pt4},
    pt2=location+size{Cos[\[Theta]],Sin[\[Theta]]};
    pt3=pt2+size{-Sin[\[Theta]],Cos[\[Theta]]};
    pt4=pt3-size{Cos[\[Theta]],Sin[\[Theta]]};
    {If[squarecolor=!=Null,{squarecolor,Polygon[{location,pt2,pt3,pt4}]},{}],
      outlinecolor,Line[{pt2,pt3,pt4}]}
    ]



Arrow[{start:{_,_},end:{_,_}},opts___?OptionQ]:=Arrow[start,end,opts]
Arrow[start:{_,_},l_?NumericQ,\[Theta]_?NumericQ,opts___?OptionQ]:=
  Arrow[start,l{Cos[\[Theta]],Sin[\[Theta]]},opts]



\!\(\(Options[Arrow3D] = {HeadScaling3D \[Rule] Relative, HeadLength3D \[Rule] 0.10, HeadWidth3D \[Rule] 0.5, HeadSegments3D \[Rule] 10};\)\[IndentingNewLine]
  \(Arrow3D[base : {_, _, _}, tip : {_, _, _}, ___] /; base == tip := Point[base];\)\n
  Arrow3D[base : {_, _, _}, tip : {_, _, _}, opts___?OptionQ] := \[IndentingNewLine]Module[{length, halfwidth, polys, scaletype, scale, anOrthogonalVector, normalize, rotationmatrix, mycome}, \[IndentingNewLine]anOrthogonalVector[norm : {_, _, _}] := \n\tBlock[{pos, a, b, v1}, \n\t\tpos = If[VectorQ[norm, NumberQ], Abs[N[norm]], norm]; \n\t\tpos = Sort[Transpose[{pos, Range[3]}]]; \n\t\t{pos, a, b} = Map[Last, pos]; \n\t\tv1 = ReplacePart[{0, 0, 0}, \(-Part[norm, a]\), b]; \n\t\tReplacePart[v1, Part[norm, b], a]]; \nnormalize[vec_] := vec/\@\(vec . vec\); \nrotationmatrix[axis_, \[Theta]_] := \n\tModule[{n1, n2, n3}, \n\t\t{n1, n2, n3} = normalize[axis] // N; \n\t\t{{n1\^2 + \((1 - n1\^2)\) Cos[\[Theta]], n1\ n2 \((1 - Cos[\[Theta]])\) + n3\ Sin[\[Theta]], n1\ n3 \((1 - Cos[\[Theta]])\) - n2\ Sin[\[Theta]]}, {n1\ n2 \((1 - Cos[\[Theta]])\) - n3\ Sin[\[Theta]], n2\^2 + \((1 - n2\^2)\) Cos[\[Theta]], n2\ n3 \((1 - Cos[\[Theta]])\) + n1\ Sin[\[Theta]]}, {n1\ n3 \((1 - Cos[\[Theta]])\) + n2\ Sin[\[Theta]], n2\ n3 \((1 - Cos[\[Theta]])\) - n1\ Sin[\[Theta]], n3\^2 + \((1 - n3\^2)\) Cos[\[Theta]]}} // N\n\t\t]; \nmycone[vec_, tipp_, polys_, halfwidth_, length_] := \n\tBlock[{norm = normalize[anOrthogonalVector[vec]], \[Theta], \[CapitalDelta]\[Theta] = 2  \[Pi]/polys, nvec = normalize[vec]}, \n\t\tTable[Polygon[{tipp, tipp + halfwidth\ \((norm . rotationmatrix[vec, \ \[Theta]])\) - length\ nvec, tipp + halfwidth\ \((norm . rotationmatrix[vec, \ \[Theta] + \[CapitalDelta]\[Theta]])\) - length\ nvec}], {\[Theta], 0, 2  \[Pi] - \[CapitalDelta]\[Theta], \[CapitalDelta]\[Theta]}] // N]; \[IndentingNewLine]\[IndentingNewLine]scaletype = \(HeadScaling3D /. {opts}\) /. Options[Arrow3D]; \[IndentingNewLine]length = \(HeadLength3D /. {opts}\) /. Options[Arrow3D]; \[IndentingNewLine]halfwidth = \((\(HeadWidth3D /. {opts}\) /. Options[Arrow3D])\)/2; \[IndentingNewLine]polys = \(HeadSegments3D /. {opts}\) /. Options[Arrow3D]; \[IndentingNewLine]polys = Max[2, polys]; \[IndentingNewLine]scale = If[scaletype === Relative, \@\(\((tip - base)\) . \((tip - base)\)\), scaletype]; \[IndentingNewLine]length = length*scale; \[IndentingNewLine]halfwidth = length*halfwidth; \[IndentingNewLine]\[IndentingNewLine]{Line[{base, base + 0.999 \((tip - base)\)}], mycone[tip - base, tip, polys, halfwidth, length]}]\)



\!\(ArrowCurve[graphics_, fraction_, opts___?OptionQ] := \[IndentingNewLine]Module[{ncases, cases, case, clength, clength2, npoints, norm, npos, frac, i, j, scale, tlength, hlength}, \[IndentingNewLine]scale = \(HeadScaling /. {opts}\) /. Options[Arrow]; \[IndentingNewLine]hlength = \(HeadLength /. {opts}\) /. Options[Arrow]; \[IndentingNewLine]norm[v_] := N[\@\(v . v\)]; \[IndentingNewLine]frac = Min[1, Max[0, fraction]]; \[IndentingNewLine]cases = Select[Cases[{graphics}, Line[_], \[Infinity]] /. Line[a_] \[Rule] a, Length[#] > 2 &]; \[IndentingNewLine]ncases = Length[cases]; \[IndentingNewLine]Table[\[IndentingNewLine]case = cases\[LeftDoubleBracket]j\[RightDoubleBracket]; \[IndentingNewLine]npoints = Length[case]; \[IndentingNewLine]clength = Partition[case, 2, 1]; \[IndentingNewLine]clength2 = \(clength = \(\(norm[#2 - #1] &\) @@ # &\) /@ clength\); \[IndentingNewLine]Do[clength\[LeftDoubleBracket]i\[RightDoubleBracket] = clength\[LeftDoubleBracket]i\[RightDoubleBracket] + clength\[LeftDoubleBracket]i - 1\[RightDoubleBracket], {i, 2, Length[clength]}]; \[IndentingNewLine]tlength = Last[clength]; \[IndentingNewLine]clength = Abs[clength/Last[clength] - frac]; \[IndentingNewLine]npos = \(Position[clength, Min[clength], {1}, 1]\)\[LeftDoubleBracket]1, 1\[RightDoubleBracket]; \[IndentingNewLine]Arrow[case\[LeftDoubleBracket]npos\[RightDoubleBracket], case\[LeftDoubleBracket]npos + 1\[RightDoubleBracket], Sequence @@ If[scale === Relative, Join[{HeadLength \[Rule] tlength/clength2\[LeftDoubleBracket]npos\[RightDoubleBracket] hlength}, {opts}], {opts}]], {j, 1, ncases}]\[IndentingNewLine]]\)



\!\(ArrowCurve3D[graphics_, fraction_, opts___?OptionQ] := \[IndentingNewLine]Module[{g, ncases, cases, case, clength, npoints, norm, npos, frac, i, j, scale}, \[IndentingNewLine]norm[v_] := N[\@\(v . v\)]; \[IndentingNewLine]scale = \(HeadScaling3D /. {opts}\) /. Options[Arrow3D]; \[IndentingNewLine]frac = Min[1, Max[0, fraction]]; \[IndentingNewLine]g = graphics //. {a___, Line[{p1__, p2_}], Line[{p2_, p3__}], b___} \[Rule] {a, Line[{p1, p2, p3}], b}; \[IndentingNewLine]cases = Select[Cases[{g}, Line[_], \[Infinity]] /. Line[a_] \[Rule] a, Length[#] > 2 &]; \[IndentingNewLine]ncases = Length[cases]; \[IndentingNewLine]Table[\[IndentingNewLine]case = cases\[LeftDoubleBracket]j\[RightDoubleBracket]; \[IndentingNewLine]npoints = Length[case]; \[IndentingNewLine]clength = Partition[case, 2, 1]; \[IndentingNewLine]clength = \(\(norm[#2 - #1] &\) @@ # &\) /@ clength; \[IndentingNewLine]Do[clength\[LeftDoubleBracket]i\[RightDoubleBracket] = clength\[LeftDoubleBracket]i\[RightDoubleBracket] + clength\[LeftDoubleBracket]i - 1\[RightDoubleBracket], {i, 2, Length[clength]}]; \[IndentingNewLine]If[\[Not] NumberQ[scale], scale = Last[clength]]; \[IndentingNewLine]npos = \(Position[clength, a_ /; a \[GreaterEqual] frac\ Last[clength], {1}, 1]\)\[LeftDoubleBracket]1, 1\[RightDoubleBracket]; \[IndentingNewLine]Arrow3D[case\[LeftDoubleBracket]npos\[RightDoubleBracket], case\[LeftDoubleBracket]npos + 1\[RightDoubleBracket], HeadScaling3D \[Rule] scale, opts], {j, 1, ncases}]\[IndentingNewLine]]\)



ArrowLine[pts:{{_,_}..},opts___]:=
  With[{l=Line[pts]},
    {l,ArrowCurve[l,1,opts]}]



ArrowLine3D[pts:{{_,_,_}..},opts___]:=
  With[{l=Line[pts]},
    {l,ArrowCurve3D[{l},1,opts]}]



ArrowTangent[point:{_,_},vector:{_,_},opts___]:=Arrow[point,point+vector,opts]



ArrowTangent3D[point:{_,_,_},vector:{_,_,_},opts___]:=
  Arrow3D[point,point+vector,opts]







ProportionalArrow[fraction_][start_,finish_,opts___]:=
  Module[{scale,hlength},
    scale=HeadScaling/.{opts}/.Options[Arrow];
    hlength=HeadLength/.{opts}/.Options[Arrow];
    {Arrow[start,start+fraction (finish-start),
        Sequence@@
          If[scale===Relative,
            Join[{HeadLength\[Rule] hlength/fraction},{opts}],{opts}]],
      Line[{start+fraction (finish-start),finish}]}]



ProportionalArrow3D[fraction_][start_,finish_,opts___]:=
  Module[{scale,length},
    scale=HeadScaling3D/.{opts}/.Options[Arrow3D];
    length=HeadLength3D/.{opts}/.Options[Arrow3D];
    {Arrow3D[start,start+fraction (finish-start),
        HeadLength3D\[RuleDelayed]
          If[scale===Relative, length/fraction,length],opts],
      Line[{start+fraction (finish-start),finish}]}]



Options[Arrow2D]={HeadScaling2D\[Rule]Relative,HeadLength2D\[Rule]0.15,
      HeadWidth2D\[Rule]0.5,HeadCenter2D\[Rule]0.5,
      HeadColor2D\[Rule]RGBColor[0,0,0],ShaftColor2D\[Rule]RGBColor[0,0,0],
      HeadPosition2D\[Rule]Automatic};

\!\(Arrow2D[{xorg_, yorg_}, vec : {_, _}, opts___?OptionQ] := \[IndentingNewLine]Module[{p0, p1, p2, p3, f, sl, l, w, c, W, C, hcolor, scolor, m, \[Theta]}, \[IndentingNewLine]\[IndentingNewLine]f = \(HeadPosition2D /. {opts}\) /. Options[Arrow2D]; \[IndentingNewLine]l = \(HeadLength2D /. {opts}\) /. Options[Arrow2D]; \[IndentingNewLine]W = \(HeadWidth2D /. {opts}\) /. Options[Arrow2D]; \[IndentingNewLine]C = \(HeadCenter2D /. {opts}\) /. Options[Arrow2D]; \[IndentingNewLine]sl = \(HeadScaling2D /. {opts}\) /. Options[Arrow2D]; \[IndentingNewLine]hcolor = \(HeadColor2D /. {opts}\) /. Options[Arrow2D]; \[IndentingNewLine]scolor = \(ShaftColor2D /. {opts}\) /. Options[Arrow2D]; \[IndentingNewLine]\[IndentingNewLine]sl = If[sl === Relative, 1, sl, 1]; \[IndentingNewLine]l = sl\ l; \[IndentingNewLine]w = l\ W; \[IndentingNewLine]c = l\ C; \[IndentingNewLine]f = If[f === Automatic, 1, f + l/2, 1]; \[IndentingNewLine]m = N[\@\(vec . vec\)]; \[IndentingNewLine]\[Theta] = ArcTan @@ N[vec]; \[IndentingNewLine]\[IndentingNewLine]p0 = m {f, 0}; \[IndentingNewLine]p1 = m {f - l, w/2}; \[IndentingNewLine]p2 = m {f - c, 0}; \[IndentingNewLine]p3 = m {f - l, \(-w\)/2}; \[IndentingNewLine]\[IndentingNewLine]{scolor, Line[{{0, 0}, {m, 0}}], hcolor, Polygon[{p0, p1, p2, p3, p0}]} /. DrawingTransform[xorg + #1  Cos[\[Theta]] - #2  Sin[\[Theta]] &, yorg + #1  Sin[\[Theta]] + #2  Cos[\[Theta]] &]\[IndentingNewLine]]\)



End[]

Protect[Evaluate[Context[]<>"*"]]

EndPackage[]