(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)









(* :Title: DrawingCube *)
(* :Context: Graphics`DrawingCube` *)
(* :Author: David J. M. Park Jr. djmp@earthlink.net *)
(* :Summary: 
      The Graphics`DrawingCube` package is used for making three dimensional \
plots within a drawing cube. 
          Its various routines extract the primitive Graphics3D elements from \
the various plot functions and in effect turns them into Graphics3D \
primitives. Hence a complex graphic can be built up in one Show statement. 
          The Show statement itself can be generated with the \
BlankDrawingCube routine. 
          Any Graphics3D options should be entered in BlankDrawingCube or \
edited in later. They cannot be passed through drawing routines. 
          Several other useful functions such as DrawingTransform3D and \
IteratorSubstitution are also provided. 
          The names of the Graphics3D primitive routines use Draw where the \
underlying routine has the word Plot or prepend the word Draw if the \
underlying routine does not use Plot. 
          There are auxiliary packages ParametricDrawing3D`, \
ContourDrawing3D`, 
  DrawingField3D` DrawingShapes` and DrawingSurfaceOfRevolution` which must \
be separately loaded to obtain the routines associated with \
ParametricPlot3D`, ContourPlot3D`, PlotField3D`, 
  Shapes` and SurfaceOfRevolution`. *)
(* :Copyright: \[Copyright] 1998, 2001 by David J. M. Park Jr. *)
(* :Package Version: 2.0 *)
(* :Mathematica Version: 4.0 *)
(* :Keywords: Graphics3D, plot combinations *)





BeginPackage["DrawGraphics`DrawingCube`",{"Utilities`FilterOptions`"}]

DrawGraphics`DrawingCube::usage="DrawingCube` is an auxiliary package for \
DrawGraphics that contains various drawing routines for 3D graphics."



BlankDrawingCube::usage="BlankDrawingCube[opts_:{}, range_:{-10,10}] will \
create a blank drawing cube and the skeleton code for drawing on it. Optional \
arguments specifying plotting range and additional options for the Show \
command can be given. A Null value for any of the arguments will also \
implement the default value. BlankDrawingPaper[ , {-10,10}] is a valid use."



DrawAxes::usage=
    "DrawAxes[{xorg, yorg, zorg}, {min, max}, \
styles:{{GrayLevel[0]},{GrayLevel[0]},{GrayLevel[0]}}] will produce the three \
dimensional set of axes lines centered at the specified origin. The extent of \
the lines is determined by {min, max} where the displacements are from the \
specified origin. Axes styles may be given as an optional third argument.";



DrawContourLines::usage=
    "DrawContourLines[f[x, y], {x, xmin, xmax}, {y, ymin, ymax}, opts] will \
extract the 2D contours from a ContourPlot and raise them to primitive \
Graphics3D objects. f[x, y] must be a defined function, not just an \
expression. In plotting contours on a surface, it is useful to lower the \
surface slightly so it will not intersect the contours. Alternatively, the \
option DrawContourOffset can be used to specify an offset for the contour \
lines.";

DrawContourOffset::usage="DrawContourOffset is an option for DrawContourLines \
which specifies an offset, in the normal plot coordinates, for rendering the \
contour lines. Generally, the contours should be slightly raised so they \
won't intersect the surface polygons. The default value is {0,0,0}."



DrawGraphics3D::usage=
    "DrawGraphics3D[plot[args]] will extract the primitive graphics, without \
display, from any plot that produces Graphics3D output or can be converted to \
Graphics3D output. It will handle plot routines produced by packages which \
were not anticipated by the author of DrawingCube.";



DrawWithOptions3D::usage=
    "DrawWithOptions3D[plot_[args_] will extract the primitive graphics for \
the plot, and the option rules used by the plot. It can be used when you wish \
to pick up the overall plot options of some plot to use in the Show \
statement. The usage would be:\n{primitives,options} = \
DrawWithOptions3D[plot[args]]";



Draw3D::usage=
    "Draw3D[f, {x, xmin, xmax}, {y, ymin, ymax}] generates a \
three-dimensional drawing of f as a function of x and y. Draw3D[{f, s}, {x, \
xmin, xmax}, {y, ymin, ymax}] generates a three-dimensional drawing in which \
the height of the surface is specified by f, and the shading is specified by \
s. The primitive Graphics3D objects are extracted from the corresponding \
Plot3D routine. Options may be passed to Plot3D through the last arguments.";



Draw3DItems::usage=
    "Draw3DItems[{primitives}, options] is a shortcut for \
Show[Graphics3D[{primitives}], options]";



DrawingTransform3D::usage="DrawingTransform3D[f1, f2, f3], where f1, f2 and \
f3 are function names, is a rule which applies the following transformation \
to all points in the graphics object: {x_?NumberQ, y_?NumberQ, z_?NumberQ} \
\[Rule] {f1[x, y, z], f2[x, y, z], f3[x, y, z]}.";



IteratorSubstitution::usage="IteratorSubstitution[expr, {var, lim1, lim2}, \
newvar:w] is used to transform a plot range iterator, which may contain \
variable limits, to one which contains constant limits. The plotting expr is \
transformed to the new variable and returned along with the new iterator.";



ListDraw3D::"usage"=
    "ListDraw3D[array] generates a three-dimensional plot of a surface  \
representing an array of height values. ListDraw3D[array, shades] generates a \
plot with each element of the surface shaded according to the specification \
in shades. The primitive Graphics3D objects are extracted from the \
corresponding ListPlot3D routine. Options may be passed to ListPlot3D through \
the last arguments.";



NeutralLighting::usage=
    "NeutralLighting[saturation, brightness, ambient, \[Theta]:0] will \
generate a controlled lighting than can be made more neutral in color. The \
regular lights will be red, green and blue with the specified saturation and \
brightness. A GrayLevel[ambient] level can also be used. By using a low \
saturation, surface colors will be better displayed. The fourth optional \
argument, \[Theta], will rotate the light sources clockwise about the \
vertical axis. The command can be placed among the Graphics3D options. It \
generates the Lighting, AmbientLight and LightSources options.";



Begin["`Private`"]



Attributes[BlankDrawingCube]={HoldAll};
BlankDrawingCube[opts_:{},range_:{-10,10},color_:Linen]:=
	Module[{nb,opts2=opts,range2},
		opts2=If[opts2==={}\[Or]opts2===Null,ToBoxes[{}],ToBoxes[opts]];
		range2=If[range===Null,{-10,10},range];
	nb=EvaluationNotebook[];
	SelectionMove[nb,Previous,Cell];
	NotebookWrite[nb,Cell[BoxData[
    RowBox[{
      RowBox[{"Show", "[", 
        RowBox[{
          RowBox[{"Graphics3D", "[", "\n", "\t\t", 
            RowBox[{"{", "}"}], "]"}], ",", "\n", "\n", 
          RowBox[{"AspectRatio", "\[Rule]", "Automatic"}], ",", 
          RowBox[{"PlotRange", "\[Rule]", 
            RowBox[{"{", 
              
                              RowBox[{ToBoxes[range2], ",",ToBoxes[range2], 
                                  ",",ToBoxes[range2]}], "}"}]}], 
           ",", "\n",opts2}], "]"}], ";"}]], 
  "Input",GeneratedCell\[Rule]False],All];
	SelectionEvaluate[nb]]



DrawAxes[origin:{_,_,_},range:{_,_},
    styles_:{{GrayLevel[0]},{GrayLevel[0]},{GrayLevel[0]}}]:=
	{{styles\[LeftDoubleBracket]1\[RightDoubleBracket],
        Line[{{origin\[LeftDoubleBracket]1\[RightDoubleBracket]+
                range\[LeftDoubleBracket]1\[RightDoubleBracket],
              origin\[LeftDoubleBracket]2\[RightDoubleBracket],
              origin\[LeftDoubleBracket]3\[RightDoubleBracket]},{origin\
\[LeftDoubleBracket]1\[RightDoubleBracket]+
                range\[LeftDoubleBracket]2\[RightDoubleBracket],
              origin\[LeftDoubleBracket]2\[RightDoubleBracket],
              origin\[LeftDoubleBracket]3\[RightDoubleBracket]}}]}//Flatten,
		{styles\[LeftDoubleBracket]2\[RightDoubleBracket],
        Line[{{origin\[LeftDoubleBracket]1\[RightDoubleBracket],
              origin\[LeftDoubleBracket]2\[RightDoubleBracket]+
                range\[LeftDoubleBracket]1\[RightDoubleBracket],
              origin\[LeftDoubleBracket]3\[RightDoubleBracket]},{origin\
\[LeftDoubleBracket]1\[RightDoubleBracket],
              origin\[LeftDoubleBracket]2\[RightDoubleBracket]+
                range\[LeftDoubleBracket]2\[RightDoubleBracket],
              origin\[LeftDoubleBracket]3\[RightDoubleBracket]}}]}//Flatten,
		{styles\[LeftDoubleBracket]3\[RightDoubleBracket],
        Line[{{origin\[LeftDoubleBracket]1\[RightDoubleBracket],
              origin\[LeftDoubleBracket]2\[RightDoubleBracket],
              origin\[LeftDoubleBracket]3\[RightDoubleBracket]+
                range\[LeftDoubleBracket]1\[RightDoubleBracket]},{origin\
\[LeftDoubleBracket]1\[RightDoubleBracket],
              origin\[LeftDoubleBracket]2\[RightDoubleBracket],
              origin\[LeftDoubleBracket]3\[RightDoubleBracket]+
                range\[LeftDoubleBracket]2\[RightDoubleBracket]}}]}//Flatten}



Attributes[DrawContourLines]={HoldFirst};
Options[DrawContourLines]={DrawContourOffset\[Rule]{0,0,0}};
DrawContourLines[f_,xrange_,yrange_,opts___?OptionQ]:=
  	Module[{e1,val,fname,contouroffset,plotopts},
    fname=Hold[f]\[LeftDoubleBracket]1,0\[RightDoubleBracket];
    contouroffset=DrawContourOffset/.{opts}/.Options[DrawContourLines];
    plotopts=FilterOptions[ContourPlot,Evaluate[opts]];
    e1=Cases[
        First[Graphics[
            ContourPlot[f,xrange,yrange,DisplayFunction\[Rule]Identity,
              ContourShading\[Rule]False,Evaluate[plotopts]]]],
        Line[_],\[Infinity]];
    e1/.Line[
          pts_]:>(val=
            Plus@@(fname@@#&/@pts)/
              Length[pts];(Line[
                Map[Append[#,val]&,
                  pts]]/.pt:{_?NumberQ,_?NumberQ,_?NumberQ}\[RuleDelayed]
                pt+contouroffset))
    ]



Attributes[DrawGraphics3D]={HoldAll};
DrawGraphics3D[plot_]:=
  Block[{$DisplayFunction=Identity,p},
    p=plot;
    If[Head[p]===Graphics3D,First[p],First[Graphics3D[p]]]]



Attributes[DrawWithOptions3D]={HoldFirst};
DrawWithOptions3D[plot_]:=
  Block[{p,$DisplayFunction=Identity},
    p=plot;
    p=If[Head[p]===Graphics3D,p,Graphics3D[p]];
    {First[p],
      Last[p]/.{(DisplayFunction\[Rule]Identity)\[Rule]
            Sequence[],(DisplayFunction\[RuleDelayed]Identity)\[Rule]
            Sequence[]}}]



Attributes[Draw3D]={HoldAll};
Draw3D[data__]:=
	First[Graphics3D[Plot3D[data,DisplayFunction\[Rule]Identity]]]



Draw3DItems[{primitives___},options___?OptionQ]:=
  Show[Graphics3D[{primitives}],options]

DrawingTransform3D[function1_,function2_,
    function3_]:={x_?NumericQ,y_?NumericQ, 
      z_?NumericQ}\[Rule]{function1[x,y,z],function2[x,y,z],function3[x,y,z]}



\!\(IteratorSubstitution[expr_, iter : {var_, lim1_, lim2_}, 
      newvar_:  Global`w] := \n\t
    Module[{newiter, subrules, lim3, lim4, newexpr}, \n\t\t{lim3, lim4} = 
        If[lim2 === 0, {lim2, lim1}, {lim1, lim2}]; \n\t\tnewiter = {var, 
          lim3, lim4}; \n\t\tnewiter = 
        If[\[Not] \((lim1 === 0 \[Or] 
                lim3/lim4 === \(-1\))\), \(newiter - lim3\)\/\(lim4 - lim3\), 
          newiter\/lim4]; \n\t\tsubrules = 
        Solve[newvar == newiter\[LeftDoubleBracket]1\[RightDoubleBracket], 
          var]; \n\t\tnewiter\[LeftDoubleBracket]1\[RightDoubleBracket] = 
        newvar; \n\t\tnewexpr = expr /. subrules // Simplify; \n\t\tnewexpr = 
        If[Length[newexpr] == 1, 
          newexpr\[LeftDoubleBracket]1\[RightDoubleBracket], 
          newexpr]; \n\t\t{newexpr, newiter}\n\t\t]\)



ListDraw3D[data__]:=
	First[Graphics3D[ListPlot3D[data,DisplayFunction\[Rule]Identity]]]



NeutralLighting[saturation_,brightness_,ambient_,\[Theta]_:0]=
      Sequence[Lighting\[Rule]True,AmbientLight\[Rule]GrayLevel[ambient],
        LightSources\[Rule]{{{Cos[\[Theta]]-Sin[\[Theta]],0,
                Cos[\[Theta]]+Sin[\[Theta]]},
              Hue[0.0,saturation,brightness]},{{Cos[\[Theta]]-Sin[\[Theta]],1,
                Cos[\[Theta]]+Sin[\[Theta]]},
              Hue[0.333333,saturation,brightness]},{{-Sin[\[Theta]],1,
                Cos[\[Theta]]},Hue[0.666667,saturation,brightness]}}];;



End[]

Protect[Evaluate[Context[]<>"*"]]

EndPackage[]