(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)









(* :Title: DrawingField *)
(* :Context: DrawGraphics`DrawingField` *)
(* :Author: David J. M. Park Jr. djmp@earthlink.net *)
(* :Summary: 
      This is an auxiliary package to DrawingPaper` which loads the \
Graphics`PlotField` package and provides the associated drawing routines. *)
(* :Copyright: \[Copyright] 1998, 2000,2001 by David J. M. Park Jr. *)
(* :Package Version: 2.0 *)
(* :Mathematica Version: 4.0 *)
(* :Keywords: graphics, plot combinations, PlotField, vector fields *)
(* :Requirements: Graphics`PlotFields` *)





BeginPackage["DrawGraphics`DrawingField`",{"Graphics`PlotField`"}]

DrawGraphics`DrawingField::usage="DrawingField is an auxiliary package to \
DrawGraphics` that loads the Graphics`PlotField` package and provides the \
associated drawing routines."



DrawVectorField::usage="DrawVectorField[f, {x, x0, x1, (xu)}, {y, y0, y1, \
(yu)}, (options)] produces a vector field drawing of the two-dimensional \
vector function f. The primitive Graphics objects are extracted from the \
corresponding PlotVectorField routine. Options may be passed to \
PlotVectorField through the last arguments.";



DrawGradientField::usage="DrawGradientField[f, {x, x0, x1, (xu)}, {y, y0, y1, \
(yu)}, (options)] produces a vector field drawing of the gradient vector \
field of the scalar function f by calculating its derivatives analytically. \
The primitive Graphics objects are extracted from the corresponding \
PlotGradientField routine. Options may be passed to PlotGradientField through \
the last arguments.";



DrawHamiltonianField::usage="DrawHamiltonianField[f, {x, x0, x1, (xu)}, {y, \
y0, y1, (yu)}, (options)] produces a vector field drawing of the Hamiltonian \
vector field of the scalar-valued function f by calculating its derivatives \
analytically. The primitive Graphics objects are extracted from the \
corresponding PlotHamiltonianField routine. Options may be passed to \
PlotHamiltonianField through the last arguments.";



DrawPolyaField::usage="DrawPolyaField[f[x + I y], {x, x0, x1, (dx)}, {y, y0, \
y1, (dy)}, options] draws the function f in the complex plane using Polya \
representation. The primitive Graphics objects are extracted from the \
corresponding PlotPolyaField routine. Options may be passed to PlotPolyaField \
through the last arguments.";



ListDrawVectorField::usage="ListDrawVectorField[{{vec11,vec12,..},...}] \
accepts a rectangular array of two-dimensional vectors (larger than 2x2) and \
displays them, with each vector positioned in the same location graphically \
as the matrix would be (ie, vector 1,1 in the upper left corner). \
ListPlotVectorField[{{pt,vec},{pt,vec},...}] displays a list of vectors, each \
based at the corresponding point. The primitive Graphics objects are \
extracted from the corresponding ListPlotVectorField routine. Options may be \
passed to ListPlotVectorField through the last arguments.";



Begin["`Private`"]



Attributes[DrawVectorField]={HoldFirst};
DrawVectorField[field_,xrange_,yrange_,opts___?OptionQ]:=	
  First[PlotVectorField[field,xrange,yrange,DisplayFunction\[Rule]Identity,
      Evaluate[opts]]]



DrawGradientField[f_,xrange_,yrange_,opts___?OptionQ]:=	
  First[PlotGradientField[f,xrange,yrange,DisplayFunction\[Rule]Identity,
      Evaluate[opts]]]



DrawHamiltonianField[f_,xrange_,yrange_,opts___?OptionQ]:=	
  First[PlotHamiltonianField[f,xrange,yrange,DisplayFunction\[Rule]Identity,
      Evaluate[opts]]]



Attributes[DrawPolyaField]={HoldFirst};
DrawPolyaField[f_,xrange_,yrange_,opts___?OptionQ]:=	
  First[PlotPolyaField[f,xrange,yrange,DisplayFunction\[Rule]Identity,
      Evaluate[opts]]]



ListDrawVectorField[array_,opts___?OptionQ]:=	
  First[ListPlotVectorField[array,DisplayFunction\[Rule]Identity,
      Evaluate[opts]]]



End[]

Protect[Evaluate[Context[]<>"*"]]

EndPackage[]