(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)









(* :Title: DrawingPaper *)
(* :Context: DrawGraphics`DrawingPaper` *)
(* :Author: David J. M. Park Jr. djmp@earthlink.net *)
(* :Summary: 
      The Graphics`DrawingPaper` package is used for making two-
        dimensional plots on a piece of paper. 
            Its various routines extract the primitive Graphics elements from \
the various plot functions and in effect turns them into two-
        dimensional Graphics primitives. Hence a complex graphic can be built-
        up in one Show statement. 
            The Show statement itself can be generated with the \
BlankDrawingPaper routine. 
            Several other useful functions such as DrawingTransform and \
ContourColors are also provided. 
            The names of the Graphics primitive routines use Draw where the \
underlying routine has the word Plot or prepend the word Draw if the \
underlying routine does not use Plot. 
            There are auxiliary packages ImplicitDrawing`,FilledDrawing`, \
DrawingField`,
      MultipleListDrawing` ComplexMapDrawing` and InequalityDrawing`   which \
must be separately loaded to obtain the routines associated with \
ImplicitPlot`, FilledPlot`, PlotField`, MultitpleListPlot`, 
  ComplexMap` and InequalityGraphics. *)
(* :Copyright: \[Copyright] 1998, 2000, 2001 by David J. M. Park Jr. *)
(* :Package Version: 2.0 *)
(* :Mathematica Version: 4.0 *)
(* :Keywords: graphics, plot combinations *)
(* :Requirements: Graphics`Colors` *)







BeginPackage["DrawGraphics`DrawingPaper`",{"Graphics`Colors`",
    "DrawGraphics`PolarDensity`"}]

DrawGraphics`DrawingPaper::usage=
  "DrawingPaper is an auxiliary package for DrawGraphics that provides 2D drawing routines."



BlankDrawingPaper::usage=
  "BlankDrawingPaper[opts_:{}, range_:{-10,10}, color_:Linen] will create a blank piece of drawing paper and the skeleton code for drawing on it. Optional arguments specifying color and plotting range can be given as well as additional options for the Show command. A Null value for any of the arguments will also implement the default value. BlankDrawingPaper[ , , MistyRose] is a valid use."



CirclePoint::usage="CirclePoint[location, size, rimcolor, diskcolor] can be used to mark missing or special points in 2D graphics. It draws a disk of one color and an outline circle of another color. The size is given in printer's points.";



ColorBands::usage="ColorBands[breakvalues, {undercolor, overcolor}, colorlist][z] will return color values from the colorlist as z lies in the ith interval from the ordered breakvalues. If the length of the colorlist is less than the number of intervals, the colors are used cyclically. Undercolor is used for z \[LessEqual] the first breakvalue and overcolor is used for z > the last breakvalue.";



ColorMix::usage="ColorMix[color1, color2][z] will supply a color interpolated between RGBColors or GrayLevel colors, color1 and color2, according to the value of 0 \[LessEqual] z \[LessEqual] 1. z is not checked for the proper range.";



ContourColors::usage="ContourColors[zvalue, contourlist] can be used as a ColorFunction to assure that adjacent contour regions have distinct color shadings. It uses some saturation and brightness variation in addition to hue variation. To use ContourColors properly: first specify a list of contours. In ContourDraw or ContourPlot specify a PlotRange option with the z-range running from the first to last item on contourlist; then use the options Contours \[Rule] contourlist and ColorFunction \[Rule] Evaluate[ContourColors[#, contourlist]&].";



ContourDraw::usage="ContourDraw[f, {x, xmin, xmax}, {y, ymin, ymax}, opts...] generates a contour drawing of f as a function of x and y. The routine produces the Graphics object converted from the ContourGraphics object produced by a regular ContourPlot. Options may be passed to ContourPlot through the last arguments.";



DensityDraw::usage="DensityDraw[f, {x, xmin, xmax}, {y, ymin, ymax}] makes a density drawing of f as a function of x and y. The routine produces the Graphics object converted from the DensityGraphics object produced by a regular DensityPlot. Options may be passed to DensityPlot through the last arguments.";

PolarDensityDraw::usage="PolarDensityDraw[f[r, \[Theta]], {r, r1, r2}, {\[Theta], \[Theta]1, \[Theta]2}] generates a polar density plot of f[r, \[Theta]].";

ListPolarDensityDraw::usage="ListPolarDensityDraw[matrix] generates a polar density plot from an array of height values. Rows matrix correspond to constant angles, and columns of matrix correspond to constant radii.";



DontShow::usage="DontShow is the same as Show but with the option DisplayFunction \[Rule]Identity automatically inserted.";



DoShow::usage="DoShow is the same as Show, but with the option DisplayFunction \[Rule] $DisplayFunction automatically inserted.";



Draw::usage=
  "Draw[f, {x, xmin, xmax}, opts...] generates a drawing of f as a function of x from xmin to xmax. Draw[{f1, f2, ... }, {x, xmin, xmax}] draws several functions fi. The primitive Graphics objects are extracted from the corresponding Plot routine. Options may be passed to Plot through the last arguments."



Draw2D::usage="Draw2D[{primitives}, options] is a shortcut for Show[Graphics[{primitives}], options]";



DrawGraphics::usage="DrawGraphics[plot[args]] will extract the primitive graphics, without display, from any plot that produces Graphics output or can be converted to Graphics output. It will handle plot routines produced by packages which were not anticipated by the author of DrawingPaper.";



DrawLineLabels::usage="DrawLineLabels[function, position, opts][expr] will label all the lines in expr. function is a pure function of two variables which is applied to the choosen point to generate the value of the label. position is a pure function that should generate a number between 0 and 1. It specifies the fractional number of plot points along the line for the label placement as a function of the Line value. position = 0.5& will put the labels at roughly the midpoint of each line independent of the line value. position = Random[]& will put the labels at random positions. The option DrawLLFormat can be used to set a format specification for the labels. The default is (NumberForm[#,2]&). The option DrawLLTextOptions can be used to add options to the Text statements that produce the labels.";

DrawLLFormat::usage="DrawLLFormat is an option for DrawLineLabels which supplies a formatting function for the value to be displayed. The default is NumberForm[#,2]&.";

DrawLLTextOptions::usage="DrawLLTextOptions is an option for DrawLineLabels which can be used to supply options to the Text statements which display the values.";



DrawingTransform::usage="DrawingTransform[f1, f2], where f1 and f2 are function names, is a rule which applies the transformation {x_?NumericQ, y_?NumericQ} \[Rule] {f1[x, y], f2[x, y]} to all point specifications in Points, Lines and Polygons which are contained in the graphics object. It also transforms Text, Circle, Disk, Rectangle, Raster and RasterArray by transforming the explicit coordinate specifications in the commands.";



DrawPolarR::usage=
  "DrawPolarR[r[\[Theta]], {\[Theta], \[Theta]min, \[Theta]max}, opts] will produce the primitive graphics elements for a polar plot of r[\[Theta]] by using ParametricPlot. Options may be passed to ParametricPlot through the last arguments."



DrawPolarA::usage=
  "DrawPolarA[\[Theta][r], {r, rmin, rmax}, opts] will produce the primitive graphics elements for a polar plot of \[Theta][r] by using ParametricPlot. Options may be passed to ParametricPlot through the last arguments."



DrawUnitStep::usage="DrawUnitStep[expr, {x, min, max}, options...] will Draw a UnitStep expression, omitting the points which define the step function breaks. The UnitStep functions must all be of the form UnitStep[x-a] where a is numeric.";



DrawWithOptions::usage="DrawWithOptions[plot_[args_] will extract the primitive graphics for the plot, and the option rules used by the plot. It can be used when you wish to pick up the overall plot options of some plot to use in the Show statement. The usage would be:\n{primitives,options} = DrawWithOptions[plot[args]]";



\!\(\(FineGrainLines::usage = \*"\"\<FineGrainLines[distance, grain, distfunc:(\!\(\@\(\((#2 - #1)\) . \((#2 - #1)\)\)\)&)][expr] will fine grain the points defining all Lines in expr using FineGrainPoints.\>\"";\)\)



\!\(\(FineGrainPoints::usage = \*"\"\<FineGrainPoints distance, grain, distfunc:(\!\(\@\(\((#2 - #1)\) . \((#2 - #1)\)\)\)&)][pointlist] will linearly interpolate a set of points into a list of points so that the separation between adjacent points is not greater than distance. The distance is calculated by applying the optional distfunc to adjacent points. At each iteration grain-1 points are inserted.\>\"";\)\)



\!\(\(FineGrainPolygons::usage = \*"\"\<FineGrainPolygons[distance, grain, distfunc:(\!\(\@\(\((#2 - #1)\) . \((#2 - #1)\)\)\)&)][expr] will fine grain the points defining all Polygons in expr using FineGrainPoints. If the last point defining the polygon is not the same as the first point, then the first point is appended to the polygon point list before fine graining.\>\"";\)\)



FullDraw::usage="FullDraw[plot[args]], like FullGraphics, will extract all of the graphical primitives for any plot that can be converted to Graphics output. The graphical primitives produced by any options will also be included, i.e, Axes, Ticks, Frames, Labels.";



HollisGrid::usage="HollisGrid[{p1,p2,...,pn}] creates a grid over the polygon with vertices p1, p2,..., pn.\nHollisGrid[{\[Gamma]1[t],\[Gamma]2[t]}, {t, tmin, tmax}] creates a grid over the region whose boundary is parametrized by \[Gamma].";

GridNexus::usage="GridNexus is an option for HollisGrid that specifies the nexus or hub of the grid The default is Automatic.";

GridSmoothness::usage="GridSmoothness is an option for HollisGrid that specifies the smoothing of the grid. It should be between 0 and 1. Default is 0.5.";

GridExtraSmoothing::usage="GridExtraSmoothing is an option for HollisGrid that specifies whether to smooth every tier of the grid. It's default is False.";



ListContourDraw::usage="ListContourDraw[array, opts] generates the primitive graphics of a contour plot from an array of height values.";



ListDensityDraw::usage="ListDensityDraw[array, opts] generates the primitive graphics of a density plot from an array of height values.";



ListDraw::usage="ListDraw[{y1, y2, ... }, opts...] draws a list of values. The x coordinates for each point are taken to be 1, 2, ... . ListDraw[{{x1, y1}, {x2, y2}, ... }, opts...] draws a list of values with specified x and y coordinates. The primitive Graphics objects are extracted from the corresponding ListPlot routine. Options may be passed to ListPlot through the last arguments.";



MakePolyGrid::usage="MakePolyGrid[{nx, ny}, {{xmin, ymin}, {xmax, ymax}}] will create a 2D rectangular grid of polygons. There will be nx rectangles along the x-axis and ny rectangles along the y axis. The second argument defines the region occupied by the rectangular grid.";



ParametricDraw::usage=
  "ParametricDraw[{fx, fy}, {t, tmin, tmax}, opts...] produces a parametric drawing with x and y coordinates fx and fy generated as a function of t. ParametricDraw[{{fx, fy}, {gx, gy}, ... }, {t, tmin, tmax}] draws several parametric curves. The primitive Graphics objects are extracted from the corresponding ParametricPlot routine. Options may be passed to ParametricPlot through the last arguments."



PolygonOutline::usage="PolygonOutline[linedirectives...][graphics] will convert Polygons to closed Lines using the line directives.";



RaiseTo3D::usage="RaiseTo3D[f][graphics] applies the rule {x_?NumericQ, y_?NumericQ} \[RuleDelayed] {x, y, f[x, y]} to graphics.";



SplitLineOnDistance::usage="SplitLineOnDistance[distance] is a rule which will split any Line primitives into multiple lines whenever two points are farther apart than the distance specified.";



SplitLineOnSlope::usage="SplitLineOnSlope[slope] is a rule which will split any Line primitives into multiple lines whenever two points give a slope whose absolute value is greater than the specified slope";



SplitLineOnVertical::usage="SplitLineOnVertical[distance] is a rule which will split any Line primitives into multiple lines whenever two points are vertically farther apart than the distance specified.";



StitchLineSegments::usage=
  "StitchLineSegments[segs_List] will stitch together a list of line segments into one line segment. One must be careful with the order of the segments and the order of the points within each segment. The segs list is Flattened as the first step."



ToPointPrimitives::usage="ToPointPrimitives[graphics] will convert Circle to a Line, Disk and Rectangle to Polygons, Raster and RasterArray to Polygons with color directives.";



TrimPolygons::usage="TrimPolygons[f, {fmin, fmax}][polygrid] will extract a list of polygons from a polygrid of rectangular polygons so that f applied to the polygon points is between fmin and fmax. Rectangles entirely outside the range are eliminated and rectangles entirely within the range are left untouched. Rectangles partly in and out are trimed.";



TwoColorScale::usage="TwoColorScale[{zmin, z0, zmax}, {lowcolor, color1, color2, color3, color4, highcolor}][z] provides a color function that shades between color1 and color2 if zmin < z \[LessEqual]z0, shades between color3 and color4 if z0 < z \[LessEqual] zmax, returns lowcolor if z \[LessEqual] zmin and highcolor if z > zmax. The colors must all be RGBColors.";





Begin["`Private`"]



Attributes[BlankDrawingPaper]={HoldAll};
BlankDrawingPaper[opts_:{},range_:{-10,10},color_:Linen]:=
	Module[{nb,color2=Hold[color],opts2=opts,range2},
		color2=If[color2===Hold[Linen]\[Or]color2===Hold[Null],"Linen",
        ToString@@(Unevaluated/@color2)];
		opts2=If[opts2==={}\[Or]opts2===Null,ToBoxes[{}],ToBoxes[opts]];
		range2=If[range===Null,{-10,10},range];
	nb=EvaluationNotebook[];
	SelectionMove[nb,Previous,Cell];
	NotebookDelete[nb];
	NotebookWrite[nb,Cell[BoxData[
    RowBox[{
      RowBox[{"Show", "[", 
        RowBox[{
          RowBox[{"Graphics", "[", "\n", "\t\t", 
            RowBox[{"{", "}"}], "]"}], ",", "\n", "\n", 
          RowBox[{"AspectRatio", "\[Rule]", "Automatic"}], ",", 
          RowBox[{"PlotRange", "\[Rule]", 
            RowBox[{"{", 
              RowBox[{ToBoxes[range2], ",",ToBoxes[range2]}], "}"}]}], ",", 
          RowBox[{"Background", "\[Rule]",color2}], ",", "\n",opts2}], "]"}], 
              ";"}]], 
  "Input",GeneratedCell\[Rule]False],All];
	SelectionEvaluate[nb]]



CirclePoint[location_,size_,rimcolor_,diskcolor_]:={diskcolor,
    Disk[location,Offset[{size,size}]],rimcolor,
    Circle[location,Offset[{size,size}]]}



ColorBands[breakvalues_?OrderedQ,{undercolor_,overcolor_},colorlist_][z_]:=
  Module[{i},
    If[z<=First[breakvalues],Return[undercolor]];
    If[z>Last[breakvalues],Return[overcolor]];
    i=1;
    While[z>breakvalues\[LeftDoubleBracket]i+1\[RightDoubleBracket],i++];
    colorlist\[LeftDoubleBracket]
      Mod[i,Length[colorlist],1]\[RightDoubleBracket]]



ColorMix[color1_,color2_][z_]/;
    MatchQ[Head[color1],RGBColor|GrayLevel]\[And]
      MatchQ[Head[color2],RGBColor|GrayLevel]:=
  Module[{col1,col2},
    {col1,col2}=
      If[Head[#]===GrayLevel,RGBColor@@Table[First[#],{3}],#]&/@{color1,
          color2};
    RGBColor@@(((1-z)List@@col1+z List@@col2))]



ContourColors[z_,clist_List]:=
	Module[{len=Length[clist],i,range,
      b=clist\[LeftDoubleBracket]1\[RightDoubleBracket],
      m=clist\[LeftDoubleBracket]-1\[RightDoubleBracket]-
          clist\[LeftDoubleBracket]1\[RightDoubleBracket]},
		range=clist\[LeftDoubleBracket]len\[RightDoubleBracket]-
        clist\[LeftDoubleBracket]1\[RightDoubleBracket];
		i=0;While[\[Not](i\[Equal]len)\[And]
        clist\[LeftDoubleBracket]i+1\[RightDoubleBracket]\[LessEqual]b+z m,
      i++];i;
		Hue[Mod[i/len,1],1-Mod[i/len,0.6],1-Mod[i/len,0.3]]
		]



Attributes[ContourDraw]={HoldAll};
ContourDraw[f_,xrange_,yrange_,opts___?OptionQ]:=
  First[Graphics[
      ContourPlot[f,xrange,yrange,DisplayFunction\[Rule]Identity,
        Evaluate[opts]]]]



Attributes[DensityDraw]={HoldAll};
DensityDraw[f_,xrange_,yrange_,opts___?OptionQ]:=
  First[Graphics[
      DensityPlot[f,xrange,yrange,DisplayFunction\[Rule]Identity,
        Evaluate[opts]]]]

PolarDensityDraw[
    func_,{r_Symbol,r1_?NumericQ,
      r2_?NumericQ},{\[Theta]_Symbol,\[Theta]1_?NumericQ,\[Theta]2_?NumericQ},
    opts___?OptionQ]:=
  First[Graphics[
      PolarDensityPlot[func,{r,r1,r2},{\[Theta],\[Theta]1,\[Theta]2},
        DisplayFunction\[Rule]Identity,Evaluate[opts]]]]

ListPolarDensityDraw[vals_?MatrixQ,opts___?OptionQ]:=
  First[Graphics[
      ListPolarDensityPlot[vals,DisplayFunction\[Rule]Identity,
        Evaluate[opts]]]]



Attributes[DontShow]={HoldAll};
DontShow[args___]:=
  Block[{$DisplayFunction=Identity},
    Show[args]]



DoShow[args1___,DisplayFunction\[Rule]_,args2___]:=
    Show[args1,DisplayFunction\[Rule]$DisplayFunction,args2];
DoShow[args___]:=Show[args,DisplayFunction\[Rule]$DisplayFunction]



Attributes[Draw]={HoldAll};
Draw[f_,{x_,xmin_,xmax_},opts___?OptionQ]:=
	First[Plot[f,{x,xmin,xmax},DisplayFunction\[Rule]Identity,Evaluate[opts]]]



Draw2D[primitives_List,opts___?OptionQ]:=Show[Graphics[primitives],opts]



Attributes[DrawGraphics]={HoldAll};
DrawGraphics[plot_]:=
  Block[{$DisplayFunction=Identity},
    First[Graphics[plot]]]



Options[DrawLineLabels]={DrawLLFormat\[Rule](NumberForm[#,2]&),
      DrawLLTextOptions\[Rule]{}};
DrawLineLabels[function_,fracposition_,opts___][expr_]:=
  Module[{lines,format,textoptions},
    format:=DrawLLFormat/.{opts}/.Options[DrawLineLabels];
    textoptions=DrawLLTextOptions/.{opts}/.Options[DrawLineLabels];
    lines=Flatten[Cases[expr,Line[_],\[Infinity]]];
    Module[{fpos,pos,val,point,len},
          len= Length[#\[LeftDoubleBracket]1\[RightDoubleBracket]];
          
          val=Plus@@(function@@#&/@#\[LeftDoubleBracket]1\[RightDoubleBracket]\
)/len;
          fpos=fracposition[val];
          fpos=If[fpos<0\[Or]fpos>1,0.5,fpos];
          pos=Min[Max[Floor[fpos len],1],len];
          point=#\[LeftDoubleBracket]1,pos\[RightDoubleBracket];
          Text[format[val],point,Sequence@@textoptions]]&/@lines
    ]



DrawingTransform[function1_,function2_]:=
  With[
    {transformrule={x_?NumericQ,y_?NumericQ}\[Rule]{function1[x,y],
            function2[x,y]}},
    {Line[pts_]\[RuleDelayed](Line[pts/.transformrule]),
      Polygon[pts_]\[RuleDelayed](Polygon[pts/.transformrule]),
      Point[pt_]\[RuleDelayed]Point[pt/.transformrule],
      Text[txt_,pos_,args___]\[RuleDelayed]Text[txt,pos/.transformrule,args],
      Circle[center_,args___]\[RuleDelayed]
        Circle[center/.transformrule,args],
      Disk[center_,args___]\[RuleDelayed]Disk[center/.transformrule,args],
      Rectangle[lowleft_,upright_,arg___]\[RuleDelayed]
        Rectangle[lowleft/.transformrule,upright/.transformrule,arg],
      Raster[array_,{lowleft:{_,_},upright:{_,_}},args___]\[RuleDelayed]
        Raster[array,{lowleft/.transformrule,upright/.transformrule},args],
      Raster[array_,opts___?OptionQ]\[RuleDelayed]
        Raster[array,{{0,0}/.transformrule,Dimensions[array]/.transformrule},
          opts],
      RasterArray[array_,{lowleft:{_,_},upright:{_,_}}]\[RuleDelayed]
        RasterArray[array,{lowleft/.transformrule,upright/.transformrule}],
      RasterArray[array_]\[RuleDelayed]
        RasterArray[
          array,{{0,0}/.transformrule,Dimensions[array]/.transformrule}]}]



Attributes[DrawPolarR]={HoldAll};
DrawPolarR[r_,{\[Theta]_,\[Theta]min_,\[Theta]max_},opts___?OptionQ]:=
	First[ParametricPlot[{r Cos[\[Theta]],
        r Sin[\[Theta]]},{\[Theta],\[Theta]min,\[Theta]max},
      DisplayFunction\[Rule]Identity,Evaluate[opts]]]



Attributes[DrawPolarA]={HoldAll};
DrawPolarA[\[Theta]_,{r_,rmin_,rmax_},opts___?OptionQ]:=
	First[ParametricPlot[{r Cos[\[Theta]],r Sin[\[Theta]]},{r,rmin,rmax},
      DisplayFunction\[Rule]Identity,Evaluate[opts]]]



DrawUnitStep[expr_,{x_,min_,max_},opts___?OptionQ]:=
  Module[{breaks},
    breaks=Union[Cases[expr,UnitStep[a_]\[Rule]-a+x,-1]];
    breaks=Join[{min},Select[breaks,(#>min\[And]#<max&)],{max}];
    MapThread[Draw[expr,{x,#1,#2},opts]&,{Drop[breaks,-1],Drop[breaks,1]}]
    ]







Attributes[DrawWithOptions]={HoldFirst};
DrawWithOptions[plot_]:=
  Block[{p,$DisplayFunction=Identity},
    p=Graphics[plot];
    {First[p],
      Last[p]/.{(DisplayFunction\[Rule]Identity)\[Rule]
            Sequence[],(DisplayFunction\[RuleDelayed]Identity)\[Rule]
            Sequence[]}}]



\!\(\(FineGrainLines[distance_, grain_, distfunc_: \((\@\(\((#2 - #1)\) . \((#2 - #1)\)\) &)\)]\)[expr_] := \[IndentingNewLine]expr /. Line[points_] \[RuleDelayed] Line[\(FineGrainPoints[distance, grain, distfunc]\)[points]]\)



\!\(\(FineGrainPoints[distance_, grain_, distfunc_: \((\@\(\((#2 - #1)\) . \((#2 - #1)\)\) &)\)]\)[pointlist_] := \[IndentingNewLine]Module[{outlist = pointlist, f}, \[IndentingNewLine]f[list_] := \[IndentingNewLine]Module[{wlist = list, wgrain = Min[2, grain], dlist, i, seq}, \[IndentingNewLine]dlist = Partition[wlist, 2, 1]; \[IndentingNewLine]dlist = \(Apply[distfunc[#1, #2] > distance &, #] &\) /@ dlist; \[IndentingNewLine]Do[If[dlist\[LeftDoubleBracket]i\[RightDoubleBracket], inc = \((wlist\[LeftDoubleBracket]i + 1\[RightDoubleBracket] - wlist\[LeftDoubleBracket]i\[RightDoubleBracket])\)/wgrain; \[IndentingNewLine]wlist = ReplacePart[wlist, seq @@ Table[wlist\[LeftDoubleBracket]i\[RightDoubleBracket] + j\ inc, {j, 0, wgrain - 1}], i]], {i, 1, Length[dlist]}]; \[IndentingNewLine]wlist /. seq \[Rule] Sequence\[IndentingNewLine]]; \[IndentingNewLine]FixedPoint[f, outlist]\[IndentingNewLine]]\)



\!\(\(FineGrainPolygons[distance_, grain_, distfunc_: \((\@\(\((#2 - #1)\) . \((#2 - #1)\)\) &)\)]\)[expr_] := \[IndentingNewLine]expr /. a_Polygon \[RuleDelayed] \[IndentingNewLine]Module[{points = First[a]}, \[IndentingNewLine]If[Chop[First[points]] \[NotEqual] Chop[Last[points]], points = Join[points, {First[points]}]]; \[IndentingNewLine]Polygon[\(FineGrainPoints[distance, grain, distfunc]\)[points]]\[IndentingNewLine]]\)







Attributes[FullDraw]={HoldFirst};
FullDraw[plot_]:=
  Block[{$DisplayFunction=Identity},
    First[FullGraphics[Graphics[plot]]]]





\!\(HollisGrid[vertices : {{_?NumericQ, _?NumericQ} .. }, opts___?OptionQ] /; Length[Union[vertices]] > 2 := Module[{g, dists, cdists, nedges, edgepts, nex, pp, edgelengths, dt, ntiers, r, pts, perim}, pp = PlotPoints /. \[InvisibleSpace]{opts}; pp = Which[MatchQ[pp, {_?NumericQ .. }], First[pp], NumericQ[pp] && pp \[GreaterEqual] 0, pp, True, 36]; {g, dists, cdists} = pointsToParametric[pts = If[First[vertices] \[Equal] Last[vertices], N[vertices], N[Append[vertices, First[vertices]]]]]; edgelengths = Rest[dists]; perim = Plus @@ edgelengths; nedges = Length[edgelengths]; pp = Max[pp, nedges]; divs = Which[pp \[LessEqual] 56, If[\((r = Round[Log[2, Max[1, #1]]])\) \[LessEqual] 2, 2\^r, 8\ Max[1, Round[#1\/8]]] &, pp \[LessEqual] 192, If[\((r = Round[Log[2, Max[1, #1]]])\) \[LessEqual] 3, 2\^r, 16\ Max[1, Round[#1\/16]]] &, True, If[\((r = Round[Log[2, Max[1, #1]]])\) \[LessEqual] 4, 2\^r, 32\ Max[1, Round[#1\/32]]] &] /@ \(\(pp\ edgelengths\)\/perim\); dt = edgelengths\/divs; edgepts = \((Flatten[#1, 1] &)\)[Table[Table[g[t], {t, cdists\[LeftDoubleBracket]i\[RightDoubleBracket], cdists\[LeftDoubleBracket]i + 1\[RightDoubleBracket] - dt\[LeftDoubleBracket]i\[RightDoubleBracket], dt\[LeftDoubleBracket]i\[RightDoubleBracket]}], {i, 1, nedges}]]; AppendTo[edgepts, First[edgepts]]; nex = If[MatchQ[nex = GridNexus /. \[InvisibleSpace]{opts}, {_?NumericQ, _?NumericQ}], nex, Plus @@ \((r = Rest[pts])\)\/Length[r]]; makeTiers[edgepts, nex, pp, opts]]\)



\!\(HollisGrid[gamma_, {t_Symbol, tmin_?NumericQ, tmax_?NumericQ}, opts___?OptionQ] := Module[{edgepts, nex, pp, g, dt, r, ntiers, ndivs, sm0}, pp = PlotPoints /. \[InvisibleSpace]{opts}; pp = Which[MatchQ[pp, {_?NumericQ .. }], First[pp], NumericQ[pp] && pp \[GreaterEqual] 0, pp, True, 32]; pp = Max[4, pp]; g[s_] = N[gamma] /. \[InvisibleSpace]t \[Rule] s; If[\(! MatchQ[g[tmin + 1\/10. \^8], {_?NumericQ, _?NumericQ}]\), Message[SolidPlot::"\<badpath\>"]; Return[$Failed]]; ndivs = Which[pp < 6, 4, pp \[LessEqual] 96, 8\ Round[pp\/8], pp \[LessEqual] 192, 16\ Round[pp\/16], True, 32\ Round[pp\/32]]; dt = N[\(tmax - tmin\)\/ndivs]; edgepts = Table[g[t], {t, tmin, tmax, dt}]; nex = If[MatchQ[nex = GridNexus /. \[InvisibleSpace]{opts}, {_?NumericQ, _?NumericQ}], nex, Plus @@ \((r = Rest[edgepts])\)\/Length[r]]; sm0 = If[\((r = First[edgepts] - Last[edgepts])\) . r > 1\/10\^6, GridSmoothness \[Rule] 0, Null \[Rule] Null]; makeTiers[edgepts, nex, pp, sm0, opts]]\)



\!\(makeTiers[edgepts_, nex_, pp_, opts___?OptionQ] := Module[{ds, len, avrad, ndivs, ntiers, edgevecs, smoothedvecs, n, extrasmooth, dontsmooth, s, sm, r, mat, tier, firsttier, transitiontier}, ndivs = Length[edgepts] - 1; edgevecs = edgepts /. \[InvisibleSpace]{x_?NumericQ, y_} \[Rule] {x, y} - nex; len = Plus @@ \(\((\@\(\((r = #1\[LeftDoubleBracket]1\[RightDoubleBracket] - #1\[LeftDoubleBracket]2\[RightDoubleBracket])\) . r\) &)\) /@ Partition[edgevecs, 2, 1]\); avrad = Plus @@ \(\((\@\(#1 . #1\) &)\) /@ Rest[edgevecs]\)\/ndivs; ntiers = If[MatchQ[r = PlotPoints /. \[InvisibleSpace]{opts}, {_?NumericQ, _?NumericQ}], 2\^Round[Log[2, Max[1, Last[r]]]], 2\^Ceiling[Log[2, Max[1, \(pp\ avrad\)\/len]]]]; ds = 1. \/ntiers; n = ntiers; extrasmooth = If[\((\(GridExtraSmoothing /. \[InvisibleSpace]{opts}\) /. \[InvisibleSpace]{GridExtraSmoothing \[Rule] False})\) =!= True, False, True]; sm = \(GridSmoothness /. \[InvisibleSpace]{opts}\) /. \[InvisibleSpace]{GridSmoothness \[Rule]  .5}; sm = If[NumericQ[sm], N[sm],  .5]; dontsmooth = If[sm \[Equal] 0 || ntiers \[LessEqual] 4 || ndivs < 16, True, False]; If[dontsmooth, \((Chop[Flatten[#1, 1]] &)\)[Table[s = 1 - \((ntiers + 1 - i)\)\ ds; If[i \[Equal] n\/2 && IntegerQ[ndivs\/2] && ndivs \[GreaterEqual] 8, transitiontier = Table[\((nex + #1 &)\) /@ {s\ edgevecs\[LeftDoubleBracket]i\[RightDoubleBracket], Sequence @@ \((\((s + ds)\)\ edgevecs\[LeftDoubleBracket]Range[i, i + 2]\[RightDoubleBracket])\), s\ edgevecs\[LeftDoubleBracket]i + 2\[RightDoubleBracket]}, {i, 1, ndivs - 1, 2}]; edgevecs = edgevecs\[LeftDoubleBracket]Range[1, ndivs + 1, 2]\[RightDoubleBracket]; ndivs = ndivs\/2; n = n\/2; transitiontier, mat = {{s, 0}, {s + ds, 0}, {0, s + ds}, {0, s}}; Table[\((nex + #1 &)\) /@ \((mat . {edgevecs\[LeftDoubleBracket]i\[RightDoubleBracket], edgevecs\[LeftDoubleBracket]i + 1\[RightDoubleBracket]})\), {i, 1, ndivs}]], {i, ntiers, 1, \(-1\)}]], \((Chop[Flatten[#1, 1]] &)\)[Join[s = 1 - ds; smoothedvecs = 1\/2\ \(( .5\ RotateRight[r = Rest[edgevecs]] +  .5\ RotateLeft[r] + \((2\/sm - 1)\)\ r)\)\ sm; PrependTo[smoothedvecs, Last[smoothedvecs]]; firsttier = Table[\((nex + #1 &)\) /@ {s\ smoothedvecs\[LeftDoubleBracket]i + 1\[RightDoubleBracket], s\ smoothedvecs\[LeftDoubleBracket]i\[RightDoubleBracket], \((s + ds)\)\ edgevecs\[LeftDoubleBracket]i\[RightDoubleBracket], \((s + ds)\)\ edgevecs\[LeftDoubleBracket]i + 1\[RightDoubleBracket]}, {i, 1, ndivs}]; edgevecs = smoothedvecs; {firsttier}, Table[s = 1 - \((ntiers + 1 - i)\)\ ds; If[i \[Equal] n\/2 && IntegerQ[ndivs\/2] && ndivs \[GreaterEqual] 8, smoothedvecs = \(( .5\ RotateRight[r = Rest[edgevecs]] +  .5\ RotateLeft[r] + \((1\/sm - 1)\)\ r)\)\ sm; PrependTo[smoothedvecs, Last[smoothedvecs]]; transitiontier = Table[\((nex + #1 &)\) /@ {s\ smoothedvecs\[LeftDoubleBracket]i + 2\[RightDoubleBracket], s\ smoothedvecs\[LeftDoubleBracket]i\[RightDoubleBracket], Sequence @@ \((\((s + ds)\)\ edgevecs\[LeftDoubleBracket]Range[i, i + 2]\[RightDoubleBracket])\)}, {i, 1, ndivs - 1, 2}]; edgevecs = smoothedvecs\[LeftDoubleBracket]Range[1, ndivs + 1, 2]\[RightDoubleBracket]; ndivs = ndivs\/2; n = n\/2; transitiontier, If[extrasmooth, smoothedvecs = \(( .5\ RotateRight[r = Rest[edgevecs]] +  .5\ RotateLeft[r] + \((1\/sm - 1)\)\ r)\)\ sm; PrependTo[smoothedvecs, Last[smoothedvecs]]; tier = Table[\((nex + #1 &)\) /@ {s\ smoothedvecs\[LeftDoubleBracket]i\[RightDoubleBracket], \((s + ds)\)\ edgevecs\[LeftDoubleBracket]i\[RightDoubleBracket], \((s + ds)\)\ edgevecs\[LeftDoubleBracket]i + 1\[RightDoubleBracket], s\ smoothedvecs\[LeftDoubleBracket]i + 1\[RightDoubleBracket]}, {i, 1, ndivs}]; edgevecs = smoothedvecs; tier, mat = {{s, 0}, {s + ds, 0}, {0, s + ds}, {0, s}}; Table[\((nex + #1 &)\) /@ \((mat . {edgevecs\[LeftDoubleBracket]i\[RightDoubleBracket], edgevecs\[LeftDoubleBracket]i + 1\[RightDoubleBracket]})\), {i, 1, ndivs}]]], {i, ntiers - 1, 1, \(-1\)}]]]]]\)



\!\(\(pointsToParametric[pts : {{_?NumericQ, _?NumericQ} .. }] := \[IndentingNewLine]Module[{dists, cdists, steps}, \[IndentingNewLine]dists = Prepend[Partition[pts, 2, 1] /. {p1_, p2_} \[Rule] Sqrt[\((p1 - p2)\) . \((p1 - p2)\)], 0]; \[IndentingNewLine]cdists = Prepend[Table[Plus @@ dists\[LeftDoubleBracket]Range[k]\[RightDoubleBracket], {k, 2, Length[pts]}], 0]; \[IndentingNewLine]steps[s_] = \((UnitStep[s - First[#]] - UnitStep[s - Last[#]] &)\) /@ Partition[cdists, 2, 1]; \[IndentingNewLine]{Compile[{t}, Evaluate[Simplify@Sum[\(steps[t]\)\[LeftDoubleBracket]k\[RightDoubleBracket]*\((\(\((t - cdists\[LeftDoubleBracket]k\[RightDoubleBracket])\)*pts\[LeftDoubleBracket]k + 1\[RightDoubleBracket] + \((cdists\[LeftDoubleBracket]k + 1\[RightDoubleBracket] - t)\)*pts\[LeftDoubleBracket]k\[RightDoubleBracket]\)\/\(cdists\[LeftDoubleBracket]k + 1\[RightDoubleBracket] - cdists\[LeftDoubleBracket]k\[RightDoubleBracket]\))\), {k, 1, Length[pts] - 1}] + UnitStep[t - Last[cdists]]*Last[pts]]], dists, cdists}];\)\)



ListContourDraw[array_,opts___]:=
  First[Graphics[
      ListContourPlot[array,DisplayFunction\[Rule]Identity,Evaluate[opts]]]]



ListDensityDraw[array_,opts___]:=
  First[Graphics[
      ListDensityPlot[array,DisplayFunction\[Rule]Identity,Evaluate[opts]]]]



ListDraw[array_,opts___?OptionQ]:=
	First[ListPlot[array,DisplayFunction\[Rule]Identity,Evaluate[opts]]]



MakePolyGrid[pts:{nx_Integer?Positive,ny__Integer?Positive},
    range:{{xmin_,ymin_},{xmax_,ymax_}}]:=
  Cases[Raster[Array[1&,Reverse[pts]],range]//
      ToPointPrimitives,_Polygon,\[Infinity]]



Attributes[ParametricDraw]={HoldAll};
ParametricDraw[pointfunctions_,iterator_,opts___?OptionQ]:=
	First[ParametricPlot[pointfunctions,iterator,DisplayFunction\[Rule]Identity,
      Evaluate[opts]]]



PolygonOutline[directives___][g_]:=
  g/.Polygon[pts_]\[RuleDelayed]
      If[Last[pts]\[Equal]First[pts],{directives,Line[pts]},{directives,
          Line[Join[pts,{First[pts]}]]}]



RaiseTo3D[f_][graphics_]:=
  graphics/.{x_?NumericQ,y_?NumericQ}\[RuleDelayed]{x,y,f[x,y]}



\!\(SplitLineOnDistance[distance_] := Line[a_] \[RuleDelayed] Line /@ Split[a, \((\@\(\((#2 - #1)\) . \((#2 - #1)\)\) < distance &)\)]\)



SplitLineOnSlope[slope_]:=
  Line[a_]\[RuleDelayed]Line/@Split[a,(Abs[Divide@@Reverse[#2-#1]]<slope&)]



SplitLineOnVertical[distance_]:=
  Line[a_]\[RuleDelayed]Line/@
      Split[a,(Abs[#2\[LeftDoubleBracket]2\[RightDoubleBracket]-#1\
\[LeftDoubleBracket]2\[RightDoubleBracket]]<distance&)]



StitchLineSegments[segs_List]:=
		First[(Flatten[
            segs]//.{Line[{a__}],Line[{b__}],c___}\[Rule]{Line[{a,b}],
              c})//.Line[{a___,{b_,c_},{b_,c_},d___}]\[Rule]Line[{a,{b,c},d}]]



rasterconvert[array_,{{xmin_,ymin_},{xmax_,ymax_}},opts___?OptionQ]:=
  Module[{m,n,cfun,scaling,array2=array,delx,dely,xval,yval},
    cfun=ColorFunction/.{opts}/.Options[Raster];
    scaling=ColorFunctionScaling/.{opts}/.Options[Raster];
    If[cfun===Automatic,cfun=GrayLevel];
    If[scaling,array2=Map[Max[0,Min[#,1]]&,array2,{2}]];
    {m,n}=Dimensions[array];
    delx=(xmax-xmin)/n;
    dely=(ymax-ymin)/m;
    xval=Table[xmin+i delx,{i,0,n}];
    yval=Table[ymin+j dely,{j,0,m}];
    Table[{cfun[array2\[LeftDoubleBracket]j,i\[RightDoubleBracket]],
        Polygon[{{xval\[LeftDoubleBracket]i\[RightDoubleBracket],
              yval\[LeftDoubleBracket]
                j\[RightDoubleBracket]},{xval\[LeftDoubleBracket]
                i+1\[RightDoubleBracket],
              yval\[LeftDoubleBracket]
                j\[RightDoubleBracket]},{xval\[LeftDoubleBracket]
                i+1\[RightDoubleBracket],
              yval\[LeftDoubleBracket]
                j+1\[RightDoubleBracket]},{xval\[LeftDoubleBracket]
                i\[RightDoubleBracket],
              yval\[LeftDoubleBracket]j+1\[RightDoubleBracket]}}]},{i,1,n},{j,
        1,m}]]

\!\(ToPointPrimitives[g_] := \[IndentingNewLine]g /. \[IndentingNewLine]{Circle[center_, r : \(({_, _} | _)\)] \[RuleDelayed] ParametricDraw[Evaluate[r {Cos[\[Theta]], Sin[\[Theta]]} + center], {\[Theta], 0, 2  \[Pi]}], \[IndentingNewLine]Circle[center_, r : \(({_, _} | _)\), {\[Theta]1_, \[Theta]2_}] \[RuleDelayed] ParametricDraw[Evaluate[r {Cos[\[Theta]], Sin[\[Theta]]} + center], {\[Theta], \[Theta]1, \[Theta]2}], \[IndentingNewLine]Disk[center_, r : \(({_, _} | _)\)] \[RuleDelayed] Polygon @@ \(ParametricDraw[Evaluate[r {Cos[\[Theta]], Sin[\[Theta]]} + center], {\[Theta], 0, 2  \[Pi]}]\)\[LeftDoubleBracket]1, 1\[RightDoubleBracket], \[IndentingNewLine]Disk[center_, r : \(({_, _} | _)\), {\[Theta]1_, \[Theta]2_}] \[RuleDelayed] Polygon @@ \(ParametricDraw[Evaluate[r {Cos[\[Theta]], Sin[\[Theta]]} + center], {\[Theta], \[Theta]1, \[Theta]2}]\)\[LeftDoubleBracket]1, 1\[RightDoubleBracket], \[IndentingNewLine]Rectangle[{xmin_\ ymin_}, {xmax_, ymax_}] \[RuleDelayed] Polygon[{{xmin, ymin}, {xmax, ymin}, {xmax, ymax}, {xmin, ymax}}], \[IndentingNewLine]RasterArray[array_] \[RuleDelayed] \[IndentingNewLine]Module[{m, n}, \[IndentingNewLine]{m, n} = Dimensions[array]; \[IndentingNewLine]Table[{array\[LeftDoubleBracket]j, i\[RightDoubleBracket], Polygon[{{i - 1, j - 1}, {i, j - 1}, {i, j}, {i - 1, j}}]}, {i, 1, n}, {j, 1, m}]], \[IndentingNewLine]RasterArray[array_, {{xmin_, ymin_}, {xmax_, ymax_}}] \[RuleDelayed] \[IndentingNewLine]Module[{m, n, delx, dely, xval, yval}, \[IndentingNewLine]{m, n} = Dimensions[array]; \[IndentingNewLine]delx = \((xmax - xmin)\)/n; \[IndentingNewLine]dely = \((ymax - ymin)\)/m; \[IndentingNewLine]xval = Table[xmin + i\ delx, {i, 0, n}]; \[IndentingNewLine]yval = Table[ymin + j\ dely, {j, 0, m}]; \[IndentingNewLine]Table[{array\[LeftDoubleBracket]j, i\[RightDoubleBracket], Polygon[{{xval\[LeftDoubleBracket]i\[RightDoubleBracket], yval\[LeftDoubleBracket]j\[RightDoubleBracket]}, {xval\[LeftDoubleBracket]i + 1\[RightDoubleBracket], yval\[LeftDoubleBracket]j\[RightDoubleBracket]}, {xval\[LeftDoubleBracket]i + 1\[RightDoubleBracket], yval\[LeftDoubleBracket]j + 1\[RightDoubleBracket]}, {xval\[LeftDoubleBracket]i\[RightDoubleBracket], yval\[LeftDoubleBracket]j + 1\[RightDoubleBracket]}}]}, {i, 1, n}, {j, 1, m}]], \[IndentingNewLine]Raster[array_, opts___?OptionQ] \[RuleDelayed] \[IndentingNewLine]Module[{m, n, cfun, scaling, array2 = array}, \[IndentingNewLine]cfun = \(ColorFunction /. {opts}\) /. Options[Raster]; \[IndentingNewLine]scaling = \(ColorFunctionScaling /. {opts}\) /. Options[Raster]; \[IndentingNewLine]If[cfun === Automatic, cfun = GrayLevel]; \[IndentingNewLine]{m, n} = Dimensions[array]; \[IndentingNewLine]If[scaling, array2 = Map[Max[0, Min[#, 1]] &, array2, {2}]]; \[IndentingNewLine]Table[{cfun[array2\[LeftDoubleBracket]j, i\[RightDoubleBracket]], Polygon[{{i - 1, j - 1}, {i, j - 1}, {i, j}, {i - 1, j}}]}, {i, 1, n}, {j, 1, m}]], \[IndentingNewLine]Raster[array_, {{xmin_, ymin_}, {xmax_, ymax_}}, opts___?OptionQ] \[RuleDelayed] \[IndentingNewLine]rasterconvert[array, {{xmin, ymin}, {xmax, ymax}}, opts], \[IndentingNewLine]Raster[array_, {{xmin_, ymin_}, {xmax_, ymax_}}, {zmin_, zmax_}, opts___?OptionQ] \[RuleDelayed] rasterconvert[Map[\(1\/\(zmax - zmin\)\) # + \((zmin\/\(\(-zmax\) + zmin\))\) &, array, {2}], {{xmin, ymin}, {xmax, ymax}}, opts]}\)



\!\(\(TrimPolygons[f_, {fmin_, fmax_}]\)[polygrid : {Polygon[_] .. }] := \[IndentingNewLine]Flatten[\[IndentingNewLine]\(Module[\[IndentingNewLine]{pts = First[#], \[IndentingNewLine]ptlist = {}, \[IndentingNewLine]inQ, vals, fraclow, frachigh, i, j, \[IndentingNewLine]p1, p2, f1, f2, lowin, highin, in, low, high}, \[IndentingNewLine]\[IndentingNewLine]inQ[pt_] := fmin \[LessEqual] f @@ pt \[LessEqual] fmax; \[IndentingNewLine]vals = \(f @@ # &\) /@ pts; \[IndentingNewLine]\[IndentingNewLine]Do[\[IndentingNewLine]j = Mod[i + 1, 4, 1]; \[IndentingNewLine]{p1, p2} = pts\_\(\(\[LeftDoubleBracket]\)\({i, j}\)\(\[RightDoubleBracket]\)\); \[IndentingNewLine]{f1, f2} = vals\_\(\(\[LeftDoubleBracket]\)\({i, j}\)\(\[RightDoubleBracket]\)\); \[IndentingNewLine]If[inQ[p1], ptlist = Join[ptlist, {p1}]]; \[IndentingNewLine]If[Chop[f2 - f1] == 0. , lowin = False; highin = False, fraclow = \((fmin - f1)\)/\((f2 - f1)\); lowin = 0 \[LessEqual] fraclow \[LessEqual] 1; frachigh = \((fmax - f1)\)/\((f2 - f1)\); highin = 0 \[LessEqual] frachigh \[LessEqual] 1]; \[IndentingNewLine]ptlist = \[IndentingNewLine]Which[\[IndentingNewLine]\[Not] \((lowin \[Or] highin)\), ptlist, \[IndentingNewLine]lowin \[And] \[Not] highin, Join[ptlist, {p1 + fraclow \((p2 - p1)\)}], \[IndentingNewLine]highin \[And] \[Not] lowin, Join[ptlist, {p1 + frachigh \((p2 - p1)\)}], \[IndentingNewLine]fraclow < frachigh, Join[ptlist, {p1 + fraclow \((p2 - p1)\), p1 + frachigh \((p2 - p1)\)}], \[IndentingNewLine]True, Join[ptlist, {p1 + frachigh \((p2 - p1)\), p1 + fraclow \((p2 - p1)\)}]], \[IndentingNewLine]{i, 1, 4}]; \[IndentingNewLine]\[IndentingNewLine]If[Length[ptlist] \[Equal] 0, {}, \[IndentingNewLine]Polygon[ptlist]]\[IndentingNewLine]] &\) /@ polygrid]\)



TwoColorScale[{zmin_,z0_,zmax_},colors:
        {lowcolor_:ColorMix[White,Black][0.6],
          color1_:ColorMix[White,Blue][0.8],
          color2_:ColorMix[White,Blue][0.2],
          color3_:ColorMix[White,Red][0.2],
          color4_:ColorMix[White,Red][0.8],
          highcolor_:ColorMix[White,Black][0.1]}][z_]:=
  Which[
    z<zmin,lowcolor,
    zmin\[LessEqual]z\[LessEqual]z0,
    ColorMix[color1,color2][(z-zmin)/(z0-zmin)],
    z0<z\[LessEqual]zmax,ColorMix[color3,color4][(z-z0)/(zmax-z0)],
    True,highcolor]



End[]

Protect[Evaluate[Context[]<>"*"]]

EndPackage[]