(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)









(* :Title: DrawingSurfaceOfRevolution *)
(* :Context: DrawGraphics`DrawingSurfaceOfRevolution` *)
(* :Author: David J. M. Park Jr. djmp@earthlink.net *)
(* :Summary: 
      This is an auxiliary package to DrawingCube` which loads the \
Graphics`SurfaceOfRevolution` package and provides the associated drawing \
routines. *)
(* :Copyright: \[Copyright] 1998, 2001 by David J. M. Park Jr. *)
(* :Package Version: 2.0 *)
(* :Mathematica Version: 4.0 *)
(* :Keywords: Graphics3D, plot combinations, SurfaceOfRevolution *)
(* :Requirements: Graphics`SurfaceOfRevolution` *)





BeginPackage["DrawGraphics`DrawingSurfaceOfRevolution`",{"Graphics`\
SurfaceOfRevolution`"}]

Graphics`DrawingSurfaceOfRevolution::usage="DrawingSurfaceOfRevolution is an \
auxiliary package for DrawGraphics that loads the \
Graphics`SurfaceOfRevolution package and provides the associated drawing \
routines."



DrawListSurfaceOfRevolution::usage=
    "DrawListSurfaceOfRevolution[pts, ({t, tmin, tmax})] will generate a \
rotated surface from the list of points pts (either pairs in the x-z plane, \
or triplets in space), with the variable of rotation being t, ranging from \
tmin to tmax (if not specified, the rotation will be all the way around the \
axis).  DrawListSurfaceOfRevolution accepts the option RevolutionAxis, along \
with Graphics3D options. The primitive Graphics3D objects are extracted from \
the corresponding ListSurfaceOfRevolution routine. Options may be passed to \
ListSurfaceOfRevolution through the last arguments.";



DrawSurfaceOfRevolution::usage="DrawSurfaceOfRevolution[fun, {u, u0, u1}, \
(options...)] draws the surface of revolution of the curve defined by the \
function fun (the dependent variable is in the z plane). \
DrawSurfaceOfRevolution[{xfun, zfun}, {u, u0, u1}, (options...)] draws the \
surface of revolution of the curve defined  parametrically by {xfun, zfun}. \
DrawSurfaceOfRevolution[{xfun, yfun, zfun}, {u, u0, u1}] is also allowed.  \
The range of  revolution can be specified after the range of the variable u \
by {t, tmin, tmax}.  SurfaceOfRevolution accepts the option RevolutionAxis, \
along with ParametricPlot3D options. The primitive Graphics3D objects are \
extracted from the corresponding SurfaceOfRevolution routine. Options may be \
passed to SurfaceOfRevolution through the last arguments.";



Begin["`Private`"]



DrawListSurfaceOfRevolution[points_List,opts___?OptionQ]:=
    First[ListSurfaceOfRevolution[points,DisplayFunction\[Rule]Identity,
        opts]];

DrawListSurfaceOfRevolution[points_List,iter:{_,_,_},opts___?OptionQ]:=
  First[ListSurfaceOfRevolution[points,iter,DisplayFunction\[Rule]Identity,
      opts]]



DrawSurfaceOfRevolution[f_,iter:{_,_,_},opts___?OptionQ]:=
    First[SurfaceOfRevolution[f,iter,DisplayFunction\[Rule]Identity,opts]];

DrawSurfaceOfRevolution[f_,iter1:{_,_,_},iter2:{_,_,_},opts___?OptionQ]:=
    First[SurfaceOfRevolution[f,iter1,iter2,DisplayFunction\[Rule]Identity,
        opts]];



End[]

Protect[Evaluate[Context[]<>"*"]]

EndPackage[]