(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)









(* :Title: DrawingTicksAndGrids *)
(* :Context: DrawGraphics`DrawingTicksAndGrids` *)
(* :Author: David J. M. Park Jr. djmp@earthlink.net *)
(* :Summary: 
      This is an auxiliary package to DrawingPaper which provides routines \
for drawing customized tick lines and grids. *)
(* :Copyright: \[Copyright] 2000, 2001 by David J. M. Park Jr. *)
(* :Package Version: 2.0 *)
(* :Mathematica Version: 4.0 *)
(* :Keywords: graphics, Girds, Ticks *)
(* :Requirements: Graphics`Colors` *)





BeginPackage["DrawGraphics`DrawingTicksAndGrids`",{"Graphics`Colors`"}]

DrawGraphics`DrawingTicksAndGrids::usage=
  "DrawingTicksAndGrids is an auxiliary package for DrawGraphics that provides routines for drawing customized ticks, grids and free standing scales."



\!\(\(CustomTicks::usage = \*"\"\<CustomTicks[inversefunction, tickspecs, options] will generate custom tick marks. If the normal axes is given by the variable u, but is to labeled by v = f[u] then the inverse function \!\(f\^\(-1\)\) must be supplied as a pure function. If a linear scale is to be used, tickspecs will take the form: {start, end, inc, subdivisions}. subdivisions of n will provide n-1 unlabeled tick marks between each labeled tick mark. If a log scale is to be used, tickspecs will take the form {startpower, endpower, vals, subvals} where vals and subvals are the lists of the labeled and unlabeled values in one decade. The labeled ticks will be \!\(10\^power\) vals where power ranges from the start to end value. If tickspecs is of the form databased[valuelist] tick marks will be put at the specific values given in the list. Mathematica will eliminate any ticks which are outside the PlotRange.\\n\\nThe options for CustomTicks are:CTNumberFunction, CTTickSpecs, CTTickStyle, CTUnLabTickSpecs, CTUnLabTickStyle. See their usage messages.\>\"";\)\)

CTNumberFunction::usage="CTNumberFunction is an option for CustomTicks which specifies a pure function to be applied to tick values to give the desired formatting. Its default value is Identity.";

CTNumberFunction::usage="CTNumberFunction is an option for CustomTicks which specifies a pure function to be applied to tick values to give the desired formatting. Its default value is Identity. Examples:\n (\"\"&) - No labels\n(NumberForm[#,{3,2}, NumberPadding \[Rule] {\" \",\"0\"}]&)\n(StyleForm[#,FontSize \[Rule] 15,FontColor \[Rule] Blue]&).";

CTTickSpecs::usage="CTTickSpecs is an option for CustomTicks which specifies the negative and positive tick lengths. Its default value is {0.00625,0}. This is appropriate for upper and right frame axes";

CTTickStyle::usage="CTTickStyle is an option for CustomTicks which gives a list of style directives for the labeled tick marks.";

CTUnLabTickSpecs::usage="CTUnLabTickSpecs is an option for CustomTicks which specifies the negative and positive unlabeled tick lengths. Its default value is {0.00375,0}. This is appropriate for upper and right frame axes";\

CTUnLabTickStyle::usage="CTUnLabTickStyle is an option for CustomTicks which gives a list of style directives for the unlabeled tick marks.";



\!\(\(CustomGridLines::usage = \*"\"\<CustomGridLines[inversefunction, gridspecs, gridstyle:{LightBlue}] will generate custom gridlines. The routine works in a similar manner as CustonTicks. If the normal axes is given by the variable u, but is labeled by v = f[u] then the inverse function \!\(f\^\(-1\)\) must be supplied as a pure function. Otherwise, use the Identity function. If a linear scale is to be used, gridspecs will take the form: {start, end, inc}. If a log scale is to be used, gridspecs will take the form {startpower, endpower, vals} where vals is a list of the grid lines in one decade. The grid lines will occur at \!\(10\^power\) vals where power ranges from the start to end value. If gridspecs is of the form databased[valuelist] grid lines will be put at the specific values given in the list. Mathematica will eliminate any grid lines which are outside the PlotRange. gridstyle is an optional argument which specifies a list of graphics directives for the grid lines. The default gridstyle is {LightBlue}.\>\"";\)\)



XTickLine::usage="XTickLine[{xmin, xmax, yloc},{rangemin, rangemax},{labelstart, labelend, increment}, subdivisions, options...] will draw a horizontal labeled line with tick marks.\nxmin, xmax and yloc control the actual placement of the line in the graphics. \nrangemin and rangemax specify what number range this line is meant to signify. \nlabelstart, labelend and increment specify the values and spacing for the major tick marks. \nsubdivisions gives the number of subdivisions between major tick marks. \nThe options are XLabTickSpecs, XUnLabTickSpecs and XTextSpecs which control finer details. See their usage messages. ";

XLabTickSpecs::usage="XLabTickSpecs is an option for XTickLine which specifies the details of the labeled tick lines. It can take the form {plen, mlen, {style directives}}, where the last item is optional. plen and  mlen are as in the regular Mathematica tick specification. The default value is {0.00625, 0}.";

XUnLabTickSpecs::usage="XUnLabTickSpecs is an option for XTickLine which specifies the details of the minor unlabeled tick lines. It can take the form {plen, mlen, {style directives}}, where the last item is optional. plen and  mlen are as in the regular Mathematica tick specification. The default value is {0.00375, 0}.";

XTextSpecs::usage="XTextSpecs is an option for XTickLine which specifies the placement and style for the label values. It takes the form {offset, direction, displacement, options...} where offset and direction are as in a regular Text statement. displacement is the Scaled displacement of the label from the line. options can be used to pass StyleForm type options for the label. The default value is {{0,1}, {1,0}, 0.002}.";



YTickLine::usage="YTickLine[{ymin, ymax, xloc},{rangemin, rangemax},{labelstart, labelend, increment}, subdivisions, options...] will draw a vertical labeled line with tick marks.\nymin, ymax and xloc control the actual placement of the line in the graphics. \nrangemin and rangemax specify what number range this line is meant to signify. \nlabelstart, labelend and increment specify the values and spacing for the major tick marks. \nsubdivisions gives the number of subdivisions between major tick marks. \nThe options are YLabTickSpecs, YUnLabTickSpecs and YTextSpecs which control finer details. See their usage messages. ";

YLabTickSpecs::usage="YLabTickSpecs is an option for YTickLine which specifies the details of the labeled tick lines. It can take the form {plen, mlen, {style directives}}, where the last item is optional. plen and  mlen are as in the regular Mathematica tick specification. The default value is {0.00625, 0}.";

YUnLabTickSpecs::usage="YUnLabTickSpecs is an option for YTickLine which specifies the details of the minor unlabeled tick lines. It can take the form {plen, mlen, {style directives}}, where the last item is optional. plen and  mlen are as in the regular Mathematica tick specification. The default value is {0.00375, 0}.";\

YTextSpecs::usage="YTextSpecs is an option for YTickLine which specifies the placement and style for the label values. It takes the form {offset, direction, displacement, options...} where offset and direction are as in a regular Text statement. displacement is the Scaled displacement of the label from the line. options can be used to pass StyleForm type options for the label. The default value is {{1,0},{1,0},0.002}.";



XSymbolicScale::usage="XSymbolicScale[{xmin, xmax, yloc}, {x0, x1}, marks:{{x, xval}..}, yplus:0.02, yminus:0, labloc:-0.04] will draw a scale in the x direction with tick marks and values as indicated in the marks list. The scale line will run from xmin to xmax on the plot with yloc as the vertical coordinate. The scale will linearly represent values from x0 \[LessEqual] x \[LessEqual] x1. For each mark xval may be a symbol, expression or number. The mark values may optionally be given as {x, xval, textoffset} where textoffset is inserted in the Text statement displaying the value. The default value for textoffset is {0,0}.";



YSymbolicScale::usage="YSymbolicScale[{ymin, ymax, xloc}, {y0, y1}, marks:{{y, yval}..}, xplus:0.02, xminus:0, labloc:-0.04] will draw a scale in the y direction with tick marks and values as indicated in the marks list. The scale line will run from ymin to ymax on the plot with xloc as the horizontal coordinate. The scale will linearly represent values from y0 \[LessEqual] y \[LessEqual] y1. For each mark yval may be a symbol, expression or number. The mark values may optionally be given as {y, yval, textoffset} where textoffset is inserted in the Text statement displaying the value. The default value for textoffset is {0,0}.";



Begin["`Private`"]



\!\(CustomGridLines[invfunc_, gridvalues : \(({_?NumericQ, _?NumericQ, _?NumericQ} | {_Integer, _Integer, _List} | Global`databased[_])\), gridstyle_List : {LightBlue}] := Module[{grids, i, startexp, endexp, vals, gridstart, gridend, inc}, Switch[gridvalues, \[IndentingNewLine]{_?NumericQ, _?NumericQ, _?NumericQ}, \[IndentingNewLine]{gridstart, gridend, inc} = gridvalues; \[IndentingNewLine]\ grids = Select[Table[x, {x, gridstart, gridend, inc}], NumericQ[invfunc[#1]] &], \[IndentingNewLine]\[IndentingNewLine]{_Integer, _Integer, _List}, \[IndentingNewLine]{startexp, endexp, vals} = gridvalues; grids = Flatten[Table[10\^i\ vals, {i, startexp, endexp}]], \[IndentingNewLine]\[IndentingNewLine]Global`databased[_], \[IndentingNewLine]grids = gridvalues\[LeftDoubleBracket]1\[RightDoubleBracket]]; \[IndentingNewLine]\[IndentingNewLine]\(({invfunc[#1], gridstyle} &)\) /@ grids]\)



Options[CustomTicks] = {CTNumberFunction -> Identity, 
    CTTickSpecs -> {0.00625, 0}, CTTickStyle -> {}, 
    CTUnLabTickSpecs -> {0.00375, 0}, CTUnLabTickStyle -> {}}; 

CustomTicks[invfunc_,
    tickvalues:({_?NumericQ,_?NumericQ,_?NumericQ,_Integer?
              Positive}|{_Integer,_Integer,_List,_List}|
          Global`databased[_]),(opts___)?OptionQ]:=
  Module[{majorticks,minorticks,numfunc,tickspecs,tickstyle,Utickspecs,
      Utickstyle,i,startexp,endexp,vals,subvals,labelstart,labelend,inc,
      subdivisions},
    
    numfunc=CTNumberFunction/.{opts}/.Options[CustomTicks];
    tickspecs=CTTickSpecs/.{opts}/.Options[CustomTicks];
    tickstyle=CTTickStyle/.{opts}/.Options[CustomTicks];
    Utickspecs=CTUnLabTickSpecs/.{opts}/.Options[CustomTicks];
    Utickstyle=CTUnLabTickStyle/.{opts}/.Options[CustomTicks];
    
    Switch[tickvalues,
      {_?NumericQ,_?NumericQ,_?NumericQ,_Integer?Positive},{labelstart,
          labelend,inc,subdivisions}=tickvalues;
      majorticks=
        Select[Table[x,{x,labelstart,labelend,inc}],NumericQ[invfunc[#1]]&];
      minorticks=
        Complement[
          Select[Table[x,{x,labelstart,labelend,inc/subdivisions}],
            NumericQ[invfunc[#1]]&],majorticks],
      
      {_Integer,_Integer,_List,_List},{startexp,endexp,vals,subvals}=
        tickvalues;majorticks=Flatten[Table[10^i*vals,{i,startexp,endexp}]];
      minorticks=Flatten[Table[10^i*subvals,{i,startexp,endexp}]],
      
      Global`databased[_],
      majorticks=tickvalues\[LeftDoubleBracket]1\[RightDoubleBracket];
      minorticks={}];
    Join[({invfunc[#1],numfunc[#1],tickspecs,tickstyle}&)/@
        majorticks,({invfunc[#1],"",Utickspecs,Utickstyle}&)/@minorticks]]



Options[XTickLine]={XLabTickSpecs\[Rule]{0.00625,0.},
      XUnLabTickSpecs\[Rule]{0.00375,0.},
      XTextSpecs\[Rule]{{0,1},{1,0},0.002}};

XTickLine[{xmin_,xmax_,yloc_},{rmin_,rmax_},lticks:{lstart_,lend_,ldel_},
    uldiv_,opts___?OptionQ]:=
  Module[{x,r,labtickspecs,unlabtickspecs,textspecs,lplen,lmlen,uplen,umlen,
      lstyle,ustyle,udel,umin,umax,textoff,textdir,textopts,textdisp},
    labtickspecs=(XLabTickSpecs/.{opts}/.Options[XTickLine]);
    unlabtickspecs=(XUnLabTickSpecs/.{opts}/.Options[XTickLine]);
    textspecs=(XTextSpecs/.{opts}/.Options[XTickLine]);
    
    {lplen,lmlen}=labtickspecs\[LeftDoubleBracket]{1,2}\[RightDoubleBracket];
    {uplen,umlen}=
      unlabtickspecs\[LeftDoubleBracket]{1,2}\[RightDoubleBracket];
    lstyle=
      If[Length[labtickspecs]\[GreaterEqual]3,
        labtickspecs\[LeftDoubleBracket]3\[RightDoubleBracket],{}];
    ustyle=
      If[Length[unlabtickspecs]\[GreaterEqual]3,
        unlabtickspecs\[LeftDoubleBracket]3\[RightDoubleBracket],{}];
    textoff=textspecs\[LeftDoubleBracket]1\[RightDoubleBracket];
    textdir=textspecs\[LeftDoubleBracket]2\[RightDoubleBracket];
    textdisp=textspecs\[LeftDoubleBracket]3\[RightDoubleBracket];
    textopts=Flatten[Drop[textspecs,3]];
    
    udel=ldel/uldiv;
    umin=lstart-Floor[(lstart-rmin)/udel]udel;
    umax=lend+Floor[(rmax-lend)/udel]udel;
    
    {Line[{{xmin,yloc},{xmax,yloc}}],
      Table[
        x=xmin+(r-rmin)(xmax-xmin)/(rmax-rmin);{Sequence@@ustyle,
          Line[{Scaled[{0,0},{x,yloc}],Scaled[{0,uplen},{x,yloc}]}],
          Line[{Scaled[{0,0},{x,yloc}],Scaled[{0,-umlen},{x,yloc}]}]},{r,umin,
          umax,udel}],
      Table[
        x=xmin+(r-rmin)(xmax-xmin)/(rmax-rmin);{{Sequence@@lstyle,
            Line[{Scaled[{0,0},{x,yloc}],Scaled[{0,lplen},{x,yloc}]}],
            Line[{Scaled[{0,0},{x,yloc}],Scaled[{0,-lmlen},{x,yloc}]}]},
          Text[StyleForm[r,Sequence@@textopts],Scaled[{0,-textdisp},{x,yloc}],
            textoff,textdir]},{r,lstart,lend,ldel}]}
    ]



Options[YTickLine]={YLabTickSpecs\[Rule]{0.00625,0.},
      YUnLabTickSpecs\[Rule]{0.00375,0.},
      YTextSpecs\[Rule]{{1,0},{1,0},0.002}};

YTickLine[{ymin_,ymax_,xloc_},{rmin_,rmax_},lticks:{lstart_,lend_,ldel_},
    uldiv_,opts___?OptionQ]:=
  Module[{y,r,labtickspecs,unlabtickspecs,textspecs,lplen,lmlen,uplen,umlen,
      lstyle,ustyle,udel,umin,umax,textoff,textdir,textopts,textdisp},
    labtickspecs=(YLabTickSpecs/.{opts}/.Options[YTickLine]);
    unlabtickspecs=(YUnLabTickSpecs/.{opts}/.Options[YTickLine]);
    textspecs=(YTextSpecs/.{opts}/.Options[YTickLine]);
    
    {lplen,lmlen}=labtickspecs\[LeftDoubleBracket]{1,2}\[RightDoubleBracket];
    {uplen,umlen}=
      unlabtickspecs\[LeftDoubleBracket]{1,2}\[RightDoubleBracket];
    lstyle=
      If[Length[labtickspecs]\[GreaterEqual]3,
        labtickspecs\[LeftDoubleBracket]3\[RightDoubleBracket],{}];
    ustyle=
      If[Length[unlabtickspecs]\[GreaterEqual]3,
        unlabtickspecs\[LeftDoubleBracket]3\[RightDoubleBracket],{}];
    textoff=textspecs\[LeftDoubleBracket]1\[RightDoubleBracket];
    textdir=textspecs\[LeftDoubleBracket]2\[RightDoubleBracket];
    textdisp=textspecs\[LeftDoubleBracket]3\[RightDoubleBracket];
    textopts=Flatten[Drop[textspecs,3]];
    
    udel=ldel/uldiv;
    umin=lstart-Floor[(lstart-rmin)/udel]udel;
    umax=lend+Floor[(rmax-lend)/udel]udel;
    
    {Line[{{xloc,ymin},{xloc,ymax}}],
      Table[
        y=ymin+(r-rmin)(ymax-ymin)/(rmax-rmin);{Sequence@@ustyle,
          Line[{Scaled[{0,0},{xloc,y}],Scaled[{uplen,0},{xloc,y}]}],
          Line[{Scaled[{0,0},{xloc,y}],Scaled[{-umlen,0},{xloc,y}]}]},{r,umin,
          umax,udel}],
      Table[
        y=ymin+(r-rmin)(ymax-ymin)/(rmax-rmin);{{Sequence@@lstyle,
            Line[{Scaled[{0,0},{xloc,y}],Scaled[{lplen,0},{xloc,y}]}],
            Line[{Scaled[{0,0},{xloc,y}],Scaled[{-lmlen,0},{xloc,y}]}]},
          Text[StyleForm[r,Sequence@@textopts],Scaled[{-textdisp,0},{xloc,y}],
            textoff,textdir]},{r,lstart,lend,ldel}]}
    ]



\!\(XSymbolicScale[{xmin_, xmax_, yloc_}, {x0_, x1_}, marks : {{_, __} .. }, yplus_:  0.02, yminus_:  0, labloc_: - 0.04] := \[IndentingNewLine]Module[\[IndentingNewLine]{x, xval, xp, i, mark, textoffset}, \[IndentingNewLine]{Line[{{xmin, yloc}, {xmax, yloc}}], \[IndentingNewLine]Table[\[IndentingNewLine]mark = Part[marks, i]; \[IndentingNewLine]{x, xval} = Take[mark, 2]; \[IndentingNewLine]textoffset = If[Length[mark] > 2, Part[mark, 3], {0, 0}]; \[IndentingNewLine]xp = \(x\ xmax - x0\ xmax - x\ xmin + x1\ xmin\)\/\(\(-x0\) + x1\); \[IndentingNewLine]{Line[{Scaled[{0, yplus}, {xp, yloc}], Scaled[{0, yminus}, {xp, yloc}]}], \[IndentingNewLine]Text[xval, Scaled[{0, labloc}, {xp, yloc}], textoffset]}, {i, 1, Length[marks]}]}]\)



\!\(YSymbolicScale[{ymin_, ymax_, xloc_}, {y0_, y1_}, marks : {{_, __} .. }, xplus_:  0.02, xminus_:  0, labloc_: - 0.04] := \[IndentingNewLine]Module[\[IndentingNewLine]{y, yval, yp, i, mark, textoffset}, \[IndentingNewLine]{Line[{{xloc, ymin}, {xloc, ymax}}], \[IndentingNewLine]Table[\[IndentingNewLine]mark = Part[marks, i]; \[IndentingNewLine]{y, yval} = Take[mark, 2]; \[IndentingNewLine]textoffset = If[Length[mark] > 2, Part[mark, 3], {0, 0}]; \[IndentingNewLine]yp = \(y\ ymax - y0\ ymax - y\ ymin + y1\ ymin\)\/\(\(-y0\) + y1\); \[IndentingNewLine]{Line[{Scaled[{xplus, 0}, {xloc, yp}], Scaled[{xminus, 0}, {xloc, yp}]}], \[IndentingNewLine]Text[yval, Scaled[{labloc, 0}, {xloc, yp}], textoffset]}, {i, 1, Length[marks]}]}]\)



End[]

Protect[Evaluate[Context[]<>"*"]]

EndPackage[]