(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)









(* :Title: InequalityDrawing *)
(* :Context: DrawGraphics`InequalityDrawing` *)
(* :Author: David J. M. Park Jr. djmp@earthlink.net *)
(* :Summary: 
      This is an auxiliary package to DrawingPaper and DrawingCube which \
loads the Graphics`InequalityGraphics` package and provides the associated \
drawing routines. *)
(* :Copyright: \[Copyright] 2001 by David J. M. Park Jr. *)
(* :Package Version: 2.0 *)
(* :Mathematica Version: 4.1 *)
(* :Keywords: graphics, plot combinations, InequalityPlot *)
(* :Requirements: Graphics`InequalityGraphics` *)





BeginPackage["DrawGraphics`InequalityDrawing`",{"Graphics`InequalityGraphics`\
"}]

DrawGraphics`InequalityDrawing::usage="InequalityDrawing is an auxiliary \
package for DrawGraphics that loads the Graphics`InequalityGraphics` package \
and provides the associated drawing routines."



ComplexInequalityDraw::usage=
    "ComplexInequalityDraw[ineqs, {z, zmin, zmax}, opts... ] plots the the \
region defined by ineqs within the box bounded by {Re[zmin], Im[zmin]} and \
{Re[zmax], Im[zmax]}. The functions that occur within the inequality need to \
be real valued functions of a complex argument, e.g. Abs, Re and Im. The \
primitive Graphics objects are extracted from the corresponding \
ComplexInequalityPlot routine. Options may be passed to ComplexInequalityPlot \
through the last arguments.";



InequalityDraw::usage=
    "InequalityDraw[ineqs, {x,xmin,xmax}, {y,ymin,ymax}, opts...] plots \
region defined by ineqs within the box bounded by {xmin, ymin} and {xmax, \
ymax}. The primitive Graphics objects are extracted from the corresponding \
InequalityPlot routine. Options may be passed to InequalityPlot through the \
last arguments.";



InequalityDraw3D::usage=
    "InequalityDraw3D[ineqs, {x,xmin,xmax}, {y,ymin,ymax}, {z,zmin,zmax}, \
opts...] plots the set described by the inequalities ineqs within the box \
bounded by {xmin,ymin,zmin} and {xmax,ymax,zmax}. The primitive Graphics3D \
objects are extracted from the corresponding InequalityPlot3D routine. \
Options may be passed to InequalityPlot3D through the last arguments.";



Begin["`Private`"]



ComplexInequalityDraw[ineqs_,range1_List,opts___?OptionQ]:=
  First[ComplexInequalityPlot[ineqs,range1,opts,
      DisplayFunction\[Rule]Identity]]



InequalityDraw[ineqs_,range1_List,range2_List,opts___?OptionQ]:=
  First[InequalityPlot[ineqs,range1,range2,opts,
      DisplayFunction\[Rule]Identity]]



InequalityDraw3D[ineqs_,range1_List,range2_List,range3_List,opts___?OptionQ]:=
  First[InequalityPlot3D[ineqs,range1,range2,range3,opts,
      DisplayFunction\[Rule]Identity]]



End[]

Protect[Evaluate[Context[]<>"*"]]

EndPackage[]