(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)









(* :Title: ParametricDrawing3D *)
(* :Context: DrawGraphics`ParametricDrawing3D` *)
(* :Author: David J. M. Park Jr. djmp@earthlink.net *)
(* :Summary: 
      This is an auxiliary package to DrawingCube` which loads the \
Graphics`ParametricPlot3D package and provides the associated drawing \
routines. *)
(* :Copyright: \[Copyright] 1998, 2001 by David J. M. Park Jr. *)
(* :Package Version: 2.0 *)
(* :Mathematica Version: 4.0, 4.1 *)
(* :Keywords: Graphics3D, plot combinations, ParametricPlot3D *)
(* :Requirements: Graphics`ParametricPlot3D` *)





BeginPackage["DrawGraphics`ParametricDrawing3D`", 
  {"Graphics`ParametricPlot3D`"}]

DrawGraphics`ParametricDrawing3D::usage="ParametricDrawing3D is an auxiliary \
package for DrawGraphics that loads the Graphics`ParametricPlot3D package and \
provides the associated drawing routines."



CylindricalDraw3D::usage="CylindricalDraw3D[z, {r, rmin, rmax}, {phi, phimin, \
phimax}, (options)] draws z as a function of r and phi. CylindricalDraw3D[{z, \
style},  ...] uses style to render each surface patch. The primitive \
Graphics3D objects are extracted from the corresponding CylindricalPlot3D \
routine. Options may be passed to CylindricalPlot3D through the last \
arguments.";



ParametricDraw3D::usage="ParametricDraw3D[{fx, fy, fz}, {t, tmin, tmax}] \
produces a three-dimensional space curve parametrized by a variable t which \
runs from tmin to tmax. ParametricDraw3D[{fx, fy, fz}, {t, tmin, tmax}, {u, \
umin, umax}] produces a three-dimensional surface parametrized by t and u. \
ParametricDraw3D[{fx, fy, fz, s}, ... ] shades the plot according to the \
color specification s. ParametricDraw3D[{{fx, fy, fz}, {gx, gy, gz}, ... }, ... \
] plots several objects together. ParametricDraw3D[{x,y,z,(style)}, \
{u,u0,u1,du}, ({v,v0,v1,dv})] uses increments du and dv instead of the \
PlotPoints option. The primitive Graphics3D objects are extracted from the \
corresponding ParametricPlot3D routine. Options may be passed to \
ParametricPlot3D through the last arguments.";



PointParametricDraw3D::usage="PointParametricDraw3D[{x,y,z}, {u,u0,u1,(du)}, \
(options)] draws a one-parameter set of points in space. \
PointParametricDraw3D[{x,y,z}, {u,u0,u1,(du)}, {v,v0,v1,(dv)}, (options)] \
draws a two-parameter set of points in space. Options are passed to Show. The \
primitive Graphics3D objects are extracted from the corresponding \
PointParametricPlot3D routine. Options may be passed to PointParametricPlot3D \
through the last arguments.";



SphericalDraw3D::usage="SphericalDraw3D[r, {theta, thetamin, thetamax}, {phi, \
phimin, phimax}, (options)] draws r as a function of the angles theta and \
phi. SphericalDraw3D[{r, style}, ...] uses style to render each surface \
patch. The primitive Graphics3D objects are extracted from the corresponding \
SphericalPlot3D routine. Options may be passed to SphericalPlot3D through the \
last arguments.";



ToSingleLine::usage=
    "ToSingleLine[expr] converts the graphics primitives produced by \
ParametricPlot3D with a single iterator to a single Line with multiple \
points. The normal output is multiple two-point Lines.";



Begin["`Private`"]



Attributes[CylindricalDraw3D]={HoldFirst};
CylindricalDraw3D[z_,iter1:{_,_,__},iter2:{_,_,__},opts___?OptionQ]:=
  First[CylindricalPlot3D[z,iter1,iter2,DisplayFunction\[Rule]Identity,
      Evaluate[opts]]]



Attributes[ParametricDraw3D]={HoldAll};
ParametricDraw3D[data__]:=
  First[ParametricPlot3D[data,DisplayFunction\[Rule]Identity]]



Attributes[PointParametricDraw3D]={HoldFirst};
PointParametricDraw3D[funs:{_,_,_},iter:{_,_,_,_},opts___?OptionQ]:=
    First[PointParametricPlot3D[funs,iter,DisplayFunction\[Rule]Identity,
        Evaluate[opts]]];

PointParametricDraw3D[funs:{_,_,_},iter1:{_,_,__},iter2:{_,_,__},
    opts___?OptionQ]:=
  First[PointParametricPlot3D[funs,iter1,iter2,DisplayFunction\[Rule]Identity,
      Evaluate[opts]]]



Attributes[SphericalDraw3D]={HoldFirst};
SphericalDraw3D[r_,iter1:{_,_,__},iter2:{_,_,__},opts___?OptionQ]:=
  First[SphericalPlot3D[r,iter1,iter2,DisplayFunction\[Rule]Identity,
      Evaluate[opts]]]




ToSingleLine[expr_]:=
  expr/.a:{Line[{{_,_,_},{_,_,_}}]..}\[RuleDelayed]
      Line[Join[
          First@@#&/@a,{Last[a]\[LeftDoubleBracket]1,2\[RightDoubleBracket]}]]



End[]

Protect[Evaluate[Context[]<>"*"]]

EndPackage[]