(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)



(* :Package Version:1.0.8.6*)
(* :Copyright:Copyright 2002,
  Selwyn Hollis*)(* :Name:Graphics`PolarDensity`*)
(* :Author:Selwyn Hollis*)(* :
    Description:
      This package defines the functions PolarDensityPlot and \
ListPolarDensityPlot.*)

BeginPackage["DrawGraphics`PolarDensity`"]

ListPolarDensityPlot::"usage"="ListPolarDensityPlot[matrix] generates a polar density plot from an array of height values. Rows of matrix correspond to constant angles, and columns of matrix correspond to constant radii.";

PolarDensityPlot::"usage"="PolarDensityPlot[ f[r,\[Theta]], {r, r1, r2}, {\[Theta], \[Theta]1, \[Theta]2} ] \ngenerates a polar density plot of f[r,\[Theta]].";

Options[ListPolarDensityPlot]={AspectRatio\[Rule]Automatic,
      Background\[Rule]Automatic,ColorFunction\[Rule]Automatic,
      ColorFunctionScaling\[Rule]True,ColorOutput\[Rule]Automatic,
      DefaultColor\[Rule]Automatic,Epilog\[Rule]{},Frame\[Rule]Automatic,
      FrameLabel\[Rule]None,FrameStyle\[Rule]Automatic,
      FrameTicks\[Rule]Automatic,GridLines\[Rule]None,
      ImageSize\[Rule]Automatic,Mesh\[Rule]False,MeshStyle\[Rule]GrayLevel[0],
      PlotLabel\[Rule]None,PlotRange\[Rule]Automatic,
      PlotRegion\[Rule]Automatic,Prolog\[Rule]{},RotateLabel\[Rule]True,
      Ticks\[Rule]Automatic,DefaultFont\[RuleDelayed]$DefaultFont,
      DisplayFunction\[RuleDelayed]$DisplayFunction,
      FormatType\[RuleDelayed]$FormatType,TextStyle\[RuleDelayed]$TextStyle};

Options[PolarDensityPlot]={AspectRatio\[Rule]Automatic,
      Background\[Rule]Automatic,ColorFunction\[Rule]Automatic,
      ColorFunctionScaling\[Rule]True,ColorOutput\[Rule]Automatic,
      DefaultColor\[Rule]Automatic,Epilog\[Rule]{},Frame\[Rule]Automatic,
      FrameLabel\[Rule]None,FrameStyle\[Rule]Automatic,
      FrameTicks\[Rule]Automatic,GridLines\[Rule]None,
      ImageSize\[Rule]Automatic,Mesh\[Rule]False,MeshStyle\[Rule]GrayLevel[0],
      PlotLabel\[Rule]None,PlotRange\[Rule]Automatic,
      PlotRegion\[Rule]Automatic,Prolog\[Rule]{},RotateLabel\[Rule]True,
      Ticks\[Rule]Automatic,DefaultFont\[RuleDelayed]$DefaultFont,
      DisplayFunction\[RuleDelayed]$DisplayFunction,
      FormatType\[RuleDelayed]$FormatType,TextStyle\[RuleDelayed]$TextStyle};

Begin["`Private`"]

<<Utilities`FilterOptions`;

ListPolarDensityPlot::"pr"="Invalid PlotRange.";

truncate[x_]:=x*Map[If[0.\[LessEqual]#\[LessEqual]1.,1.,0.]&,x,{2}]

sectors=Compile[{{m,_Integer},{n,_Integer},r1,dr,theta1,dtheta},
      Flatten[Table[{r1+dr*j,theta1+dtheta*(i-1),theta1+dtheta*i},{j,n,
            1,-1},{i,1,m}],1]];

ListPolarDensityPlot[vals_?MatrixQ,opts___Rule]:=
    Module[{pr,scaledvals,colorfn,sectordata,dims,mesh,mindata,maxdata,
        drawmesh,meshstyle,dr,dtheta,theta1,theta2,r1,r2,z1,z2,bg,colors,
        slices,colfunscale},
      
      colorfn=(ColorFunction/.{opts}/.Options[
                ListPolarDensityPlot])/.{Automatic\[Rule]GrayLevel};
      bg=Background/.{opts}/.Options[ListPolarDensityPlot];
      bg=If[bg===Automatic,GrayLevel[1],bg];
      colorfunscale=
        ColorFunctionScaling/.{opts}/.Options[ListPolarDensityPlot];
      {dim1,dim2}=Dimensions[vals];
      
      pr=(PlotRange/.{opts}/.Options[ListPolarDensityPlot]);
      {mindata,maxdata}={Min[N[vals]],Max[N[vals]]};
      pr=pr//.{{x_,y_,Automatic}\[Rule]{x,y,{mindata,maxdata}},{x_,Automatic,
                z_}\[Rule]{x,{0.,2.*Pi},z},{Automatic,y_,z_}\[Rule]{{0.,1.},y,
                z},{x_,y_,{z1_,Automatic}}\[Rule]{x,y,{z1,maxdata}},{x_,
                y_,{Automatic,z2_}}\[Rule]{x,y,{mindata,z2}}};
      pr=Which[pr===Automatic,{{0.,1.},{0.,2Pi},{mindata,maxdata}},
          VectorQ[pr]&&Length[pr]\[Equal]2,{{0.,1.},{0.,2Pi},
            pr//.{{x_,Automatic}\[Rule]{x,maxdata},{Automatic,
                    y_}\[Rule]{mindata,y}}},1\[Equal]1,pr];
      If[Not[MatrixQ[pr]]||Length[pr]\[NotEqual]3||
          Union[NumericQ/@Flatten[pr]]=!={True},
        Message[ListPolarDensityPlot::"pr"];Return[$Failed]];
      {r1,r2,theta1,theta2,z1,z2}=N[Flatten[pr]];
      
      drawmesh=Mesh/.{opts}/.Options[ListPolarDensityPlot];
      drawmesh=If[drawmesh===True||drawmesh===Automatic,True,False];
      meshstyle=Flatten[{MeshStyle}/.{opts}/.Options[ListPolarDensityPlot]];
      dtheta=(theta2-theta1)/dim1;
      dr=(r2-r1)/dim2;
      mesh=
        If[drawmesh,
          Join[Table[
              Line[Outer[
                  Times,{r2,Max[r1,dr]},{Cos[theta],Sin[theta]}]],{theta,
                theta1+dtheta,theta2,2*dtheta}],
            Table[Line[Outer[Times,{r2,r1},{Cos[theta],Sin[theta]}]],{theta,
                theta1,theta2-dtheta,2*dtheta}],
            Table[Circle[{0,0},r,{theta1,theta2}],{r,Max[r1,dr],r2,dr}]],{}];
      
      scaledvals=
        If[z1\[LessEqual]mindata&&z2\[GreaterEqual]maxdata,(vals-z1)/(z2-z1),
          truncate[(vals-z1)/(z2-z1)]];
      
      scaledvals=
        If[colorfunscale,
          If[z1\[LessEqual]mindata&&
              z2\[GreaterEqual]maxdata,(vals-z1)/(z2-z1),
            truncate[(vals-z1)/(z2-z1)]],vals,vals];
      colors=colorfn/@Flatten[Transpose[Reverse/@scaledvals]];
      slices=
        Disk[{0,0},#1[[1]],#1[[{2,3}]]]&/@
          sectors[dim1,dim2,r1,dr,theta1,dtheta];
      Show[Graphics[Transpose[{colors,slices}]],
        Graphics[{bg,Disk[{0,0},r1,{theta1-dtheta,theta2+dtheta}]}],
        Graphics[Join[meshstyle,mesh]],PlotRange\[Rule]All,Axes\[Rule]False,
        FilterOptions[Graphics,opts],
        FilterOptions[Graphics,Options[ListPolarDensityPlot]]]];

PolarDensityPlot[
      func_,{r_Symbol,r1_?NumericQ,r2_?NumericQ},{theta_Symbol,
        theta1_?NumericQ,theta2_?NumericQ},opts___Rule]:=
    Module[{data,ff,nr,ntheta,dtheta,dr,pp,zrange,colorfunscale},
      pp=PlotPoints/.{opts}/.{PlotPoints\[Rule]Automatic};
      {nr,ntheta}=
        Which[NumericQ[pp],{pp,Floor[.637*(theta2-theta1)*pp]},
          VectorQ[pp]&&Length[pp]\[Equal]2,pp,
          1\[Equal]1,{Automatic,Automatic}];
      nr=If[nr===Automatic,15,nr];
      ntheta=If[ntheta===Automatic,Floor[9.56*(theta2-theta1)],ntheta];
      dtheta=N[(theta2-theta1)/ntheta];
      dr=N[(r2-r1)/nr];
      colorfunscale=
        ColorFunctionScaling/.{opts}/.Options[ListPolarDensityPlot];
      zrange=PlotRange/.{opts}/.Options[PolarDensityPlot];
      ff=Compile[{rr,tt},Evaluate[func/.{r\[Rule]rr,theta\[Rule]tt}]];
      data=
        Table[ff[rr,tt],{tt,theta1+dtheta,theta2,dtheta},{rr,r1+dr,r2,dr}];
      ListPolarDensityPlot[data,
        PlotRange\[Rule]{{r1,r2},{theta1,theta2},zrange},opts]];

End[]

EndPackage[]