(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)









(* :Title: SplineDrawing *)
(* :Context: DrawGraphics`SplineDrawing` *)
(* :Author: David J. M. Park Jr. djmp@earthlink.net *)
(* :Summary: 
      This package provides routines for using Spline curves in Graphics. *)
(* :Copyright: \[Copyright] 2001 by David J. M. Park Jr. *)
(* :Package Version: 2.0 *)
(* :Mathematica Version: 4.1 *)
(* :Keywords: Graphics, Splines *)
(* :Requirements: NumericalMath`SplineFit`, Graphics`Spline` *)





BeginPackage["DrawGraphics`SplineDrawing`",{"NumericalMath`SplineFit`",
    "Graphics`Spline`"}]

DrawGraphics`SplineDrawing::usage="DrawingSplines is an auxiliary package for \
DrawGraphics that provides several routines for using Spline curves in \
Graphics. It loads Graphics`Spline` and NumericalMath`SplineFit`."



DrawIndexedPoints::usage=
    "DrawIndexedPoints[pointlist, offset:{-1,-1}] will plot a list of points, \
{xi, yi}, and number them with the specified offset. ";



SplineToLine::usage=
    "SplineToLine[points, mode, mumpts] will generate a spline curve using \
mode (Cubic, Bezier, CompositeBezier) and then convert it to a Line with \
numpts evenly spaced points.";



Begin["`Private`"]



DrawIndexedPoints[pts:{{_,_}..},offset_:{-1,-1}]:=
  Table[{Point[pts\[LeftDoubleBracket]i\[RightDoubleBracket]],
      Text[i,pts\[LeftDoubleBracket]i\[RightDoubleBracket],offset]},{i,1,
      Length[pts]}]



SplineToLine[pts:{{_,_},{_,_}..},mode_,numpts_Integer?Positive]:=
  Module[{sfun,n=Length[pts]-1},
    sfun=SplineFit[pts,mode];
    Line[Table[sfun[t],{t,0,n,n/(numpts-1)}]]
    ]



End[]

Protect[Evaluate[$Context<>"*"]]

EndPackage[]