(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     19357,        774]*)
(*NotebookOutlinePosition[     33417,       1203]*)
(*  CellTagsIndexPosition[     29978,       1098]*)
(*WindowFrame->Normal*)



Notebook[{
Cell["Master Index Entries for DrawGraphics", "Chapter"],

Cell["\[Copyright] David Park 2001, 2003, 2004,2005", "Section"],

Cell["DrawGraphics", "IndexSection",
  CellTags->"MasterIndexHeading"],

Cell[CellGroupData[{

Cell["DrawingPaper", "IndexSection"],

Cell[CellGroupData[{

Cell[BoxData[
    ButtonBox["BlankDrawingPaper",
      ButtonData:>{"BlankDrawingPaper"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"BlankDrawingPaper"],

Cell[BoxData[
    ButtonBox["CirclePoint",
      ButtonData:>{"CirclePoint"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"CirclePoint"],

Cell[BoxData[
    ButtonBox["Draw2D",
      ButtonData:>{"Draw2D"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"Draw2D"],

Cell[BoxData[
    ButtonBox["DontShow",
      ButtonData:>{"DontShow"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"DontShow"],

Cell[BoxData[
    ButtonBox["DoShow",
      ButtonData:>{"DoShow"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"DoShow"],

Cell[BoxData[
    ButtonBox["Draw",
      ButtonData:>{"Draw"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"Draw"],

Cell[BoxData[
    ButtonBox["ParametricDraw",
      ButtonData:>{"ParametricDraw"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ParametricDraw"],

Cell[BoxData[
    ButtonBox["DrawPolarR",
      ButtonData:>{"DrawPolarR"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"DrawPolarR"],

Cell[BoxData[
    ButtonBox["DrawPolarA",
      ButtonData:>{"DrawPolarA"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"DrawPolarA"],

Cell[BoxData[
    ButtonBox["ContourDraw",
      ButtonData:>{"ContourDraw"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ContourDraw"],

Cell[BoxData[
    ButtonBox["ContourColors",
      ButtonData:>{"ContourColors"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ContourColors"],

Cell[BoxData[
    ButtonBox["ColorBands",
      ButtonData:>{"ColorBands"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ColorBands"],

Cell[BoxData[
    ButtonBox["TwoColorScale",
      ButtonData:>{"TwoColorScale"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"TwoColorScale"],

Cell[BoxData[
    ButtonBox["ColorMix",
      ButtonData:>{"ColorMix"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ColorMix"],

Cell[BoxData[
    ButtonBox["DrawLineLabels",
      ButtonData:>{"DrawLineLabels"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"DrawLineLabels"],

Cell[BoxData[
    ButtonBox["DensityDraw",
      ButtonData:>{"DensityDraw"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"DensityDraw"],

Cell[BoxData[
    ButtonBox["PolarDensityDraw",
      ButtonData:>{"PolarDensityDraw"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"PolarDensityDraw"],

Cell[BoxData[
    ButtonBox["ListPolarDensityDraw",
      ButtonData:>{"ListPolarDensityDraw"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ListPolarDensityDraw"],

Cell[BoxData[
    ButtonBox["ListDraw",
      ButtonData:>{"ListDraw"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ListDraw"],

Cell[BoxData[
    ButtonBox["ListContourDraw",
      ButtonData:>{"ListContourDraw"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ListContourDraw"],

Cell[BoxData[
    ButtonBox["ListDensityDraw",
      ButtonData:>{"ListDensityDraw"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ListDensityDraw"],

Cell[BoxData[
    ButtonBox["DrawingTransform",
      ButtonData:>{"DrawingTransform"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"DrawingTransform"],

Cell[BoxData[
    ButtonBox["ToPointPrimitives",
      ButtonData:>{"ToPointPrimitives"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ToPointPrimitives"],

Cell[BoxData[
    ButtonBox["FineGrainPoints",
      ButtonData:>{"FineGrainPoints"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"FineGrainPoints"],

Cell[BoxData[
    ButtonBox["FineGrainPolygons",
      ButtonData:>{"FineGrainPolygons"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"FineGrainPolygons"],

Cell[BoxData[
    ButtonBox["MakePolyGrid",
      ButtonData:>{"MakePolyGrid"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"MakePolyGrid"],

Cell[BoxData[
    ButtonBox["TrimPolygons",
      ButtonData:>{"TrimPolygons"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"TrimPolygons"],

Cell[BoxData[
    ButtonBox["HollisGrid",
      ButtonData:>{"HollisGrid"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"HollisGrid"],

Cell[BoxData[
    ButtonBox["RaiseTo3D",
      ButtonData:>{"RaiseTo3D"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"RaiseTo3D"],

Cell[BoxData[
    ButtonBox["StitchLineSegments",
      ButtonData:>{"StitchLineSegments"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"StitchLineSegments"],

Cell[BoxData[
    ButtonBox["PolygonOutline",
      ButtonData:>{"PolygonOutline"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"PolygonOutline"],

Cell[BoxData[
    ButtonBox["SplitLineOnDistance",
      ButtonData:>{"SplitLineOnDistance"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"SplitLineOnDistance"],

Cell[BoxData[
    ButtonBox["SplitLineOnSlope",
      ButtonData:>{"SplitLineOnSlope"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"SplitLineOnSlope"],

Cell[BoxData[
    ButtonBox["SplitLineOnVertical",
      ButtonData:>{"SplitLineOnVertical"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"SplitLineOnVertical"],

Cell[BoxData[
    ButtonBox["DrawUnitStep",
      ButtonData:>{"DrawUnitStep"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"DrawUnitStep"],

Cell[BoxData[
    ButtonBox["DrawGraphics",
      ButtonData:>{"DrawGraphics"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"DrawGraphics"],

Cell[BoxData[
    ButtonBox["DrawWithOptions",
      ButtonData:>{"DrawWithOptions"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"DrawWithOptions"],

Cell[BoxData[
    ButtonBox["FullDraw",
      ButtonData:>{"FullDraw"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"FullDraw"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["ImplicitDrawing", "IndexSection"],

Cell[BoxData[
    ButtonBox["ImplicitDraw",
      ButtonData:>{"ImplicitDraw"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ImplicitDraw"]
}, Closed]],

Cell[CellGroupData[{

Cell["FilledDrawing", "IndexSection"],

Cell[CellGroupData[{

Cell[BoxData[
    ButtonBox["FilledDraw",
      ButtonData:>{"FilledDraw"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"FilledDraw"],

Cell[BoxData[
    ButtonBox["FilledListDraw",
      ButtonData:>{"FilledListDraw"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"FilledListDraw"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["DrawingField", "IndexSection"],

Cell[CellGroupData[{

Cell[BoxData[
    ButtonBox["DrawGradientField",
      ButtonData:>{"DrawGradientField"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"DrawGradientField"],

Cell[BoxData[
    ButtonBox["DrawHamiltonianField",
      ButtonData:>{"DrawHamiltonianField"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"DrawHamiltonianField"],

Cell[BoxData[
    ButtonBox["DrawPolyaField",
      ButtonData:>{"DrawPolyaField"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"DrawPolyaField"],

Cell[BoxData[
    ButtonBox["DrawVectorField",
      ButtonData:>{"DrawVectorField"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"DrawVectorField"],

Cell[BoxData[
    ButtonBox["ListDrawVectorField",
      ButtonData:>{"ListDrawVectorField"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ListDrawVectorField"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["ComplexMapDrawing", "IndexSection"],

Cell[CellGroupData[{

Cell[BoxData[
    ButtonBox["DrawCartesianMap",
      ButtonData:>{"DrawCartesianMap"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"DrawCartesianMap"],

Cell[BoxData[
    ButtonBox["DrawPolarMap",
      ButtonData:>{"DrawPolarMap"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"DrawPolarMap"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["SplineDrawing", "IndexSection"],

Cell[CellGroupData[{

Cell[BoxData[
    ButtonBox["DrawIndexedPoints",
      ButtonData:>{"DrawIndexedPoints"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"DrawIndexedPoints"],

Cell[BoxData[
    ButtonBox["SplineToLine",
      ButtonData:>{"SplineToLine"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"SplineToLine"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["DrawingTicksAndGrids", "IndexSection"],

Cell[CellGroupData[{

Cell[BoxData[
    ButtonBox["XTickLine",
      ButtonData:>{"XTickLine"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"XTickLine"],

Cell[BoxData[
    ButtonBox["YTickLine",
      ButtonData:>{"YTickLine"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"YTickLine"],

Cell[CellGroupData[{

Cell[BoxData[
    ButtonBox["XSymbolicScale",
      ButtonData:>{"XSymbolicScale"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"XSymbolicScale"],

Cell[BoxData[
    ButtonBox["YSymbolicScale",
      ButtonData:>{"YSymbolicScale"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"YSymbolicScale"]
}, Open  ]],

Cell[BoxData[
    ButtonBox["CustomTicks",
      ButtonData:>{"CustomTicks"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"CustomTicks"],

Cell[BoxData[
    ButtonBox["CustomGridLines",
      ButtonData:>{"CustomGridLines"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"CustomGridLines"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["DrawingArrows", "IndexSection"],

Cell[BoxData[
    ButtonBox["AngleArc",
      ButtonData:>{"AngleArc"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"AngleArc"],

Cell[BoxData[
    ButtonBox["AngleSquare",
      ButtonData:>{"AngleSquare"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"AngleSquare"],

Cell[BoxData[
    ButtonBox["Arrow",
      ButtonData:>{"Arrow"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"Arrow"],

Cell[BoxData[
    ButtonBox["ArrowCurve",
      ButtonData:>{"ArrowCurve"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ArrowCurve"],

Cell[BoxData[
    ButtonBox["ArrowLine",
      ButtonData:>{"ArrowLine"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ArrowLine"],

Cell[BoxData[
    ButtonBox["ArrowTangent",
      ButtonData:>{"ArrowTangent"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ArrowTangent"],

Cell[BoxData[
    ButtonBox["ProportionalArrow",
      ButtonData:>{"ProportionalArrow"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ProportionalArrow"],

Cell[BoxData[
    ButtonBox["Arrow2D",
      ButtonData:>{"Arrow2D"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"Arrow2D"],

Cell[BoxData[
    ButtonBox["Arrow3D",
      ButtonData:>{"Arrow3D"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"Arrow3D"],

Cell[BoxData[
    ButtonBox["ArrowCurve3D",
      ButtonData:>{"ArrowCurve3D"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ArrowCurve3D"],

Cell[BoxData[
    ButtonBox["ArrowLine3D",
      ButtonData:>{"ArrowLine3D"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ArrowLine3D"],

Cell[BoxData[
    ButtonBox["ArrowTangent3D",
      ButtonData:>{"ArrowTangent3D"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ArrowTangent3D"],

Cell[BoxData[
    ButtonBox["ProportionalArrow3D",
      ButtonData:>{"ProportionalArrow3D"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ProportionalArrow3D"]
}, Closed]],

Cell[CellGroupData[{

Cell["InequalityDrawing", "IndexSection"],

Cell[CellGroupData[{

Cell[BoxData[
    ButtonBox["ComplexInequalityDraw",
      ButtonData:>{"ComplexInequalityDraw"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ComplexInequalityDraw"],

Cell[BoxData[
    ButtonBox["InequalityDraw",
      ButtonData:>{"InequalityDraw"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"InequalityDraw"],

Cell[BoxData[
    ButtonBox["InequalityDraw3D",
      ButtonData:>{"InequalityDraw3D"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"InequalityDraw3D"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["DrawingCube", "IndexSection"],

Cell[CellGroupData[{

Cell[BoxData[
    ButtonBox["BlankDrawingCube",
      ButtonData:>{"BlankDrawingCube"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"BlankDrawingCube"],

Cell[BoxData[
    ButtonBox["Draw3DItems",
      ButtonData:>{"Draw3DItems"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"Draw3DItems"],

Cell[BoxData[
    ButtonBox["Draw3D",
      ButtonData:>{"Draw3D"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"Draw3D"],

Cell[BoxData[
    ButtonBox["ListDraw3D",
      ButtonData:>{"ListDraw3D"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ListDraw3D"],

Cell[BoxData[
    ButtonBox["DrawAxes",
      ButtonData:>{"DrawAxes"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"DrawAxes"],

Cell[BoxData[
    ButtonBox["DrawContourLines",
      ButtonData:>{"DrawContourLines"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"DrawContourLines"],

Cell[BoxData[
    ButtonBox["DrawingTransform3D",
      ButtonData:>{"DrawingTransform3D"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"DrawingTransform3D"],

Cell[BoxData[
    ButtonBox["IteratorSubstitution",
      ButtonData:>{"IteratorSubstitution"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"IteratorSubstitution"],

Cell[BoxData[
    ButtonBox["NeutralLighting",
      ButtonData:>{"NeutralLighting"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"NeutralLighting"],

Cell[BoxData[
    ButtonBox["DrawGraphics3D",
      ButtonData:>{"DrawGraphics3D"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"DrawGraphics3D"],

Cell[BoxData[
    ButtonBox["DrawWithOptions3D",
      ButtonData:>{"DrawWithOptions3D"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"DrawWithOptions3D"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["ParametricDrawing3D", "IndexSection"],

Cell[CellGroupData[{

Cell[BoxData[
    ButtonBox["CylindricalDraw3D",
      ButtonData:>{"CylindricalDraw3D"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"CylindricalDraw3D"],

Cell[BoxData[
    ButtonBox["ParametricDraw3D",
      ButtonData:>{"ParametricDraw3D"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ParametricDraw3D"],

Cell[BoxData[
    ButtonBox["PointParametricDraw3D",
      ButtonData:>{"PointParametricDraw3D"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"PointParametricDraw3D"],

Cell[BoxData[
    ButtonBox["SphericalDraw3D",
      ButtonData:>{"SphericalDraw3D"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"SphericalDraw3D"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["DrawingField3D", "IndexSection"],

Cell[CellGroupData[{

Cell[BoxData[
    ButtonBox["DrawGradientField3D",
      ButtonData:>{"DrawGradientField3D"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"DrawGradientField3D"],

Cell[BoxData[
    ButtonBox["DrawVectorField3D",
      ButtonData:>{"DrawVectorField3D"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"DrawVectorField3D"],

Cell[BoxData[
    ButtonBox["ListDrawVectorField3D",
      ButtonData:>{"ListDrawVectorField3D"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ListDrawVectorField3D"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["DrawingSurfaceOfRevolution", "IndexSection"],

Cell[CellGroupData[{

Cell[BoxData[
    ButtonBox["DrawListSurfaceOfRevolution",
      ButtonData:>{"DrawListSurfaceOfRevolution"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"DrawListSurfaceOfRevolution"],

Cell[BoxData[
    ButtonBox["DrawSurfaceOfRevolution",
      ButtonData:>{"DrawSurfaceOfRevolution"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"DrawSurfaceOfRevolution"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["ContourDrawing3D", "IndexSection"],

Cell[CellGroupData[{

Cell[BoxData[
    ButtonBox["ContourDraw3D",
      ButtonData:>{"ContourDraw3D"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ContourDraw3D"],

Cell[BoxData[
    ButtonBox["ListContourDraw3D",
      ButtonData:>{"ListContourDraw3D"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"ListContourDraw3D"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["DrawingShapes", "IndexSection"],

Cell[CellGroupData[{

Cell[BoxData[
    ButtonBox["UseAffineShape",
      ButtonData:>{"UseAffineShape"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"UseAffineShape"],

Cell[BoxData[
    ButtonBox["UseRotateShape",
      ButtonData:>{"UseRotateShape"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"UseRotateShape"],

Cell[BoxData[
    ButtonBox["UseTranslateShape",
      ButtonData:>{"UseTranslateShape"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"UseTranslateShape"],

Cell[BoxData[
    ButtonBox["UseWireFrame",
      ButtonData:>{"UseWireFrame"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"UseWireFrame"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Text3D", "IndexSection"],

Cell[BoxData[
    ButtonBox["Text3D",
      ButtonData:>{"Text3D"},
      ButtonStyle->"AddOnsLink"]], "Index",
  CellTags->"Text3D"]
}, Closed]]
},
FrontEndVersion->"5.0 for Microsoft Windows",
ScreenRectangle->{{0, 1280}, {0, 941}},
ScreenStyleEnvironment->"Brackets",
WindowToolbars->"EditBar",
CellGrouping->Manual,
WindowSize->{512, 740},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
ShowCellBracket->True,
StyleDefinitions -> "HelpBrowser.nb"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "MasterIndexHeading"->{
    Cell[1880, 55, 70, 1, 42, "IndexSection",
      CellTags->"MasterIndexHeading"]},
  "BlankDrawingPaper"->{
    Cell[2036, 64, 166, 4, 17, "Index",
      CellTags->"BlankDrawingPaper"]},
  "CirclePoint"->{
    Cell[2205, 70, 148, 4, 17, "Index",
      CellTags->"CirclePoint"]},
  "Draw2D"->{
    Cell[2356, 76, 133, 4, 17, "Index",
      CellTags->"Draw2D"]},
  "DontShow"->{
    Cell[2492, 82, 139, 4, 17, "Index",
      CellTags->"DontShow"]},
  "DoShow"->{
    Cell[2634, 88, 133, 4, 17, "Index",
      CellTags->"DoShow"]},
  "Draw"->{
    Cell[2770, 94, 127, 4, 17, "Index",
      CellTags->"Draw"]},
  "ParametricDraw"->{
    Cell[2900, 100, 157, 4, 17, "Index",
      CellTags->"ParametricDraw"]},
  "DrawPolarR"->{
    Cell[3060, 106, 145, 4, 17, "Index",
      CellTags->"DrawPolarR"]},
  "DrawPolarA"->{
    Cell[3208, 112, 145, 4, 17, "Index",
      CellTags->"DrawPolarA"]},
  "ContourDraw"->{
    Cell[3356, 118, 148, 4, 17, "Index",
      CellTags->"ContourDraw"]},
  "ContourColors"->{
    Cell[3507, 124, 154, 4, 17, "Index",
      CellTags->"ContourColors"]},
  "ColorBands"->{
    Cell[3664, 130, 145, 4, 17, "Index",
      CellTags->"ColorBands"]},
  "TwoColorScale"->{
    Cell[3812, 136, 154, 4, 17, "Index",
      CellTags->"TwoColorScale"]},
  "ColorMix"->{
    Cell[3969, 142, 139, 4, 17, "Index",
      CellTags->"ColorMix"]},
  "DrawLineLabels"->{
    Cell[4111, 148, 157, 4, 17, "Index",
      CellTags->"DrawLineLabels"]},
  "DensityDraw"->{
    Cell[4271, 154, 148, 4, 17, "Index",
      CellTags->"DensityDraw"]},
  "PolarDensityDraw"->{
    Cell[4422, 160, 163, 4, 17, "Index",
      CellTags->"PolarDensityDraw"]},
  "ListPolarDensityDraw"->{
    Cell[4588, 166, 175, 4, 17, "Index",
      CellTags->"ListPolarDensityDraw"]},
  "ListDraw"->{
    Cell[4766, 172, 139, 4, 17, "Index",
      CellTags->"ListDraw"]},
  "ListContourDraw"->{
    Cell[4908, 178, 160, 4, 17, "Index",
      CellTags->"ListContourDraw"]},
  "ListDensityDraw"->{
    Cell[5071, 184, 160, 4, 17, "Index",
      CellTags->"ListDensityDraw"]},
  "DrawingTransform"->{
    Cell[5234, 190, 163, 4, 17, "Index",
      CellTags->"DrawingTransform"]},
  "ToPointPrimitives"->{
    Cell[5400, 196, 166, 4, 17, "Index",
      CellTags->"ToPointPrimitives"]},
  "FineGrainPoints"->{
    Cell[5569, 202, 160, 4, 17, "Index",
      CellTags->"FineGrainPoints"]},
  "FineGrainPolygons"->{
    Cell[5732, 208, 166, 4, 17, "Index",
      CellTags->"FineGrainPolygons"]},
  "MakePolyGrid"->{
    Cell[5901, 214, 151, 4, 17, "Index",
      CellTags->"MakePolyGrid"]},
  "TrimPolygons"->{
    Cell[6055, 220, 151, 4, 17, "Index",
      CellTags->"TrimPolygons"]},
  "HollisGrid"->{
    Cell[6209, 226, 145, 4, 17, "Index",
      CellTags->"HollisGrid"]},
  "RaiseTo3D"->{
    Cell[6357, 232, 142, 4, 17, "Index",
      CellTags->"RaiseTo3D"]},
  "StitchLineSegments"->{
    Cell[6502, 238, 169, 4, 17, "Index",
      CellTags->"StitchLineSegments"]},
  "PolygonOutline"->{
    Cell[6674, 244, 157, 4, 17, "Index",
      CellTags->"PolygonOutline"]},
  "SplitLineOnDistance"->{
    Cell[6834, 250, 172, 4, 17, "Index",
      CellTags->"SplitLineOnDistance"]},
  "SplitLineOnSlope"->{
    Cell[7009, 256, 163, 4, 17, "Index",
      CellTags->"SplitLineOnSlope"]},
  "SplitLineOnVertical"->{
    Cell[7175, 262, 172, 4, 17, "Index",
      CellTags->"SplitLineOnVertical"]},
  "DrawUnitStep"->{
    Cell[7350, 268, 151, 4, 17, "Index",
      CellTags->"DrawUnitStep"]},
  "DrawGraphics"->{
    Cell[7504, 274, 151, 4, 17, "Index",
      CellTags->"DrawGraphics"]},
  "DrawWithOptions"->{
    Cell[7658, 280, 160, 4, 17, "Index",
      CellTags->"DrawWithOptions"]},
  "FullDraw"->{
    Cell[7821, 286, 139, 4, 17, "Index",
      CellTags->"FullDraw"]},
  "ImplicitDraw"->{
    Cell[8051, 298, 151, 4, 17, "Index",
      CellTags->"ImplicitDraw"]},
  "FilledDraw"->{
    Cell[8301, 311, 145, 4, 17, "Index",
      CellTags->"FilledDraw"]},
  "FilledListDraw"->{
    Cell[8449, 317, 157, 4, 17, "Index",
      CellTags->"FilledListDraw"]},
  "DrawGradientField"->{
    Cell[8716, 331, 166, 4, 17, "Index",
      CellTags->"DrawGradientField"]},
  "DrawHamiltonianField"->{
    Cell[8885, 337, 175, 4, 17, "Index",
      CellTags->"DrawHamiltonianField"]},
  "DrawPolyaField"->{
    Cell[9063, 343, 157, 4, 17, "Index",
      CellTags->"DrawPolyaField"]},
  "DrawVectorField"->{
    Cell[9223, 349, 160, 4, 17, "Index",
      CellTags->"DrawVectorField"]},
  "ListDrawVectorField"->{
    Cell[9386, 355, 172, 4, 17, "Index",
      CellTags->"ListDrawVectorField"]},
  "DrawCartesianMap"->{
    Cell[9673, 369, 163, 4, 17, "Index",
      CellTags->"DrawCartesianMap"]},
  "DrawPolarMap"->{
    Cell[9839, 375, 151, 4, 17, "Index",
      CellTags->"DrawPolarMap"]},
  "DrawIndexedPoints"->{
    Cell[10101, 389, 166, 4, 17, "Index",
      CellTags->"DrawIndexedPoints"]},
  "SplineToLine"->{
    Cell[10270, 395, 151, 4, 17, "Index",
      CellTags->"SplineToLine"]},
  "XTickLine"->{
    Cell[10539, 409, 142, 4, 17, "Index",
      CellTags->"XTickLine"]},
  "YTickLine"->{
    Cell[10684, 415, 142, 4, 17, "Index",
      CellTags->"YTickLine"]},
  "XSymbolicScale"->{
    Cell[10851, 423, 157, 4, 17, "Index",
      CellTags->"XSymbolicScale"]},
  "YSymbolicScale"->{
    Cell[11011, 429, 157, 4, 17, "Index",
      CellTags->"YSymbolicScale"]},
  "CustomTicks"->{
    Cell[11183, 436, 148, 4, 17, "Index",
      CellTags->"CustomTicks"]},
  "CustomGridLines"->{
    Cell[11334, 442, 160, 4, 17, "Index",
      CellTags->"CustomGridLines"]},
  "AngleArc"->{
    Cell[11583, 454, 139, 4, 17, "Index",
      CellTags->"AngleArc"]},
  "AngleSquare"->{
    Cell[11725, 460, 148, 4, 17, "Index",
      CellTags->"AngleSquare"]},
  "Arrow"->{
    Cell[11876, 466, 130, 4, 17, "Index",
      CellTags->"Arrow"]},
  "ArrowCurve"->{
    Cell[12009, 472, 145, 4, 17, "Index",
      CellTags->"ArrowCurve"]},
  "ArrowLine"->{
    Cell[12157, 478, 142, 4, 17, "Index",
      CellTags->"ArrowLine"]},
  "ArrowTangent"->{
    Cell[12302, 484, 151, 4, 17, "Index",
      CellTags->"ArrowTangent"]},
  "ProportionalArrow"->{
    Cell[12456, 490, 166, 4, 17, "Index",
      CellTags->"ProportionalArrow"]},
  "Arrow2D"->{
    Cell[12625, 496, 136, 4, 17, "Index",
      CellTags->"Arrow2D"]},
  "Arrow3D"->{
    Cell[12764, 502, 136, 4, 17, "Index",
      CellTags->"Arrow3D"]},
  "ArrowCurve3D"->{
    Cell[12903, 508, 151, 4, 17, "Index",
      CellTags->"ArrowCurve3D"]},
  "ArrowLine3D"->{
    Cell[13057, 514, 148, 4, 17, "Index",
      CellTags->"ArrowLine3D"]},
  "ArrowTangent3D"->{
    Cell[13208, 520, 157, 4, 17, "Index",
      CellTags->"ArrowTangent3D"]},
  "ProportionalArrow3D"->{
    Cell[13368, 526, 172, 4, 17, "Index",
      CellTags->"ProportionalArrow3D"]},
  "ComplexInequalityDraw"->{
    Cell[13643, 539, 178, 4, 17, "Index",
      CellTags->"ComplexInequalityDraw"]},
  "InequalityDraw"->{
    Cell[13824, 545, 157, 4, 17, "Index",
      CellTags->"InequalityDraw"]},
  "InequalityDraw3D"->{
    Cell[13984, 551, 163, 4, 17, "Index",
      CellTags->"InequalityDraw3D"]},
  "BlankDrawingCube"->{
    Cell[14256, 565, 163, 4, 17, "Index",
      CellTags->"BlankDrawingCube"]},
  "Draw3DItems"->{
    Cell[14422, 571, 148, 4, 17, "Index",
      CellTags->"Draw3DItems"]},
  "Draw3D"->{
    Cell[14573, 577, 133, 4, 17, "Index",
      CellTags->"Draw3D"]},
  "ListDraw3D"->{
    Cell[14709, 583, 145, 4, 17, "Index",
      CellTags->"ListDraw3D"]},
  "DrawAxes"->{
    Cell[14857, 589, 139, 4, 17, "Index",
      CellTags->"DrawAxes"]},
  "DrawContourLines"->{
    Cell[14999, 595, 163, 4, 17, "Index",
      CellTags->"DrawContourLines"]},
  "DrawingTransform3D"->{
    Cell[15165, 601, 169, 4, 17, "Index",
      CellTags->"DrawingTransform3D"]},
  "IteratorSubstitution"->{
    Cell[15337, 607, 175, 4, 17, "Index",
      CellTags->"IteratorSubstitution"]},
  "NeutralLighting"->{
    Cell[15515, 613, 160, 4, 17, "Index",
      CellTags->"NeutralLighting"]},
  "DrawGraphics3D"->{
    Cell[15678, 619, 157, 4, 17, "Index",
      CellTags->"DrawGraphics3D"]},
  "DrawWithOptions3D"->{
    Cell[15838, 625, 166, 4, 17, "Index",
      CellTags->"DrawWithOptions3D"]},
  "CylindricalDraw3D"->{
    Cell[16121, 639, 166, 4, 17, "Index",
      CellTags->"CylindricalDraw3D"]},
  "ParametricDraw3D"->{
    Cell[16290, 645, 163, 4, 17, "Index",
      CellTags->"ParametricDraw3D"]},
  "PointParametricDraw3D"->{
    Cell[16456, 651, 178, 4, 17, "Index",
      CellTags->"PointParametricDraw3D"]},
  "SphericalDraw3D"->{
    Cell[16637, 657, 160, 4, 17, "Index",
      CellTags->"SphericalDraw3D"]},
  "DrawGradientField3D"->{
    Cell[16909, 671, 172, 4, 17, "Index",
      CellTags->"DrawGradientField3D"]},
  "DrawVectorField3D"->{
    Cell[17084, 677, 166, 4, 17, "Index",
      CellTags->"DrawVectorField3D"]},
  "ListDrawVectorField3D"->{
    Cell[17253, 683, 178, 4, 17, "Index",
      CellTags->"ListDrawVectorField3D"]},
  "DrawListSurfaceOfRevolution"->{
    Cell[17555, 697, 196, 4, 17, "Index",
      CellTags->"DrawListSurfaceOfRevolution"]},
  "DrawSurfaceOfRevolution"->{
    Cell[17754, 703, 184, 4, 17, "Index",
      CellTags->"DrawSurfaceOfRevolution"]},
  "ContourDraw3D"->{
    Cell[18052, 717, 154, 4, 17, "Index",
      CellTags->"ContourDraw3D"]},
  "ListContourDraw3D"->{
    Cell[18209, 723, 166, 4, 17, "Index",
      CellTags->"ListContourDraw3D"]},
  "UseAffineShape"->{
    Cell[18486, 737, 157, 4, 17, "Index",
      CellTags->"UseAffineShape"]},
  "UseRotateShape"->{
    Cell[18646, 743, 157, 4, 17, "Index",
      CellTags->"UseRotateShape"]},
  "UseTranslateShape"->{
    Cell[18806, 749, 166, 4, 17, "Index",
      CellTags->"UseTranslateShape"]},
  "UseWireFrame"->{
    Cell[18975, 755, 151, 4, 17, "Index",
      CellTags->"UseWireFrame"]},
  "Text3D"->{
    Cell[19208, 767, 133, 4, 17, "Index",
      CellTags->"Text3D"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"MasterIndexHeading", 20105, 794},
  {"BlankDrawingPaper", 20216, 797},
  {"CirclePoint", 20314, 800},
  {"Draw2D", 20401, 803},
  {"DontShow", 20485, 806},
  {"DoShow", 20569, 809},
  {"Draw", 20649, 812},
  {"ParametricDraw", 20737, 815},
  {"DrawPolarR", 20832, 818},
  {"DrawPolarA", 20923, 821},
  {"ContourDraw", 21015, 824},
  {"ContourColors", 21110, 827},
  {"ColorBands", 21204, 830},
  {"TwoColorScale", 21298, 833},
  {"ColorMix", 21390, 836},
  {"DrawLineLabels", 21483, 839},
  {"DensityDraw", 21579, 842},
  {"PolarDensityDraw", 21677, 845},
  {"ListPolarDensityDraw", 21784, 848},
  {"ListDraw", 21883, 851},
  {"ListContourDraw", 21977, 854},
  {"ListDensityDraw", 22078, 857},
  {"DrawingTransform", 22180, 860},
  {"ToPointPrimitives", 22284, 863},
  {"FineGrainPoints", 22387, 866},
  {"FineGrainPolygons", 22490, 869},
  {"MakePolyGrid", 22590, 872},
  {"TrimPolygons", 22685, 875},
  {"HollisGrid", 22778, 878},
  {"RaiseTo3D", 22868, 881},
  {"StitchLineSegments", 22966, 884},
  {"PolygonOutline", 23069, 887},
  {"SplitLineOnDistance", 23173, 890},
  {"SplitLineOnSlope", 23279, 893},
  {"SplitLineOnVertical", 23385, 896},
  {"DrawUnitStep", 23487, 899},
  {"DrawGraphics", 23582, 902},
  {"DrawWithOptions", 23680, 905},
  {"FullDraw", 23774, 908},
  {"ImplicitDraw", 23865, 911},
  {"FilledDraw", 23958, 914},
  {"FilledListDraw", 24053, 917},
  {"DrawGradientField", 24155, 920},
  {"DrawHamiltonianField", 24263, 923},
  {"DrawPolyaField", 24368, 926},
  {"DrawVectorField", 24468, 929},
  {"ListDrawVectorField", 24573, 932},
  {"DrawCartesianMap", 24679, 935},
  {"DrawPolarMap", 24778, 938},
  {"DrawIndexedPoints", 24878, 941},
  {"SplineToLine", 24979, 944},
  {"XTickLine", 25072, 947},
  {"YTickLine", 25162, 950},
  {"XSymbolicScale", 25257, 953},
  {"YSymbolicScale", 25357, 956},
  {"CustomTicks", 25454, 959},
  {"CustomGridLines", 25552, 962},
  {"AngleArc", 25647, 965},
  {"AngleSquare", 25738, 968},
  {"Arrow", 25826, 971},
  {"ArrowCurve", 25913, 974},
  {"ArrowLine", 26004, 977},
  {"ArrowTangent", 26097, 980},
  {"ProportionalArrow", 26198, 983},
  {"Arrow2D", 26294, 986},
  {"Arrow3D", 26380, 989},
  {"ArrowCurve3D", 26471, 992},
  {"ArrowLine3D", 26566, 995},
  {"ArrowTangent3D", 26663, 998},
  {"ProportionalArrow3D", 26768, 1001},
  {"ComplexInequalityDraw", 26880, 1004},
  {"InequalityDraw", 26987, 1007},
  {"InequalityDraw3D", 27089, 1010},
  {"BlankDrawingCube", 27193, 1013},
  {"Draw3DItems", 27292, 1016},
  {"Draw3D", 27381, 1019},
  {"ListDraw3D", 27469, 1022},
  {"DrawAxes", 27559, 1025},
  {"DrawContourLines", 27655, 1028},
  {"DrawingTransform3D", 27761, 1031},
  {"IteratorSubstitution", 27871, 1034},
  {"NeutralLighting", 27978, 1037},
  {"DrawGraphics3D", 28079, 1040},
  {"DrawWithOptions3D", 28182, 1043},
  {"CylindricalDraw3D", 28288, 1046},
  {"ParametricDraw3D", 28393, 1049},
  {"PointParametricDraw3D", 28502, 1052},
  {"SphericalDraw3D", 28610, 1055},
  {"DrawGradientField3D", 28716, 1058},
  {"DrawVectorField3D", 28824, 1061},
  {"ListDrawVectorField3D", 28934, 1064},
  {"DrawListSurfaceOfRevolution", 29054, 1067},
  {"DrawSurfaceOfRevolution", 29176, 1070},
  {"ContourDraw3D", 29284, 1073},
  {"ListContourDraw3D", 29386, 1076},
  {"UseAffineShape", 29489, 1079},
  {"UseRotateShape", 29589, 1082},
  {"UseTranslateShape", 29692, 1085},
  {"UseWireFrame", 29793, 1088},
  {"Text3D", 29883, 1091}
  }
*)

(*NotebookFileOutline
Notebook[{
Cell[1754, 51, 56, 0, 87, "Chapter"],
Cell[1813, 53, 64, 0, 65, "Section"],
Cell[1880, 55, 70, 1, 42, "IndexSection",
  CellTags->"MasterIndexHeading"],

Cell[CellGroupData[{
Cell[1975, 60, 36, 0, 42, "IndexSection"],

Cell[CellGroupData[{
Cell[2036, 64, 166, 4, 17, "Index",
  CellTags->"BlankDrawingPaper"],
Cell[2205, 70, 148, 4, 17, "Index",
  CellTags->"CirclePoint"],
Cell[2356, 76, 133, 4, 17, "Index",
  CellTags->"Draw2D"],
Cell[2492, 82, 139, 4, 17, "Index",
  CellTags->"DontShow"],
Cell[2634, 88, 133, 4, 17, "Index",
  CellTags->"DoShow"],
Cell[2770, 94, 127, 4, 17, "Index",
  CellTags->"Draw"],
Cell[2900, 100, 157, 4, 17, "Index",
  CellTags->"ParametricDraw"],
Cell[3060, 106, 145, 4, 17, "Index",
  CellTags->"DrawPolarR"],
Cell[3208, 112, 145, 4, 17, "Index",
  CellTags->"DrawPolarA"],
Cell[3356, 118, 148, 4, 17, "Index",
  CellTags->"ContourDraw"],
Cell[3507, 124, 154, 4, 17, "Index",
  CellTags->"ContourColors"],
Cell[3664, 130, 145, 4, 17, "Index",
  CellTags->"ColorBands"],
Cell[3812, 136, 154, 4, 17, "Index",
  CellTags->"TwoColorScale"],
Cell[3969, 142, 139, 4, 17, "Index",
  CellTags->"ColorMix"],
Cell[4111, 148, 157, 4, 17, "Index",
  CellTags->"DrawLineLabels"],
Cell[4271, 154, 148, 4, 17, "Index",
  CellTags->"DensityDraw"],
Cell[4422, 160, 163, 4, 17, "Index",
  CellTags->"PolarDensityDraw"],
Cell[4588, 166, 175, 4, 17, "Index",
  CellTags->"ListPolarDensityDraw"],
Cell[4766, 172, 139, 4, 17, "Index",
  CellTags->"ListDraw"],
Cell[4908, 178, 160, 4, 17, "Index",
  CellTags->"ListContourDraw"],
Cell[5071, 184, 160, 4, 17, "Index",
  CellTags->"ListDensityDraw"],
Cell[5234, 190, 163, 4, 17, "Index",
  CellTags->"DrawingTransform"],
Cell[5400, 196, 166, 4, 17, "Index",
  CellTags->"ToPointPrimitives"],
Cell[5569, 202, 160, 4, 17, "Index",
  CellTags->"FineGrainPoints"],
Cell[5732, 208, 166, 4, 17, "Index",
  CellTags->"FineGrainPolygons"],
Cell[5901, 214, 151, 4, 17, "Index",
  CellTags->"MakePolyGrid"],
Cell[6055, 220, 151, 4, 17, "Index",
  CellTags->"TrimPolygons"],
Cell[6209, 226, 145, 4, 17, "Index",
  CellTags->"HollisGrid"],
Cell[6357, 232, 142, 4, 17, "Index",
  CellTags->"RaiseTo3D"],
Cell[6502, 238, 169, 4, 17, "Index",
  CellTags->"StitchLineSegments"],
Cell[6674, 244, 157, 4, 17, "Index",
  CellTags->"PolygonOutline"],
Cell[6834, 250, 172, 4, 17, "Index",
  CellTags->"SplitLineOnDistance"],
Cell[7009, 256, 163, 4, 17, "Index",
  CellTags->"SplitLineOnSlope"],
Cell[7175, 262, 172, 4, 17, "Index",
  CellTags->"SplitLineOnVertical"],
Cell[7350, 268, 151, 4, 17, "Index",
  CellTags->"DrawUnitStep"],
Cell[7504, 274, 151, 4, 17, "Index",
  CellTags->"DrawGraphics"],
Cell[7658, 280, 160, 4, 17, "Index",
  CellTags->"DrawWithOptions"],
Cell[7821, 286, 139, 4, 17, "Index",
  CellTags->"FullDraw"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[8009, 296, 39, 0, 42, "IndexSection"],
Cell[8051, 298, 151, 4, 17, "Index",
  CellTags->"ImplicitDraw"]
}, Closed]],

Cell[CellGroupData[{
Cell[8239, 307, 37, 0, 26, "IndexSection"],

Cell[CellGroupData[{
Cell[8301, 311, 145, 4, 17, "Index",
  CellTags->"FilledDraw"],
Cell[8449, 317, 157, 4, 17, "Index",
  CellTags->"FilledListDraw"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[8655, 327, 36, 0, 26, "IndexSection"],

Cell[CellGroupData[{
Cell[8716, 331, 166, 4, 17, "Index",
  CellTags->"DrawGradientField"],
Cell[8885, 337, 175, 4, 17, "Index",
  CellTags->"DrawHamiltonianField"],
Cell[9063, 343, 157, 4, 17, "Index",
  CellTags->"DrawPolyaField"],
Cell[9223, 349, 160, 4, 17, "Index",
  CellTags->"DrawVectorField"],
Cell[9386, 355, 172, 4, 17, "Index",
  CellTags->"ListDrawVectorField"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[9607, 365, 41, 0, 26, "IndexSection"],

Cell[CellGroupData[{
Cell[9673, 369, 163, 4, 17, "Index",
  CellTags->"DrawCartesianMap"],
Cell[9839, 375, 151, 4, 17, "Index",
  CellTags->"DrawPolarMap"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[10039, 385, 37, 0, 26, "IndexSection"],

Cell[CellGroupData[{
Cell[10101, 389, 166, 4, 17, "Index",
  CellTags->"DrawIndexedPoints"],
Cell[10270, 395, 151, 4, 17, "Index",
  CellTags->"SplineToLine"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[10470, 405, 44, 0, 26, "IndexSection"],

Cell[CellGroupData[{
Cell[10539, 409, 142, 4, 17, "Index",
  CellTags->"XTickLine"],
Cell[10684, 415, 142, 4, 17, "Index",
  CellTags->"YTickLine"],

Cell[CellGroupData[{
Cell[10851, 423, 157, 4, 17, "Index",
  CellTags->"XSymbolicScale"],
Cell[11011, 429, 157, 4, 17, "Index",
  CellTags->"YSymbolicScale"]
}, Open  ]],
Cell[11183, 436, 148, 4, 17, "Index",
  CellTags->"CustomTicks"],
Cell[11334, 442, 160, 4, 17, "Index",
  CellTags->"CustomGridLines"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[11543, 452, 37, 0, 26, "IndexSection"],
Cell[11583, 454, 139, 4, 17, "Index",
  CellTags->"AngleArc"],
Cell[11725, 460, 148, 4, 17, "Index",
  CellTags->"AngleSquare"],
Cell[11876, 466, 130, 4, 17, "Index",
  CellTags->"Arrow"],
Cell[12009, 472, 145, 4, 17, "Index",
  CellTags->"ArrowCurve"],
Cell[12157, 478, 142, 4, 17, "Index",
  CellTags->"ArrowLine"],
Cell[12302, 484, 151, 4, 17, "Index",
  CellTags->"ArrowTangent"],
Cell[12456, 490, 166, 4, 17, "Index",
  CellTags->"ProportionalArrow"],
Cell[12625, 496, 136, 4, 17, "Index",
  CellTags->"Arrow2D"],
Cell[12764, 502, 136, 4, 17, "Index",
  CellTags->"Arrow3D"],
Cell[12903, 508, 151, 4, 17, "Index",
  CellTags->"ArrowCurve3D"],
Cell[13057, 514, 148, 4, 17, "Index",
  CellTags->"ArrowLine3D"],
Cell[13208, 520, 157, 4, 17, "Index",
  CellTags->"ArrowTangent3D"],
Cell[13368, 526, 172, 4, 17, "Index",
  CellTags->"ProportionalArrow3D"]
}, Closed]],

Cell[CellGroupData[{
Cell[13577, 535, 41, 0, 26, "IndexSection"],

Cell[CellGroupData[{
Cell[13643, 539, 178, 4, 17, "Index",
  CellTags->"ComplexInequalityDraw"],
Cell[13824, 545, 157, 4, 17, "Index",
  CellTags->"InequalityDraw"],
Cell[13984, 551, 163, 4, 17, "Index",
  CellTags->"InequalityDraw3D"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[14196, 561, 35, 0, 26, "IndexSection"],

Cell[CellGroupData[{
Cell[14256, 565, 163, 4, 17, "Index",
  CellTags->"BlankDrawingCube"],
Cell[14422, 571, 148, 4, 17, "Index",
  CellTags->"Draw3DItems"],
Cell[14573, 577, 133, 4, 17, "Index",
  CellTags->"Draw3D"],
Cell[14709, 583, 145, 4, 17, "Index",
  CellTags->"ListDraw3D"],
Cell[14857, 589, 139, 4, 17, "Index",
  CellTags->"DrawAxes"],
Cell[14999, 595, 163, 4, 17, "Index",
  CellTags->"DrawContourLines"],
Cell[15165, 601, 169, 4, 17, "Index",
  CellTags->"DrawingTransform3D"],
Cell[15337, 607, 175, 4, 17, "Index",
  CellTags->"IteratorSubstitution"],
Cell[15515, 613, 160, 4, 17, "Index",
  CellTags->"NeutralLighting"],
Cell[15678, 619, 157, 4, 17, "Index",
  CellTags->"DrawGraphics3D"],
Cell[15838, 625, 166, 4, 17, "Index",
  CellTags->"DrawWithOptions3D"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[16053, 635, 43, 0, 26, "IndexSection"],

Cell[CellGroupData[{
Cell[16121, 639, 166, 4, 17, "Index",
  CellTags->"CylindricalDraw3D"],
Cell[16290, 645, 163, 4, 17, "Index",
  CellTags->"ParametricDraw3D"],
Cell[16456, 651, 178, 4, 17, "Index",
  CellTags->"PointParametricDraw3D"],
Cell[16637, 657, 160, 4, 17, "Index",
  CellTags->"SphericalDraw3D"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[16846, 667, 38, 0, 26, "IndexSection"],

Cell[CellGroupData[{
Cell[16909, 671, 172, 4, 17, "Index",
  CellTags->"DrawGradientField3D"],
Cell[17084, 677, 166, 4, 17, "Index",
  CellTags->"DrawVectorField3D"],
Cell[17253, 683, 178, 4, 17, "Index",
  CellTags->"ListDrawVectorField3D"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[17480, 693, 50, 0, 26, "IndexSection"],

Cell[CellGroupData[{
Cell[17555, 697, 196, 4, 17, "Index",
  CellTags->"DrawListSurfaceOfRevolution"],
Cell[17754, 703, 184, 4, 17, "Index",
  CellTags->"DrawSurfaceOfRevolution"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[17987, 713, 40, 0, 26, "IndexSection"],

Cell[CellGroupData[{
Cell[18052, 717, 154, 4, 17, "Index",
  CellTags->"ContourDraw3D"],
Cell[18209, 723, 166, 4, 17, "Index",
  CellTags->"ListContourDraw3D"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[18424, 733, 37, 0, 26, "IndexSection"],

Cell[CellGroupData[{
Cell[18486, 737, 157, 4, 17, "Index",
  CellTags->"UseAffineShape"],
Cell[18646, 743, 157, 4, 17, "Index",
  CellTags->"UseRotateShape"],
Cell[18806, 749, 166, 4, 17, "Index",
  CellTags->"UseTranslateShape"],
Cell[18975, 755, 151, 4, 17, "Index",
  CellTags->"UseWireFrame"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{
Cell[19175, 765, 30, 0, 26, "IndexSection"],
Cell[19208, 767, 133, 4, 17, "Index",
  CellTags->"Text3D"]
}, Closed]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

