(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     28465,        645]*)
(*NotebookOutlinePosition[     29472,        680]*)
(*  CellTagsIndexPosition[     29397,        674]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["ArrowTangent3D", "ObjectName",
  CellTags->"Function?"],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  Cell[BoxData[
      RowBox[{
        StyleBox["ArrowTangent3D",
          "MR"], 
        StyleBox["[",
          "MR"], 
        StyleBox[\(point . \ vector, opts ... \),
          "TI"], 
        StyleBox["]",
          "MR"]}]]],
  " is an alternative form of Arrow3D in which the point of application and \
the vector are specified."
}], "Usage",
  CellTags->"Function?"],

Cell["\<\
Display of the Graphics is suppressed.\
\>", "MathCaption",
  CellTags->"Function?"],

Cell[TextData[{
  "The regular ",
  ButtonBox["Arrow3D",
    ButtonData:>{"Arrow3D"},
    ButtonStyle->"AddOnsLink"],
  " options can be passed to the Arrow3D routine."
}], "MathCaption"],

Cell[TextData[{
  "See also: ",
  ButtonBox["Arrow3D",
    ButtonData:>{"Arrow3D"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["ArrowCurve3D",
    ButtonData:>{"ArrowCurve3D"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["ArrowLine3D",
    ButtonData:>{"ArrowLine3D"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["ProportionalArrow3D",
    ButtonData:>{"ProportionalArrow3D"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["Arrow",
    ButtonData:>{"Graphics`Arrow`", "1.2"},
    ButtonStyle->"AddOnsLink"],
  " ."
}], "MathCaption"],

Cell[CellGroupData[{

Cell["Example", "ExampleSection"],

Cell[BoxData[
    \(Needs["\<DrawGraphics`DrawingMaster`\>"]\)], "Input",
  CellLabel->"In[1]:="],

Cell["\<\
Vectors are plotted by giving their point of application and their value.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(SetOptions[Arrow3D, 
        HeadScaling3D \[Rule] 5];\)\), "\[IndentingNewLine]", 
    \(\(Show[
        Graphics3D[\n\t{ArrowTangent3D[{0, 0, 0}, {1, 0, 
                0}], \[IndentingNewLine]Red, 
            ArrowTangent3D[{2, 2, 2}, {2, 0, 0}], \[IndentingNewLine]Blue, 
            ArrowTangent3D[{0, 0, 0}, {\(-2\), \(-2\), 2}]}], \n\n
        AspectRatio \[Rule] Automatic, PlotRange \[Rule] All, 
        ViewPoint -> {2.358, \ 1.991, \ 
            1.387}, \n{}];\)\), "\[IndentingNewLine]", 
    \(\(SetOptions[Arrow3D, HeadScaling3D \[Rule] Relative];\)\)}], "Input",
  CellLabel->"In[107]:=",
  GeneratedCell->False],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .71175 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-4.71628e-018 1.0443 -0.116465 1.0443 [
[ 0 0 0 0 ]
[ 1 .71175 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.56458 .4594 m
.56627 .71175 L
s
.56627 .71175 m
1 .59921 L
s
1 .59921 m
.97963 .3234 L
s
.97963 .3234 m
.56458 .4594 L
s
.02422 .20403 m
.46367 0 L
s
.46367 0 m
.46041 .32752 L
s
.46041 .32752 m
0 .4996 L
s
0 .4996 m
.02422 .20403 L
s
.56458 .4594 m
.56627 .71175 L
s
.56627 .71175 m
0 .4996 L
s
0 .4996 m
.02422 .20403 L
s
.02422 .20403 m
.56458 .4594 L
s
.97963 .3234 m
.46367 0 L
s
.46367 0 m
.46041 .32752 L
s
.46041 .32752 m
1 .59921 L
s
1 .59921 m
.97963 .3234 L
s
0 0 m
1 0 L
1 .71175 L
0 .71175 L
closepath
clip
newpath
.5 Mabswid
.633 .557 .751 r
.56433 .68498 m .5779 .63123 L .56942 .62887 L closepath p F P
0 g
s
.441 .364 .675 r
.56433 .68498 m .58293 .63591 L .5779 .63123 L closepath p F P
0 g
s
.742 .767 .873 r
.56433 .68498 m .5682 .64575 L .57697 .6449 L closepath p F P
0 g
s
.894 .767 .715 r
.56433 .68498 m .56072 .62971 L .55507 .63343 L closepath p F P
0 g
s
.757 .667 .763 r
.56433 .68498 m .56942 .62887 L .56072 .62971 L closepath p F P
0 g
s
.571 .614 .857 r
.56433 .68498 m .55966 .64336 L .5682 .64575 L closepath p F P
0 g
s
.942 .71 .239 r
.56433 .68498 m .55507 .63343 L .55466 .63864 L closepath p F P
0 g
s
.205 .319 .759 r
.56433 .68498 m .55466 .63864 L .55966 .64336 L closepath p F P
0 g
s
0 0 .172 r
.56433 .68498 m .5826 .64113 L .58293 .63591 L closepath p F P
0 g
s
.904 .946 .821 r
.56433 .68498 m .57697 .6449 L .5826 .64113 L closepath p F P
0 g
s
0 0 1 r
.56802 .6457 m
.5975 .33242 L
s
.901 .842 .777 r
.51626 .28946 m .54583 .31116 L .55025 .30238 L closepath p F P
0 g
s
.97 .728 .514 r
.51626 .28946 m .54587 .31999 L .54583 .31116 L closepath p F P
0 g
s
.755 .893 .94 r
.51626 .28946 m .55025 .30238 L .55744 .29698 L closepath p F P
0 g
s
.628 .137 0 r
.51626 .28946 m .55035 .32553 L .54587 .31999 L closepath p F P
0 g
s
.138 .666 .871 r
.51626 .28946 m .55744 .29698 L .56469 .29702 L closepath p F P
0 g
s
.424 .642 .948 r
.51626 .28946 m .5576 .32564 L .55035 .32553 L closepath p F P
0 g
s
.774 .332 .199 r
.51626 .28946 m .56469 .29702 L .56922 .30252 L closepath p F P
0 g
s
.704 .724 .866 r
.51626 .28946 m .56485 .32024 L .5576 .32564 L closepath p F P
0 g
s
.845 .616 .592 r
.51626 .28946 m .56922 .30252 L .56929 .31139 L closepath p F P
0 g
s
.802 .7 .753 r
.51626 .28946 m .56929 .31139 L .56485 .32024 L closepath p F P
0 g
s
.56687 .31622 m
.5975 .33242 L
s
.919 .874 .776 r
.44987 .31936 m .48772 .34524 L .49312 .33448 L closepath p F P
0 g
s
.982 .731 .477 r
.44987 .31936 m .48766 .35613 L .48772 .34524 L closepath p F P
0 g
s
.739 .922 .953 r
.44987 .31936 m .49312 .33448 L .50183 .32792 L closepath p F P
0 g
s
.653 .159 0 r
.44987 .31936 m .49299 .36303 L .48766 .35613 L closepath p F P
0 g
s
.08 .63 .827 r
.44987 .31936 m .50183 .32792 L .51056 .32806 L closepath p F P
0 g
s
.343 .627 .958 r
.44987 .31936 m .50172 .36328 L .49299 .36303 L closepath p F P
0 g
s
.761 .291 .129 r
.44987 .31936 m .51056 .32806 L .51598 .3349 L closepath p F P
0 g
s
.696 .751 .894 r
.44987 .31936 m .51051 .35672 L .50172 .36328 L closepath p F P
0 g
s
.865 .619 .565 r
.44987 .31936 m .51598 .3349 L .51596 .34586 L closepath p F P
0 g
s
.819 .724 .76 r
.44987 .31936 m .51596 .34586 L .51051 .35672 L closepath p F P
0 g
s
1 0 0 r
.51322 .35132 m
.64609 .41836 L
s
0 g
.25 Mabswid
.02422 .20403 m
.46367 0 L
s
.46367 0 m
.46041 .32752 L
s
.46041 .32752 m
0 .4996 L
s
0 .4996 m
.02422 .20403 L
s
.97963 .3234 m
.46367 0 L
s
.46367 0 m
.46041 .32752 L
s
.46041 .32752 m
1 .59921 L
s
1 .59921 m
.97963 .3234 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[107]:=",
  ImageSize->{288, 204.938},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000c2000`400?l00000o`00003oQ03oool2
000009X0oooo00220?ooo`80000000@0oooo0000000000000000V03oool00800oooo0P0000030?oo
o`040000003oool0oooo000009L0oooo001n0?ooo`8000001@3oool010000000oooo0?ooo`3oool2
000009D0oooo001l0?ooo`8000001`3oool00`000000oooo0?ooo`030?ooo`800000T`3oool007X0
oooo0P0000090?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0T03oool007L0oooo
0`00000;0?ooo`030000003oool0oooo00H0oooo0P00002@0?ooo`00M@3oool2000000h0oooo00<0
00000?ooo`3oool0203oool00`000000oooo0?ooo`2=0?ooo`00L`3oool200000100oooo00<00000
0?ooo`3oool02@3oool2000008d0oooo001a0?ooo`8000004P3oool00`000000oooo0?ooo`0;0?oo
o`800000R`3oool006l0oooo0P00000D0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3o
ool0R03oool006d0oooo0P00000F0?ooo`030000003oool0oooo00h0oooo0P0000280?ooo`00JP3o
ool3000001P0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`250?ooo`00J03oool2
000001/0oooo00<000000?ooo`3oool04@3oool2000008D0oooo001V0?ooo`8000007@3oool00`00
0000oooo0?ooo`0C0?ooo`800000P`3oool006@0oooo0P00000O0?ooo`030000003oool0oooo01D0
oooo00<000000?ooo`3oool0P03oool00680oooo0P00000Q0?ooo`030000003oool0oooo01H0oooo
0P0000200?ooo`00G`3oool3000002<0oooo00<000000?ooo`3oool0603oool00`000000oooo0?oo
o`1m0?ooo`00G@3oool2000002H0oooo00<000000?ooo`3oool06@3oool2000007d0oooo001K0?oo
o`800000:03oool00`000000oooo0?ooo`0K0?ooo`800000N`3oool005T0oooo0P00000Z0?ooo`03
0000003oool0oooo01d0oooo00<000000?ooo`3oool0N03oool005L0oooo0P00000/0?ooo`030000
003oool0oooo01h0oooo0P00001h0?ooo`00E@3oool2000002h0oooo00<000000?ooo`3oool0803o
ool00`000000oooo0?ooo`1e0?ooo`00DP3oool300000300oooo00<000000?ooo`3oool08@3oool2
000007D0oooo001@0?ooo`800000<`3oool00`000000oooo0?ooo`0S0?ooo`800000L`3oool004h0
oooo0P00000e0?ooo`030000003oool0oooo02D0oooo00<000000?ooo`3oool0L03oool004`0oooo
0P00000g0?ooo`030000003oool0oooo02H0oooo0P00001`0?ooo`00BP3oool2000003T0oooo00<0
00000?ooo`3oool0:03oool00`000000oooo0?ooo`1]0?ooo`00B03oool2000003/0oooo00<00000
0?ooo`3oool0:@3oool2000006d0oooo00150?ooo`<00000?@3oool00`000000oooo0?ooo`0[0?oo
o`800000J`3oool004<0oooo0P0000100?ooo`030000003oool0oooo02d0oooo00<000000?ooo`3o
ool0J03oool00440oooo0P0000120?ooo`030000003oool0oooo02h0oooo0P00001X0?ooo`00?`3o
ool2000004@0oooo00<000000?ooo`3oool0<03oool00`000000oooo0?ooo`1U0?ooo`00?@3oool2
000004H0oooo00<000000?ooo`3oool0<@3oool2000006D0oooo000k0?ooo`800000B03oool00`00
0000oooo0?ooo`0c0?ooo`800000H`3oool003P0oooo0`00001:0?ooo`030000003oool0oooo03D0
oooo00<000000?ooo`3oool0H03oool003H0oooo0P00001=0?ooo`030000003oool0oooo03H0oooo
0P00001P0?ooo`00=03oool2000004l0oooo00<000000?ooo`3oool0>03oool00`000000oooo0?oo
o`1M0?ooo`00<P3oool200000540oooo00<000000?ooo`3oool0>@3oool2000005d0oooo000`0?oo
o`800000D`3oool00`000000oooo0?ooo`0k0?ooo`800000F`3oool002h0oooo0P00001E0?ooo`03
0000003oool0oooo03d0oooo00<000000?ooo`3oool0F03oool002/0oooo0`00001G0?ooo`030000
003oool0oooo03h0oooo0P00001H0?ooo`00:@3oool2000005X0oooo00<000000?ooo`3oool0@03o
ool00`000000oooo0?ooo`1E0?ooo`009`3oool2000005`0oooo00<000000?ooo`3oool0@@3oool2
000005D0oooo000U0?ooo`800000GP3oool00`000000oooo0?ooo`130?ooo`800000D`3oool002<0
oooo0P00001P0?ooo`030000003oool0oooo04D0oooo00<000000?ooo`3oool0D03oool00200oooo
0`00001R0?ooo`030000003oool0oooo04H0oooo0P00001@0?ooo`007P3oool2000006@0oooo00<0
00000?ooo`3oool0B@3oool00`000000oooo0?ooo`1=0?ooo`00703oool2000006H0oooo00<00000
0?ooo`3oool0BP3oool2000004d0oooo000J0?ooo`800000J03oool00`000000oooo0?ooo`1<0?oo
o`800000B`3oool001P0oooo0P00001Z0?ooo`030000003oool0oooo04h0oooo00<000000?ooo`3o
ool0B03oool001H0oooo0P00001/0?ooo`030000003oool0oooo04l0oooo0P0000180?ooo`004`3o
ool3000006h0oooo00<000000?ooo`3oool0D@3oool00`000000oooo0?ooo`150?ooo`004@3oool2
00000740oooo00<000000?ooo`3oool0DP3oool2000004D0oooo000?0?ooo`800000L`3oool00`00
0000oooo0?ooo`1D0?ooo`800000@`3oool000d0oooo0P00001e0?ooo`030000003oool0oooo05H0
oooo00<000000?ooo`3oool0@03oool000/0oooo0P00001g0?ooo`030000003oool0oooo05L0oooo
0P0000100?ooo`002@3oool2000007T0oooo00<000000?ooo`3oool0F@3oool00`000000oooo0?oo
o`0m0?ooo`001`3oool2000007/0oooo00<000000?ooo`3oool0FP3oool2000003d0oooo00070?oo
o`040000003oool00000000007T0oooo00<000000?ooo`3oool0G03oool2000003/0oooo00070?oo
o`040000003oool0oooo0?ooo`800000M`3oool00`000000oooo0?ooo`1N0?ooo`030000003oool0
oooo03P0oooo00070?ooo`030000003oool0oooo00<0oooo0P00001e0?ooo`030000003oool0oooo
05l0oooo0P00000h0?ooo`001`3oool00`000000oooo0?ooo`050?ooo`800000L`3oool00`000000
oooo0?ooo`1Q0?ooo`030000003oool0oooo03D0oooo00070?ooo`030000003oool0oooo00L0oooo
0P00001a0?ooo`030000003oool0oooo0680oooo0P00000e0?ooo`001`3oool00`000000oooo0?oo
o`090?ooo`800000K`3oool00`000000oooo0?ooo`1T0?ooo`800000<`3oool000H0oooo00<00000
0?ooo`3oool0303oool2000006d0oooo00<000000?ooo`3oool0IP3oool00`000000oooo0?ooo`0`
0?ooo`001P3oool00`000000oooo0?ooo`0>0?ooo`<00000JP3oool00`000000oooo0?ooo`1W0?oo
o`800000<03oool000H0oooo00<000000?ooo`3oool04@3oool2000006P0oooo00<000000?ooo`3o
ool0J@3oool00`000000oooo0?ooo`0]0?ooo`001P3oool00`000000oooo0?ooo`0C0?ooo`800000
IP3oool00`000000oooo0?ooo`1Z0?ooo`800000;@3oool000H0oooo00<000000?ooo`3oool05@3o
ool2000006@0oooo00<000000?ooo`3oool0K03oool2000002/0oooo00060?ooo`030000003oool0
oooo01L0oooo0P00001R0?ooo`030000003oool0oooo06h0oooo00<000000?ooo`3oool0:03oool0
00H0oooo00<000000?ooo`3oool06@3oool200000600oooo00<000000?ooo`3oool0K`3oool20000
02P0oooo00060?ooo`030000003oool0oooo01/0oooo0P00001N0?ooo`030000003oool0oooo0740
oooo00<000000?ooo`3oool09@3oool000H0oooo00<000000?ooo`3oool07@3oool2000005`0oooo
00<000000?ooo`3oool0LP3oool2000002D0oooo00060?ooo`030000003oool0oooo01l0oooo0`00
001I0?ooo`030000003oool0oooo07@0oooo0P00000S0?ooo`001P3oool00`000000oooo0?ooo`0R
0?ooo`800000E`3oool00`000000oooo0?ooo`1f0?ooo`030000003oool0oooo0200oooo00060?oo
o`030000003oool0oooo02@0oooo0P00001E0?ooo`030000003oool0oooo07L0oooo0P00000P0?oo
o`001@3oool00`000000oooo0?ooo`0W0?ooo`800000D`3oool00`000000oooo0?ooo`1i0?ooo`03
0000003oool0oooo01d0oooo00050?ooo`030000003oool0oooo02T0oooo0P00001A0?ooo`030000
003oool0oooo07X0oooo0P00000M0?ooo`001@3oool00`000000oooo0?ooo`0[0?ooo`800000C`3o
ool00`000000oooo0?ooo`1l0?ooo`8000006`3oool000D0oooo00<000000?ooo`3oool0;@3oool2
000004d0oooo00<000000?ooo`3oool0OP3oool00`000000oooo0?ooo`0H0?ooo`001@3oool00`00
0000oooo0?ooo`0_0?ooo`800000B`3oool00`000000oooo0?ooo`1o0?ooo`800000603oool000D0
oooo00<000000?ooo`3oool0<@3oool3000004P0oooo00<000000?ooo`3oool03@3oool300000740
oooo00<000000?ooo`3oool05@3oool000D0oooo00<000000?ooo`3oool0=03oool2000004H0oooo
00<000000?ooo`3oool03P3oool6000006h0oooo0P00000E0?ooo`001@3oool00`000000oooo0?oo
o`0f0?ooo`800000A03oool00`000000oooo0?ooo`0?0?ooo`X00000J`3oool2000001<0oooo0005
0?ooo`030000003oool0oooo03P0oooo0P0000120?ooo`030000003oool0oooo00l0oooo1P000002
0=RMU`D00000JP3oool00`000000oooo0?ooo`0@0?ooo`001@3oool00`000000oooo0?ooo`0j0?oo
o`800000@03oool00`000000oooo0?ooo`0@0?ooo`80000000<0];WM0000003=/l000P0000040=RM
U`800000JP3oool200000100oooo00050?ooo`030000003oool0oooo03`0oooo0P00000n0?ooo`03
0000003oool0oooo0140oooo0P000000102d^Md000000000003=/l02000000<0f9fG00<000000?oo
o`3oool0JP3oool00`000000oooo0?ooo`0=0?ooo`001@3oool00`000000oooo0?ooo`0n0?ooo`80
0000?03oool00`000000oooo0?ooo`0B0?ooo`<0000000@0];WM000000000000cK?00P0000000`3H
WIL000000?ooo`1/0?ooo`8000003@3oool000@0oooo00<000000?ooo`3oool0@@3oool2000003X0
oooo00<000000?ooo`3oool04`3oool00`000000K:Cb000000020;Big@030000003=/l00cK?00080
0000K`3oool2000000/0oooo00040?ooo`030000003oool0oooo04<0oooo0`00000g0?ooo`030000
003oool0oooo01@0oooo00<0000006bTlP0000000P2d^Md300000780oooo00<000000?ooo`3oool0
203oool000@0oooo00<000000?ooo`3oool0AP3oool200000380oooo1000000F0?ooo`040000001/
Y?80K:Cb000000<0];WM0`00001a0?ooo`800000203oool000@0oooo00<000000?ooo`3oool0B03o
ool200000340oooo2000000B0?ooo`060000001/Y?80K:Cb0000002d^Md000000`3oool200000700
oooo0P0000070?ooo`00103oool00`000000oooo0?ooo`1:0?ooo`800000<03oool=000000d0oooo
100000060?ooo`800000J`3oool3000000030?ooo`000000oooo00H0oooo00040?ooo`030000003o
ool0oooo04`0oooo0P00000/0?ooo`80000000<0oooo000000000000100000000`3MWY0000000000
0002000000040<9:8@0000000000000001H0oooo0P00001V0?ooo`<00000103oool00`000000oooo
0?ooo`050?ooo`00103oool00`000000oooo0?ooo`1>0?ooo`8000009`3oool3000000@0oooo00D0
00000;;0i000000000000=6i`P02000000<0gIj@1@00000G0?ooo`030000003oool0oooo0600oooo
0`0000070?ooo`030000003oool0oooo00D0oooo00040?ooo`030000003oool0oooo0500oooo0P00
000R0?ooo`<00000203oool00`000000//3T00000002000000040=6i`P0000000000000000@0gIj@
0P00000F0?ooo`030000o`3oool0oooo05d0oooo0`00000:0?ooo`030000003oool0oooo00D0oooo
00040?ooo`030000003oool0oooo0580oooo0P00000N0?ooo`8000002`3oool200000080//3T0`00
00020=6i`P8000000`3MWY000`000000oooo0?ooo`0D0?ooo`030000o`3oool0oooo05X0oooo0`00
000=0?ooo`030000003oool0oooo00D0oooo00040?ooo`030000003oool0oooo05@0oooo0P00000I
0?ooo`<000003P3oool300000080//3T0`0000020=6i`P80000000<0gIj@0000003oool05@3oool0
0`000?l0oooo0?ooo`1G0?ooo`<00000403oool00`000000oooo0?ooo`050?ooo`00103oool00`00
0000oooo0?ooo`1F0?ooo`<000004`3oool300000180oooo00<0000005NPm@0000000P2b`>@40000
0080dKW20P00000F0?ooo`030000o`3oool0oooo05@0oooo0`00000D0?ooo`030000003oool0oooo
00@0oooo00040?ooo`030000003oool0oooo05T0oooo0P00000?0?ooo`8000005P3oool00`000000
Ej3e000000030;;0i0050000003A^L8000000000003o00005P3oool00`000?l0oooo0?ooo`1B0?oo
o`<000005`3oool00`000000oooo0?ooo`040?ooo`000`3oool00`000000oooo0?ooo`1L0?ooo`80
00002P3oool3000001T0oooo00<0000005NPm@0000000`2b`>@2000000040=6i`P00000000000?l0
01@0oooo00<0003o0?ooo`3oool0C`3oool3000001X0oooo00<000000?ooo`3oool0103oool000<0
oooo00<000000?ooo`3oool0GP3oool2000000D0oooo0`00000M0?ooo`030000001GX?D0000000@0
//3T00<000000?ooo`3oool00P0000000`3o0000oooo0?ooo`0@0?ooo`030000o`3oool0oooo04`0
oooo0`00000M0?ooo`030000003oool0oooo00@0oooo00030?ooo`030000003oool0oooo0600oooo
0P0000000`3oool000000000000Q0?ooo`040000001GX?D000000;;0i08000001@3oool200000003
0?l0003oool0oooo00h0oooo00<0003o0?ooo`3oool0B@3oool300000200oooo00<000000?ooo`3o
ool0103oool000<0oooo00<000000?ooo`3oool0H03oool4000002<0oooo0`0000090?ooo`800000
00<0o`000?ooo`3oool0303oool00`000?l0oooo0?ooo`160?ooo`<000008`3oool00`000000oooo
0?ooo`040?ooo`000`3oool00`000000oooo0?ooo`1N0?ooo`800000103oool2000002l0oooo0P00
00000`3o0000oooo0?ooo`0:0?ooo`030000o`3oool0oooo04<0oooo0`00000V0?ooo`030000003o
ool0oooo00@0oooo00030?ooo`030000003oool0oooo05/0oooo0`0000080?ooo`800000;`3oool2
000000030?l0003oool0oooo00P0oooo00<0003o0?ooo`3oool0@03oool3000002T0oooo00<00000
0?ooo`3oool0103oool000<0oooo00<000000?ooo`3oool0F03oool3000000d0oooo0`00000^0?oo
o`80000000<0o`000?ooo`3oool01P3oool00`000?l0oooo0?ooo`0m0?ooo`<00000;03oool00`00
0000oooo0?ooo`040?ooo`000`3oool00`000000oooo0?ooo`1F0?ooo`8000004`3oool2000002h0
oooo0P0000000`3o0000oooo0?ooo`040?ooo`030000o`3oool0oooo03X0oooo0`00000_0?ooo`03
0000003oool0oooo00@0oooo00030?ooo`030000003oool0oooo05<0oooo0`00000G0?ooo`800000
;P3oool2000000030?l0003oool0oooo0080oooo00<0003o0?ooo`3oool0=`3oool300000380oooo
00<000000?ooo`3oool0103oool000<0oooo00<000000?ooo`3oool0D03oool3000001`0oooo0P00
000^0?ooo`80000000<0o`000?ooo`000?l0=`3oool3000003D0oooo00<000000?ooo`3oool0103o
ool000<0oooo00<000000?ooo`3oool0CP3oool200000240oooo0P00000^0?ooo`80000000<0o`00
0?ooo`3oool0<P3oool3000003P0oooo00<000000?ooo`3oool0103oool000<0oooo00<000000?oo
o`3oool0B`3oool3000002D0oooo0P00000^0?ooo`80000000<0o`000?ooo`3oool0;03oool40000
03`0oooo00<000000?ooo`3oool00`3oool00080oooo00<000000?ooo`3oool0B@3oool3000002X0
oooo0P00000/0?ooo`050000o`3oool000000000003o0000:@3oool300000400oooo00<000000?oo
o`3oool00`3oool00080oooo00<000000?ooo`3oool0A`3oool2000002l0oooo0P00000Z0?ooo`04
0000o`3oool0oooo0?ooo`80000000<0o`000?ooo`3oool08P3oool3000004<0oooo00<000000?oo
o`3oool00`3oool00080oooo00<000000?ooo`3oool0A03oool3000003<0oooo0`00000W0?ooo`03
0000o`3oool0oooo00<0oooo0P0000000`3o0000oooo0?ooo`0M0?ooo`<00000AP3oool00`000000
oooo0?ooo`030?ooo`000P3oool00`000000oooo0?ooo`110?ooo`<00000>@3oool2000002D0oooo
00<0003o0?ooo`3oool01@3oool2000000030?l0003oool0oooo01P0oooo0`0000190?ooo`030000
003oool0oooo00<0oooo00020?ooo`030000003oool0oooo03l0oooo0P00000n0?ooo`8000008`3o
ool00`000?l0oooo0?ooo`070?ooo`80000000<0o`000?ooo`3oool04`3oool3000004`0oooo00<0
00000?ooo`3oool00`3oool00080oooo00<000000?ooo`3oool0?03oool300000480oooo0P00000Q
0?ooo`030000o`3oool0oooo00T0oooo0P0000000`3o0000oooo0?ooo`0>0?ooo`<00000C`3oool0
0`000000oooo0?ooo`030?ooo`000P3oool00`000000oooo0?ooo`0j0?ooo`800000A`3oool20000
01l0oooo00<0003o0?ooo`3oool02`3oool2000000030?l0003oool0oooo00T0oooo0`00001B0?oo
o`030000003oool0oooo00<0oooo00020?ooo`030000003oool0oooo03L0oooo0`00001;0?ooo`80
0000703oool00`000?l0oooo0?ooo`0>0?ooo`8000001`3oool3000005D0oooo00<000000?ooo`3o
ool00`3oool00080oooo00<000000?ooo`3oool0=03oool300000500oooo0P00000J0?ooo`030000
o`3oool0oooo0100oooo0P0000020?ooo`<00000F03oool00`000000oooo0?ooo`030?ooo`000P3o
ool00`000000oooo0?ooo`0b0?ooo`800000E@3oool2000001P0oooo00<0003o0?ooo`3oool04@3o
ool3000005/0oooo00<000000?ooo`3oool00`3oool00080oooo00<000000?ooo`3oool0;`3oool3
000005T0oooo0`00000E0?ooo`030000o`3oool0oooo00h0oooo0`0000030?ooo`800000F@3oool0
0`000000oooo0?ooo`030?ooo`000P3oool00`000000oooo0?ooo`0/0?ooo`<00000G`3oool20000
01<0oooo00<0003o0?ooo`3oool02`3oool3000000P0oooo0P00001G0?ooo`030000003oool0oooo
00<0oooo00000`3oool000000?ooo`0/0?ooo`800000I03oool200000140oooo00<0003o0?ooo`3o
ool0203oool3000000d0oooo0P00001F0?ooo`030000003oool0oooo0080oooo00000`3oool00000
0?ooo`0Y0?ooo`<00000J03oool2000000l0oooo00<0003o0?ooo`3oool01@3oool300000180oooo
0P00001D0?ooo`030000003oool0oooo0080oooo00000`3oool000000?ooo`0V0?ooo`<00000K@3o
ool2000000d0oooo00<0003o0?ooo`3oool00P3oool3000001L0oooo0P00001B0?ooo`030000003o
ool0oooo0080oooo00000`3oool000000?ooo`0T0?ooo`800000LP3oool2000000/0oooo00<0003o
0?ooo`0000000P00000L0?ooo`800000D03oool00`000000oooo0?ooo`020?ooo`0000<0oooo0000
003oool08@3oool3000007H0oooo0P0000080?ooo`03000000000?l000000240oooo0P00001>0?oo
o`030000003oool0oooo0080oooo00000`3oool000000?ooo`0O0?ooo`800000N`3oool2000000<0
oooo0`0000000`000?l0oooo0?ooo`0S0?ooo`800000C03oool00`000000oooo0?ooo`020?ooo`00
00<0oooo0000003oool0703oool3000007l0oooo0`0000030?ooo`030000o`3oool0oooo02D0oooo
0P00001:0?ooo`030000003oool0oooo0080oooo00000`3oool000000?ooo`0I0?ooo`<00000P`3o
ool00`000000oooo0?ooo`020?ooo`030000o`3oool0oooo02L0oooo00<000000?ooo`3oool0A`3o
ool00`000000oooo0?ooo`020?ooo`0000<0oooo0000003oool05`3oool2000008H0oooo00<00000
0?ooo`3oool00P3oool00`000?l0oooo0?ooo`0X0?ooo`800000A`3oool00`000000oooo0?ooo`02
0?ooo`0000<0oooo0000003oool0503oool3000008P0oooo00<000000?ooo`3oool00P3oool00`00
0?l0oooo0?ooo`0Z0?ooo`800000A@3oool00`000000oooo0?ooo`020?ooo`0000<0oooo0000003o
ool04@3oool3000008/0oooo00<000000?ooo`3oool00P3oool00`000?l0oooo0?ooo`0/0?ooo`80
0000@`3oool00`000000oooo0?ooo`020?ooo`0000<0oooo0000003oool03`3oool2000008h0oooo
00<000000?ooo`3oool00P3oool00`000?l0oooo0?ooo`0^0?ooo`800000@@3oool00`000000oooo
0?ooo`020?ooo`0000<000000?ooo`3oool0303oool300000900oooo00<000000?ooo`3oool00P3o
ool00`000?l0oooo0?ooo`0`0?ooo`800000?`3oool00`000000oooo0?ooo`020?ooo`0000<00000
0?ooo`3oool02@3oool3000009<0oooo00<000000?ooo`3oool00P3oool00`000?l0oooo0?ooo`0b
0?ooo`800000?@3oool00`000000oooo0?ooo`020?ooo`0000<000000?ooo`3oool01`3oool20000
09H0oooo00<000000?ooo`3oool00P3oool00`000?l0oooo0?ooo`0d0?ooo`800000?03oool00`00
0000oooo0?ooo`010?ooo`0000<000000?ooo`3oool0103oool3000009P0oooo00D000000?ooo`3o
ool0oooo0000o`0i0?ooo`800000>P3oool00`000000oooo0?ooo`010?ooo`0000@000000?ooo`3o
ool0oooo0`00002K0?ooo`050000003oool0oooo0?ooo`000?l0>`3oool2000003P0oooo00<00000
0?ooo`3oool00@3oool000040000003oool00000000009h0oooo00D000000?ooo`3oool0oooo0000
o`0m0?ooo`800000=P3oool00`000000oooo0?ooo`010?ooo`000P00002P0?ooo`050000003oool0
oooo0?ooo`000?l0?`3oool2000003@0oooo00<000000?ooo`3oool00@3oool00080oooo0`00002M
0?ooo`050000003oool0oooo0?ooo`000?l0@@3oool200000380oooo00<000000?ooo`3oool00@3o
ool000D0oooo0P00002K0?ooo`050000003oool0oooo0?ooo`000?l0@`3oool200000300oooo00<0
00000?ooo`3oool00@3oool000L0oooo0`00002H0?ooo`050000003oool0oooo0?ooo`000?l0A@3o
ool2000002h0oooo00<000000?ooo`3oool00@3oool000X0oooo0`00002E0?ooo`050000003oool0
oooo0?ooo`000?l0A`3oool2000002`0oooo00<000000?ooo`3oool00@3oool000d0oooo0P00002C
0?ooo`050000003oool0oooo0?ooo`000?l0B@3oool2000002X0oooo00<000000?ooo`3oool00@3o
ool000l0oooo0`00002@0?ooo`050000003oool0oooo0?ooo`000?l0B`3oool2000002P0oooo00<0
00000?ooo`3oool00@3oool00180oooo0`00002=0?ooo`040000003oool0oooo0000odh0oooo0P00
000V0?ooo`030000003oool0oooo0040oooo000E0?ooo`800000R`3oool010000000oooo0?ooo`00
0?m@0?ooo`800000903oool00`000000oooo0?ooo`010?ooo`005`3oool3000008P0oooo00@00000
0?ooo`3oool0003oDP3oool2000002<0oooo0@0000010?ooo`40oooo000J0?ooo`<00000Q@3oool0
10000000oooo0?ooo`000?mD0?ooo`8000008@3oool100000040oooo0@3oool001d0oooo0`000022
0?ooo`040000003oool0oooo0000oeH0oooo0P00000O0?ooo`4000000@3oool10?ooo`00803oool2
00000800oooo00@000000?ooo`3oool0003oF03oool2000001d0oooo0@0000010?ooo`40oooo000R
0?ooo`<00000O@3oool010000000oooo0?ooo`000?mJ0?ooo`8000006`3oool100000040oooo0@3o
ool002D0oooo0`00001j0?ooo`040000003oool0oooo0000oe`0oooo0P00000I0?ooo`4000000@3o
ool10?ooo`00:03oool2000007P0oooo00@000000?ooo`3oool0003oGP3oool2000001L0oooo0@00
00010?ooo`40oooo000Z0?ooo`<00000M@3oool010000000oooo0?ooo`000?mP0?ooo`8000005@3o
ool100000040oooo0@3oool002d0oooo0`00001b0?ooo`030000003oool0003o06<0oooo0P00000C
0?ooo`4000000@3oool10?ooo`00<03oool200000700oooo00<000000?ooo`000?l0I@3oool20000
0140oooo0@0000010?ooo`40oooo000b0?ooo`<00000K@3oool00`000000oooo0000o`1W0?ooo`80
00003`3oool100000040oooo0@3oool003D0oooo0`00001Z0?ooo`030000003oool0003o06T0oooo
0P00000=0?ooo`4000000@3oool10?ooo`00>03oool3000006L0oooo00<000000?ooo`000?l0J`3o
ool2000000/0oooo0@0000010?ooo`40oooo000k0?ooo`800000I@3oool00`000000oooo0000o`1]
0?ooo`8000002P3oool100000040oooo000m0?ooo`<00000HP3oool00`000000oooo0000o`1_0?oo
o`800000203oool100000040oooo00100?ooo`<00000G`3oool00`000000oooo0000o`1a0?ooo`80
00001P3oool100000040oooo00130?ooo`800000G@3oool00`000000oooo0000o`1c0?ooo`800000
103oool100000040oooo00150?ooo`<00000FP3oool00`000000oooo0000o`1e0?ooo`8000000P3o
ool100000040oooo00180?ooo`<00000E`3oool00`000000003o0?ooo`1g0?ooo`<000000@3oool0
04/0oooo0P00001E0?ooo`03000000000?l0oooo07P0oooo0P0000010?ooo`00C@3oool300000580
oooo00<000000000o`3oool0M03oool4000000<0oooo001@0?ooo`<00000C`3oool00`000000003o
0?ooo`1`0?ooo`@000001`3oool005<0oooo0`00001<0?ooo`03000000000?l0oooo06`0oooo1000
000;0?ooo`00EP3oool2000004X0oooo00<000000000o`3oool0J03oool4000000l0oooo001H0?oo
o`<00000A`3oool00`000000003o0?ooo`1T0?ooo`@000004`3oool005/0oooo0`0000140?ooo`03
000000000?l0oooo0600oooo1000000G0?ooo`00GP3oool200000480oooo00<000000000o`3oool0
G03oool4000001/0oooo001P0?ooo`<00000?`3oool00`000000003o0?ooo`1I0?ooo`<000007`3o
ool006<0oooo0`00000j0?ooo`80000000@0003o0000000000000000E03oool400000280oooo001V
0?ooo`800000=`3oool2000000040<6Z``000?l000000::>`0800000C`3oool4000002H0oooo001X
0?ooo`<00000=03oool2000000040<6Z``000?l0000000000080L5f/00<000000?ooo`3oool0B03o
ool4000002X0oooo001[0?ooo`<00000<@3oool2000000040<6Z``000?l0000000000080L5f/00<0
00000?ooo`3oool0A03oool4000002h0oooo001^0?ooo`<00000;P3oool3000000030000o`2RS/00
000000<00000@P3oool400000380oooo001a0?ooo`800000;03oool20000000309:Mf`000?l00000
00<00000?`3oool4000003H0oooo001c0?ooo`<00000:@3oool200000080TYgK0P0000000`3Wl]80
00000?ooo`0j0?ooo`@00000>P3oool007H0oooo0`00000W0?ooo`030000002BWM/0TYgK00<00000
>@3oool3000003h0oooo001i0?ooo`8000009@3oool010000000TYgK0000002ma=l2000003D0oooo
100000110?ooo`00N`3oool300000280oooo00<0000009:Mf`0000000P00000b0?ooo`@00000A@3o
ool007h0oooo0`00000O0?ooo`030000002BWM/0000000800000;P3oool4000004T0oooo00210?oo
o`8000007@3oool4000002/0oooo1000001=0?ooo`00P`3oool3000001X0oooo1000000W0?ooo`@0
0000D@3oool008H0oooo0`00000H0?ooo`800000903oool4000005D0oooo00290?ooo`<000005@3o
ool200000200oooo1000001I0?ooo`00S03oool2000001<0oooo0P00000M0?ooo`<00000G@3oool0
08h0oooo0`00000@0?ooo`8000006@3oool400000600oooo002A0?ooo`<000003P3oool00`000000
oooo0?ooo`0C0?ooo`@00000I03oool009@0oooo0P00000<0?ooo`030000003oool0oooo00l0oooo
1000001X0?ooo`00UP3oool3000000T0oooo00<000000?ooo`3oool02`3oool4000006`0oooo002I
0?ooo`<000001P3oool00`000000oooo0?ooo`070?ooo`@00000L03oool009`0oooo0P0000040?oo
o`030000003oool0oooo00<0oooo1000001d0?ooo`00WP3oool3000000030?ooo`000000oooo00@0
0000N03oool00:40oooo0`00001l0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {203.938, 0}} -> {-0.000790697, 0.111521, \
0.00334202, 0.00334202}}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"5.0 for Microsoft Windows",
ScreenRectangle->{{0, 1024}, {0, 677}},
ScreenStyleEnvironment->"Working",
WindowToolbars->{},
WindowSize->{515, 639},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
StyleDefinitions -> "HelpBrowser.nb"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "Function?"->{
    Cell[1776, 53, 61, 1, 41, "ObjectName",
      CellTags->"Function?"],
    Cell[1840, 56, 420, 15, 50, "Usage",
      CellTags->"Function?"],
    Cell[2263, 73, 94, 3, 41, "MathCaption",
      CellTags->"Function?"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"Function?", 29151, 663}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 61, 1, 41, "ObjectName",
  CellTags->"Function?"],
Cell[1840, 56, 420, 15, 50, "Usage",
  CellTags->"Function?"],
Cell[2263, 73, 94, 3, 41, "MathCaption",
  CellTags->"Function?"],
Cell[2360, 78, 187, 6, 41, "MathCaption"],
Cell[2550, 86, 564, 22, 58, "MathCaption"],

Cell[CellGroupData[{
Cell[3139, 112, 33, 0, 39, "ExampleSection"],
Cell[3175, 114, 97, 2, 29, "Input"],
Cell[3275, 118, 97, 2, 25, "Text"],

Cell[CellGroupData[{
Cell[3397, 124, 654, 13, 209, "Input"],
Cell[4054, 139, 24371, 501, 211, 4050, 245, "GraphicsData", "PostScript", \
"Graphics"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

