(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    168614,       6319]*)
(*NotebookOutlinePosition[    169569,       6353]*)
(*  CellTagsIndexPosition[    169492,       6347]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Draw3DItems", "ObjectName",
  CellTags->"Function?"],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  Cell[BoxData[
      RowBox[{
        StyleBox["Draw3DItems",
          "MR"], 
        StyleBox["[",
          "MR"], 
        RowBox[{
          RowBox[{
            StyleBox["{",
              "MR"], 
            StyleBox["primitives",
              "TI"], 
            StyleBox["}",
              "TI"]}], 
          StyleBox[",",
            "TI"], 
          StyleBox["options",
            "TI"]}], 
        StyleBox["]",
          "MR"]}]]],
  " is a shortcut for ",
  Cell[BoxData[
      StyleBox[\(Show[Graphics3D[{primitives}], options]\),
        "MR"]]]
}], "Usage",
  CellTags->"Function?"],

Cell[TextData[{
  "See also: ",
  ButtonBox["BlankDrawingCube",
    ButtonData:>{"BlankDrawingCube"},
    ButtonStyle->"AddOnsLink"],
  " ."
}], "MathCaption"],

Cell[CellGroupData[{

Cell["Example", "ExampleSection"],

Cell[BoxData[
    \(Needs["\<DrawGraphics`DrawingMaster`\>"]\)], "Input",
  CellLabel->"In[296]:="],

Cell["\<\
The following combines three different items to show a cube circumscribed by \
a sphere.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(sphere[\[Phi]_, \[Theta]_] := {Cos[\[Theta]] Cos[\[Phi]], 
          Sin[\[Theta]] Cos[\[Phi]], Sin[\[Phi]]};\)\), "\n", 
    \(\(Draw3DItems[\[IndentingNewLine]{Cuboid[\(-{1, \ 1, \ 1}\)/\@3, {1, \ 
                1, \ 1}/\@3], \[IndentingNewLine]ParametricDraw3D[
            Evaluate[
              sphere[\[Phi], \[Theta]]], {\[Phi], \(-\[Pi]\)/2, \[Pi]/
                2}, {\[Theta], 0, \[Pi]}, 
            PlotPoints \[Rule] {20, 20}], \[IndentingNewLine]ParametricDraw3D[
              Evaluate[
                sphere[\[Phi], \[Theta]]], {\[Phi], \(-\[Pi]\)/2, \[Pi]/
                  2}, {\[Theta], \[Pi], 2  \[Pi]}, 
              PlotPoints \[Rule] {20, 20}] // 
            UseWireFrame}, \[IndentingNewLine]Boxed \[Rule] 
          False, \[IndentingNewLine]ImageSize \[Rule] 300];\)\)}], "Input",
  CellLabel->"In[297]:="],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.08739 
%%ImageSize: 300 326.216 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0575307 1.16712 -1.11131e-017 1.16712 [
[ 0 0 0 0 ]
[ 1 1.08739 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 1.08739 L
0 1.08739 L
closepath
clip
newpath
.5 Mabswid
[ ] 0 setdash
.733 .579 .682 r
.46246 .64041 m .46809 .59444 L .50664 .5982 L p F P
0 g
s
.733 .579 .682 r
.50664 .5982 m .50476 .64442 L .46246 .64041 L p F P
0 g
s
.731 .602 .713 r
.50898 .55173 m .50664 .5982 L .46809 .59444 L p F P
0 g
s
.707 .556 .681 r
.50476 .64442 m .50664 .5982 L .5456 .59819 L p F P
0 g
s
.707 .581 .712 r
.50664 .5982 m .50898 .55173 L .54323 .55172 L p F P
0 g
s
.707 .581 .712 r
.54323 .55172 m .5456 .59819 L .50664 .5982 L p F P
0 g
s
.707 .556 .681 r
.5456 .59819 m .54749 .64441 L .50476 .64442 L p F P
0 g
s
.679 .535 .682 r
.54749 .64441 m .5456 .59819 L .58415 .59441 L p F P
0 g
s
.683 .562 .713 r
.5456 .59819 m .54323 .55172 L .57712 .54831 L p F P
0 g
s
.683 .562 .713 r
.57712 .54831 m .58415 .59441 L .5456 .59819 L p F P
0 g
s
.731 .602 .713 r
.46809 .59444 m .4751 .54833 L .50898 .55173 L p F P
0 g
s
.727 .623 .743 r
.51174 .50582 m .50898 .55173 L .4751 .54833 L p F P
0 g
s
.706 .606 .742 r
.50898 .55173 m .51174 .50582 L .54045 .50581 L p F P
0 g
s
.706 .606 .742 r
.54045 .50581 m .54323 .55172 L .50898 .55173 L p F P
0 g
s
.685 .589 .743 r
.54323 .55172 m .54045 .50581 L .56883 .50287 L p F P
0 g
s
.685 .589 .743 r
.56883 .50287 m .57712 .54831 L .54323 .55172 L p F P
0 g
s
.759 .603 .684 r
.42143 .63244 m .43073 .58697 L .46809 .59444 L p F P
0 g
s
.759 .603 .684 r
.46809 .59444 m .46246 .64041 L .42143 .63244 L p F P
0 g
s
.754 .624 .715 r
.45354 .56711 m .45637 .57428 L .44112 .57793 L F
.47171 .57061 m .46198 .58213 L .44112 .57793 L F
.44112 .57793 m .45721 .58778 L .43073 .58697 L F
.46809 .59444 m .45396 .59162 L p .45721 .58778 L F P
0 g
s
.754 .624 .715 r
.45396 .59162 m .43073 .58697 L p .45721 .58778 L F P
0 g
s
.562 .35 .551 r
.46029 .58268 m .46026 .58417 L p .4611 .58318 L F P
0 g
s
.951 .687 .501 r
.45924 .58158 m .46029 .58268 L .46026 .58417 L p F P
0 g
s
.562 .35 .551 r
.46198 .58213 m .46029 .58268 L p .4611 .58318 L F P
0 g
s
.666 .737 .903 r
.46198 .58213 m .46029 .58268 L .45924 .58158 L p F P
0 g
s
.754 .624 .715 r
.46972 .58369 m .46809 .59444 L p .44112 .57793 L F P
0 g
s
.679 .535 .682 r
.58415 .59441 m .5898 .64038 L .54749 .64441 L p F P
0 g
s
.734 .554 .648 r
.45831 .68544 m .46246 .64041 L .50476 .64442 L p F P
0 g
s
.734 .554 .648 r
.50476 .64442 m .50338 .68959 L .45831 .68544 L p F P
0 g
s
.705 .529 .648 r
.50338 .68959 m .50476 .64442 L .54749 .64441 L p F P
0 g
s
.705 .529 .648 r
.54749 .64441 m .54889 .68958 L .50338 .68959 L p F P
0 g
s
.674 .505 .648 r
.54889 .68958 m .54749 .64441 L .5898 .64038 L p F P
0 g
s
.763 .58 .65 r
.41457 .67718 m .42143 .63244 L .46246 .64041 L p F P
0 g
s
.763 .58 .65 r
.46246 .64041 m .45831 .68544 L .41457 .67718 L p F P
0 g
s
.674 .505 .648 r
.5898 .64038 m .59395 .68541 L .54889 .68958 L p F P
0 g
s
.642 .481 .65 r
.59395 .68541 m .5898 .64038 L .63082 .6324 L p F P
0 g
s
.733 .526 .611 r
.45575 .72869 m .45831 .68544 L .50338 .68959 L p F P
0 g
s
.733 .526 .611 r
.50338 .68959 m .50253 .73287 L .45575 .72869 L p F P
0 g
s
.701 .499 .611 r
.50253 .73287 m .50338 .68959 L .54889 .68958 L p F P
0 g
s
.701 .499 .611 r
.54889 .68958 m .54975 .73286 L .50253 .73287 L p F P
0 g
s
.668 .472 .611 r
.54975 .73286 m .54889 .68958 L .59395 .68541 L p F P
0 g
s
.642 .481 .65 r
.63082 .6324 m .63769 .67713 L .59395 .68541 L p F P
0 g
s
.668 .472 .611 r
.59395 .68541 m .59652 .72866 L .54975 .73286 L p F P
0 g
s
.632 .444 .611 r
.59652 .72866 m .59395 .68541 L .63769 .67713 L p F P
0 g
s
.632 .444 .611 r
.63769 .67713 m .64193 .7203 L .59652 .72866 L p F P
0 g
s
.592 .415 .611 r
.64193 .7203 m .63769 .67713 L .67921 .66485 L p F P
0 g
s
.731 .492 .567 r
.45488 .7693 m .45575 .72869 L .50253 .73287 L p F P
0 g
s
.731 .492 .567 r
.50253 .73287 m .50224 .77342 L .45488 .7693 L p F P
0 g
s
.695 .463 .567 r
.50224 .77342 m .50253 .73287 L .54975 .73286 L p F P
0 g
s
.695 .463 .567 r
.54975 .73286 m .55005 .77341 L .50224 .77342 L p F P
0 g
s
.658 .433 .567 r
.55005 .77341 m .54975 .73286 L .59652 .72866 L p F P
0 g
s
.658 .433 .567 r
.59652 .72866 m .5974 .76927 L .55005 .77341 L p F P
0 g
s
.618 .401 .565 r
.5974 .76927 m .59652 .72866 L .64193 .7203 L p F P
0 g
s
.592 .415 .611 r
.67921 .66485 m .68507 .7079 L .64193 .7203 L p F P
0 g
s
.618 .401 .565 r
.64193 .7203 m .64338 .76104 L .5974 .76927 L p F P
0 g
s
.573 .366 .563 r
.64338 .76104 m .64193 .7203 L .68507 .7079 L p F P
0 g
s
.724 .45 .512 r
.45577 .80638 m .45488 .7693 L .50224 .77342 L p F P
0 g
s
.724 .45 .512 r
.50224 .77342 m .50253 .81035 L .45577 .80638 L p F P
0 g
s
.686 .419 .513 r
.50253 .81035 m .50224 .77342 L .55005 .77341 L p F P
0 g
s
.686 .419 .513 r
.55005 .77341 m .54975 .81034 L .50253 .81035 L p F P
0 g
s
.645 .385 .512 r
.54975 .81034 m .55005 .77341 L .5974 .76927 L p F P
0 g
s
.762 .481 .508 r
.45488 .7693 m .45577 .80638 L .41035 .79847 L p F P
0 g
s
.645 .385 .512 r
.5974 .76927 m .59651 .80635 L .54975 .81034 L p F P
0 g
s
.6 .348 .508 r
.59651 .80635 m .5974 .76927 L .64338 .76104 L p F P
0 g
s
.573 .366 .563 r
.68507 .7079 m .68708 .74881 L .64338 .76104 L p F P
0 g
s
.52 .326 .558 r
.68708 .74881 m .68507 .7079 L .72501 .69159 L p F P
0 g
s
.6 .348 .508 r
.64338 .76104 m .64191 .79842 L .59651 .80635 L p F P
0 g
s
.548 .306 .501 r
.64191 .79842 m .64338 .76104 L .68708 .74881 L p F P
0 g
s
.52 .326 .558 r
.72501 .69159 m .72755 .73273 L .68708 .74881 L p F P
0 g
s
.711 .394 .439 r
.45848 .83899 m .45577 .80638 L .50253 .81035 L p F P
0 g
s
.711 .394 .439 r
.50253 .81035 m .50344 .84273 L .45848 .83899 L p F P
0 g
s
.669 .36 .441 r
.50344 .84273 m .50253 .81035 L .54975 .81034 L p F P
0 g
s
.669 .36 .441 r
.54975 .81034 m .54883 .84272 L .50344 .84273 L p F P
0 g
s
.624 .323 .439 r
.54883 .84272 m .54975 .81034 L .59651 .80635 L p F P
0 g
s
.548 .306 .501 r
.68708 .74881 m .68504 .78665 L .64191 .79842 L p F P
0 g
s
.485 .255 .489 r
.68504 .78665 m .68708 .74881 L .72755 .73273 L p F P
0 g
s
.752 .426 .432 r
.41484 .83156 m .41035 .79847 L .45577 .80638 L p F P
0 g
s
.752 .426 .432 r
.45577 .80638 m .45848 .83899 L .41484 .83156 L p F P
0 g
s
.624 .323 .439 r
.59651 .80635 m .59379 .83897 L .54883 .84272 L p F P
0 g
s
.573 .279 .432 r
.59379 .83897 m .59651 .80635 L .64191 .79842 L p F P
0 g
s
.573 .279 .432 r
.64191 .79842 m .63742 .83152 L .59379 .83897 L p F P
0 g
s
.512 .227 .418 r
.63742 .83152 m .64191 .79842 L .68504 .78665 L p F P
0 g
s
.485 .255 .489 r
.72755 .73273 m .72498 .77117 L .68504 .78665 L p F P
0 g
s
.406 .191 .471 r
.72498 .77117 m .72755 .73273 L .76384 .71301 L p F P
0 g
s
.512 .227 .418 r
.68504 .78665 m .67883 .82046 L .63742 .83152 L p F P
0 g
s
.437 .161 .396 r
.67883 .82046 m .68504 .78665 L .72498 .77117 L p F P
0 g
s
.686 .314 .336 r
.46305 .86619 m .45848 .83899 L .50344 .84273 L p F P
0 g
s
.686 .314 .336 r
.50344 .84273 m .50496 .8696 L .46305 .86619 L p F P
0 g
s
.64 .278 .34 r
.50496 .8696 m .50344 .84273 L .54883 .84272 L p F P
0 g
s
.64 .278 .34 r
.54883 .84272 m .54729 .86959 L .50496 .8696 L p F P
0 g
s
.589 .234 .336 r
.54729 .86959 m .54883 .84272 L .59379 .83897 L p F P
0 g
s
.729 .345 .323 r
.42241 .85939 m .41484 .83156 L .45848 .83899 L p F P
0 g
s
.729 .345 .323 r
.45848 .83899 m .46305 .86619 L .42241 .85939 L p F P
0 g
s
.406 .191 .471 r
.76384 .71301 m .76077 .75221 L .72498 .77117 L p F P
0 g
s
.437 .161 .396 r
.72498 .77117 m .71712 .80594 L .67883 .82046 L p F P
0 g
s
.338 .075 .36 r
.71712 .80594 m .72498 .77117 L .76077 .75221 L p F P
0 g
s
.634 .189 .177 r
.4695 .88699 m .46305 .86619 L .50496 .8696 L p F P
0 g
s
.338 .075 .36 r
.76077 .75221 m .75138 .78816 L .71712 .80594 L p F P
0 g
s
.2 0 .301 r
.75138 .78816 m .76077 .75221 L .79147 .73003 L p F P
0 g
s
.677 .218 .154 r
.46305 .86619 m .45614 .8696 L .45426 .86827 L F
.44769 .86362 m .45858 .86544 L p .45426 .86827 L F P
0 g
s
.677 .218 .154 r
.45858 .86544 m .46305 .86619 L p .45426 .86827 L F P
0 g
s
.951 .687 .501 r
.4537 .86864 m .45425 .86828 L .45422 .87005 L F
.562 .35 .551 r
.45422 .87005 m .45607 .86955 L p .45426 .86828 L F P
0 g
s
.765 .553 .611 r
.41033 .72035 m .41457 .67718 L .45831 .68544 L p F P
0 g
s
.765 .553 .611 r
.45831 .68544 m .45575 .72869 L .41033 .72035 L p F P
0 g
s
.562 .35 .551 r
.46026 .58417 m .45422 .87005 L p .4611 .58318 L F P
0 g
s
.677 .218 .154 r
.45426 .86827 m .43306 .88099 L .44769 .86362 L F
.951 .687 .501 r
.45426 .86827 m .45422 .87005 L p .45425 .86828 L F P
0 g
s
.677 .218 .154 r
.44035 .87739 m .43306 .88099 L .45426 .86827 L F
.42241 .85939 m .44769 .86362 L p .44434 .8676 L F P
0 g
s
.792 .608 .652 r
.37304 .66491 m .38252 .62061 L .42143 .63244 L p F P
0 g
s
.792 .608 .652 r
.42143 .63244 m .41457 .67718 L .37304 .66491 L p F P
0 g
s
.812 .658 .692 r
.34661 .60508 m .36282 .56138 L .39538 .5759 L p F P
0 g
s
.812 .658 .692 r
.39538 .5759 m .38252 .62061 L .34661 .60508 L p F P
0 g
s
.797 .583 .611 r
.36718 .70796 m .37304 .66491 L .41457 .67718 L p F P
0 g
s
.797 .583 .611 r
.41457 .67718 m .41033 .72035 L .36718 .70796 L p F P
0 g
s
.822 .639 .655 r
.33463 .64879 m .34661 .60508 L .38252 .62061 L p F P
0 g
s
.822 .639 .655 r
.38252 .62061 m .37304 .66491 L .33463 .64879 L p F P
0 g
s
.822 .703 .733 r
.33385 .54366 m .35771 .50263 L .3829 .51854 L p F P
0 g
s
.822 .703 .733 r
.3829 .51854 m .36282 .56138 L .33385 .54366 L p F P
0 g
s
.765 .521 .565 r
.40889 .76108 m .41033 .72035 L .45575 .72869 L p F P
0 g
s
.765 .521 .565 r
.45575 .72869 m .45488 .7693 L .40889 .76108 L p F P
0 g
s
.838 .69 .699 r
.31454 .58608 m .33385 .54366 L .36282 .56138 L p F P
0 g
s
.838 .69 .699 r
.36282 .56138 m .34661 .60508 L .31454 .58608 L p F P
0 g
s
.831 .615 .611 r
.32723 .69167 m .33463 .64879 L .37304 .66491 L p F P
0 g
s
.831 .615 .611 r
.37304 .66491 m .36718 .70796 L .32723 .69167 L p F P
0 g
s
.8 .552 .563 r
.36518 .74887 m .36718 .70796 L .41033 .72035 L p F P
0 g
s
.8 .552 .563 r
.41033 .72035 m .40889 .76108 L .36518 .74887 L p F P
0 g
s
.853 .674 .658 r
.30025 .62905 m .31454 .58608 L .34661 .60508 L p F P
0 g
s
.853 .674 .658 r
.34661 .60508 m .33463 .64879 L .30025 .62905 L p F P
0 g
s
.845 .736 .744 r
.30925 .52304 m .33645 .48416 L .35771 .50263 L p F P
0 g
s
.845 .736 .744 r
.35771 .50263 m .33385 .54366 L .30925 .52304 L p F P
0 g
s
.866 .727 .707 r
.28718 .56392 m .30925 .52304 L .33385 .54366 L p F P
0 g
s
.866 .727 .707 r
.33385 .54366 m .31454 .58608 L .28718 .56392 L p F P
0 g
s
.762 .481 .508 r
.41035 .79847 m .40889 .76108 L .45488 .7693 L p F P
0 g
s
.837 .585 .558 r
.32469 .73281 m .32723 .69167 L .36718 .70796 L p F P
0 g
s
.837 .585 .558 r
.36718 .70796 m .36518 .74887 L .32469 .73281 L p F P
0 g
s
.866 .652 .611 r
.29141 .6717 m .30025 .62905 L .33463 .64879 L p F P
0 g
s
.866 .652 .611 r
.33463 .64879 m .32723 .69167 L .29141 .6717 L p F P
0 g
s
.886 .713 .663 r
.27082 .60598 m .28718 .56392 L .31454 .58608 L p F P
0 g
s
.886 .713 .663 r
.31454 .58608 m .30025 .62905 L .27082 .60598 L p F P
0 g
s
.8 .512 .501 r
.36721 .78671 m .36518 .74887 L .40889 .76108 L p F P
0 g
s
.8 .512 .501 r
.40889 .76108 m .41035 .79847 L .36721 .78671 L p F P
0 g
s
.876 .621 .55 r
.28838 .71311 m .29141 .6717 L .32723 .69167 L p F P
0 g
s
.876 .621 .55 r
.32723 .69167 m .32469 .73281 L .28838 .71311 L p F P
0 g
s
.903 .693 .608 r
.26067 .64835 m .27082 .60598 L .30025 .62905 L p F P
0 g
s
.903 .693 .608 r
.30025 .62905 m .29141 .6717 L .26067 .64835 L p F P
0 g
s
.839 .544 .49 r
.32726 .77125 m .32469 .73281 L .36518 .74887 L p F P
0 g
s
.839 .544 .49 r
.36518 .74887 m .36721 .78671 L .32726 .77125 L p F P
0 g
s
.792 .456 .418 r
.37342 .82052 m .36721 .78671 L .41035 .79847 L p F P
0 g
s
.792 .456 .418 r
.41035 .79847 m .41484 .83156 L .37342 .82052 L p F P
0 g
s
.881 .578 .471 r
.29145 .7523 m .28838 .71311 L .32469 .73281 L p F P
0 g
s
.881 .578 .471 r
.32469 .73281 m .32726 .77125 L .29145 .7523 L p F P
0 g
s
.917 .662 .538 r
.25719 .69007 m .26067 .64835 L .29141 .6717 L p F P
0 g
s
.917 .662 .538 r
.29141 .6717 m .28838 .71311 L .25719 .69007 L p F P
0 g
s
.833 .485 .396 r
.33511 .80602 m .32726 .77125 L .36721 .78671 L p F P
0 g
s
.833 .485 .396 r
.36721 .78671 m .37342 .82052 L .33511 .80602 L p F P
0 g
s
.923 .615 .441 r
.26072 .73014 m .25719 .69007 L .28838 .71311 L p F P
0 g
s
.923 .615 .441 r
.28838 .71311 m .29145 .7523 L .26072 .73014 L p F P
0 g
s
.77 .372 .298 r
.38388 .84931 m .37342 .82052 L .41484 .83156 L p F P
0 g
s
.77 .372 .298 r
.41484 .83156 m .42241 .85939 L .38388 .84931 L p F P
0 g
s
.951 .687 .501 r
.45422 .87005 m .25442 .69746 L .27995 .39389 L p F P
0 g
s
.641 .768 .94 r
.45607 .86955 m .45422 .87005 L .45307 .86905 L p F P
0 g
s
.677 .218 .154 r
.45614 .8696 m .44035 .87739 L .45307 .86905 L F
.45607 .86955 m .45307 .86905 L .45426 .86827 L F
.45614 .8696 m .45307 .86905 L .45607 .86955 L F
.951 .687 .501 r
.46026 .58417 m .45426 .86827 L p .45924 .58158 L F P
0 g
s
.951 .687 .501 r
.45924 .58158 m .45426 .86827 L .45425 .86828 L F
.754 .624 .715 r
.43073 .58697 m .4423 .54159 L .4751 .54833 L p F P
0 g
s
.777 .647 .719 r
.39538 .5759 m .41133 .5316 L .4423 .54159 L p F P
0 g
s
.777 .647 .719 r
.4423 .54159 m .43073 .58697 L .39538 .5759 L p F P
0 g
s
.766 .664 .75 r
.45593 .4971 m .4423 .54159 L .41133 .5316 L p F P
0 g
s
.785 .629 .687 r
.38252 .62061 m .39538 .5759 L .43073 .58697 L p F P
0 g
s
.785 .629 .687 r
.43073 .58697 m .42143 .63244 L .38252 .62061 L p F P
0 g
s
.766 .664 .75 r
.41133 .5316 m .43008 .48853 L .45593 .4971 L p F P
0 g
s
.799 .674 .725 r
.36282 .56138 m .3829 .51854 L .41133 .5316 L p F P
0 g
s
.799 .674 .725 r
.41133 .5316 m .39538 .5759 L .36282 .56138 L p F P
0 g
s
.785 .687 .756 r
.43008 .48853 m .41133 .5316 L .3829 .51854 L p F P
0 g
s
.785 .687 .756 r
.3829 .51854 m .40645 .47734 L .43008 .48853 L p F P
0 g
s
.804 .713 .765 r
.40645 .47734 m .3829 .51854 L .35771 .50263 L p F P
0 g
s
.804 .713 .765 r
.35771 .50263 m .38562 .46375 L .40645 .47734 L p F P
0 g
s
.822 .742 .776 r
.33645 .48416 m .36816 .44803 L .38562 .46375 L p F P
0 g
s
.822 .742 .776 r
.38562 .46375 m .35771 .50263 L .33645 .48416 L p F P
0 g
s
.951 .687 .501 r
.27995 .39389 m .45924 .58158 L p .45425 .86828 L F P
0 g
s
.951 .687 .501 r
.27995 .39389 m .45425 .86828 L .4537 .86864 L F
.235 0 .194 r
.70389 .83601 m .71712 .80594 L .75138 .78816 L p F P
0 g
s
.2 0 .301 r
.79147 .73003 m .78071 .76739 L .75138 .78816 L p F P
0 g
s
.235 0 .194 r
.75138 .78816 m .73561 .81982 L .70389 .83601 L p F P
0 g
s
.054 0 .092 r
.73561 .81982 m .75138 .78816 L .78071 .76739 L p F P
0 g
s
.054 0 .092 r
.78071 .76739 m .76265 .80094 L .73561 .81982 L p F P
0 g
s
0 0 0 r
.76265 .80094 m .78071 .76739 L .8042 .74398 L p F P
0 g
s
0 0 0 r
.8042 .74398 m .78419 .77971 L .76265 .80094 L p F P
0 g
s
0 0 0 r
.73743 .82957 m .76265 .80094 L .78419 .77971 L p F P
0 g
s
0 0 0 r
.78419 .77971 m .75632 .811 L .73743 .82957 L p F P
0 g
s
.562 .35 .551 r
.4611 .58318 m .45426 .86828 L .7809 .78216 L F
0 0 0 r
.78419 .77971 m .8042 .74398 L .82102 .7184 L p F P
0 g
s
0 0 0 r
.82102 .7184 m .79946 .75655 L .78419 .77971 L p F P
0 g
s
.697 .919 .586 r
.78419 .77971 m .78586 .77718 L p .78089 .78217 L F P
0 g
s
.697 .919 .586 r
.78284 .77977 m .78089 .78217 L .78586 .77718 L F
.77776 .78692 m .78419 .77971 L p .78089 .78217 L F P
0 g
s
.754 .624 .715 r
.47171 .57061 m .46972 .58369 L p .46198 .58213 L F P
0 g
s
.65 .514 .684 r
.5898 .64038 m .58415 .59441 L .6215 .58693 L p F P
0 g
s
.657 .544 .715 r
.58415 .59441 m .57712 .54831 L .60991 .54155 L p F P
0 g
s
.657 .544 .715 r
.60991 .54155 m .6215 .58693 L .58415 .59441 L p F P
0 g
s
.663 .574 .745 r
.57712 .54831 m .56883 .50287 L .59626 .49706 L p F P
0 g
s
.663 .574 .745 r
.59626 .49706 m .60991 .54155 L .57712 .54831 L p F P
0 g
s
.65 .514 .684 r
.6215 .58693 m .63082 .6324 L .5898 .64038 L p F P
0 g
s
.629 .527 .719 r
.6215 .58693 m .60991 .54155 L .64087 .53155 L p F P
0 g
s
.639 .56 .75 r
.60991 .54155 m .59626 .49706 L .62209 .48848 L p F P
0 g
s
.639 .56 .75 r
.62209 .48848 m .64087 .53155 L .60991 .54155 L p F P
0 g
s
.619 .493 .687 r
.63082 .6324 m .6215 .58693 L .65684 .57584 L p F P
0 g
s
.629 .527 .719 r
.64087 .53155 m .65684 .57584 L .6215 .58693 L p F P
0 g
s
.606 .456 .652 r
.63769 .67713 m .63082 .6324 L .66971 .62054 L p F P
0 g
s
.619 .493 .687 r
.65684 .57584 m .66971 .62054 L .63082 .6324 L p F P
0 g
s
.6 .511 .725 r
.65684 .57584 m .64087 .53155 L .66929 .51847 L p F P
0 g
s
.614 .548 .756 r
.64087 .53155 m .62209 .48848 L .64572 .47728 L p F P
0 g
s
.614 .548 .756 r
.64572 .47728 m .66929 .51847 L .64087 .53155 L p F P
0 g
s
.584 .472 .692 r
.66971 .62054 m .65684 .57584 L .68939 .56131 L p F P
0 g
s
.6 .511 .725 r
.66929 .51847 m .68939 .56131 L .65684 .57584 L p F P
0 g
s
.606 .456 .652 r
.66971 .62054 m .67921 .66485 L .63769 .67713 L p F P
0 g
s
.566 .43 .655 r
.67921 .66485 m .66971 .62054 L .70561 .605 L p F P
0 g
s
.584 .472 .692 r
.68939 .56131 m .70561 .605 L .66971 .62054 L p F P
0 g
s
.567 .495 .734 r
.68939 .56131 m .66929 .51847 L .69446 .50255 L p F P
0 g
s
.587 .536 .765 r
.66929 .51847 m .64572 .47728 L .66653 .46368 L p F P
0 g
s
.587 .536 .765 r
.66653 .46368 m .69446 .50255 L .66929 .51847 L p F P
0 g
s
.545 .45 .699 r
.70561 .605 m .68939 .56131 L .71833 .54357 L p F P
0 g
s
.567 .495 .734 r
.69446 .50255 m .71833 .54357 L .68939 .56131 L p F P
0 g
s
.546 .383 .611 r
.68507 .7079 m .67921 .66485 L .7176 .64871 L p F P
0 g
s
.566 .43 .655 r
.70561 .605 m .7176 .64871 L .67921 .66485 L p F P
0 g
s
.52 .402 .658 r
.7176 .64871 m .70561 .605 L .73766 .58598 L p F P
0 g
s
.545 .45 .699 r
.71833 .54357 m .73766 .58598 L .70561 .605 L p F P
0 g
s
.529 .479 .744 r
.71833 .54357 m .69446 .50255 L .7157 .48407 L p F P
0 g
s
.499 .427 .707 r
.73766 .58598 m .71833 .54357 L .74291 .52294 L p F P
0 g
s
.529 .479 .744 r
.7157 .48407 m .74291 .52294 L .71833 .54357 L p F P
0 g
s
.546 .383 .611 r
.7176 .64871 m .72501 .69159 L .68507 .7079 L p F P
0 g
s
.491 .345 .611 r
.72501 .69159 m .7176 .64871 L .75196 .62895 L p F P
0 g
s
.52 .402 .658 r
.73766 .58598 m .75196 .62895 L .7176 .64871 L p F P
0 g
s
.464 .369 .663 r
.75196 .62895 m .73766 .58598 L .76499 .56381 L p F P
0 g
s
.499 .427 .707 r
.74291 .52294 m .76499 .56381 L .73766 .58598 L p F P
0 g
s
.485 .462 .757 r
.74291 .52294 m .7157 .48407 L .73237 .4634 L p F P
0 g
s
.443 .401 .717 r
.76499 .56381 m .74291 .52294 L .76237 .49979 L p F P
0 g
s
.485 .462 .757 r
.73237 .4634 m .76237 .49979 L .74291 .52294 L p F P
0 g
s
.454 .277 .55 r
.72755 .73273 m .72501 .69159 L .76081 .6716 L p F P
0 g
s
.491 .345 .611 r
.75196 .62895 m .76081 .6716 L .72501 .69159 L p F P
0 g
s
.422 .3 .608 r
.76081 .6716 m .75196 .62895 L .78137 .60587 L p F P
0 g
s
.464 .369 .663 r
.76499 .56381 m .78137 .60587 L .75196 .62895 L p F P
0 g
s
.433 .446 .773 r
.75804 .48603 m .75808 .48614 L .74681 .48092 L F
.76237 .49979 m .75533 .49126 L p .75808 .48614 L F P
0 g
s
.433 .446 .773 r
.75533 .49126 m .74681 .48092 L p .75808 .48614 L F P
0 g
s
.433 .446 .773 r
.73237 .4634 m .74343 .44189 L p .75804 .48603 L F P
0 g
s
.433 .446 .773 r
.74343 .44189 m .74389 .441 L p .74831 .45507 L F P
0 g
s
.433 .446 .773 r
.74831 .45507 m .75804 .48603 L .74343 .44189 L F
.74681 .48092 m .73237 .4634 L p .75804 .48603 L F P
0 g
s
.754 .624 .715 r
.4751 .54833 m .47171 .57061 L p .45637 .57428 L F P
0 g
s
.754 .624 .715 r
.4751 .54833 m .45637 .57428 L .45354 .56711 L F
.747 .643 .745 r
.48336 .50289 m .4751 .54833 L .4423 .54159 L p F P
0 g
s
.727 .623 .743 r
.4751 .54833 m .48336 .50289 L .51174 .50582 L p F P
0 g
s
.721 .645 .772 r
.51488 .46127 m .51174 .50582 L .48336 .50289 L p F P
0 g
s
.704 .63 .772 r
.51174 .50582 m .51488 .46127 L .53728 .46127 L p F P
0 g
s
.704 .63 .772 r
.53728 .46127 m .54045 .50581 L .51174 .50582 L p F P
0 g
s
.686 .616 .772 r
.54045 .50581 m .53728 .46127 L .55943 .45892 L p F P
0 g
s
.686 .616 .772 r
.55943 .45892 m .56883 .50287 L .54045 .50581 L p F P
0 g
s
.747 .643 .745 r
.4423 .54159 m .45593 .4971 L .48336 .50289 L p F P
0 g
s
.738 .661 .775 r
.49274 .45894 m .48336 .50289 L .45593 .4971 L p F P
0 g
s
.721 .645 .772 r
.48336 .50289 m .49274 .45894 L .51488 .46127 L p F P
0 g
s
.667 .604 .775 r
.56883 .50287 m .55943 .45892 L .58078 .45428 L p F P
0 g
s
.667 .604 .775 r
.58078 .45428 m .59626 .49706 L .56883 .50287 L p F P
0 g
s
.753 .68 .78 r
.47137 .4543 m .45593 .4971 L .43008 .48853 L p F P
0 g
s
.738 .661 .775 r
.45593 .4971 m .47137 .4543 L .49274 .45894 L p F P
0 g
s
.648 .593 .78 r
.59626 .49706 m .58078 .45428 L .60084 .44743 L p F P
0 g
s
.648 .593 .78 r
.60084 .44743 m .62209 .48848 L .59626 .49706 L p F P
0 g
s
.713 .667 .803 r
.51834 .41893 m .51488 .46127 L .49274 .45894 L p F P
0 g
s
.7 .655 .802 r
.51488 .46127 m .51834 .41893 L .53379 .41893 L p F P
0 g
s
.7 .655 .802 r
.53379 .41893 m .53728 .46127 L .51488 .46127 L p F P
0 g
s
.686 .645 .803 r
.53728 .46127 m .53379 .41893 L .54904 .41727 L p F P
0 g
s
.686 .645 .803 r
.54904 .41727 m .55943 .45892 L .53728 .46127 L p F P
0 g
s
.726 .68 .806 r
.50309 .41729 m .49274 .45894 L .47137 .4543 L p F P
0 g
s
.713 .667 .803 r
.49274 .45894 m .50309 .41729 L .51834 .41893 L p F P
0 g
s
.671 .635 .806 r
.55943 .45892 m .54904 .41727 L .56373 .414 L p F P
0 g
s
.671 .635 .806 r
.56373 .414 m .58078 .45428 L .55943 .45892 L p F P
0 g
s
.769 .699 .786 r
.45131 .44747 m .43008 .48853 L .40645 .47734 L p F P
0 g
s
.753 .68 .78 r
.43008 .48853 m .45131 .44747 L .47137 .4543 L p F P
0 g
s
.627 .584 .786 r
.62209 .48848 m .60084 .44743 L .61911 .43852 L p F P
0 g
s
.627 .584 .786 r
.61911 .43852 m .64572 .47728 L .62209 .48848 L p F P
0 g
s
.738 .694 .81 r
.4884 .41402 m .47137 .4543 L .45131 .44747 L p F P
0 g
s
.726 .68 .806 r
.47137 .4543 m .4884 .41402 L .50309 .41729 L p F P
0 g
s
.656 .628 .81 r
.58078 .45428 m .56373 .414 L .57748 .40919 L p F P
0 g
s
.656 .628 .81 r
.57748 .40919 m .60084 .44743 L .58078 .45428 L p F P
0 g
s
.769 .699 .786 r
.40645 .47734 m .43303 .43856 L .45131 .44747 L p F P
0 g
s
.749 .71 .815 r
.47465 .40922 m .45131 .44747 L .43303 .43856 L p F P
0 g
s
.738 .694 .81 r
.45131 .44747 m .47465 .40922 L .4884 .41402 L p F P
0 g
s
.783 .721 .794 r
.43303 .43856 m .40645 .47734 L .38562 .46375 L p F P
0 g
s
.606 .576 .794 r
.64572 .47728 m .61911 .43852 L .63511 .42773 L p F P
0 g
s
.606 .576 .794 r
.63511 .42773 m .66653 .46368 L .64572 .47728 L p F P
0 g
s
.783 .721 .794 r
.38562 .46375 m .41702 .42778 L .43303 .43856 L p F P
0 g
s
.759 .726 .822 r
.46218 .40297 m .43303 .43856 L .41702 .42778 L p F P
0 g
s
.749 .71 .815 r
.43303 .43856 m .46218 .40297 L .47465 .40922 L p F P
0 g
s
.796 .744 .805 r
.41702 .42778 m .38562 .46375 L .36816 .44803 L p F P
0 g
s
.557 .526 .776 r
.69446 .50255 m .66653 .46368 L .68398 .44795 L p F P
0 g
s
.557 .526 .776 r
.68398 .44795 m .7157 .48407 L .69446 .50255 L p F P
0 g
s
.796 .744 .805 r
.36816 .44803 m .4037 .41536 L .41702 .42778 L p F P
0 g
s
.767 .744 .832 r
.45132 .39544 m .41702 .42778 L .4037 .41536 L p F P
0 g
s
.759 .726 .822 r
.41702 .42778 m .45132 .39544 L .46218 .40297 L p F P
0 g
s
.523 .516 .79 r
.7157 .48407 m .68398 .44795 L .69752 .43043 L p F P
0 g
s
.523 .516 .79 r
.69752 .43043 m .73237 .4634 L .7157 .48407 L p F P
0 g
s
.666 .737 .903 r
.76001 .48545 m .75812 .48606 L p .75859 .48518 L F P
0 g
s
.562 .35 .551 r
.76013 .48697 m .76001 .48545 L .75812 .48606 L p F P
0 g
s
.666 .737 .903 r
.75911 .48421 m .76001 .48545 L p .75859 .48518 L F P
0 g
s
.976 .679 .381 r
.75911 .48421 m .76001 .48545 L .76013 .48697 L p F P
0 g
s
.433 .446 .773 r
.75808 .48614 m .75948 .48523 L .76237 .49979 L F
.77602 .4746 m .76386 .49704 L p .75948 .48523 L F P
0 g
s
.433 .446 .773 r
.76386 .49704 m .76237 .49979 L p .75948 .48523 L F P
0 g
s
.433 .446 .773 r
.74389 .441 m .76847 .46671 L p .75808 .48614 L F P
0 g
s
.433 .446 .773 r
.76847 .46671 m .77602 .4746 L p .75808 .48614 L F P
0 g
s
.64 .621 .815 r
.60084 .44743 m .57748 .40919 L .58994 .40294 L p F P
0 g
s
.64 .621 .815 r
.58994 .40294 m .61911 .43852 L .60084 .44743 L p F P
0 g
s
.701 .69 .836 r
.52208 .37966 m .51834 .41893 L .50309 .41729 L p F P
0 g
s
.693 .682 .835 r
.51834 .41893 m .52208 .37966 L .53002 .37966 L p F P
0 g
s
.693 .682 .835 r
.53002 .37966 m .53379 .41893 L .51834 .41893 L p F P
0 g
s
.683 .675 .836 r
.53379 .41893 m .53002 .37966 L .53785 .37879 L p F P
0 g
s
.683 .675 .836 r
.53785 .37879 m .54904 .41727 L .53379 .41893 L p F P
0 g
s
.71 .699 .838 r
.51425 .3788 m .50309 .41729 L .4884 .41402 L p F P
0 g
s
.701 .69 .836 r
.50309 .41729 m .51425 .3788 L .52208 .37966 L p F P
0 g
s
.673 .669 .838 r
.54904 .41727 m .53785 .37879 L .54537 .37708 L p F P
0 g
s
.673 .669 .838 r
.54537 .37708 m .56373 .414 L .54904 .41727 L p F P
0 g
s
.624 .617 .823 r
.61911 .43852 m .58994 .40294 L .60079 .3954 L p F P
0 g
s
.624 .617 .823 r
.60079 .3954 m .63511 .42773 L .61911 .43852 L p F P
0 g
s
.717 .708 .841 r
.50673 .37709 m .4884 .41402 L .47465 .40922 L p F P
0 g
s
.71 .699 .838 r
.4884 .41402 m .50673 .37709 L .51425 .3788 L p F P
0 g
s
.663 .664 .841 r
.56373 .414 m .54537 .37708 L .55239 .37456 L p F P
0 g
s
.663 .664 .841 r
.55239 .37456 m .57748 .40919 L .56373 .414 L p F P
0 g
s
.724 .719 .845 r
.4997 .37458 m .47465 .40922 L .46218 .40297 L p F P
0 g
s
.717 .708 .841 r
.47465 .40922 m .4997 .37458 L .50673 .37709 L p F P
0 g
s
.653 .661 .845 r
.57748 .40919 m .55239 .37456 L .55872 .37131 L p F P
0 g
s
.653 .661 .845 r
.55872 .37131 m .58994 .40294 L .57748 .40919 L p F P
0 g
s
.583 .57 .805 r
.66653 .46368 m .63511 .42773 L .64842 .4153 L p F P
0 g
s
.583 .57 .805 r
.64842 .4153 m .68398 .44795 L .66653 .46368 L p F P
0 g
s
.608 .614 .832 r
.63511 .42773 m .60079 .3954 L .60973 .38675 L p F P
0 g
s
.608 .614 .832 r
.60973 .38675 m .64842 .4153 L .63511 .42773 L p F P
0 g
s
.73 .729 .85 r
.49337 .37132 m .46218 .40297 L .45132 .39544 L p F P
0 g
s
.724 .719 .845 r
.46218 .40297 m .49337 .37132 L .4997 .37458 L p F P
0 g
s
.643 .659 .85 r
.58994 .40294 m .55872 .37131 L .5642 .36739 L p F P
0 g
s
.643 .659 .85 r
.5642 .36739 m .60079 .3954 L .58994 .40294 L p F P
0 g
s
.767 .744 .832 r
.4037 .41536 m .44237 .38679 L .45132 .39544 L p F P
0 g
s
.735 .741 .856 r
.48789 .36741 m .45132 .39544 L .44237 .38679 L p F P
0 g
s
.73 .729 .85 r
.45132 .39544 m .48789 .36741 L .49337 .37132 L p F P
0 g
s
.633 .658 .857 r
.60079 .3954 m .5642 .36739 L .56866 .36292 L p F P
0 g
s
.633 .658 .857 r
.56866 .36292 m .60973 .38675 L .60079 .3954 L p F P
0 g
s
.684 .715 .872 r
.52603 .34435 m .52208 .37966 L .51425 .3788 L closepath p F P
0 g
s
.681 .712 .872 r
.52603 .34435 m .53002 .37966 L .52208 .37966 L closepath p F P
0 g
s
.677 .709 .872 r
.52603 .34435 m .53785 .37879 L .53002 .37966 L closepath p F P
0 g
s
.687 .718 .873 r
.52603 .34435 m .51425 .3788 L .50673 .37709 L closepath p F P
0 g
s
.674 .707 .873 r
.52603 .34435 m .54537 .37708 L .53785 .37879 L closepath p F P
0 g
s
.69 .722 .874 r
.52603 .34435 m .50673 .37709 L .4997 .37458 L closepath p F P
0 g
s
.67 .705 .874 r
.52603 .34435 m .55239 .37456 L .54537 .37708 L closepath p F P
0 g
s
.558 .566 .818 r
.68398 .44795 m .64842 .4153 L .65862 .4015 L p F P
0 g
s
.591 .613 .842 r
.64842 .4153 m .60973 .38675 L .61649 .37719 L p F P
0 g
s
.591 .613 .842 r
.61649 .37719 m .65862 .4015 L .64842 .4153 L p F P
0 g
s
.558 .566 .818 r
.65862 .4015 m .69752 .43043 L .68398 .44795 L p F P
0 g
s
.692 .726 .876 r
.52603 .34435 m .4997 .37458 L .49337 .37132 L closepath p F P
0 g
s
.666 .704 .876 r
.52603 .34435 m .55872 .37131 L .55239 .37456 L closepath p F P
0 g
s
.735 .741 .856 r
.44237 .38679 m .48342 .36294 L .48789 .36741 L p F P
0 g
s
.623 .659 .864 r
.60973 .38675 m .56866 .36292 L .57199 .358 L p F P
0 g
s
.623 .659 .864 r
.57199 .358 m .61649 .37719 L .60973 .38675 L p F P
0 g
s
.694 .729 .878 r
.52603 .34435 m .49337 .37132 L .48789 .36741 L closepath p F P
0 g
s
.662 .704 .878 r
.52603 .34435 m .5642 .36739 L .55872 .37131 L closepath p F P
0 g
s
.695 .733 .88 r
.52603 .34435 m .48789 .36741 L .48342 .36294 L closepath p F P
0 g
s
.659 .704 .88 r
.52603 .34435 m .56866 .36292 L .5642 .36739 L closepath p F P
0 g
s
.656 .705 .883 r
.52603 .34435 m .57199 .358 L .56866 .36292 L closepath p F P
0 g
s
.531 .564 .834 r
.69752 .43043 m .65862 .4015 L .6654 .38668 L p F P
0 g
s
.574 .614 .855 r
.65862 .4015 m .61649 .37719 L .62088 .36697 L p F P
0 g
s
.574 .614 .855 r
.62088 .36697 m .6654 .38668 L .65862 .4015 L p F P
0 g
s
.614 .661 .872 r
.61649 .37719 m .57199 .358 L .57409 .35277 L p F P
0 g
s
.614 .661 .872 r
.57409 .35277 m .62088 .36697 L .61649 .37719 L p F P
0 g
s
.485 .509 .807 r
.73237 .4634 m .69752 .43043 L .70672 .41151 L p F P
0 g
s
.531 .564 .834 r
.6654 .38668 m .70672 .41151 L .69752 .43043 L p F P
0 g
s
.653 .706 .886 r
.52603 .34435 m .57409 .35277 L .57199 .358 L closepath p F P
0 g
s
.605 .665 .882 r
.62088 .36697 m .57409 .35277 L .57489 .34736 L p F P
0 g
s
.65 .708 .889 r
.52603 .34435 m .57489 .34736 L .57409 .35277 L closepath p F P
0 g
s
.557 .618 .869 r
.6654 .38668 m .62088 .36697 L .62272 .35635 L p F P
0 g
s
.605 .665 .882 r
.57489 .34736 m .62272 .35635 L .62088 .36697 L p F P
0 g
s
.485 .509 .807 r
.70672 .41151 m .74389 .441 L .73237 .4634 L p F P
0 g
s
.649 .71 .893 r
.52603 .34435 m .57436 .34192 L .57489 .34736 L closepath p F P
0 g
s
.647 .713 .896 r
.52603 .34435 m .5725 .3366 L .57436 .34192 L closepath p F P
0 g
s
.647 .717 .899 r
.52603 .34435 m .56935 .33154 L .5725 .3366 L closepath p F P
0 g
s
.597 .671 .891 r
.62272 .35635 m .57489 .34736 L .57436 .34192 L p F P
0 g
s
.503 .565 .852 r
.70672 .41151 m .6654 .38668 L .66849 .37118 L p F P
0 g
s
.557 .618 .869 r
.62272 .35635 m .66849 .37118 L .6654 .38668 L p F P
0 g
s
.597 .671 .891 r
.57436 .34192 m .62194 .3456 L .62272 .35635 L p F P
0 g
s
.591 .679 .902 r
.62194 .3456 m .57436 .34192 L .5725 .3366 L p F P
0 g
s
.54 .625 .885 r
.66849 .37118 m .62272 .35635 L .62194 .3456 L p F P
0 g
s
.503 .565 .852 r
.66849 .37118 m .71118 .39164 L .70672 .41151 L p F P
0 g
s
.591 .679 .902 r
.5725 .3366 m .6185 .33503 L .62194 .3456 L p F P
0 g
s
.586 .688 .912 r
.6185 .33503 m .5725 .3366 L .56935 .33154 L p F P
0 g
s
.586 .688 .912 r
.56935 .33154 m .61246 .32494 L .6185 .33503 L p F P
0 g
s
.472 .569 .872 r
.71118 .39164 m .66849 .37118 L .66772 .35543 L p F P
0 g
s
.54 .625 .885 r
.62194 .3456 m .66772 .35543 L .66849 .37118 L p F P
0 g
s
.524 .635 .902 r
.66772 .35543 m .62194 .3456 L .6185 .33503 L p F P
0 g
s
.524 .635 .902 r
.6185 .33503 m .663 .33986 L .66772 .35543 L p F P
0 g
s
.509 .648 .919 r
.663 .33986 m .6185 .33503 L .61246 .32494 L p F P
0 g
s
.509 .648 .919 r
.61246 .32494 m .65437 .32491 L .663 .33986 L p F P
0 g
s
.666 .737 .903 r
.27995 .39389 m .60395 .27269 L .75911 .48421 L p F P
0 g
s
.666 .737 .903 r
.27995 .39389 m .75911 .48421 L .75859 .48518 L F
.27995 .39389 m .75859 .48518 L .46198 .58213 L F
.75812 .48606 m .46198 .58213 L p .75859 .48518 L F P
0 g
s
.392 .33 .667 r
.78137 .60587 m .76499 .56381 L .78679 .53887 L p F P
0 g
s
.443 .401 .717 r
.76237 .49979 m .78679 .53887 L .76499 .56381 L p F P
0 g
s
.454 .277 .55 r
.76081 .6716 m .76384 .71301 L .72755 .73273 L p F P
0 g
s
.369 .215 .537 r
.76384 .71301 m .76081 .6716 L .79152 .64823 L p F P
0 g
s
.422 .3 .608 r
.78137 .60587 m .79152 .64823 L .76081 .6716 L p F P
0 g
s
.299 .105 .441 r
.76077 .75221 m .76384 .71301 L .795 .68995 L p F P
0 g
s
.369 .215 .537 r
.79152 .64823 m .795 .68995 L .76384 .71301 L p F P
0 g
s
.299 .105 .441 r
.795 .68995 m .79147 .73003 L .76077 .75221 L p F P
0 g
s
0 0 .202 r
.78071 .76739 m .79147 .73003 L .81615 .70501 L p F P
0 g
s
0 0 .202 r
.81615 .70501 m .8042 .74398 L .78071 .76739 L p F P
0 g
s
.562 .35 .551 r
.78298 .78161 m .76013 .48697 L p .46198 .58213 L F P
0 g
s
.562 .35 .551 r
.75812 .48606 m .46198 .58213 L p .76013 .48697 L F P
0 g
s
.976 .679 .381 r
.60395 .27269 m .75911 .48421 L p .78284 .77977 L F P
0 g
s
.976 .679 .381 r
.76013 .48697 m .78284 .77977 L p .75911 .48421 L F P
0 g
s
.976 .679 .381 r
.60395 .27269 m .78284 .77977 L .78245 .7801 L F
.562 .35 .551 r
.4611 .58318 m .7809 .78216 L .78189 .78094 L F
.677 .218 .154 r
.46305 .86619 m .4695 .88699 L .43306 .88099 L p F P
0 g
s
.562 .35 .551 r
.45607 .86955 m .78298 .78161 L p .45426 .86828 L F P
0 g
s
.641 .768 .94 r
.25442 .69746 m .78142 .78136 L .45607 .86955 L F
.78089 .78217 m .45607 .86955 L p .78142 .78136 L F P
0 g
s
.562 .35 .551 r
.4611 .58318 m .78298 .78161 L .46198 .58213 L F
.697 .919 .586 r
.78993 .77101 m .79946 .75655 L p .78606 .77432 L F P
0 g
s
.641 .768 .94 r
.25442 .69746 m .61262 .58472 L .782 .78048 L p F P
0 g
s
.641 .768 .94 r
.25442 .69746 m .782 .78048 L .78142 .78136 L F
.976 .679 .381 r
.61262 .58472 m .60395 .27269 L p .78245 .7801 L F P
0 g
s
.976 .679 .381 r
.782 .78048 m .61262 .58472 L p .78245 .7801 L F P
0 g
s
.697 .919 .586 r
.78606 .77432 m .78089 .78217 L .78993 .77101 L F
.976 .679 .381 r
.78298 .78161 m .782 .78048 L p .78245 .7801 L F P
0 g
s
.697 .919 .586 r
.782 .78048 m .76989 .79576 L .78089 .78217 L F
.78606 .77432 m .78034 .78191 L .782 .78048 L F
.78034 .78191 m .76989 .79576 L .782 .78048 L F
.562 .35 .551 r
.78189 .78094 m .7809 .78216 L .78298 .78161 L F
.641 .768 .94 r
.782 .78048 m .78298 .78161 L p .78142 .78136 L F P
0 g
s
.976 .679 .381 r
.78284 .77977 m .78298 .78161 L p .78245 .7801 L F P
0 g
s
.697 .919 .586 r
.78586 .77718 m .78993 .77101 L p .78284 .77977 L F P
0 g
s
.697 .919 .586 r
.76989 .79576 m .77776 .78692 L p .78089 .78217 L F P
0 g
s
.641 .768 .94 r
.78298 .78161 m .78089 .78217 L p .78142 .78136 L F P
0 g
s
.697 .919 .586 r
.75632 .811 m .76989 .79576 L p .79946 .75655 L F P
0 g
s
.641 .768 .94 r
.45307 .86905 m .25442 .69746 L p .45607 .86955 L F P
0 g
s
.677 .218 .154 r
.43306 .88099 m .42485 .86435 L p .44434 .8676 L F P
0 g
s
.677 .218 .154 r
.42485 .86435 m .42241 .85939 L p .44434 .8676 L F P
0 g
s
.666 .737 .903 r
.45924 .58158 m .27995 .39389 L p .46198 .58213 L F P
0 g
s
.26536 .53899 m
.26754 .54148 L
s
.442 .503 .826 r
.74389 .441 m .70672 .41151 L .71118 .39164 L p F P
0 g
s
.26536 .53899 m
.26812 .53458 L
s
.372 .371 .729 r
.78679 .53887 m .76237 .49979 L .77602 .4746 L p F P
0 g
s
.43354 .33508 m
.43687 .33519 L
s
.43957 .32499 m
.45703 .32765 L
s
.24722 .57998 m
.26285 .5972 L
s
.331 .242 .602 r
.79152 .64823 m .78137 .60587 L .80493 .57986 L p F P
0 g
s
.392 .33 .667 r
.78679 .53887 m .80493 .57986 L .78137 .60587 L p F P
0 g
s
.43304 .33662 m
.43354 .33508 L
s
.44807 .31567 m
.47121 .32235 L
s
.369 .428 .791 r
.77602 .4746 m .74389 .441 L .74976 .41738 L p F P
0 g
s
.442 .503 .826 r
.71118 .39164 m .74976 .41738 L .74389 .441 L p F P
0 g
s
.45883 .3074 m
.48236 .31818 L
s
.589 .234 .336 r
.59379 .83897 m .5892 .86616 L .54729 .86959 L p F P
0 g
s
.529 .182 .323 r
.5892 .86616 m .59379 .83897 L .63742 .83152 L p F P
0 g
s
.24986 .51179 m
.26536 .53899 L
s
.24722 .57998 m
.26536 .53899 L
s
.298 .28 .67 r
.80493 .57986 m .78679 .53887 L .80225 .51166 L p F P
0 g
s
.372 .371 .729 r
.77602 .4746 m .80225 .51166 L .78679 .53887 L p F P
0 g
s
.43354 .33508 m
.43957 .32499 L
s
.38903 .33993 m
.43354 .33508 L
s
.47156 .30044 m
.49197 .31458 L
s
.391 .499 .849 r
.74976 .41738 m .71118 .39164 L .71063 .37134 L p F P
0 g
s
.472 .569 .872 r
.66772 .35543 m .71063 .37134 L .71118 .39164 L p F P
0 g
s
.4859 .29502 m
.50096 .31122 L
s
.38456 .35476 m
.38903 .33993 L
s
.44 .577 .894 r
.71063 .37134 m .66772 .35543 L .663 .33986 L p F P
0 g
s
.50144 .29129 m
.5101 .3078 L
s
.54964 .29301 m
.55054 .29128 L
s
.51773 .2894 m
.52021 .30401 L
s
.53257 .29939 m
.53426 .2894 L
s
.529 .182 .323 r
.63742 .83152 m .62983 .85936 L .5892 .86616 L p F P
0 g
s
.456 .115 .298 r
.62983 .85936 m .63742 .83152 L .67883 .82046 L p F P
0 g
s
.26883 .44807 m
.27385 .46648 L
s
.24986 .51179 m
.27276 .47944 L
s
.43957 .32499 m
.44807 .31567 L
s
.39764 .32498 m
.43957 .32499 L
s
.28 .334 .74 r
.80225 .51166 m .77602 .4746 L .78325 .44795 L p F P
0 g
s
.369 .428 .791 r
.74976 .41738 m .78325 .44795 L .77602 .4746 L p F P
0 g
s
.23596 .62199 m
.25872 .64627 L
s
.252 .131 .514 r
.795 .68995 m .79152 .64823 L .8162 .62186 L p F P
0 g
s
.331 .242 .602 r
.80493 .57986 m .8162 .62186 L .79152 .64823 L p F P
0 g
s
.874 .513 .36 r
.30083 .78825 m .29145 .7523 L .32726 .77125 L p F P
0 g
s
.874 .513 .36 r
.32726 .77125 m .33511 .80602 L .30083 .78825 L p F P
0 g
s
.26883 .44807 m
.27594 .44158 L
s
.289 .408 .81 r
.78325 .44795 m .74976 .41738 L .7496 .39314 L p F P
0 g
s
.391 .499 .849 r
.71063 .37134 m .7496 .39314 L .74976 .41738 L p F P
0 g
s
.23032 .55155 m
.24722 .57998 L
s
.24722 .57998 m
.23596 .62199 L
s
.204 .163 .587 r
.8162 .62186 m .80493 .57986 L .82181 .55142 L p F P
0 g
s
.298 .28 .67 r
.80225 .51166 m .82181 .55142 L .80493 .57986 L p F P
0 g
s
.44807 .31567 m
.45883 .3074 L
s
.40999 .31111 m
.44807 .31567 L
s
.63289 .31214 m
.64201 .31105 L
s
.38903 .33993 m
.39764 .32498 L
s
.3471 .35127 m
.38903 .33993 L
s
.44 .577 .894 r
.663 .33986 m .70492 .35117 L .71063 .37134 L p F P
0 g
s
.407 .588 .917 r
.70492 .35117 m .663 .33986 L .65437 .32491 L p F P
0 g
s
.34159 .37083 m
.3471 .35127 L
s
.332 .497 .872 r
.7496 .39314 m .71063 .37134 L .70492 .35117 L p F P
0 g
s
.809 .393 .259 r
.34832 .83608 m .33511 .80602 L .37342 .82052 L p F P
0 g
s
.809 .393 .259 r
.37342 .82052 m .38388 .84931 L .34832 .83608 L p F P
0 g
s
.456 .115 .298 r
.67883 .82046 m .66835 .84926 L .62983 .85936 L p F P
0 g
s
.362 .029 .258 r
.66835 .84926 m .67883 .82046 L .71712 .80594 L p F P
0 g
s
.45883 .3074 m
.47156 .30044 L
s
.42579 .29875 m
.45883 .3074 L
s
.62354 .29939 m
.62619 .29869 L
s
.24139 .48291 m
.24986 .51179 L
s
.24986 .51179 m
.23032 .55155 L
s
.167 .212 .665 r
.82181 .55142 m .80225 .51166 L .81069 .48278 L p F P
0 g
s
.28 .334 .74 r
.78325 .44795 m .81069 .48278 L .80225 .51166 L p F P
0 g
s
.634 .189 .177 r
.50496 .8696 m .50711 .89001 L .4695 .88699 L p F P
0 g
s
.583 .15 .184 r
.50711 .89001 m .50496 .8696 L .54729 .86959 L p F P
0 g
s
.583 .15 .184 r
.54729 .86959 m .54512 .89001 L .50711 .89001 L p F P
0 g
s
.524 .1 .177 r
.54512 .89001 m .54729 .86959 L .5892 .86616 L p F P
0 g
s
.47156 .30044 m
.4859 .29502 L
s
.44464 .28831 m
.47156 .30044 L
s
.39764 .32498 m
.40999 .31111 L
s
.35794 .33181 m
.39764 .32498 L
s
.407 .588 .917 r
.65437 .32491 m .69406 .33172 L .70492 .35117 L p F P
0 g
s
.64226 .32492 m
.65437 .32491 L
s
.64201 .31105 m
.65437 .32491 L
s
.65437 .32491 m
.68337 .32989 L
s
.911 .536 .301 r
.27148 .76749 m .26072 .73014 L .29145 .7523 L p F P
0 g
s
.911 .536 .301 r
.29145 .7523 m .30083 .78825 L .27148 .76749 L p F P
0 g
s
.23209 .66405 m
.25521 .68801 L
s
.25812 .70066 m
.26072 .73014 L
s
.145 0 .388 r
.79147 .73003 m .795 .68995 L .82007 .66393 L p F P
0 g
s
.252 .131 .514 r
.8162 .62186 m .82007 .66393 L .795 .68995 L p F P
0 g
s
.524 .1 .177 r
.5892 .86616 m .58274 .88697 L .54512 .89001 L p F P
0 g
s
.452 .034 .154 r
.58274 .88697 m .5892 .86616 L .62983 .85936 L p F P
0 g
s
.26847 .42061 m
.26883 .44807 L
s
.24139 .48291 m
.26883 .44807 L
s
.157 .285 .746 r
.81069 .48278 m .78325 .44795 L .78358 .42049 L p F P
0 g
s
.289 .408 .81 r
.7496 .39314 m .78358 .42049 L .78325 .44795 L p F P
0 g
s
.4859 .29502 m
.50144 .29129 L
s
.46599 .28014 m
.4859 .29502 L
s
.55054 .29128 m
.55281 .29182 L
s
.21816 .59313 m
.23596 .62199 L
s
.23596 .62199 m
.23209 .66405 L
s
.081 .011 .468 r
.82007 .66393 m .8162 .62186 L .83397 .593 L p F P
0 g
s
.204 .163 .587 r
.82181 .55142 m .83397 .593 L .8162 .62186 L p F P
0 g
s
.841 .406 .195 r
.31659 .8199 m .30083 .78825 L .33511 .80602 L p F P
0 g
s
.841 .406 .195 r
.33511 .80602 m .34832 .83608 L .31659 .8199 L p F P
0 g
s
.362 .029 .258 r
.71712 .80594 m .70389 .83601 L .66835 .84926 L p F P
0 g
s
.3471 .35127 m
.35794 .33181 L
s
.30883 .36905 m
.3471 .35127 L
s
.332 .497 .872 r
.70492 .35117 m .74318 .36893 L .7496 .39314 L p F P
0 g
s
.264 .497 .893 r
.74318 .36893 m .70492 .35117 L .69406 .33172 L p F P
0 g
s
.50144 .29129 m
.51773 .2894 L
s
.53426 .2894 m
.55054 .29128 L
s
.30472 .38463 m
.30883 .36905 L
s
.26847 .42061 m
.27837 .41263 L
s
.187 .383 .825 r
.78358 .42049 m .7496 .39314 L .74318 .36893 L p F P
0 g
s
.51773 .2894 m
.53426 .2894 L
s
.713 .236 .112 r
.39858 .87209 m .38388 .84931 L .42241 .85939 L p F P
0 g
s
.713 .236 .112 r
.42241 .85939 m .43306 .88099 L .39858 .87209 L p F P
0 g
s
.452 .034 .154 r
.62983 .85936 m .61917 .88095 L .58274 .88697 L p F P
0 g
s
.36 0 .112 r
.61917 .88095 m .62983 .85936 L .66835 .84926 L p F P
0 g
s
.40999 .31111 m
.42579 .29875 L
s
.37377 .31367 m
.40999 .31111 L
s
.67055 .31305 m
.67821 .31359 L
s
.64201 .31105 m
.67055 .31305 L
s
.62619 .29869 m
.64201 .31105 L
s
.22089 .5213 m
.23032 .55155 L
s
.23032 .55155 m
.21816 .59313 L
s
.02 .05 .551 r
.83397 .593 m .82181 .55142 L .8312 .52116 L p F P
0 g
s
.167 .212 .665 r
.81069 .48278 m .8312 .52116 L .82181 .55142 L p F P
0 g
s
.74 .241 .045 r
.36685 .86043 m .34832 .83608 L .38388 .84931 L p F P
0 g
s
.74 .241 .045 r
.38388 .84931 m .39858 .87209 L .36685 .86043 L p F P
0 g
s
.36 0 .112 r
.66835 .84926 m .65363 .87204 L .61917 .88095 L p F P
0 g
s
.239 0 .045 r
.65363 .87204 m .66835 .84926 L .70389 .83601 L p F P
0 g
s
.24053 .45306 m
.24139 .48291 L
s
.24139 .48291 m
.22089 .5213 L
s
.42579 .29875 m
.44464 .28831 L
s
.65683 .2974 m
.65771 .29737 L
s
.62619 .29869 m
.65683 .2974 L
s
.62087 .29575 m
.62619 .29869 L
s
0 .116 .639 r
.8312 .52116 m .81069 .48278 L .81152 .45292 L p F P
0 g
s
.157 .285 .746 r
.78358 .42049 m .81152 .45292 L .81069 .48278 L p F P
0 g
s
.35794 .33181 m
.37377 .31367 L
s
.264 .497 .893 r
.69406 .33172 m .73045 .34549 L .74318 .36893 L p F P
0 g
s
.68337 .32989 m
.69406 .33172 L
s
.67821 .31359 m
.69406 .33172 L
s
.23601 .70513 m
.26072 .73014 L
s
.145 0 .388 r
.82007 .66393 m .81615 .70501 L .79147 .73003 L p F P
0 g
s
.856 .403 .093 r
.28952 .80103 m .27148 .76749 L .30083 .78825 L p F P
0 g
s
.26072 .73014 m
.27148 .76749 L
s
.856 .403 .093 r
.30083 .78825 m .31659 .8199 L .28952 .80103 L p F P
0 g
s
.21398 .63556 m
.23209 .66405 L
s
.23209 .66405 m
.23601 .70513 L
s
0 0 .293 r
.81615 .70501 m .82007 .66393 L .83815 .63542 L p F P
0 g
s
.081 .011 .468 r
.83397 .593 m .83815 .63542 L .82007 .66393 L p F P
0 g
s
0 .218 .732 r
.81152 .45292 m .78358 .42049 L .77668 .39296 L p F P
0 g
s
.187 .383 .825 r
.74318 .36893 m .77668 .39296 L .78358 .42049 L p F P
0 g
s
.059 .352 .826 r
.77668 .39296 m .74318 .36893 L .73045 .34549 L p F P
0 g
s
.44464 .28831 m
.46599 .28014 L
s
.61444 .28698 m
.6331 .28362 L
s
.514 0 0 r
.47776 .90046 m .4695 .88699 L .50711 .89001 L p F P
0 g
s
.514 0 0 r
.50711 .89001 m .50988 .90302 L .47776 .90046 L p F P
0 g
s
.462 0 0 r
.50988 .90302 m .50711 .89001 L .54512 .89001 L p F P
0 g
s
.462 0 0 r
.54512 .89001 m .54234 .90301 L .50988 .90302 L p F P
0 g
s
.392 0 0 r
.54234 .90301 m .54512 .89001 L .58274 .88697 L p F P
0 g
s
.20811 .56238 m
.21816 .59313 L
s
.21816 .59313 m
.21398 .63556 L
s
0 0 .377 r
.83815 .63542 m .83397 .593 L .84398 .56224 L p F P
0 g
s
.02 .05 .551 r
.8312 .52116 m .84398 .56224 L .83397 .593 L p F P
0 g
s
.552 .002 0 r
.44671 .89539 m .43306 .88099 L .4695 .88699 L p F P
0 g
s
.552 .002 0 r
.4695 .88699 m .47776 .90046 L .44671 .89539 L p F P
0 g
s
.392 0 0 r
.58274 .88697 m .57444 .90045 L .54234 .90301 L p F P
0 g
s
.303 0 0 r
.57444 .90045 m .58274 .88697 L .61917 .88095 L p F P
0 g
s
.745 .226 0 r
.33865 .8462 m .31659 .8199 L .34832 .83608 L p F P
0 g
s
.745 .226 0 r
.34832 .83608 m .36685 .86043 L .33865 .8462 L p F P
0 g
s
.239 0 .045 r
.70389 .83601 m .68535 .86037 L .65363 .87204 L p F P
0 g
s
.073 0 0 r
.68535 .86037 m .70389 .83601 L .73561 .81982 L p F P
0 g
s
.67821 .31359 m
.71154 .32354 L
s
.65771 .29737 m
.67821 .31359 L
s
.521 .291 .507 r
.61262 .58472 m .60395 .27269 L .27995 .39389 L p F P
0 g
s
.34042 .32364 m
.36938 .31498 L
s
.36938 .31498 m
.37377 .31367 L
s
.38297 .30637 m
.39424 .29744 L
s
.37377 .31367 m
.38297 .30637 L
s
.56274 .2745 m
.58485 .27983 L
s
.60428 .27314 m
.60507 .27284 L
s
.44685 .27288 m
.45176 .27474 L
s
.45176 .27474 m
.46599 .28014 L
s
.46599 .28014 m
.48921 .27452 L
s
.41884 .28368 m
.42545 .28486 L
s
.42545 .28486 m
.44464 .28831 L
s
.28323 .38742 m
.29277 .38058 L
s
.29277 .38058 m
.30883 .36905 L
s
.27533 .39309 m
.28323 .38742 L
s
.31493 .35779 m
.32154 .34559 L
s
.30883 .36905 m
.31493 .35779 L
s
.32154 .34559 m
.33548 .34032 L
s
.33548 .34032 m
.35794 .33181 L
s
.39424 .29744 m
.39857 .29762 L
s
.39857 .29762 m
.42579 .29875 L
s
.53426 .2894 m
.53836 .27165 L
s
.51359 .27166 m
.51773 .2894 L
s
.55054 .29128 m
.56274 .2745 L
s
.48921 .27452 m
.50144 .29129 L
s
.521 .291 .507 r
.27995 .39389 m .25442 .69746 L .61262 .58472 L p F P
0 g
s
.24053 .45306 m
.26847 .42061 L
s
.27271 .40362 m
.27457 .39617 L
s
.26847 .42061 m
.27271 .40362 L
s
.27457 .39617 m
.27533 .39309 L
s
.48921 .27452 m
.51359 .27166 L
s
.47743 .26544 m
.47905 .26669 L
s
.47905 .26669 m
.48921 .27452 L
s
.56274 .2745 m
.57449 .26542 L
s
.53836 .27165 m
.56274 .2745 L
s
.21959 .48995 m
.22089 .5213 L
s
.22089 .5213 m
.20811 .56238 L
s
0 0 .465 r
.84398 .56224 m .8312 .52116 L .83246 .48981 L p F P
0 g
s
0 .116 .639 r
.81152 .45292 m .83246 .48981 L .8312 .52116 L p F P
0 g
s
.572 .005 0 r
.4174 .88789 m .39858 .87209 L .43306 .88099 L p F P
0 g
s
.572 .005 0 r
.43306 .88099 m .44671 .89539 L .4174 .88789 L p F P
0 g
s
.303 0 0 r
.61917 .88095 m .60549 .89536 L .57444 .90045 L p F P
0 g
s
.185 0 0 r
.60549 .89536 m .61917 .88095 L .65363 .87204 L p F P
0 g
s
.53836 .27165 m
.51359 .27166 L
s
.51359 .27166 m
.5096 .26165 L
s
.53836 .27165 m
.54231 .26164 L
s
.32154 .34559 m
.34042 .32364 L
s
.28955 .36632 m
.29711 .36142 L
s
.29711 .36142 m
.32154 .34559 L
s
.059 .352 .826 r
.73045 .34549 m .76243 .36619 L .77668 .39296 L p F P
0 g
s
.69406 .33172 m
.73045 .34549 L
s
.71154 .32354 m
.73045 .34549 L
s
.73045 .34549 m
.75487 .3613 L
s
.24769 .42304 m
.24053 .45306 L
s
.24053 .45306 m
.21959 .48995 L
s
0 0 .562 r
.83246 .48981 m .81152 .45292 L .80432 .4229 L p F P
0 g
s
0 .218 .732 r
.77668 .39296 m .80432 .4229 L .81152 .45292 L p F P
0 g
s
.24795 .7441 m
.27148 .76749 L
s
.21821 .67774 m
.23601 .70513 L
s
.23601 .70513 m
.24795 .7441 L
s
0 0 .039 r
.8042 .74398 m .81615 .70501 L .83391 .67761 L p F P
0 g
s
0 0 .293 r
.83815 .63542 m .83391 .67761 L .81615 .70501 L p F P
0 g
s
.27533 .39309 m
.28955 .36632 L
s
.27002 .39884 m
.27533 .39309 L
s
.24769 .42304 m
.27002 .39884 L
s
0 .128 .675 r
.80432 .4229 m .77668 .39296 L .76243 .36619 L p F P
0 g
s
.39424 .29744 m
.41884 .28368 L
s
.36509 .30392 m
.39424 .29744 L
s
.65771 .29737 m
.68685 .30384 L
s
.65556 .29617 m
.65771 .29737 L
s
.6331 .28362 m
.65556 .29617 L
s
.566 0 0 r
.39052 .87807 m .36685 .86043 L .39858 .87209 L p F P
0 g
s
.566 0 0 r
.39858 .87209 m .4174 .88789 L .39052 .87807 L p F P
0 g
s
.185 0 0 r
.65363 .87204 m .6348 .88785 L .60549 .89536 L p F P
0 g
s
.031 0 0 r
.6348 .88785 m .65363 .87204 L .68535 .86037 L p F P
0 g
s
.708 .18 0 r
.31473 .82965 m .28952 .80103 L .31659 .8199 L p F P
0 g
s
.27148 .76749 m
.28952 .80103 L
s
.708 .18 0 r
.31659 .8199 m .33865 .8462 L .31473 .82965 L p F P
0 g
s
.073 0 0 r
.73561 .81982 m .71353 .84613 L .68535 .86037 L p F P
0 g
s
0 0 0 r
.71353 .84613 m .73561 .81982 L .76265 .80094 L p F P
0 g
s
.20371 .60518 m
.21398 .63556 L
s
.21398 .63556 m
.21821 .67774 L
s
0 0 .124 r
.83391 .67761 m .83815 .63542 L .84838 .60503 L p F P
0 g
s
0 0 .377 r
.84398 .56224 m .84838 .60503 L .83815 .63542 L p F P
0 g
s
.41884 .28368 m
.44685 .27288 L
s
.39492 .28715 m
.41884 .28368 L
s
.6413 .28481 m
.65699 .28708 L
s
.6331 .28362 m
.6413 .28481 L
s
.60507 .27284 m
.6331 .28362 L
s
.20652 .53047 m
.20811 .56238 L
s
.20811 .56238 m
.20371 .60518 L
s
0 0 .203 r
.84838 .60503 m .84398 .56224 L .84553 .53032 L p F P
0 g
s
0 0 .465 r
.83246 .48981 m .84553 .53032 L .84398 .56224 L p F P
0 g
s
.52 0 0 r
.36675 .86613 m .33865 .8462 L .36685 .86043 L p F P
0 g
s
.52 0 0 r
.36685 .86043 m .39052 .87807 L .36675 .86613 L p F P
0 g
s
.031 0 0 r
.68535 .86037 m .66166 .87802 L .6348 .88785 L p F P
0 g
s
0 0 0 r
.66166 .87802 m .68535 .86037 L .71353 .84613 L p F P
0 g
s
.34042 .32364 m
.36509 .30392 L
s
.311 .34116 m
.31796 .33701 L
s
.31796 .33701 m
.34042 .32364 L
s
.73399 .33691 m
.74095 .34104 L
s
.71154 .32354 m
.73399 .33691 L
s
.68685 .30384 m
.71154 .32354 L
s
.251 0 0 r
.48776 .90573 m .47776 .90046 L .50988 .90302 L p F P
0 g
s
.251 0 0 r
.50988 .90302 m .51322 .90775 L .48776 .90573 L p F P
0 g
s
.202 0 0 r
.51322 .90775 m .50988 .90302 L .54234 .90301 L p F P
0 g
s
.202 0 0 r
.54234 .90301 m .53896 .90775 L .51322 .90775 L p F P
0 g
s
.128 0 0 r
.53896 .90775 m .54234 .90301 L .57444 .90045 L p F P
0 g
s
.22691 .45835 m
.21959 .48995 L
s
.21959 .48995 m
.20652 .53047 L
s
0 0 .292 r
.84553 .53032 m .83246 .48981 L .8251 .4582 L p F P
0 g
s
0 0 .562 r
.80432 .4229 m .8251 .4582 L .83246 .48981 L p F P
0 g
s
.274 0 0 r
.46318 .90173 m .44671 .89539 L .47776 .90046 L p F P
0 g
s
.274 0 0 r
.47776 .90046 m .48776 .90573 L .46318 .90173 L p F P
0 g
s
.128 0 0 r
.57444 .90045 m .56442 .90572 L .53896 .90775 L p F P
0 g
s
.027 0 0 r
.56442 .90572 m .57444 .90045 L .60549 .89536 L p F P
0 g
s
.44685 .27288 m
.47743 .26544 L
s
.42906 .27395 m
.44685 .27288 L
s
.62222 .27386 m
.62283 .27389 L
s
.60507 .27284 m
.62222 .27386 L
s
.57449 .26542 m
.60507 .27284 L
s
.2311 .71852 m
.24795 .7441 L
s
.24795 .7441 m
.26795 .77981 L
s
0 0 .039 r
.83391 .67761 m .82102 .7184 L .8042 .74398 L p F P
0 g
s
.28955 .36632 m
.311 .34116 L
s
.26306 .39375 m
.28955 .36632 L
s
0 .128 .675 r
.76243 .36619 m .78892 .39361 L .80432 .4229 L p F P
0 g
s
.75487 .3613 m
.76243 .36619 L
s
.74095 .34104 m
.76243 .36619 L
s
.26795 .77981 m
.28952 .80103 L
s
.28952 .80103 m
.29533 .80762 L
s
0 0 0 r
.76265 .80094 m .73743 .82957 L .71353 .84613 L p F P
0 g
s
.25315 .41262 m
.26306 .39375 L
s
.24769 .42304 m
.25315 .41262 L
s
.24769 .42304 m
.22691 .45835 L
s
0 0 .403 r
.8251 .4582 m .80432 .4229 L .78892 .39361 L p F P
0 g
s
.267 0 0 r
.44006 .89582 m .4174 .88789 L .44671 .89539 L p F P
0 g
s
.267 0 0 r
.44671 .89539 m .46318 .90173 L .44006 .89582 L p F P
0 g
s
.027 0 0 r
.60549 .89536 m .58899 .90171 L .56442 .90572 L p F P
0 g
s
0 0 0 r
.58899 .90171 m .60549 .89536 L .6348 .88785 L p F P
0 g
s
.5096 .26165 m
.47743 .26544 L
s
.47743 .26544 m
.46646 .26484 L
s
.57449 .26542 m
.58542 .2648 L
s
.57449 .26542 m
.54231 .26164 L
s
.20817 .64856 m
.21821 .67774 L
s
.21821 .67774 m
.2311 .71852 L
s
0 0 0 r
.82102 .7184 m .83391 .67761 L .84392 .64842 L p F P
0 g
s
0 0 .124 r
.84838 .60503 m .84392 .64842 L .83391 .67761 L p F P
0 g
s
.54231 .26164 m
.5096 .26165 L
s
.5096 .26165 m
.50588 .26018 L
s
.54231 .26164 m
.54599 .26017 L
s
.418 0 0 r
.34674 .85228 m .31473 .82965 L .33865 .8462 L p F P
0 g
s
.29533 .80762 m
.31473 .82965 L
s
.418 0 0 r
.33865 .8462 m .36675 .86613 L .34674 .85228 L p F P
0 g
s
0 0 0 r
.71353 .84613 m .68541 .86607 L .66166 .87802 L p F P
0 g
s
0 0 0 r
.68541 .86607 m .71353 .84613 L .73743 .82957 L p F P
0 g
s
.36509 .30392 m
.39492 .28715 L
s
.33927 .31848 m
.34538 .31503 L
s
.34538 .31503 m
.36509 .30392 L
s
.70654 .31494 m
.71265 .31838 L
s
.68685 .30384 m
.70654 .31494 L
s
.65699 .28708 m
.68685 .30384 L
s
.20201 .57363 m
.20371 .60518 L
s
.20371 .60518 m
.20817 .64856 L
s
0 0 .203 r
.84553 .53032 m .85004 .57349 L .84838 .60503 L p F P
0 g
s
.758 .668 .116 r
.84392 .64842 m .84838 .60503 L .85004 .57349 L p F P
0 g
s
0 .357 .677 r
.41895 .88811 m .39052 .87807 L .4174 .88789 L p F P
0 g
s
0 .357 .677 r
.4174 .88789 m .44006 .89582 L .41895 .88811 L p F P
0 g
s
0 0 0 r
.6348 .88785 m .6121 .89579 L .58899 .90171 L p F P
0 g
s
.254 .75 .678 r
.6121 .89579 m .6348 .88785 L .66166 .87802 L p F P
0 g
s
.21391 .49825 m
.20652 .53047 L
s
.20652 .53047 m
.20201 .57363 L
s
0 0 .292 r
.8251 .4582 m .8381 .49811 L .84553 .53032 L p F P
0 g
s
.826 .59 .037 r
.85004 .57349 m .84553 .53032 L .8381 .49811 L p F P
0 g
s
.311 .34116 m
.33927 .31848 L
s
.28655 .36613 m
.311 .34116 L
s
.74095 .34104 m
.76539 .36601 L
s
.71265 .31838 m
.74095 .34104 L
s
.39492 .28715 m
.42906 .27395 L
s
.37368 .29914 m
.37871 .29629 L
s
.37871 .29629 m
.39492 .28715 L
s
.67318 .29622 m
.67821 .29906 L
s
.65699 .28708 m
.67318 .29622 L
s
.62283 .27389 m
.65699 .28708 L
s
0 .391 .764 r
.4004 .87876 m .36675 .86613 L .39052 .87807 L p F P
0 g
s
0 .391 .764 r
.39052 .87807 m .41895 .88811 L .4004 .87876 L p F P
0 g
s
.254 .75 .678 r
.66166 .87802 m .6332 .88807 L .6121 .89579 L p F P
0 g
s
.417 .858 .765 r
.6332 .88807 m .66166 .87802 L .68541 .86607 L p F P
0 g
s
.25265 .75666 m
.26795 .77981 L
s
.27438 .78702 m
.29582 .81109 L
s
.26795 .77981 m
.27438 .78702 L
s
.24309 .42744 m
.22691 .45835 L
s
.22691 .45835 m
.21391 .49825 L
s
0 0 .403 r
.78892 .39361 m .80888 .4273 L .8251 .4582 L p F P
0 g
s
.826 .465 0 r
.8381 .49811 m .8251 .4582 L .80888 .4273 L p F P
0 g
s
.76243 .36619 m
.78892 .39361 L
s
.26306 .39375 m
.28655 .36613 L
s
.24309 .42744 m
.26306 .39375 L
s
.76539 .36601 m
.78892 .39361 L
s
.22171 .6913 m
.2311 .71852 L
s
.2311 .71852 m
.25265 .75666 L
s
0 0 0 r
.84392 .64842 m .83037 .69117 L .82102 .7184 L p F P
0 g
s
.806 .9 .491 r
.79946 .75655 m .82102 .7184 L .83037 .69117 L p F P
0 g
s
.29582 .81109 m
.31473 .82965 L
s
0 0 0 r
.73743 .82957 m .70541 .85222 L .68541 .86607 L p F P
0 g
s
.612 .931 .705 r
.70541 .85222 m .73743 .82957 L .75632 .811 L p F P
0 g
s
.143 .672 .869 r
.49932 .90207 m .48776 .90573 L .51322 .90775 L p F P
0 g
s
.143 .672 .869 r
.51322 .90775 m .51708 .90348 L .49932 .90207 L p F P
0 g
s
.18 .705 .864 r
.51708 .90348 m .51322 .90775 L .53896 .90775 L p F P
0 g
s
.18 .705 .864 r
.53896 .90775 m .53506 .90348 L .51708 .90348 L p F P
0 g
s
.236 .748 .869 r
.53506 .90348 m .53896 .90775 L .56442 .90572 L p F P
0 g
s
.42906 .27395 m
.46646 .26484 L
s
.41323 .28387 m
.41699 .28152 L
s
.41699 .28152 m
.42906 .27395 L
s
.63489 .28146 m
.63864 .28381 L
s
.62283 .27389 m
.63489 .28146 L
s
.62136 .27354 m
.62283 .27389 L
s
.58542 .2648 m
.62136 .27354 L
s
.20658 .61828 m
.20817 .64856 L
s
.20817 .64856 m
.22171 .6913 L
s
.903 .857 .409 r
.83037 .69117 m .84392 .64842 L .84547 .61814 L p F P
0 g
s
.758 .668 .116 r
.85004 .57349 m .84547 .61814 L .84392 .64842 L p F P
0 g
s
.128 .649 .885 r
.4822 .89927 m .46318 .90173 L .48776 .90573 L p F P
0 g
s
.128 .649 .885 r
.48776 .90573 m .49932 .90207 L .4822 .89927 L p F P
0 g
s
.236 .748 .869 r
.56442 .90572 m .55282 .90206 L .53506 .90348 L p F P
0 g
s
.309 .797 .885 r
.55282 .90206 m .56442 .90572 L .58899 .90171 L p F P
0 g
s
0 .429 .838 r
.38491 .86796 m .34674 .85228 L .36675 .86613 L p F P
0 g
s
.31473 .82965 m
.34674 .85228 L
s
0 .429 .838 r
.36675 .86613 m .4004 .87876 L .38491 .86796 L p F P
0 g
s
.417 .858 .765 r
.68541 .86607 m .65174 .87871 L .6332 .88807 L p F P
0 g
s
.571 .939 .838 r
.65174 .87871 m .68541 .86607 L .70541 .85222 L p F P
0 g
s
.134 .634 .907 r
.46616 .89514 m .44006 .89582 L .46318 .90173 L p F P
0 g
s
.134 .634 .907 r
.46318 .90173 m .4822 .89927 L .46616 .89514 L p F P
0 g
s
.309 .797 .885 r
.58899 .90171 m .56994 .89925 L .55282 .90206 L p F P
0 g
s
.394 .847 .907 r
.56994 .89925 m .58899 .90171 L .6121 .89579 L p F P
0 g
s
.33927 .31848 m
.37368 .29914 L
s
.31775 .34118 m
.33927 .31848 L
s
.71265 .31838 m
.73415 .34107 L
s
.67821 .29906 m
.71265 .31838 L
s
.50588 .26018 m
.46646 .26484 L
s
.45668 .27332 m
.45901 .27131 L
s
.45901 .27131 m
.46646 .26484 L
s
.59286 .27127 m
.59517 .27328 L
s
.58542 .2648 m
.59286 .27127 L
s
.58542 .2648 m
.54599 .26017 L
s
.20943 .54177 m
.20201 .57363 L
s
.20201 .57363 m
.20658 .61828 L
s
.958 .777 .329 r
.84547 .61814 m .85004 .57349 L .84258 .54162 L p F P
0 g
s
.826 .59 .037 r
.8381 .49811 m .84258 .54162 L .85004 .57349 L p F P
0 g
s
.54599 .26017 m
.50588 .26018 L
s
.50588 .26018 m
.50257 .26792 L
s
.54599 .26017 m
.54928 .26791 L
s
.158 .626 .93 r
.45158 .88978 m .41895 .88811 L .44006 .89582 L p F P
0 g
s
.158 .626 .93 r
.44006 .89582 m .46616 .89514 L .45158 .88978 L p F P
0 g
s
.394 .847 .907 r
.6121 .89579 m .58598 .89512 L .56994 .89925 L p F P
0 g
s
.484 .892 .93 r
.58598 .89512 m .6121 .89579 L .6332 .88807 L p F P
0 g
s
.28258 .79091 m
.29582 .81109 L
s
.29582 .81109 m
.33107 .83682 L
s
.612 .931 .705 r
.75632 .811 m .72105 .83674 L .70541 .85222 L p F P
0 g
s
.773 .995 .794 r
.72105 .83674 m .75632 .811 L .76953 .79082 L p F P
0 g
s
.697 .919 .586 r
.79946 .75655 m .76953 .79082 L .75632 .811 L p F P
0 g
s
.24431 .73209 m
.25265 .75666 L
s
.25956 .76457 m
.28258 .79091 L
s
.25265 .75666 m
.25956 .76457 L
s
.23057 .46669 m
.21391 .49825 L
s
.21391 .49825 m
.20943 .54177 L
s
.867 .985 .705 r
.76953 .79082 m .79946 .75655 L .80777 .73197 L p F P
0 g
s
.806 .9 .491 r
.83037 .69117 m .80777 .73197 L .79946 .75655 L p F P
0 g
s
.961 .663 .241 r
.84258 .54162 m .8381 .49811 L .82139 .46655 L p F P
0 g
s
.826 .465 0 r
.80888 .4273 m .82139 .46655 L .8381 .49811 L p F P
0 g
s
.78892 .39361 m
.80888 .4273 L
s
.28655 .36613 m
.31775 .34118 L
s
.26807 .39823 m
.28655 .36613 L
s
.76539 .36601 m
.78386 .3981 L
s
.73415 .34107 m
.76539 .36601 L
s
.24309 .42744 m
.26807 .39823 L
s
.24309 .42744 m
.23057 .46669 L
s
.78386 .3981 m
.80888 .4273 L
s
.33107 .83682 m
.34674 .85228 L
s
.34674 .85228 m
.3568 .85642 L
s
.571 .939 .838 r
.70541 .85222 m .66721 .86791 L .65174 .87871 L p F P
0 g
s
.694 .981 .885 r
.66721 .86791 m .70541 .85222 L .72105 .83674 L p F P
0 g
s
.22044 .66311 m
.22171 .6913 L
s
.22171 .6913 m
.24431 .73209 L
s
.198 .622 .948 r
.43887 .8833 m .4004 .87876 L .41895 .88811 L p F P
0 g
s
.198 .622 .948 r
.41895 .88811 m .45158 .88978 L .43887 .8833 L p F P
0 g
s
.484 .892 .93 r
.6332 .88807 m .60054 .88975 L .58598 .89512 L p F P
0 g
s
.57 .926 .948 r
.60054 .88975 m .6332 .88807 L .65174 .87871 L p F P
0 g
s
.948 .943 .62 r
.80777 .73197 m .83037 .69117 L .83161 .66297 L p F P
0 g
s
.903 .857 .409 r
.84547 .61814 m .83161 .66297 L .83037 .69117 L p F P
0 g
s
.37368 .29914 m
.41323 .28387 L
s
.35593 .31983 m
.37368 .29914 L
s
.67821 .29906 m
.69594 .31974 L
s
.63864 .28381 m
.67821 .29906 L
s
.21397 .58771 m
.20658 .61828 L
s
.20658 .61828 m
.22044 .66311 L
s
.993 .869 .537 r
.83161 .66297 m .84547 .61814 L .83804 .58757 L p F P
0 g
s
.958 .777 .329 r
.84258 .54162 m .83804 .58757 L .84547 .61814 L p F P
0 g
s
.246 .619 .957 r
.42835 .87585 m .38491 .86796 L .4004 .87876 L p F P
0 g
s
.3568 .85642 m
.38491 .86796 L
s
.246 .619 .957 r
.4004 .87876 m .43887 .8833 L .42835 .87585 L p F P
0 g
s
.57 .926 .948 r
.65174 .87871 m .61325 .88327 L .60054 .88975 L p F P
0 g
s
.644 .944 .957 r
.61325 .88327 m .65174 .87871 L .66721 .86791 L p F P
0 g
s
.41323 .28387 m
.45668 .27332 L
s
.39998 .30295 m
.41323 .28387 L
s
.63864 .28381 m
.65187 .30289 L
s
.6 .27445 m
.61171 .27729 L
s
.61171 .27729 m
.63864 .28381 L
s
.59517 .27328 m
.6 .27445 L
s
.439 .795 .997 r
.51219 .88895 m .49932 .90207 L .51708 .90348 L p F P
0 g
s
.439 .795 .997 r
.51708 .90348 m .52139 .88969 L .51219 .88895 L p F P
0 g
s
.459 .814 .997 r
.52139 .88969 m .51708 .90348 L .53506 .90348 L p F P
0 g
s
.459 .814 .997 r
.53506 .90348 m .53071 .88969 L .52139 .88969 L p F P
0 g
s
.486 .833 .997 r
.53071 .88969 m .53506 .90348 L .55282 .90206 L p F P
0 g
s
.2756 .76957 m
.28258 .79091 L
s
.28258 .79091 m
.3203 .82007 L
s
.773 .995 .794 r
.76953 .79082 m .7318 .81999 L .72105 .83674 L p F P
0 g
s
.86 .992 .832 r
.7318 .81999 m .76953 .79082 L .77647 .76947 L p F P
0 g
s
.867 .985 .705 r
.80777 .73197 m .77647 .76947 L .76953 .79082 L p F P
0 g
s
.427 .776 .997 r
.50334 .88749 m .4822 .89927 L .49932 .90207 L p F P
0 g
s
.427 .776 .997 r
.49932 .90207 m .51219 .88895 L .50334 .88749 L p F P
0 g
s
.486 .833 .997 r
.55282 .90206 m .53992 .88894 L .53071 .88969 L p F P
0 g
s
.518 .851 .997 r
.53992 .88894 m .55282 .90206 L .56994 .89925 L p F P
0 g
s
.3203 .82007 m
.33107 .83682 L
s
.33973 .84077 m
.37294 .85595 L
s
.33107 .83682 m
.33973 .84077 L
s
.694 .981 .885 r
.72105 .83674 m .67917 .85589 L .66721 .86791 L p F P
0 g
s
.776 .984 .903 r
.67917 .85589 m .72105 .83674 L .7318 .81999 L p F P
0 g
s
.31775 .34118 m
.35593 .31983 L
s
.30146 .37178 m
.31775 .34118 L
s
.73415 .34107 m
.75043 .37167 L
s
.69594 .31974 m
.73415 .34107 L
s
.22625 .51054 m
.20943 .54177 L
s
.20943 .54177 m
.21397 .58771 L
s
.997 .769 .452 r
.83804 .58757 m .84258 .54162 L .82571 .5104 L p F P
0 g
s
.961 .663 .241 r
.82139 .46655 m .82571 .5104 L .84258 .54162 L p F P
0 g
s
.80888 .4273 m
.82139 .46655 L
s
.422 .759 .995 r
.49507 .88533 m .46616 .89514 L .4822 .89927 L p F P
0 g
s
.422 .759 .995 r
.4822 .89927 m .50334 .88749 L .49507 .88533 L p F P
0 g
s
.518 .851 .997 r
.56994 .89925 m .54876 .88748 L .53992 .88894 L p F P
0 g
s
.553 .866 .995 r
.54876 .88748 m .56994 .89925 L .58598 .89512 L p F P
0 g
s
.24351 .7067 m
.24431 .73209 L
s
.25155 .74076 m
.2756 .76957 L
s
.24431 .73209 m
.25155 .74076 L
s
.933 .964 .753 r
.77647 .76947 m .80777 .73197 L .80854 .70658 L p F P
0 g
s
.948 .943 .62 r
.83161 .66297 m .80854 .70658 L .80777 .73197 L p F P
0 g
s
.45668 .27332 m
.50257 .26792 L
s
.44849 .29127 m
.45668 .27332 L
s
.59517 .27328 m
.60334 .29122 L
s
.54928 .26791 m
.59517 .27328 L
s
.23057 .46669 m
.25647 .43683 L
s
.23057 .46669 m
.22625 .51054 L
s
.79545 .43669 m
.82139 .46655 L
s
.26807 .39823 m
.30146 .37178 L
s
.25647 .43683 m
.26807 .39823 L
s
.78386 .3981 m
.79545 .43669 L
s
.75043 .37167 m
.78386 .3981 L
s
.37294 .85595 m
.38491 .86796 L
s
.644 .944 .957 r
.66721 .86791 m .62375 .87581 L .61325 .88327 L p F P
0 g
s
.703 .947 .957 r
.62375 .87581 m .66721 .86791 L .67917 .85589 L p F P
0 g
s
.424 .744 .993 r
.48761 .88255 m .45158 .88978 L .46616 .89514 L p F P
0 g
s
.424 .744 .993 r
.46616 .89514 m .49507 .88533 L .48761 .88255 L p F P
0 g
s
.553 .866 .995 r
.58598 .89512 m .55702 .88532 L .54876 .88748 L p F P
0 g
s
.589 .878 .993 r
.55702 .88532 m .58598 .89512 L .60054 .88975 L p F P
0 g
s
.54928 .26791 m
.50257 .26792 L
s
.49978 .28528 m
.50257 .26792 L
s
.54928 .26791 m
.55204 .28527 L
s
.22775 .63468 m
.22044 .66311 L
s
.22044 .66311 m
.24351 .7067 L
s
.977 .904 .673 r
.80854 .70658 m .83161 .66297 L .82426 .63455 L p F P
0 g
s
.993 .869 .537 r
.83804 .58757 m .82426 .63455 L .83161 .66297 L p F P
0 g
s
.433 .73 .989 r
.48115 .87919 m .43887 .8833 L .45158 .88978 L p F P
0 g
s
.433 .73 .989 r
.45158 .88978 m .48761 .88255 L .48115 .87919 L p F P
0 g
s
.589 .878 .993 r
.60054 .88975 m .56448 .88253 L .55702 .88532 L p F P
0 g
s
.623 .885 .989 r
.56448 .88253 m .60054 .88975 L .61325 .88327 L p F P
0 g
s
.35593 .31983 m
.39998 .30295 L
s
.34246 .34911 m
.35593 .31983 L
s
.69594 .31974 m
.7094 .34902 L
s
.65187 .30289 m
.69594 .31974 L
s
.31488 .80243 m
.31983 .81854 L
s
.31983 .81854 m
.3203 .82007 L
s
.32151 .82069 m
.36489 .84301 L
s
.3203 .82007 m
.32151 .82069 L
s
.776 .984 .903 r
.7318 .81999 m .6872 .84295 L .67917 .85589 L p F P
0 g
s
.822 .961 .9 r
.6872 .84295 m .7318 .81999 L .73719 .80235 L p F P
0 g
s
.86 .992 .832 r
.77647 .76947 m .73719 .80235 L .7318 .81999 L p F P
0 g
s
.36489 .84301 m
.37294 .85595 L
s
.37294 .85595 m
.42035 .86761 L
s
.703 .947 .957 r
.67917 .85589 m .63174 .86757 L .62375 .87581 L p F P
0 g
s
.745 .936 .949 r
.63174 .86757 m .67917 .85589 L .6872 .84295 L p F P
0 g
s
.447 .718 .982 r
.47587 .87536 m .42835 .87585 L .43887 .8833 L p F P
0 g
s
.38491 .86796 m
.42835 .87585 L
s
.447 .718 .982 r
.43887 .8833 m .48115 .87919 L .47587 .87536 L p F P
0 g
s
.623 .885 .989 r
.61325 .88327 m .57093 .87918 L .56448 .88253 L p F P
0 g
s
.654 .886 .982 r
.57093 .87918 m .61325 .88327 L .62375 .87581 L p F P
0 g
s
.23063 .55776 m
.21397 .58771 L
s
.21397 .58771 m
.22775 .63468 L
s
.986 .819 .592 r
.82426 .63455 m .83804 .58757 L .82134 .55762 L p F P
0 g
s
.997 .769 .452 r
.82571 .5104 m .82134 .55762 L .83804 .58757 L p F P
0 g
s
.82139 .46655 m
.82571 .5104 L
s
.27535 .7476 m
.2756 .76957 L
s
.30113 .79093 m
.31488 .80243 L
s
.2756 .76957 m
.30113 .79093 L
s
.893 .952 .835 r
.73719 .80235 m .77647 .76947 L .77669 .7475 L p F P
0 g
s
.933 .964 .753 r
.80854 .70658 m .77669 .7475 L .77647 .76947 L p F P
0 g
s
.30146 .37178 m
.34246 .34911 L
s
.29121 .40974 m
.30146 .37178 L
s
.75043 .37167 m
.76068 .40962 L
s
.7094 .34902 m
.75043 .37167 L
s
.25246 .48097 m
.22625 .51054 L
s
.22625 .51054 m
.23063 .55776 L
s
.79946 .48084 m
.82571 .5104 L
s
.25064 .68118 m
.24351 .7067 L
s
.25088 .71617 m
.27535 .7476 L
s
.24351 .7067 m
.25088 .71617 L
s
.42035 .86761 m
.42835 .87585 L
s
.654 .886 .982 r
.62375 .87581 m .57621 .87534 L .57093 .87918 L p F P
0 g
s
.679 .883 .974 r
.57621 .87534 m .62375 .87581 L .63174 .86757 L p F P
0 g
s
.94 .91 .763 r
.77669 .7475 m .80854 .70658 L .80137 .68106 L p F P
0 g
s
.977 .904 .673 r
.82426 .63455 m .80137 .68106 L .80854 .70658 L p F P
0 g
s
.39998 .30295 m
.44849 .29127 L
s
.3899 .33116 m
.39998 .30295 L
s
.65187 .30289 m
.66193 .33109 L
s
.60334 .29122 m
.64542 .30134 L
s
.64542 .30134 m
.65187 .30289 L
s
.25647 .43683 m
.29121 .40974 L
s
.25246 .48097 m
.25647 .43683 L
s
.79545 .43669 m
.79946 .48084 L
s
.76068 .40962 m
.79545 .43669 L
s
.585 .795 .979 r
.52139 .88969 m .52603 .86617 L .51219 .88895 L closepath p F P
0 g
s
.59 .8 .98 r
.53071 .88969 m .52603 .86617 L .52139 .88969 L closepath p F P
0 g
s
.597 .805 .979 r
.53992 .88894 m .52603 .86617 L .53071 .88969 L closepath p F P
0 g
s
.58 .789 .978 r
.51219 .88895 m .52603 .86617 L .50334 .88749 L closepath p F P
0 g
s
.605 .809 .978 r
.54876 .88748 m .52603 .86617 L .53992 .88894 L closepath p F P
0 g
s
.36109 .82945 m
.36489 .84301 L
s
.36489 .84301 m
.41511 .85877 L
s
.745 .936 .949 r
.6872 .84295 m .63697 .85873 L .63174 .86757 L p F P
0 g
s
.771 .916 .936 r
.63697 .85873 m .6872 .84295 L .69098 .82939 L p F P
0 g
s
.822 .961 .9 r
.73719 .80235 m .69098 .82939 L .6872 .84295 L p F P
0 g
s
.577 .783 .977 r
.50334 .88749 m .52603 .86617 L .49507 .88533 L closepath p F P
0 g
s
.613 .812 .977 r
.55702 .88532 m .52603 .86617 L .54876 .88748 L closepath p F P
0 g
s
.31488 .80243 m
.31516 .78436 L
s
.31488 .80243 m
.36109 .82945 L
s
.841 .925 .887 r
.69098 .82939 m .73719 .80235 L .73689 .78428 L p F P
0 g
s
.893 .952 .835 r
.77669 .7475 m .73689 .78428 L .73719 .80235 L p F P
0 g
s
.576 .777 .974 r
.49507 .88533 m .52603 .86617 L .48761 .88255 L closepath p F P
0 g
s
.621 .814 .974 r
.56448 .88253 m .52603 .86617 L .55702 .88532 L closepath p F P
0 g
s
.41511 .85877 m
.42035 .86761 L
s
.42035 .86761 m
.47192 .87113 L
s
.679 .883 .974 r
.63174 .86757 m .58016 .87111 L .57621 .87534 L p F P
0 g
s
.7 .875 .963 r
.58016 .87111 m .63174 .86757 L .63697 .85873 L p F P
0 g
s
.24389 .60688 m
.22775 .63468 L
s
.22775 .63468 m
.25064 .68118 L
s
.957 .842 .688 r
.80137 .68106 m .82426 .63455 L .80807 .60676 L p F P
0 g
s
.986 .819 .592 r
.82134 .55762 m .80807 .60676 L .82426 .63455 L p F P
0 g
s
.82134 .55762 m
.82571 .5104 L
s
.44849 .29127 m
.49978 .28528 L
s
.44225 .31872 m
.44849 .29127 L
s
.60334 .29122 m
.60956 .31867 L
s
.55204 .28527 m
.60334 .29122 L
s
.576 .771 .972 r
.48761 .88255 m .52603 .86617 L .48115 .87919 L closepath p F P
0 g
s
.629 .815 .972 r
.57093 .87918 m .52603 .86617 L .56448 .88253 L closepath p F P
0 g
s
.27562 .74674 m
.28213 .72559 L
s
.27535 .7476 m
.27562 .74674 L
s
.27669 .74883 m
.31516 .78436 L
s
.27535 .7476 m
.27669 .74883 L
s
.894 .901 .825 r
.73689 .78428 m .77669 .7475 L .76988 .72549 L p F P
0 g
s
.94 .91 .763 r
.80137 .68106 m .76988 .72549 L .77669 .7475 L p F P
0 g
s
.49978 .28528 m
.55204 .28527 L
s
.49767 .31234 m
.49978 .28528 L
s
.55204 .28527 m
.55413 .31232 L
s
.577 .766 .968 r
.48115 .87919 m .52603 .86617 L .47587 .87536 L closepath p F P
0 g
s
.42835 .87585 m
.47587 .87536 L
s
.637 .815 .968 r
.57621 .87534 m .52603 .86617 L .57093 .87918 L closepath p F P
0 g
s
.34246 .34911 m
.3899 .33116 L
s
.33397 .3865 m
.34246 .34911 L
s
.7094 .34902 m
.71787 .3864 L
s
.66193 .33109 m
.7094 .34902 L
s
.41283 .84957 m
.41511 .85877 L
s
.41511 .85877 m
.46941 .86664 L
s
.7 .875 .963 r
.63697 .85873 m .58265 .86662 L .58016 .87111 L p F P
0 g
s
.715 .864 .952 r
.58265 .86662 m .63697 .85873 L .63924 .84953 L p F P
0 g
s
.771 .916 .936 r
.69098 .82939 m .63924 .84953 L .63697 .85873 L p F P
0 g
s
.23063 .55776 m
.25652 .52942 L
s
.23063 .55776 m
.24389 .60688 L
s
.7954 .52929 m
.82134 .55762 L
s
.36109 .82945 m
.36175 .81563 L
s
.36109 .82945 m
.41283 .84957 L
s
.47192 .87113 m
.47587 .87536 L
s
.644 .814 .965 r
.58016 .87111 m .52603 .86617 L .57621 .87534 L closepath p F P
0 g
s
.785 .89 .92 r
.63924 .84953 m .69098 .82939 L .6903 .81557 L p F P
0 g
s
.841 .925 .887 r
.73689 .78428 m .6903 .81557 L .69098 .82939 L p F P
0 g
s
.46941 .86664 m
.47192 .87113 L
s
.651 .812 .961 r
.58265 .86662 m .52603 .86617 L .58016 .87111 L closepath p F P
0 g
s
.25064 .68118 m
.26589 .65628 L
s
.25794 .69148 m
.26686 .70405 L
s
.26686 .70405 m
.28213 .72559 L
s
.25064 .68118 m
.25794 .69148 L
s
.25246 .48097 m
.28766 .45415 L
s
.25246 .48097 m
.25652 .52942 L
s
.29121 .40974 m
.33397 .3865 L
s
.28766 .45415 m
.29121 .40974 L
s
.92 .85 .757 r
.76988 .72549 m .80137 .68106 L .78608 .65617 L p F P
0 g
s
.957 .842 .688 r
.80807 .60676 m .78608 .65617 L .80137 .68106 L p F P
0 g
s
.80807 .60676 m
.82134 .55762 L
s
.79946 .48084 m
.7954 .52929 L
s
.76422 .45403 m
.79946 .48084 L
s
.76068 .40962 m
.76422 .45403 L
s
.71787 .3864 m
.76068 .40962 L
s
.31516 .78436 m
.32134 .76634 L
s
.31516 .78436 m
.36175 .81563 L
s
.844 .884 .869 r
.6903 .81557 m .73689 .78428 L .73068 .76626 L p F P
0 g
s
.894 .901 .825 r
.76988 .72549 m .73068 .76626 L .73689 .78428 L p F P
0 g
s
.41362 .84025 m
.41283 .84957 L
s
.41283 .84957 m
.46844 .86198 L
s
.715 .864 .952 r
.63924 .84953 m .58363 .86196 L .58265 .86662 L p F P
0 g
s
.725 .85 .941 r
.58363 .86196 m .63924 .84953 L .63843 .84021 L p F P
0 g
s
.785 .89 .92 r
.6903 .81557 m .63843 .84021 L .63924 .84953 L p F P
0 g
s
.46844 .86198 m
.46941 .86664 L
s
.656 .809 .957 r
.58363 .86196 m .52603 .86617 L .58265 .86662 L closepath p F P
0 g
s
.3899 .33116 m
.44225 .31872 L
s
.38355 .36808 m
.3899 .33116 L
s
.66193 .33109 m
.66827 .36801 L
s
.60956 .31867 m
.66193 .33109 L
s
.36699 .80193 m
.36175 .81563 L
s
.36175 .81563 m
.41362 .84025 L
s
.46903 .8573 m
.46844 .86198 L
s
.66 .805 .953 r
.58303 .85727 m .52603 .86617 L .58363 .86196 L closepath p F P
0 g
s
.725 .85 .941 r
.63843 .84021 m .58303 .85727 L .58363 .86196 L p F P
0 g
s
.79 .862 .903 r
.63843 .84021 m .6903 .81557 L .68503 .80187 L p F P
0 g
s
.844 .884 .869 r
.73068 .76626 m .68503 .80187 L .6903 .81557 L p F P
0 g
s
.24389 .60688 m
.26882 .58062 L
s
.24389 .60688 m
.26589 .65628 L
s
.78311 .5805 m
.80807 .60676 L
s
.663 .801 .948 r
.58086 .85269 m .52603 .86617 L .58303 .85727 L closepath p F P
0 g
s
.665 .796 .945 r
.57717 .84832 m .52603 .86617 L .58086 .85269 L closepath p F P
0 g
s
.46844 .86198 m
.52603 .86617 L
s
.47192 .87113 m
.52603 .86617 L
s
.47587 .87536 m
.52603 .86617 L
s
.46941 .86664 m
.52603 .86617 L
s
.52603 .86617 m
.52603 .86617 L
s
.52603 .86617 m
.57204 .84431 L
s
.52603 .86617 m
.56562 .84077 L
s
.52603 .86617 m
.55806 .8378 L
s
.52603 .86617 m
.54959 .83549 L
s
.52603 .86617 m
.54043 .83391 L
s
.52603 .86617 m
.53086 .83311 L
s
.52115 .83311 m
.52603 .86617 L
s
.51159 .83391 m
.52603 .86617 L
s
.50243 .8355 m
.52603 .86617 L
s
.49396 .83781 m
.52603 .86617 L
s
.48641 .84079 m
.52603 .86617 L
s
.47999 .84433 m
.52603 .86617 L
s
.47487 .84834 m
.52603 .86617 L
s
.47119 .85271 m
.52603 .86617 L
s
.46903 .8573 m
.52603 .86617 L
s
.28213 .72559 m
.29605 .7042 L
s
.28213 .72559 m
.32134 .76634 L
s
.88 .85 .809 r
.73068 .76626 m .76988 .72549 L .75593 .7041 L p F P
0 g
s
.92 .85 .757 r
.78608 .65617 m .75593 .7041 L .76988 .72549 L p F P
0 g
s
.78608 .65617 m
.80807 .60676 L
s
.41754 .83106 m
.41362 .84025 L
s
.41362 .84025 m
.46903 .8573 L
s
.731 .835 .929 r
.58303 .85727 m .63843 .84021 L .6345 .83102 L p F P
0 g
s
.79 .862 .903 r
.68503 .80187 m .6345 .83102 L .63843 .84021 L p F P
0 g
s
.47119 .85271 m
.46903 .8573 L
s
.731 .835 .929 r
.6345 .83102 m .58086 .85269 L .58303 .85727 L p F P
0 g
s
.44225 .31872 m
.49767 .31234 L
s
.43831 .3553 m
.44225 .31872 L
s
.60956 .31867 m
.61349 .35526 L
s
.57486 .3147 m
.60956 .31867 L
s
.55413 .31232 m
.57486 .3147 L
s
.33397 .3865 m
.38355 .36808 L
s
.33104 .43112 m
.33397 .3865 L
s
.71787 .3864 m
.72081 .43102 L
s
.66827 .36801 m
.71787 .3864 L
s
.25652 .52942 m
.29125 .50372 L
s
.25652 .52942 m
.26882 .58062 L
s
.7954 .52929 m
.78311 .5805 L
s
.76063 .5036 m
.7954 .52929 L
s
.47487 .84834 m
.47119 .85271 L
s
.41754 .83106 m
.47119 .85271 L
s
.732 .819 .918 r
.58086 .85269 m .6345 .83102 L .6275 .82223 L p F P
0 g
s
.732 .819 .918 r
.6275 .82223 m .57717 .84832 L .58086 .85269 L p F P
0 g
s
.52603 .86617 m
.57717 .84832 L
s
.32134 .76634 m
.33345 .7489 L
s
.32134 .76634 m
.36699 .80193 L
s
.836 .844 .852 r
.68503 .80187 m .73068 .76626 L .71854 .74883 L p F P
0 g
s
.88 .85 .809 r
.75593 .7041 m .71854 .74883 L .73068 .76626 L p F P
0 g
s
.49767 .31234 m
.55413 .31232 L
s
.49633 .34875 m
.49767 .31234 L
s
.55413 .31232 m
.55546 .34874 L
s
.28766 .45415 m
.33104 .43112 L
s
.28766 .45415 m
.29125 .50372 L
s
.76063 .5036 m
.76422 .45403 L
s
.72081 .43102 m
.76422 .45403 L
s
.42452 .82227 m
.41754 .83106 L
s
.36699 .80193 m
.41754 .83106 L
s
.788 .834 .887 r
.6345 .83102 m .68503 .80187 L .67521 .78868 L p F P
0 g
s
.788 .834 .887 r
.67521 .78868 m .6275 .82223 L .6345 .83102 L p F P
0 g
s
.3768 .78874 m
.36699 .80193 L
s
.26589 .65628 m
.28916 .63282 L
s
.27289 .66741 m
.29605 .7042 L
s
.26589 .65628 m
.27289 .66741 L
s
.836 .844 .852 r
.71854 .74883 m .67521 .78868 L .68503 .80187 L p F P
0 g
s
.76277 .63271 m
.78608 .65617 L
s
.75593 .7041 m
.77908 .6673 L
s
.77908 .6673 m
.78608 .65617 L
s
.47999 .84433 m
.47487 .84834 L
s
.42452 .82227 m
.47487 .84834 L
s
.57204 .84431 m
.57717 .84832 L
s
.57717 .84832 m
.6275 .82223 L
s
.48641 .84079 m
.47999 .84433 L
s
.43442 .81414 m
.47999 .84433 L
s
.57204 .84431 m
.61759 .8141 L
s
.57204 .84431 m
.56562 .84077 L
s
.49396 .83781 m
.48641 .84079 L
s
.447 .80691 m
.48641 .84079 L
s
.56562 .84077 m
.60499 .80688 L
s
.56562 .84077 m
.55806 .8378 L
s
.29605 .7042 m
.31699 .68411 L
s
.29605 .7042 m
.33345 .7489 L
s
.73496 .68403 m
.75593 .7041 L
s
.71854 .74883 m
.75593 .7041 L
s
.43442 .81414 m
.42452 .82227 L
s
.3768 .78874 m
.42452 .82227 L
s
.61759 .8141 m
.6275 .82223 L
s
.6275 .82223 m
.67521 .78868 L
s
.38355 .36808 m
.43831 .3553 L
s
.38135 .41286 m
.38355 .36808 L
s
.66827 .36801 m
.67047 .41279 L
s
.61349 .35526 m
.66827 .36801 L
s
.26882 .58062 m
.30212 .55683 L
s
.26882 .58062 m
.28916 .63282 L
s
.76277 .63271 m
.78311 .5805 L
s
.74977 .55673 m
.78311 .5805 L
s
.50243 .8355 m
.49396 .83781 L
s
.46193 .80082 m
.49396 .83781 L
s
.59006 .8008 m
.55806 .8378 L
s
.55806 .8378 m
.54959 .83549 L
s
.33345 .7489 m
.35135 .7326 L
s
.33345 .7489 m
.3768 .78874 L
s
.70062 .73253 m
.71854 .74883 L
s
.70699 .75945 m
.71854 .74883 L
s
.67521 .78868 m
.70699 .75945 L
s
.3768 .78874 m
.39099 .77647 L
s
.66099 .77642 m
.67521 .78868 L
s
.51159 .83391 m
.50243 .8355 L
s
.47879 .79607 m
.50243 .8355 L
s
.57319 .79605 m
.54959 .83549 L
s
.54959 .83549 m
.54043 .83391 L
s
.52115 .83311 m
.51159 .83391 L
s
.49708 .79281 m
.51159 .83391 L
s
.5549 .7928 m
.54043 .83391 L
s
.54043 .83391 m
.53086 .83311 L
s
.53086 .83311 m
.52115 .83311 L
s
.51625 .79115 m
.52115 .83311 L
s
.53572 .79114 m
.53086 .83311 L
s
.447 .80691 m
.43442 .81414 L
s
.39099 .77647 m
.43442 .81414 L
s
.61759 .8141 m
.66099 .77642 L
s
.61759 .8141 m
.60499 .80688 L
s
.29125 .50372 m
.33401 .48166 L
s
.29125 .50372 m
.30212 .55683 L
s
.74977 .55673 m
.76063 .5036 L
s
.71783 .48157 m
.76063 .5036 L
s
.33104 .43112 m
.38135 .41286 L
s
.33104 .43112 m
.33401 .48166 L
s
.71783 .48157 m
.72081 .43102 L
s
.67047 .41279 m
.72081 .43102 L
s
.43831 .3553 m
.49633 .34875 L
s
.43695 .40019 m
.43831 .3553 L
s
.61349 .35526 m
.61485 .40015 L
s
.56991 .35036 m
.61349 .35526 L
s
.55546 .34874 m
.56991 .35036 L
s
.28916 .63282 m
.32006 .61162 L
s
.29563 .64474 m
.31699 .68411 L
s
.28916 .63282 m
.29563 .64474 L
s
.73496 .68403 m
.75631 .64464 L
s
.75631 .64464 m
.76277 .63271 L
s
.73184 .61153 m
.76277 .63271 L
s
.46193 .80082 m
.447 .80691 L
s
.40926 .76552 m
.447 .80691 L
s
.60499 .80688 m
.64271 .76547 L
s
.60499 .80688 m
.59006 .8008 L
s
.49633 .34875 m
.55546 .34874 L
s
.49587 .39369 m
.49633 .34875 L
s
.55546 .34874 m
.55592 .39368 L
s
.39099 .77647 m
.40926 .76552 L
s
.35135 .7326 m
.39099 .77647 L
s
.69233 .74171 m
.70062 .73253 L
s
.66099 .77642 m
.69233 .74171 L
s
.64271 .76547 m
.66099 .77642 L
s
.31699 .68411 m
.34453 .66603 L
s
.31699 .68411 m
.34675 .72612 L
s
.34675 .72612 m
.35135 .7326 L
s
.70062 .73253 m
.73496 .68403 L
s
.70739 .66595 m
.73496 .68403 L
s
.35135 .7326 m
.37465 .71798 L
s
.67729 .71792 m
.70062 .73253 L
s
.47879 .79607 m
.46193 .80082 L
s
.43113 .75625 m
.46193 .80082 L
s
.59006 .8008 m
.62082 .75621 L
s
.59006 .8008 m
.57319 .79605 L
s
.30212 .55683 m
.34301 .53645 L
s
.30212 .55683 m
.32006 .61162 L
s
.73184 .61153 m
.74977 .55673 L
s
.70885 .53637 m
.74977 .55673 L
s
.38135 .41286 m
.43695 .40019 L
s
.38135 .41286 m
.38358 .46419 L
s
.66824 .46412 m
.67047 .41279 L
s
.61485 .40015 m
.67047 .41279 L
s
.49708 .79281 m
.47879 .79607 L
s
.45597 .74898 m
.47879 .79607 L
s
.57319 .79605 m
.59597 .74895 L
s
.57319 .79605 m
.5549 .7928 L
s
.33401 .48166 m
.38358 .46419 L
s
.33401 .48166 m
.34301 .53645 L
s
.70885 .53637 m
.71783 .48157 L
s
.66824 .46412 m
.71783 .48157 L
s
.40926 .76552 m
.43113 .75625 L
s
.37465 .71798 m
.40926 .76552 L
s
.67634 .71923 m
.67729 .71792 L
s
.64271 .76547 m
.67634 .71923 L
s
.62082 .75621 m
.64271 .76547 L
s
.51625 .79115 m
.49708 .79281 L
s
.48305 .74398 m
.49708 .79281 L
s
.5549 .7928 m
.56888 .74397 L
s
.5549 .7928 m
.53572 .79114 L
s
.32006 .61162 m
.35783 .59349 L
s
.32576 .62428 m
.34453 .66603 L
s
.32006 .61162 m
.32576 .62428 L
s
.53572 .79114 m
.51625 .79115 L
s
.5115 .74143 m
.51625 .79115 L
s
.53572 .79114 m
.54043 .74143 L
s
.70739 .66595 m
.72615 .6242 L
s
.72615 .6242 m
.73184 .61153 L
s
.69404 .59342 m
.73184 .61153 L
s
.43695 .40019 m
.49587 .39369 L
s
.43695 .40019 m
.43833 .45206 L
s
.61347 .45202 m
.61485 .40015 L
s
.5706 .39529 m
.61485 .40015 L
s
.55592 .39368 m
.5706 .39529 L
s
.37465 .71798 m
.40277 .70556 L
s
.34453 .66603 m
.37465 .71798 L
s
.67729 .71792 m
.70739 .66595 L
s
.67483 .71684 m
.67729 .71792 L
s
.64915 .70551 m
.67483 .71684 L
s
.34453 .66603 m
.37801 .6506 L
s
.67388 .65054 m
.70739 .66595 L
s
.43113 .75625 m
.45597 .74898 L
s
.40277 .70556 m
.43113 .75625 L
s
.62082 .75621 m
.64915 .70551 L
s
.59597 .74895 m
.62082 .75621 L
s
.49587 .39369 m
.55592 .39368 L
s
.49587 .39369 m
.49634 .44584 L
s
.55545 .44583 m
.55592 .39368 L
s
.34301 .53645 m
.39031 .52031 L
s
.34301 .53645 m
.35783 .59349 L
s
.69404 .59342 m
.70885 .53637 L
s
.66152 .52025 m
.70885 .53637 L
s
.38358 .46419 m
.43833 .45206 L
s
.38358 .46419 m
.39031 .52031 L
s
.66152 .52025 m
.66824 .46412 L
s
.61347 .45202 m
.66824 .46412 L
s
.45597 .74898 m
.48305 .74398 L
s
.43491 .69579 m
.44026 .70929 L
s
.44026 .70929 m
.45597 .74898 L
s
.59597 .74895 m
.61699 .69575 L
s
.56888 .74397 m
.59597 .74895 L
s
.40277 .70556 m
.43491 .69579 L
s
.37801 .6506 m
.40277 .70556 L
s
.65773 .68642 m
.67388 .65054 L
s
.64915 .70551 m
.65773 .68642 L
s
.61699 .69575 m
.64915 .70551 L
s
.35783 .59349 m
.4014 .57916 L
s
.36254 .6068 m
.37801 .6506 L
s
.35783 .59349 m
.36254 .6068 L
s
.67388 .65054 m
.68934 .60673 L
s
.68934 .60673 m
.69404 .59342 L
s
.65045 .57911 m
.69404 .59342 L
s
.48305 .74398 m
.5115 .74143 L
s
.47007 .68905 m
.47183 .69651 L
s
.47183 .69651 m
.48305 .74398 L
s
.56888 .74397 m
.58182 .68903 L
s
.54043 .74143 m
.56888 .74397 L
s
.37801 .6506 m
.41647 .63844 L
s
.63541 .63839 m
.67388 .65054 L
s
.5115 .74143 m
.54043 .74143 L
s
.50711 .68561 m
.5115 .74143 L
s
.54043 .74143 m
.54478 .6856 L
s
.43833 .45206 m
.49634 .44584 L
s
.43833 .45206 m
.4425 .50913 L
s
.60931 .50909 m
.61347 .45202 L
s
.57715 .44814 m
.61347 .45202 L
s
.55545 .44583 m
.57715 .44814 L
s
.39031 .52031 m
.4425 .50913 L
s
.39031 .52031 m
.4014 .57916 L
s
.65045 .57911 m
.66152 .52025 L
s
.60931 .50909 m
.65458 .51877 L
s
.65458 .51877 m
.66152 .52025 L
s
.43491 .69579 m
.47007 .68905 L
s
.41647 .63844 m
.43491 .69579 L
s
.63478 .64034 m
.63541 .63839 L
s
.61699 .69575 m
.63478 .64034 L
s
.58182 .68903 m
.61699 .69575 L
s
.49634 .44584 m
.55545 .44583 L
s
.49634 .44584 m
.49775 .50339 L
s
.55405 .50338 m
.55545 .44583 L
s
.4014 .57916 m
.44937 .56924 L
s
.40492 .59299 m
.41647 .63844 L
s
.4014 .57916 m
.40492 .59299 L
s
.63541 .63839 m
.64694 .59293 L
s
.64694 .59293 m
.65045 .57911 L
s
.6078 .57031 m
.62072 .57298 L
s
.62072 .57298 m
.65045 .57911 L
s
.60246 .56921 m
.6078 .57031 L
s
.41647 .63844 m
.45868 .63003 L
s
.63375 .63806 m
.63541 .63839 L
s
.59318 .63 m
.63375 .63806 L
s
.47007 .68905 m
.49036 .68716 L
s
.49036 .68716 m
.50711 .68561 L
s
.45868 .63003 m
.47007 .68905 L
s
.58182 .68903 m
.59318 .63 L
s
.54478 .6856 m
.58182 .68903 L
s
.4425 .50913 m
.49775 .50339 L
s
.4425 .50913 m
.44937 .56924 L
s
.6038 .55748 m
.60931 .50909 L
s
.60246 .56921 m
.6038 .55748 L
s
.5895 .50704 m
.60931 .50909 L
s
.55405 .50338 m
.5895 .50704 L
s
.50711 .68561 m
.54478 .6856 L
s
.50324 .62573 m
.50659 .67764 L
s
.50659 .67764 m
.50711 .68561 L
s
.54715 .6485 m
.54861 .62572 L
s
.54478 .6856 m
.54715 .6485 L
s
.55405 .50338 m
.49775 .50339 L
s
.49775 .50339 m
.50008 .56416 L
s
.55405 .50338 m
.55174 .56415 L
s
.50324 .62573 m
.45868 .63003 L
s
.44937 .56924 m
.45868 .63003 L
s
.60246 .56921 m
.59318 .63 L
s
.59318 .63 m
.54861 .62572 L
s
.50008 .56416 m
.44937 .56924 L
s
.60246 .56921 m
.55174 .56415 L
s
.54861 .62572 m
.50324 .62573 L
s
.50008 .56416 m
.50324 .62573 L
s
.55174 .56415 m
.54861 .62572 L
s
.55174 .56415 m
.50008 .56416 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[297]:=",
  ImageSize->{300, 326.188},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004/0001AR000`400?l00000o`00003oo`3oool]
0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]
0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]
0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]
0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]
0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]
0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]
0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]
0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]
0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]
0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]
0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]
0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]
0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]
0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]
0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]
0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00U@3ooolA000008H0oooo002?0?oooad00000P03o
ool008T0oooo:@00001j0?ooo`00P`3oool@000000<0oooo00@000000?ooo`3oool000001`3oool0
10000000oooo0?ooo`0000030?ooo`l00000M@3oool007l0oooo3@0000050?oooaT00000103oool>
00000700oooo001m0?ooo`<000000P3oool400000080oooo0P0000030?ooo`@000000P3oool00`00
0000oooo000000030?ooo`030000003oool0oooo00@0oooo00D000000?ooo`3oool0oooo00000002
0?ooo`030000003oool0oooo00<000000`3oool30000000308E:P@000000000000<000000P3oool3
000006h0oooo001j0?ooo`P000001@3oool00`000000oooo0?ooo`03000000H0oooo00<000000?oo
o`0000000`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo0P0000060?oo
o`<000000P25BX4010000000QDZ10000000000020?ooo`@0000000<0oooo0000000000000P00001[
0?ooo`00N03oool7000000P0oooo0`0000020?ooo`030000003oool0oooo00D0oooo0P0000040?oo
o`030000003oool0oooo0080oooo00<000000?ooo`3oool00`3oool2000000@0oooo0`00000508E:
P@80000000<0nJeQ0000003oool00`3oool8000006T0oooo001f0?ooo`L0000000<0oooo00000000
00000P0000040?ooo`8000001@3ooolP000000H0QDZ10P0000020?V]H@@000000`3oool7000006L0
oooo001d0?ooo`@0000000<0oooo0000000000001`3oool>000000D0oooo4`00000508E:P@T00000
0P3i[F400`000000oooo0?ooo`040?ooo`D0000000<0oooo000000000000I@3oool00780oooo1000
0000103oool000000000000000070?ooo`@0000000<0oooo000000000000203oool00`000000oooo
0?ooo`04000000<0oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`3oool3000000h0
QDZ100<000000?V]H@0000000`0000060?ooo`030000003oool0000000H00000H`3oool00700oooo
0`0000000`3oool000000000000500000080oooo1@0000040?ooo`030000003oool0000000800000
103oool400000080oooo0P0000030?ooo`030000003oool0oooo0080oooo1000000208E:P@030000
0025BX40QDZ100`0QDZ100<000000?V]H@3i[F400P3i[F4500000080oooo2`00001Q0?ooo`00KP3o
ool7000000<0oooo2P0000030?ooo`030000003oool0oooo00<0oooo100000030?ooo`030000003o
ool000000080oooo00D000000?ooo`3oool0oooo000000020?ooo`8000001@25BX400`000000QDZ1
08E:P@0<08E:P@800000103i[F48000000<0oooo00<000000?ooo`0000001@00001O0?ooo`00K@3o
ool3000000<0oooo00<000000?ooo`3oool00`0000040?ooo`8000000`3oool5000000<0oooo0P00
00000`3oool00000000000040?ooo`8000000P3oool010000000oooo0?ooo`3oool3000000L0QDZ1
00<0000008E:P@25BX403025BX42000000D0nJeQ0P0000040?ooo`<000000P3oool00`000000oooo
0?ooo`020?ooo`<00000GP3oool006/0oooo0`0000040?ooo`060000003oool000000000003oool0
00000`3oool2000000P0oooo00<000000?ooo`0000000`0000040?ooo`8000000`3oool010000000
oooo0?ooo`3oool3000000X0QDZ100<0000008E:P@25BX403025BX42000000D0nJeQ00@000000?oo
o`00000000000`3oool00`000000oooo00000004000000<0oooo1000001L0?ooo`00JP3oool30000
00<0oooo100000000`3oool0000000000006000000P0oooo00@000000?ooo`3oool000000P3oool2
000000@0oooo0P0000000`3oool0000000000002000000d0QDZ100<0000008E:P@25BX403025BX42
000000H0nJeQ00<000000?ooo`3oool01@0000030?ooo`<000000`3oool010000000oooo00000000
001K0?ooo`00J03oool200000080oooo00<000000?ooo`0000001P0000001@3oool000000?ooo`3o
ool0000000<0oooo1P0000000`3oool000000?ooo`02000000D0oooo0P0000020?oooad000001P25
BX400`000000nJeQ000000060?V]H@80000000@0oooo0000003oool0oooo2@0000020?ooo`030000
003oool0000000800000F@3oool006H0oooo0`0000020?ooo`@000001P3oool010000000oooo0?oo
o`00000:0?ooo`@000000P3oool:0000000308E:P@000000QDZ100l0QDZ100<0000008E:P@25BX40
1P25BX47000000030?V]H@000000nJeQ00D0nJeQ00L000000?ooo`3oool0oooo0000003oool00000
00L0oooo1@0000020?ooo`<00000E`3oool006D0oooo1`0000020?ooo`030000003oool0oooo00@0
oooo00@000000?ooo`3oool000002@3oool900000080oooo0`00000408E:P@0300000025BX40QDZ1
00h0QDZ100<0000008E:P@25BX403025BX45000000D0nJeQ00L000000?ooo`3oool0oooo0000003o
ool0000000L0oooo00<000000?ooo`3oool01`00001F0?ooo`00H`3oool800000080oooo00<00000
0?ooo`3oool01@3oool00`000000oooo000000050?ooo`D000000P3oool00`000000oooo0?ooo`04
0?ooo`8000001`25BX400`000000QDZ108E:P@0>08E:P@0300000025BX40QDZ100`0QDZ100<00000
0?V]H@0000000P3i[F45000000030?V]H@000000000000D000001P3oool010000000oooo0?ooo`3o
ool5000000030?ooo`000000oooo05@0oooo001R0?ooo`<0000000D0oooo000000000000oooo0000
00020?ooo`030000003oool0oooo00D0oooo5`00000908E:P@0300000025BX40QDZ100h0QDZ100<0
000008E:P@25BX403@25BX42000000L0nJeQ1@0000000`22YN/0000000000004000000<0oooo00H0
00000?ooo`3oool0oooo0000003oool6000005<0oooo001P0?ooo`<0000000<0oooo000000000000
0`3oool01@000000oooo0?ooo`000000oooo00T000002`3oool00`000000oooo00000003000000`0
QDZ100<0000008E:P@25BX403P25BX400`000000QDZ108E:P@0=08E:P@8000002@3i[F400`000000
PZG[08:Uj`0400000080J9KZ1P0000020?ooo`040000003oool0oooo0?ooo`D00000DP3oool005l0
oooo1@0000040?ooo`030000003oool0000000<000000`3oool2000000030?ooo`000000000000`0
oooo0`00000?08E:P@0300000025BX40QDZ100l0QDZ100<0000008E:P@25BX403025BX42000000X0
nJeQ00H0000008:Uj`22YN/0PZG[0000001XU^X2000000@0J9KZ100000000`3oool000000?ooo`03
0?ooo`@00000D@3oool005d0oooo1P0000030?ooo`D00000103oool2000000<0oooo00<000000?oo
o`3oool0103oool80000000308E:P@000000QDZ100h0QDZ100<0000008E:P@25BX403`25BX400`00
0000QDZ108E:P@0<08E:P@8000002`3i[F4010000000PZG[08:Uj`00000306RFjP<00000101XU^X4
000000<0oooo00<000000?ooo`0000000`00001?0?ooo`00G03oool2000000040?ooo`000000oooo
00000080oooo0P000000103oool000000?ooo`0000020?ooo`<000000`3oool900000080oooo0`00
000308E:P@0300000025BX40QDZ100h0QDZ100<0000008E:P@25BX403`25BX400`000000QDZ108E:
P@0<08E:P@030000003i[F40000000/0nJeQ1@00000406RFjP8000000P1XU^X00`000000@goT04=o
i00300000080oooo00<000000?ooo`3oool00`00001>0?ooo`00F`3oool010000000oooo0?ooo`00
00020?ooo`<000000`3oool00`000000oooo0000000200000080oooo100000000`3oool000000?oo
o`060?ooo`8000001P25BX400`000000QDZ108E:P@0>08E:P@0300000025BX40QDZ100l0QDZ100<0
000008E:P@25BX403025BX400`000000nJeQ0000000;0?V]H@0500000026X^H0QZ;V0000001`Tn@0
1000000206RFjP@0000000@0@goT00000013On@0@goT100000020?ooo`030000003oool0000004d0
oooo001J0?ooo`030000003oool000000080000000<0oooo000000000000103oool00`000000oooo
00000005000000D0oooo00<000000?ooo`3oool00P3oool3000000P0QDZ100<0000008E:P@25BX40
3P25BX400`000000QDZ108E:P@0?08E:P@0300000025BX40QDZ100`0QDZ100<000000?V]H@000000
303i[F400`000000QZ;V00000005072Ci0@0000000D0J9KZ000000000000@goT0000000404=oi080
000000<0oooo0000000000000P00001<0?ooo`00F@3oool3000000040?ooo`0000000000000000H0
oooo100000080?ooo`80000000@0oooo00000000000000002`25BX400`000000QDZ108E:P@0:08E:
PAh000001`25BX400`000000nJeQ0000000=0?V]H@<00000201`Tn@5000000H0@goT1P00001;0?oo
o`00F03oool3000000050?ooo`00000000000?ooo`000000103oool4000000X0oooo0`00000>08E:
P@0300000025BX40QDZ10080QDZ12000000408E:P@0300000025BX40QDZ100l0QDZ100<0000008E:
P@25BX401@25BX460000000408E:P@000000nJeQ000000h0nJeQ0P00000:072Ci0D000001013On@0
0`0000003e[C00000003000004/0oooo001H0?ooo`D0000000<0oooo0000003oool00P3oool40000
00030?ooo`000000oooo00L0oooo0P0000000`25BX40000008E:P@0<08E:P@L000003025BX400`00
0000QDZ108E:P@0?08E:P@0300000025BX40QDZ100/0QDZ11P00000<0?V]H@<000002P1`Tn@60000
00<0@goT00<0000000mJd`0000000`00001:0?ooo`00E`3oool300000080oooo0P0000030?ooo`80
00000P3oool2000000H0oooo0`00000208E:P@0300000025BX40QDZ100H0QDZ11P00000208E:P@03
00000025BX40QDZ100h0QDZ100<0000008E:P@25BX403`25BX400`000000QDZ108E:P@0<08E:P@03
0000003i[F4000000080nJeQ1@0000080?V]H@030000001hTMl00000008000001`1`Tn@010000000
E7oO0000001DOml40000000504=oi00000003e[C0000000?F]<00`0000190?ooo`00EP3oool20000
00<0oooo00@000000?ooo`000000oooo0P0000040?ooo`8000000`3oool3000000D0QDZ100<00000
08E:P@25BX401P00000808E:P@0300000025BX40QDZ100h0QDZ100<0000008E:P@25BX403`25BX40
0`000000QDZ108E:P@0<08E:P@030000003i[F40000000L0nJeQ1P0000020?V]H@8000000`1hTMl4
000000<0L9?T00<0000005Aog`0000000`1DOml50000000300mJd`0000003e[C00<00000B03oool0
05D0oooo0P0000040?ooo`@000001P3oool2000000030?ooo`000000000000L0QDZ11000000>08E:
P@0300000025BX40QDZ100h0QDZ100<0000008E:P@25BX403`25BX400`000000QDZ108E:P@0<08E:
P@030000003i[F40000000d0nJeQ1000000707RAg`<0000000<0L9?T0000000000001@1DOml50000
00<03e[C0P0000170?ooo`00E03oool2000000@0oooo0`0000070?ooo`@000001`25BX4200000003
08E:P@000000QDZ100l0QDZ100<0000008E:P@25BX403P25BX400`000000QDZ108E:P@0?08E:P@03
00000025BX40QDZ100`0QDZ100<000000?V]H@0000003`3i[F4010000000nJeQ00000000000807RA
g`<000001`1DOml4000000<03e[C0P0000160?ooo`00D`3oool3000000@0oooo0`0000050?ooo`<0
00001`25BX43000000<0QDZ100<0000008E:P@25BX403P25BX400`000000QDZ108E:P@0>08E:P@03
00000025BX40QDZ100l0QDZ100<0000008E:P@25BX403025BX400`000000nJeQ0000000?0?V]H@03
0000003i[F40nJeQ00@000001P1hTMl3000000L0E7oO1000000200mJd`<00000A@3oool00580oooo
0`0000030?ooo`@00000103oool200000080QDZ100<0000008E:P@25BX400`25BX42000000H0QDZ1
00<0000008E:P@25BX403P25BX400`000000QDZ108E:P@0>08E:P@0300000025BX40QDZ100l0QDZ1
00<0000008E:P@25BX403025BX400`000000nJeQ0000000?0?V]H@040000003i[F40nJeQ0?V]H@80
000000<0N97O000000000000101hTMl20000000306Aof@000000000000H0E7oO1@000000100?F]<0
00000000000000140?ooo`00D@3oool400000080oooo00H000000?ooo`000000oooo0000003oool3
000000@0QDZ100<0000008E:P@25BX400`00000808E:P@0300000025BX40QDZ100d0QDZ100<00000
08E:P@25BX403`25BX400`000000QDZ108E:P@0?08E:P@0300000025BX40QDZ100`0QDZ100<00000
0?V]H@0000003`3i[F401P000000nJeQ0?V]H@3i[F400000082@fP80000000P0N97O000000000000
000007RAg`000000I7oI00000080I7oI00<0000005Aog`1DOml00`1DOml01@000000;f;C00000000
00003e[C0080000000<0022/0000003oool0@`3oool00540oooo0`0000000`3oool0000000000002
0?ooo`@000001P25BX4010000000QDZ100000000000;08E:P@0300000025BX40QDZ100d0QDZ100<0
000008E:P@25BX403`25BX400`000000QDZ108E:P@0?08E:P@0300000025BX40QDZ100`0QDZ100<0
00000?V]H@0000003`3i[F400`000000nJeQ0?V]H@020?V]H@0300000020T=X0P93J008000000P1h
TMl20000000306Aof@000000I7oI0080I7oI0P00000305Aog`040000000_H]<0000002mRd`H00000
@`3oool00500oooo00<000000?ooo`0000000`0000020?ooo`8000002@25BX42000000d0QDZ100<0
000008E:P@25BX403@25BX400`000000QDZ108E:P@0?08E:P@0300000025BX40QDZ100l0QDZ100<0
000008E:P@25BX403025BX400`000000nJeQ0000000?0?V]H@030000003i[F40nJeQ00<0nJeQ00@0
0000082@fP20T=X0P93J0P000000101hTMl0000000000000000506Aof@80000000@0E7oO0000000_
H]<000000`0_H]<500000480oooo001?0?ooo`030000003oool000000080000000H0oooo00000000
0000000008E:P@00000708E:P@<000003P25BX400`000000QDZ108E:P@0=08E:P@0300000025BX40
QDZ100l0QDZ100<0000008E:P@25BX403`25BX400`000000QDZ108E:P@0<08E:P@030000003i[F40
000000l0nJeQ00<000000?V]H@3i[F40103i[F400`000000P93J082@fP02082@fP80000000@0I7oI
00000000000000001@1TOmT010000000E7oO00000000000402mRd`D00000@@3oool004h0oooo00<0
00000?ooo`3oool01000000308E:P@0300000025BX40QDZ100@0QDZ10P00000208E:P@0300000025
BX40QDZ100`0QDZ100<0000008E:P@25BX403@25BX400`000000QDZ108E:P@0;08E:PAP000003@25
BX400`000000nJeQ0000000@0?V]H@030000003i[F40nJeQ00<0nJeQ00<00000082@fP20T=X00`20
T=X300000080I7oI0P00000506Aof@030000000_H]<0000000D0;f;C0P0000000`008:`000000?oo
o`0o0?ooo`00C@3oool00`000000oooo0?ooo`04000000@0QDZ100<0000008E:P@25BX400`25BX40
0`000000QDZ108E:P@0208E:P@0300000025BX40QDZ100`0QDZ100<0000008E:P@25BX403@25BX40
0`000000QDZ108E:P@0208E:P@T000001025BX400`000000QDZ108E:P@0?08E:P@0300000025BX40
000000P000001025BX400`000000nJeQ0000000@0?V]H@030000003i[F40nJeQ00@0nJeQ00<00000
082@fP20T=X00P20T=X010000000LH3C00000000000306Aof@8000000`1TOmT3000000D0;f;C0`00
00000`008:`000000?ooo`0n0?ooo`00C@3oool00`000000oooo00000002000000030?ooo`000000
QDZ100<0QDZ100@0000008E:P@25BX40QDZ10P00000508E:P@0300000025BX40QDZ100`0QDZ100<0
000008E:P@25BX403025BX46000000d0QDZ100<0000008E:P@25BX403`25BX400`000000QDZ108E:
P@0808E:P@T000003P3i[F400`000000nJeQ0?V]H@050?V]H@0400000020T=X0P93J00000080LH3C
00@000000760d`00000000000`1TOmT20000000306Aof@000000BFS?00800000100_H]<00`000000
03Nk00000002000003l0oooo001<0?ooo`080000003oool000000000003oool000000?ooo`000004
08E:P@0400000025BX400000000000L0QDZ100<0000008E:P@25BX403025BX400`000000QDZ108E:
P@0808E:P@@0000000<0QDZ100000025BX404025BX400`000000QDZ108E:P@0?08E:P@0300000025
BX40QDZ100`0QDZ100<000000?V]H@0000000P3i[F44000000X0nJeQ00<000000?V]H@3i[F401@3i
[F4010000000P93J082@fP0000020760d`050000001aP=<0LH3C0760d`000000101TOmT200000004
04UXc`000000BFS?000000@0;f;C1@00000n0?ooo`00C03oool4000000040?ooo`000000oooo0000
00<0QDZ10`00000908E:P@0300000025BX40QDZ100`0QDZ100<0000008E:P@25BX401025BX440000
00D0QDZ100<0000008E:P@25BX403`25BX400`000000QDZ108E:P@0?08E:P@0300000025BX40QDZ1
00`0QDZ100<000000?V]H@0000001P3i[F44000000H0nJeQ00<000000?V]H@3i[F401P3i[F400`00
0000P93J000000020760d`030000001aP=<0LH3C0080LH3C0P00000306Aof@@0000000<0BFS?0000
000_H]<00P0_H]<00`00000003Nk00000002000003h0oooo001;0?ooo`<0000000H0oooo0000003o
ool000000?ooo`00000308E:P@0300000025BX40QDZ100P0QDZ100<0000008E:P@25BX403@25BX40
0`000000QDZ108E:P@04000000T0QDZ100<0000008E:P@25BX403`25BX400`000000QDZ108E:P@0?
08E:P@0300000025BX40QDZ100`0QDZ100<000000?V]H@0000002P3i[F4400000080nJeQ00<00000
0?V]H@3i[F401`3i[F42000000<0LH3C00<000000760d`1aP=<00`1aP=<010000000I7oI06Aof@00
000204UXc`0400000019J<l0BFS?00000080;f;C00<00000000g^`0000000`00000m0?ooo`00BP3o
ool5000000060?ooo`000000oooo0?ooo`000000QDZ10`00000:08E:P@0300000025BX40QDZ100`0
QDZ11000000=08E:P@0300000025BX40QDZ100l0QDZ100<0000008E:P@25BX403`25BX400`000000
QDZ108E:P@0<08E:P@030000003i[F40000000h0nJeQ100000090?V]H@8000000P1aP=<00`000000
LH3C0760d`040760d`<000000P19J<l200000080BFS?0`0000000`00=k/00000000g^`03000003`0
oooo001:0?ooo`<0000000<0oooo0000003oool00`0000001@25BX40000008E:P@25BX40000000X0
QDZ100<0000008E:P@25BX402@25BX430000000308E:P@000000QDZ100h0QDZ100<0000008E:P@25
BX403`25BX400`000000QDZ108E:P@0?08E:P@0300000025BX40QDZ100`0QDZ100<000000?V]H@00
0000403i[F400`000000nJeQ00000002000000H0nJeQ00<0000007b2cP0000000P0000080760d`05
00000019J<l0BFS?00000019J<l00P00000204UXc`<000000P00=k/2000003`0oooo00190?ooo`<0
00000P3oool010000000oooo0000003oool2000000<0QDZ100<0000008E:P@25BX402025BX400`00
0000QDZ108E:P@0608E:P@<000001025BX400`000000QDZ108E:P@0=08E:P@0300000025BX40QDZ1
00l0QDZ100<0000008E:P@25BX403`25BX400`000000QDZ108E:P@0<08E:P@030000003i[F400000
0100nJeQ00<000000?V]H@3i[F400P3i[F43000000@0nJeQ00@0000007b2cP1lP/h00000201aP=<2
0000000304UXc`000000BFS?0080BFS?00H0000004UXc`19J<l00000000g^`000002000g^`800000
>`3oool004T0oooo0P0000020?ooo`030000003oool0000000<000001025BX400`000000QDZ108E:
P@0808E:P@0300000025BX40QDZ10080QDZ11000000708E:P@0300000025BX40QDZ100d0QDZ100<0
000008E:P@25BX403`25BX400`000000QDZ108E:P@0?08E:P@0300000025BX40QDZ100`0QDZ100<0
00000?V]H@000000403i[F400`000000nJeQ0?V]H@050?V]H@<000000P3i[F4010000000O8;>0000
000000060760d`030000001NKLX0GVg:008000001019J<l00`000000BFS?00000002000000<003Nk
00<000000?ooo`3oool0>@3oool004P0oooo0`0000020?ooo`80000000@0oooo0000003oool00000
1025BX400`000000QDZ108E:P@0808E:P@0300000025BX400000008000002`25BX400`000000QDZ1
08E:P@0=08E:P@0300000025BX40QDZ100l0QDZ100<0000008E:P@25BX403`25BX400`000000QDZ1
08E:P@0<08E:P@030000003i[F4000000100nJeQ00<000000?V]H@3i[F40203i[F450000000307b2
cP000000LH3C00@0LH3C00D0000005i]bP1NKLX0GVg:0000000504UXc`80000000<0:4Rn00000000
=k/00P00=k/2000003X0oooo00170?ooo`<000000`3oool01P000000oooo000000000000oooo0000
00@0QDZ100<0000008E:P@25BX402025BX42000000h0QDZ100<0000008E:P@25BX403P25BX400`00
0000QDZ108E:P@0>08E:P@0300000025BX40QDZ100l0QDZ100<0000008E:P@25BX403@25BX420000
0100nJeQ00<000000?V]H@3i[F402`3i[F4200000080O8;>00<000000760d`1aP=<00P1aP=<01000
0000GVg:05i]bP1NKLX2000000D0BFS?0`000003000g^`<00000>@3oool004L0oooo0`0000020?oo
o`<0000000@0oooo0000003oool000000`25BX400`000000QDZ108E:P@0708E:P@<000003`25BX40
0`000000QDZ108E:P@0>08E:P@0300000025BX40QDZ100h0QDZ100<0000008E:P@25BX403`25BX40
0`000000QDZ108E:P@0=08E:P@800000403i[F400`000000nJeQ0?V]H@0<0?V]H@<0000000<0O8;>
0000000000000P1aP=<00`000000GVg:05i]bP0205i]bP<000000`19J<l010000000:4Rn00000000
0003000g^`800000>@3oool004H0oooo0P0000000`3oool000000?ooo`02000000<0oooo00<00000
0?ooo`0000000`25BX400`000000QDZ108E:P@0508E:P@8000000P25BX400`000000QDZ108E:P@0=
08E:P@0300000025BX40QDZ100h0QDZ100<0000008E:P@25BX403P25BX400`000000QDZ108E:P@0?
08E:P@0300000025BX40QDZ100d0QDZ10P00000@0?V]H@030000003i[F40nJeQ00`0nJeQ0P000000
101lP/h000000000001lP/h2000000D0GVg:00@0000005i]bP1NKLX000000P19J<l00`000000:4Rn
02Q8_P020000008003Nk0`00000h0?ooo`00AP3oool300000080oooo0P0000030?ooo`030000003o
ool0000000<0QDZ100<0000008E:P@25BX401025BX400`000000QDZ108E:P@0208E:P@0300000025
BX40QDZ100d0QDZ100<0000008E:P@25BX403P25BX400`000000QDZ108E:P@0>08E:P@0300000025
BX40QDZ100l0QDZ100<0000008E:P@25BX403@25BX42000000l0nJeQ00<000000?V]H@3i[F403@3i
[F400`000000nJeQ0000000207b2cP<000001@1NKLX01`000000GVg:05i]bP1NKLX0000004UXc`00
00000P0XB;h300000004000g^`0000000000000003P0oooo00150?ooo`80000000H0oooo0000003o
ool000000?ooo`0000030?ooo`<000000`25BX400`000000QDZ108E:P@0208E:P@8000001@25BX40
0`000000QDZ108E:P@0=08E:P@0300000025BX40QDZ100h0QDZ100<0000008E:P@25BX403P25BX40
0`000000QDZ108E:P@0?08E:P@0300000025BX40QDZ100d0QDZ10P00000?0?V]H@030000003i[F40
nJeQ00d0nJeQ00<000000?V]H@0000000`1lP/h3000000@0GVg:00<0000005i]bP1NKLX00P1NKLX2
00000080:4Rn00<0000002Q8_P0000000P0000000`0008l000000000000g0?ooo`00A@3oool20000
00030?ooo`00000000000080oooo00L000000?ooo`3oool0oooo0000003oool0000000<0QDZ100<0
000008E:P@25BX400P00000708E:P@0300000025BX40QDZ100d0QDZ100<0000008E:P@25BX403P25
BX400`000000QDZ108E:P@0:08E:PB8000001025BX42000000l0nJeQ00<000000?V]H@3i[F403@3i
[F4010000000nJeQ0?V]H@00000207b2cP030000001^L/D0KW;5008000000P1NKLX00`000000GVg:
05i]bP0305i]bP040000000XB;h0:4Rn00000080:4Rn00<00000000g^`0000000P00000g0?ooo`00
A03oool00`000000oooo00000002000000<0oooo00<000000?ooo`3oool00P0000000`3oool00000
08E:P@0208E:P@<000002@25BX400`000000QDZ108E:P@0=08E:P@0300000025BX40QDZ100h0QDZ1
00<0000008E:P@25BX400P25BX48000000@0QDZ100<0000008E:P@25BX403`25BX400`000000QDZ1
08E:P@0908E:P@L000003P3i[F400`000000nJeQ0?V]H@0=0?V]H@040000003i[F40nJeQ0?V]H@80
0000101^L/D4000000D0GVg:0P00000202Q8_P030000000XB;h0:4Rn00<0000000<0dgL00000003o
ool0=@3oool004@0oooo0P0000000`3oool00000000000030?ooo`030000003oool0oooo00800000
00<0oooo00000025BX400P25BX400`000000QDZ108E:P@0908E:P@0300000025BX40QDZ100d0QDZ1
00<0000008E:P@25BX403025BX47000000`0QDZ100<0000008E:P@25BX403`25BX400`000000QDZ1
08E:P@0=08E:P@80000000<0nJeQ0000000000000P00000:0?V]H@030000003i[F40nJeQ00d0nJeQ
00@000000?V]H@3i[F40nJeQ0P00000406iba@80000000<0GVg:0000001NKLX00`1NKLX00`000000
AeFm0000000202Q8_P030000000XB;h0:4Rn0080000000<0002?000000000000=P3oool004<0oooo
00<000000?ooo`0000000P0000040?ooo`080000003oool000000?ooo`000000oooo00000025BX43
000000`0QDZ100<0000008E:P@25BX403025BX400`000000QDZ108E:P@0608E:P@H000000P25BX40
0`000000QDZ108E:P@0>08E:P@0300000025BX40QDZ100l0QDZ100<0000008E:P@25BX403@25BX42
000000D0nJeQ100000060?V]H@030000003i[F40nJeQ00`0nJeQ00<000000?V]H@3i[F400`3i[F40
0`000000KW;506iba@0306iba@D000000P1NKLX01P000000AeFm04ME_@000000:4Rn000000<0:4Rn
0`0000000`3CM`0000000?ooo`0d0?ooo`00@`3oool00`000000oooo00000002000000<0oooo00<0
00000?ooo`0000000`3oool00`000000QDZ10000000208E:P@0300000025BX40QDZ100X0QDZ100<0
000008E:P@25BX403025BX400`000000QDZ108E:P@06000000P0QDZ100<0000008E:P@25BX403P25
BX400`000000QDZ108E:P@0?08E:P@0300000025BX40QDZ100d0QDZ10P0000090?V]H@@000000P3i
[F400`000000nJeQ0?V]H@0<0?V]H@030000003i[F40nJeQ00@0nJeQ00<0000006iba@1^L/D00`1^
L/D200000080GVg:00<0000005i]bP0000000`17EKd2000000<0:4Rn0`0000000`3CM`0000000?oo
o`0d0?ooo`00@P3oool4000000030?ooo`000000oooo0080oooo0P0000040?ooo`8000000`25BX40
0`000000QDZ108E:P@0:08E:P@0300000025BX40QDZ100/0QDZ11000000>08E:P@0300000025BX40
QDZ100h0QDZ100<0000008E:P@25BX403`25BX400`000000QDZ108E:P@0=08E:P@8000003@3i[F44
000000d0nJeQ00<000000?V]H@3i[F401@3i[F400`000000KW;506iba@0306iba@8000000P1NKLX2
000000@0AeFm00H0000002Q8_P0XB;h0:4Rn000000007J<2000000030==g00000000oooo03<0oooo
00120?ooo`060000003oool000000000003oool000000`3oool2000000<0oooo0P00000408E:P@03
00000025BX40QDZ100X0QDZ100<0000008E:P@25BX402025BX430000000308E:P@000000QDZ100l0
QDZ100<0000008E:P@25BX403P25BX400`000000QDZ108E:P@0?08E:P@0300000025BX40QDZ100d0
QDZ10P00000?0?V]H@030000003i[F400000008000002P3i[F400`000000nJeQ0?V]H@050?V]H@03
0000001^L/D0KW;500<0KW;50`000000101NKLX0000000000000000304ME_@060000000XB;h0:4Rn
02Q8_P00000001fS0P0000000`3CM`0000000?ooo`0c0?ooo`00@P3oool3000000<0oooo00@00000
0?ooo`3oool000000`3oool00`000000oooo0000000408E:P@0300000025BX40QDZ100X0QDZ100<0
000008E:P@25BX401@25BX43000000@0QDZ100<0000008E:P@25BX403P25BX400`000000QDZ108E:
P@0>08E:P@0300000025BX40QDZ100l0QDZ100<0000008E:P@25BX403@25BX42000000l0nJeQ00<0
00000?V]H@3i[F400P3i[F43000000L0nJeQ00<000000?V]H@3i[F401P3i[F400`000000KW;506ib
a@0206iba@030000001^L/D00000008000000P17EKd01@000000AeFm04ME_@17EKd000000080:4Rn
00<00000000MX`007J<00`00000d0?ooo`00@@3oool4000000<0oooo00@000000?ooo`0000000000
0P3oool010000000oooo0?ooo`00000408E:P@0300000025BX40QDZ100X0QDZ100<0000008E:P@25
BX400P25BX43000000L0QDZ100<0000008E:P@25BX403P25BX400`000000QDZ108E:P@0>08E:P@03
00000025BX40QDZ100l0QDZ100<0000008E:P@25BX403@25BX42000000l0nJeQ00<000000?V]H@3i
[F401@3i[F43000000@0nJeQ00<000000?V]H@3i[F401`3i[F401@000000KW;506iba@1^L/D00000
00<0KW;500D0000004ME_@17EKd0AeFm0000000204ME_@80000000@0:4Rn000000007J<001fS0P00
00000`3CM`0000000?ooo`0b0?ooo`00@@3oool4000000<0oooo0P000000103oool0000000000000
00030?ooo`0300000025BX40QDZ10080QDZ100<0000008E:P@25BX402P25BX400`000000QDZ10000
0002000000X0QDZ100<0000008E:P@25BX403P25BX400`000000QDZ108E:P@0>08E:P@0300000025
BX40QDZ100h0QDZ100<0000008E:P@25BX403P25BX42000000l0nJeQ00<000000?V]H@3i[F40203i
[F43000000030?V]H@000000nJeQ00T0nJeQ00@0000006iba@1^L/D000000P1^L/D00`000000Gejj
0000000304ME_@<0000000<0AeFm0000000000000P007J<010000000mZTm00000000000c0?ooo`00
@@3oool4000000<0oooo0P0000000`3oool000000?ooo`040?ooo`0300000025BX40QDZ100<0QDZ1
00<0000008E:P@25BX402@25BX42000000h0QDZ100<0000008E:P@25BX403@25BX400`000000QDZ1
08E:P@0>08E:P@0300000025BX40QDZ100h0QDZ100<0000008E:P@25BX403P25BX400`000000nJeQ
0?V]H@0=0?V]H@030000003i[F40nJeQ00`0nJeQ0P00000:0?V]H@030000001^L/D0000000<0KW;5
00<0000005mN^P0000001@17EKd010000000AeFm000000000002000MX`040000003fZCd000000000
03<0oooo00100?ooo`<0000000<0oooo0000003oool00P3oool010000000oooo0000000000040?oo
o`8000001@25BX400`000000QDZ108E:P@0708E:P@<000003`25BX400`000000QDZ108E:P@0>08E:
P@0300000025BX40QDZ100d0QDZ100<0000008E:P@25BX403P25BX400`000000QDZ108E:P@0>08E:
P@030000003i[F40nJeQ00d0nJeQ00<000000?V]H@3i[F403@3i[F43000000T0nJeQ0P00000206ib
a@050000001OG[X0Gejj05mN^P0000001017EKd20000000504ME_@00000001fS000MX`0000000P3f
ZCd200000380oooo00100?ooo`<0000000@0oooo0000003oool0oooo0`0000000`3oool000000?oo
o`020?ooo`030000003oool0000000D0QDZ100<0000008E:P@25BX401@25BX4200000080QDZ100<0
000008E:P@25BX403@25BX400`000000QDZ108E:P@0>08E:P@0300000025BX40QDZ100d0QDZ100<0
000008E:P@25BX403P25BX400`000000QDZ108E:P@0>08E:P@030000003i[F40nJeQ00d0nJeQ00<0
00000?V]H@3i[F403@3i[F400`000000nJeQ0?V]H@02000000P0nJeQ00<0000006iba@0000001@1O
G[X01P000000AeFm04ME_@17EKd0000004ME_@<0000000@001fS0000003fZCd0mZTm0P00000b0?oo
o`00@03oool2000000030?ooo`000000oooo0080oooo0P0000020?ooo`070000003oool0oooo0?oo
o`000000oooo0000000508E:P@0300000025BX40QDZ100@0QDZ100<0000008E:P@25BX400`25BX40
0`000000QDZ108E:P@0<08E:P@0300000025BX40QDZ100h0QDZ100<0000008E:P@25BX403@25BX40
0`000000QDZ108E:P@0>08E:P@0300000025BX40QDZ100h0QDZ100<000000?V]H@3i[F403@3i[F40
0`000000nJeQ0?V]H@0<0?V]H@030000003i[F40nJeQ00<0nJeQ0P0000060?V]H@030000001^L/D0
000000D0Gejj00T0000004ME_@17EKd0AeFm00000017EKd0000002XfZP0000000P007J<010000000
mZTm0?JY?@00000b0?ooo`00?`3oool3000000040?ooo`000000oooo0?ooo`80000000@0oooo0000
003oool000000P3oool010000000oooo0?ooo`00000508E:P@0300000025BX40QDZ10080QDZ10P00
000608E:P@0300000025BX40QDZ100`0QDZ100<0000008E:P@25BX403P25BX400`000000QDZ108E:
P@0=08E:P@0300000025BX40QDZ100h0QDZ100<0000008E:P@25BX403P25BX400`000000nJeQ0?V]
H@0=0?V]H@030000003i[F40nJeQ00`0nJeQ00<000000?V]H@3i[F401@3i[F42000000@0nJeQ0P00
000705mN^P0300000017EKd000000080AeFm0P000000100Z=ZX00000000MX`0000020?JY?@800000
<@3oool003l0oooo0`000000103oool000000?ooo`3oool2000000060?ooo`000000oooo0000003o
ool000000`3oool00`000000QDZ108E:P@0308E:P@0300000025BX40QDZ1008000002025BX400`00
0000QDZ108E:P@0<08E:P@0300000025BX40QDZ100h0QDZ100<0000008E:P@25BX403@25BX400`00
0000QDZ108E:P@0>08E:P@0300000025BX40QDZ100h0QDZ100<000000?V]H@3i[F403@3i[F400`00
0000nJeQ0?V]H@0<0?V]H@030000003i[F40nJeQ00L0nJeQ0P0000020?V]H@8000001`1OG[X01@00
0000AeFm00000017EKd000000080:SJZ0P0000000`007J<000000?JY?@020?JY?@030000003oool0
oooo02l0oooo000o0?ooo`<0000000<0oooo0000003oool00P0000020?ooo`040000003oool00000
000000@0oooo00<0000008E:P@25BX400`25BX43000000X0QDZ100<0000008E:P@25BX403025BX40
0`000000QDZ108E:P@0>08E:P@0300000025BX40QDZ100d0QDZ100<0000008E:P@25BX403P25BX40
0`000000QDZ108E:P@0>08E:P@030000003i[F40nJeQ00d0nJeQ00<000000?V]H@3i[F40303i[F40
0`000000nJeQ0?V]H@090?V]H@<000002@1OG[X20000000304ME_@000000:SJZ0080:SJZ0`000003
0?JY?@030000003oool0oooo02l0oooo000o0?ooo`<0000000@0oooo0000003oool000000`3oool0
10000000oooo0000000000030?ooo`0300000025BX40QDZ100@0QDZ100<0000008E:P@25BX402P25
BX400`000000QDZ108E:P@0<08E:P@0300000025BX40QDZ100h0QDZ100<0000008E:P@25BX402P25
BX4J000000/0QDZ100<000000?V]H@3i[F403@3i[F400`000000nJeQ0?V]H@0<0?V]H@030000003i
[F40nJeQ00/0nJeQ0P00000905mN^P0300000017EKd0000000<0:SJZ0`0000030?JY?@030000003o
ool0oooo02l0oooo000n0?ooo`8000000P3oool3000000D0oooo0`0000030?ooo`0300000025BX40
QDZ10080QDZ10`00000<08E:P@0300000025BX40QDZ100d0QDZ100<0000008E:P@25BX403@25BX40
0`000000QDZ108E:P@0208E:P@P000000`25BX400`000000QDZ108E:P@0>08E:P@0300000025BX40
QDZ100<0QDZ12000000308E:P@030000003i[F40nJeQ00`0nJeQ00<000000?V]H@3i[F403@3i[F40
0`000000nJeQ0?V]H@0;0?V]H@8000002@1OG[X2000000D0:SJZ0P0000030?JY?@800000<03oool0
03h0oooo0P0000020?ooo`<000001@3oool00`000000oooo000000030?ooo`0500000025BX40QDZ1
08E:P@0000000P25BX400`000000QDZ108E:P@0;08E:P@0300000025BX40QDZ100`0QDZ100<00000
08E:P@25BX402`25BX47000000/0QDZ100<0000008E:P@25BX403P25BX400`000000QDZ108E:P@0;
08E:P@L000002`3i[F400`000000nJeQ0?V]H@0<0?V]H@030000003i[F40nJeQ00`0nJeQ10000007
05mN^P8000001P0Z=ZX010000000mZTm0?JY?@3fZCd200000300oooo000n0?ooo`8000000P3oool2
000000D0oooo00@000000?ooo`00000000000`3oool010000000QDZ108E:P@00000408E:P@030000
0025BX40QDZ100X0QDZ100<0000008E:P@25BX403025BX400`000000QDZ108E:P@0608E:P@D00000
0P25BX400`000000QDZ108E:P@0=08E:P@0300000025BX40QDZ100h0QDZ100<0000008E:P@25BX40
3P25BX4010000000nJeQ0?V]H@3i[F46000000D0nJeQ00<000000?V]H@3i[F40303i[F400`000000
nJeQ0?V]H@0;0?V]H@040000003i[F400000075V]`8000001P1OG[X2000000H0:SJZ0P0000020?JY
?@800000<03oool003h0oooo0P0000020?ooo`8000001@3oool010000000oooo0000000000030?oo
o`<000001@25BX400`000000QDZ108E:P@0:08E:P@0300000025BX40QDZ100`0QDZ100<0000008E:
P@25BX401P00000708E:P@0300000025BX40QDZ100d0QDZ100<0000008E:P@25BX403P25BX400`00
0000QDZ108E:P@0>08E:P@030000003i[F40nJeQ00L0nJeQ100000000`3i[F4000000?V]H@0=0?V]
H@030000003i[F40nJeQ00/0nJeQ00<000000?V]H@0000000P1aI[L2000000D0Gejj00<0000004a7
Z`0000001@0Z=ZX200000080mZTm00<000000=>G2@3oool0;`3oool003h0oooo00<000000?ooo`3o
ool00`0000040?ooo`050000003oool0oooo0?ooo`0000000`3oool00`000000QDZ108E:P@0508E:
P@0300000025BX40QDZ100X0QDZ100<0000008E:P@25BX402`25BX44000000d0QDZ100<0000008E:
P@25BX403@25BX400`000000QDZ108E:P@0>08E:P@0300000025BX40QDZ100h0QDZ100<000000?V]
H@3i[F402`3i[F43000000d0nJeQ00<000000?V]H@3i[F402`3i[F400`000000nJeQ00000002075V
]`030000001OG[X0000000<0Gejj00@0000004a7Z`1<Aj/000001@0Z=ZX00`000000olAc00000002
0?JY?@030000003oool0oooo02h0oooo000m0?ooo`8000000P3oool3000000@0oooo00D000000?oo
o`3oool0oooo000000020?ooo`8000001`25BX400`000000QDZ108E:P@0:08E:P@0300000025BX40
QDZ100P0QDZ10`0000000`25BX40000008E:P@0>08E:P@0300000025BX40QDZ100d0QDZ100<00000
08E:P@25BX403P25BX400`000000QDZ108E:P@0=08E:P@8000003P3i[F400`000000nJeQ00000002
000000X0nJeQ00<000000?V]H@3i[F402`3i[F400`000000nJeQ00000003075V]`060000001OG[X0
00000000001OG[X000000`1<Aj/00`000000:SJZ02XfZP0202XfZP030000003oa7<000000080mZTm
0P00000_0?ooo`00?@3oool2000000030?ooo`0000000000008000000`3oool00`000000oooo0?oo
o`020?ooo`<0000000<0oooo00000025BX401P25BX400`000000QDZ108E:P@0:08E:P@0300000025
BX40QDZ100H0QDZ10P00000408E:P@0300000025BX40QDZ100h0QDZ100<0000008E:P@25BX403025
BX400`000000QDZ108E:P@0>08E:P@0300000025BX40QDZ100d0QDZ10P00000>0?V]H@030000003i
[F40nJeQ0080nJeQ0P0000080?V]H@030000003i[F40nJeQ00/0nJeQ00<000000?V]H@000000101a
I[L00`000000Gejj05mN^P02000000<0C4N[00<0000002XfZP0Z=ZX00P0Z=ZX01@000000olAc0?o4
L`000000mZTm00800000;`3oool003d0oooo0P0000001@3oool000000000003oool0000000<0oooo
00<000000?ooo`3oool00P3oool01@000000oooo0000003oool0000000L0QDZ100<0000008E:P@25
BX402`25BX400`000000QDZ108E:P@0208E:P@<000001`25BX400`000000QDZ108E:P@0=08E:P@03
00000025BX40QDZ100`0QDZ100<0000008E:P@25BX403P25BX400`000000QDZ108E:P@0=08E:P@80
00003@3i[F400`000000nJeQ0?V]H@050?V]H@<00000103i[F400`000000nJeQ0?V]H@0;0?V]H@04
0000003i[F40nJeQ000000D0LFJg00@0000005mN^P0000000000101<Aj/01@000000:SJZ02XfZP0Z
=ZX000000080olAc00@000000?JY?@0000000000;`3oool003d0oooo0`000000103oool000000?oo
o`0000020?ooo`030000003oool0oooo0080oooo0P000000103oool000000?ooo`00000808E:P@03
00000025BX40QDZ100X0QDZ100<0000008E:P@0000000P00000:08E:P@0300000025BX40QDZ100d0
QDZ100<0000008E:P@25BX403025BX400`000000QDZ108E:P@0=08E:P@0300000025BX40QDZ100h0
QDZ100<0000008E:P@000000303i[F400`000000nJeQ0?V]H@080?V]H@<0000000<0nJeQ0000003i
[F40303i[F4010000000nJeQ0?V]H@000005075V]`80000000<0C4N[0000000000000`1<Aj/01000
0000:SJZ02XfZP0000040?o4L`<00000;`3oool003d0oooo100000020?ooo`80000000<0oooo0000
003oool00P3oool01@000000oooo0?ooo`000000oooo008000002025BX400`000000QDZ108E:P@0:
08E:P@8000003@25BX400`000000QDZ108E:P@0=08E:P@0300000025BX40QDZ100d0QDZ100<00000
08E:P@25BX403025BX400`000000QDZ108E:P@0>08E:P@0300000025BX40000000`0nJeQ00<00000
0?V]H@3i[F402`3i[F43000000`0nJeQ00@000000?V]H@3i[F4000001P1aI[L01@000000C4N[0000
001<Aj/0000000<0C4N[00<0000002XfZP000000103oa7<2000000030=>G2@3oool0oooo02d0oooo
000m0?ooo`80000000@0oooo0000003oool0oooo0`0000030?ooo`060000003oool0oooo0?ooo`00
0000oooo0P00000808E:P@0300000025BX40QDZ100P0QDZ10`00000>08E:P@0300000025BX40QDZ1
00d0QDZ100<0000008E:P@25BX403@25BX400`000000QDZ108E:P@0<08E:P@0300000025BX40QDZ1
00h0QDZ100<0000008E:P@000000303i[F400`000000nJeQ0?V]H@0<0?V]H@040000003i[F400000
000000X0nJeQ00@000000?V]H@3i[F4000001@1aI[L3000000<0C4N[00H0000004a7Z`1<Aj/00000
02XfZP0000050?o4L`030000003CU`T0oooo02h0oooo000m0?ooo`80000000<0oooo0000003oool0
0P3oool200000080oooo00<000000?ooo`3oool00P3oool2000000030?ooo`000000QDZ100L0QDZ1
00<0000008E:P@25BX401P25BX4200000080QDZ100<0000008E:P@25BX403@25BX400`000000QDZ1
08E:P@0<08E:P@0300000025BX40QDZ100d0QDZ100<0000008E:P@25BX403025BX400`000000QDZ1
08E:P@0>08E:P@0300000025BX40000000`0nJeQ00<000000?V]H@3i[F40303i[F4010000000nJeQ
0?V]H@3i[F42000000P0nJeQ00@000000?V]H@3i[F400000101aI[L010000000I5BZ06ADZP000004
04a7Z`030000001<Aj/0C4N[008000001@3oa7<00`000000diL90000000^0?ooo`00?@3oool30000
00@0oooo00@000000?ooo`3oool000001@3oool3000000T0QDZ100<0000008E:P@25BX401025BX42
000000D0QDZ100<0000008E:P@25BX403025BX400`000000QDZ108E:P@0<08E:P@0300000025BX40
QDZ100d0QDZ100<0000008E:P@25BX403025BX400`000000QDZ108E:P@0=08E:P@0400000025BX40
QDZ1000000`0nJeQ00<000000?V]H@3i[F402`3i[F400`000000nJeQ0?V]H@040?V]H@8000001P3i
[F4010000000nJeQ0?V]H@000003075V]`050000001TE:X0I5BZ06ADZP0000001@1<Aj/010000000
C4N[0000000000050?o4L`<00000;P3oool003d0oooo0`0000040?ooo`030000003oool0000000H0
oooo0`00000:08E:P@0400000025BX40QDZ108E:P@8000001`25BX400`000000QDZ108E:P@0<08E:
P@0300000025BX40QDZ100`0QDZ100<0000008E:P@25BX403@25BX400`000000QDZ108E:P@0<08E:
P@0300000025BX40QDZ100d0QDZ100@0000008E:P@25BX4000002`3i[F400`000000nJeQ0?V]H@0<
0?V]H@030000003i[F40nJeQ00H0nJeQ0P0000030?V]H@030000003i[F40nJeQ0080nJeQ00<00000
075V]`000000101TE:X2000000D0C4N[00<0000004a7Z`0000001@3oa7<3000002h0oooo000l0?oo
o`@00000103oool2000000L0oooo0`00000:08E:P@0400000025BX400000000000T0QDZ100<00000
08E:P@25BX403025BX400`000000QDZ108E:P@0<08E:P@0300000025BX40QDZ100d0QDZ100<00000
08E:P@25BX403025BX400`000000QDZ108E:P@0=08E:P@0400000025BX40QDZ1000000/0nJeQ00<0
00000?V]H@3i[F40303i[F400`000000nJeQ0?V]H@080?V]H@80000000<0nJeQ0000003i[F400`3i
[F400`000000LFJg0000000406ADZP8000001P1<Aj/2000000D0olAc0`00000^0?ooo`00?03oool3
000000D0oooo0P0000060?ooo`040000003oool00000000000X0QDZ10P00000;08E:P@0300000025
BX40QDZ100`0QDZ100<0000008E:P@25BX403@25BX400`000000QDZ108E:P@0<08E:P@0300000025
BX40QDZ100`0QDZ100<0000008E:P@25BX403@25BX4010000000QDZ108E:P@00000;0?V]H@030000
003i[F40nJeQ00`0nJeQ00<000000?V]H@3i[F402P3i[F42000000@0nJeQ0P00000406ADZP030000
001TE:X0000000H0C4N[0P0000050?o4L`80000000<0diL90?ooo`3oool0;03oool003`0oooo0`00
00040?ooo`80000000<0oooo0000003oool0103oool010000000oooo00000000000808E:P@<00000
3@25BX400`000000QDZ108E:P@0<08E:P@0300000025BX40QDZ100`0QDZ100<0000008E:P@25BX40
3025BX400`000000QDZ108E:P@0<08E:P@0300000025BX40QDZ100d0QDZ100@0000008E:P@25BX40
00002`3i[F400`000000nJeQ0?V]H@0;0?V]H@030000003i[F40nJeQ00`0nJeQ0`0000020?V]H@03
0000001TE:X0I5BZ00<0I5BZ00@0000006ADZP1TE:X00000101<Aj/010000000=2VF000000000004
0?o4L`030000003eaU@0000002h0oooo000l0?ooo`<00000103oool010000000oooo000000000004
0?ooo`050000003oool0oooo0?ooo`0000001`25BX401@000000QDZ108E:P@25BX40000000`0QDZ1
00<0000008E:P@25BX403025BX400`000000QDZ108E:P@0<08E:P@0300000025BX40QDZ100T0QDZ1
5P00000<08E:P@0400000025BX40QDZ1000000/0nJeQ00<000000?V]H@3i[F402`3i[F400`000000
nJeQ0?V]H@0;0?V]H@070000003i[F40nJeQ0?V]H@000000nJeQ0000000506ADZP040000001TE:X0
I5BZ000000@0C4N[0P0000000`3ldIL000000?o4L`020?o4L`030000003eaU@0mLID00800000;@3o
ool003`0oooo00@000000?ooo`00000000000P3oool2000000040?ooo`000000oooo000000<0oooo
00D000000?ooo`3oool0oooo0000000608E:P@0300000025BX40QDZ10080QDZ100<0000008E:P@25
BX402P25BX400`000000QDZ108E:P@0<08E:P@0300000025BX40QDZ100`0QDZ100@0000008E:P@25
BX40QDZ12000000308E:P@0300000025BX40QDZ100`0QDZ100@0000008E:P@25BX40QDZ120000004
08E:P@0400000025BX40QDZ1000000/0nJeQ00<000000?V]H@3i[F402`3i[F400`000000nJeQ0?V]
H@0;0?V]H@030000003i[F40nJeQ0080nJeQ0P00000506ADZP040000001TE:X0I5BZ000000<0C4N[
00<0000003@YUP0000000P3ldIL010000000olAc0?o4L`0000020?G6E0800000;@3oool003`0oooo
00@000000?ooo`00000000000P3oool2000000040?ooo`000000oooo00000080oooo00<000000?oo
o`3oool00P3oool00`000000QDZ108E:P@0208E:P@8000001@25BX400`000000QDZ108E:P@0:08E:
P@0300000025BX40QDZ100`0QDZ100<0000008E:P@25BX402P25BX46000000/0QDZ100<0000008E:
P@25BX403025BX400`000000QDZ108E:P@0908E:P@P000002P3i[F400`000000nJeQ0?V]H@0<0?V]
H@030000003i[F40nJeQ00X0nJeQ00<000000?V]H@3i[F40103i[F42000000@0I5BZ00D0000006AD
ZP1TE:X0I5BZ0000000204a7Z`030000000d:IH000000080o=6G00@000000?o4L`3oa7<000000`3e
aU@00`000000oooo0?ooo`0[0?ooo`00?03oool2000000030?ooo`000000oooo008000000P3oool0
1P000000oooo0?ooo`000000oooo000000@0oooo00D0000008E:P@25BX40QDZ10000000808E:P@03
00000025BX40QDZ100X0QDZ100<0000008E:P@25BX403025BX400`000000QDZ108E:P@0508E:P@@0
00000P25BX400`000000QDZ108E:P@0<08E:P@0300000025BX40QDZ100`0QDZ100<0000008E:P@25
BX403@25BX400`000000QDZ108E:P@07000000@0nJeQ00<000000?V]H@3i[F402`3i[F400`000000
nJeQ0?V]H@0;0?V]H@030000003i[F40nJeQ00@0nJeQ00<0000006ADZP0000000P1TE:X00`000000
I5BZ06ADZP0206ADZP030000001<Aj/000000080=2VF00L000000?cAU`3ldIL0o=6G0000003oa7<0
000000<0mLID00<000000?ooo`3oool0:`3oool003`0oooo0P0000000`3oool000000?ooo`020000
00<0oooo00@000000?ooo`00000000001@3oool4000000T0QDZ100<0000008E:P@25BX402P25BX40
0`000000QDZ108E:P@0<08E:P@0300000025BX40QDZ100D000001P25BX400`000000QDZ108E:P@0<
08E:P@0300000025BX40QDZ100`0QDZ100<0000008E:P@25BX403@25BX4010000000QDZ108E:P@00
00060?V]H@H00000303i[F400`000000nJeQ0?V]H@0;0?V]H@030000003i[F40nJeQ00@0nJeQ0P00
0000101TE:X0000000000000000506ADZP0404a7Z`000000=2VF000000@0o=6G00<000000?o4L`00
00000`3eaU@00`000000oooo0?ooo`0[0?ooo`00?03oool2000000050?ooo`00000000000?ooo`00
00000`3oool010000000oooo0?ooo`0000050?ooo`8000002`25BX400`000000QDZ108E:P@0:08E:
P@0300000025BX40QDZ100/0QDZ11000000;08E:P@0300000025BX40QDZ100`0QDZ100<0000008E:
P@25BX403025BX400`000000QDZ108E:P@0<08E:P@0500000025BX40QDZ108E:P@0000002P3i[F40
10000000nJeQ00000000000:0?V]H@030000003i[F40nJeQ00X0nJeQ00<000000?V]H@3i[F401@3i
[F42000000<0I5BZ00<0000006ADZP1TE:X00`1TE:X010000000=2VF03@YUP0000050?cAU`800000
0`3eaU@00`000000oooo0?ooo`0[0?ooo`00?03oool2000000050?ooo`00000000000?ooo`000000
0`3oool00`000000oooo0?ooo`02000000@0oooo0P00000;08E:P@0300000025BX40QDZ100X0QDZ1
00<0000008E:P@25BX401`25BX440000000308E:P@000000QDZ100d0QDZ100<0000008E:P@25BX40
2`25BX400`000000QDZ108E:P@0<08E:P@0300000025BX40QDZ100`0QDZ100<0000008E:P@25BX40
0P00000:0?V]H@040000003i[F40nJeQ0?V]H@<000001`3i[F400`000000nJeQ0?V]H@0:0?V]H@03
0000003i[F40nJeQ00D0nJeQ0P00000306ADZP8000000`1TE:X200000080=2VF00<000000?cAU`3l
dIL00`3ldIL2000000<0mLID00<000000?ooo`3oool0:`3oool003`0oooo0P000000103oool00000
0000000000040?ooo`030000003oool000000080oooo00<000000?ooo`3oool00P0000000`25BX40
000008E:P@0:08E:P@0300000025BX40QDZ100X0QDZ100<0000008E:P@25BX400`25BX43000000D0
QDZ100<0000008E:P@25BX403025BX400`000000QDZ108E:P@0;08E:P@0300000025BX40QDZ100`0
QDZ100<0000008E:P@25BX403025BX4300000080Y<C`00<000000?V]H@3i[F401P3i[F400`000000
nJeQ0?V]H@050?V]H@<000000`3i[F400`000000nJeQ0?V]H@0;0?V]H@030000003i[F40nJeQ00D0
nJeQ00D0000007INZ@000000I5BZ0000000206ADZP030000001TE:X000000080E3fJ00<0000003@Y
UP0000001P3ldIL00`000000mLID0?G6E002000002d0oooo000l0?ooo`80000000@0oooo0000003o
ool000001@3oool2000000<0oooo0`00000208E:P@0300000025BX40QDZ100T0QDZ100<0000008E:
P@25BX402P25BX400`000000QDZ100000003000000T0QDZ100<0000008E:P@25BX402`25BX400`00
0000QDZ108E:P@0;08E:P@0300000025BX40QDZ100`0QDZ100<0000008E:P@25BX402@25BX440000
00D0Y<C`00<000000?V]H@3i[F401@3i[F400`000000nJeQ0?V]H@080?V]H@80000000<0nJeQ0000
003i[F402`3i[F400`000000nJeQ0?V]H@060?V]H@050000001fGZT0000006ADZP0000000`1TE:X0
10000000E3fJ05@mVP1D?IX2000000L0o=6G00@000000?G6E03eaU@00000;P3oool003`0oooo00<0
00000?ooo`3oool00`0000050?ooo`8000000`3oool300000080QDZ100<0000008E:P@25BX402@25
BX400`000000QDZ108E:P@0908E:P@<000003@25BX400`000000QDZ108E:P@0;08E:P@0300000025
BX40QDZ100/0QDZ100<0000008E:P@25BX403025BX400`000000QDZ108E:P@0508E:P@@000000`2T
a?000`000000Y<C`0:C4l0040:C4l0030000003i[F40nJeQ00@0nJeQ00<000000?V]H@3i[F402P3i
[F43000000/0nJeQ00<000000?V]H@3i[F401`3i[F400`000000MUjY0000000306ADZP8000000`1D
?IX2000000H0o=6G0P0000020?G6E0030000003oool0oooo02`0oooo000l0?ooo`<0000000@0oooo
0000000000000000103oool200000080oooo00@000000?ooo`3oool000000`25BX400`000000QDZ1
08E:P@0908E:P@0300000025BX40QDZ100H0QDZ10P0000000`25BX40000008E:P@0=08E:P@030000
0025BX40QDZ100/0QDZ100<0000008E:P@25BX403025BX400`000000QDZ108E:P@0;08E:P@030000
0025BX40QDZ10080QDZ10`0000070:C4l0030000002Ta?00Y<C`00@0Y<C`00<000000?V]H@3i[F40
103i[F400`000000nJeQ0?V]H@0;0?V]H@040000003i[F400000000000P0nJeQ00<000000?V]H@3i
[F40203i[F400`000000MUjY0000000206ADZP040000001D?IX0E3fJ000000<0E3fJ00<000000?cA
U`3ldIL0103ldIL01@000000o]j90000003eaU@0000002h0oooo000l0?ooo`<0000000@0oooo0000
000000000000103oool010000000oooo0?ooo`0000030?ooo`0500000025BX40QDZ108E:P@000000
2`25BX400`000000QDZ108E:P@0408E:P@8000001025BX400`000000QDZ108E:P@0;08E:P@030000
0025BX40QDZ100/0QDZ100<0000008E:P@25BX403025BX400`000000QDZ108E:P@0;08E:P@030000
0025BX400000008000002@2Ta?000`000000Y<C`0:C4l0060:C4l0030000003i[F40nJeQ0080nJeQ
00<000000?V]H@3i[F402`3i[F400`000000nJeQ0?V]H@020?V]H@8000001P3i[F400`000000nJeQ
0?V]H@080?V]H@030000001fGZT0000000800000101D?IX010000000E3fJ05@mVP0000060?cAU`05
0000003ngXT000000?G6E0000000;P3oool003`0oooo0`0000001@3oool000000000003oool00000
00<0oooo0`0000040?ooo`0300000025BX40QDZ10080QDZ100<0000008E:P@25BX402025BX400`00
0000QDZ108E:P@0208E:P@8000001P25BX400`000000QDZ108E:P@0<08E:P@0300000025BX40QDZ1
00/0QDZ100<0000008E:P@25BX402`25BX400`000000QDZ108E:P@0:08E:P@<00000302Ta?000`00
0000Y<C`0:C4l0070:C4l0050000003i[F40nJeQ0?V]H@0000003@3i[F400`000000nJeQ0?V]H@04
0?V]H@800000103i[F400`000000nJeQ0?V]H@080?V]H@80000000<0MUjY0000001D?IX01@1D?IX2
000000L0o=6G00D000000?kNR@000000mLID0000000^0?ooo`00?03oool3000000050?ooo`000000
00000?ooo`0000000`3oool2000000D0oooo00<0000008E:P@25BX400P25BX400`000000QDZ108E:
P@0908E:P@0400000025BX400000000000T0QDZ100<0000008E:P@25BX402`25BX400`000000QDZ1
08E:P@0;08E:P@0300000025BX40QDZ100/0QDZ100<0000008E:P@25BX401`25BX43000000030:C4
l0000000Y<C`00`0Y<C`00<000000:C4l02Ta?00202Ta?0010000000nJeQ0?V]H@00000=0?V]H@03
0000003i[F40nJeQ00H0nJeQ0P0000000`3i[F4000000?V]H@0:0?V]H@@000001`1D?IX00`000000
o=6G0?cAU`040?cAU`030000003ngXT0o]j90080000000<0`Z/M0?ooo`3oool0;03oool003`0oooo
0P0000020?ooo`8000000P3oool00`000000oooo0?ooo`02000000D0oooo00<0000008E:P@25BX40
0P25BX400`000000QDZ108E:P@0908E:P@8000002`25BX400`000000QDZ108E:P@0;08E:P@030000
0025BX40QDZ100/0QDZ100<0000008E:P@25BX402`25BX400`000000QDZ108E:P@0408E:P@<00000
102Ta?000`000000Y<C`0:C4l00;0:C4l0030000002Ta?00Y<C`00T0Y<C`0P00000>0?V]H@030000
003i[F40nJeQ00P0nJeQ0P00000;0?V]H@80000000<0K4bK0000001D?IX01P1D?IX2000000D0o=6G
00@000000?kNR@3ngXT0o]j90P00000^0?ooo`00?03oool200000080oooo00<000000?ooo`000000
0P3oool3000000030?ooo`000000oooo00<0oooo00<0000008E:P@25BX400`25BX400`000000QDZ1
08E:P@0708E:P@8000003@25BX400`000000QDZ108E:P@0:08E:P@0300000025BX40QDZ100/0QDZ1
00<0000008E:P@25BX402`25BX4010000000QDZ108E:P@25BX43000000L0Y<C`00<000000:C4l02T
a?002`2Ta?000`000000Y<C`0:C4l00:0:C4l0030000003i[F40nJeQ00/0nJeQ00<000000?V]H@3i
[F402P3i[F43000000T0nJeQ00D0000006a<V`1/C9/0K4bK0000000505@mVP030000003dek000000
00D0o=6G00@000000?kNR@3ngXT0o]j90P00000^0?ooo`00?@3oool01P000000oooo0?ooo`000000
oooo00000080oooo0P0000020?ooo`030000003oool0oooo0080oooo00<0000008E:P@25BX400`25
BX400`000000QDZ108E:P@0508E:P@8000000P25BX400`000000QDZ108E:P@0:08E:P@0300000025
BX40QDZ100/0QDZ100<0000008E:P@25BX402P25BX400`000000QDZ108E:P@0;08E:P@@000002P2T
a?000`000000Y<C`0:C4l00;0:C4l0030000002Ta?00Y<C`00X0Y<C`00<000000?V]H@3i[F402`3i
[F400`000000nJeQ0?V]H@090?V]H@050000003i[F40nJeQ0?V]H@000000203i[F401@000000K4bK
06a<V`1/C9/0000000D0E3fJ00@000000?CG/03dek0000000`3ldIL00`000000o]j90?kNR@020?kN
R@800000;P3oool003d0oooo0P0000001@3oool000000?ooo`3oool000000080oooo00D000000?oo
o`3oool0oooo000000030?ooo`0300000025BX40QDZ100<0QDZ100<0000008E:P@25BX401025BX40
0`000000QDZ108E:P@0208E:P@0300000025BX40QDZ100/0QDZ100<0000008E:P@25BX402P25BX40
0`000000QDZ108E:P@0:08E:P@0300000025BX40QDZ100P0QDZ11000000=0:C4l0030000002Ta?00
Y<C`00X0Y<C`00<000000:C4l02Ta?002`2Ta?02000000/0nJeQ00<000000?V]H@3i[F402P3i[F40
0`000000nJeQ0?V]H@020?V]H@030000003i[F40nJeQ00@0nJeQ0P00000306a<V`030000001D?IX0
E3fJ0080E3fJ00D000000?CG/03dek00m=N`000000030?cAU`030000003ngXT0o]j90080o]j90P00
000^0?ooo`00?@3oool3000000<0oooo00<000000?ooo`0000000P0000020?ooo`050000003oool0
oooo0?ooo`0000001P25BX400`000000QDZ108E:P@0208E:P@0300000025BX40QDZ100@0QDZ100<0
000008E:P@25BX402P25BX400`000000QDZ108E:P@0:08E:P@0300000025BX40QDZ100/0QDZ100<0
000008E:P@25BX401025BX4H000000T0Y<C`00<000000:C4l02Ta?002P2Ta?0010000000Y<C`0:C4
l000000:0?V]H@030000003i[F40nJeQ00X0nJeQ00<000000?V]H@3i[F400`3i[F42000000@0nJeQ
0P00000306a<V`030000001D?IX0E3fJ0080E3fJ00<000000?CG/03dek000P3dek0010000000o=6G
0?cAU`0000030?kNR@<00000;P3oool003d0oooo0`0000030?ooo`060000003oool000000000003o
ool000000P3oool010000000oooo0?ooo`00000608E:P@0300000025BX40QDZ1008000001`25BX40
0`000000QDZ108E:P@0:08E:P@0300000025BX40QDZ100X0QDZ100<0000008E:P@25BX402`25BX40
10000000QDZ108E:P@25BX46000000<0Y<C`00<000000:C4l02Ta?002`2Ta?0010000000Y<C`0:C4
l02Ta?06000000<0Y<C`00<000000:C4l02Ta?002P2Ta?001@000000Y<C`0:C4l02Ta?00000000T0
nJeQ00<000000?V]H@3i[F402@3i[F400`000000nJeQ0?V]H@060?V]H@040000003i[F40nJeQ0?V]
H@800000101/C9/01@000000E3fJ05@mVP1D?IX0000000D0m=N`00<000000?cAU`0000000`3ngXT2
000002l0oooo000m0?ooo`<00000103oool00`000000oooo000000020?ooo`030000003oool00000
0080oooo00<0000008E:P@25BX401@25BX42000000X0QDZ100<0000008E:P@25BX402P25BX400`00
0000QDZ108E:P@0:08E:P@0300000025BX40QDZ100L0QDZ11`0000090:C4l0030000002Ta?00Y<C`
00/0Y<C`00<000000:C4l02Ta?001`2Ta?06000000X0Y<C`00<000000:C4l02Ta?000P2Ta?000`00
0000nJeQ0?V]H@050?V]H@030000003i[F40nJeQ00X0nJeQ00<000000?V]H@3i[F401`3i[F430000
00030?V]H@000000K4bK00<0K4bK00@0000005@mVP1D?IX000001P3dek02000000@0o]j90P00000_
0?ooo`00?@3oool3000000@0oooo00<000000?ooo`0000000P3oool00`000000oooo0?ooo`020000
00P0QDZ100<0000008E:P@25BX402@25BX400`000000QDZ108E:P@0:08E:P@0300000025BX40QDZ1
00X0QDZ100@0000008E:P@25BX40QDZ11P0000001025BX40000000000000000<0:C4l0030000002T
a?00Y<C`00/0Y<C`00<000000:C4l02Ta?002P2Ta?000`000000Y<C`0:C4l006000000<0Y<C`00<0
00000:C4l02Ta?00102Ta?000`000000nJeQ0?V]H@040?V]H@030000003i[F40nJeQ00T0nJeQ00<0
00000?V]H@3i[F402P3i[F4010000000nJeQ0?V]H@00000306a<V`040000001D?IX0E3fJ000000L0
m=N`00<000000?kNR@3ngXT00P3ngXT2000002l0oooo000n0?ooo`<000000`3oool00`000000oooo
000000030?ooo`040000003oool00000000000L0QDZ100<0000008E:P@0000002`25BX400`000000
QDZ108E:P@0908E:P@0300000025BX40QDZ100T0QDZ11@00000408E:P@<000000P2Ta?000`000000
Y<C`0:C4l00:0:C4l0030000002Ta?00Y<C`00X0Y<C`00<000000:C4l02Ta?002`2Ta?000`000000
Y<C`0:C4l0060:C4l0D000001P2Ta?000`000000nJeQ0?V]H@030?V]H@030000003i[F40nJeQ00T0
nJeQ00<000000?V]H@3i[F402@3i[F401@000000nJeQ0000003i[F40000000<0K4bK00<0000005@m
VP0000001`3dek02000000<0o]j900<000000>OKJ0000000;`3oool003h0oooo0`0000020?ooo`04
0000003oool00000000000@0oooo00<000000?ooo`0000001P25BX4010000000QDZ108E:P@00000;
08E:P@0300000025BX40QDZ100X0QDZ100<0000008E:P@25BX401@25BX430000000308E:P@000000
QDZ10080QDZ1100000060:C4l0030000002Ta?00Y<C`00T0Y<C`00<000000:C4l02Ta?002P2Ta?00
0`000000Y<C`0:C4l00:0:C4l0030000002Ta?00Y<C`00X0Y<C`00<000000:C4l00000000P000003
0:C4l0030000003i[F40nJeQ0080nJeQ00<000000?V]H@3i[F402@3i[F400`000000nJeQ0?V]H@0:
0?V]H@030000003i[F40nJeQ00800000101/C9/2000000L0m=N`0P0000030?kNR@030000003WffP0
000002l0oooo000n0?ooo`80000000H0oooo0000003oool000000?ooo`0000060?ooo`8000001@25
BX400`000000QDZ108E:P@0208E:P@0300000025BX40QDZ100T0QDZ100<0000008E:P@25BX402@25
BX400`000000QDZ108E:P@0308E:P@8000001@25BX43000000X0Y<C`00<000000:C4l02Ta?002@2T
a?000`000000Y<C`0:C4l00:0:C4l0030000002Ta?00Y<C`00X0Y<C`00<000000:C4l02Ta?002P2T
a?000`000000Y<C`0:C4l0020:C4l0<0000000<0Y<C`0000003i[F400P3i[F400`000000nJeQ0?V]
H@090?V]H@030000003i[F40nJeQ00T0nJeQ00<000000?V]H@3i[F400P3i[F400`000000K4bK06a<
V`0206a<V`8000001P3dek0010000000n^N/0?[W[00000020?kNR@030000003WffP0000002l0oooo
000n0?ooo`040000003oool000000?ooo`80000000<0oooo0000000000001P3oool2000000<0QDZ1
00<0000008E:P@25BX400`25BX400`000000QDZ108E:P@0908E:P@0300000025BX40QDZ100X0QDZ1
00<0000008E:P@0000000P00000408E:P@@00000302Ta?000`000000Y<C`0:C4l0090:C4l0030000
002Ta?00Y<C`00X0Y<C`00<000000:C4l02Ta?002P2Ta?000`000000Y<C`0:C4l0090:C4l0030000
002Ta?00Y<C`00H0Y<C`0`0000000`3i[F4000000?V]H@0:0?V]H@030000003i[F40nJeQ00T0nJeQ
00<000000?V]H@3i[F400`3i[F42000000<0K4bK00<000000?CG/03dek001@3dek001P000000n^N/
0?[W[0000000o]j900000080im]X00<000000?ooo`3oool0;@3oool003h0oooo00D000000?ooo`00
0000oooo000000020?ooo`8000001P3oool200000080QDZ100<0000008E:P@25BX401@25BX400`00
0000QDZ108E:P@0908E:P@0300000025BX40QDZ100P0QDZ10`00000408E:P@<000000`2Ta?000`00
0000Y<C`0:C4l00:0:C4l0030000002Ta?00Y<C`00T0Y<C`00<000000:C4l02Ta?002P2Ta?000`00
0000Y<C`0:C4l00:0:C4l0030000002Ta?00Y<C`00T0Y<C`00<000000:C4l02Ta?002@2Ta?030000
00X0nJeQ00<000000?V]H@3i[F402@3i[F400`000000nJeQ0?V]H@030?V]H@040000001/C9/00000
06a<V`8000001P3dek001`000000n^N/0?[W[03jij`000000?kNR@0000000P3WffP00`000000oooo
0?ooo`0]0?ooo`00?`3oool2000000070?ooo`00000000000?ooo`000000oooo000000050?ooo`04
00000025BX400000000000P0QDZ100<0000008E:P@25BX402@25BX400`000000QDZ108E:P@0608E:
P@80000000@0QDZ100000025BX40QDZ10`0000070:C4l0030000002Ta?00Y<C`00T0Y<C`00<00000
0:C4l02Ta?002P2Ta?000`000000Y<C`0:C4l0090:C4l0030000002Ta?00Y<C`00T0Y<C`00<00000
0:C4l02Ta?002P2Ta?000`000000Y<C`0:C4l00:0:C4l0040000003i[F400000000000L0nJeQ00<0
00000?V]H@3i[F402@3i[F400`000000nJeQ0?V]H@040?V]H@030000001/C9/00000008000001`3d
ek002@000000n^N/0?[W[03jij`000000?kNR@000000im]X0000000`0?ooo`00?`3oool200000003
0?ooo`000000oooo0080000000<0oooo0000003oool0103oool00`000000QDZ10000000:08E:P@03
00000025BX40QDZ100T0QDZ100<0000008E:P@25BX400P25BX43000000<0QDZ10`00000:0:C4l003
0000002Ta?00Y<C`00T0Y<C`00<000000:C4l02Ta?002P2Ta?000`000000Y<C`0:C4l0090:C4l003
0000002Ta?00Y<C`00T0Y<C`00<000000:C4l02Ta?002@2Ta?000`000000Y<C`0:C4l00:0:C4l003
0000002Ta?0000000080nJeQ0`0000040?V]H@030000003i[F40nJeQ00T0nJeQ00<000000?V]H@3i
[F40103i[F4200000080GSN900<000000?CG/03dek00103dek000`000000n^N/0?[W[0030?[W[080
000000<0im]X0000003oool0;`3oool003l0oooo0`0000020?ooo`80000000<0oooo0000003oool0
103oool20000000308E:P@000000QDZ100P0QDZ100<0000008E:P@25BX402@25BX400`000000QDZ1
08E:P@02000000<0QDZ10`0000000`2Ta?0000000:C4l00:0:C4l0030000002Ta?00Y<C`00X0Y<C`
00<000000:C4l02Ta?002@2Ta?000`000000Y<C`0:C4l0090:C4l0030000002Ta?00Y<C`00T0Y<C`
00<000000:C4l02Ta?002@2Ta?000`000000Y<C`0:C4l00:0:C4l0030000002Ta?00000000D0nJeQ
0P0000000`3i[F4000000?V]H@0:0?V]H@030000003i[F40nJeQ00D0nJeQ00H0000005hgR@1N=hT0
00000>_I`@0000050?CG/0030000003jij`0n^N/00<0n^N/00@000000>OKJ03WffP00000<03oool0
0400oooo0P0000030?ooo`040000003oool0oooo000000@0oooo0P0000000`25BX40000008E:P@09
08E:P@0300000025BX40QDZ100T0QDZ10P0000000`25BX40000000000002000000D0Y<C`00<00000
0:C4l02Ta?002@2Ta?000`000000Y<C`0:C4l0090:C4l0030000002Ta?00Y<C`00T0Y<C`00<00000
0:C4l02Ta?002@2Ta?000`000000Y<C`0:C4l0090:C4l0030000002Ta?00Y<C`00T0Y<C`00<00000
0:C4l02Ta?002@2Ta?001@000000Y<C`0:C4l02Ta?00000000H0nJeQ0P00000:0?V]H@030000003i
[F40nJeQ00H0nJeQ00H0000005hgR@00000000000>_I`@0000040?CG/0030000003jij`0n^N/00@0
n^N/00<000000>OKJ0000000<@3oool00400oooo0`0000020?ooo`80000000<0oooo0000003oool0
0`3oool01@000000QDZ108E:P@25BX40000000T0QDZ100<0000008E:P@25BX401`25BX45000000T0
Y<C`00<000000:C4l02Ta?002@2Ta?000`000000Y<C`0:C4l0090:C4l0030000002Ta?00Y<C`00T0
Y<C`00<000000:C4l02Ta?00202Ta?000`000000Y<C`0:C4l0090:C4l0030000002Ta?00Y<C`00T0
Y<C`00<000000:C4l02Ta?002P2Ta?000`000000Y<C`0:C4l0020:C4l0030000003i[F40nJeQ00<0
nJeQ00<000000?V]H@0000002@3i[F400`000000nJeQ0?V]H@060?V]H@<000000`3[fL401@000000
m=N`0?CG/03dek00000000D0n^N/0P0000000`3WffP000000?ooo`0`0?ooo`00@03oool300000080
oooo00D000000?ooo`000000oooo000000020?ooo`8000001025BX400`000000QDZ108E:P@0708E:
P@0300000025BX40QDZ100D0QDZ10`0000000`2Ta?0000000:C4l00:0:C4l0030000002Ta?00Y<C`
00T0Y<C`00<000000:C4l02Ta?00202Ta?000`000000Y<C`0:C4l0090:C4l0030000002Ta?00Y<C`
00P0Y<C`00<000000:C4l02Ta?002@2Ta?000`000000Y<C`0:C4l0090:C4l0030000002Ta?00Y<C`
00T0Y<C`00<000000:C4l02Ta?00102Ta?000`000000nJeQ0?V]H@020?V]H@030000003i[F40nJeQ
008000001P3i[F400`000000nJeQ0?V]H@070?V]H@800000103[fL4010000000m=N`0?CG/0000006
0?[W[080000000<0im]X0000003oool0<03oool00400oooo0P000000103oool000000?ooo`000002
0?ooo`80000000@0oooo00000000000000001025BX400`000000QDZ108E:P@0708E:P@0300000025
BX40QDZ10080QDZ10`0000050:C4l0030000002Ta?00Y<C`00P0Y<C`00<000000:C4l02Ta?002@2T
a?000`000000Y<C`0:C4l0080:C4l0030000002Ta?00Y<C`00T0Y<C`00<000000:C4l02Ta?00202T
a?000`000000Y<C`0:C4l0090:C4l0030000002Ta?00Y<C`00T0Y<C`00<000000:C4l02Ta?002@2T
a?000`000000Y<C`0:C4l0050:C4l0040000003i[F40nJeQ000000D0nJeQ00<000000?V]H@3i[F40
0`3i[F400`000000nJeQ0?V]H@070?V]H@8000001@3[fL400`000000m=N`000000050?[W[0050000
003blIh000000>OKJ0000000<@3oool00440oooo00D000000?ooo`000000oooo000000030?ooo`@0
00001P25BX400`000000QDZ108E:P@0708E:P@D000001`2Ta?000`000000Y<C`0:C4l0080:C4l003
0000002Ta?00Y<C`00T0Y<C`00<000000:C4l02Ta?00202Ta?000`000000Y<C`0:C4l0090:C4l003
0000002Ta?00Y<C`00P0Y<C`00<000000:C4l02Ta?002@2Ta?000`000000Y<C`0:C4l0090:C4l003
0000002Ta?00Y<C`00P0Y<C`00<000000:C4l02Ta?001`2Ta?000`000000nJeQ000000060?V]H@05
0000003i[F40nJeQ0?V]H@0000002@3i[F42000000H0jmW100<000000?CG/03jij`01@3jij`01000
0000l_6N00000000000b0?ooo`00@@3oool2000000030?ooo`000000000000@0oooo00<000000?oo
o`0000001`25BX400`000000QDZ108E:P@0408E:P@<0000000<0Y<C`0000000000002@2Ta?000`00
0000Y<C`0:C4l0080:C4l0030000002Ta?00Y<C`00T0Y<C`00<000000:C4l02Ta?00202Ta?000`00
0000Y<C`0:C4l0080:C4l0030000002Ta?00Y<C`00P0Y<C`00<000000:C4l02Ta?00202Ta?000`00
0000Y<C`0:C4l0090:C4l0030000002Ta?00Y<C`00T0Y<C`00<000000:C4l02Ta?00202Ta?000`00
0000nJeQ0?V]H@060?V]H@80000000<0nJeQ0000003i[F40203i[F400`000000jmW10>_I`@060>_I
`@030000003jij`0n^N/00<0n^N/00<000000?;aWP3blIh00P00000b0?ooo`00@@3oool200000003
0?ooo`000000000000@0oooo0`00000708E:P@0400000025BX40QDZ108E:P@<000000`2Ta?000`00
0000Y<C`0:C4l0090:C4l0030000002Ta?00Y<C`00P0Y<C`00<000000:C4l02Ta?002@2Ta?000`00
0000Y<C`0:C4l0080:C4l0030000002Ta?00Y<C`00H0Y<C`4`0000050:C4l0030000002Ta?00Y<C`
00T0Y<C`00<000000:C4l02Ta?00202Ta?000`000000Y<C`0:C4l0090:C4l0030000003i[F40nJeQ
00P0nJeQ00<000000?V]H@3i[F401`3i[F42000000L0jmW10P0000050?[W[0030000003blIh0l_6N
00800000<P3oool00480oooo0P0000000`3oool00000000000020?ooo`040000003oool0oooo0000
00L0QDZ1100000050:C4l0030000002Ta?00000000/0Y<C`00<000000:C4l02Ta?00202Ta?000`00
0000Y<C`0:C4l0080:C4l0030000002Ta?00Y<C`00H0Y<C`2`0000020:C4l0030000002Ta?00Y<C`
00P0Y<C`00<000000:C4l02Ta?000`2Ta?08000000T0Y<C`00<000000:C4l02Ta?00202Ta?000`00
0000Y<C`0:C4l0080:C4l0030000002Ta?00000000P0nJeQ00<000000?V]H@000000203i[F400`00
0000jmW10>_I`@060>_I`@800000103jij`01@000000l_6N0?;aWP3blIh0000003<0oooo00120?oo
o`80000000<0oooo0000000000000P3oool00`000000oooo0?ooo`02000000<0QDZ10`0000000`2T
a?0000000:C4l0050:C4l0040000002Ta?00Y<C`000000/0Y<C`00<000000:C4l02Ta?00202Ta?00
0`000000Y<C`0:C4l0090:C4l0030000002Ta?00Y<C`00D000000P2Ta?000`000000Y<C`0:C4l008
0:C4l0030000002Ta?00Y<C`00P0Y<C`00<000000:C4l02Ta?00202Ta?000`000000Y<C`0:C4l006
00000080Y<C`00<000000:C4l02Ta?002@2Ta?000`000000Y<C`0:C4l0070:C4l0050000002Ta?00
Y<C`0:C4l00000001`3i[F4010000000nJeQ0?V]H@0000060?V]H@8000001`3[fL4010000000l>S3
0?3X``0000030?[W[0050000003blIh0l_6N0?;aWP000000<`3oool00480oooo0`0000001@3oool0
00000?ooo`3oool000000080oooo1@0000050:C4l0030000002Ta?00Y<C`0080Y<C`00<000000:C4
l02Ta?000P2Ta?000`000000Y<C`0:C4l0090:C4l0030000002Ta?00Y<C`00P0Y<C`00<000000:C4
l02Ta?001`2Ta?04000000P0Y<C`00<000000:C4l02Ta?001`2Ta?000`000000Y<C`0:C4l0080:C4
l0030000002Ta?00Y<C`00P0Y<C`00<000000:C4l02Ta?001P2Ta?04000000T0Y<C`00<000000:C4
l02Ta?00202Ta?000`000000Y<C`0:C4l0020:C4l0030000003i[F40nJeQ00<0nJeQ00<000000?V]
H@3i[F400P3i[F42000000@0nJeQ00<000000>_I`@3[fL401@3[fL401@000000l>S30?3X``3`j<<0
00000080n^N/00@000000?;aWP3blIh0l_6N0P00000c0?ooo`00@`3oool010000000oooo00000000
00020?ooo`030000003oool0oooo00<00000202Ta?0010000000Y<C`0:C4l00000060:C4l0030000
002Ta?00Y<C`00T0Y<C`00<000000:C4l02Ta?001`2Ta?000`000000Y<C`0:C4l0040:C4l0<00000
00<0Y<C`0000002Ta?002@2Ta?000`000000Y<C`0:C4l0070:C4l0030000002Ta?00Y<C`00P0Y<C`
00<000000:C4l02Ta?001`2Ta?000`000000Y<C`0:C4l0090:C4l0030000002Ta?00000000800000
1P2Ta?000`000000Y<C`0:C4l0070:C4l0030000002Ta?00Y<C`00@0Y<C`00D000000?V]H@3i[F40
nJeQ000000070?V]H@040000003i[F40nJeQ000000P0jmW100D000000?3X``3`j<<0l>S300000002
0?[W[0050000003blIh0l_6N0?;aWP000000=03oool004<0oooo1P0000030?ooo`<00000202Ta?00
0`000000Y<C`000000080:C4l0030000002Ta?00Y<C`00P0Y<C`00<000000:C4l02Ta?00202Ta?00
0`000000Y<C`00000003000000@0Y<C`00<000000:C4l02Ta?00202Ta?000`000000Y<C`0:C4l007
0:C4l0030000002Ta?00Y<C`00P0Y<C`00<000000:C4l02Ta?001`2Ta?000`000000Y<C`0:C4l008
0:C4l0030000002Ta?00Y<C`00<0Y<C`100000000`2Ta?0000000:C4l0090:C4l0030000002Ta?00
Y<C`00D0Y<C`00<000000?V]H@0000002@3i[F400`000000nJeQ000000070>_I`@030000003`j<<0
l>S30080l>S300<000000?[W[00000000`3blIh2000003@0oooo00130?ooo`80000000@0oooo0000
0000000000000`3oool4000000P0Y<C`00<000000:C4l02Ta?001`2Ta?000`000000Y<C`0:C4l009
0:C4l0030000002Ta?00Y<C`00L0Y<C`0P0000090:C4l0030000002Ta?00Y<C`00L0Y<C`00<00000
0:C4l02Ta?001`2Ta?000`000000Y<C`0:C4l0080:C4l0030000002Ta?00Y<C`00L0Y<C`00<00000
0:C4l02Ta?00202Ta?000`000000Y<C`0:C4l0070:C4l08000002@2Ta?000`000000Y<C`0:C4l007
0:C4l08000002P3i[F400`000000jmW10>_I`@050>_I`@030000003`j<<0l>S300@0l>S30P000003
0?;aWP030000003oool0oooo03<0oooo00140?ooo`D000000`3oool2000000030>bML00000000000
00H0Y<C`00<000000:C4l00000002@2Ta?000`000000Y<C`0:C4l0080:C4l0030000002Ta?00Y<C`
00D0Y<C`0P0000000`2Ta?0000000:C4l0080:C4l0030000002Ta?00Y<C`00P0Y<C`00<000000:C4
l02Ta?001P2Ta?000`000000Y<C`0:C4l0080:C4l0030000002Ta?00Y<C`00L0Y<C`00<000000:C4
l02Ta?001`2Ta?000`000000Y<C`0:C4l0080:C4l0040000002Ta?000000000000L0Y<C`00<00000
0:C4l02Ta?001`2Ta?000`000000nJeQ0?V]H@080?V]H@030000003QfLl0000000D0jmW100<00000
0?3X``3`j<<01@3`j<<010000000l_6N0?;aWP3blIh2000003D0oooo00140?ooo`80000000<0oooo
0000000000000P0000000`3oool00000000000030>bML0030000002Ta?00Y<C`00<0Y<C`00@00000
0:C4l02Ta?0000002@2Ta?000`000000Y<C`0:C4l0080:C4l0030000002Ta?00Y<C`0080Y<C`0P00
00030:C4l0030000002Ta?00Y<C`00L0Y<C`00<000000:C4l02Ta?00202Ta?000`000000Y<C`0:C4
l0060:C4l0030000002Ta?00Y<C`00P0Y<C`00<000000:C4l02Ta?001`2Ta?000`000000Y<C`0:C4
l0070:C4l0030000002Ta?00Y<C`00P0Y<C`00@000000:C4l02Ta?00Y<C`0P0000040:C4l0030000
002Ta?00Y<C`00L0Y<C`00<000000:C4l0000000203i[F4010000000hMW?0>7Ic`0000050>_I`@03
0000003`j<<0l>S300@0l>S30P0000020?;aWP030000003>iWd0000003D0oooo00150?ooo`D00000
00@0oooo0000003oool000000`3/WG02000000<0Y<C`00<000000:C4l02Ta?000P2Ta?000`000000
Y<C`0:C4l0070:C4l0030000002Ta?00Y<C`00L0Y<C`00<000000:C4l02Ta?000P0000060:C4l003
0000002Ta?00Y<C`00L0Y<C`00<000000:C4l02Ta?001`2Ta?000`000000Y<C`0:C4l0070:C4l003
0000002Ta?00Y<C`00H0Y<C`00<000000:C4l02Ta?00202Ta?000`000000Y<C`0:C4l0070:C4l003
0000002Ta?00Y<C`00L0Y<C`00<000000:C4l02Ta?00102Ta?0200000080Y<C`00<000000:C4l02T
a?001`2Ta?0010000000Y<C`0:C4l00000060?V]H@030000003QfLl0hMW?0080hMW?00D000000>_I
`@3[fL40jmW1000000060?3X``030000003^m/0000000080l_6N0P00000f0?ooo`00A@3oool00`00
0000oooo0000000200000080oooo0P0000040>bML080000000<0Y<C`0000002Ta?00102Ta?000`00
0000Y<C`0:C4l0070:C4l0030000002Ta?00Y<C`00P0Y<C`0P0000080:C4l0030000002Ta?00Y<C`
00L0Y<C`00<000000:C4l02Ta?001`2Ta?000`000000Y<C`0:C4l0070:C4l0030000002Ta?00Y<C`
00H0Y<C`00<000000:C4l02Ta?001`2Ta?000`000000Y<C`0:C4l0070:C4l0030000002Ta?00Y<C`
00P0Y<C`00<000000:C4l02Ta?001P2Ta?02000000T0Y<C`00<000000:C4l02Ta?000P2Ta?000`00
0000nJeQ0?V]H@020?V]H@030000003QfLl0hMW?00@0hMW?00<000000>_I`@0000001`3`j<<01`00
0000k_K00000003blIh000000<kVO@000000=P3oool004D0oooo1P0000000`3oool0000000000005
0>bML0<000001P2Ta?000`000000Y<C`0:C4l0070:C4l0030000002Ta?00Y<C`00D0Y<C`0P000000
0`2Ta?0000000:C4l0080:C4l0030000002Ta?00Y<C`00L0Y<C`00<000000:C4l02Ta?001P2Ta?00
0`000000Y<C`0:C4l0070:C4l0030000002Ta?00Y<C`00H0Y<C`00<000000:C4l02Ta?001`2Ta?00
0`000000Y<C`0:C4l0070:C4l0030000002Ta?00Y<C`00L0Y<C`00<000000:C4l02Ta?001`2Ta?00
10000000Y<C`0000000000060:C4l0030000002Ta?00Y<C`00@0Y<C`00@000000?V]H@3i[F400000
1`3QfLl00`000000jmW1000000060?3X``050000003^m/00k_K00000003blIh00P00000g0?ooo`00
AP3oool020000000oooo000000000000oooo0000003oool000001P3/WG02000000L0Y<C`00<00000
0:C4l02Ta?001`2Ta?000`000000Y<C`0:C4l0020:C4l08000000`2Ta?000`000000Y<C`0:C4l007
0:C4l0030000002Ta?00Y<C`00L0Y<C`00<000000:C4l02Ta?001`2Ta?000`000000Y<C`0:C4l006
0:C4l0030000002Ta?00Y<C`00H0Y<C`00<000000:C4l02Ta?001`2Ta?000`000000Y<C`0:C4l007
0:C4l0030000002Ta?00Y<C`00H0Y<C`00<000000:C4l02Ta?00202Ta?0010000000Y<C`0:C4l02T
a?02000000<0Y<C`00<000000:C4l02Ta?001P2Ta?02000000T0hMW?00<000000?3X``3`j<<0103`
j<<010000000k_K00>kf`03^m/02000000030<kVO@000000oooo03H0oooo00160?ooo`@000000P3o
ool3000000D0k9e`0`0000070:C4l0030000002Ta?00Y<C`00L0Y<C`00@000000:C4l00000000000
1P2Ta?000`000000Y<C`0:C4l0070:C4l0030000002Ta?00Y<C`00H0Y<C`00<000000:C4l02Ta?00
1`2Ta?000`000000Y<C`0:C4l0060:C4l0030000002Ta?00Y<C`00H0Y<C`00<000000:C4l02Ta?00
1`2Ta?000`000000Y<C`0:C4l0060:C4l0030000002Ta?00Y<C`00L0Y<C`00<000000:C4l02Ta?00
1`2Ta?000`000000Y<C`0:C4l0040:C4l080000000<0Y<C`0000002Ta?001`2Ta?02000000P0hMW?
0P0000050?3X``030000003^m/00k_K00080k_K00P0000000`3>iWd0oooo0?ooo`0f0?ooo`00A`3o
ool00`000000oooo000000030?ooo`800000103/WG000`000000k9e`0>bML003000000H0Y<C`00<0
00000:C4l02Ta?001`2Ta?000`000000Y<C`0:C4l0070:C4l0030000002Ta?00Y<C`00H0Y<C`00<0
00000:C4l02Ta?001`2Ta?000`000000Y<C`0:C4l0060:C4l0030000002Ta?00Y<C`00H0Y<C`00<0
00000:C4l02Ta?001P2Ta?000`000000Y<C`0:C4l0070:C4l0030000002Ta?00Y<C`00H0Y<C`00<0
00000:C4l02Ta?001P2Ta?000`000000Y<C`0:C4l0070:C4l0030000002Ta?00Y<C`00L0Y<C`00<0
00000:C4l02Ta?001`2Ta?000`000000hMW?0>7Ic`060>7Ic`040000003Ti]<0i>KC000000@0l>S3
00<000000>kf`03^m/000P3^m/000`000000c^Im0000000h0?ooo`00A`3oool400000080oooo0`00
00030>bML0070000003/WG00k9e`0>bML0000000hI=h000000060:C4l0030000002Ta?00Y<C`00D0
Y<C`00<000000:C4l00000002@2Ta?000`000000Y<C`0:C4l0060:C4l0030000002Ta?00Y<C`00H0
Y<C`00<000000:C4l02Ta?001P2Ta?000`000000Y<C`0:C4l0060:C4l0030000002Ta?00Y<C`00H0
Y<C`00<000000:C4l02Ta?001`2Ta?000`000000Y<C`0:C4l0050:C4l0030000002Ta?00Y<C`00L0
Y<C`00<000000:C4l02Ta?001P2Ta?000`000000Y<C`0:C4l0070:C4l0030000002Ta?00000000L0
Y<C`00<000000>7Ic`3QfLl01P3QfLl01@000000i>KC0>CVd`3Ti]<0000000<0l>S300<000000>kf
`03^m/000P3^m/02000000030<kVO@3oool0oooo03L0oooo00180?ooo`<000000`3oool01P000000
jHU=000000000000k9e`000000<0k9e`0P0000000`3QTgP000000:C4l0040:C4l0030000002Ta?00
Y<C`00@0Y<C`00D000000:C4l02Ta?00Y<C`000000080:C4l0030000002Ta?00Y<C`00H0Y<C`00<0
00000:C4l02Ta?001`2Ta?000`000000Y<C`0:C4l0060:C4l0030000002Ta?00Y<C`00D0Y<C`00<0
00000:C4l02Ta?001P2Ta?000`000000Y<C`0:C4l0060:C4l0030000002Ta?00Y<C`00H0Y<C`00<0
00000:C4l02Ta?001P2Ta?000`000000Y<C`0:C4l0070:C4l0030000002Ta?00Y<C`00L0Y<C`00@0
00000:C4l02Ta?0000001@2Ta?000`000000hMW?0>7Ic`060>7Ic`030000003Ti]<0i>KC0080i>KC
00@000000?3X``3`j<<00000103^m/02000000030<kVO@000000oooo03P0oooo00180?ooo`@00000
0P3oool00`000000jHU=0>V9C@03000000<0k9e`00D000000>6CN0000000hI=h000000050:C4l004
0000002Ta?00Y<C`0:C4l0800000102Ta?000`000000Y<C`0:C4l0070:C4l0030000002Ta?00Y<C`
00H0Y<C`00<000000:C4l02Ta?001P2Ta?000`000000Y<C`0:C4l0060:C4l0030000002Ta?00Y<C`
0080Y<C`4@0000040:C4l0030000002Ta?00Y<C`00H0Y<C`00<000000:C4l02Ta?001@2Ta?000`00
0000Y<C`0:C4l0070:C4l0030000002Ta?00Y<C`00L0Y<C`00<000000:C4l02Ta?000P2Ta?001@00
0000Y<C`0:C4l02Ta?00000000P0hMW?00<000000>CVd`3Ti]<00`3Ti]<00`000000l>S300000005
0>kf`080000000<0c^Im0?ooo`3oool0>03oool004T0oooo0P000000103oool000000?ooo`000002
0>V9C@@000000P3/WG001P000000hI=h0>6CN0000000hI=h000000D0Y<C`00<000000:C4l0000000
1`2Ta?000`000000Y<C`0:C4l0070:C4l0030000002Ta?00Y<C`00D0Y<C`00<000000:C4l02Ta?00
1`2Ta?000`000000Y<C`0:C4l0020:C4l0P000000`2Ta?000`000000Y<C`0:C4l0060:C4l0030000
002Ta?00Y<C`0080Y<C`200000040:C4l0030000002Ta?00Y<C`00H0Y<C`00<000000:C4l02Ta?00
1P2Ta?000`000000Y<C`0:C4l0070:C4l0030000002Ta?00Y<C`00@0Y<C`00<000000:C4l0000000
203QfLl00`000000i>KC0>CVd`050>CVd`800000103^m/0010000000gObd00000000000j0?ooo`00
B@3oool3000000040?ooo`000000oooo00000080jHU=00<000000>V9C@3YRDd00`0000030>6CN003
0000003QTgP0000000D0Y<C`00<000000:C4l02Ta?001`2Ta?000`000000Y<C`0:C4l0060:C4l003
0000002Ta?00Y<C`00H0Y<C`00<000000:C4l02Ta?001@2Ta?06000000<0Y<C`00<000000:C4l02T
a?001@2Ta?000`000000Y<C`0:C4l0060:C4l0030000002Ta?00Y<C`00H0Y<C`00@000000:C4l02T
a?00Y<C`1P0000060:C4l0030000002Ta?00Y<C`00L0Y<C`00<000000:C4l02Ta?001P2Ta?000`00
0000Y<C`0:C4l0060:C4l0030000003QfLl0hMW?00H0hMW?00<000000>CVd`3Ti]<01P3Ti]<00`00
0000k_K00>kf`0020>kf`0040000003Mo;@0gObd000003/0oooo001:0?ooo`<0000000<0oooo0000
000000000P3YRDd2000000<0jHU=00<000000>6CN03QTgP00P3QTgP010000000hI=h000000000002
0:C4l0030000002Ta?00000000T0Y<C`00<000000:C4l02Ta?001P2Ta?000`000000Y<C`0:C4l005
0:C4l0040000002Ta?00Y<C`0:C4l0@0000000<0Y<C`0000002Ta?001`2Ta?000`000000Y<C`0:C4
l0040:C4l0030000002Ta?00Y<C`00H0Y<C`00<000000:C4l02Ta?001@2Ta?000`000000Y<C`0:C4
l0050:C4l0030000002Ta?00Y<C`00@000000P2Ta?000`000000Y<C`0:C4l0060:C4l0030000002T
a?00Y<C`00H0Y<C`00<000000:C4l02Ta?001P2Ta?000`000000e]SJ000000060>7Ic`030000003T
i]<0i>KC00H0i>KC0P0000030>kf`0030000003Mo;@0gObd00800000>`3oool004X0oooo1@000000
1P3oool000000>V9C@000000jHU=00000080jHU=0`0000030>6CN0060000003QTgP0hI=h0000002T
a?0000000P2Ta?000`000000Y<C`0:C4l0060:C4l0030000002Ta?00Y<C`00L0Y<C`00<000000:C4
l02Ta?001@2Ta?03000000H0Y<C`00<000000:C4l02Ta?001@2Ta?000`000000Y<C`0:C4l0050:C4
l0030000002Ta?00Y<C`00D0Y<C`00<000000:C4l02Ta?001@2Ta?000`000000Y<C`0:C4l0050:C4
l0030000002Ta?00Y<C`00@0Y<C`0`0000070:C4l0030000002Ta?00Y<C`00H0Y<C`00<000000:C4
l02Ta?001P2Ta?001@000000e]SJ0=KHfP3Ff=X0000000@0hMW?00<000000>CVd`3Ti]<01P3Ti]<0
0`000000i??E000000020>kf`0050000003Mo;@0gObd0=gl]0000000?03oool004/0oooo0P000000
1P3oool00000000000000000jHU=00000080jHU=00<000000>V9C@0000000P3OPe`200000080hI=h
00@000000>6CN03QTgP00000102Ta?000`000000Y<C`0:C4l0060:C4l0030000002Ta?00Y<C`00L0
Y<C`00<000000:C4l02Ta?000P2Ta?02000000030:C4l0000000Y<C`00H0Y<C`00<000000:C4l02T
a?001@2Ta?000`000000Y<C`0:C4l0050:C4l0030000002Ta?00Y<C`00D0Y<C`00<000000:C4l02T
a?001@2Ta?000`000000Y<C`0:C4l0040:C4l0030000002Ta?00Y<C`00D0Y<C`00<000000:C4l02T
a?000P0000040:C4l0030000002Ta?00Y<C`00H0Y<C`00<000000:C4l02Ta?001P2Ta?000`000000
e]SJ0=KHfP020=KHfP050000003QfLl0hMW?0>7Ic`000000203Ti]<01P000000i??E0>Cce@000000
k_K0000000@0gObd00<000000?ooo`3oool0>P3oool004`0oooo0P0000001@3oool000000000003Y
RDd0000000<0jHU=00<000000>V9C@0000000`3OPe`01@000000hI=h0>6CN0000000hI=h00800000
102Ta?000`000000Y<C`0:C4l0060:C4l0030000002Ta?00Y<C`00H0Y<C`00<000000:C4l02Ta?00
0P0000030:C4l0030000002Ta?00Y<C`00H0Y<C`00<000000:C4l02Ta?00102Ta?000`000000Y<C`
0:C4l0050:C4l0030000002Ta?00Y<C`00D0Y<C`00<000000:C4l02Ta?00102Ta?000`000000Y<C`
0:C4l0050:C4l0030000002Ta?00Y<C`00D0Y<C`00<000000:C4l02Ta?000P2Ta?0200000080Y<C`
00<000000:C4l02Ta?001@2Ta?000`000000Y<C`0:C4l0060:C4l0030000003Ff=X0e]SJ00@0e]SJ
00<000000>7Ic`000000203Ti]<01`000000i??E0>Cce@3TlmD000000>kf`00000000`3Mo;@00`00
0000oooo0?ooo`0k0?ooo`00C03oool200000080oooo0`0000040>V9C@800000103OPe`200000005
0>6CN000000000000=J;O@000000102Ta?000`000000Y<C`0:C4l0060:C4l0030000002Ta?00Y<C`
00H0Y<C`0P0000060:C4l0030000002Ta?00Y<C`00D0Y<C`00<000000:C4l02Ta?001@2Ta?000`00
0000Y<C`0:C4l0040:C4l0030000002Ta?00Y<C`00D0Y<C`00<000000:C4l02Ta?00102Ta?000`00
0000Y<C`0:C4l0040:C4l0030000002Ta?00Y<C`00D0Y<C`00<000000:C4l02Ta?001@2Ta?020000
00L0Y<C`00<000000:C4l02Ta?001P2Ta?000`000000e]SJ0=KHfP060=KHfP030000003Ti]<0i>KC
00H0i>KC00<000000>Cce@3TlmD00P3TlmD2000000<0gObd00<000000?ooo`3oool0?03oool004d0
oooo0P0000020?ooo`8000001@3YRDd2000000D0gh=L0`0000020=J;O@030000002Ta?00Y<C`0080
Y<C`0P0000070:C4l0030000002Ta?00Y<C`00<0Y<C`0P0000000`2Ta?0000000:C4l0060:C4l003
0000002Ta?00Y<C`00D0Y<C`00<000000:C4l02Ta?00102Ta?000`000000Y<C`0:C4l0040:C4l003
0000002Ta?00Y<C`00@0Y<C`00<000000:C4l02Ta?00102Ta?000`000000Y<C`0:C4l0050:C4l003
0000002Ta?00Y<C`00@0Y<C`00<000000:C4l02Ta?001P2Ta?0010000000Y<C`0000000000040:C4
l0030000002Ta?00Y<C`00D0Y<C`0P0000080=KHfP8000001P3Ti]<2000000D0i??E00@000000=gl
]03Mo;@0gObd0P00000n0?ooo`00CP3oool2000000040?ooo`0000000000000000@0jHU=00<00000
0=n3G0000000103OPe`010000000gh=L0000000000020=J;O@800000102Ta?000`000000Y<C`0:C4
l0040:C4l0030000002Ta?00Y<C`0080Y<C`00<000000:C4l02Ta?000P2Ta?000`000000Y<C`0:C4
l0050:C4l0030000002Ta?00Y<C`00@0Y<C`00<000000:C4l02Ta?00102Ta?000`000000Y<C`0:C4
l0040:C4l0030000002Ta?00Y<C`00@0Y<C`00<000000:C4l02Ta?00102Ta?000`000000Y<C`0:C4
l0040:C4l0030000002Ta?00Y<C`00D0Y<C`00<000000:C4l02Ta?001@2Ta?000`000000Y<C`0:C4
l0020:C4l080000000<0Y<C`0000002Ta?001P2Ta?02000000L0e]SJ0P0000020=SRgP030000003T
i]<0i>KC0080i>KC00<000000>Cce@3TlmD0103TlmD200000080gObd0P00000o0?ooo`00C`3oool2
000000040?ooo`0000000000000000<0jHU=00@000000=n3G03OPe`000000`3OPe`010000000gh=L
0000003EO6D200000080eX]m00<000000:C4l02Ta?000P2Ta?000`000000Y<C`0:C4l0040:C4l004
0000002Ta?000000000000H0Y<C`00<000000:C4l02Ta?00102Ta?000`000000Y<C`0:C4l0050:C4
l0030000002Ta?00Y<C`00@0Y<C`00<000000:C4l02Ta?000`2Ta?000`000000Y<C`0:C4l0040:C4
l0030000002Ta?00Y<C`00@0Y<C`00<000000:C4l02Ta?00102Ta?000`000000Y<C`0:C4l0040:C4
l0030000002Ta?00Y<C`00D0Y<C`00<000000:C4l02Ta?001@2Ta?000`000000Y<C`0:C4l0050:C4
l08000001`3Ff=X00`000000f>;N0=SRgP020=SRgP050000003Ti]<0i>KC0>CVd`0000001P3TlmD2
00000080gObd0P0000100?ooo`00C`3oool2000000050?ooo`00000000000=]W5`0000000P3YRDd0
1@000000gh=L0=n3G03OPe`000000080gh=L00@000000=n3G03OPe`000000P3EO6D2000000030=J;
O@000000Y<C`00<0Y<C`00<000000:C4l02Ta?00102Ta?000`000000Y<C`0:C4l0060:C4l0030000
002Ta?00Y<C`00D0Y<C`00<000000:C4l02Ta?00102Ta?000`000000Y<C`0:C4l0040:C4l0030000
002Ta?00Y<C`00<0Y<C`00<000000:C4l02Ta?00102Ta?000`000000Y<C`0:C4l0030:C4l0030000
002Ta?00Y<C`00@0Y<C`00<000000:C4l02Ta?00102Ta?000`000000Y<C`0:C4l0050:C4l0030000
002Ta?00Y<C`00D0Y<C`00<000000:C4l00000001@2Ta?000`000000e]SJ0=KHfP060=KHfP030000
003Hh]h0f>;N00<0f>;N00@000000>CVd`3Ti]<000001@3TlmD2000000050=cme0000000gObd0=gl
]0000000@@3oool00500oooo0P000000103oool000000=]W5`3KIaL2000000030>V9C@000000gh=L
0080gh=L0P0000030=n3G0040000003EO6D0eGaU0=ElI@@00000102Ta?000`000000Y<C`0:C4l002
0:C4l0030000002Ta?00000000P0Y<C`00<000000:C4l02Ta?001@2Ta?000`000000Y<C`0:C4l004
0:C4l0030000002Ta?00Y<C`00<0Y<C`00<000000:C4l02Ta?00102Ta?000`000000Y<C`0:C4l003
0:C4l0030000002Ta?00Y<C`00<0Y<C`00<000000:C4l02Ta?00102Ta?000`000000Y<C`0:C4l004
0:C4l0030000002Ta?00Y<C`00@0Y<C`00<000000:C4l02Ta?001@2Ta?001@000000Y<C`0:C4l02T
a?00000000<0Y<C`00<000000=KHfP3Ff=X01P3Ff=X00`000000f>;N0=SRgP050=SRgP8000001@3T
lmD01P000000g?gD0=cme03LoM@000000=gl]0800000@@3oool00540oooo0`0000030=]W5`<00000
103OPe`01@000000gh=L0=n3G03OPe`0000000@0eGaU00@000000=ElI@3EO6D00000102Ta?001000
0000Y<C`0000000000030:C4l0030000002Ta?00Y<C`00H0Y<C`00<000000:C4l02Ta?00102Ta?00
0`000000Y<C`0:C4l0040:C4l0030000002Ta?00Y<C`00<0Y<C`00<000000:C4l02Ta?00102Ta?00
0`000000Y<C`0:C4l0030:C4l0030000002Ta?00Y<C`00<0Y<C`00<000000:C4l02Ta?000`2Ta?00
0`000000Y<C`0:C4l0040:C4l0030000002Ta?00Y<C`00@0Y<C`00<000000:C4l02Ta?001@2Ta?00
0`000000Y<C`0:C4l0030:C4l0030000002Ta?00000000L0e]SJ0P0000080=SRgP030000003TlmD0
i??E00<0i??E00<000000=cme03LoM@00P3LoM@300000480oooo001B0?ooo`<00000103KIaL20000
00<0gh=L0`0000000`3OPe`000000=ElI@040=ElI@040000003EO6D0eGaU000000@0Y<C`00<00000
0:C4l02Ta?00102Ta?02000000L0Y<C`00<000000:C4l02Ta?00102Ta?000`000000Y<C`0:C4l004
0:C4l0030000002Ta?00Y<C`00<0Y<C`00<000000:C4l02Ta?000`2Ta?000`000000Y<C`0:C4l003
0:C4l0030000002Ta?00Y<C`0080Y<C`00<000000:C4l02Ta?00102Ta?000`000000Y<C`0:C4l004
0:C4l0030000002Ta?00Y<C`00@0Y<C`00<000000:C4l02Ta?00102Ta?000`000000Y<C`0:C4l005
0:C4l0030000003Ff=X0e]SJ00D0e]SJ00<000000=SRgP3Hh]h01P3Hh]h3000000@0i??E00<00000
0=cme03LoM@00P3LoM@3000004<0oooo001C0?ooo`8000001@3KIaL3000000070=n3G0000000gh=L
0=n3G0000000gh=L000000050=ElI@80000000H0eGaU0000002Ta?00Y<C`0000002Ta?02000000H0
Y<C`00<000000:C4l02Ta?001@2Ta?000`000000Y<C`0:C4l0040:C4l0030000002Ta?00Y<C`00<0
Y<C`00@000000:C4l02Ta?00Y<C`5P0000030:C4l0030000002Ta?00Y<C`00@0Y<C`00<000000:C4
l02Ta?00102Ta?000`000000Y<C`0:C4l0040:C4l0030000002Ta?00Y<C`00@0Y<C`0P0000000`39
eN<000000=KHfP040=KHfP030000003Hh]h0f>;N00H0f>;N00@000000=O/h`3Gk><000000`3TlmD0
0`000000g?gD0=cme0030=cme0800000A03oool005@0oooo0P0000040=]W5`80000000<0efLa0000
000000000`3OPe`2000000L0eGaU00@000000=ElI@0000000000102Ta?000`000000Y<C`0:C4l004
0:C4l0030000002Ta?00Y<C`00D0Y<C`00<000000:C4l02Ta?00102Ta?000`000000Y<C`0:C4l002
0:C4l0@000000P2Ta?000`000000Y<C`0:C4l0030:C4l0030000002Ta?00Y<C`00<0Y<C`00<00000
0:C4l02Ta?000P2Ta?000`000000Y<C`0:C4l005000000@0Y<C`00<000000:C4l02Ta?00102Ta?00
0`000000Y<C`0:C4l0030:C4l08000001P2Ta?001@000000bMGS0<WEh`39eN<0000000<0e]SJ0P00
00070=SRgP8000000`3Gk><010000000i??E0000000000050=cme0030000002bjiH0oooo04@0oooo
001E0?ooo`<000000`3KIaL600000080gh=L0P0000070=ElI@040000003EO6D00000000000@0Y<C`
00<000000:C4l02Ta?00102Ta?000`000000Y<C`0:C4l0040:C4l0030000002Ta?00Y<C`00@0Y<C`
00<000000:C4l02Ta?000P0000020:C4l0030000002Ta?00Y<C`0080Y<C`00<000000:C4l02Ta?00
0P2Ta?000`000000Y<C`0:C4l0030:C4l0050000002Ta?00Y<C`0:C4l00000001@2Ta?000`000000
Y<C`0:C4l00200000080Y<C`00<000000:C4l02Ta?000`2Ta?000`000000Y<C`0:C4l0030:C4l003
0000002Ta?00Y<C`00D0Y<C`00<000000<WEh`39eN<00`39eN<00`000000e]SJ000000080=SRgP03
0000003Gk><0encS00<0encS0P0000050=cme0<00000AP3oool005D0oooo0P0000001@3KIaL00000
0=]W5`3KIaL000000080efLa00<000000=MW<@3GIc400P000000103OPe`000000000000000060=El
I@80000000<0bWA[0000002Ta?000`2Ta?02000000D0Y<C`00<000000:C4l02Ta?00102Ta?000`00
0000Y<C`0:C4l0030:C4l0<00000102Ta?000`000000Y<C`0:C4l0020:C4l0030000002Ta?00Y<C`
0080Y<C`00<000000:C4l02Ta?000P2Ta?000`000000Y<C`0:C4l0020:C4l0030000002Ta?00Y<C`
00<0Y<C`00<000000:C4l02Ta?000P2Ta?02000000D0Y<C`00<000000:C4l02Ta?000`2Ta?000`00
0000Y<C`0:C4l0040:C4l08000001`39eN<00`000000f>;N0=SRgP050=SRgP8000001P3Gk><00`00
0000g?gD0=cme0030=cme00300000035o//0000004L0oooo001F0?ooo`@000000P3KIaL00`000000
efLa0000000200000080efLa0`0000000`3EO6D00000000000040=ElI@<0000000<0bWA[0000002T
a?00102Ta?000`000000Y<C`0:C4l0030:C4l08000001@2Ta?000`000000Y<C`0:C4l00200000080
Y<C`00<000000:C4l02Ta?000`2Ta?001@000000Y<C`0:C4l02Ta?00000000@0Y<C`00<000000:C4
l02Ta?000P2Ta?000`000000Y<C`0:C4l0020:C4l0030000002Ta?00Y<C`0080Y<C`00<000000:C4
l02Ta?000`2Ta?0010000000Y<C`0000000000020:C4l0030000002Ta?00Y<C`00<0Y<C`00<00000
0:C4l02Ta?00102Ta?000`000000bMGS0<WEh`050<WEh`<000001@3Hh]h2000000H0encS0`000004
0=cme00400000035o//00000000004L0oooo001G0?ooo`@0000000@0ffLG0000003GIc4000000P3G
Ic42000000030=MW<@000000cfA20080000000P0eGaU0000003EO6D0eGaU0000003EO6D000000<Yd
J`<000001@2Ta?02000000D0Y<C`00<000000:C4l02Ta?000`2Ta?02000000D0Y<C`00<000000:C4
l02Ta?000P2Ta?000`000000Y<C`0:C4l0020:C4l0050000002Ta?00Y<C`0:C4l0000000102Ta?00
1@000000Y<C`0:C4l02Ta?00000000D0Y<C`00<000000:C4l02Ta?000P2Ta?000`000000Y<C`0:C4
l0020:C4l08000001@2Ta?000`000000Y<C`0:C4l0030:C4l08000001P39eN<2000000<0b]cW00D0
00000=SRgP3Hh]h0f>;N000000060=O/h`80000000<0d_KV0000003LoM@00P3LoM@200000080aOk;
00<000000?ooo`3oool0AP3oool005P0oooo10000000103KIaL000000=MW<@0000030=MW<@030000
003GIc4000000080cfA21@0000000`3EO6D000000<YdJ`020<YdJ`8000001P2Ta?000`000000Y<C`
0:C4l0030:C4l0030000002Ta?00Y<C`0080000000<0Y<C`0000002Ta?00102Ta?000`000000Y<C`
0:C4l0030:C4l0050000002Ta?00Y<C`0:C4l00000000`2Ta?000`000000Y<C`0:C4l0020:C4l005
0000002Ta?00Y<C`0:C4l0000000102Ta?000`000000Y<C`0:C4l0020:C4l0030000002Ta?00Y<C`
00<0Y<C`00@000000:C4l000000000000P2Ta?000`000000Y<C`0:C4l0030:C4l00300000039eN<0
bMGS00D0bMGS00<000000<[Li`3:g>L00`3:g>L010000000f>;N0000000000050=O/h`8000000`3B
m^H010000000g?gD0=cme00000030<Gnb`030000003oool0oooo04L0oooo001I0?ooo`80000000D0
]Bh0000000000000efLa000000040=MW<@800000103?I48300000080eGaU00@000000<YdJ`3:M6/0
bWA[0`0000050:C4l0030000002Ta?00Y<C`00<0Y<C`0P0000040:C4l0030000002Ta?00Y<C`00<0
Y<C`00<000000:C4l02Ta?000P2Ta?001@000000Y<C`0:C4l02Ta?00000000@0Y<C`00D000000:C4
l02Ta?00Y<C`000000030:C4l0050000002Ta?00Y<C`0:C4l0000000102Ta?000`000000Y<C`0:C4
l0030:C4l0030000002Ta?00Y<C`0080Y<C`0P0000050:C4l00300000039eN<0bMGS00@0bMGS0P00
00070<[Li`030000003Gk><0encS00@0encS00<000000=;fiP3Bm^H00`3Bm^H00`000000g?gD0000
00020<Gnb`800000BP3oool005X0oooo0P0000020;D^008000001P3GIc400`000000cfA20<mT@P03
0<mT@P@000001@3:M6/2000000D0Y<C`0P000000102Ta?0000000000002Ta?02000000@0Y<C`0P00
00040:C4l0030000002Ta?00Y<C`0080Y<C`00@000000:C4l02Ta?000000102Ta?001@000000Y<C`
0:C4l02Ta?00000000<0Y<C`00D000000:C4l02Ta?00Y<C`000000030:C4l0030000002Ta?00Y<C`
00<0Y<C`00<000000:C4l02Ta?000P2Ta?02000000040:C4l000000000000:C4l08000001@39eN<2
000000L0b]cW0`0000040=O/h`8000001@3Bm^H300000080aOk;0P00001;0?ooo`00F`3oool20000
0080]Bh00`0000040=MW<@<000000P3?I4800`000000cfA20<mT@P04000000D0bWA[00<000000:C4
l02Ta?00102Ta?000`000000Y<C`0:C4l0030:C4l0030000002Ta?00Y<C`00<0Y<C`00<000000:C4
l02Ta?000P2Ta?000`000000Y<C`0:C4l0020:C4l0040000002Ta?00Y<C`000000<0Y<C`00@00000
0:C4l02Ta?0000000`2Ta?001@000000Y<C`0:C4l02Ta?00000000@0Y<C`00<000000:C4l02Ta?00
0P2Ta?000`000000Y<C`0:C4l0020:C4l0030000002Ta?00Y<C`00<0Y<C`00<000000<WEh`39eN<0
1039eN<00`000000b]cW0<[Li`050<[Li`8000000P38hn/00`000000encS0=O/h`02000000H0d_KV
0P0000030<Gnb`800000C03oool005d0oooo00<000000;D^002e;P00100000030=MW<@030000003?
I4800000008000000`3?I4800`000000aEm<0000000400000080bWA[0P0000030:C4l0040000002T
a?000000000000@0Y<C`0P0000040:C4l0030000002Ta?00Y<C`0080Y<C`00D000000:C4l02Ta?00
Y<C`000000020:C4l0050000002Ta?00Y<C`0:C4l00000000P2Ta?001@000000Y<C`0:C4l02Ta?00
000000<0Y<C`00D000000:C4l02Ta?00Y<C`000000030:C4l08000000`2Ta?0200000080Y<C`1000
00000`2kdN/000000<WEh`020<WEh`8000001P3:g>L2000000@0b>?[00<000000=O/h`0000001P3B
m^H300000080aOk;0P00001>0?ooo`00GP3oool01@000000]Bh0000000000000_ST000<0000000<0
efLa0000003?I4800P3?I482000000<0cfA200<000000<EOC035Gd`00P0000000`35Gd`000000000
0004000000030:C4l0000000Y<C`0080Y<C`0P0000040:C4l0030000002Ta?00Y<C`0080Y<C`00<0
00000:C4l02Ta?000P2Ta?001`000000Y<C`0:C4l02Ta?0000000:C4l00000000`2Ta?0010000000
Y<C`0:C4l00000030:C4l0040000002Ta?00Y<C`000000<0Y<C`00D000000:C4l02Ta?00Y<C`0000
00040:C4l0L000000`2kdN/010000000bMGS0000000000060<[Li`8000001@38hn/2000000H0d_KV
0P0000020<Kki`0400000035o//00000000004l0oooo001O0?ooo`<000000`2n>@0400000080cfA2
00H000000<mT@P00000000000<mT@P0000040<EOC08000000`35Gd`010000000Y<C`000000000005
0:C4l08000000`2Ta?02000000<0Y<C`00D000000:C4l02Ta?00Y<C`000000030:C4l0050000002T
a?00Y<C`0000002Ta?001P0000000`2Ta?0000000:C4l0020:C4l0040000002Ta?00Y<C`000000<0
Y<C`00@000000:C4l02Ta?00Y<C`100000000`2BAfh00000000000050;_Aj`8000001P3:g>L20000
00D0b>?[0P0000000`35j^l000000=;fiP030=;fiP8000000`36nnL010000000aOk;00000000001@
0?ooo`00H03oool3000000@0_ST00`0000020<mT@P030000003?I480cfA200<000001@35Gd`20000
0080aEm<0P0000000`2Ta?000000000000050:C4l08000000`2Ta?0200000080Y<C`0P0000020:C4
l0030000002Ta?00Y<C`00D0000000H0Y<C`0000002Ta?00Y<C`0000002Ta?0500000080Y<C`00@0
00000:C4l02Ta?00Y<C`1`0000000`2BAfh00000000000050;_Aj`80000000<0^mG]0000003:g>L0
0`3:g>L2000000@0b>?[0`0000020<GZk`040000003Bm^H0d_KV0=;fiP8000001@36nnL200000580
oooo001R0?ooo`8000001@2n>@04000000@0cfA2100000040<EOC0D000000P2Ta?03000000@0Y<C`
0P0000030:C4l0050000002Ta?00Y<C`0:C4l00000000P2Ta?0200000080Y<C`00D000000:C4l000
0000Y<C`000000020:C4l0070000002Ta?00Y<C`0000002Ta?0000000:C4l00>000000@0^m7[0`00
00040;_Ek@040000003:g>L00000000000@0b>?[0P0000050<GZk`040000003Bm^H00000000000D0
a__W0`00001C0?ooo`00H`3oool400000080_ST000<000000;dm2`2m?@/00`0000020<mT@P040000
0035Gd`0aEm<0<EOC08000001035Gd`4000000@0Y<C`0`0000030:C4l08000000P2Ta?0200000080
Y<C`0P0000000`2Ta?0000000:C4l0020:C4l08000000P2Ta?0020000000Y<C`0000002Ta?000000
0:C4l0000000Y<C`1`000000102F>eH000000000002F>eH2000000<0^m7[0`0000060;_Ek@<00000
0`38hn/3000000H0aN[_0`0000050<Kki`@00000E03oool006@0oooo0P0000001@2n>@0000000000
002n>@0000000080_Cd;00<000000;dm2`0000000`0000040<EOC0<0000000<0aEm<00000035Gd`0
100000050:C4l08000000`2Ta?0200000080Y<C`0P000000102Ta?0000000000002Ta?0200000009
0:C4l0000000Y<C`0000002Ta?0000000:C4l0000000Y<C`00D000000P2F>eH20000000409HkEP00
0000000009HkEP8000000`2kdN/2000000H0^mG]0`000000102ifO0000000<SSj`38hn/2000000H0
aN[_100000050<Kki`@00000EP3oool006H0oooo0P000000102n>@0000000000000000020;dm2`03
0000002m?@/0_Cd;00@000001@35Gd`400000080^UQB100000040:C4l0<000000P2Ta?0200000080
Y<C`0P0000001P2Ta?0000000000002Ta?0000000:C4l080000000<0Y<C`00000000000010000000
0`2SAeL00000000000020000000409HkEP000000000009HkEP8000000P2kdN/3000000D0^mG]0`00
00030;WIl0@000001@35j^l3000000<0_^ob00<000000<Kki`36nnL00`0000000`2ann8000000000
001G0?ooo`00I`3oool200000080_ST0100000040;dm2`D000000`35Gd`00`000000aEm<00000004
00000080Y<C`0`0000040:C4l0L0000000H0Y<C`000000000000Y<C`0000002Ta?06000000030:=7
E`00000000000080000000<0XdMG0000002F>eH01@000000102Zbo4000000000000000040;_Ek@@0
00000P2ifO0400000080]mgc00@000000<GZk`35j^l0aN[_0`0000050;k_lP0400000036nnL00000
00000080/O_R0P00001I0?ooo`00J03oool5000000040;dm2`000000000000000080_Cd;00<00000
0;Hl702f?1`00P2f?1`5000000030<EOC0000000^UQB0080^UQB100000000`2Ta?00000000000002
000000040:C4l0000000Y<C`0:C4l0/0000000<0XdMG000000000000100000000`2SAeL000000000
0008000000040:W=lP000000^mG]0;_Ek@<000000P2ifO04000000D0]mgc00<000000<GZk`000000
0P0000070;k_lP<000000P2ann83000005X0oooo001Z0?ooo`@000000P2m?@/5000000H0]S`L1P00
00020;YHDP80000000<0Y<C`0000000000000P0000000`2Ta?00000000000004000000030:C4l000
0000000001@000000P2YcO86000000030;WIl00000000000008000001P2ggO<5000000H0_^ob1@00
00020;7khP<00000G03oool006/0oooo1@0000000`2m?@/000000;dm2`020;dm2`<00000102f?1`0
10000000]S`L0000002]=bL800000080Y<C`9`0000020;OMl`P000000P2cgoH00`000000_^ob0;k_
lP020;k_lP@000000`2cl_@00`000000/O_R00000003000005d0oooo001]0?ooo`80000000@006gF
00000000000000000`2m?@/00`000000]S`L00000003000000040;Hl70000000]S`L000000@0[CLW
0`0000000`2Ta?0000000000000Y000000X0/mof00<000000;k_lP0000000P0000060;?bm0D00000
G`3oool006h0oooo0`0000000`00KMH0000000000003000000D0]S`L2@0000020:dg9`@0000000<0
XS0]0000002R<2d00P2R<2dI000000@0Y/of00<000000;?OmP2cgoH01@2cgoH9000000H0/o;d2000
001P0?ooo`00L03oool500000080?Ykd1P000000102f?1`000000000000000040:dg9c0000001P2]
h_T00`000000/o;d0;?bm006000000030:Cam0000000000000<00000HP3oool00780oooo1@000006
03jNm240000000<0V<kj000000000000100000001@2Qd?P00000000000000000Xm3g01@000001@2T
lO@5000006@0oooo001d0?ooo`T00000100nW_@2000000L0L[Ok1`00000209?5n08000000P2Ca_T0
10000000TlSj0000002DbOX20000000809O<nP000000000009[?nP000000W<oj0000002Nd?T20000
0080XM3h200000070:ORn`8000000`2TlO@9000006H0oooo001f0?ooo`@000000`0bWo8=000000D0
K[[m1000000209?6n@80000000d0TlSj0000002DbOX0000009G;nP000000Ulcj0000002Hc_X00000
09[?nP000000W<oj0080000000@0W]3i00000000000000001`2Oh_d<000000<0TNgb1000001X0?oo
o`00N03oool4000000P0<Yob0P00000406jjo@D00000101/__h200000080TlSj00<0000009C9nP2D
bOX00P00000209O<nP030000002Hc_X000000080V/oj00<0000009c?nP2LcoX00P00000309KPoPH0
0000102Oh_d2000000L0TNgb1000001Z0?ooo`00N`3oool?000000H0K;kn0`00000206c2oQ400000
0P2=gOh3000000H0U^3n3P00001]0?ooo`00OP3oool4000000H0::3^0P00000306bnoP<00000101/
`_h200000080KLKo00@00000073;o`1`bol000000P1ed?l01@000000O=Go07cEo`1leOl000000080
Q=Wo0P00000408gMoP<000000`2Fh?h2000000H0NnC^0`00001`0?ooo`00PP3oool<000000@0K<;n
0P00000306g6o`040000001`bol0L<_o000000<0MM3o00<0000007cEo`1leOl00P1leOl010000000
Q=Wo08CIo`24fOl2000000@0SMgn3000001c0?ooo`00Q@3oool4000000D08Z;X1@00000306g6o`05
0000001`bol0L<_o073;o`000000101ed?l00`000000O=Go07cEo`0207cEo`0400000024fOl0Q=Wo
08CIo`D000001@1Tf>P4000007H0oooo00290?ooo`D000001@0PY^8E000000D0ClcR1@00001j0?oo
o`00SP3oool7000000@09:cN00<0000002jdg@0^]=d0100^]=d00`000000?;oN03bogP0203bogPP0
0000O`3oool009D0oooo400000270?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?oo
o`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?oo
o`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?oo
o`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?oo
o`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?oo
o`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?oo
o`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?oo
o`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?oo
o`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?oo
o`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?oo
o`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?ooo`00o`3oool]0?oo
o`00\
\>"],
  ImageRangeCache->{{{0, 299}, {325.188, 0}} -> {0.0492886, -8.76037*^-05, \
0.00286561, 0.00286561}}]
}, Open  ]],

Cell[BoxData[
    \(Clear[sphere]\)], "Input",
  CellLabel->"In[4]:="]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"5.0 for Microsoft Windows",
ScreenRectangle->{{0, 1024}, {0, 677}},
ScreenStyleEnvironment->"Working",
WindowToolbars->{},
WindowSize->{506, 639},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
ShowSelection->True,
StyleDefinitions -> "HelpBrowser.nb"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "Function?"->{
    Cell[1776, 53, 58, 1, 41, "ObjectName",
      CellTags->"Function?"],
    Cell[1837, 56, 648, 27, 48, "Usage",
      CellTags->"Function?"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"Function?", 169321, 6338}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 58, 1, 41, "ObjectName",
  CellTags->"Function?"],
Cell[1837, 56, 648, 27, 48, "Usage",
  CellTags->"Function?"],
Cell[2488, 85, 159, 6, 41, "MathCaption"],

Cell[CellGroupData[{
Cell[2672, 95, 33, 0, 39, "ExampleSection"],
Cell[2708, 97, 99, 2, 29, "Input"],
Cell[2810, 101, 112, 3, 25, "Text"],

Cell[CellGroupData[{
Cell[2947, 108, 863, 15, 218, "Input"],
Cell[3813, 125, 164688, 6185, 333, 82175, 5162, "GraphicsData", "PostScript", \
"Graphics"]
}, Open  ]],
Cell[168516, 6313, 70, 2, 29, "Input"]
}, Open  ]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

