(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    244657,       9913]*)
(*NotebookOutlinePosition[    245631,       9947]*)
(*  CellTagsIndexPosition[    245554,       9941]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["ParametricDraw3D", "ObjectName",
  CellTags->"Function?"],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  Cell[BoxData[
      RowBox[{
        StyleBox[
          RowBox[{"Parametric", 
            StyleBox["Draw3D",
              "MR"]}]], 
        StyleBox["[",
          "MR"], 
        StyleBox[\({fx, fy, fz}, {t, tmin, tmax}, {u, umin, umax}, 
          opts ... \),
          "TI"], 
        StyleBox["]",
          "MR"]}]]],
  " extracts the graphics primitives from the corresponding ParametricPlot3D \
statement."
}], "Usage",
  CellTags->"Function?"],

Cell["\<\
Display of the Graphics is suppressed.\
\>", "MathCaption",
  CellTags->"Function?"],

Cell["\<\
Usage is the same as ParametricPlot3D. Regular ParametricPlot3D options may \
be used. Basic Graphics3D options, such as PlotRange have no effect.\
\>", "MathCaption"],

Cell["\<\
The extended usage of the Graphics`ParametricPlot3D` package is allowed.\
\>", "MathCaption"],

Cell[TextData[{
  "See also: ",
  ButtonBox["Draw3D",
    ButtonData:>{"Draw3D"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["CylindricalDraw3D",
    ButtonData:>{"CylindricalDraw3D"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["SphericalDraw3D",
    ButtonData:>{"SphericalDraw3D"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["PointParametricDraw3D",
    ButtonData:>{"PointParametricDraw3D"},
    ButtonStyle->"AddOnsLink"],
  ",  ",
  ButtonBox["ParametricPlot3D",
    ButtonStyle->"RefGuideLink"],
  "."
}], "MathCaption"],

Cell[CellGroupData[{

Cell["Example", "ExampleSection"],

Cell[BoxData[
    \(Needs["\<DrawGraphics`DrawingMaster`\>"]\)], "Input",
  CellLabel->"In[1]:="],

Cell["\<\
This draws a sphere, a plane and a circle. A wireframe was used on the plane, \
and UseRotateShape was used to reposition the circle.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(Draw3DItems[\[IndentingNewLine]{ParametricDraw3D[{Cos[\[Theta]] 
                Cos[\[Phi]], Sin[\[Theta]] Cos[\[Phi]], 
              Sin[\[Phi]]}, {\[Phi], \(-\[Pi]\)/2, \[Pi]/2}, {\[Theta], 0, 
              2  \[Pi]}, 
            PlotPoints \[Rule] {21, 
                31}], \[IndentingNewLine]\[IndentingNewLine]ParametricDraw3D[{\
x, y, 0}, {x, \(-2\), 2}, {y, \(-2\), 2}] // 
            UseWireFrame, \[IndentingNewLine]\[IndentingNewLine]Blue, 
          AbsoluteThickness[2], 
          ParametricDraw3D[
              3/2 {Cos[\[Theta]], Sin[\[Theta]], 0}, {\[Theta], 0, 
                2  \[Pi]}] // 
            UseRotateShape[0, 
              45  \[Degree], \(-45\) \[Degree]]}, \[IndentingNewLine]\
\[IndentingNewLine]ImageSize \[Rule] 400, \[IndentingNewLine]Boxed \[Rule] 
          False, \[IndentingNewLine]Background \[Rule] 
          Seashell\[IndentingNewLine]];\)\)], "Input",
  CellLabel->"In[327]:="],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .76799 
%%ImageSize: 400 307.194 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Background color
1 .961 .933 r
MFill
% Scaling calculations
8.83896e-017 1.04938 -0.0891493 1.04938 [
[ 0 0 0 0 ]
[ 1 .76799 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 m
1 0 L
1 .76799 L
0 .76799 L
closepath
clip
newpath
0 0 0 r
.5 Mabswid
[ ] 0 setdash
.40564 .67222 m
.39517 .66299 L
s
.42323 .66723 m
.40564 .67222 L
s
.42323 .66723 m
.41283 .65794 L
s
.44093 .66221 m
.42323 .66723 L
s
.39517 .66299 m
.41283 .65794 L
s
.39517 .66299 m
.38457 .65365 L
s
.44093 .66221 m
.4306 .65286 L
s
.45874 .65716 m
.44093 .66221 L
s
.41283 .65794 m
.4306 .65286 L
s
.41283 .65794 m
.4023 .64854 L
s
.45874 .65716 m
.44849 .64775 L
s
.47668 .65208 m
.45874 .65716 L
s
.38457 .65365 m
.4023 .64854 L
s
.38457 .65365 m
.37384 .64419 L
s
.4306 .65286 m
.44849 .64775 L
s
.4306 .65286 m
.42014 .6434 L
s
.47668 .65208 m
.46649 .6426 L
s
.49473 .64696 m
.47668 .65208 L
s
.4023 .64854 m
.42014 .6434 L
s
.4023 .64854 m
.39164 .63902 L
s
.44849 .64775 m
.46649 .6426 L
s
.44849 .64775 m
.43811 .63822 L
s
.49473 .64696 m
.48462 .63742 L
s
.51289 .64181 m
.49473 .64696 L
s
.37384 .64419 m
.39164 .63902 L
s
.37384 .64419 m
.36297 .63462 L
s
.42014 .6434 m
.43811 .63822 L
s
.42014 .6434 m
.40956 .63382 L
s
.46649 .6426 m
.48462 .63742 L
s
.46649 .6426 m
.45619 .63301 L
s
.51289 .64181 m
.50287 .63221 L
s
.53118 .63662 m
.51289 .64181 L
s
.39164 .63902 m
.40956 .63382 L
s
.39164 .63902 m
.38085 .62939 L
s
.43811 .63822 m
.45619 .63301 L
s
.43811 .63822 m
.4276 .62858 L
s
.48462 .63742 m
.50287 .63221 L
s
.48462 .63742 m
.47439 .62777 L
s
.53118 .63662 m
.52123 .62696 L
s
.54959 .6314 m
.53118 .63662 L
s
.36297 .63462 m
.38085 .62939 L
s
.36297 .63462 m
.35198 .62493 L
s
.40956 .63382 m
.4276 .62858 L
s
.40956 .63382 m
.39884 .62412 L
s
.45619 .63301 m
.47439 .62777 L
s
.45619 .63301 m
.44576 .6233 L
s
.50287 .63221 m
.52123 .62696 L
s
.50287 .63221 m
.49272 .62249 L
s
.54959 .6314 m
.53972 .62167 L
s
.56813 .62615 m
.54959 .6314 L
s
.38085 .62939 m
.39884 .62412 L
s
.38085 .62939 m
.36993 .61963 L
s
.4276 .62858 m
.44576 .6233 L
s
.4276 .62858 m
.41696 .61881 L
s
.47439 .62777 m
.49272 .62249 L
s
.47439 .62777 m
.46404 .618 L
s
.52123 .62696 m
.53972 .62167 L
s
.52123 .62696 m
.51116 .61718 L
s
.56813 .62615 m
.55834 .61635 L
s
.58678 .62086 m
.56813 .62615 L
s
.35198 .62493 m
.36993 .61963 L
s
.35198 .62493 m
.34085 .61512 L
s
.39884 .62412 m
.41696 .61881 L
s
.39884 .62412 m
.388 .6143 L
s
.44576 .6233 m
.46404 .618 L
s
.44576 .6233 m
.43519 .61348 L
s
.49272 .62249 m
.51116 .61718 L
s
.49272 .62249 m
.48244 .61265 L
s
.53972 .62167 m
.55834 .61635 L
s
.53972 .62167 m
.52973 .61183 L
s
.58678 .62086 m
.57708 .611 L
s
.60556 .61553 m
.58678 .62086 L
s
.36993 .61963 m
.388 .6143 L
s
.36993 .61963 m
.35887 .60976 L
s
.41696 .61881 m
.43519 .61348 L
s
.41696 .61881 m
.40619 .60893 L
s
.46404 .618 m
.48244 .61265 L
s
.46404 .618 m
.45355 .6081 L
s
.51116 .61718 m
.52973 .61183 L
s
.51116 .61718 m
.50097 .60727 L
s
.55834 .61635 m
.57708 .611 L
s
.55834 .61635 m
.54843 .60644 L
s
.60556 .61553 m
.59594 .60561 L
s
.62447 .61017 m
.60556 .61553 L
s
.34085 .61512 m
.35887 .60976 L
s
.34085 .61512 m
.32958 .60519 L
s
.388 .6143 m
.40619 .60893 L
s
.388 .6143 m
.37701 .60436 L
s
.43519 .61348 m
.45355 .6081 L
s
.43519 .61348 m
.4245 .60352 L
s
.48244 .61265 m
.50097 .60727 L
s
.48244 .61265 m
.47203 .60269 L
s
.52973 .61183 m
.54843 .60644 L
s
.52973 .61183 m
.51962 .60185 L
s
.57708 .611 m
.59594 .60561 L
s
.57708 .611 m
.56725 .60102 L
s
.62447 .61017 m
.61494 .60018 L
s
.64351 .60477 m
.62447 .61017 L
s
.35887 .60976 m
.37701 .60436 L
s
.35887 .60976 m
.34767 .59976 L
s
.40619 .60893 m
.4245 .60352 L
s
.40619 .60893 m
.39528 .59892 L
s
.45355 .6081 m
.47203 .60269 L
s
.45355 .6081 m
.44294 .59808 L
s
.50097 .60727 m
.51962 .60185 L
s
.50097 .60727 m
.49064 .59724 L
s
.54843 .60644 m
.56725 .60102 L
s
.54843 .60644 m
.5384 .5964 L
s
.59594 .60561 m
.61494 .60018 L
s
.59594 .60561 m
.5862 .59556 L
s
.32958 .60519 m
.34767 .59976 L
s
.32958 .60519 m
.31817 .59514 L
s
.64351 .60477 m
.63406 .59471 L
s
.66267 .59934 m
.64351 .60477 L
s
.37701 .60436 m
.39528 .59892 L
s
.37701 .60436 m
.36589 .59429 L
s
.4245 .60352 m
.44294 .59808 L
s
.4245 .60352 m
.41367 .59345 L
s
.47203 .60269 m
.49064 .59724 L
s
.47203 .60269 m
.4615 .5926 L
s
.51962 .60185 m
.5384 .5964 L
s
.51962 .60185 m
.50938 .59176 L
s
.56725 .60102 m
.5862 .59556 L
s
.56725 .60102 m
.5573 .59091 L
s
.61494 .60018 m
.63406 .59471 L
s
.61494 .60018 m
.60528 .59006 L
s
.34767 .59976 m
.36589 .59429 L
s
.34767 .59976 m
.33634 .58964 L
s
.66267 .59934 m
.65331 .58921 L
s
.68196 .59387 m
.66267 .59934 L
s
.39528 .59892 m
.41367 .59345 L
s
.39528 .59892 m
.38424 .58879 L
s
.44294 .59808 m
.4615 .5926 L
s
.44294 .59808 m
.43219 .58794 L
s
.49064 .59724 m
.50938 .59176 L
s
.49064 .59724 m
.48019 .58709 L
s
.5384 .5964 m
.5573 .59091 L
s
.5384 .5964 m
.52824 .58623 L
s
.5862 .59556 m
.60528 .59006 L
s
.5862 .59556 m
.57634 .58538 L
s
.31817 .59514 m
.33634 .58964 L
s
.31817 .59514 m
.30661 .58495 L
s
.63406 .59471 m
.65331 .58921 L
s
.63406 .59471 m
.62449 .58453 L
s
.36589 .59429 m
.38424 .58879 L
s
.36589 .59429 m
.35463 .5841 L
s
.68196 .59387 m
.67269 .58367 L
s
.70139 .58836 m
.68196 .59387 L
s
.41367 .59345 m
.43219 .58794 L
s
.41367 .59345 m
.40271 .58324 L
s
.4615 .5926 m
.48019 .58709 L
s
.4615 .5926 m
.45083 .58239 L
s
.50938 .59176 m
.52824 .58623 L
s
.50938 .59176 m
.499 .58153 L
s
.5573 .59091 m
.57634 .58538 L
s
.5573 .59091 m
.54723 .58067 L
s
.60528 .59006 m
.62449 .58453 L
s
.60528 .59006 m
.59551 .57981 L
s
.33634 .58964 m
.35463 .5841 L
s
.33634 .58964 m
.32486 .57938 L
s
.65331 .58921 m
.67269 .58367 L
s
.65331 .58921 m
.64383 .57895 L
s
.38424 .58879 m
.40271 .58324 L
s
.38424 .58879 m
.37305 .57852 L
s
.70139 .58836 m
.69221 .57809 L
s
.72095 .58282 m
.70139 .58836 L
s
.43219 .58794 m
.45083 .58239 L
s
.43219 .58794 m
.4213 .57766 L
s
.48019 .58709 m
.499 .58153 L
s
.48019 .58709 m
.4696 .5768 L
s
.52824 .58623 m
.54723 .58067 L
s
.52824 .58623 m
.51795 .57594 L
s
.57634 .58538 m
.59551 .57981 L
s
.57634 .58538 m
.56635 .57507 L
s
.30661 .58495 m
.32486 .57938 L
s
.30661 .58495 m
.29491 .57464 L
s
.62449 .58453 m
.64383 .57895 L
s
.62449 .58453 m
.6148 .57421 L
s
.35463 .5841 m
.37305 .57852 L
s
.35463 .5841 m
.34323 .57378 L
s
.67269 .58367 m
.69221 .57809 L
s
.67269 .58367 m
.66331 .57334 L
s
.40271 .58324 m
.4213 .57766 L
s
.40271 .58324 m
.3916 .57291 L
s
.72095 .58282 m
.71186 .57248 L
s
.74064 .57723 m
.72095 .58282 L
s
.45083 .58239 m
.4696 .5768 L
s
.45083 .58239 m
.44003 .57204 L
s
.499 .58153 m
.51795 .57594 L
s
.499 .58153 m
.4885 .57118 L
s
.54723 .58067 m
.56635 .57507 L
s
.54723 .58067 m
.53703 .57031 L
s
.59551 .57981 m
.6148 .57421 L
s
.59551 .57981 m
.58561 .56944 L
s
.32486 .57938 m
.34323 .57378 L
s
.32486 .57938 m
.31323 .569 L
s
.64383 .57895 m
.66331 .57334 L
s
.64383 .57895 m
.63424 .56857 L
s
.37305 .57852 m
.3916 .57291 L
s
.37305 .57852 m
.36173 .56813 L
s
.69221 .57809 m
.71186 .57248 L
s
.69221 .57809 m
.68292 .56769 L
s
.4213 .57766 m
.44003 .57204 L
s
.4213 .57766 m
.41028 .56726 L
s
.74064 .57723 m
.73165 .56682 L
s
.76047 .57161 m
.74064 .57723 L
s
.4696 .5768 m
.4885 .57118 L
s
.4696 .5768 m
.45888 .56639 L
s
.51795 .57594 m
.53703 .57031 L
s
.51795 .57594 m
.50753 .56551 L
s
.56635 .57507 m
.58561 .56944 L
s
.56635 .57507 m
.55624 .56464 L
s
.29491 .57464 m
.31323 .569 L
s
.29491 .57464 m
.28306 .5642 L
s
.6148 .57421 m
.63424 .56857 L
s
.6148 .57421 m
.60499 .56376 L
s
.34323 .57378 m
.36173 .56813 L
s
.34323 .57378 m
.33168 .56332 L
s
.66331 .57334 m
.68292 .56769 L
s
.66331 .57334 m
.6538 .56288 L
s
.3916 .57291 m
.41028 .56726 L
s
.3916 .57291 m
.38036 .56245 L
s
.71186 .57248 m
.73165 .56682 L
s
.71186 .57248 m
.70266 .56201 L
s
.44003 .57204 m
.45888 .56639 L
s
.44003 .57204 m
.42908 .56157 L
s
.76047 .57161 m
.75157 .56113 L
s
.78043 .56595 m
.76047 .57161 L
s
.4885 .57118 m
.50753 .56551 L
s
.4885 .57118 m
.47786 .56069 L
s
.53703 .57031 m
.55624 .56464 L
s
.53703 .57031 m
.52669 .55981 L
s
0 0 1 r
2 Mabswid
.67286 .44192 m
.68639 .4461 L
s
0 0 0 r
.5 Mabswid
.58561 .56944 m
.60499 .56376 L
s
.58561 .56944 m
.57558 .55893 L
s
.31323 .569 m
.33168 .56332 L
s
.31323 .569 m
.30146 .55849 L
s
.63424 .56857 m
.6538 .56288 L
s
.63424 .56857 m
.62451 .55805 L
s
.36173 .56813 m
.38036 .56245 L
s
.36173 .56813 m
.35026 .5576 L
s
.68292 .56769 m
.70266 .56201 L
s
.68292 .56769 m
.6735 .55716 L
s
.41028 .56726 m
.42908 .56157 L
s
.41028 .56726 m
.39911 .55672 L
s
.73165 .56682 m
.75157 .56113 L
s
.73165 .56682 m
.72254 .55628 L
s
.45888 .56639 m
.47786 .56069 L
s
.45888 .56639 m
.44802 .55584 L
s
.78043 .56595 m
.77164 .55539 L
s
.80054 .56025 m
.78043 .56595 L
s
.50753 .56551 m
.52669 .55981 L
s
.50753 .56551 m
.49698 .55495 L
s
.55624 .56464 m
.57558 .55893 L
s
.55624 .56464 m
.54599 .55406 L
s
.28306 .5642 m
.30146 .55849 L
s
.28306 .5642 m
.27105 .55362 L
s
.60499 .56376 m
.62451 .55805 L
s
.60499 .56376 m
.59505 .55318 L
s
.33168 .56332 m
.35026 .5576 L
s
.33168 .56332 m
.31998 .55273 L
s
.6538 .56288 m
.6735 .55716 L
s
.6538 .56288 m
.64417 .55229 L
s
0 0 1 r
2 Mabswid
.701 .45088 m
.68639 .4461 L
s
0 0 0 r
.5 Mabswid
.38036 .56245 m
.39911 .55672 L
s
.38036 .56245 m
.36897 .55185 L
s
.70266 .56201 m
.72254 .55628 L
s
.70266 .56201 m
.69334 .5514 L
s
.42908 .56157 m
.44802 .55584 L
s
.42908 .56157 m
.418 .55096 L
s
.75157 .56113 m
.77164 .55539 L
s
.75157 .56113 m
.74256 .55051 L
s
.47786 .56069 m
.49698 .55495 L
s
.47786 .56069 m
.46709 .55007 L
s
.80054 .56025 m
.79184 .54962 L
s
.82078 .55451 m
.80054 .56025 L
s
.52669 .55981 m
.54599 .55406 L
s
.52669 .55981 m
.51623 .54917 L
s
.57558 .55893 m
.59505 .55318 L
s
.57558 .55893 m
.56542 .54828 L
s
.30146 .55849 m
.31998 .55273 L
s
.30146 .55849 m
.28953 .54784 L
s
.62451 .55805 m
.64417 .55229 L
s
.62451 .55805 m
.61467 .54739 L
s
.35026 .5576 m
.36897 .55185 L
s
.35026 .5576 m
.33864 .54694 L
s
.6735 .55716 m
.69334 .5514 L
s
.6735 .55716 m
.66397 .54649 L
s
.39911 .55672 m
.418 .55096 L
s
.39911 .55672 m
.3878 .54605 L
s
.72254 .55628 m
.74256 .55051 L
s
.72254 .55628 m
.71332 .5456 L
s
.44802 .55584 m
.46709 .55007 L
s
.44802 .55584 m
.43702 .54515 L
s
.77164 .55539 m
.79184 .54962 L
s
.77164 .55539 m
.76272 .5447 L
s
.49698 .55495 m
.51623 .54917 L
s
.49698 .55495 m
.48629 .54425 L
s
.82078 .55451 m
.81218 .54381 L
s
.84117 .54873 m
.82078 .55451 L
s
.54599 .55406 m
.56542 .54828 L
s
.54599 .55406 m
.53561 .54336 L
s
.27105 .55362 m
.28953 .54784 L
s
.27105 .55362 m
.25889 .54291 L
s
.59505 .55318 m
.61467 .54739 L
s
.59505 .55318 m
.58499 .54246 L
s
0 0 1 r
2 Mabswid
.7146 .45562 m
.701 .45088 L
s
0 0 0 r
.5 Mabswid
.31998 .55273 m
.33864 .54694 L
s
.31998 .55273 m
.30813 .54201 L
s
.64417 .55229 m
.66397 .54649 L
s
.64417 .55229 m
.63442 .54156 L
s
.729 .582 .691 r
.49136 .4588 m .49446 .43406 L .52119 .43616 L p F P
0 0 0 r
s
.729 .582 .691 r
.52119 .43616 m .52083 .46108 L .49136 .4588 L p F P
0 0 0 r
s
.726 .605 .722 r
.52145 .4217 m .52119 .43616 L .49446 .43406 L p F P
0 0 0 r
s
.694 .553 .69 r
.52083 .46108 m .52119 .43616 L .54806 .43493 L p F P
0 0 0 r
s
.695 .579 .721 r
.52119 .43616 m .52145 .4217 L .53507 .42107 L p F P
0 0 0 r
s
.695 .579 .721 r
.53507 .42107 m .54636 .42054 L p .52119 .43616 L F P
0 0 0 r
s
.695 .579 .721 r
.54636 .42054 m .54806 .43493 L .52119 .43616 L p F P
0 0 0 r
s
.36897 .55185 m
.3878 .54605 L
s
.36897 .55185 m
.35743 .54111 L
s
.726 .605 .722 r
.51023 .42081 m .52145 .4217 L p .49446 .43406 L F P
0 0 0 r
s
.69334 .5514 m
.71332 .5456 L
s
.69334 .5514 m
.6839 .54066 L
s
.694 .553 .69 r
.54806 .43493 m .55045 .45974 L .52083 .46108 L p F P
0 0 0 r
s
.657 .526 .692 r
.55045 .45974 m .54806 .43493 L .57403 .4304 L p F P
0 0 0 r
s
.662 .556 .724 r
.54806 .43493 m .54636 .42054 L .55952 .41823 L p F P
0 0 0 r
s
.662 .556 .724 r
.55952 .41823 m .57043 .41632 L p .54806 .43493 L F P
0 0 0 r
s
.662 .556 .724 r
.57043 .41632 m .57403 .4304 L .54806 .43493 L p F P
0 0 0 r
s
.418 .55096 m
.43702 .54515 L
s
.418 .55096 m
.40677 .54021 L
s
.73 .557 .658 r
.48903 .48309 m .49136 .4588 L .52083 .46108 L p F P
0 0 0 r
s
.73 .557 .658 r
.52083 .46108 m .52056 .48549 L .48903 .48309 L p F P
0 0 0 r
s
.691 .525 .658 r
.52056 .48549 m .52083 .46108 L .55045 .45974 L p F P
0 0 0 r
s
.726 .605 .722 r
.49446 .43406 m .49666 .41974 L .51023 .42081 L p F P
0 0 0 r
s
.74256 .55051 m
.76272 .5447 L
s
.74256 .55051 m
.73344 .53976 L
s
.763 .613 .693 r
.46315 .45298 m .46889 .42871 L .49446 .43406 L p F P
0 0 0 r
s
.763 .613 .693 r
.49446 .43406 m .49136 .4588 L .46315 .45298 L p F P
0 0 0 r
s
.756 .634 .725 r
.49666 .41974 m .49446 .43406 L .46889 .42871 L p F P
0 0 0 r
s
.46709 .55007 m
.48629 .54425 L
s
.46709 .55007 m
.45617 .53931 L
s
.756 .634 .725 r
.48594 .41748 m .49666 .41974 L p .46889 .42871 L F P
0 0 0 r
s
.79184 .54962 m
.81218 .54381 L
s
.79184 .54962 m
.78303 .53885 L
s
.691 .525 .658 r
.55045 .45974 m .55225 .48408 L .52056 .48549 L p F P
0 0 0 r
s
.65 .494 .659 r
.55225 .48408 m .55045 .45974 L .57909 .45482 L p F P
0 0 0 r
s
.657 .526 .692 r
.57403 .4304 m .57909 .45482 L .55045 .45974 L p F P
0 0 0 r
s
.51623 .54917 m
.53561 .54336 L
s
.51623 .54917 m
.50563 .5384 L
s
.84117 .54873 m
.83267 .53795 L
s
.86169 .54291 m
.84117 .54873 L
s
.767 .591 .66 r
.45882 .47694 m .46315 .45298 L .49136 .4588 L p F P
0 0 0 r
s
.767 .591 .66 r
.49136 .4588 m .48903 .48309 L .45882 .47694 L p F P
0 0 0 r
s
.56542 .54828 m
.58499 .54246 L
s
.56542 .54828 m
.55513 .5375 L
s
.28953 .54784 m
.30813 .54201 L
s
.28953 .54784 m
.27745 .53705 L
s
.756 .634 .725 r
.46889 .42871 m .47296 .41473 L .48594 .41748 L p F P
0 0 0 r
s
.61467 .54739 m
.63442 .54156 L
s
.61467 .54739 m
.60469 .53659 L
s
.33864 .54694 m
.35743 .54111 L
s
.33864 .54694 m
.32687 .53614 L
s
.616 .499 .697 r
.57909 .45482 m .57403 .4304 L .5981 .42274 L p F P
0 0 0 r
s
.627 .533 .729 r
.57403 .4304 m .57043 .41632 L .58261 .41241 L p F P
0 0 0 r
s
.627 .533 .729 r
.58261 .41241 m .59273 .40916 L p .57403 .4304 L F P
0 0 0 r
s
.627 .533 .729 r
.59273 .40916 m .5981 .42274 L .57403 .4304 L p F P
0 0 0 r
s
.729 .529 .621 r
.4875 .50643 m .48903 .48309 L .52056 .48549 L p F P
0 0 0 r
s
.729 .529 .621 r
.52056 .48549 m .52039 .5089 L .4875 .50643 L p F P
0 0 0 r
s
.686 .494 .621 r
.52039 .5089 m .52056 .48549 L .55225 .48408 L p F P
0 0 0 r
s
.66397 .54649 m
.6839 .54066 L
s
.66397 .54649 m
.65431 .53569 L
s
.3878 .54605 m
.40677 .54021 L
s
.3878 .54605 m
.37635 .53523 L
s
.71332 .5456 m
.73344 .53976 L
s
.71332 .5456 m
.70397 .53478 L
s
.686 .494 .621 r
.55225 .48408 m .55343 .50745 L .52039 .5089 L p F P
0 0 0 r
s
.641 .459 .622 r
.55343 .50745 m .55225 .48408 L .58292 .47889 L p F P
0 0 0 r
s
.65 .494 .659 r
.57909 .45482 m .58292 .47889 L .55225 .48408 L p F P
0 0 0 r
s
.797 .649 .698 r
.43729 .4438 m .44547 .42027 L .46889 .42871 L p F P
0 0 0 r
s
.797 .649 .698 r
.46889 .42871 m .46315 .45298 L .43729 .4438 L p F P
0 0 0 r
s
.786 .666 .731 r
.47296 .41473 m .46889 .42871 L .44547 .42027 L p F P
0 0 0 r
s
.43702 .54515 m
.45617 .53931 L
s
.43702 .54515 m
.42588 .53433 L
s
.786 .666 .731 r
.46316 .41117 m .47296 .41473 L p .44547 .42027 L F P
0 0 0 r
s
.604 .462 .662 r
.58292 .47889 m .57909 .45482 L .60567 .44649 L p F P
0 0 0 r
s
.616 .499 .697 r
.5981 .42274 m .60567 .44649 L .57909 .45482 L p F P
0 0 0 r
s
.76272 .5447 m
.78303 .53885 L
s
.76272 .5447 m
.7537 .53387 L
s
.77 .566 .622 r
.456 .50011 m .45882 .47694 L .48903 .48309 L p F P
0 0 0 r
s
.77 .566 .622 r
.48903 .48309 m .4875 .50643 L .456 .50011 L p F P
0 0 0 r
s
.48629 .54425 m
.50563 .5384 L
s
.48629 .54425 m
.47546 .53342 L
s
.81218 .54381 m
.83267 .53795 L
s
.81218 .54381 m
.80347 .53296 L
s
.53561 .54336 m
.55513 .5375 L
s
.53561 .54336 m
.5251 .53251 L
s
.805 .629 .663 r
.4311 .46724 m .43729 .4438 L .46315 .45298 L p F P
0 0 0 r
s
.805 .629 .663 r
.46315 .45298 m .45882 .47694 L .4311 .46724 L p F P
0 0 0 r
s
.25889 .54291 m
.27745 .53705 L
s
.25889 .54291 m
.24658 .53205 L
s
.86169 .54291 m
.8533 .53205 L
s
.88237 .53705 m
.86169 .54291 L
s
.58499 .54246 m
.60469 .53659 L
s
.58499 .54246 m
.57479 .5316 L
s
0 0 1 r
2 Mabswid
.72708 .46028 m
.7146 .45562 L
s
0 0 0 r
.5 Mabswid
.30813 .54201 m
.32687 .53614 L
s
.30813 .54201 m
.29613 .53114 L
s
.786 .666 .731 r
.44547 .42027 m .45128 .40685 L .46316 .41117 L p F P
0 0 0 r
s
.63442 .54156 m
.65431 .53569 L
s
.63442 .54156 m
.62454 .53069 L
s
.35743 .54111 m
.37635 .53523 L
s
.35743 .54111 m
.34574 .53023 L
s
.6839 .54066 m
.70397 .53478 L
s
.6839 .54066 m
.67434 .52977 L
s
.641 .459 .622 r
.58292 .47889 m .58541 .50211 L .55343 .50745 L p F P
0 0 0 r
s
.589 .422 .622 r
.58541 .50211 m .58292 .47889 L .61139 .47009 L p F P
0 0 0 r
s
.604 .462 .662 r
.60567 .44649 m .61139 .47009 L .58292 .47889 L p F P
0 0 0 r
s
.40677 .54021 m
.42588 .53433 L
s
.40677 .54021 m
.3954 .52932 L
s
.726 .497 .579 r
.48683 .52835 m .4875 .50643 L .52039 .5089 L p F P
0 0 0 r
s
.726 .497 .579 r
.52039 .5089 m .52031 .53083 L .48683 .52835 L p F P
0 0 0 r
s
.68 .459 .579 r
.52031 .53083 m .52039 .5089 L .55343 .50745 L p F P
0 0 0 r
s
.587 .512 .737 r
.5981 .42274 m .59273 .40916 L .60343 .40379 L p F P
0 0 0 r
s
.73344 .53976 m
.7537 .53387 L
s
.73344 .53976 m
.72419 .52886 L
s
.569 .472 .704 r
.60567 .44649 m .5981 .42274 L .6193 .4122 L p F P
0 0 0 r
s
.587 .512 .737 r
.60343 .40379 m .61234 .39932 L p .5981 .42274 L F P
0 0 0 r
s
.587 .512 .737 r
.61234 .39932 m .6193 .4122 L .5981 .42274 L p F P
0 0 0 r
s
.45617 .53931 m
.47546 .53342 L
s
.45617 .53931 m
.44512 .5284 L
s
.78303 .53885 m
.80347 .53296 L
s
.78303 .53885 m
.7741 .52795 L
s
.68 .459 .579 r
.55343 .50745 m .55395 .52937 L .52031 .53083 L p F P
0 0 0 r
s
.629 .419 .578 r
.55395 .52937 m .55343 .50745 L .58541 .50211 L p F P
0 0 0 r
s
.813 .606 .623 r
.42706 .49013 m .4311 .46724 L .45882 .47694 L p F P
0 0 0 r
s
.813 .606 .623 r
.45882 .47694 m .456 .50011 L .42706 .49013 L p F P
0 0 0 r
s
.50563 .5384 m
.5251 .53251 L
s
.83267 .53795 m
.8533 .53205 L
s
.83267 .53795 m
.82406 .52703 L
s
.816 .702 .74 r
.4428 .40212 m .45128 .40685 L p .42516 .40904 L F P
0 0 0 r
s
.816 .702 .74 r
.45128 .40685 m .44547 .42027 L .42516 .40904 L p F P
0 0 0 r
s
.771 .536 .578 r
.45475 .52199 m .456 .50011 L .4875 .50643 L p F P
0 0 0 r
s
.771 .536 .578 r
.4875 .50643 m .48683 .52835 L .45475 .52199 L p F P
0 0 0 r
s
.55513 .5375 m
.57479 .5316 L
s
.831 .689 .706 r
.41481 .43156 m .42516 .40904 L .44547 .42027 L p F P
0 0 0 r
s
.831 .689 .706 r
.44547 .42027 m .43729 .4438 L .41481 .43156 L p F P
0 0 0 r
s
.27745 .53705 m
.29613 .53114 L
s
.27745 .53705 m
.26521 .52612 L
s
.88237 .53705 m
.87408 .52612 L
s
.90318 .53114 m
.88237 .53705 L
s
.55 .428 .666 r
.61139 .47009 m .60567 .44649 L .62913 .43501 L p F P
0 0 0 r
s
.569 .472 .704 r
.6193 .4122 m .62913 .43501 L .60567 .44649 L p F P
0 0 0 r
s
.60469 .53659 m
.62454 .53069 L
s
.60469 .53659 m
.59459 .52566 L
s
.32687 .53614 m
.34574 .53023 L
s
.32687 .53614 m
.31495 .5252 L
s
.65431 .53569 m
.67434 .52977 L
s
.65431 .53569 m
.64452 .52474 L
s
.37635 .53523 m
.3954 .52932 L
s
.37635 .53523 m
.36474 .52428 L
s
.70397 .53478 m
.72419 .52886 L
s
.70397 .53478 m
.69451 .52382 L
s
.845 .672 .668 r
.40697 .45431 m .41481 .43156 L .43729 .4438 L p F P
0 0 0 r
s
.845 .672 .668 r
.43729 .4438 m .4311 .46724 L .40697 .45431 L p F P
0 0 0 r
s
.42588 .53433 m
.44512 .5284 L
s
.42588 .53433 m
.41459 .52336 L
s
.7537 .53387 m
.7741 .52795 L
s
.7537 .53387 m
.74455 .5229 L
s
.629 .419 .578 r
.58541 .50211 m .58651 .524 L .55395 .52937 L p F P
0 0 0 r
s
.571 .374 .576 r
.58651 .524 m .58541 .50211 L .61513 .49305 L p F P
0 0 0 r
s
.589 .422 .622 r
.61139 .47009 m .61513 .49305 L .58541 .50211 L p F P
0 0 0 r
s
.816 .702 .74 r
.42516 .40904 m .4325 .39637 L .4428 .40212 L p F P
0 0 0 r
s
.80347 .53296 m
.82406 .52703 L
s
.80347 .53296 m
.79465 .52198 L
s
.52372 .53108 m
.5251 .53251 L
s
.24658 .53205 m
.26521 .52612 L
s
.24658 .53205 m
.2341 .52106 L
s
.8533 .53205 m
.87408 .52612 L
s
.8533 .53205 m
.8448 .52106 L
s
.527 .379 .623 r
.61513 .49305 m .61139 .47009 L .63655 .45795 L p F P
0 0 0 r
s
.55 .428 .666 r
.62913 .43501 m .63655 .45795 L .61139 .47009 L p F P
0 0 0 r
s
.818 .577 .575 r
.42528 .51196 m .42706 .49013 L .456 .50011 L p F P
0 0 0 r
s
.818 .577 .575 r
.456 .50011 m .45475 .52199 L .42528 .51196 L p F P
0 0 0 r
s
.29613 .53114 m
.31495 .5252 L
s
.29613 .53114 m
.28397 .52014 L
s
.90318 .53114 m
.895 .52014 L
s
.92415 .5252 m
.90318 .53114 L
s
0 0 1 r
2 Mabswid
.73835 .46484 m
.72708 .46028 L
s
.5 Mabswid
.72 .457 .528 r
.48704 .54835 m .48683 .52835 L .52031 .53083 L p F P
0 0 0 r
s
.47546 .53342 m
.48685 .52994 L
s
.49105 .52866 m
.49489 .52749 L
s
.49489 .52749 m
.49643 .52906 L
s
.72 .457 .528 r
.52031 .53083 m .52033 .55079 L .48704 .54835 L p F P
0 0 0 r
s
.669 .416 .528 r
.52033 .55079 m .52031 .53083 L .55395 .52937 L p F P
0 0 0 r
s
.54986 .53197 m
.55513 .5375 L
s
.54 .491 .75 r
.6193 .4122 m .61234 .39932 L .62113 .39268 L p F P
0 0 0 r
s
.62454 .53069 m
.64452 .52474 L
s
.34574 .53023 m
.36474 .52428 L
s
.34574 .53023 m
.3339 .51921 L
s
.513 .442 .714 r
.62913 .43501 m .6193 .4122 L .63675 .39915 L p F P
0 0 0 r
s
.54 .491 .75 r
.62113 .39268 m .62845 .38715 L p .6193 .4122 L F P
0 0 0 r
s
.54 .491 .75 r
.62845 .38715 m .63675 .39915 L .6193 .4122 L p F P
0 0 0 r
s
.67434 .52977 m
.69451 .52382 L
s
.67434 .52977 m
.66465 .51875 L
s
.669 .416 .528 r
.55395 .52937 m .55379 .54936 L .52033 .55079 L p F P
0 0 0 r
s
.54471 .52657 m
.54764 .52964 L
s
.53238 .53031 m
.54471 .52657 L
s
.51445 .52152 m
.52334 .5307 L
s
.613 .37 .525 r
.55379 .54936 m .55395 .52937 L .58651 .524 L p F P
0 0 0 r
s
.57792 .53066 m
.59459 .52566 L
s
.3954 .52932 m
.41459 .52336 L
s
.3954 .52932 m
.38388 .51829 L
s
.857 .651 .623 r
.40185 .47681 m .40697 .45431 L .4311 .46724 L p F P
0 0 0 r
s
.857 .651 .623 r
.4311 .46724 m .42706 .49013 L .40185 .47681 L p F P
0 0 0 r
s
.72419 .52886 m
.74455 .5229 L
s
.72419 .52886 m
.71482 .51782 L
s
.77 .498 .524 r
.45514 .54211 m .45475 .52199 L .48683 .52835 L p F P
0 0 0 r
s
.44512 .5284 m
.45482 .52542 L
s
.46157 .52334 m
.46449 .52244 L
s
.47537 .53332 m
.47546 .53342 L
s
.46449 .52244 m
.46634 .52429 L
s
.77 .498 .524 r
.48683 .52835 m .48704 .54835 L .45514 .54211 L p F P
0 0 0 r
s
.845 .745 .753 r
.4257 .39064 m .4325 .39637 L p .40882 .39541 L F P
0 0 0 r
s
.845 .745 .753 r
.4325 .39637 m .42516 .40904 L .40882 .39541 L p F P
0 0 0 r
s
.7741 .52795 m
.79465 .52198 L
s
.7741 .52795 m
.76505 .5169 L
s
.49489 .52749 m
.51445 .52152 L
s
.484 .51643 m
.49489 .52749 L
s
.82406 .52703 m
.8448 .52106 L
s
.82406 .52703 m
.81534 .51597 L
s
.867 .736 .717 r
.39667 .41669 m .40882 .39541 L .42516 .40904 L p F P
0 0 0 r
s
.867 .736 .717 r
.42516 .40904 m .41481 .43156 L .39667 .41669 L p F P
0 0 0 r
s
.54471 .52657 m
.53415 .51551 L
s
.26521 .52612 m
.28397 .52014 L
s
.26521 .52612 m
.25281 .51504 L
s
.87408 .52612 m
.895 .52014 L
s
.87408 .52612 m
.86568 .51504 L
s
.483 .389 .672 r
.63655 .45795 m .62913 .43501 L .64847 .42077 L p F P
0 0 0 r
s
.513 .442 .714 r
.63675 .39915 m .64847 .42077 L .62913 .43501 L p F P
0 0 0 r
s
.31495 .5252 m
.3339 .51921 L
s
.31495 .5252 m
.30287 .51411 L
s
.92415 .5252 m
.91608 .51411 L
s
.94526 .51921 m
.92415 .5252 L
s
.64452 .52474 m
.66465 .51875 L
s
.571 .374 .576 r
.61513 .49305 m .61677 .5149 L .58651 .524 L p F P
0 0 0 r
s
.499 .321 .57 r
.61677 .5149 m .61513 .49305 L .64141 .48056 L p F P
0 0 0 r
s
.527 .379 .623 r
.63655 .45795 m .64141 .48056 L .61513 .49305 L p F P
0 0 0 r
s
.36474 .52428 m
.38388 .51829 L
s
.36474 .52428 m
.35298 .51318 L
s
.613 .37 .525 r
.58651 .524 m .58617 .54409 L .55379 .54936 L p F P
0 0 0 r
s
.54471 .52657 m
.56446 .5206 L
s
.56446 .5206 m
.57018 .52669 L
s
.547 .317 .518 r
.58617 .54409 m .58651 .524 L .61677 .5149 L p F P
0 0 0 r
s
.61453 .51967 m
.62454 .53069 L
s
.6105 .52088 m
.61453 .51967 L
s
.69451 .52382 m
.71482 .51782 L
s
.69451 .52382 m
.68492 .51272 L
s
.41459 .52336 m
.40315 .51225 L
s
.74455 .5229 m
.76505 .5169 L
s
.74455 .5229 m
.73528 .51178 L
s
.887 .724 .674 r
.38746 .43857 m .39667 .41669 L .41481 .43156 L p F P
0 0 0 r
s
.887 .724 .674 r
.41481 .43156 m .40697 .45431 L .38746 .43857 L p F P
0 0 0 r
s
.845 .745 .753 r
.40882 .39541 m .41743 .38367 L .4257 .39064 L p F P
0 0 0 r
s
.46449 .52244 m
.484 .51643 L
s
.82 .54 .515 r
.42584 .53225 m .42528 .51196 L .45475 .52199 L p F P
0 0 0 r
s
.41459 .52336 m
.4255 .51997 L
s
.44288 .5262 m
.44512 .5284 L
s
.82 .54 .515 r
.45475 .52199 m .45514 .54211 L .42584 .53225 L p F P
0 0 0 r
s
.45338 .51132 m
.46449 .52244 L
s
.79465 .52198 m
.81534 .51597 L
s
.79465 .52198 m
.7857 .51085 L
s
.867 .623 .568 r
.3996 .49857 m .40185 .47681 L .42706 .49013 L p F P
0 0 0 r
s
.867 .623 .568 r
.42706 .49013 m .42528 .51196 L .3996 .49857 L p F P
0 0 0 r
s
.51445 .52152 m
.53415 .51551 L
s
.51445 .52152 m
.50366 .51038 L
s
.2341 .52106 m
.25281 .51504 L
s
.2341 .52106 m
.22145 .50992 L
s
.8448 .52106 m
.86568 .51504 L
s
.8448 .52106 m
.83618 .50992 L
s
.56446 .5206 m
.58435 .51458 L
s
.56446 .5206 m
.55399 .50945 L
s
.28397 .52014 m
.30287 .51411 L
s
.28397 .52014 m
.27165 .50898 L
s
.895 .52014 m
.91608 .51411 L
s
.895 .52014 m
.88671 .50898 L
s
.447 .326 .622 r
.64141 .48056 m .63655 .45795 L .65735 .4429 L p F P
0 0 0 r
s
.483 .389 .672 r
.64847 .42077 m .65735 .4429 L .63655 .45795 L p F P
0 0 0 r
s
.61324 .51826 m
.61453 .51967 L
s
.484 .469 .766 r
.63675 .39915 m .62845 .38715 L .63492 .37949 L p F P
0 0 0 r
s
.709 .406 .461 r
.48815 .56599 m .48704 .54835 L .52033 .55079 L p F P
0 0 0 r
s
.709 .406 .461 r
.52033 .55079 m .52046 .56833 L .48815 .56599 L p F P
0 0 0 r
s
.653 .36 .462 r
.52046 .56833 m .52033 .55079 L .55379 .54936 L p F P
0 0 0 r
s
.3339 .51921 m
.35298 .51318 L
s
.3339 .51921 m
.3219 .50805 L
s
.94526 .51921 m
.9373 .50805 L
s
.96653 .51318 m
.94526 .51921 L
s
.66465 .51875 m
.68492 .51272 L
s
.66465 .51875 m
.65483 .50758 L
s
0 0 1 r
2 Mabswid
.74831 .46926 m
.73835 .46484 L
s
0 0 0 r
.5 Mabswid
.38388 .51829 m
.40315 .51225 L
s
.38388 .51829 m
.3722 .50711 L
s
.653 .36 .462 r
.55379 .54936 m .55293 .56695 L .52046 .56833 L p F P
0 0 0 r
s
.59 .307 .456 r
.55293 .56695 m .55379 .54936 L .58617 .54409 L p F P
0 0 0 r
s
.71482 .51782 m
.73528 .51178 L
s
.71482 .51782 m
.70533 .50664 L
s
.442 .409 .727 r
.64847 .42077 m .63675 .39915 L .64964 .38407 L p F P
0 0 0 r
s
.484 .469 .766 r
.63492 .37949 m .64031 .3731 L p .63675 .39915 L F P
0 0 0 r
s
.484 .469 .766 r
.64031 .3731 m .64964 .38407 L .63675 .39915 L p F P
0 0 0 r
s
.4377 .51619 m
.45338 .51132 L
s
.76505 .5169 m
.7857 .51085 L
s
.76505 .5169 m
.75589 .5057 L
s
.763 .448 .453 r
.45719 .55999 m .45514 .54211 L .48704 .54835 L p F P
0 0 0 r
s
.763 .448 .453 r
.48704 .54835 m .48815 .56599 L .45719 .55999 L p F P
0 0 0 r
s
.905 .705 .622 r
.38144 .46059 m .38746 .43857 L .40697 .45431 L p F P
0 0 0 r
s
.905 .705 .622 r
.40697 .45431 m .40185 .47681 L .38144 .46059 L p F P
0 0 0 r
s
.484 .51643 m
.50366 .51038 L
s
.484 .51643 m
.47298 .50523 L
s
.873 .795 .771 r
.41262 .37715 m .41743 .38367 L p .39723 .37989 L F P
0 0 0 r
s
.873 .795 .771 r
.41743 .38367 m .40882 .39541 L .39723 .37989 L p F P
0 0 0 r
s
.81534 .51597 m
.83618 .50992 L
s
.81534 .51597 m
.8065 .50476 L
s
.53415 .51551 m
.55399 .50945 L
s
.53415 .51551 m
.52345 .50429 L
s
.25281 .51504 m
.27165 .50898 L
s
.25281 .51504 m
.24024 .50382 L
s
.86568 .51504 m
.88671 .50898 L
s
.86568 .51504 m
.85717 .50382 L
s
.547 .317 .518 r
.61677 .5149 m .61626 .53514 L .58617 .54409 L p F P
0 0 0 r
s
.60438 .50851 m
.6116 .51646 L
s
.58435 .51458 m
.59164 .52246 L
s
.462 .249 .503 r
.61626 .53514 m .61677 .5149 L .64355 .50234 L p F P
0 0 0 r
s
.499 .321 .57 r
.64141 .48056 m .64355 .50234 L .61677 .5149 L p F P
0 0 0 r
s
.63461 .51365 m
.64452 .52474 L
s
.63399 .51383 m
.63461 .51365 L
s
.58435 .51458 m
.60438 .50851 L
s
.58435 .51458 m
.57398 .50335 L
s
.30287 .51411 m
.3219 .50805 L
s
.30287 .51411 m
.29063 .50288 L
s
.91608 .51411 m
.9373 .50805 L
s
.91608 .51411 m
.9079 .50288 L
s
.902 .793 .731 r
.38373 .39973 m .39723 .37989 L .40882 .39541 L p F P
0 0 0 r
s
.902 .793 .731 r
.40882 .39541 m .39667 .41669 L .38373 .39973 L p F P
0 0 0 r
s
.63461 .51365 m
.65483 .50758 L
s
.63437 .51338 m
.63461 .51365 L
s
.35298 .51318 m
.3722 .50711 L
s
.35298 .51318 m
.34107 .50194 L
s
.95868 .50194 m
.96653 .51318 L
s
.68492 .51272 m
.70533 .50664 L
s
.68492 .51272 m
.6752 .50146 L
s
.394 .34 .679 r
.65735 .4429 m .64847 .42077 L .66284 .4043 L p F P
0 0 0 r
s
.442 .409 .727 r
.64964 .38407 m .66284 .4043 L .64847 .42077 L p F P
0 0 0 r
s
.59 .307 .456 r
.58617 .54409 m .58436 .56189 L .55293 .56695 L p F P
0 0 0 r
s
.513 .242 .441 r
.58436 .56189 m .58617 .54409 L .61626 .53514 L p F P
0 0 0 r
s
.402 .251 .559 r
.64355 .50234 m .64141 .48056 L .66316 .46505 L p F P
0 0 0 r
s
.447 .326 .622 r
.65735 .4429 m .66316 .46505 L .64141 .48056 L p F P
0 0 0 r
s
.873 .585 .498 r
.4003 .51909 m .3996 .49857 L .42528 .51196 L p F P
0 0 0 r
s
.39156 .50099 m
.39996 .50915 L
s
.41733 .50781 m
.42256 .50617 L
s
.873 .585 .498 r
.42528 .51196 m .42584 .53225 L .4003 .51909 L p F P
0 0 0 r
s
.42256 .50617 m
.4301 .5136 L
s
.73528 .51178 m
.75589 .5057 L
s
.73528 .51178 m
.72589 .50052 L
s
.45338 .51132 m
.47298 .50523 L
s
.45338 .51132 m
.44211 .50005 L
s
.7857 .51085 m
.8065 .50476 L
s
.7857 .51085 m
.77664 .49957 L
s
.816 .489 .435 r
.42877 .55053 m .42584 .53225 L .45514 .54211 L p F P
0 0 0 r
s
.816 .489 .435 r
.45514 .54211 m .45719 .55999 L .42877 .55053 L p F P
0 0 0 r
s
0 0 1 r
2 Mabswid
.31 .37744 m
.30108 .3777 L
s
0 0 0 r
.5 Mabswid
.50366 .51038 m
.52345 .50429 L
s
.50366 .51038 m
.49272 .4991 L
s
.873 .795 .771 r
.39723 .37989 m .40676 .36921 L .41262 .37715 L p F P
0 0 0 r
s
.22145 .50992 m
.24024 .50382 L
s
.22145 .50992 m
.20864 .49863 L
s
.83618 .50992 m
.85717 .50382 L
s
.83618 .50992 m
.82745 .49863 L
s
.55399 .50945 m
.57398 .50335 L
s
.55399 .50945 m
.54339 .49815 L
s
.27165 .50898 m
.29063 .50288 L
s
.27165 .50898 m
.25916 .49768 L
s
.88671 .50898 m
.9079 .50288 L
s
.88671 .50898 m
.87831 .49768 L
s
.93 .786 .68 r
.37349 .4206 m .38373 .39973 L .39667 .41669 L p F P
0 0 0 r
s
.93 .786 .68 r
.39667 .41669 m .38746 .43857 L .37349 .4206 L p F P
0 0 0 r
s
.60438 .50851 m
.59411 .49721 L
s
.92 .677 .555 r
.37878 .48226 m .38144 .46059 L .40185 .47681 L p F P
0 0 0 r
s
.92 .677 .555 r
.40185 .47681 m .3996 .49857 L .37878 .48226 L p F P
0 0 0 r
s
.3219 .50805 m
.34107 .50194 L
s
.3219 .50805 m
.30974 .49673 L
s
.9373 .50805 m
.95868 .50194 L
s
.9373 .50805 m
.92923 .49673 L
s
.3722 .50711 m
.39156 .50099 L
s
.3722 .50711 m
.36037 .49578 L
s
.70533 .50664 m
.72589 .50052 L
s
.70533 .50664 m
.69571 .49531 L
s
.413 .447 .786 r
.64964 .38407 m .64031 .3731 L .64414 .36472 L p F P
0 0 0 r
s
.42256 .50617 m
.44211 .50005 L
s
.41106 .49483 m
.42256 .50617 L
s
.75589 .5057 m
.77664 .49957 L
s
.75589 .5057 m
.7466 .49436 L
s
0 0 1 r
2 Mabswid
.75686 .47352 m
.74831 .46926 L
s
.5 Mabswid
.689 .335 .37 r
.49014 .58081 m .48815 .56599 L .52046 .56833 L p F P
0 0 0 r
s
.689 .335 .37 r
.52046 .56833 m .52069 .583 L .49014 .58081 L p F P
0 0 0 r
s
.626 .284 .372 r
.52069 .583 m .52046 .56833 L .55293 .56695 L p F P
0 0 0 r
s
.335 .256 .617 r
.66316 .46505 m .65735 .4429 L .67284 .42544 L p F P
0 0 0 r
s
.394 .34 .679 r
.66284 .4043 m .67284 .42544 L .65735 .4429 L p F P
0 0 0 r
s
.47298 .50523 m
.49272 .4991 L
s
.47298 .50523 m
.46181 .49388 L
s
.8065 .50476 m
.82745 .49863 L
s
.8065 .50476 m
.79755 .4934 L
s
.52345 .50429 m
.54339 .49815 L
s
.52345 .50429 m
.51261 .49293 L
s
.626 .284 .372 r
.55293 .56695 m .55139 .58171 L .52069 .583 L p F P
0 0 0 r
s
.554 .222 .361 r
.55139 .58171 m .55293 .56695 L .58436 .56189 L p F P
0 0 0 r
s
.24024 .50382 m
.25916 .49768 L
s
.24024 .50382 m
.22751 .49245 L
s
.85717 .50382 m
.87831 .49768 L
s
.85717 .50382 m
.84855 .49245 L
s
.347 .369 .742 r
.66284 .4043 m .64964 .38407 L .65733 .36753 L p F P
0 0 0 r
s
.413 .447 .786 r
.64414 .36472 m .64734 .35772 L p .64964 .38407 L F P
0 0 0 r
s
.413 .447 .786 r
.64734 .35772 m .65733 .36753 L .64964 .38407 L p F P
0 0 0 r
s
.513 .242 .441 r
.61626 .53514 m .61355 .5533 L .58436 .56189 L p F P
0 0 0 r
s
.411 .155 .413 r
.61355 .5533 m .61626 .53514 L .64288 .5228 L p F P
0 0 0 r
s
.462 .249 .503 r
.64355 .50234 m .64288 .5228 L .61626 .53514 L p F P
0 0 0 r
s
.60438 .50851 m
.62456 .50241 L
s
.62456 .50241 m
.63013 .50864 L
s
.57398 .50335 m
.59411 .49721 L
s
.57398 .50335 m
.56347 .49197 L
s
.746 .377 .355 r
.46089 .57519 m .45719 .55999 L .48815 .56599 L p F P
0 0 0 r
s
.746 .377 .355 r
.48815 .56599 m .49014 .58081 L .46089 .57519 L p F P
0 0 0 r
s
.29063 .50288 m
.30974 .49673 L
s
.29063 .50288 m
.27822 .4915 L
s
.9079 .50288 m
.92923 .49673 L
s
.9079 .50288 m
.89961 .4915 L
s
.896 .853 .792 r
.40419 .36217 m .40676 .36921 L p .39097 .36308 L F P
0 0 0 r
s
.896 .853 .792 r
.40676 .36921 m .39723 .37989 L .39097 .36308 L p F P
0 0 0 r
s
.61438 .49102 m
.62456 .50241 L
s
.343 .155 .476 r
.64288 .5228 m .64355 .50234 L .66573 .48674 L p F P
0 0 0 r
s
.65349 .50605 m
.65483 .50758 L
s
.402 .251 .559 r
.66316 .46505 m .66573 .48674 L .64355 .50234 L p F P
0 0 0 r
s
.65483 .50758 m
.6752 .50146 L
s
.64488 .49626 m
.64768 .49944 L
s
.62456 .50241 m
.64488 .49626 L
s
.95072 .49054 m
.95868 .50194 L
s
.34107 .50194 m
.36037 .49578 L
s
.34107 .50194 m
.32899 .49054 L
s
.6752 .50146 m
.69571 .49531 L
s
.955 .77 .614 r
.36678 .44205 m .37349 .4206 L .38746 .43857 L p F P
0 0 0 r
s
.955 .77 .614 r
.38746 .43857 m .38144 .46059 L .36678 .44205 L p F P
0 0 0 r
s
.72589 .50052 m
.7466 .49436 L
s
.72589 .50052 m
.71638 .48911 L
s
.871 .53 .402 r
.40401 .5379 m .4003 .51909 L .42584 .53225 L p F P
0 0 0 r
s
.871 .53 .402 r
.42584 .53225 m .42877 .55053 L .40401 .5379 L p F P
0 0 0 r
s
.44211 .50005 m
.46181 .49388 L
s
.44211 .50005 m
.4307 .48863 L
s
.933 .861 .745 r
.37667 .38132 m .39097 .36308 L .39723 .37989 L p F P
0 0 0 r
s
.933 .861 .745 r
.39723 .37989 m .38373 .39973 L .37667 .38132 L p F P
0 0 0 r
s
.77664 .49957 m
.79755 .4934 L
s
.77664 .49957 m
.76746 .48815 L
s
.49272 .4991 m
.51261 .49293 L
s
.49272 .4991 m
.48164 .48767 L
s
.554 .222 .361 r
.58436 .56189 m .58109 .57697 L .55139 .58171 L p F P
0 0 0 r
s
.462 .14 .334 r
.58109 .57697 m .58436 .56189 L .61355 .5533 L p F P
0 0 0 r
s
0 0 1 r
2 Mabswid
.30108 .3777 m
.29227 .37841 L
s
0 0 0 r
.5 Mabswid
.20864 .49863 m
.22751 .49245 L
s
.20864 .49863 m
.19566 .48719 L
s
.82745 .49863 m
.84855 .49245 L
s
.82745 .49863 m
.8186 .48719 L
s
.929 .635 .465 r
.37961 .50307 m .37878 .48226 L .3996 .49857 L p F P
0 0 0 r
s
.39105 .50049 m
.39156 .50099 L
s
.39156 .50099 m
.39837 .49884 L
s
.39949 .49849 m
.41106 .49483 L
s
.929 .635 .465 r
.3996 .49857 m .4003 .51909 L .37961 .50307 L p F P
0 0 0 r
s
.54339 .49815 m
.56347 .49197 L
s
.54339 .49815 m
.53264 .48671 L
s
.25916 .49768 m
.27822 .4915 L
s
.25916 .49768 m
.24651 .48623 L
s
.87831 .49768 m
.89961 .4915 L
s
.87831 .49768 m
.8698 .48623 L
s
.59411 .49721 m
.61438 .49102 L
s
.59411 .49721 m
.58369 .48575 L
s
.8 .414 .323 r
.43405 .56633 m .42877 .55053 L .45719 .55999 L p F P
0 0 0 r
s
.8 .414 .323 r
.45719 .55999 m .46089 .57519 L .43405 .56633 L p F P
0 0 0 r
s
.26 .151 .535 r
.66573 .48674 m .66316 .46505 L .6794 .44705 L p F P
0 0 0 r
s
.335 .256 .617 r
.67284 .42544 m .6794 .44705 L .66316 .46505 L p F P
0 0 0 r
s
.266 .274 .682 r
.67284 .42544 m .66284 .4043 L .67148 .3862 L p F P
0 0 0 r
s
.347 .369 .742 r
.65733 .36753 m .67148 .3862 L .66284 .4043 L p F P
0 0 0 r
s
.30974 .49673 m
.32899 .49054 L
s
.30974 .49673 m
.29742 .48527 L
s
.92923 .49673 m
.95072 .49054 L
s
.92923 .49673 m
.92106 .48527 L
s
.64488 .49626 m
.65772 .49237 L
s
.896 .853 .792 r
.39097 .36308 m .40106 .35358 L .40419 .36217 L p F P
0 0 0 r
s
.36037 .49578 m
.37908 .48982 L
s
.36037 .49578 m
.34838 .4843 L
s
.69571 .49531 m
.71638 .48911 L
s
.69571 .49531 m
.68597 .48382 L
s
.41106 .49483 m
.4307 .48863 L
s
.39941 .48334 m
.41106 .49483 L
s
.7466 .49436 m
.76746 .48815 L
s
.7466 .49436 m
.73719 .48286 L
s
.46181 .49388 m
.48164 .48767 L
s
.46181 .49388 m
.45048 .48238 L
s
.79755 .4934 m
.8186 .48719 L
s
.79755 .4934 m
.78847 .48189 L
s
.51261 .49293 m
.53264 .48671 L
s
.51261 .49293 m
.50162 .48141 L
s
.973 .74 .525 r
.36382 .4636 m .36678 .44205 L .38144 .46059 L p F P
0 0 0 r
s
.973 .74 .525 r
.38144 .46059 m .37878 .48226 L .36382 .4636 L p F P
0 0 0 r
s
.967 .859 .68 r
.3658 .40107 m .37667 .38132 L .38373 .39973 L p F P
0 0 0 r
s
.967 .859 .68 r
.38373 .39973 m .37349 .4206 L .3658 .40107 L p F P
0 0 0 r
s
.22751 .49245 m
.24651 .48623 L
s
.22751 .49245 m
.21461 .48093 L
s
.84855 .49245 m
.8698 .48623 L
s
.84855 .49245 m
.83981 .48093 L
s
.319 .421 .809 r
.65733 .36753 m .64734 .35772 L .64831 .34895 L p F P
0 0 0 r
s
.56347 .49197 m
.58369 .48575 L
s
.56347 .49197 m
.55281 .48044 L
s
0 0 1 r
2 Mabswid
.76393 .47758 m
.75686 .47352 L
s
0 0 0 r
.5 Mabswid
.27822 .4915 m
.29742 .48527 L
s
.27822 .4915 m
.26565 .47996 L
s
.89961 .4915 m
.92106 .48527 L
s
.89961 .4915 m
.89121 .47996 L
s
.61438 .49102 m
.6348 .48479 L
s
.61438 .49102 m
.60406 .47948 L
s
.411 .155 .413 r
.64288 .5228 m .63936 .54146 L .61355 .5533 L p F P
0 0 0 r
s
.261 .028 .359 r
.63936 .54146 m .64288 .5228 L .66493 .50747 L p F P
0 0 0 r
s
.343 .155 .476 r
.66573 .48674 m .66493 .50747 L .64288 .5228 L p F P
0 0 0 r
s
.6348 .48479 m
.64488 .49626 L
s
.66559 .49034 m
.6752 .50146 L
s
.94266 .47899 m
.95072 .49054 L
s
.32899 .49054 m
.34838 .4843 L
s
.32899 .49054 m
.31676 .47899 L
s
.65537 .47851 m
.66371 .48816 L
s
.647 .228 .234 r
.49301 .5924 m .49014 .58081 L .52069 .583 L p F P
0 0 0 r
s
.647 .228 .234 r
.52069 .583 m .52102 .5944 L .49301 .5924 L p F P
0 0 0 r
s
.578 .172 .237 r
.52102 .5944 m .52069 .583 L .55139 .58171 L p F P
0 0 0 r
s
.462 .14 .334 r
.61355 .5533 m .60866 .56893 L .58109 .57697 L p F P
0 0 0 r
s
.334 .025 .283 r
.60866 .56893 m .61355 .5533 L .63936 .54146 L p F P
0 0 0 r
s
.38573 .4877 m
.39941 .48334 L
s
.71638 .48911 m
.73719 .48286 L
s
.71638 .48911 m
.70674 .47754 L
s
.164 .153 .598 r
.6794 .44705 m .67284 .42544 L .68223 .40625 L p F P
0 0 0 r
s
.266 .274 .682 r
.67148 .3862 m .68223 .40625 L .67284 .42544 L p F P
0 0 0 r
s
.578 .172 .237 r
.55139 .58171 m .54918 .59322 L .52102 .5944 L p F P
0 0 0 r
s
.492 .096 .218 r
.54918 .59322 m .55139 .58171 L .58109 .57697 L p F P
0 0 0 r
s
.4307 .48863 m
.45048 .48238 L
s
.4307 .48863 m
.41914 .47705 L
s
.907 .917 .815 r
.4009 .3463 m .40106 .35358 L p .39048 .34568 L F P
0 0 0 r
s
.907 .917 .815 r
.40106 .35358 m .39097 .36308 L .39048 .34568 L p F P
0 0 0 r
s
.76746 .48815 m
.78847 .48189 L
s
.76746 .48815 m
.75816 .47657 L
s
.21 .314 .753 r
.67148 .3862 m .65733 .36753 L .65934 .35021 L p F P
0 0 0 r
s
.319 .421 .809 r
.64831 .34895 m .64912 .34163 L p .65733 .36753 L F P
0 0 0 r
s
.319 .421 .809 r
.64912 .34163 m .65934 .35021 L .65733 .36753 L p F P
0 0 0 r
s
.706 .269 .209 r
.4662 .58729 m .46089 .57519 L .49014 .58081 L p F P
0 0 0 r
s
.706 .269 .209 r
.49014 .58081 m .49301 .5924 L .4662 .58729 L p F P
0 0 0 r
s
.48164 .48767 m
.50162 .48141 L
s
.48164 .48767 m
.47041 .47608 L
s
.19566 .48719 m
.21461 .48093 L
s
.19566 .48719 m
.1825 .4756 L
s
.8186 .48719 m
.83981 .48093 L
s
.8186 .48719 m
.80964 .4756 L
s
.851 .443 .263 r
.41071 .55452 m .40401 .5379 L .42877 .55053 L p F P
0 0 0 r
s
.851 .443 .263 r
.42877 .55053 m .43405 .56633 L .41071 .55452 L p F P
0 0 0 r
s
.923 .568 .338 r
.38398 .52253 m .37961 .50307 L .4003 .51909 L p F P
0 0 0 r
s
.923 .568 .338 r
.4003 .51909 m .40401 .5379 L .38398 .52253 L p F P
0 0 0 r
s
.159 .014 .42 r
.66493 .50747 m .66573 .48674 L .68229 .46863 L p F P
0 0 0 r
s
.26 .151 .535 r
.6794 .44705 m .68229 .46863 L .66573 .48674 L p F P
0 0 0 r
s
.67386 .48749 m
.68597 .48382 L
s
.53264 .48671 m
.55281 .48044 L
s
.53264 .48671 m
.52175 .47511 L
s
.24651 .48623 m
.26565 .47996 L
s
.24651 .48623 m
.23369 .47462 L
s
.8698 .48623 m
.89121 .47996 L
s
.8698 .48623 m
.86118 .47462 L
s
.58369 .48575 m
.60406 .47948 L
s
.58369 .48575 m
.57314 .47414 L
s
.29742 .48527 m
.31676 .47899 L
s
.29742 .48527 m
.28493 .47365 L
s
.92106 .48527 m
.94266 .47899 L
s
.92106 .48527 m
.91277 .47365 L
s
.6348 .48479 m
.65537 .47851 L
s
.6348 .48479 m
.62458 .47316 L
s
0 0 1 r
2 Mabswid
.29227 .37841 m
.28494 .37954 L
s
0 0 0 r
.5 Mabswid
.34838 .4843 m
.33623 .47267 L
s
.993 .842 .587 r
.35867 .42189 m .3658 .40107 L .37349 .4206 L p F P
0 0 0 r
s
.993 .842 .587 r
.37349 .4206 m .36678 .44205 L .35867 .42189 L p F P
0 0 0 r
s
.946 .934 .753 r
.37598 .36223 m .39048 .34568 L .39097 .36308 L p F P
0 0 0 r
s
.946 .934 .753 r
.39097 .36308 m .37667 .38132 L .37598 .36223 L p F P
0 0 0 r
s
.68597 .48382 m
.70674 .47754 L
s
.67911 .47574 m
.68597 .48382 L
s
.492 .096 .218 r
.58109 .57697 m .5764 .58891 L .54918 .59322 L p F P
0 0 0 r
s
.378 0 .172 r
.5764 .58891 m .58109 .57697 L .60866 .56893 L p F P
0 0 0 r
s
.39941 .48334 m
.41914 .47705 L
s
.38759 .4717 m
.39941 .48334 L
s
.73719 .48286 m
.75816 .47657 L
s
.73719 .48286 m
.72766 .47121 L
s
.45048 .48238 m
.47041 .47608 L
s
.45048 .48238 m
.43901 .47072 L
s
.976 .685 .398 r
.36475 .48475 m .36382 .4636 L .37878 .48226 L p F P
0 0 0 r
s
.34838 .4843 m
.3645 .47912 L
s
.37328 .48323 m
.37905 .48883 L
s
.976 .685 .398 r
.37878 .48226 m .37961 .50307 L .36475 .48475 L p F P
0 0 0 r
s
.78847 .48189 m
.80964 .4756 L
s
.78847 .48189 m
.77928 .47023 L
s
.756 .295 .154 r
.44164 .57923 m .43405 .56633 L .46089 .57519 L p F P
0 0 0 r
s
.756 .295 .154 r
.46089 .57519 m .4662 .58729 L .44164 .57923 L p F P
0 0 0 r
s
.907 .917 .815 r
.39048 .34568 m .4007 .33742 L .4009 .3463 L p F P
0 0 0 r
s
.50162 .48141 m
.52175 .47511 L
s
.50162 .48141 m
.49048 .46974 L
s
.21461 .48093 m
.23369 .47462 L
s
.21461 .48093 m
.20153 .46925 L
s
.83981 .48093 m
.86118 .47462 L
s
.83981 .48093 m
.83096 .46925 L
s
.55281 .48044 m
.57314 .47414 L
s
.55281 .48044 m
.54202 .46876 L
s
.26565 .47996 m
.28493 .47365 L
s
.26565 .47996 m
.25291 .46827 L
s
.89121 .47996 m
.91277 .47365 L
s
.89121 .47996 m
.8827 .46827 L
s
.07 .174 .667 r
.68223 .40625 m .67148 .3862 L .67385 .3672 L p F P
0 0 0 r
s
.21 .314 .753 r
.65934 .35021 m .67385 .3672 L .67148 .3862 L p F P
0 0 0 r
s
.60406 .47948 m
.62458 .47316 L
s
.60406 .47948 m
.59361 .46778 L
s
.03 0 .477 r
.68229 .46863 m .6794 .44705 L .68927 .42724 L p F P
0 0 0 r
s
.164 .153 .598 r
.68223 .40625 m .68927 .42724 L .6794 .44705 L p F P
0 0 0 r
s
.93449 .46729 m
.94266 .47899 L
s
.31676 .47899 m
.33623 .47267 L
s
.31676 .47899 m
.30436 .46729 L
s
.65537 .47851 m
.64526 .4668 L
s
.37386 .47611 m
.38759 .4717 L
s
.35586 .46631 m
.3643 .47451 L
s
.334 .025 .283 r
.63936 .54146 m .63301 .55785 L .60866 .56893 L p F P
0 0 0 r
s
.141 0 .187 r
.63301 .55785 m .63936 .54146 L .66071 .52676 L p F P
0 0 0 r
s
.261 .028 .359 r
.66493 .50747 m .66071 .52676 L .63936 .54146 L p F P
0 0 0 r
s
0 0 1 r
2 Mabswid
.76941 .48141 m
.76393 .47758 L
s
0 0 0 r
.5 Mabswid
.70674 .47754 m
.72766 .47121 L
s
.70674 .47754 m
.69696 .46581 L
s
.19 .387 .827 r
.65934 .35021 m .64912 .34163 L .6471 .33285 L p F P
0 0 0 r
s
.41914 .47705 m
.43901 .47072 L
s
.41914 .47705 m
.40741 .46532 L
s
.75816 .47657 m
.77928 .47023 L
s
.75816 .47657 m
.74873 .46483 L
s
.47041 .47608 m
.49048 .46974 L
s
.47041 .47608 m
.45903 .46434 L
s
.1825 .4756 m
.20153 .46925 L
s
.1825 .4756 m
.16917 .46384 L
s
.80964 .4756 m
.83096 .46925 L
s
.80964 .4756 m
.80055 .46384 L
s
.021 0 .254 r
.66071 .52676 m .66493 .50747 L .68139 .48969 L p F P
0 0 0 r
s
.159 .014 .42 r
.68229 .46863 m .68139 .48969 L .66493 .50747 L p F P
0 0 0 r
s
.65537 .47851 m
.67609 .47218 L
s
.67609 .47218 m
.67751 .47386 L
s
.378 0 .172 r
.60866 .56893 m .60164 .58159 L .5764 .58891 L p F P
0 0 0 r
s
.214 0 .085 r
.60164 .58159 m .60866 .56893 L .63301 .55785 L p F P
0 0 0 r
s
.52175 .47511 m
.54202 .46876 L
s
.52175 .47511 m
.5107 .46335 L
s
.971 .931 .656 r
.36493 .38078 m .37598 .36223 L .37667 .38132 L p F P
0 0 0 r
s
.971 .931 .656 r
.37667 .38132 m .3658 .40107 L .36493 .38078 L p F P
0 0 0 r
s
.23369 .47462 m
.25291 .46827 L
s
.23369 .47462 m
.22069 .46286 L
s
.86118 .47462 m
.8827 .46827 L
s
.86118 .47462 m
.85243 .46286 L
s
.998 .796 .45 r
.35552 .44331 m .35867 .42189 L .36678 .44205 L p F P
0 0 0 r
s
.998 .796 .45 r
.36678 .44205 m .36382 .4636 L .35552 .44331 L p F P
0 0 0 r
s
.57314 .47414 m
.59361 .46778 L
s
.57314 .47414 m
.56244 .46236 L
s
.883 .454 .152 r
.39186 .54016 m .38398 .52253 L .40401 .5379 L p F P
0 0 0 r
s
.883 .454 .152 r
.40401 .5379 m .41071 .55452 L .39186 .54016 L p F P
0 0 0 r
s
.28493 .47365 m
.30436 .46729 L
s
.28493 .47365 m
.27228 .46187 L
s
.91277 .47365 m
.93449 .46729 L
s
.91277 .47365 m
.90437 .46187 L
s
.885 .977 .829 r
.40301 .33021 m .4007 .33742 L p .39594 .32843 L F P
0 0 0 r
s
.885 .977 .829 r
.4007 .33742 m .39048 .34568 L .39594 .32843 L p F P
0 0 0 r
s
.62458 .47316 m
.64526 .4668 L
s
.62458 .47316 m
.61423 .46138 L
s
.558 .056 .018 r
.50699 .59787 m .49515 .59703 L p .52102 .5944 L F P
0 0 0 r
s
.558 .056 .018 r
.49515 .59703 m .49301 .5924 L .52102 .5944 L p F P
0 0 0 r
s
.558 .056 .018 r
.52102 .5944 m .52127 .59889 L .50699 .59787 L p F P
0 0 0 r
s
.481 0 .022 r
.52127 .59889 m .52102 .5944 L .54918 .59322 L p F P
0 0 0 r
s
.33623 .47267 m
.35586 .46631 L
s
.33623 .47267 m
.32392 .46088 L
s
.788 .3 .053 r
.42032 .5685 m .41071 .55452 L .43405 .56633 L p F P
0 0 0 r
s
.788 .3 .053 r
.43405 .56633 m .44164 .57923 L .42032 .5685 L p F P
0 0 0 r
s
.67609 .47218 m
.68019 .47093 L
s
.66608 .46039 m
.67609 .47218 L
s
.008 .233 .741 r
.67385 .3672 m .65934 .35021 L .65543 .33285 L p F P
0 0 0 r
s
.19 .387 .827 r
.6471 .33285 m .64542 .32552 L p .65934 .35021 L F P
0 0 0 r
s
.19 .387 .827 r
.64542 .32552 m .65543 .33285 L .65934 .35021 L p F P
0 0 0 r
s
.38759 .4717 m
.40741 .46532 L
s
.37562 .45989 m
.38759 .4717 L
s
.481 0 .022 r
.53316 .59839 m .52127 .59889 L p .54918 .59322 L F P
0 0 0 r
s
.481 0 .022 r
.54918 .59322 m .54752 .59779 L .53316 .59839 L p F P
0 0 0 r
s
.377 0 0 r
.54752 .59779 m .54918 .59322 L .5764 .58891 L p F P
0 0 0 r
s
.72766 .47121 m
.74873 .46483 L
s
.72766 .47121 m
.71799 .4594 L
s
.43901 .47072 m
.45903 .46434 L
s
.43901 .47072 m
.42738 .4589 L
s
.944 .585 .212 r
.36961 .50497 m .36475 .48475 L .37961 .50307 L p F P
0 0 0 r
s
.944 .585 .212 r
.37961 .50307 m .38398 .52253 L .36961 .50497 L p F P
0 0 0 r
s
.614 .091 0 r
.4815 .59443 m .47016 .59227 L p .49301 .5924 L F P
0 0 0 r
s
.614 .091 0 r
.47016 .59227 m .4662 .58729 L .49301 .5924 L p F P
0 0 0 r
s
.614 .091 0 r
.49301 .5924 m .49515 .59703 L .4815 .59443 L p F P
0 0 0 r
s
0 0 .533 r
.68927 .42724 m .68223 .40625 L .6849 .38607 L p F P
0 0 0 r
s
.07 .174 .667 r
.67385 .3672 m .6849 .38607 L .68223 .40625 L p F P
0 0 0 r
s
.77928 .47023 m
.80055 .46384 L
s
.77928 .47023 m
.76996 .45841 L
s
0 0 1 r
2 Mabswid
.28494 .37954 m
.2792 .38109 L
s
0 0 0 r
.5 Mabswid
.49048 .46974 m
.5107 .46335 L
s
.49048 .46974 m
.4792 .45791 L
s
.20153 .46925 m
.22069 .46286 L
s
.20153 .46925 m
.18827 .45741 L
s
.83096 .46925 m
.85243 .46286 L
s
.83096 .46925 m
.82198 .45741 L
s
.54202 .46876 m
.56244 .46236 L
s
.54202 .46876 m
.53107 .45692 L
s
0 0 .299 r
.68139 .48969 m .68229 .46863 L .69239 .44869 L p F P
0 0 0 r
s
.03 0 .477 r
.68927 .42724 m .69239 .44869 L .68229 .46863 L p F P
0 0 0 r
s
.68697 .46886 m
.69696 .46581 L
s
.25291 .46827 m
.27228 .46187 L
s
.25291 .46827 m
.24 .45642 L
s
.8827 .46827 m
.90437 .46187 L
s
.8827 .46827 m
.87407 .45642 L
s
.59361 .46778 m
.61423 .46138 L
s
.59361 .46778 m
.58301 .45592 L
s
.897 .985 .73 r
.38188 .34327 m .39594 .32843 L .39048 .34568 L p F P
0 0 0 r
s
.897 .985 .73 r
.39048 .34568 m .37598 .36223 L .38188 .34327 L p F P
0 0 0 r
s
.30436 .46729 m
.32392 .46088 L
s
.30436 .46729 m
.29178 .45542 L
s
.92621 .45542 m
.93449 .46729 L
s
.377 0 0 r
.559 .59598 m .54752 .59779 L p .5764 .58891 L F P
0 0 0 r
s
.377 0 0 r
.5764 .58891 m .5729 .59378 L .559 .59598 L p F P
0 0 0 r
s
.23 0 0 r
.5729 .59378 m .5764 .58891 L .60164 .58159 L p F P
0 0 0 r
s
.64526 .4668 m
.66608 .46039 L
s
.64526 .4668 m
.635 .45493 L
s
.885 .977 .829 r
.39594 .32843 m .40582 .32143 L .40301 .33021 L p F P
0 0 0 r
s
.35586 .46631 m
.36383 .46372 L
s
.69696 .46581 m
.71799 .4594 L
s
.69003 .45749 m
.69696 .46581 L
s
.40741 .46532 m
.42738 .4589 L
s
.40741 .46532 m
.39553 .45343 L
s
.963 .886 .5 r
.35768 .40092 m .36493 .38078 L .3658 .40107 L p F P
0 0 0 r
s
.963 .886 .5 r
.3658 .40107 m .35867 .42189 L .35768 .40092 L p F P
0 0 0 r
s
.645 .098 0 r
.45767 .58819 m .44729 .58479 L p .4662 .58729 L F P
0 0 0 r
s
.645 .098 0 r
.44729 .58479 m .44164 .57923 L .4662 .58729 L p F P
0 0 0 r
s
.645 .098 0 r
.4662 .58729 m .47016 .59227 L .45767 .58819 L p F P
0 0 0 r
s
.74873 .46483 m
.76996 .45841 L
s
.74873 .46483 m
.73917 .45293 L
s
.45903 .46434 m
.4792 .45791 L
s
.45903 .46434 m
.44749 .45243 L
s
.16917 .46384 m
.18827 .45741 L
s
.16917 .46384 m
.15565 .45193 L
s
.80055 .46384 m
.82198 .45741 L
s
.80055 .46384 m
.79134 .45193 L
s
.957 .696 .248 r
.35651 .46482 m .35552 .44331 L .36382 .4636 L p F P
0 0 0 r
s
.34363 .45443 m
.35586 .46631 L
s
.957 .696 .248 r
.36382 .4636 m .36475 .48475 L .35651 .46482 L p F P
0 0 0 r
s
.3639 .4637 m
.37562 .45989 L
s
.214 0 .085 r
.63301 .55785 m .6239 .57152 L .60164 .58159 L p F P
0 0 0 r
s
.6239 .57152 m .63301 .55785 L .65311 .5441 L p F P
s
.141 0 .187 r
.66071 .52676 m .65311 .5441 L .63301 .55785 L p F P
0 0 0 r
s
.5107 .46335 m
.53107 .45692 L
s
.5107 .46335 m
.49951 .45143 L
s
.22069 .46286 m
.24 .45642 L
s
.22069 .46286 m
.20752 .45093 L
s
.85243 .46286 m
.87407 .45642 L
s
.85243 .46286 m
.84357 .45093 L
s
0 0 1 r
2 Mabswid
.77325 .48498 m
.76941 .48141 L
s
.5 Mabswid
0 0 .013 r
.65311 .5441 m .66071 .52676 L .67663 .50971 L p F P
0 0 0 r
s
.021 0 .254 r
.68139 .48969 m .67663 .50971 L .66071 .52676 L p F P
0 0 0 r
s
.56244 .46236 m
.58301 .45592 L
s
.56244 .46236 m
.55159 .45043 L
s
.019 .34 .821 r
.65543 .33285 m .64542 .32552 L .64044 .31713 L p F P
0 0 0 r
s
.27228 .46187 m
.29178 .45542 L
s
.27228 .46187 m
.25945 .44993 L
s
.90437 .46187 m
.92621 .45542 L
s
.90437 .46187 m
.89586 .44993 L
s
0 .019 .591 r
.6849 .38607 m .67385 .3672 L .66967 .34813 L p F P
0 0 0 r
s
.008 .233 .741 r
.65543 .33285 m .66967 .34813 L .67385 .3672 L p F P
0 0 0 r
s
.61423 .46138 m
.635 .45493 L
s
.61423 .46138 m
.60373 .44943 L
s
.32392 .46088 m
.34363 .45443 L
s
.32392 .46088 m
.31144 .44893 L
s
.66608 .46039 m
.65593 .44843 L
s
.768 .264 0 r
.40314 .55547 m .39186 .54016 L .41071 .55452 L p F P
0 0 0 r
s
.768 .264 0 r
.41071 .55452 m .42032 .5685 L .40314 .55547 L p F P
0 0 0 r
s
.37562 .45989 m
.39553 .45343 L
s
.36348 .44793 m
.37562 .45989 L
s
0 0 .329 r
.69239 .44869 m .68927 .42724 L .69215 .40639 L p F P
0 0 0 r
s
0 0 .533 r
.6849 .38607 m .69215 .40639 L .68927 .42724 L p F P
0 0 0 r
s
.71799 .4594 m
.73917 .45293 L
s
.71799 .4594 m
.70819 .44743 L
s
.23 0 0 r
.58352 .59071 m .5729 .59378 L p .60164 .58159 L F P
0 0 0 r
s
.23 0 0 r
.60164 .58159 m .59642 .58698 L .58352 .59071 L p F P
0 0 0 r
s
.019 0 0 r
.59642 .58698 m .60164 .58159 L .6239 .57152 L p F P
0 0 0 r
s
.42738 .4589 m
.44749 .45243 L
s
.42738 .4589 m
.41559 .44692 L
s
.793 .999 .811 r
.41056 .31463 m .40582 .32143 L p .40725 .31214 L F P
0 0 0 r
s
.793 .999 .811 r
.40582 .32143 m .39594 .32843 L .40725 .31214 L p F P
0 0 0 r
s
.76996 .45841 m
.79134 .45193 L
s
.76996 .45841 m
.76051 .44642 L
s
.838 .411 0 r
.37838 .52376 m .36961 .50497 L .38398 .52253 L p F P
0 0 0 r
s
.838 .411 0 r
.38398 .52253 m .39186 .54016 L .37838 .52376 L p F P
0 0 0 r
s
.4792 .45791 m
.49951 .45143 L
s
.4792 .45791 m
.46776 .44592 L
s
.18827 .45741 m
.20752 .45093 L
s
.18827 .45741 m
.17484 .44541 L
s
.82198 .45741 m
.84357 .45093 L
s
.82198 .45741 m
.81288 .44541 L
s
0 0 .047 r
.67663 .50971 m .68139 .48969 L .69141 .4701 L p F P
0 0 0 r
s
0 0 .299 r
.69239 .44869 m .69141 .4701 L .68139 .48969 L p F P
0 0 0 r
s
.66608 .46039 m
.68706 .45393 L
s
.68706 .45393 m
.68872 .45593 L
s
.856 .932 .552 r
.37116 .3606 m .38188 .34327 L .37598 .36223 L p F P
0 0 0 r
s
.856 .932 .552 r
.37598 .36223 m .36493 .38078 L .37116 .3606 L p F P
0 0 0 r
s
.53107 .45692 m
.55159 .45043 L
s
.53107 .45692 m
.51998 .44491 L
s
.63 .066 0 r
.43647 .57935 m .42746 .57482 L p .44164 .57923 L F P
0 0 0 r
s
.63 .066 0 r
.42746 .57482 m .42032 .5685 L .44164 .57923 L p F P
0 0 0 r
s
.63 .066 0 r
.44164 .57923 m .44729 .58479 L .43647 .57935 L p F P
0 0 0 r
s
.24 .45642 m
.25945 .44993 L
s
.24 .45642 m
.22691 .44441 L
s
.87407 .45642 m
.89586 .44993 L
s
.87407 .45642 m
.86532 .44441 L
s
.58301 .45592 m
.60373 .44943 L
s
.58301 .45592 m
.57227 .4439 L
s
0 .114 .66 r
.66967 .34813 m .65543 .33285 L .64561 .31623 L p F P
0 0 0 r
s
.019 .34 .821 r
.64044 .31713 m .63628 .31013 L p .65543 .33285 L F P
0 0 0 r
s
.019 .34 .821 r
.63628 .31013 m .64561 .31623 L .65543 .33285 L p F P
0 0 0 r
s
.29178 .45542 m
.31144 .44893 L
s
.29178 .45542 m
.27904 .4434 L
s
.91782 .4434 m
.92621 .45542 L
s
0 0 1 r
2 Mabswid
.2792 .38109 m
.27512 .38305 L
s
0 0 0 r
.5 Mabswid
.635 .45493 m
.65593 .44843 L
s
.635 .45493 m
.62461 .44289 L
s
.886 .767 .268 r
.35448 .4222 m .35768 .40092 L .35867 .42189 L p F P
0 0 0 r
s
.886 .767 .268 r
.35867 .42189 m .35552 .44331 L .35448 .4222 L p F P
0 0 0 r
s
.35813 .44968 m
.36348 .44793 L
s
.34363 .45443 m
.35585 .45043 L
s
.34363 .45443 m
.33123 .44239 L
s
.68706 .45393 m
.69023 .45295 L
s
.67701 .44188 m
.68706 .45393 L
s
.39553 .45343 m
.41559 .44692 L
s
.39553 .45343 m
.38349 .44138 L
s
.73917 .45293 m
.76051 .44642 L
s
.73917 .45293 m
.72948 .44087 L
s
.44749 .45243 m
.46776 .44592 L
s
.44749 .45243 m
.4358 .44037 L
s
.793 .999 .811 r
.40725 .31214 m .41634 .30634 L .41056 .31463 L p F P
0 0 0 r
s
.829 .514 0 r
.36168 .48588 m .35651 .46482 L .36475 .48475 L p F P
0 0 0 r
s
.829 .514 0 r
.36475 .48475 m .36961 .50497 L .36168 .48588 L p F P
0 0 0 r
s
.15565 .45193 m
.17484 .44541 L
s
.15565 .45193 m
.14195 .43986 L
s
.79134 .45193 m
.81288 .44541 L
s
.79134 .45193 m
.782 .43986 L
s
.711 .936 .62 r
.39431 .32533 m .40725 .31214 L .39594 .32843 L p F P
0 0 0 r
s
.711 .936 .62 r
.39594 .32843 m .38188 .34327 L .39431 .32533 L p F P
0 0 0 r
s
.49951 .45143 m
.51998 .44491 L
s
.49951 .45143 m
.48817 .43935 L
s
.20752 .45093 m
.22691 .44441 L
s
.20752 .45093 m
.19417 .43885 L
s
.84357 .45093 m
.86532 .44441 L
s
.84357 .45093 m
.83459 .43885 L
s
0 0 .353 r
.69215 .40639 m .6849 .38607 L .68053 .36578 L p F P
0 0 0 r
s
0 .019 .591 r
.66967 .34813 m .68053 .36578 L .6849 .38607 L p F P
0 0 0 r
s
.55159 .45043 m
.57227 .4439 L
s
.55159 .45043 m
.5406 .43834 L
s
.25945 .44993 m
.27904 .4434 L
s
.25945 .44993 m
.24644 .43783 L
s
.89586 .44993 m
.91782 .4434 L
s
.89586 .44993 m
.88723 .43783 L
s
.60373 .44943 m
.62461 .44289 L
s
.60373 .44943 m
.59309 .43732 L
s
.019 0 0 r
.60576 .58276 m .59642 .58698 L p .6239 .57152 L F P
0 0 0 r
s
.31144 .44893 m
.33123 .44239 L
s
.31144 .44893 m
.29878 .43681 L
s
.65311 .5441 m .64223 .55905 L .6239 .57152 L p F P
s
.64223 .55905 m .65311 .5441 L .66806 .52818 L p F P
s
0 0 .013 r
.67663 .50971 m .66806 .52818 L .65311 .5441 L p F P
0 0 0 r
s
0 0 .052 r
.69141 .4701 m .69239 .44869 L .69536 .42771 L p F P
0 0 0 r
s
0 0 .329 r
.69215 .40639 m .69536 .42771 L .69239 .44869 L p F P
0 0 0 r
s
.69309 .45207 m
.70819 .44743 L
s
.65593 .44843 m
.67701 .44188 L
s
.65593 .44843 m
.64564 .43631 L
s
.019 0 0 r
.6239 .57152 m .61712 .57763 L .60576 .58276 L p F P
0 0 0 r
s
.61712 .57763 m .6239 .57152 L .64223 .55905 L p F P
s
0 .274 .755 r
.64561 .31623 m .63628 .31013 L .62848 .30252 L p F P
0 0 0 r
s
.36348 .44793 m
.38349 .44138 L
s
.35118 .4358 m
.35331 .4379 L
s
.70819 .44743 m
.72948 .44087 L
s
.70819 .44743 m
.69825 .43529 L
s
0 0 1 r
2 Mabswid
.77535 .48826 m
.77325 .48498 L
s
0 0 0 r
.5 Mabswid
.41559 .44692 m
.4358 .44037 L
s
.41559 .44692 m
.40364 .43478 L
s
.76051 .44642 m
.782 .43986 L
s
.76051 .44642 m
.75093 .43427 L
s
.46776 .44592 m
.48817 .43935 L
s
.46776 .44592 m
.45616 .43376 L
s
.723 .776 .283 r
.36411 .38005 m .37116 .3606 L .36493 .38078 L p F P
0 0 0 r
s
.723 .776 .283 r
.36493 .38078 m .35768 .40092 L .36411 .38005 L p F P
0 0 0 r
s
.17484 .44541 m
.19417 .43885 L
s
.17484 .44541 m
.16122 .43325 L
s
.81288 .44541 m
.83459 .43885 L
s
.81288 .44541 m
.80366 .43325 L
s
.525 0 0 r
.41877 .56823 m .41152 .56274 L p .42032 .5685 L F P
0 0 0 r
s
.525 0 0 r
.41152 .56274 m .40314 .55547 L .42032 .5685 L p F P
0 0 0 r
s
.525 0 0 r
.42032 .5685 m .42746 .57482 L .41877 .56823 L p F P
0 0 0 r
s
.51998 .44491 m
.5406 .43834 L
s
.51998 .44491 m
.50873 .43274 L
s
.66806 .52818 m .67663 .50971 L .6863 .49094 L p F P
s
0 0 .047 r
.69141 .4701 m .6863 .49094 L .67663 .50971 L p F P
0 0 0 r
s
.617 .151 0 r
.39092 .54062 m .37838 .52376 L .39186 .54016 L p F P
0 0 0 r
s
.617 .151 0 r
.39186 .54016 m .40314 .55547 L .39092 .54062 L p F P
0 0 0 r
s
.593 .929 .725 r
.42335 .30027 m .41634 .30634 L p .42405 .29759 L F P
0 0 0 r
s
.593 .929 .725 r
.41634 .30634 m .40725 .31214 L .42405 .29759 L p F P
0 0 0 r
s
.22691 .44441 m
.24644 .43783 L
s
.22691 .44441 m
.21364 .43223 L
s
.86532 .44441 m
.88723 .43783 L
s
.86532 .44441 m
.85645 .43223 L
s
.57227 .4439 m
.59309 .43732 L
s
.57227 .4439 m
.56137 .43172 L
s
0 0 .39 r
.68053 .36578 m .66967 .34813 L .65891 .32984 L p F P
0 0 0 r
s
0 .114 .66 r
.64561 .31623 m .65891 .32984 L .66967 .34813 L p F P
0 0 0 r
s
.27904 .4434 m
.29878 .43681 L
s
.27904 .4434 m
.26612 .43121 L
s
.90931 .43121 m
.91782 .4434 L
s
.711 .553 0 r
.35548 .44408 m .35448 .4222 L .35552 .44331 L p F P
0 0 0 r
s
.35331 .4379 m
.35528 .43984 L
s
.711 .553 0 r
.35552 .44331 m .35651 .46482 L .35548 .44408 L p F P
0 0 0 r
s
.35535 .43991 m
.36348 .44793 L
s
.62461 .44289 m
.64564 .43631 L
s
.62461 .44289 m
.61407 .43069 L
s
.33123 .44239 m
.35118 .4358 L
s
.33123 .44239 m
.31867 .43018 L
s
.67701 .44188 m
.66683 .42967 L
s
.38349 .44138 m
.40364 .43478 L
s
.38349 .44138 m
.37127 .42916 L
s
0 .274 .755 r
.62848 .30252 m .62198 .29618 L p .64561 .31623 L F P
0 0 0 r
s
.72948 .44087 m
.75093 .43427 L
s
.72948 .44087 m
.71965 .42864 L
s
.4358 .44037 m
.45616 .43376 L
s
.4358 .44037 m
.42394 .42813 L
s
0 .274 .755 r
.62198 .29618 m .63019 .30116 L .64561 .31623 L p F P
0 0 0 r
s
.528 .023 0 r
.65891 .32984 m .64561 .31623 L .63019 .30116 L p F P
0 0 0 r
s
.14195 .43986 m
.16122 .43325 L
s
.14195 .43986 m
.12806 .42762 L
s
.782 .43986 m
.80366 .43325 L
s
.782 .43986 m
.77254 .42762 L
s
0 0 .336 r
.371 .50596 m .36168 .48588 L .36961 .50497 L p F P
0 0 0 r
s
0 0 .336 r
.36961 .50497 m .37838 .52376 L .371 .50596 L p F P
0 0 0 r
s
0 0 1 r
2 Mabswid
.27512 .38305 m
.27278 .38543 L
s
.5 Mabswid
0 0 .353 r
.68053 .36578 m .68766 .38541 L .69215 .40639 L p F P
0 0 0 r
s
.765 .526 0 r
.69536 .42771 m .69215 .40639 L .68766 .38541 L p F P
0 0 0 r
s
.48817 .43935 m
.50873 .43274 L
s
.48817 .43935 m
.47667 .4271 L
s
.6248 .57241 m .61712 .57763 L p .64223 .55905 L F P
s
.38442 .34148 m .39431 .32533 L .38188 .34327 L p F P
s
.38188 .34327 m .37116 .3606 L .38442 .34148 L p F P
s
.19417 .43885 m
.21364 .43223 L
s
.19417 .43885 m
.18063 .42659 L
s
.83459 .43885 m
.85645 .43223 L
s
.83459 .43885 m
.82548 .42659 L
s
.593 .929 .725 r
.42405 .29759 m .43189 .29289 L .42335 .30027 L p F P
0 0 0 r
s
.5406 .43834 m
.56137 .43172 L
s
.5406 .43834 m
.52945 .42608 L
s
.24644 .43783 m
.26612 .43121 L
s
.24644 .43783 m
.23326 .42556 L
s
.88723 .43783 m
.90931 .43121 L
s
.88723 .43783 m
.87848 .42556 L
s
.59309 .43732 m
.61407 .43069 L
s
.59309 .43732 m
.5823 .42505 L
s
0 0 .052 r
.69536 .42771 m .69435 .44949 L .69141 .4701 L p F P
0 0 0 r
s
.794 .765 .253 r
.6863 .49094 m .69141 .4701 L .69435 .44949 L p F P
0 0 0 r
s
.69496 .43631 m
.69825 .43529 L
s
.67701 .44188 m
.6941 .43658 L
s
.29878 .43681 m
.31867 .43018 L
s
.29878 .43681 m
.28595 .42453 L
s
.64564 .43631 m
.66683 .42967 L
s
.64564 .43631 m
.63521 .42402 L
s
.41286 .30927 m .42405 .29759 L .40725 .31214 L p F P
s
.40725 .31214 m .39431 .32533 L .41286 .30927 L p F P
s
.35509 .43451 m
.37127 .42916 L
s
.35118 .4358 m
.35504 .43452 L
s
.35118 .4358 m
.33871 .4235 L
s
.69825 .43529 m
.71965 .42864 L
s
.69518 .43153 m
.69825 .43529 L
s
0 .201 .618 r
.63019 .30116 m .62198 .29618 L .61168 .28974 L p F P
0 0 0 r
s
.64223 .55905 m .63414 .56606 L .6248 .57241 L p F P
s
.66806 .52818 m .6558 .54462 L .64223 .55905 L p F P
s
.596 .898 .617 r
.63414 .56606 m .64223 .55905 L .6558 .54462 L p F P
0 0 0 r
s
.40364 .43478 m
.42394 .42813 L
s
.40364 .43478 m
.39152 .42247 L
s
.75093 .43427 m
.77254 .42762 L
s
.75093 .43427 m
.74121 .42195 L
s
0 0 .031 r
.36099 .40117 m .36411 .38005 L .35768 .40092 L p F P
0 0 0 r
s
0 0 .031 r
.35768 .40092 m .35448 .4222 L .36099 .40117 L p F P
0 0 0 r
s
.45616 .43376 m
.47667 .4271 L
s
.45616 .43376 m
.4444 .42143 L
s
.16122 .43325 m
.18063 .42659 L
s
.16122 .43325 m
.1474 .42092 L
s
.80366 .43325 m
.82548 .42659 L
s
.80366 .43325 m
.79431 .42092 L
s
.50873 .43274 m
.52945 .42608 L
s
.50873 .43274 m
.49733 .4204 L
s
.21364 .43223 m
.23326 .42556 L
s
.21364 .43223 m
.20018 .41988 L
s
.85645 .43223 m
.87848 .42556 L
s
.85645 .43223 m
.84746 .41988 L
s
.6863 .49094 m .67709 .51068 L .66806 .52818 L p F P
s
.753 .918 .551 r
.6558 .54462 m .66806 .52818 L .67709 .51068 L p F P
0 0 0 r
s
.4409 .28785 m .43189 .29289 L p .44565 .28552 L F P
s
.43189 .29289 m .42405 .29759 L .44565 .28552 L p F P
s
.56137 .43172 m
.5823 .42505 L
s
.56137 .43172 m
.55033 .41936 L
s
0 0 .324 r
.36074 .46603 m .35548 .44408 L .35651 .46482 L p F P
0 0 0 r
s
0 0 .324 r
.35651 .46482 m .36168 .48588 L .36074 .46603 L p F P
0 0 0 r
s
0 0 1 r
2 Mabswid
.77567 .49121 m
.77535 .48826 L
s
.5 Mabswid
0 0 .39 r
.65891 .32984 m .66907 .34629 L .68053 .36578 L p F P
0 0 0 r
s
.828 .449 0 r
.68766 .38541 m .68053 .36578 L .66907 .34629 L p F P
0 0 0 r
s
.26612 .43121 m
.28595 .42453 L
s
.26612 .43121 m
.25303 .41884 L
s
.90068 .41884 m
.90931 .43121 L
s
0 .143 .662 r
.40536 .55524 m .40022 .54898 L p .40314 .55547 L F P
0 0 0 r
s
0 .143 .662 r
.40022 .54898 m .39092 .54062 L .40314 .55547 L p F P
0 0 0 r
s
0 .143 .662 r
.40314 .55547 m .41152 .56274 L .40536 .55524 L p F P
0 0 0 r
s
.61407 .43069 m
.63521 .42402 L
s
.61407 .43069 m
.60339 .41832 L
s
.31867 .43018 m
.33871 .4235 L
s
.31867 .43018 m
.30593 .41781 L
s
.66683 .42967 m
.65651 .41729 L
s
.37127 .42916 m
.39152 .42247 L
s
0 .201 .618 r
.61168 .28974 m .6031 .28437 L p .63019 .30116 L F P
0 0 0 r
s
.71965 .42864 m
.74121 .42195 L
s
.71965 .42864 m
.70969 .41625 L
s
.42394 .42813 m
.4444 .42143 L
s
.42394 .42813 m
.41192 .41573 L
s
.925 .732 .245 r
.69435 .44949 m .69536 .42771 L .69082 .40656 L p F P
0 0 0 r
s
.765 .526 0 r
.68766 .38541 m .69082 .40656 L .69536 .42771 L p F P
0 0 0 r
s
.68818 .42298 m
.69262 .4284 L
s
.66683 .42967 m
.68818 .42298 L
s
.12806 .42762 m
.1474 .42092 L
s
.12806 .42762 m
.11397 .41521 L
s
.77254 .42762 m
.79431 .42092 L
s
.77254 .42762 m
.76294 .41521 L
s
0 .029 .599 r
.3843 .52452 m .371 .50596 L .37838 .52376 L p F P
0 0 0 r
s
0 .029 .599 r
.37838 .52376 m .39092 .54062 L .3843 .52452 L p F P
0 0 0 r
s
.44565 .28552 m .45184 .28173 L .4409 .28785 L p F P
s
.47667 .4271 m
.49733 .4204 L
s
.47667 .4271 m
.465 .41468 L
s
.18063 .42659 m
.20018 .41988 L
s
.18063 .42659 m
.1669 .41416 L
s
.82548 .42659 m
.84746 .41988 L
s
.82548 .42659 m
.81624 .41416 L
s
.596 .898 .617 r
.63981 .56003 m .63414 .56606 L p .6558 .54462 L F P
0 0 0 r
s
.787 .31 0 r
.66907 .34629 m .65891 .32984 L .64189 .31321 L p F P
0 0 0 r
s
.528 .023 0 r
.63019 .30116 m .64189 .31321 L .65891 .32984 L p F P
0 0 0 r
s
0 0 .006 r
.37791 .36025 m .38442 .34148 L .37116 .3606 L p F P
0 0 0 r
s
0 0 .006 r
.37116 .3606 m .36411 .38005 L .37791 .36025 L p F P
0 0 0 r
s
.52945 .42608 m
.55033 .41936 L
s
.52945 .42608 m
.51815 .41364 L
s
0 .201 .618 r
.6031 .28437 m .60975 .28838 L .63019 .30116 L p F P
0 0 0 r
s
.664 .116 0 r
.64189 .31321 m .63019 .30116 L .60975 .28838 L p F P
0 0 0 r
s
.23326 .42556 m
.25303 .41884 L
s
.23326 .42556 m
.21989 .41312 L
s
.87848 .42556 m
.90068 .41884 L
s
.87848 .42556 m
.86961 .41312 L
s
.904 .91 .51 r
.67709 .51068 m .6863 .49094 L .68909 .47121 L p F P
0 0 0 r
s
.794 .765 .253 r
.69435 .44949 m .68909 .47121 L .6863 .49094 L p F P
0 0 0 r
s
.5823 .42505 m
.60339 .41832 L
s
.5823 .42505 m
.57136 .4126 L
s
.28595 .42453 m
.30593 .41781 L
s
.28595 .42453 m
.27294 .41208 L
s
.444 0 0 r
.60975 .28838 m .6031 .28437 L .59073 .27942 L p F P
0 0 0 r
s
.63521 .42402 m
.65651 .41729 L
s
.63521 .42402 m
.62464 .41155 L
s
0 0 1 r
2 Mabswid
.27278 .38543 m
.27225 .38822 L
s
0 0 0 r
.5 Mabswid
.33871 .4235 m
.35428 .4183 L
s
.33871 .4235 m
.32606 .41103 L
s
.69395 .42118 m
.70969 .41625 L
s
.68818 .42298 m
.69207 .42177 L
s
.67797 .41051 m
.68818 .42298 L
s
.4368 .29593 m .44565 .28552 L .42405 .29759 L p F P
s
.42405 .29759 m .41286 .30927 L .4368 .29593 L p F P
s
.39152 .42247 m
.41192 .41573 L
s
.39152 .42247 m
.37923 .40998 L
s
0 0 .305 r
.36196 .42344 m .36099 .40117 L .35448 .4222 L p F P
0 0 0 r
s
.35428 .4183 m
.35584 .41778 L
s
0 0 .305 r
.35448 .4222 m .35548 .44408 L .36196 .42344 L p F P
0 0 0 r
s
.3618 .41968 m
.37127 .42916 L
s
.4043 .32434 m .41286 .30927 L .39431 .32533 L p F P
s
.39431 .32533 m .38442 .34148 L .4043 .32434 L p F P
s
.74121 .42195 m
.76294 .41521 L
s
.74121 .42195 m
.73137 .40946 L
s
.46245 .27799 m .45184 .28173 L p .47109 .27656 L F P
s
.45184 .28173 m .44565 .28552 L .47109 .27656 L p F P
s
.4444 .42143 m
.465 .41468 L
s
.4444 .42143 m
.43247 .40893 L
s
.1474 .42092 m
.1669 .41416 L
s
.1474 .42092 m
.1334 .40841 L
s
.79431 .42092 m
.81624 .41416 L
s
.79431 .42092 m
.78482 .40841 L
s
.49733 .4204 m
.51815 .41364 L
s
.49733 .4204 m
.48577 .40789 L
s
0 0 .551 r
.37022 .48748 m .36074 .46603 L .36168 .48588 L p F P
0 0 0 r
s
0 0 .551 r
.36168 .48588 m .371 .50596 L .37022 .48748 L p F P
0 0 0 r
s
.596 .898 .617 r
.6558 .54462 m .64671 .55268 L .63981 .56003 L p F P
0 0 0 r
s
.20018 .41988 m
.21989 .41312 L
s
.20018 .41988 m
.18654 .40736 L
s
.84746 .41988 m
.86961 .41312 L
s
.84746 .41988 m
.83835 .40736 L
s
.444 0 0 r
.59073 .27942 m .58044 .2753 L p .60975 .28838 L F P
0 0 0 r
s
.55033 .41936 m
.57136 .4126 L
s
.55033 .41936 m
.53913 .40683 L
s
.823 .994 .752 r
.64671 .55268 m .6558 .54462 L .66393 .52878 L p F P
0 0 0 r
s
.753 .918 .551 r
.67709 .51068 m .66393 .52878 L .6558 .54462 L p F P
0 0 0 r
s
.25303 .41884 m
.27294 .41208 L
s
.25303 .41884 m
.23974 .40631 L
s
.89193 .40631 m
.90068 .41884 L
s
.954 .636 .218 r
.69082 .40656 m .68766 .38541 L .67575 .36523 L p F P
0 0 0 r
s
.828 .449 0 r
.66907 .34629 m .67575 .36523 L .68766 .38541 L p F P
0 0 0 r
s
.60339 .41832 m
.62464 .41155 L
s
.60339 .41832 m
.59256 .40578 L
s
.47109 .27656 m .47531 .27346 L .46245 .27799 L p F P
s
.30593 .41781 m
.32606 .41103 L
s
.30593 .41781 m
.29301 .40526 L
s
.65651 .41729 m
.67797 .41051 L
s
.65651 .41729 m
.64604 .40473 L
s
.36163 .41585 m
.37923 .40998 L
s
.34634 .4042 m
.3568 .41468 L
s
.70969 .41625 m
.73137 .40946 L
s
.70969 .41625 m
.69959 .40368 L
s
.987 .846 .469 r
.68909 .47121 m .69435 .44949 L .68983 .42873 L p F P
0 0 0 r
s
.925 .732 .245 r
.69082 .40656 m .68983 .42873 L .69435 .44949 L p F P
0 0 0 r
s
.41192 .41573 m
.43247 .40893 L
s
.41192 .41573 m
.39973 .40315 L
s
0 0 1 r
2 Mabswid
.77414 .49381 m
.77567 .49121 L
s
.5 Mabswid
.444 0 0 r
.58044 .2753 m .5852 .27855 L .60975 .28838 L p F P
0 0 0 r
s
.452 0 0 r
.5852 .27855 m .58044 .2753 L .56658 .27211 L p F P
0 0 0 r
s
.11397 .41521 m
.1334 .40841 L
s
.11397 .41521 m
.09969 .40262 L
s
.76294 .41521 m
.78482 .40841 L
s
.76294 .41521 m
.7532 .40262 L
s
0 .262 .771 r
.39691 .54086 m .39414 .53408 L p .39092 .54062 L F P
0 0 0 r
s
0 .262 .771 r
.39414 .53408 m .3843 .52452 L .39092 .54062 L p F P
0 0 0 r
s
0 .262 .771 r
.39092 .54062 m .40022 .54898 L .39691 .54086 L p F P
0 0 0 r
s
.465 .41468 m
.48577 .40789 L
s
.465 .41468 m
.45318 .40209 L
s
.1669 .41416 m
.18654 .40736 L
s
.1669 .41416 m
.15298 .40156 L
s
.81624 .41416 m
.83835 .40736 L
s
.81624 .41416 m
.80688 .40156 L
s
.664 .116 0 r
.60975 .28838 m .61926 .29909 L .64189 .31321 L p F P
0 0 0 r
s
.685 .148 0 r
.61926 .29909 m .60975 .28838 L .5852 .27855 L p F P
0 0 0 r
s
.162 0 0 r
.48701 .27122 m .47531 .27346 L p .49917 .27119 L F P
0 0 0 r
s
.162 0 0 r
.47531 .27346 m .47109 .27656 L .49917 .27119 L p F P
0 0 0 r
s
.51815 .41364 m
.53913 .40683 L
s
.51815 .41364 m
.50669 .40103 L
s
.931 .967 .686 r
.66393 .52878 m .67709 .51068 L .67962 .49229 L p F P
0 0 0 r
s
.904 .91 .51 r
.68909 .47121 m .67962 .49229 L .67709 .51068 L p F P
0 0 0 r
s
0 0 .266 r
.37502 .38121 m .37791 .36025 L .36411 .38005 L p F P
0 0 0 r
s
0 0 .266 r
.36411 .38005 m .36099 .40117 L .37502 .38121 L p F P
0 0 0 r
s
.21989 .41312 m
.23974 .40631 L
s
.21989 .41312 m
.20633 .4005 L
s
.86961 .41312 m
.89193 .40631 L
s
.86961 .41312 m
.86062 .4005 L
s
.452 0 0 r
.56658 .27211 m .55508 .26946 L p .5852 .27855 L F P
0 0 0 r
s
.57136 .4126 m
.59256 .40578 L
s
.57136 .4126 m
.56027 .39998 L
s
.911 .506 .164 r
.67575 .36523 m .66907 .34629 L .65084 .32855 L p F P
0 0 0 r
s
.787 .31 0 r
.64189 .31321 m .65084 .32855 L .66907 .34629 L p F P
0 0 0 r
s
.27294 .41208 m
.29301 .40526 L
s
.27294 .41208 m
.25975 .39945 L
s
.823 .994 .752 r
.65009 .54608 m .64671 .55268 L p .66393 .52878 L F P
0 0 0 r
s
.162 0 0 r
.49917 .27119 m .50119 .26851 L .48701 .27122 L p F P
0 0 0 r
s
.62464 .41155 m
.64604 .40473 L
s
.62464 .41155 m
.61391 .39892 L
s
.21 0 0 r
.46506 .28601 m .47109 .27656 L .44565 .28552 L p F P
0 0 0 r
s
.21 0 0 r
.44565 .28552 m .4368 .29593 L .46506 .28601 L p F P
0 0 0 r
s
.32606 .41103 m
.34634 .4042 L
s
.32606 .41103 m
.31323 .39838 L
s
0 0 .502 r
.36709 .44629 m .36196 .42344 L .35548 .44408 L p F P
0 0 0 r
s
0 0 .502 r
.35548 .44408 m .36074 .46603 L .36709 .44629 L p F P
0 0 0 r
s
.823 .35 .072 r
.65084 .32855 m .64189 .31321 L .61926 .29909 L p F P
0 0 0 r
s
.452 0 0 r
.55508 .26946 m .55768 .27222 L .5852 .27855 L p F P
0 0 0 r
s
.402 0 0 r
.55768 .27222 m .55508 .26946 L .54039 .2682 L p F P
0 0 0 r
s
.37923 .40998 m
.39973 .40315 L
s
.73137 .40946 m
.7532 .40262 L
s
.73137 .40946 m
.72138 .39679 L
s
.307 0 0 r
.51342 .26789 m .50119 .26851 L p .52852 .26972 L F P
0 0 0 r
s
.307 0 0 r
.50119 .26851 m .49917 .27119 L .52852 .26972 L p F P
0 0 0 r
s
.402 0 0 r
.54039 .2682 m .52822 .26715 L p .55768 .27222 L F P
0 0 0 r
s
.43247 .40893 m
.45318 .40209 L
s
.43247 .40893 m
.42038 .39626 L
s
.307 0 0 r
.52852 .26972 m .52822 .26715 L .51342 .26789 L p F P
0 0 0 r
s
.008 .189 .702 r
.38372 .50783 m .37022 .48748 L .371 .50596 L p F P
0 0 0 r
s
.008 .189 .702 r
.371 .50596 m .3843 .52452 L .38372 .50783 L p F P
0 0 0 r
s
.1334 .40841 m
.15298 .40156 L
s
.1334 .40841 m
.1192 .39573 L
s
.78482 .40841 m
.80688 .40156 L
s
.78482 .40841 m
.77521 .39573 L
s
.402 0 0 r
.52822 .26715 m .52852 .26972 L .55768 .27222 L p F P
0 0 0 r
s
.48577 .40789 m
.50669 .40103 L
s
.48577 .40789 m
.47405 .3952 L
s
.079 0 .204 r
.39866 .34249 m .4043 .32434 L .38442 .34148 L p F P
0 0 0 r
s
.079 0 .204 r
.38442 .34148 m .37791 .36025 L .39866 .34249 L p F P
0 0 0 r
s
0 0 1 r
2 Mabswid
.27225 .38822 m
.27356 .39141 L
s
0 0 0 r
.5 Mabswid
.18654 .40736 m
.20633 .4005 L
s
.18654 .40736 m
.17271 .39466 L
s
.83835 .40736 m
.86062 .4005 L
s
.83835 .40736 m
.8291 .39466 L
s
.53913 .40683 m
.56027 .39998 L
s
.53913 .40683 m
.52778 .39413 L
s
.173 0 .107 r
.43002 .31008 m .4368 .29593 L .41286 .30927 L p F P
0 0 0 r
s
.173 0 .107 r
.41286 .30927 m .4043 .32434 L .43002 .31008 L p F P
0 0 0 r
s
.992 .741 .421 r
.68983 .42873 m .69082 .40656 L .67871 .38623 L p F P
0 0 0 r
s
.67797 .41051 m
.68452 .40844 L
s
.954 .636 .218 r
.67575 .36523 m .67871 .38623 L .69082 .40656 L p F P
0 0 0 r
s
.69079 .40646 m
.69959 .40368 L
s
.69076 .40647 m
.69079 .40646 L
s
.66761 .39785 m
.67797 .41051 L
s
.23974 .40631 m
.25975 .39945 L
s
.23974 .40631 m
.22628 .3936 L
s
.88306 .3936 m
.89193 .40631 L
s
.59256 .40578 m
.61391 .39892 L
s
.59256 .40578 m
.58157 .39306 L
s
.29301 .40526 m
.31323 .39838 L
s
.29301 .40526 m
.27991 .39253 L
s
.685 .148 0 r
.5852 .27855 m .592 .28822 L .61926 .29909 L p F P
0 0 0 r
s
.648 .136 .013 r
.592 .28822 m .5852 .27855 L .55768 .27222 L p F P
0 0 0 r
s
.823 .994 .752 r
.66393 .52878 m .65419 .53803 L .65009 .54608 L p F P
0 0 0 r
s
.987 .895 .622 r
.67962 .49229 m .68909 .47121 L .68465 .45135 L p F P
0 0 0 r
s
.987 .846 .469 r
.68983 .42873 m .68465 .45135 L .68909 .47121 L p F P
0 0 0 r
s
.64604 .40473 m
.66761 .39785 L
s
.64604 .40473 m
.63543 .392 L
s
.34634 .4042 m
.3336 .39146 L
s
.69959 .40368 m
.72138 .39679 L
s
.39973 .40315 m
.42038 .39626 L
s
.39973 .40315 m
.38736 .39039 L
s
.378 0 .029 r
.49629 .28007 m .49917 .27119 L .47109 .27656 L p F P
0 0 0 r
s
.378 0 .029 r
.47109 .27656 m .46506 .28601 L .49629 .28007 L p F P
0 0 0 r
s
.09969 .40262 m
.1192 .39573 L
s
.09969 .40262 m
.0852 .38986 L
s
.7532 .40262 m
.77521 .39573 L
s
.7532 .40262 m
.74333 .38986 L
s
.912 .97 .794 r
.65419 .53803 m .66393 .52878 L .66612 .51218 L p F P
0 0 0 r
s
.931 .967 .686 r
.67962 .49229 m .66612 .51218 L .66393 .52878 L p F P
0 0 0 r
s
.45318 .40209 m
.47405 .3952 L
s
.45318 .40209 m
.44119 .38932 L
s
.15298 .40156 m
.17271 .39466 L
s
.15298 .40156 m
.13886 .38878 L
s
.80688 .40156 m
.8291 .39466 L
s
.80688 .40156 m
.79738 .38878 L
s
.096 .001 .447 r
.37592 .40384 m .37502 .38121 L .36099 .40117 L p F P
0 0 0 r
s
.36165 .39905 m
.36274 .39868 L
s
.37261 .40325 m
.37923 .40998 L
s
.096 .001 .447 r
.36099 .40117 m .36196 .42344 L .37592 .40384 L p F P
0 0 0 r
s
.34634 .4042 m
.36165 .39905 L
s
.50669 .40103 m
.52778 .39413 L
s
.50669 .40103 m
.49507 .38825 L
s
.20633 .4005 m
.22628 .3936 L
s
.20633 .4005 m
.19259 .38771 L
s
.86062 .4005 m
.88306 .3936 L
s
.86062 .4005 m
.85149 .38771 L
s
.56027 .39998 m
.58157 .39306 L
s
.56027 .39998 m
.54902 .38717 L
s
0 0 1 r
2 Mabswid
.77074 .49602 m
.77414 .49381 L
s
0 0 0 r
.5 Mabswid
.25975 .39945 m
.27991 .39253 L
s
.25975 .39945 m
.24637 .38664 L
s
.107 .159 .634 r
.37629 .46911 m .36709 .44629 L .36074 .46603 L p F P
0 0 0 r
s
.107 .159 .634 r
.36074 .46603 m .37022 .48748 L .37629 .46911 L p F P
0 0 0 r
s
.648 .136 .013 r
.55768 .27222 m .5614 .28121 L .592 .28822 L p F P
0 0 0 r
s
.584 .094 .058 r
.5614 .28121 m .55768 .27222 L .52852 .26972 L p F P
0 0 0 r
s
.95 .62 .362 r
.67871 .38623 m .67575 .36523 L .65674 .34685 L p F P
0 0 0 r
s
.911 .506 .164 r
.65084 .32855 m .65674 .34685 L .67575 .36523 L p F P
0 0 0 r
s
.61391 .39892 m
.63543 .392 L
s
.61391 .39892 m
.60303 .3861 L
s
.31323 .39838 m
.3336 .39146 L
s
.31323 .39838 m
.30022 .38556 L
s
.496 .024 .063 r
.52895 .27844 m .52852 .26972 L .49917 .27119 L p F P
0 0 0 r
s
.496 .024 .063 r
.49917 .27119 m .49629 .28007 L .52895 .27844 L p F P
0 0 0 r
s
.173 .345 .796 r
.3939 .52568 m .39369 .51867 L p .3843 .52452 L F P
0 0 0 r
s
.173 .345 .796 r
.39369 .51867 m .38372 .50783 L .3843 .52452 L p F P
0 0 0 r
s
.173 .345 .796 r
.3843 .52452 m .39414 .53408 L .3939 .52568 L p F P
0 0 0 r
s
.37555 .39437 m
.38736 .39039 L
s
.35414 .38448 m
.36498 .3955 L
s
.823 .35 .072 r
.61926 .29909 m .62654 .31346 L .65084 .32855 L p F P
0 0 0 r
s
.787 .339 .183 r
.62654 .31346 m .61926 .29909 L .592 .28822 L p F P
0 0 0 r
s
.72138 .39679 m
.74333 .38986 L
s
.72138 .39679 m
.71125 .38395 L
s
.584 .094 .058 r
.52852 .26972 m .52895 .27844 L .5614 .28121 L p F P
0 0 0 r
s
.42038 .39626 m
.44119 .38932 L
s
.42038 .39626 m
.40811 .38341 L
s
.912 .97 .794 r
.65507 .53111 m .65419 .53803 L p .66612 .51218 L F P
0 0 0 r
s
.1192 .39573 m
.13886 .38878 L
s
.1192 .39573 m
.1048 .38287 L
s
.77521 .39573 m
.79738 .38878 L
s
.77521 .39573 m
.76546 .38287 L
s
.881 .49 .288 r
.65674 .34685 m .65084 .32855 L .62654 .31346 L p F P
0 0 0 r
s
.47405 .3952 m
.49507 .38825 L
s
.47405 .3952 m
.46215 .38233 L
s
.987 .794 .558 r
.68465 .45135 m .68983 .42873 L .67778 .40877 L p F P
0 0 0 r
s
.992 .741 .421 r
.67871 .38623 m .67778 .40877 L .68983 .42873 L p F P
0 0 0 r
s
.66761 .39785 m
.67837 .39442 L
s
.68276 .39303 m
.68935 .39093 L
s
.68935 .39093 m
.69959 .40368 L
s
.17271 .39466 m
.19259 .38771 L
s
.17271 .39466 m
.15867 .38179 L
s
.8291 .39466 m
.85149 .38771 L
s
.8291 .39466 m
.81972 .38179 L
s
.96 .908 .722 r
.66612 .51218 m .67962 .49229 L .67533 .47382 L p F P
0 0 0 r
s
.987 .895 .622 r
.68465 .45135 m .67533 .47382 L .67962 .49229 L p F P
0 0 0 r
s
.52778 .39413 m
.54902 .38717 L
s
.52778 .39413 m
.51626 .38125 L
s
.364 0 .202 r
.46043 .29948 m .46506 .28601 L .4368 .29593 L p F P
0 0 0 r
s
.364 0 .202 r
.4368 .29593 m .43002 .31008 L .46043 .29948 L p F P
0 0 0 r
s
.217 .02 .385 r
.39616 .36331 m .39866 .34249 L .37791 .36025 L p F P
0 0 0 r
s
.217 .02 .385 r
.37791 .36025 m .37502 .38121 L .39616 .36331 L p F P
0 0 0 r
s
.22628 .3936 m
.24637 .38664 L
s
.22628 .3936 m
.21262 .38071 L
s
.87406 .38071 m
.88306 .3936 L
s
.58157 .39306 m
.60303 .3861 L
s
.58157 .39306 m
.57043 .38016 L
s
.27991 .39253 m
.30022 .38556 L
s
.27991 .39253 m
.26662 .37962 L
s
.63543 .392 m
.62466 .37908 L
s
.3336 .39146 m
.35414 .38448 L
s
.3336 .39146 m
.32069 .37854 L
s
0 0 1 r
2 Mabswid
.27356 .39141 m
.27677 .39499 L
s
.5 Mabswid
.306 .023 .309 r
.42555 .3277 m .43002 .31008 L .4043 .32434 L p F P
0 0 0 r
s
.306 .023 .309 r
.4043 .32434 m .39866 .34249 L .42555 .3277 L p F P
0 0 0 r
s
.68935 .39093 m
.71125 .38395 L
s
.67896 .378 m
.68935 .39093 L
s
.38736 .39039 m
.40811 .38341 L
s
.0852 .38986 m
.1048 .38287 L
s
.0852 .38986 m
.07051 .37691 L
s
.74333 .38986 m
.76546 .38287 L
s
.74333 .38986 m
.73332 .37691 L
s
.215 .154 .569 r
.38066 .42756 m .37592 .40384 L .36196 .42344 L p F P
0 0 0 r
s
.215 .154 .569 r
.36196 .42344 m .36709 .44629 L .38066 .42756 L p F P
0 0 0 r
s
.44119 .38932 m
.46215 .38233 L
s
.44119 .38932 m
.42902 .37637 L
s
.228 .294 .724 r
.38938 .49129 m .37629 .46911 L .37022 .48748 L p F P
0 0 0 r
s
.228 .294 .724 r
.37022 .48748 m .38372 .50783 L .38938 .49129 L p F P
0 0 0 r
s
.13886 .38878 m
.15867 .38179 L
s
.13886 .38878 m
.12454 .37582 L
s
.79738 .38878 m
.81972 .38179 L
s
.79738 .38878 m
.78775 .37582 L
s
.912 .97 .794 r
.66612 .51218 m .65613 .52268 L .65507 .53111 L p F P
0 0 0 r
s
.49507 .38825 m
.51626 .38125 L
s
.49507 .38825 m
.48329 .37528 L
s
.19259 .38771 m
.21262 .38071 L
s
.19259 .38771 m
.17864 .37474 L
s
.85149 .38771 m
.87406 .38071 L
s
.85149 .38771 m
.84224 .37474 L
s
.54902 .38717 m
.57043 .38016 L
s
.54902 .38717 m
.53761 .37419 L
s
.787 .339 .183 r
.592 .28822 m .59722 .30184 L .62654 .31346 L p F P
0 0 0 r
s
.73 .306 .241 r
.59722 .30184 m .592 .28822 L .5614 .28121 L p F P
0 0 0 r
s
.24637 .38664 m
.26662 .37962 L
s
.24637 .38664 m
.2328 .37365 L
s
.951 .684 .495 r
.67778 .40877 m .67871 .38623 L .65935 .3677 L p F P
0 0 0 r
s
.95 .62 .362 r
.65674 .34685 m .65935 .3677 L .67871 .38623 L p F P
0 0 0 r
s
.65711 .38502 m
.66761 .39785 L
s
.63543 .392 m
.65711 .38502 L
s
.60303 .3861 m
.62466 .37908 L
s
.60303 .3861 m
.592 .3731 L
s
.30022 .38556 m
.32069 .37854 L
s
.30022 .38556 m
.28703 .37255 L
s
.67233 .38013 m
.67896 .378 L
s
.65711 .38502 m
.66586 .38221 L
s
.64646 .37201 m
.65711 .38502 L
s
.492 .114 .251 r
.49408 .29312 m .49629 .28007 L .46506 .28601 L p F P
0 0 0 r
s
.492 .114 .251 r
.46506 .28601 m .46043 .29948 L .49408 .29312 L p F P
0 0 0 r
s
.35414 .38448 m
.37483 .37745 L
s
.35414 .38448 m
.34132 .37146 L
s
.921 .903 .79 r
.65613 .52268 m .66612 .51218 L .66207 .49552 L p F P
0 0 0 r
s
.96 .908 .722 r
.67533 .47382 m .66207 .49552 L .66612 .51218 L p F P
0 0 0 r
s
.964 .82 .653 r
.67533 .47382 m .68465 .45135 L .67293 .43227 L p F P
0 0 0 r
s
.987 .794 .558 r
.67778 .40877 m .67293 .43227 L .68465 .45135 L p F P
0 0 0 r
s
.71125 .38395 m
.73332 .37691 L
s
.71125 .38395 m
.70098 .37092 L
s
0 0 1 r
2 Mabswid
.76544 .49782 m
.77074 .49602 L
s
0 0 0 r
.5 Mabswid
.40811 .38341 m
.42902 .37637 L
s
.1048 .38287 m
.12454 .37582 L
s
.1048 .38287 m
.09019 .36982 L
s
.76546 .38287 m
.78775 .37582 L
s
.76546 .38287 m
.75556 .36982 L
s
.46215 .38233 m
.48329 .37528 L
s
.46215 .38233 m
.45009 .36927 L
s
.15867 .38179 m
.17864 .37474 L
s
.15867 .38179 m
.14444 .36873 L
s
.81972 .38179 m
.84224 .37474 L
s
.81972 .38179 m
.81021 .36873 L
s
.51626 .38125 m
.53761 .37419 L
s
.51626 .38125 m
.50458 .36818 L
s
.311 .159 .507 r
.39694 .38627 m .39616 .36331 L .37502 .38121 L p F P
0 0 0 r
s
.37946 .38223 m
.38736 .39039 L
s
.37647 .37915 m
.37691 .37961 L
s
.37483 .37745 m
.37647 .37915 L
s
.311 .159 .507 r
.37502 .38121 m .37592 .40384 L .39694 .38627 L p F P
0 0 0 r
s
.39643 .37116 m
.40811 .38341 L
s
.895 .573 .43 r
.65935 .3677 m .65674 .34685 L .63134 .33121 L p F P
0 0 0 r
s
.881 .49 .288 r
.62654 .31346 m .63134 .33121 L .65674 .34685 L p F P
0 0 0 r
s
.824 .453 .352 r
.63134 .33121 m .62654 .31346 L .59722 .30184 L p F P
0 0 0 r
s
.21262 .38071 m
.2328 .37365 L
s
.21262 .38071 m
.19876 .36763 L
s
.86493 .36763 m
.87406 .38071 L
s
.57043 .38016 m
.592 .3731 L
s
.57043 .38016 m
.55913 .36708 L
s
.73 .306 .241 r
.5614 .28121 m .56425 .29434 L .59722 .30184 L p F P
0 0 0 r
s
.664 .259 .267 r
.56425 .29434 m .5614 .28121 L .52895 .27844 L p F P
0 0 0 r
s
.323 .4 .787 r
.39661 .51035 m .39904 .5034 L p .38372 .50783 L F P
0 0 0 r
s
.323 .4 .787 r
.39904 .5034 m .38938 .49129 L .38372 .50783 L p F P
0 0 0 r
s
.323 .4 .787 r
.38372 .50783 m .39369 .51867 L .39661 .51035 L p F P
0 0 0 r
s
.26662 .37962 m
.28703 .37255 L
s
.26662 .37962 m
.25315 .36653 L
s
.921 .903 .79 r
.6544 .51575 m .65613 .52268 L p .66207 .49552 L F P
0 0 0 r
s
.62466 .37908 m
.64646 .37201 L
s
.62466 .37908 m
.61374 .36598 L
s
.587 .197 .27 r
.52929 .29137 m .52895 .27844 L .49629 .28007 L p F P
0 0 0 r
s
.587 .197 .27 r
.49629 .28007 m .49408 .29312 L .52929 .29137 L p F P
0 0 0 r
s
.303 .27 .656 r
.38915 .45172 m .38066 .42756 L .36709 .44629 L p F P
0 0 0 r
s
.303 .27 .656 r
.36709 .44629 m .37629 .46911 L .38915 .45172 L p F P
0 0 0 r
s
.32069 .37854 m
.34132 .37146 L
s
.32069 .37854 m
.30759 .36543 L
s
.67896 .378 m
.70098 .37092 L
s
.451 .15 .363 r
.45738 .3167 m .46043 .29948 L .43002 .31008 L p F P
0 0 0 r
s
.451 .15 .363 r
.43002 .31008 m .42555 .3277 L .45738 .3167 L p F P
0 0 0 r
s
.664 .259 .267 r
.52895 .27844 m .52929 .29137 L .56425 .29434 L p F P
0 0 0 r
s
.37483 .37745 m
.38256 .37482 L
s
.37483 .37745 m
.36211 .36433 L
s
.07051 .37691 m
.09019 .36982 L
s
.07051 .37691 m
.05561 .36378 L
s
.73332 .37691 m
.75556 .36982 L
s
.73332 .37691 m
.72317 .36378 L
s
.39 .161 .441 r
.42357 .34839 m .42555 .3277 L .39866 .34249 L p F P
0 0 0 r
s
.39 .161 .441 r
.39866 .34249 m .39616 .36331 L .42357 .34839 L p F P
0 0 0 r
s
.42902 .37637 m
.45009 .36927 L
s
.12454 .37582 m
.14444 .36873 L
s
.12454 .37582 m
.11002 .36268 L
s
.78775 .37582 m
.81021 .36873 L
s
.78775 .37582 m
.77798 .36268 L
s
0 0 1 r
2 Mabswid
.27677 .39499 m
.2819 .39893 L
s
0 0 0 r
.5 Mabswid
.48329 .37528 m
.50458 .36818 L
s
.48329 .37528 m
.47133 .36213 L
s
.17864 .37474 m
.19876 .36763 L
s
.17864 .37474 m
.1645 .36157 L
s
.84224 .37474 m
.86493 .36763 L
s
.84224 .37474 m
.83285 .36157 L
s
.933 .831 .722 r
.66207 .49552 m .67533 .47382 L .66421 .45609 L p F P
0 0 0 r
s
.964 .82 .653 r
.67293 .43227 m .66421 .45609 L .67533 .47382 L p F P
0 0 0 r
s
.937 .723 .589 r
.67293 .43227 m .67778 .40877 L .65854 .39058 L p F P
0 0 0 r
s
.951 .684 .495 r
.65935 .3677 m .65854 .39058 L .67778 .40877 L p F P
0 0 0 r
s
.66842 .36488 m
.67896 .378 L
s
.53761 .37419 m
.55913 .36708 L
s
.53761 .37419 m
.52604 .36102 L
s
.2328 .37365 m
.25315 .36653 L
s
.2328 .37365 m
.21904 .36047 L
s
.592 .3731 m
.61374 .36598 L
s
.592 .3731 m
.58081 .35991 L
s
.28703 .37255 m
.30759 .36543 L
s
.28703 .37255 m
.27365 .35936 L
s
.65945 .36779 m
.66842 .36488 L
s
.64646 .37201 m
.65935 .36783 L
s
.921 .903 .79 r
.66207 .49552 m .65229 .50731 L .6544 .51575 L p F P
0 0 0 r
s
.34132 .37146 m
.36211 .36433 L
s
.34132 .37146 m
.32832 .35825 L
s
.70098 .37092 m
.72317 .36378 L
s
.70098 .37092 m
.69056 .3577 L
s
.38306 .35714 m
.39217 .36669 L
s
.09019 .36982 m
.11002 .36268 L
s
.09019 .36982 m
.07537 .35659 L
s
.75556 .36982 m
.77798 .36268 L
s
.75556 .36982 m
.74553 .35659 L
s
.372 .363 .719 r
.40122 .47564 m .38915 .45172 L .37629 .46911 L p F P
0 0 0 r
s
.372 .363 .719 r
.37629 .46911 m .38938 .49129 L .40122 .47564 L p F P
0 0 0 r
s
.379 .262 .593 r
.40104 .41077 m .39694 .38627 L .37592 .40384 L p F P
0 0 0 r
s
.379 .262 .593 r
.37592 .40384 m .38066 .42756 L .40104 .41077 L p F P
0 0 0 r
s
.824 .453 .352 r
.59722 .30184 m .60066 .31915 L .63134 .33121 L p F P
0 0 0 r
s
.763 .41 .385 r
.60066 .31915 m .59722 .30184 L .56425 .29434 L p F P
0 0 0 r
s
.45009 .36927 m
.47133 .36213 L
s
.45009 .36927 m
.43786 .35603 L
s
.14444 .36873 m
.1645 .36157 L
s
.14444 .36873 m
.13001 .35548 L
s
.81021 .36873 m
.83285 .36157 L
s
.81021 .36873 m
.80057 .35548 L
s
.50458 .36818 m
.52604 .36102 L
s
.50458 .36818 m
.49273 .35492 L
s
.892 .625 .528 r
.65854 .39058 m .65935 .3677 L .63347 .35193 L p F P
0 0 0 r
s
.895 .573 .43 r
.63134 .33121 m .63347 .35193 L .65935 .3677 L p F P
0 0 0 r
s
.63565 .35881 m
.64646 .37201 L
s
.19876 .36763 m
.21904 .36047 L
s
.19876 .36763 m
.18471 .35436 L
s
.85567 .35436 m
.86493 .36763 L
s
0 0 1 r
2 Mabswid
.75916 .499 m
.76544 .49782 L
s
.5 Mabswid
.553 .239 .39 r
.49262 .3101 m .49408 .29312 L .46043 .29948 L p F P
0 0 0 r
s
.553 .239 .39 r
.46043 .29948 m .45738 .3167 L .49262 .3101 L p F P
0 0 0 r
s
.55913 .36708 m
.58081 .35991 L
s
.55913 .36708 m
.54766 .35381 L
s
.25315 .36653 m
.27365 .35936 L
s
.25315 .36653 m
.23947 .35325 L
s
.898 .834 .774 r
.65229 .50731 m .66207 .49552 L .65181 .47957 L p F P
0 0 0 r
s
.933 .831 .722 r
.66421 .45609 m .65181 .47957 L .66207 .49552 L p F P
0 0 0 r
s
.61374 .36598 m
.63565 .35881 L
s
.61374 .36598 m
.60267 .35269 L
s
.835 .524 .464 r
.63347 .35193 m .63134 .33121 L .60066 .31915 L p F P
0 0 0 r
s
.30759 .36543 m
.32832 .35825 L
s
.30759 .36543 m
.29431 .35214 L
s
.66842 .36488 m
.69056 .3577 L
s
.916 .747 .658 r
.66421 .45609 m .67293 .43227 L .65425 .41489 L p F P
0 0 0 r
s
.937 .723 .589 r
.65854 .39058 m .65425 .41489 L .67293 .43227 L p F P
0 0 0 r
s
.36211 .36433 m
.38306 .35714 L
s
.36211 .36433 m
.34921 .35102 L
s
.05561 .36378 m
.07537 .35659 L
s
.05561 .36378 m
.04049 .35046 L
s
.72317 .36378 m
.74553 .35659 L
s
.72317 .36378 m
.71287 .35046 L
s
.447 .26 .533 r
.42419 .37163 m .42357 .34839 L .39616 .36331 L p F P
0 0 0 r
s
.39639 .37012 m
.40699 .36652 L
s
.42418 .37121 m
.42902 .37637 L
s
.447 .26 .533 r
.39616 .36331 m .39694 .38627 L .42419 .37163 L p F P
0 0 0 r
s
.4239 .36078 m
.43786 .35603 L
s
.40417 .3499 m
.40979 .35589 L
s
.898 .834 .774 r
.64796 .50068 m .65229 .50731 L p .65181 .47957 L F P
0 0 0 r
s
.11002 .36268 m
.13001 .35548 L
s
.11002 .36268 m
.09529 .34934 L
s
.77798 .36268 m
.80057 .35548 L
s
.77798 .36268 m
.76807 .34934 L
s
.763 .41 .385 r
.56425 .29434 m .56614 .31136 L .60066 .31915 L p F P
0 0 0 r
s
.701 .362 .399 r
.56614 .31136 m .56425 .29434 L .52929 .29137 L p F P
0 0 0 r
s
.47133 .36213 m
.49273 .35492 L
s
.47133 .36213 m
.4592 .34878 L
s
.505 .255 .47 r
.45603 .33729 m .45738 .3167 L .42555 .3277 L p F P
0 0 0 r
s
.505 .255 .47 r
.42555 .3277 m .42357 .34839 L .45603 .33729 L p F P
0 0 0 r
s
.427 .439 .769 r
.40507 .49554 m .41011 .48898 L p .38938 .49129 L F P
0 0 0 r
s
.427 .439 .769 r
.41011 .48898 m .40122 .47564 L .38938 .49129 L p F P
0 0 0 r
s
.427 .439 .769 r
.38938 .49129 m .39904 .5034 L .40507 .49554 L p F P
0 0 0 r
s
.1645 .36157 m
.18471 .35436 L
s
.1645 .36157 m
.15015 .34822 L
s
.83285 .36157 m
.85567 .35436 L
s
.83285 .36157 m
.82333 .34822 L
s
.633 .307 .401 r
.5295 .30828 m .52929 .29137 L .49408 .29312 L p F P
0 0 0 r
s
.633 .307 .401 r
.49408 .29312 m .49262 .3101 L .5295 .30828 L p F P
0 0 0 r
s
.52604 .36102 m
.54766 .35381 L
s
.52604 .36102 m
.5143 .34766 L
s
.21904 .36047 m
.23947 .35325 L
s
.21904 .36047 m
.20508 .3471 L
s
.58081 .35991 m
.60267 .35269 L
s
.58081 .35991 m
.56946 .34654 L
s
.43 .344 .658 r
.4084 .43614 m .40104 .41077 L .38066 .42756 L p F P
0 0 0 r
s
.43 .344 .658 r
.38066 .42756 m .38915 .45172 L .4084 .43614 L p F P
0 0 0 r
s
.701 .362 .399 r
.52929 .29137 m .5295 .30828 L .56614 .31136 L p F P
0 0 0 r
s
0 0 1 r
2 Mabswid
.2819 .39893 m
.28896 .40322 L
s
0 0 0 r
.5 Mabswid
.27365 .35936 m
.29431 .35214 L
s
.27365 .35936 m
.26007 .34598 L
s
.63565 .35881 m
.63753 .35819 L
s
.32832 .35825 m
.34921 .35102 L
s
.32832 .35825 m
.31513 .34485 L
s
.69056 .3577 m
.71287 .35046 L
s
.69056 .3577 m
.67999 .34429 L
s
.38306 .35714 m
.40417 .3499 L
s
.38306 .35714 m
.37026 .34373 L
s
.07537 .35659 m
.09529 .34934 L
s
.07537 .35659 m
.06034 .34316 L
s
.74553 .35659 m
.76807 .34934 L
s
.74553 .35659 m
.73535 .34316 L
s
.881 .661 .6 r
.65425 .41489 m .65854 .39058 L .6328 .3751 L p F P
0 0 0 r
s
.892 .625 .528 r
.63347 .35193 m .6328 .3751 L .65854 .39058 L p F P
0 0 0 r
s
.64158 .35687 m
.65773 .35158 L
s
.65773 .35158 m
.66842 .36488 L
s
.43786 .35603 m
.4592 .34878 L
s
.892 .763 .712 r
.65181 .47957 m .66421 .45609 L .64656 .43996 L p F P
0 0 0 r
s
.916 .747 .658 r
.65425 .41489 m .64656 .43996 L .66421 .45609 L p F P
0 0 0 r
s
.898 .834 .774 r
.65181 .47957 m .64268 .4926 L .64796 .50068 L p F P
0 0 0 r
s
.13001 .35548 m
.15015 .34822 L
s
.13001 .35548 m
.11536 .34204 L
s
.80057 .35548 m
.82333 .34822 L
s
.80057 .35548 m
.79078 .34204 L
s
.49273 .35492 m
.5143 .34766 L
s
.49273 .35492 m
.48071 .34147 L
s
.84628 .34091 m
.85567 .35436 L
s
.18471 .35436 m
.20508 .3471 L
s
.18471 .35436 m
.17045 .34091 L
s
.54766 .35381 m
.56946 .34654 L
s
.54766 .35381 m
.53603 .34034 L
s
.835 .524 .464 r
.60066 .31915 m .60218 .33976 L .63347 .35193 L p F P
0 0 0 r
s
.776 .477 .481 r
.60218 .33976 m .60066 .31915 L .56614 .31136 L p F P
0 0 0 r
s
.23947 .35325 m
.26007 .34598 L
s
.23947 .35325 m
.22561 .33978 L
s
.29431 .35214 m
.31513 .34485 L
s
.29431 .35214 m
.28083 .33865 L
s
.834 .573 .544 r
.6328 .3751 m .63347 .35193 L .60218 .33976 L p F P
0 0 0 r
s
.60267 .35269 m
.611 .34994 L
s
.62038 .34684 m
.62469 .34542 L
s
.62469 .34542 m
.62659 .34773 L
s
.62659 .34773 m
.62841 .34996 L
s
.487 .336 .602 r
.42744 .39679 m .42419 .37163 L .39694 .38627 L p F P
0 0 0 r
s
.487 .336 .602 r
.39694 .38627 m .40104 .41077 L .42744 .39679 L p F P
0 0 0 r
s
.65773 .35158 m
.67999 .34429 L
s
.65773 .35158 m
.64689 .33808 L
s
.589 .325 .484 r
.49198 .33062 m .49262 .3101 L .45738 .3167 L p F P
0 0 0 r
s
.589 .325 .484 r
.45738 .3167 m .45603 .33729 L .49198 .33062 L p F P
0 0 0 r
s
.47 .412 .71 r
.41884 .46166 m .4084 .43614 L .38915 .45172 L p F P
0 0 0 r
s
.47 .412 .71 r
.38915 .45172 m .40122 .47564 L .41884 .46166 L p F P
0 0 0 r
s
.34921 .35102 m
.37026 .34373 L
s
.34921 .35102 m
.33612 .33751 L
s
.04049 .35046 m
.06034 .34316 L
s
.71287 .35046 m
.73535 .34316 L
s
.71287 .35046 m
.70242 .33695 L
s
.39147 .33638 m
.40417 .3499 L
s
.866 .773 .757 r
.64268 .4926 m .65181 .47957 L .63564 .46508 L p F P
0 0 0 r
s
.892 .763 .712 r
.64656 .43996 m .63564 .46508 L .65181 .47957 L p F P
0 0 0 r
s
.09529 .34934 m
.11536 .34204 L
s
.09529 .34934 m
.08034 .33581 L
s
.76807 .34934 m
.79078 .34204 L
s
.76807 .34934 m
.75801 .33581 L
s
.4592 .34878 m
.48071 .34147 L
s
.54 .332 .546 r
.45645 .36073 m .45603 .33729 L .42357 .34839 L p F P
0 0 0 r
s
.4469 .33524 m
.45048 .33919 L
s
.43464 .35255 m
.43786 .35603 L
s
.42838 .34577 m
.42906 .34651 L
s
.42545 .3426 m
.42838 .34577 L
s
.54 .332 .546 r
.42357 .34839 m .42419 .37163 L .45645 .36073 L p F P
0 0 0 r
s
.40417 .3499 m
.42545 .3426 L
s
.45618 .34545 m
.4592 .34878 L
s
.15015 .34822 m
.17045 .34091 L
s
.15015 .34822 m
.13559 .33467 L
s
.82333 .34822 m
.84628 .34091 L
s
.82333 .34822 m
.81367 .33467 L
s
.5143 .34766 m
.53603 .34034 L
s
.5143 .34766 m
.50239 .33411 L
s
.20508 .3471 m
.22561 .33978 L
s
.20508 .3471 m
.19091 .33354 L
s
.866 .773 .757 r
.63588 .48659 m .64268 .4926 L p .63564 .46508 L F P
0 0 0 r
s
.867 .687 .656 r
.64656 .43996 m .65425 .41489 L .62931 .40011 L p F P
0 0 0 r
s
.881 .661 .6 r
.6328 .3751 m .62931 .40011 L .65425 .41489 L p F P
0 0 0 r
s
.776 .477 .481 r
.56614 .31136 m .56698 .3319 L .60218 .33976 L p F P
0 0 0 r
s
.718 .431 .489 r
.56698 .3319 m .56614 .31136 L .5295 .30828 L p F P
0 0 0 r
s
.26007 .34598 m
.28083 .33865 L
s
.26007 .34598 m
.2463 .3324 L
s
.504 .471 .753 r
.41906 .48196 m .42652 .47611 L p .40122 .47564 L F P
0 0 0 r
s
.504 .471 .753 r
.42652 .47611 m .41884 .46166 L .40122 .47564 L p F P
0 0 0 r
s
.504 .471 .753 r
.40122 .47564 m .41011 .48898 L .41906 .48196 L p F P
0 0 0 r
s
.31513 .34485 m
.33612 .33751 L
s
.31513 .34485 m
.30175 .33126 L
s
.658 .381 .49 r
.5296 .32879 m .5295 .30828 L .49262 .3101 L p F P
0 0 0 r
s
.658 .381 .49 r
.49262 .3101 m .49198 .33062 L .5296 .32879 L p F P
0 0 0 r
s
.67999 .34429 m
.70242 .33695 L
s
.67999 .34429 m
.66926 .33069 L
s
0 0 1 r
2 Mabswid
.28896 .40322 m
.29793 .40783 L
s
0 0 0 r
.5 Mabswid
.37026 .34373 m
.39147 .33638 L
s
.37026 .34373 m
.35727 .33012 L
s
.06034 .34316 m
.08034 .33581 L
s
.73535 .34316 m
.75801 .33581 L
s
.73535 .34316 m
.72502 .32954 L
s
.718 .431 .489 r
.5295 .30828 m .5296 .32879 L .56698 .3319 L p F P
0 0 0 r
s
.42545 .3426 m
.4469 .33524 L
s
.41286 .32897 m
.42545 .3426 L
s
.518 .398 .656 r
.43327 .42319 m .42744 .39679 L .40104 .41077 L p F P
0 0 0 r
s
.518 .398 .656 r
.40104 .41077 m .4084 .43614 L .43327 .42319 L p F P
0 0 0 r
s
.11536 .34204 m
.13559 .33467 L
s
.11536 .34204 m
.1005 .3284 L
s
.79078 .34204 m
.81367 .33467 L
s
.79078 .34204 m
.78085 .3284 L
s
.17045 .34091 m
.19091 .33354 L
s
.17045 .34091 m
.15598 .32725 L
s
.83675 .32725 m
.84628 .34091 L
s
.53603 .34034 m
.55794 .33297 L
s
.52424 .32668 m
.52578 .32848 L
s
.866 .773 .757 r
.63564 .46508 m .62761 .47927 L .63588 .48659 L p F P
0 0 0 r
s
.829 .608 .604 r
.62931 .40011 m .6328 .3751 L .60171 .36316 L p F P
0 0 0 r
s
.834 .573 .544 r
.60218 .33976 m .60171 .36316 L .6328 .3751 L p F P
0 0 0 r
s
.61357 .33183 m
.62469 .34542 L
s
.62469 .34542 m
.64689 .33808 L
s
.22561 .33978 m
.2463 .3324 L
s
.22561 .33978 m
.21153 .32611 L
s
.78 .526 .551 r
.60171 .36316 m .60218 .33976 L .56698 .3319 L p F P
0 0 0 r
s
.56946 .34654 m
.57951 .34319 L
s
.55794 .33297 m
.56946 .34654 L
s
.85 .707 .703 r
.63564 .46508 m .64656 .43996 L .62305 .42626 L p F P
0 0 0 r
s
.867 .687 .656 r
.62931 .40011 m .62305 .42626 L .64656 .43996 L p F P
0 0 0 r
s
.28083 .33865 m
.30175 .33126 L
s
.28083 .33865 m
.26715 .32496 L
s
.64689 .33808 m
.66926 .33069 L
s
.64689 .33808 m
.63589 .32438 L
s
.33612 .33751 m
.35727 .33012 L
s
.33612 .33751 m
.32284 .32381 L
s
.613 .388 .553 r
.49218 .35419 m .49198 .33062 L .45603 .33729 L p F P
0 0 0 r
s
.46851 .32783 m
.47399 .33396 L
s
.613 .388 .553 r
.45603 .33729 m .45645 .36073 L .49218 .35419 L p F P
0 0 0 r
s
.49204 .33762 m
.50239 .33411 L
s
.70242 .33695 m
.72502 .32954 L
s
.70242 .33695 m
.69181 .32323 L
s
.566 .392 .605 r
.45867 .3864 m .45645 .36073 L .42419 .37163 L p F P
0 0 0 r
s
.566 .392 .605 r
.42419 .37163 m .42744 .39679 L .45867 .3864 L p F P
0 0 0 r
s
.39147 .33638 m
.41286 .32897 L
s
.39147 .33638 m
.37859 .32266 L
s
.08034 .33581 m
.1005 .3284 L
s
.75801 .33581 m
.78085 .3284 L
s
.75801 .33581 m
.74781 .32208 L
s
.4469 .33524 m
.46851 .32783 L
s
.4469 .33524 m
.43441 .32151 L
s
.543 .451 .701 r
.44153 .45004 m .43327 .42319 L .4084 .43614 L p F P
0 0 0 r
s
.543 .451 .701 r
.4084 .43614 m .41884 .46166 L .44153 .45004 L p F P
0 0 0 r
s
.13559 .33467 m
.15598 .32725 L
s
.13559 .33467 m
.12082 .32093 L
s
.81367 .33467 m
.83675 .32725 L
s
.81367 .33467 m
.80387 .32093 L
s
.832 .723 .744 r
.62761 .47927 m .63564 .46508 L .61418 .45279 L p F P
0 0 0 r
s
.85 .707 .703 r
.62305 .42626 m .61418 .45279 L .63564 .46508 L p F P
0 0 0 r
s
.19091 .33354 m
.21153 .32611 L
s
.19091 .33354 m
.17654 .31978 L
s
.2463 .3324 m
.26715 .32496 L
s
.2463 .3324 m
.23232 .31862 L
s
.832 .723 .744 r
.61861 .47417 m .62761 .47927 L p .61418 .45279 L F P
0 0 0 r
s
.78 .526 .551 r
.56698 .3319 m .56671 .35544 L .60171 .36316 L p F P
0 0 0 r
s
.58003 .32553 m
.58953 .33694 L
s
.59475 .3381 m
.61357 .33183 L
s
.727 .481 .555 r
.56671 .35544 m .56698 .3319 L .5296 .32879 L p F P
0 0 0 r
s
.56228 .33151 m
.56345 .33111 L
s
.61357 .33183 m
.63589 .32438 L
s
.61357 .33183 m
.60228 .31804 L
s
.30175 .33126 m
.32284 .32381 L
s
.30175 .33126 m
.28817 .31746 L
s
.82 .636 .654 r
.62305 .42626 m .62931 .40011 L .5992 .38871 L p F P
0 0 0 r
s
.829 .608 .604 r
.60171 .36316 m .5992 .38871 L .62931 .40011 L p F P
0 0 0 r
s
.66926 .33069 m
.69181 .32323 L
s
.66926 .33069 m
.65838 .31688 L
s
.673 .437 .555 r
.52957 .35239 m .5296 .32879 L .49198 .33062 L p F P
0 0 0 r
s
.5296 .33289 m
.53603 .34034 L
s
.4983 .32945 m
.49902 .33028 L
s
.4903 .32035 m
.4983 .32945 L
s
.51609 .32945 m
.52424 .32668 L
s
.52578 .32848 m
.5262 .32896 L
s
.673 .437 .555 r
.49198 .33062 m .49218 .35419 L .52957 .35239 L p F P
0 0 0 r
s
.35727 .33012 m
.37859 .32266 L
s
.35727 .33012 m
.34409 .3163 L
s
.564 .499 .741 r
.43802 .47029 m .4476 .46544 L p .41884 .46166 L F P
0 0 0 r
s
.564 .499 .741 r
.4476 .46544 m .44153 .45004 L .41884 .46166 L p F P
0 0 0 r
s
.564 .499 .741 r
.41884 .46166 m .42652 .47611 L .43802 .47029 L p F P
0 0 0 r
s
.72502 .32954 m
.74781 .32208 L
s
.72502 .32954 m
.71454 .31572 L
s
.41286 .32897 m
.43441 .32151 L
s
.41286 .32897 m
.40008 .31514 L
s
.727 .481 .555 r
.5296 .32879 m .52957 .35239 L .56671 .35544 L p F P
0 0 0 r
s
.56345 .33111 m
.58003 .32553 L
s
.54626 .3192 m
.55628 .33101 L
s
0 0 1 r
2 Mabswid
.29793 .40783 m
.3088 .41272 L
s
0 0 0 r
.5 Mabswid
.1005 .3284 m
.12082 .32093 L
s
.78085 .3284 m
.80387 .32093 L
s
.78085 .3284 m
.77078 .31456 L
s
.779 .563 .606 r
.5992 .38871 m .60171 .36316 L .56671 .35544 L p F P
0 0 0 r
s
.46851 .32783 m
.4903 .32035 L
s
.46851 .32783 m
.45614 .31398 L
s
.585 .442 .653 r
.46265 .41356 m .45867 .3864 L .42744 .39679 L p F P
0 0 0 r
s
.585 .442 .653 r
.42744 .39679 m .43327 .42319 L .46265 .41356 L p F P
0 0 0 r
s
.82708 .3134 m
.83675 .32725 L
s
.15598 .32725 m
.17654 .31978 L
s
.15598 .32725 m
.1413 .3134 L
s
.832 .723 .744 r
.61418 .45279 m .60766 .46796 L .61861 .47417 L p F P
0 0 0 r
s
.52424 .32668 m
.54626 .3192 L
s
.52424 .32668 m
.51226 .31282 L
s
.21153 .32611 m
.23232 .31862 L
s
.21153 .32611 m
.19725 .31224 L
s
.628 .438 .606 r
.49324 .38016 m .49218 .35419 L .45645 .36073 L p F P
0 0 0 r
s
.628 .438 .606 r
.45645 .36073 m .45867 .3864 L .49324 .38016 L p F P
0 0 0 r
s
.58003 .32553 m
.60228 .31804 L
s
.58003 .32553 m
.56846 .31165 L
s
.26715 .32496 m
.28817 .31746 L
s
.26715 .32496 m
.25327 .31107 L
s
.63589 .32438 m
.65838 .31688 L
s
.63589 .32438 m
.62472 .31049 L
s
.81 .659 .696 r
.61418 .45279 m .62305 .42626 L .59472 .4157 L p F P
0 0 0 r
s
.82 .636 .654 r
.5992 .38871 m .59472 .4157 L .62305 .42626 L p F P
0 0 0 r
s
.32284 .32381 m
.34409 .3163 L
s
.32284 .32381 m
.30936 .3099 L
s
.69181 .32323 m
.71454 .31572 L
s
.69181 .32323 m
.68105 .30932 L
s
.37859 .32266 m
.40008 .31514 L
s
.37859 .32266 m
.36552 .30874 L
s
.74781 .32208 m
.77078 .31456 L
s
.74781 .32208 m
.73745 .30815 L
s
.43441 .32151 m
.45614 .31398 L
s
.43441 .32151 m
.42174 .30757 L
s
.6 .485 .694 r
.46828 .44142 m .46265 .41356 L .43327 .42319 L p F P
0 0 0 r
s
.6 .485 .694 r
.43327 .42319 m .44153 .45004 L .46828 .44142 L p F P
0 0 0 r
s
.12082 .32093 m
.1413 .3134 L
s
.80387 .32093 m
.82708 .3134 L
s
.80387 .32093 m
.79393 .30698 L
s
.798 .679 .734 r
.60766 .46796 m .61418 .45279 L .58837 .44334 L p F P
0 0 0 r
s
.81 .659 .696 r
.59472 .4157 m .58837 .44334 L .61418 .45279 L p F P
0 0 0 r
s
.4903 .32035 m
.51226 .31282 L
s
.4903 .32035 m
.47804 .3064 L
s
.779 .563 .606 r
.56671 .35544 m .56534 .38135 L .5992 .38871 L p F P
0 0 0 r
s
.731 .521 .607 r
.56534 .38135 m .56671 .35544 L .52957 .35239 L p F P
0 0 0 r
s
.798 .679 .734 r
.59684 .46404 m .60766 .46796 L p .58837 .44334 L F P
0 0 0 r
s
.17654 .31978 m
.19725 .31224 L
s
.17654 .31978 m
.16195 .30581 L
s
.54626 .3192 m
.56846 .31165 L
s
.54626 .3192 m
.5344 .30522 L
s
.776 .593 .651 r
.59472 .4157 m .5992 .38871 L .56534 .38135 L p F P
0 0 0 r
s
.682 .48 .607 r
.52941 .37844 m .52957 .35239 L .49218 .35419 L p F P
0 0 0 r
s
.682 .48 .607 r
.49218 .35419 m .49324 .38016 L .52941 .37844 L p F P
0 0 0 r
s
.23232 .31862 m
.25327 .31107 L
s
.23232 .31862 m
.21814 .30464 L
s
.60228 .31804 m
.62472 .31049 L
s
.60228 .31804 m
.59083 .30405 L
s
.613 .525 .732 r
.46115 .46111 m .47242 .45751 L p .44153 .45004 L F P
0 0 0 r
s
.613 .525 .732 r
.47242 .45751 m .46828 .44142 L .44153 .45004 L p F P
0 0 0 r
s
.613 .525 .732 r
.44153 .45004 m .4476 .46544 L .46115 .46111 L p F P
0 0 0 r
s
.28817 .31746 m
.30936 .3099 L
s
.28817 .31746 m
.27439 .30346 L
s
.731 .521 .607 r
.52957 .35239 m .52941 .37844 L .56534 .38135 L p F P
0 0 0 r
s
.65838 .31688 m
.68105 .30932 L
s
.65838 .31688 m
.64734 .30287 L
s
.64 .48 .651 r
.49514 .40778 m .49324 .38016 L .45867 .3864 L p F P
0 0 0 r
s
.64 .48 .651 r
.45867 .3864 m .46265 .41356 L .49514 .40778 L p F P
0 0 0 r
s
.34409 .3163 m
.36552 .30874 L
s
.34409 .3163 m
.33072 .30229 L
s
.798 .679 .734 r
.58837 .44334 m .5837 .45928 L .59684 .46404 L p F P
0 0 0 r
s
.71454 .31572 m
.73745 .30815 L
s
.71454 .31572 m
.70391 .3017 L
s
.40008 .31514 m
.42174 .30757 L
s
.40008 .31514 m
.38711 .30111 L
s
.77078 .31456 m
.79393 .30698 L
s
.77078 .31456 m
.76055 .30052 L
s
0 0 1 r
2 Mabswid
.3088 .41272 m
.3215 .41787 L
s
0 0 0 r
.5 Mabswid
.45614 .31398 m
.47804 .3064 L
s
.45614 .31398 m
.44358 .29993 L
s
.81726 .29934 m
.82708 .3134 L
s
.1413 .3134 m
.16195 .30581 L
s
.771 .619 .691 r
.58837 .44334 m .59472 .4157 L .56289 .40889 L p F P
0 0 0 r
s
.776 .593 .651 r
.56534 .38135 m .56289 .40889 L .59472 .4157 L p F P
0 0 0 r
s
.51226 .31282 m
.5344 .30522 L
s
.51226 .31282 m
.50011 .29875 L
s
.19725 .31224 m
.21814 .30464 L
s
.19725 .31224 m
.18276 .29816 L
s
.56846 .31165 m
.59083 .30405 L
s
.56846 .31165 m
.55671 .29757 L
s
.733 .554 .65 r
.56289 .40889 m .56534 .38135 L .52941 .37844 L p F P
0 0 0 r
s
.25327 .31107 m
.27439 .30346 L
s
.25327 .31107 m
.23919 .29698 L
s
.649 .517 .69 r
.49783 .43625 m .49514 .40778 L .46265 .41356 L p F P
0 0 0 r
s
.649 .517 .69 r
.46265 .41356 m .46828 .44142 L .49783 .43625 L p F P
0 0 0 r
s
.764 .642 .727 r
.57157 .45675 m .5837 .45928 L p .55941 .43724 L F P
0 0 0 r
s
.764 .642 .727 r
.5837 .45928 m .58837 .44334 L .55941 .43724 L p F P
0 0 0 r
s
.62472 .31049 m
.64734 .30287 L
s
.62472 .31049 m
.61339 .29639 L
s
.771 .619 .691 r
.56289 .40889 m .55941 .43724 L .58837 .44334 L p F P
0 0 0 r
s
.688 .517 .65 r
.52913 .4062 m .52941 .37844 L .49324 .38016 L p F P
0 0 0 r
s
.688 .517 .65 r
.49324 .38016 m .49514 .40778 L .52913 .4062 L p F P
0 0 0 r
s
.30936 .3099 m
.33072 .30229 L
s
.30936 .3099 m
.29568 .29579 L
s
.68105 .30932 m
.70391 .3017 L
s
.68105 .30932 m
.67013 .2952 L
s
.655 .552 .726 r
.46828 .44142 m .47242 .45751 L .48739 .45492 L p F P
0 0 0 r
s
.36552 .30874 m
.38711 .30111 L
s
.36552 .30874 m
.35225 .29461 L
s
.733 .554 .65 r
.52941 .37844 m .52913 .4062 L .56289 .40889 L p F P
0 0 0 r
s
.655 .552 .726 r
.48739 .45492 m .49981 .45277 L p .46828 .44142 L F P
0 0 0 r
s
.655 .552 .726 r
.49981 .45277 m .49783 .43625 L .46828 .44142 L p F P
0 0 0 r
s
.73745 .30815 m
.76055 .30052 L
s
.73745 .30815 m
.72695 .29401 L
s
.764 .642 .727 r
.55941 .43724 m .55686 .45368 L .57157 .45675 L p F P
0 0 0 r
s
.42174 .30757 m
.44358 .29993 L
s
.42174 .30757 m
.40888 .29342 L
s
.79393 .30698 m
.81726 .29934 L
s
.79393 .30698 m
.78383 .29283 L
s
.47804 .3064 m
.50011 .29875 L
s
.47804 .3064 m
.46559 .29223 L
s
.732 .583 .688 r
.55941 .43724 m .56289 .40889 L .52913 .4062 L p F P
0 0 0 r
s
.16195 .30581 m
.18276 .29816 L
s
.5344 .30522 m
.55671 .29757 L
s
.5344 .30522 m
.52236 .29104 L
s
.692 .549 .688 r
.52872 .43483 m .52913 .4062 L .49514 .40778 L p F P
0 0 0 r
s
.692 .549 .688 r
.49514 .40778 m .49783 .43625 L .52872 .43483 L p F P
0 0 0 r
s
.21814 .30464 m
.23919 .29698 L
s
.21814 .30464 m
.20374 .29045 L
s
.729 .609 .724 r
.54399 .45268 m .55686 .45368 L p .52872 .43483 L F P
0 0 0 r
s
.729 .609 .724 r
.55686 .45368 m .55941 .43724 L .52872 .43483 L p F P
0 0 0 r
s
.59083 .30405 m
.61339 .29639 L
s
.59083 .30405 m
.57921 .28985 L
s
.732 .583 .688 r
.52913 .4062 m .52872 .43483 L .55941 .43724 L p F P
0 0 0 r
s
.693 .58 .723 r
.49783 .43625 m .49981 .45277 L .51546 .45206 L p F P
0 0 0 r
s
.729 .609 .724 r
.52872 .43483 m .52843 .45147 L .54399 .45268 L p F P
0 0 0 r
s
.27439 .30346 m
.29568 .29579 L
s
.27439 .30346 m
.26041 .28925 L
s
.64734 .30287 m
.67013 .2952 L
s
.64734 .30287 m
.63613 .28866 L
s
.693 .58 .723 r
.51546 .45206 m .52843 .45147 L p .49783 .43625 L F P
0 0 0 r
s
.693 .58 .723 r
.52843 .45147 m .52872 .43483 L .49783 .43625 L p F P
0 0 0 r
s
.33072 .30229 m
.35225 .29461 L
s
.33072 .30229 m
.31715 .28806 L
s
.70391 .3017 m
.72695 .29401 L
s
.70391 .3017 m
.69311 .28746 L
s
.38711 .30111 m
.40888 .29342 L
s
.38711 .30111 m
.37395 .28687 L
s
.76055 .30052 m
.78383 .29283 L
s
.76055 .30052 m
.75017 .28627 L
s
0 0 1 r
2 Mabswid
.3215 .41787 m
.33597 .42322 L
s
0 0 0 r
.5 Mabswid
.44358 .29993 m
.46559 .29223 L
s
.44358 .29993 m
.43083 .28567 L
s
.8073 .28507 m
.81726 .29934 L
s
.50011 .29875 m
.52236 .29104 L
s
.50011 .29875 m
.48778 .28447 L
s
.18276 .29816 m
.20374 .29045 L
s
.55671 .29757 m
.57921 .28985 L
s
.55671 .29757 m
.5448 .28327 L
s
.23919 .29698 m
.26041 .28925 L
s
.23919 .29698 m
.22489 .28267 L
s
.61339 .29639 m
.63613 .28866 L
s
.61339 .29639 m
.60189 .28207 L
s
.29568 .29579 m
.31715 .28806 L
s
.29568 .29579 m
.2818 .28147 L
s
.67013 .2952 m
.69311 .28746 L
s
.67013 .2952 m
.65905 .28087 L
s
.35225 .29461 m
.37395 .28687 L
s
.35225 .29461 m
.33878 .28027 L
s
.72695 .29401 m
.75017 .28627 L
s
.72695 .29401 m
.71628 .27966 L
s
.40888 .29342 m
.43083 .28567 L
s
.40888 .29342 m
.39583 .27906 L
s
.78383 .29283 m
.8073 .28507 L
s
.78383 .29283 m
.77359 .27846 L
s
.46559 .29223 m
.48778 .28447 L
s
.46559 .29223 m
.45295 .27786 L
s
.52236 .29104 m
.5448 .28327 L
s
.52236 .29104 m
.51015 .27665 L
s
.20374 .29045 m
.22489 .28267 L
s
.57921 .28985 m
.60189 .28207 L
s
.57921 .28985 m
.56741 .27544 L
s
.26041 .28925 m
.2818 .28147 L
s
.26041 .28925 m
.24621 .27483 L
s
.63613 .28866 m
.65905 .28087 L
s
.63613 .28866 m
.62475 .27423 L
s
.31715 .28806 m
.33878 .28027 L
s
.31715 .28806 m
.30337 .27362 L
s
.69311 .28746 m
.71628 .27966 L
s
.69311 .28746 m
.68216 .27302 L
s
0 0 1 r
2 Mabswid
.35002 .42803 m
.33597 .42322 L
s
0 0 0 r
.5 Mabswid
.37395 .28687 m
.39583 .27906 L
s
.37395 .28687 m
.36059 .27241 L
s
.75017 .28627 m
.77359 .27846 L
s
.75017 .28627 m
.73964 .2718 L
s
.43083 .28567 m
.45295 .27786 L
s
.43083 .28567 m
.41789 .27119 L
s
.79719 .27059 m
.8073 .28507 L
s
.48778 .28447 m
.51015 .27665 L
s
.48778 .28447 m
.47526 .26998 L
s
.5448 .28327 m
.56741 .27544 L
s
.5448 .28327 m
.5327 .26876 L
s
.22489 .28267 m
.24621 .27483 L
s
.60189 .28207 m
.62475 .27423 L
s
.60189 .28207 m
.59021 .26754 L
s
.2818 .28147 m
.30337 .27362 L
s
.2818 .28147 m
.26771 .26693 L
s
.65905 .28087 m
.68216 .27302 L
s
.65905 .28087 m
.6478 .26632 L
s
.33878 .28027 m
.36059 .27241 L
s
.33878 .28027 m
.32511 .26571 L
s
.71628 .27966 m
.73964 .2718 L
s
.71628 .27966 m
.70546 .2651 L
s
.39583 .27906 m
.41789 .27119 L
s
.39583 .27906 m
.38258 .26449 L
s
.77359 .27846 m
.79719 .27059 L
s
.77359 .27846 m
.76319 .26387 L
s
.45295 .27786 m
.47526 .26998 L
s
.45295 .27786 m
.44013 .26326 L
s
.51015 .27665 m
.5327 .26876 L
s
.51015 .27665 m
.49775 .26204 L
s
.56741 .27544 m
.59021 .26754 L
s
.56741 .27544 m
.55544 .26081 L
s
.24621 .27483 m
.26771 .26693 L
s
.62475 .27423 m
.6478 .26632 L
s
.62475 .27423 m
.6132 .25958 L
s
.30337 .27362 m
.32511 .26571 L
s
.30337 .27362 m
.28938 .25896 L
s
.68216 .27302 m
.70546 .2651 L
s
.68216 .27302 m
.67104 .25835 L
s
.36059 .27241 m
.38258 .26449 L
s
.36059 .27241 m
.34703 .25773 L
s
.73964 .2718 m
.76319 .26387 L
s
.73964 .2718 m
.72895 .25712 L
s
.41789 .27119 m
.44013 .26326 L
s
.41789 .27119 m
.40476 .2565 L
s
.78693 .25588 m
.79719 .27059 L
s
.47526 .26998 m
.49775 .26204 L
s
.47526 .26998 m
.46255 .25527 L
s
.5327 .26876 m
.55544 .26081 L
s
.5327 .26876 m
.52042 .25403 L
s
.59021 .26754 m
.6132 .25958 L
s
.59021 .26754 m
.57836 .25279 L
s
.26771 .26693 m
.28938 .25896 L
s
.6478 .26632 m
.67104 .25835 L
s
.6478 .26632 m
.63638 .25155 L
s
.32511 .26571 m
.34703 .25773 L
s
.32511 .26571 m
.31123 .25093 L
s
.70546 .2651 m
.72895 .25712 L
s
.70546 .2651 m
.69447 .25031 L
s
.38258 .26449 m
.40476 .2565 L
s
.38258 .26449 m
.36914 .24969 L
s
.76319 .26387 m
.78693 .25588 L
s
.76319 .26387 m
.75263 .24907 L
s
.44013 .26326 m
.46255 .25527 L
s
.44013 .26326 m
.42711 .24845 L
s
.49775 .26204 m
.52042 .25403 L
s
.49775 .26204 m
.48516 .2472 L
s
.55544 .26081 m
.57836 .25279 L
s
.55544 .26081 m
.54328 .24596 L
s
.6132 .25958 m
.63638 .25155 L
s
.6132 .25958 m
.60148 .24471 L
s
.28938 .25896 m
.31123 .25093 L
s
.67104 .25835 m
.69447 .25031 L
s
.67104 .25835 m
.65975 .24346 L
s
.34703 .25773 m
.36914 .24969 L
s
.34703 .25773 m
.33327 .24283 L
s
.72895 .25712 m
.75263 .24907 L
s
.72895 .25712 m
.71809 .24221 L
s
.40476 .2565 m
.42711 .24845 L
s
.40476 .2565 m
.39142 .24158 L
s
.77651 .24095 m
.78693 .25588 L
s
.46255 .25527 m
.48516 .2472 L
s
.46255 .25527 m
.44965 .24033 L
s
.52042 .25403 m
.54328 .24596 L
s
.52042 .25403 m
.50795 .23907 L
s
.57836 .25279 m
.60148 .24471 L
s
.57836 .25279 m
.56633 .23782 L
s
.63638 .25155 m
.65975 .24346 L
s
.63638 .25155 m
.62478 .23656 L
s
.31123 .25093 m
.33327 .24283 L
s
.69447 .25031 m
.71809 .24221 L
s
.69447 .25031 m
.68331 .2353 L
s
.36914 .24969 m
.39142 .24158 L
s
.36914 .24969 m
.35548 .23467 L
s
.75263 .24907 m
.77651 .24095 L
s
.75263 .24907 m
.74191 .23404 L
s
.42711 .24845 m
.44965 .24033 L
s
.42711 .24845 m
.41389 .2334 L
s
.48516 .2472 m
.50795 .23907 L
s
.48516 .2472 m
.47238 .23214 L
s
.54328 .24596 m
.56633 .23782 L
s
.54328 .24596 m
.53094 .23087 L
s
.60148 .24471 m
.62478 .23656 L
s
.60148 .24471 m
.58957 .22961 L
s
.65975 .24346 m
.68331 .2353 L
s
.65975 .24346 m
.64828 .22834 L
s
.33327 .24283 m
.35548 .23467 L
s
.71809 .24221 m
.74191 .23404 L
s
.71809 .24221 m
.70707 .22707 L
s
.39142 .24158 m
.41389 .2334 L
s
.39142 .24158 m
.37788 .22643 L
s
.76593 .2258 m
.77651 .24095 L
s
.44965 .24033 m
.47238 .23214 L
s
.44965 .24033 m
.43655 .22516 L
s
.50795 .23907 m
.53094 .23087 L
s
.50795 .23907 m
.49529 .22388 L
s
.56633 .23782 m
.58957 .22961 L
s
.56633 .23782 m
.55411 .22261 L
s
.62478 .23656 m
.64828 .22834 L
s
.62478 .23656 m
.61301 .22133 L
s
.68331 .2353 m
.70707 .22707 L
s
.68331 .2353 m
.67198 .22005 L
s
.35548 .23467 m
.37788 .22643 L
s
.74191 .23404 m
.76593 .2258 L
s
.74191 .23404 m
.73102 .21877 L
s
.41389 .2334 m
.43655 .22516 L
s
.41389 .2334 m
.40047 .21813 L
s
.47238 .23214 m
.49529 .22388 L
s
.47238 .23214 m
.4594 .21684 L
s
.53094 .23087 m
.55411 .22261 L
s
.53094 .23087 m
.5184 .21556 L
s
.58957 .22961 m
.61301 .22133 L
s
.58957 .22961 m
.57748 .21427 L
s
.64828 .22834 m
.67198 .22005 L
s
.64828 .22834 m
.63664 .21298 L
s
.70707 .22707 m
.73102 .21877 L
s
.70707 .22707 m
.69587 .21169 L
s
.37788 .22643 m
.40047 .21813 L
s
.75518 .2104 m
.76593 .2258 L
s
.43655 .22516 m
.4594 .21684 L
s
.43655 .22516 m
.42324 .20976 L
s
.49529 .22388 m
.5184 .21556 L
s
.49529 .22388 m
.48244 .20846 L
s
.55411 .22261 m
.57748 .21427 L
s
.55411 .22261 m
.5417 .20716 L
s
.61301 .22133 m
.63664 .21298 L
s
.61301 .22133 m
.60105 .20587 L
s
.67198 .22005 m
.69587 .21169 L
s
.67198 .22005 m
.66047 .20457 L
s
.73102 .21877 m
.75518 .2104 L
s
.73102 .21877 m
.71997 .20327 L
s
.40047 .21813 m
.42324 .20976 L
s
.4594 .21684 m
.48244 .20846 L
s
.4594 .21684 m
.44621 .20131 L
s
.5184 .21556 m
.5417 .20716 L
s
.5184 .21556 m
.50567 .20001 L
s
.57748 .21427 m
.60105 .20587 L
s
.57748 .21427 m
.5652 .1987 L
s
.63664 .21298 m
.66047 .20457 L
s
.63664 .21298 m
.62481 .19739 L
s
.69587 .21169 m
.71997 .20327 L
s
.69587 .21169 m
.6845 .19608 L
s
.74427 .19477 m
.75518 .2104 L
s
.42324 .20976 m
.44621 .20131 L
s
.48244 .20846 m
.50567 .20001 L
s
.48244 .20846 m
.46938 .1928 L
s
.5417 .20716 m
.5652 .1987 L
s
.5417 .20716 m
.5291 .19148 L
s
.60105 .20587 m
.62481 .19739 L
s
.60105 .20587 m
.5889 .19016 L
s
.66047 .20457 m
.6845 .19608 L
s
.66047 .20457 m
.64878 .18884 L
s
.71997 .20327 m
.74427 .19477 L
s
.71997 .20327 m
.70874 .18752 L
s
.44621 .20131 m
.46938 .1928 L
s
.50567 .20001 m
.5291 .19148 L
s
.50567 .20001 m
.49274 .18421 L
s
.5652 .1987 m
.5889 .19016 L
s
.5652 .1987 m
.55273 .18288 L
s
.62481 .19739 m
.64878 .18884 L
s
.62481 .19739 m
.6128 .18155 L
s
.6845 .19608 m
.70874 .18752 L
s
.6845 .19608 m
.67295 .18022 L
s
.73318 .17889 m
.74427 .19477 L
s
.46938 .1928 m
.49274 .18421 L
s
.5291 .19148 m
.55273 .18288 L
s
.5291 .19148 m
.5163 .17555 L
s
.5889 .19016 m
.6128 .18155 L
s
.5889 .19016 m
.57656 .17421 L
s
.64878 .18884 m
.67295 .18022 L
s
.64878 .18884 m
.63691 .17287 L
s
.70874 .18752 m
.73318 .17889 L
s
.70874 .18752 m
.69733 .17152 L
s
.49274 .18421 m
.5163 .17555 L
s
.55273 .18288 m
.57656 .17421 L
s
.55273 .18288 m
.54006 .16681 L
s
.6128 .18155 m
.63691 .17287 L
s
.6128 .18155 m
.6006 .16546 L
s
.67295 .18022 m
.69733 .17152 L
s
.67295 .18022 m
.66122 .16411 L
s
.72192 .16275 m
.73318 .17889 L
s
.5163 .17555 m
.54006 .16681 L
s
.57656 .17421 m
.6006 .16546 L
s
.57656 .17421 m
.56403 .158 L
s
.63691 .17287 m
.66122 .16411 L
s
.63691 .17287 m
.62485 .15664 L
s
.69733 .17152 m
.72192 .16275 L
s
.69733 .17152 m
.68575 .15527 L
s
.54006 .16681 m
.56403 .158 L
s
.6006 .16546 m
.62485 .15664 L
s
.6006 .16546 m
.58821 .14911 L
s
.66122 .16411 m
.68575 .15527 L
s
.66122 .16411 m
.6493 .14774 L
s
.71048 .14636 m
.72192 .16275 L
s
.56403 .158 m
.58821 .14911 L
s
.62485 .15664 m
.6493 .14774 L
s
.62485 .15664 m
.61259 .14015 L
s
.68575 .15527 m
.71048 .14636 L
s
.68575 .15527 m
.67397 .13876 L
s
.58821 .14911 m
.61259 .14015 L
s
.6493 .14774 m
.67397 .13876 L
s
.6493 .14774 m
.63719 .13111 L
s
.69886 .12971 m
.71048 .14636 L
s
.61259 .14015 m
.63719 .13111 L
s
.67397 .13876 m
.69886 .12971 L
s
.67397 .13876 m
.66201 .12198 L
s
.63719 .13111 m
.66201 .12198 L
s
.68704 .11278 m
.69886 .12971 L
s
.66201 .12198 m
.68704 .11278 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  CellLabel->"From In[327]:=",
  ImageSize->{400, 307.188},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006@0001<b000`400?l00000o`00003oo`3ooonA
0?ooo`00o`3om^j@0?ofkP40oooo003o0?ofkY00ooK^0@3oool00?l0ooK^T03om^h10?ooo`00o`3o
m^j@0?ofkP40oooo003o0?ofkY00ooK^0@3oool00?l0ooK^T03om^h10?ooo`00o`3om^j@0?ofkP40
oooo003o0?ofkY00ooK^0@3oool00?l0ooK^T03om^h10?ooo`00o`3om^j@0?ofkP40oooo003o0?of
kY00ooK^0@3oool00?l0ooK^T03om^h10?ooo`00o`3om^j@0?ofkP40oooo003o0?ofkY00ooK^0@3o
ool00?l0ooK^T03om^h10?ooo`00o`3om^j@0?ofkP40oooo003o0?ofkY00ooK^0@3oool00?l0ooK^
T03om^h10?ooo`00o`3om^j@0?ofkP40oooo003o0?ofkY00ooK^0@3oool00?l0ooK^T03om^h10?oo
o`00o`3om^j@0?ofkP40oooo003o0?ofkY00ooK^0@3oool00?l0ooK^T03om^h10?ooo`00o`3om^j@
0?ofkP40oooo003o0?ofkY00ooK^0@3oool00?l0ooK^T03om^h10?ooo`00o`3om^j@0?ofkP40oooo
003o0?ofkY00ooK^0@3oool00?l0ooK^T03om^h10?ooo`00o`3om^j@0?ofkP40oooo003o0?ofkY00
ooK^0@3oool00?l0ooK^T03om^h10?ooo`00o`3om^j@0?ofkP40oooo003o0?ofkY00ooK^0@3oool0
0?l0ooK^T03om^h10?ooo`00o`3om^j@0?ofkP40oooo003o0?ofkY00ooK^0@3oool00?l0ooK^T03o
m^h10?ooo`00o`3om^j@0?ofkP40oooo003o0?ofkY00ooK^0@3oool00?l0ooK^T03om^h10?ooo`00
o`3om^j@0?ofkP40oooo003o0?ofkY00ooK^0@3oool00?l0ooK^4P3om^h2000007`0ooK^0@3oool0
0?l0ooK^403om^h200000080ooK^00<000000?ofkP3om^h0N@3om^h10?ooo`00o`3om^h=0?ofkP<0
0000103om^h00`000000ooK^0?ofkP1i0?ofkP40oooo003o0?ofkP/0ooK^0P0000080?ofkP030000
003om^h0ooK^07P0ooK^0@3oool00?l0ooK^203om^h3000000X0ooK^00<000000?ofkP3om^h0N03o
m^h10?ooo`00o`3om^h60?ofkP8000000P3om^h00`000000ooK^0?ofkP090?ofkP030000003om^h0
ooK^07L0ooK^0@3oool00?l0ooK^0`3om^h3000000@0ooK^00<000000?ofkP3om^h02@3om^h00`00
0000ooK^0?ofkP1g0?ofkP40oooo003o0?ofkP40ooK^0P0000080?ofkP030000003om^h0ooK^00P0
ooK^0P00001h0?ofkP40oooo003m0?ofkP<000002P3om^h00`000000ooK^0?ofkP060?ofkP800000
0P3om^h00`000000ooK^0?ofkP1e0?ofkP40oooo003j0?ofkP<000000P3om^h00`000000ooK^0?of
kP090?ofkP030000003om^h0ooK^0080ooK^0`0000040?ofkP030000003om^h0ooK^07D0ooK^0@3o
ool00?H0ooK^100000060?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h00P000008
0?ofkP030000003om^h0ooK^07@0ooK^0@3oool00?<0ooK^0`00000:0?ofkP030000003om^h0ooK^
00P0ooK^0`00000;0?ofkP030000003om^h0ooK^07<0ooK^0@3oool00?40ooK^0P0000020?ofkP03
0000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h0103om^h300000080ooK^00<000000?ofkP3o
m^h02P3om^h00`000000ooK^0?ofkP1b0?ofkP40oooo003^0?ofkP<00000103om^h00`000000ooK^
0?ofkP0:0?ofkP030000003om^h0ooK^00<000001P3om^h00`000000ooK^0?ofkP090?ofkP030000
003om^h0ooK^0780ooK^0@3oool00>`0ooK^0P0000080?ofkP030000003om^h0ooK^00T0ooK^0`00
00090?ofkP030000003om^h0ooK^00T0ooK^0P00001c0?ofkP40oooo003Y0?ofkP<000002`3om^h0
0`000000ooK^0?ofkP060?ofkP8000000P3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0
ooK^00D0ooK^0`0000020?ofkP030000003om^h0ooK^0700ooK^0@3oool00>H0ooK^0`0000020?of
kP030000003om^h0ooK^00X0ooK^00<000000?ofkP3om^h00P3om^h3000000@0ooK^00<000000?of
kP3om^h02@3om^h00`000000ooK^0?ofkP04000000D0ooK^00<000000?ofkP3om^h0L03om^h10?oo
o`00h`3om^h3000000H0ooK^00<000000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP02000000P0
ooK^00<000000?ofkP3om^h0203om^h3000000X0ooK^00<000000?ofkP3om^h0K`3om^h10?ooo`00
h03om^h3000000T0ooK^00<000000?ofkP3om^h02@3om^h3000000X0ooK^00<000000?ofkP3om^h0
1P3om^h200000080ooK^00<000000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP1^0?ofkP40oooo
003N0?ofkP8000000P3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00D0ooK^0`00
00020?ofkP030000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h00P3om^h3000000@0ooK^00<0
00000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP1^0?ofkP40oooo003K0?ofkP<00000103om^h0
0`000000ooK^0?ofkP090?ofkP030000003om^h0ooK^00@000001P3om^h00`000000ooK^0?ofkP08
0?ofkP030000003om^h0ooK^00800000203om^h00`000000ooK^0?ofkP080?ofkP800000K`3om^h1
0?ooo`00f@3om^h2000000P0ooK^00<000000?ofkP3om^h0203om^h3000000X0ooK^00<000000?of
kP3om^h0203om^h3000000/0ooK^00<000000?ofkP3om^h01@3om^h200000080ooK^00<000000?of
kP3om^h0K03om^h10?ooo`00eP3om^h3000000/0ooK^00<000000?ofkP3om^h01@3om^h200000080
ooK^00<000000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP040?ofkP<000000P3om^h00`000000
ooK^0?ofkP0:0?ofkP030000003om^h0ooK^0080ooK^0P0000040?ofkP030000003om^h0ooK^06`0
ooK^0@3oool00=<0ooK^0`0000020?ofkP030000003om^h0ooK^00X0ooK^00<000000?ofkP3om^h0
0P3om^h2000000@0ooK^00<000000?ofkP3om^h02P3om^h00`000000ooK^0?ofkP03000000H0ooK^
00<000000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP02000000L0ooK^00<000000?ofkP3om^h0
J`3om^h10?ooo`00d03om^h3000000H0ooK^00<000000?ofkP3om^h02@3om^h00`000000ooK^0?of
kP02000000L0ooK^00<000000?ofkP3om^h02@3om^h3000000T0ooK^00<000000?ofkP3om^h02@3o
m^h3000000X0ooK^00<000000?ofkP3om^h0JP3om^h10?ooo`00c@3om^h3000000T0ooK^00<00000
0?ofkP3om^h02@3om^h3000000X0ooK^00<000000?ofkP3om^h01P3om^h200000080ooK^00<00000
0?ofkP3om^h0203om^h00`000000ooK^0?ofkP050?ofkP<000000P3om^h00`000000ooK^0?ofkP09
0?ofkP030000003om^h0ooK^06T0ooK^0@3oool00</0ooK^0P0000020?ofkP030000003om^h0ooK^
00P0ooK^00<000000?ofkP3om^h01@3om^h300000080ooK^00<000000?ofkP3om^h02@3om^h00`00
0000ooK^0?ofkP020?ofkP<00000103om^h00`000000ooK^0?ofkP090?ofkP030000003om^h0ooK^
00@000001@3om^h00`000000ooK^0?ofkP090?ofkP030000003om^h0ooK^06T0ooK^0@3oool00<P0
ooK^0`0000040?ofkP030000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h0100000050?ofkP03
0000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h00P0000080?ofkP030000003om^h0ooK^00P0
ooK^0`00000:0?ofkP030000003om^h0ooK^00P0ooK^0P00001Z0?ofkP40oooo00360?ofkP800000
203om^h00`000000ooK^0?ofkP080?ofkP<000002P3om^h00`000000ooK^0?ofkP080?ofkP<00000
2P3om^h00`000000ooK^0?ofkP060?ofkP8000000P3om^h00`000000ooK^0?ofkP090?ofkP030000
003om^h0ooK^00@0ooK^0`0000020?ofkP030000003om^h0ooK^06L0ooK^0@3oool00<<0ooK^0`00
000;0?ofkP030000003om^h0ooK^00D0ooK^0P0000020?ofkP030000003om^h0ooK^00T0ooK^00<0
00000?ofkP3om^h0103om^h300000080ooK^00<000000?ofkP3om^h02@3om^h00`000000ooK^0?of
kP020?ofkP<000001@3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00@000001@3o
m^h00`000000ooK^0?ofkP1W0?ofkP40oooo00300?ofkP<000000P3om^h00`000000ooK^0?ofkP0:
0?ofkP030000003om^h0ooK^0080ooK^0P0000040?ofkP030000003om^h0ooK^00T0ooK^00<00000
0?ofkP3om^h0100000060?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h00P000008
0?ofkP030000003om^h0ooK^00P0ooK^0`00000:0?ofkP030000003om^h0ooK^06H0ooK^0@3oool0
0;d0ooK^0`0000060?ofkP030000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h00P0000070?of
kP030000003om^h0ooK^00P0ooK^0`00000:0?ofkP030000003om^h0ooK^00P0ooK^0`00000;0?of
kP030000003om^h0ooK^00@0ooK^0`0000020?ofkP030000003om^h0ooK^00T0ooK^00<000000?of
kP3om^h0I@3om^h10?ooo`00^P3om^h3000000T0ooK^00<000000?ofkP3om^h02@3om^h3000000X0
ooK^00<000000?ofkP3om^h01@3om^h200000080ooK^00<000000?ofkP3om^h02@3om^h00`000000
ooK^0?ofkP040?ofkP<000000P3om^h00`000000ooK^0?ofkP0:0?ofkP030000003om^h0ooK^00<0
00001P3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^06D0ooK^0@3oool00;P0ooK^
0P0000020?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h01@3om^h300000080ooK^
00<000000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP020?ofkP8000001@3om^h00`000000ooK^
0?ofkP090?ofkP030000003om^h0ooK^00<000001P3om^h00`000000ooK^0?ofkP090?ofkP<00000
2@3om^h00`000000ooK^0?ofkP080?ofkP800000IP3om^h10?ooo`00]P3om^h2000000D0ooK^00<0
00000?ofkP3om^h0203om^h00`000000ooK^0?ofkP04000000H0ooK^00<000000?ofkP3om^h0203o
m^h00`000000ooK^0?ofkP02000000L0ooK^00<000000?ofkP3om^h02@3om^h3000000T0ooK^00<0
00000?ofkP3om^h01`3om^h200000080ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?of
kP040?ofkP<000000P3om^h00`000000ooK^0?ofkP1S0?ofkP40oooo002d0?ofkP8000001`3om^h0
0`000000ooK^0?ofkP080?ofkP<000002P3om^h00`000000ooK^0?ofkP080?ofkP<000002P3om^h0
0`000000ooK^0?ofkP050?ofkP<000000P3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0
ooK^00<0ooK^0`0000040?ofkP030000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h00`000006
0?ofkP030000003om^h0ooK^0680ooK^0@3oool00;40ooK^0`00000:0?ofkP030000003om^h0ooK^
00@0ooK^0`0000020?ofkP030000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h0103om^h30000
0080ooK^00<000000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP04000000D0ooK^00<000000?of
kP3om^h02@3om^h00`000000ooK^0?ofkP02000000P0ooK^00<000000?ofkP3om^h0203om^h30000
00T0ooK^00<000000?ofkP3om^h0HP3om^h10?ooo`00[P3om^h300000080ooK^00<000000?ofkP3o
m^h02@3om^h00`000000ooK^0?ofkP03000000H0ooK^00<000000?ofkP3om^h02@3om^h00`000000
ooK^0?ofkP03000000H0ooK^00<000000?ofkP3om^h0203om^h3000000X0ooK^00<000000?ofkP3o
m^h0203om^h3000000X0ooK^00<000000?ofkP3om^h01P3om^h200000080ooK^00<000000?ofkP3o
m^h0203om^h00`000000ooK^0?ofkP1Q0?ofkP40oooo002Z0?ofkP@000001P3om^h00`000000ooK^
0?ofkP080?ofkP<000002@3om^h00`000000ooK^0?ofkP090?ofkP<000002@3om^h00`000000ooK^
0?ofkP060?ofkP8000000P3om^h00`000000ooK^0?ofkP090?ofkP030000003om^h0ooK^00@0ooK^
0`0000020?ofkP030000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h00P3om^h3000000@0ooK^
00<000000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP1P0?ofkP40oooo002W0?ofkP<000002P3o
m^h00`000000ooK^0?ofkP060?ofkP8000000P3om^h00`000000ooK^0?ofkP080?ofkP030000003o
m^h0ooK^00D0ooK^0`0000020?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h00`3o
m^h2000000@0ooK^00<000000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP04000000H0ooK^00<0
00000?ofkP3om^h0203om^h00`000000ooK^0?ofkP02000000P0ooK^00<000000?ofkP3om^h0203o
m^h200000640ooK^0@3oool00:@0ooK^0`0000020?ofkP030000003om^h0ooK^00T0ooK^00<00000
0?ofkP3om^h00`3om^h2000000@0ooK^00<000000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP04
000000H0ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP02000000L0ooK^00<00000
0?ofkP3om^h0203om^h3000000X0ooK^00<000000?ofkP3om^h0203om^h3000000X0ooK^00<00000
0?ofkP3om^h01P3om^h200000080ooK^00<000000?ofkP3om^h0GP3om^h10?ooo`00X@3om^h30000
00H0ooK^00<000000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP02000000L0ooK^00<000000?of
kP3om^h0203om^h3000000X0ooK^00<000000?ofkP3om^h0203om^h3000000X0ooK^00<000000?of
kP3om^h01@3om^h200000080ooK^00<000000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP040?of
kP<000000P3om^h00`000000ooK^0?ofkP090?ofkP030000003om^h0ooK^0080ooK^0`0000040?of
kP030000003om^h0ooK^05h0ooK^0@3oool009h0ooK^0`00000:0?ofkP030000003om^h0ooK^00P0
ooK^0`00000:0?ofkP030000003om^h0ooK^00D0ooK^0P0000020?ofkP030000003om^h0ooK^00T0
ooK^00<000000?ofkP3om^h0103om^h300000080ooK^00<000000?ofkP3om^h02@3om^h00`000000
ooK^0?ofkP020?ofkP8000001@3om^h00`000000ooK^0?ofkP090?ofkP030000003om^h0ooK^00<0
00001P3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00800000203om^h00`000000
ooK^0?ofkP1M0?ofkP40oooo002L0?ofkP8000000P3om^h00`000000ooK^0?ofkP090?ofkP030000
003om^h0ooK^00@0ooK^0`0000020?ofkP030000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h0
0P3om^h2000000D0ooK^00<000000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP03000000H0ooK^
00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP02000000L0ooK^00<000000?ofkP3om^h0
2@3om^h3000000T0ooK^00<000000?ofkP3om^h0203om^h3000000/0ooK^00<000000?ofkP3om^h0
G03om^h10?ooo`00VP3om^h2000000D0ooK^00<000000?ofkP3om^h02@3om^h00`000000ooK^0?of
kP03000000H0ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP02000000L0ooK^00<0
00000?ofkP3om^h02@3om^h3000000T0ooK^00<000000?ofkP3om^h0203om^h3000000X0ooK^00<0
00000?ofkP3om^h01@3om^h300000080ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?of
kP040?ofkP<000000P3om^h00`000000ooK^0?ofkP090?ofkP030000003om^h0ooK^05`0ooK^0@3o
ool009P0ooK^0P0000080?ofkP030000003om^h0ooK^00P0ooK^0`0000090?ofkP030000003om^h0
ooK^00P0ooK^0`00000:0?ofkP030000003om^h0ooK^00D0ooK^0`0000020?ofkP030000003om^h0
ooK^00P0ooK^00<000000?ofkP3om^h0103om^h300000080ooK^00<000000?ofkP3om^h02@3om^h0
0`000000ooK^0?ofkP04000000D0ooK^00<000000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP03
000000D0ooK^00<000000?ofkP3om^h02@3om^h2000005d0ooK^0@3oool009D0ooK^0`00000;0?of
kP030000003om^h0ooK^00@0ooK^0`0000020?ofkP030000003om^h0ooK^00P0ooK^00<000000?of
kP3om^h0103om^h300000080ooK^00<000000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP040000
00D0ooK^00<000000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP03000000H0ooK^00<000000?of
kP3om^h0203om^h3000000X0ooK^00<000000?ofkP3om^h0203om^h3000000T0ooK^00<000000?of
kP3om^h01P3om^h200000080ooK^00<000000?ofkP3om^h0FP3om^h10?ooo`00TP3om^h300000080
ooK^00<000000?ofkP3om^h02P3om^h00`000000ooK^0?ofkP03000000H0ooK^00<000000?ofkP3o
m^h0203om^h00`000000ooK^0?ofkP03000000H0ooK^00<000000?ofkP3om^h0203om^h3000000X0
ooK^00<000000?ofkP3om^h0203om^h3000000T0ooK^00<000000?ofkP3om^h01P3om^h200000080
ooK^00<000000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP040?ofkP<000000P3om^h00`000000
ooK^0?ofkP080?ofkP030000003om^h0ooK^0080ooK^0`0000040?ofkP030000003om^h0ooK^05X0
ooK^0@3oool008l0ooK^0`0000060?ofkP030000003om^h0ooK^00T0ooK^0`0000090?ofkP030000
003om^h0ooK^00P0ooK^0`0000090?ofkP030000003om^h0ooK^00H0ooK^0P0000020?ofkP030000
003om^h0ooK^00T0ooK^00<000000?ofkP3om^h0103om^h300000080ooK^00<000000?ofkP3om^h0
203om^h00`000000ooK^0?ofkP030?ofkP8000001@3om^h00`000000ooK^0?ofkP080?ofkP030000
003om^h0ooK^00@000001@3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00800000
203om^h00`000000ooK^0?ofkP1I0?ofkP40oooo002<0?ofkP<000002P3om^h00`000000ooK^0?of
kP060?ofkP8000000P3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00@0ooK^0`00
00020?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h00`3om^h2000000D0ooK^00<0
00000?ofkP3om^h0203om^h00`000000ooK^0?ofkP04000000D0ooK^00<000000?ofkP3om^h02@3o
m^h00`000000ooK^0?ofkP02000000L0ooK^00<000000?ofkP3om^h0203om^h3000000X0ooK^00<0
00000?ofkP3om^h01`3om^h3000000/0ooK^00<000000?ofkP3om^h0F03om^h10?ooo`00RP3om^h2
00000080ooK^00<000000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP030?ofkP8000001@3om^h0
0`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00<000001P3om^h00`000000ooK^0?ofkP08
0?ofkP030000003om^h0ooK^008000001`3om^h00`000000ooK^0?ofkP080?ofkP<000002P3om^h0
0`000000ooK^0?ofkP080?ofkP<000002P3om^h00`000000ooK^0?ofkP040?ofkP<000000P3om^h0
0`000000ooK^0?ofkP090?ofkP030000003om^h0ooK^00<0ooK^0`0000020?ofkP030000003om^h0
ooK^00T0ooK^00<000000?ofkP3om^h0F03om^h10?ooo`00Q`3om^h3000000D0ooK^00<000000?of
kP3om^h02@3om^h00`000000ooK^0?ofkP02000000L0ooK^00<000000?ofkP3om^h0203om^h30000
00T0ooK^00<000000?ofkP3om^h0203om^h3000000X0ooK^00<000000?ofkP3om^h0103om^h30000
0080ooK^00<000000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP040?ofkP<000000P3om^h00`00
0000ooK^0?ofkP090?ofkP030000003om^h0ooK^00<000001P3om^h00`000000ooK^0?ofkP080?of
kP030000003om^h0ooK^00<000001P3om^h00`000000ooK^0?ofkP080?ofkP800000F@3om^h10?oo
o`00Q03om^h3000000T0ooK^00<000000?ofkP3om^h0203om^h3000000X0ooK^00<000000?ofkP3o
m^h0103om^h300000080ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP040?ofkP<0
00000P3om^h00`000000ooK^0?ofkP090?ofkP030000003om^h0ooK^00<000001P3om^h00`000000
ooK^0?ofkP080?ofkP030000003om^h0ooK^00@000001@3om^h00`000000ooK^0?ofkP090?ofkP<0
00002@3om^h00`000000ooK^0?ofkP080?ofkP<000002@3om^h00`000000ooK^0?ofkP060?ofkP80
00000P3om^h00`000000ooK^0?ofkP1F0?ofkP40oooo00210?ofkP<000000P3om^h00`000000ooK^
0?ofkP080?ofkP030000003om^h0ooK^00@0ooK^0`0000020?ofkP030000003om^h0ooK^00T0ooK^
00<000000?ofkP3om^h00`0000060?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h0
0`0000060?ofkP030000003om^h0ooK^00P0ooK^0`0000090?ofkP030000003om^h0ooK^00P0ooK^
0`00000:0?ofkP030000003om^h0ooK^00H0ooK^0P0000020?ofkP030000003om^h0ooK^00P0ooK^
00<000000?ofkP3om^h0103om^h300000080ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^
0?ofkP030?ofkP800000103om^h00`000000ooK^0?ofkP1F0?ofkP40oooo001n0?ofkP<000001P3o
m^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00<000001P3om^h00`000000ooK^0?of
kP080?ofkP<000002@3om^h00`000000ooK^0?ofkP080?ofkP<000002@3om^h00`000000ooK^0?of
kP060?ofkP8000000P3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00@0ooK^0`00
00020?ofkP030000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h00P3om^h3000000@0ooK^00<0
00000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP03000000D0ooK^00<000000?ofkP3om^h02@3o
m^h00`000000ooK^0?ofkP02000000L0ooK^00<000000?ofkP3om^h0E@3om^h10?ooo`00N`3om^h3
000000T0ooK^00<000000?ofkP3om^h0203om^h3000000T0ooK^00<000000?ofkP3om^h01P3om^h2
00000080ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP040?ofkP<000000P3om^h0
0`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00<0ooK^0P0000050?ofkP030000003om^h0
ooK^00P0ooK^00<000000?ofkP3om^h00`0000060?ofkP030000003om^h0ooK^00P0ooK^00<00000
0?ofkP3om^h00P0000080?ofkP030000003om^h0ooK^00P0ooK^0`0000090?ofkP030000003om^h0
ooK^00P0ooK^0`00000:0?ofkP030000003om^h0ooK^05@0ooK^0@3oool007T0ooK^0P0000020?of
kP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h0103om^h300000080ooK^00<000000?of
kP3om^h0203om^h00`000000ooK^0?ofkP030?ofkP8000001@3om^h00`000000ooK^0?ofkP080?of
kP030000003om^h0ooK^00<000001P3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^
008000001`3om^h00`000000ooK^0?ofkP080?ofkP<000002@3om^h00`000000ooK^0?ofkP080?of
kP<000002`3om^h00`000000ooK^0?ofkP040?ofkP<000000P3om^h00`000000ooK^0?ofkP080?of
kP030000003om^h0ooK^00@0ooK^0`0000020?ofkP030000003om^h0ooK^00P0ooK^00<000000?of
kP3om^h0E03om^h10?ooo`00M`3om^h2000000D0ooK^00<000000?ofkP3om^h0203om^h00`000000
ooK^0?ofkP03000000H0ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP02000000L0
ooK^00<000000?ofkP3om^h0203om^h3000000T0ooK^00<000000?ofkP3om^h0203om^h3000000X0
ooK^00<000000?ofkP3om^h0103om^h300000080ooK^00<000000?ofkP3om^h0203om^h00`000000
ooK^0?ofkP040?ofkP<000000P3om^h00`000000ooK^0?ofkP090?ofkP030000003om^h0ooK^00@0
00001@3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00@000001@3om^h00`000000
ooK^0?ofkP080?ofkP800000E@3om^h10?ooo`00M@3om^h2000000L0ooK^00<000000?ofkP3om^h0
203om^h3000000T0ooK^00<000000?ofkP3om^h0203om^h3000000X0ooK^00<000000?ofkP3om^h0
103om^h300000080ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP040?ofkP<00000
0P3om^h00`000000ooK^0?ofkP090?ofkP030000003om^h0ooK^00<000001P3om^h00`000000ooK^
0?ofkP080?ofkP030000003om^h0ooK^00<000001P3om^h00`000000ooK^0?ofkP080?ofkP<00000
2P3om^h00`000000ooK^0?ofkP070?ofkP<000002P3om^h00`000000ooK^0?ofkP050?ofkP800000
0P3om^h00`000000ooK^0?ofkP1B0?ofkP40oooo001b0?ofkP<000002P3om^h00`000000ooK^0?of
kP040?ofkP<000000P3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00@0ooK^0`00
00020?ofkP030000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h00`0000060?ofkP030000003o
m^h0ooK^00P0ooK^00<000000?ofkP3om^h00`0000060?ofkP030000003om^h0ooK^00P0ooK^0`00
00090?ofkP030000003om^h0ooK^00P0ooK^0`00000:0?ofkP030000003om^h0ooK^00@0ooK^0`00
00020?ofkP030000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h00`3om^h300000080ooK^00<0
00000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP020?ofkP800000103om^h00`000000ooK^0?of
kP1B0?ofkP40oooo001_0?ofkP<000000P3om^h00`000000ooK^0?ofkP090?ofkP030000003om^h0
ooK^00<000001P3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00<000001P3om^h0
0`000000ooK^0?ofkP080?ofkP<000002@3om^h00`000000ooK^0?ofkP080?ofkP<000002P3om^h0
0`000000ooK^0?ofkP040?ofkP<000000P3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0
ooK^00@0ooK^0`0000020?ofkP030000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h00`000006
0?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h00`0000060?ofkP030000003om^h0
ooK^00P0ooK^00<000000?ofkP3om^h00P0000070?ofkP030000003om^h0ooK^0540ooK^0@3oool0
06`0ooK^0`0000060?ofkP030000003om^h0ooK^00P0ooK^0`0000090?ofkP030000003om^h0ooK^
00P0ooK^0`00000:0?ofkP030000003om^h0ooK^00@0ooK^0`0000020?ofkP030000003om^h0ooK^
00P0ooK^00<000000?ofkP3om^h0103om^h300000080ooK^00<000000?ofkP3om^h02@3om^h00`00
0000ooK^0?ofkP03000000H0ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP030000
00H0ooK^00<000000?ofkP3om^h0203om^h3000000T0ooK^00<000000?ofkP3om^h0203om^h30000
00T0ooK^00<000000?ofkP3om^h0203om^h3000000X0ooK^00<000000?ofkP3om^h0D03om^h10?oo
o`00J@3om^h3000000X0ooK^0P0000060?ofkP8000000P3om^h00`000000ooK^0?ofkP080?ofkP03
0000003om^h0ooK^00@0ooK^0`0000020?ofkP030000003om^h0ooK^00T0ooK^00<000000?ofkP3o
m^h00`0000060?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h00`0000030?ofkQD0
00001@3om^h00`000000ooK^0?ofkP080?ofkP<000002@3om^h00`000000ooK^0?ofkP060?ofkP80
00000P3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00@0ooK^0`0000020?ofkP03
0000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h0103om^h300000080ooK^00<000000?ofkP3o
m^h0203om^h00`000000ooK^0?ofkP1@0?ofkP40oooo001W0?ofkP8000000P3om^h00`000000ooK^
0?ofkP0:0?ofkP030000003om^h0ooK^00<000001@3om^h00`000000ooK^0?ofkP080?ofkP030000
003om^h0ooK^00<000001P3om^h00`000000ooK^0?ofkP080?ofkP<000002@3om^h00`000000ooK^
0?ofkP080?ofkP<0000000<0ooK^0000000000000`0000000`0Y000000000000000@000000<0IP00
1P0000060?ofkP<000000P3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00<0ooK^
0P0000040?ofkP030000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h00`0000050?ofkP030000
003om^h0ooK^00T0ooK^00<000000?ofkP3om^h00`0000060?ofkP030000003om^h0ooK^00L0ooK^
0P00001A0?ofkP40oooo001T0?ofkP<000001@3om^h00`000000ooK^0?ofkP090?ofkP<000002@3o
m^h00`000000ooK^0?ofkP070?ofkP<000002@3om^h00`000000ooK^0?ofkP060?ofkP8000000P3o
m^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00@0ooK^1P00000302T000@0000000@0
H0070000001n1Q0000001@1n1Q020000000307h640000000UAP>0080UAP>00<0000009DH3P000000
3P0000060?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h00P0000070?ofkP030000
003om^h0ooK^00P0ooK^0`0000090?ofkP030000003om^h0ooK^00P0ooK^0`0000090?ofkP030000
003om^h0ooK^00@0ooK^0`0000020?ofkP030000003om^h0ooK^04h0ooK^0@3oool00640ooK^0`00
00090?ofkP030000003om^h0ooK^00H0ooK^0P0000020?ofkP030000003om^h0ooK^00P0ooK^00<0
00000?ofkP3om^h0103om^h200000080ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?of
kP030?ofkP8000001@3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00<0000000D0
ooK^000000000000000002T00004000000@0H00700D0000007h6401n1Q00OPH@0000000207h64080
0000101n1Q0010000000UAP>09DH3P00000709DH3P030000002U8P<0YB8300L000001@3om^h00`00
0000ooK^0?ofkP080?ofkP<000002P3om^h00`000000ooK^0?ofkP040?ofkP<000000P3om^h00`00
0000ooK^0?ofkP080?ofkP030000003om^h0ooK^00@0ooK^0`0000020?ofkP030000003om^h0ooK^
00P0ooK^00<000000?ofkP3om^h00`0000060?ofkP030000003om^h0ooK^04d0ooK^0@3oool005h0
ooK^0`0000020?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h00`3om^h2000000D0
ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP03000000D0ooK^00<000000?ofkP3o
m^h0203om^h00`000000ooK^0?ofkP02000000L0ooK^00<000000?ofkP3om^h0203om^h300000080
ooK^1P0000000`1P00L0000006001`0506001`040000001n1Q00OPH@07h640l000001@2E60h30000
0080YB8300@000000:DR0`2U8P<0YB83100000030?ofkP030000003om^h0ooK^00@0ooK^0`000002
0?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h0100000050?ofkP030000003om^h0
ooK^00P0ooK^00<000000?ofkP3om^h0100000060?ofkP030000003om^h0ooK^00L0ooK^0`000009
0?ofkP030000003om^h0ooK^04d0ooK^0@3oool005/0ooK^0`0000060?ofkP030000003om^h0ooK^
00P0ooK^00<000000?ofkP3om^h00P0000070?ofkP030000003om^h0ooK^00P0ooK^0`0000090?of
kP030000003om^h0ooK^00L0ooK^0`00000:0?ofkP030000003om^h0ooK^00@0ooK^0`0000020?of
kPH000001@1P00L00`000000H00706001`0:000000H0US9500<000000:U2A02Y@T@00P2Y@T@:0000
0080YB8300<000000:DR0`2U8P<00`2U8P<300000080ooK^00<000000?ofkP3om^h00`0000060?of
kP030000003om^h0ooK^00L0ooK^0`00000:0?ofkP030000003om^h0ooK^00L0ooK^0`00000:0?of
kP030000003om^h0ooK^00@0ooK^0`0000020?ofkP030000003om^h0ooK^00P0ooK^00<000000?of
kP3om^h0C03om^h10?ooo`00F03om^h3000000T0ooK^00<000000?ofkP3om^h0203om^h3000000X0
ooK^00<000000?ofkP3om^h0103om^h300000080ooK^00<000000?ofkP3om^h0203om^h00`000000
ooK^0?ofkP040?ofkP8000000P3om^h00`000000ooK^0?ofkP090?ofkP030000003om^h0ooK^00<0
00000`3om^h4000000<0=@0000<0000006001`1P00L01P000000101m7D00000000000000000609Hb
A@030000002F<TD0US9500<0US9500<000000:U2A02Y@T@00P2Y@T@3000000@0ZD9400<000000;Y>
?@2jCSd0100000040:DR0`030000002_9@00[bD000D000002@3om^h00`000000ooK^0?ofkP040?of
kP<000000P3om^h00`000000ooK^0?ofkP090?ofkP030000003om^h0ooK^00<0ooK^0`0000020?of
kP030000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h00`0000050?ofkP030000003om^h0ooK^
00T0ooK^00<000000?ofkP3om^h0B`3om^h10?ooo`00EP3om^h200000080ooK^00<000000?ofkP3o
m^h0203om^h00`000000ooK^0?ofkP040?ofkP<000000P3om^h00`000000ooK^0?ofkP090?ofkP03
0000003om^h0ooK^00<000001P3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00<0
00001@3om^h00`000000ooK^0?ofkP080?ofkP<00000103om^h2000000<0=@0000<0000003D00000
00001000000407dM@0<000000P1m7D000`000000US9509HbA@0509HbA@030000002F<TD0US950080
US9500<000000:U2A00000000P0000020:U2A0030000002Y@T@0ZD9400<0ZD9400<000000;Y>?@2j
CSd00P2jCSd5000000030:DR0`00000000000080000000<0[bD00000000000002P3om^h00`000000
ooK^0?ofkP03000000H0ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP03000000D0
ooK^00<000000?ofkP3om^h02@3om^h3000000T0ooK^00<000000?ofkP3om^h0203om^h2000004`0
ooK^0@3oool005<0ooK^0`0000050?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h0
0`0000060?ofkP030000003om^h0ooK^00P0ooK^0`0000090?ofkP030000003om^h0ooK^00P0ooK^
0`0000090?ofkP8000001P3om^h200000080ooK^00<000000?ofkP3om^h00P00000403D000<00000
00<0G@0c0000001m7D000`1m7D0300000080OAe000<0000007dM@00000002@2F<TD00`000000US95
09HbA@03000000H0ZD9400<000000:U2A02Y@T@00P2Y@T@00`000000^Thm0;Y>?@030;Y>?@030000
002jCSd0^Thm00D00000102_9@02000000P0ooK^0`0000090?ofkP030000003om^h0ooK^00P0ooK^
0`0000090?ofkP030000003om^h0ooK^00H0ooK^0P0000020?ofkP030000003om^h0ooK^00P0ooK^
00<000000?ofkP3om^h0103om^h3000000030?ofkP000000ooK^04/0ooK^0@3oool00500ooK^0`00
00090?ofkP030000003om^h0ooK^00L0ooK^0`00000:0?ofkP8000001P3om^h200000080ooK^00<0
00000?ofkP3om^h0203om^h00`000000ooK^0?ofkP040?ofkP<000000P3om^h00`000000ooK^0?of
kP090?ofkP030000003om^h0ooK^00<000001@3om^h3000000<0=@000P00000305d0<`030000001m
7D00OAe000<000001P1m7D02000000L0US952P0000040:U2A0030000002Y@T@0ZD940080ZD9400<0
00000;Y>?@2jCSd00`2jCSd3000000<0^Thm00@000000<UF;P00000000000P2_9@0010000000[bD0
0000000000030?ofkP<000000P3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00@0
ooK^0`0000020?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h00P3om^h3000000@0
ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP04000000D0ooK^00<000000?ofkP3o
m^h0B@3om^h10?ooo`00CP3om^h200000080ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^
0?ofkP040?ofkP8000000P3om^h00`000000ooK^0?ofkP0:0?ofkP030000003om^h0ooK^00<00000
1@3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00<000001P3om^h00`000000ooK^
0?ofkP080?ofkP<000001`3om^h7000000D0G@0c0`00000807dM@0`000000P2RCVH00`000000XTiV
000000030;=LIPL000000`2Y@T@00`000000^Thm0000000200000080^Thm00<000000;Y>?@2jCSd0
0P2jCSd00`000000bEH^0<UF;P02000000030:lU00000000[bD000@000001P3om^h00`000000ooK^
0?ofkP080?ofkP030000003om^h0ooK^00<000001@3om^h00`000000ooK^0?ofkP080?ofkP030000
003om^h0ooK^00800000203om^h00`000000ooK^0?ofkP070?ofkP<000002@3om^h00`000000ooK^
0?ofkP190?ofkP40oooo001;0?ofkP<000001@3om^h00`000000ooK^0?ofkP080?ofkP030000003o
m^h0ooK^00<000001@3om^h00`000000ooK^0?ofkP090?ofkP<000002@3om^h00`000000ooK^0?of
kP070?ofkP<000002P3om^h00`000000ooK^0?ofkP040?ofkP<000000P3om^h00`000000ooK^0?of
kP030?ofkPH000001P1M03<30000000307dM@0000000OAe000<0OAe01000000208dmH`8000000P2R
CVH3000000H0XTiV0P0000090;=LIPL00000102jCSd00`000000^Thm0;Y>?@020;Y>?@0300000039
ERh0bEH^0080bEH^100000000`2Y7@000000000000060?ofkP030000003om^h0ooK^00P0ooK^0`00
00090?ofkP030000003om^h0ooK^00L0ooK^0`00000;0?ofkP030000003om^h0ooK^00<0ooK^0`00
00020?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h0B03om^h10?ooo`00B03om^h3
000000T0ooK^00<000000?ofkP3om^h01`3om^h3000000T0ooK^0P0000060?ofkP<000000P3om^h0
0`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00@0ooK^0P0000020?ofkP030000003om^h0
ooK^00T0ooK^00<000000?ofkP3om^h00`0000060?ofkP040000003om^h0ooK^0?ofkPD000000P1M
03<00`000000G@0c05d0<`030000000405d0<`000000OAe007dM@0D000001P2=?F<4000000T0XTiV
0P0000090;=LIP<0000000@0/eaV00000033J680`fQR100000000`2jCSd000000;Y>?@020;Y>?@04
00000039ERh0bEH^0<UF;P80000000@0bEH^00000000000000000P2Y7@02000000D0ooK^00<00000
0?ofkP3om^h0103om^h300000080ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP03
0?ofkP<000000P3om^h00`000000ooK^0?ofkP090?ofkP030000003om^h0ooK^00<000001@3om^h0
0`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^04P0ooK^0@3oool004D0ooK^0`0000020?of
kP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h0103om^h200000080ooK^00<000000?of
kP3om^h02@3om^h00`000000ooK^0?ofkP03000000H0ooK^00<000000?ofkP3om^h0203om^h00`00
0000ooK^0?ofkP03000000D0ooK^00<000000?ofkP3om^h0203om^h3000000T0ooK^00<000000?of
kP3om^h010000000100/01/0000005d0<`1M03<3000000<0G@0c1000000208dmH`030000002=?F<0
SCeS00@0SCeS0`0000020:9>IP030000002RCVH0XTiV00P0XTiV00<000000;=LIP2cG6H0102cG6H3
00000080/eaV00<000000;=LIP0000001P33J68400000080^Thm0`0000050<UF;P8000000`2Y7@00
0`000000ooK^0?ofkP030?ofkP030000003om^h0ooK^00<000001@3om^h00`000000ooK^0?ofkP08
0?ofkP030000003om^h0ooK^00<000001P3om^h00`000000ooK^0?ofkP080?ofkP<000002@3om^h0
0`000000ooK^0?ofkP070?ofkP800000B@3om^h10?ooo`00@P3om^h3000000H0ooK^00<000000?of
kP3om^h0203om^h00`000000ooK^0?ofkP03000000D0ooK^00<000000?ofkP3om^h0203om^h30000
00T0ooK^00<000000?ofkP3om^h0203om^h3000000T0ooK^00<000000?ofkP3om^h0103om^h30000
0080ooK^00<000000?ofkP3om^h0203om^h400000080;00K1000000205d0<`@0000000<0LbIL0000
002=?F<0102=?F<00`000000SCeS08dmH`030000000308dmH`000000XTiV00<0XTiV00<000000:9>
IP2RCVH01`2RCVH200000080/eaV0`0000050;=LIP030000002cG6H0000000P0`fQR00<000000<=X
HP0000000`0000060<UF;P80000000D0dUTB0000002Y7@00ZAd0000000040?ofkP<000002@3om^h0
0`000000ooK^0?ofkP070?ofkP<000002P3om^h00`000000ooK^0?ofkP040?ofkP<000000P3om^h0
0`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00<0ooK^0`0000020?ofkP030000003om^h0
ooK^04H0ooK^0@3oool003l0ooK^0`0000090?ofkP030000003om^h0ooK^00P0ooK^0`0000090?of
kP8000001P3om^h200000080ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP040?of
kP<000000P3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00<000001P3om^h00`00
0000ooK^0?ofkP060?ofkP@0000000@0;00K00000000000000000`1M03<4000000<0LbIL00<00000
08dmH`2=?F<00`2=?F<3000000@0SCeS00<000000:9>IP2RCVH00P2RCVH00`000000XTiV0:9>IP07
0:9>IP@000002@2cG6H2000000P0`fQR0`0000000`33J68000000=9cFP03000000@0bEH^0P000000
103BFA8000000000002Y7@0400000080ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?of
kP030?ofkP<000000P3om^h00`000000ooK^0?ofkP090?ofkP030000003om^h0ooK^00<000001@3o
m^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00<000001P3om^h00`000000ooK^0?of
kP150?ofkP40oooo000m0?ofkP8000000P3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0
ooK^00@0ooK^0`0000020?ofkP030000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h00`000005
0?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h00`0000060?ofkP030000003om^h0
ooK^00L0ooK^0`0000090?ofkP030000003om^h0ooK^00D0ooK^1P0000000`0/01/0000005d0<`03
000000@0LbIL00@0000007<VG01c9U`000000`2=?F<200000080SCeS00<0000008dmH`2=?F<00P2=
?F<00`000000XTiV0:9>IP030:9>IP030000002RCVH0000000d000001`2cG6H00`000000`fQR0<=X
HP030<=XHP<000000P33J6800`000000`fQR000000040=9cFP8000000`39ERh00`000000dUTB0=9I
4P04000000@0ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP03000000H0ooK^00<0
00000?ofkP3om^h0203om^h3000000T0ooK^00<000000?ofkP3om^h01`3om^h3000000T0ooK^00<0
00000?ofkP3om^h0A@3om^h10?ooo`00>P3om^h3000000D0ooK^00<000000?ofkP3om^h0203om^h0
0`000000ooK^0?ofkP03000000H0ooK^00<000000?ofkP3om^h0203om^h3000000T0ooK^00<00000
0?ofkP3om^h01`3om^h3000000X0ooK^00<000000?ofkP3om^h0103om^h200000080ooK^00<00000
0?ofkP3om^h0203om^h00`000000ooK^0?ofkP030?ofkP@000000P0/01/010000000;00K00000000
000807<VG080000000@0SCeS00000000000000001@2=?F<00`000000SCeS0000000900000080Z65m
0`0000020:QQO@040000002gKWd0]fim000000<0]fim2@0000001033J68000000000000000060<=X
HP8000001P3BLeX6000000<0dUTB0P0000040?ofkP030000003om^h0ooK^00L0ooK^0`00000:0?of
kP030000003om^h0ooK^00@0ooK^0`0000020?ofkP030000003om^h0ooK^00P0ooK^00<000000?of
kP3om^h00`3om^h300000080ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP140?of
kP40oooo000g0?ofkP<000002@3om^h00`000000ooK^0?ofkP070?ofkP<000002P3om^h00`000000
ooK^0?ofkP040?ofkP<000000P3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00@0
ooK^0P0000020?ofkP030000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h00`0000050?ofkP03
0000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h00`00000502`06`<000002@1c9U`3000000H0
SCeS1000000209ICN`030000002XHGd0Z65m00@0Z65m0`0000050:QQO@050000002gKWd0]fim0;M^
O@0000002@2gKWd6000000L0`fQR0P0000050=9cFPH000001@3BFA800`000000ooK^0?ofkP020?of
kP030000003om^h0ooK^00<0ooK^0`0000020?ofkP030000003om^h0ooK^00T0ooK^00<000000?of
kP3om^h00`0000050?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h00`0000060?of
kP030000003om^h0ooK^00L0ooK^0P0000150?ofkP40oooo000e0?ofkP8000000P3om^h00`000000
ooK^0?ofkP080?ofkP030000003om^h0ooK^00@0ooK^0P0000020?ofkP030000003om^h0ooK^00T0
ooK^00<000000?ofkP3om^h00`0000060?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3o
m^h00`0000050?ofkP030000003om^h0ooK^00P0ooK^0`0000090?ofkP030000003om^h0ooK^00L0
ooK^1P00000302`06`80000000<0CPE?0000000000001P1c9U`30000000407<VG0000000000008dm
H`D000000`2FDg/010000000UU=k09ICN`0000030:QQO@<000000P2XHGd00`000000Z65m0:QQO@03
0:QQO@030000002gKWd0]fim0080]fim00<000000;M^O@2gKWd00`2gKWd4000000030<IjN`000000
aWYk0080aWYk0`0000050<=XHP030000003BLeX0dW=J00<00000103BLeX3000000@0dUTB0P000003
0?ofkP030000003om^h0ooK^00<000001P3om^h00`000000ooK^0?ofkP080?ofkP<000002@3om^h0
0`000000ooK^0?ofkP070?ofkP<000002@3om^h00`000000ooK^0?ofkP040?ofkP<000000P3om^h0
0`000000ooK^0?ofkP120?ofkP40oooo000b0?ofkP<000001@3om^h00`000000ooK^0?ofkP080?of
kP030000003om^h0ooK^00<000001@3om^h00`000000ooK^0?ofkP080?ofkP<000002@3om^h00`00
0000ooK^0?ofkP080?ofkP<000002@3om^h00`000000ooK^0?ofkP040?ofkP<000000P3om^h00`00
0000ooK^0?ofkP080?ofkP030000003om^h0ooK^00@0ooK^0P0000020?ofkP<000000`0/01/01`00
0000CPE?04h5C`1>1Dl0000007<VG00000000P1c9U`3000000<0LbIL1000000909ICN`030000002F
Dg/0000000<000001P2XHGd00`000000Z65m0:QQO@020:QQO@030000002gKWd0]fim0080]fim00<0
00000;M^O@2gKWd00`0000030;M^O@0400000036NW/0aWYk000000D0aWYk100000001033J6800000
0000000000080=9cFP@000000`3BFA8200000080ooK^0`0000090?ofkP030000003om^h0ooK^00D0
ooK^0`0000020?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h00`3om^h300000080
ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP03000000D0ooK^00<000000?ofkP3o
m^h0@P3om^h10?ooo`00;`3om^h3000000T0ooK^00<000000?ofkP3om^h01`3om^h3000000T0ooK^
0P0000060?ofkP8000000P3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00@0ooK^
0`0000020?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h00`0000060?ofkP030000
003om^h0ooK^00P0ooK^00<000000?ofkP3om^h00`0000030?ofkP@0000000<0;00K000000000000
101>1Dl00`000000LbIL00000002000000<0LbIL0`0000001021@GP0000009ICN`00000909ICN`<0
00002@2XHGd00`000000Z65m0:QQO@020:QQO@030000002gKWd0]fim0080]fim0`0000060;M^O@05
00000036NW/0aWYk0<IjN`0000001P36NW/6000000P0dW=J00D000000>5mB@000000hGe900000002
0=9I4P@000000P3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00@000001@3om^h0
0`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00<000001P3om^h00`000000ooK^0?ofkP07
0?ofkP<000002@3om^h00`000000ooK^0?ofkP110?ofkP40oooo000]0?ofkP8000000P3om^h00`00
0000ooK^0?ofkP080?ofkP030000003om^h0ooK^00@0ooK^0P0000020?ofkP030000003om^h0ooK^
00T0ooK^00<000000?ofkP3om^h00`0000050?ofkP030000003om^h0ooK^00P0ooK^00<000000?of
kP3om^h00`0000060?ofkP030000003om^h0ooK^00L0ooK^0`0000090?ofkP030000003om^h0ooK^
00P0ooK^0`0000050?ofkPH000001@1>1Dl300000080LbIL100000040851N0040000002FDg/0UU=k
000000D0UU=k0`00000209ICN`030000002XHGd0Z65m00P0Z65m00D000000:QQO@2XHGd0Z65m0000
00020;M^O@8000000P2gKWd00`000000]fim0;M^O@050;M^O@0500000036NW/0aWYk0<IjN`000000
0P36NW/3000000<0aWYk00<000000=F6MP0000000P0000060=9cFP030000003QODT000000080hGe9
100000000`39C`00ooK^0?ofkP020?ofkP030000003om^h0ooK^00L0ooK^0`00000:0?ofkP030000
003om^h0ooK^00L0ooK^0`0000090?ofkP030000003om^h0ooK^00@0ooK^0`0000020?ofkP030000
003om^h0ooK^00P0ooK^00<000000?ofkP3om^h0@03om^h10?ooo`00:P3om^h3000000D0ooK^00<0
00000?ofkP3om^h0203om^h00`000000ooK^0?ofkP03000000D0ooK^00<000000?ofkP3om^h0203o
m^h3000000T0ooK^00<000000?ofkP3om^h01`3om^h3000000X0ooK^00<000000?ofkP3om^h0103o
m^h200000080ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP040?ofkP<000000P3o
m^h00`000000ooK^0?ofkP020?ofkPD0000000@0CPE?0000001>1Dl0CPE?100000001P1c9U`00000
000000000000PD5h000000H0PD5h00@0000009ICN`2FDg/000000P2FDg/3000000D0UU=k00<00000
0:QQO@2XHGd02@2XHGd00`000000Z65m0:QQO@03000000D0]fim00<000000;M^O@2gKWd0102gKWd0
10000000aWYk0<IjN`36NW/3000000H0aWYk00D000000=F6MP3EQWH000000=F6MP03000000<0dW=J
00<000000>5mB@0000000P0000020>5mB@80000000<0bDl00000003om^h00P3om^h00`000000ooK^
0?ofkP040?ofkP<000000P3om^h00`000000ooK^0?ofkP090?ofkP030000003om^h0ooK^00<0ooK^
0`0000020?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h00`0000050?ofkP030000
003om^h0ooK^00P0ooK^00<000000?ofkP3om^h0@03om^h10?ooo`009`3om^h3000000T0ooK^00<0
00000?ofkP3om^h01`3om^h3000000T0ooK^0P0000060?ofkP8000000P3om^h00`000000ooK^0?of
kP080?ofkP030000003om^h0ooK^00@0ooK^0P0000020?ofkP030000003om^h0ooK^00T0ooK^00<0
00000?ofkP3om^h00`0000050?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h00`00
00060?ofkP030000003om^h0ooK^00H0000000@0CPE?00000000000000000`1>1Dl2000000@0PD5h
00<000000851N021@GP00`21@GP010000000UU=k09ICN`2FDg/3000000P0UU=k0P0000060:QQO@/0
00001@2gKWd00`000000]fim0;M^O@030;M^O@@000000P36NW/00`000000aWYk0<IjN`040<IjN`05
0000003EQWH0eHIf0=F6MP0000000`3EQWH500000080hGe900<000000>5mB@3QODT00P3QODT00`00
0000bDl0000000030?ofkP030000003om^h0ooK^00<000001P3om^h00`000000ooK^0?ofkP080?of
kP030000003om^h0ooK^00<000001P3om^h00`000000ooK^0?ofkP070?ofkP<000002@3om^h00`00
0000ooK^0?ofkP070?ofkP800000@@3om^h10?ooo`009@3om^h200000080ooK^00<000000?ofkP3o
m^h0203om^h00`000000ooK^0?ofkP040?ofkP8000000P3om^h00`000000ooK^0?ofkP090?ofkP03
0000003om^h0ooK^00<000001@3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00<0
00001@3om^h00`000000ooK^0?ofkP080?ofkP<000002@3om^h00`000000ooK^0?ofkP070?ofkP<0
00002P3om^h00`000000ooK^0000000600000080CPE?00<0000004h5C`0000000P0000060851N003
00000021@GP0PD5h0080PD5h00@0000009ICN`00000000000P2FDg/2000000D0UU=k2P000000102/
Khh000000000000000030:a_SP040000002jNhh0^W^>0;YkSPP0000000@0]fim0000000000000000
1P36NW/00`000000aWYk0<IjN`030<IjN`050000003EQWH0eHIf0=F6MP0000000P3EQWH300000003
0=F6MP000000000000<0hGe900@000000>5mB@3QODT0hGe90P0000001039C`0000000?ofkP3om^h3
000000T0ooK^00<000000?ofkP3om^h0203om^h3000000T0ooK^00<000000?ofkP3om^h0103om^h3
00000080ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP030?ofkP<000000P3om^h0
0`000000ooK^0?ofkP0n0?ofkP40oooo000R0?ofkP<000001@3om^h00`000000ooK^0?ofkP080?of
kP030000003om^h0ooK^00<000001@3om^h00`000000ooK^0?ofkP080?ofkP<000002@3om^h00`00
0000ooK^0?ofkP070?ofkP<000002@3om^h2000000H0ooK^0P0000020?ofkP030000003om^h0ooK^
00P0ooK^00<000000?ofkP3om^h0103om^h200000080ooK^00<000000?ofkP3om^h02@3om^h60000
00@0CPE?0P00000206<YL00300000021@GP0PD5h00D0PD5h00<000000851N021@GP00`00000609IC
N`D000000P2LHhd00`000000[6n>0:a_SP0<0:a_SP030000002jNhh0^W^>00T0^W^>1P0000040<Ij
N`0300000036NW/0aWYk00@0aWYk00<000000=F6MP3EQWH00`0000050=F6MP<000000P3QODT01`00
0000hGe90>5mB@000000jH4Y00000039C`000P0000020?ofkP030000003om^h0ooK^00P0ooK^00<0
00000?ofkP3om^h0103om^h300000080ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?of
kP03000000D0ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP03000000H0ooK^00<0
00000?ofkP3om^h0?@3om^h10?ooo`007`3om^h3000000T0ooK^00<000000?ofkP3om^h01`3om^h3
000000T0ooK^0P0000060?ofkP8000000P3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0
ooK^00@0ooK^0P0000020?ofkP030000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h00`000005
0?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h00`0000050?ofkP030000003om^h0
ooK^00L0ooK^1000000201@0=0070000001>1Dl0CPE?04h5C`000000HbU`0000000206<YL0030000
0021@GP0PD5h00D0PD5h0`0000001021@GP0000009ICN`2FDg/5000000L0W6>=00<000000:a_SP2/
Khh0302/Khh00`000000^W^>0;YkSP0<0;YkSP0300000037QXd0ahJ=00@0000000<0aWYk00000036
NW/00`36NW/400000080eHIf00<000000=F6MP3EQWH00`3EQWH010000000iI9^0>FBKP0000020>5m
B@030000003QODT0hGe900@00000103om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^
00<000001P3om^h00`000000ooK^0?ofkP070?ofkP<000002@3om^h00`000000ooK^0?ofkP070?of
kP<000002@3om^h00`000000ooK^0?ofkP0m0?ofkP40oooo000M0?ofkP8000000P3om^h00`000000
ooK^0?ofkP080?ofkP030000003om^h0ooK^00@0ooK^0P0000020?ofkP030000003om^h0ooK^00T0
ooK^00<000000?ofkP3om^h00`0000050?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3o
m^h00`0000050?ofkP030000003om^h0ooK^00P0ooK^0`0000080?ofkP030000003om^h0ooK^00P0
ooK^0`0000090?ofkP030000003om^h0ooK^00@0ooK^100000001P0D03@0000001@0=00D03@00000
04h5C`8000000`1S:G000`000000HbU`000000040851N0<0000000<0PD5h00000021@GP01000000<
09aSS@030000002/Khh0[6n>00`0[6n>00<000000;YkSP2jNhh0302jNhh00`000000ahJ=0<N6S@04
0<N6S@H0000000<0aWYk0000003EQWH0103EQWH00`000000eHIf0=F6MP020=F6MP060000003UTVh0
iI9^0>FBKP000000hGe9100000020>V1:@8000000`3om^h00`000000ooK^0?ofkP080?ofkP<00000
2@3om^h00`000000ooK^0?ofkP040?ofkP<000000P3om^h00`000000ooK^0?ofkP080?ofkP030000
003om^h0ooK^00<0ooK^0`0000020?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h0
?03om^h10?ooo`006P3om^h3000000D0ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?of
kP03000000D0ooK^00<000000?ofkP3om^h0203om^h3000000P0ooK^00<000000?ofkP3om^h0203o
m^h3000000T0ooK^00<000000?ofkP3om^h0103om^h300000080ooK^00<000000?ofkP3om^h01`3o
m^h00`000000ooK^0?ofkP040?ofkP<000000P3om^h00`000000ooK^0?ofkP080?ofkP030000003o
m^h0ooK^00<0000000<0ooK^0000000D03@00`0D03@4000000H0HbU`0P0000001021@GP000000000
000000030851N0<0000000<0RUB;0000002LHhd03@2LHhd00`000000[6n>0:a_SP0<0:a_SP030000
002jNhh0^W^>00`0^W^>00<000000<N6S@37QXd02@37QXd4000000D0eHIf00D000000=F6MP3EQWH0
eHIf000000020>FBKP@0000000<0hGe90000000000000`3YPBT2000000<0ooK^00<000000?ofkP3o
m^h0103om^h300000080ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP03000000D0
ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP03000000H0ooK^00<000000?ofkP3o
m^h01`3om^h2000003d0ooK^0@3oool001L0ooK^0`0000090?ofkP030000003om^h0ooK^00L0ooK^
0`0000090?ofkP8000001P3om^h200000080ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^
0?ofkP040?ofkP<000000P3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00<00000
1P3om^h00`000000ooK^0?ofkP070?ofkP030000003om^h0ooK^00<000001P3om^h00`000000ooK^
0?ofkP070?ofkP<000000`3om^h2000000@0500d0P00000806<YL0<000000`21@GP3000000@0RUB;
00<0000009aSS@2LHhd0302LHhd00`000000[6n>0:a_SP0<0:a_SP030000002jNhh0^W^>00`0^W^>
00<000000<N6S@37QXd00P37QXd00`000000ahJ=0<N6S@060<N6S@040000003ETX/00000000000@0
eHIf00<000000=F6MP3EQWH00`0000040>FBKP030000003QODT0000000@0jH4Y0P0000030?ofkP03
0000003om^h0ooK^00<000001P3om^h00`000000ooK^0?ofkP070?ofkP<000002@3om^h00`000000
ooK^0?ofkP070?ofkP<000002@3om^h00`000000ooK^0?ofkP040?ofkP<000000P3om^h00`000000
ooK^0?ofkP0j0?ofkP40oooo000E0?ofkP8000000P3om^h00`000000ooK^0?ofkP080?ofkP030000
003om^h0ooK^00@0ooK^0P0000020?ofkP030000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h0
0`0000050?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h00`0000060?ofkP030000
003om^h0ooK^00L0ooK^0`0000090?ofkP030000003om^h0ooK^00L0ooK^0`00000:0?ofkP030000
003om^h0ooK^00@0ooK^0P0000020?ofkP030000003om^h0ooK^008000001@0D03@2000000H0HbU`
0P0000000`1S:G00000000000003000000L0RUB;00<0000009aSS@2LHhd0302LHhd00`000000[6n>
0:a_SP0<0:a_SP030000002jNhh0^W^>00`0^W^>00<000000<N6S@37QXd02`37QXd010000000eI:;
0=FBR`3ETX/2000000<0eHIf0P0000000`3EQWH000000>FBKP050>FBKP<00000103YPBT00`000000
ooK^0?ofkP04000000T0ooK^00<000000?ofkP3om^h0103om^h300000080ooK^00<000000?ofkP3o
m^h0203om^h00`000000ooK^0?ofkP030?ofkP<000000P3om^h00`000000ooK^0?ofkP080?ofkP03
0000003om^h0ooK^00<000001@3om^h00`000000ooK^0?ofkP0j0?ofkP40oooo000B0?ofkP<00000
1@3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00<000001@3om^h00`000000ooK^
0?ofkP080?ofkP<00000203om^h00`000000ooK^0?ofkP070?ofkP<000002P3om^h00`000000ooK^
0?ofkP040?ofkP8000000P3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00@0ooK^
0P0000020?ofkP030000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h00`0000050?ofkP040000
003om^h00000000000<0500d0P0000000`0g1F8000000000000206<YL0<000000`1S:G02000000X0
RUB;00<0000009aSS@2LHhd0302LHhd00`000000[6n>0:a_SP0<0:a_SP030000002jNhh0^W^>00`0
^W^>00<000000<N6S@37QXd02`37QXd00`000000eI:;0=FBR`030=FBR`@000000P3EQWH00`000000
iI9^0>FBKP060>FBKP040000003YPBT0jH4Y0>V1:@@000000`3om^h00`000000ooK^0?ofkP080?of
kP030000003om^h0ooK^00<000001P3om^h00`000000ooK^0?ofkP070?ofkP030000003om^h0ooK^
00<000001P3om^h00`000000ooK^0?ofkP070?ofkP<000002@3om^h00`000000ooK^0?ofkP0i0?of
kP40oooo000@0?ofkP8000002@3om^h2000000P0ooK^0`0000090?ofkP030000003om^h0ooK^00@0
ooK^0`0000020?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h0103om^h200000080
ooK^00<000000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP03000000D0ooK^00<000000?ofkP3o
m^h0203om^h00`000000ooK^0?ofkP03000000D0ooK^00<000000?ofkP3om^h0203om^h3000000P0
ooK^0`00000301@0=0040000000g1F80=`ER03L5HP@00000101S:G03000000`0RUB;00<0000009aS
S@2LHhd02`2LHhd00`000000[6n>0:a_SP0<0:a_SP030000002jNhh0^W^>00`0^W^>00<000000<N6
S@37QXd02`37QXd00`000000eI:;0=FBR`060=FBR`80000000<0eHIf0000003UTVh01`3UTVh40000
0080jH4Y0P0000040?ofkP030000003om^h0ooK^00L0ooK^0`0000090?ofkP030000003om^h0ooK^
00H0ooK^100000090?ofkP030000003om^h0ooK^00@0ooK^0`0000020?ofkP030000003om^h0ooK^
00P0ooK^00<000000?ofkP3om^h0>03om^h10?ooo`004@3om^h00`000000ooK^0?ofkP090?ofkP04
0000003om^h0ooK^0?ofkP@000000P3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^
00<000001P3om^h00`000000ooK^0?ofkP070?ofkP030000003om^h0ooK^00<000001@3om^h00`00
0000ooK^0?ofkP080?ofkP<000002@3om^h00`000000ooK^0?ofkP070?ofkP<000002@3om^h20000
00H0ooK^0P0000020?ofkP030000003om^h0ooK^00L0ooK^0P00000201@0=0030000000g1F80=`ER
00<000000P1S:G000`000000HbU`06<YL00200000080LT:800<0000008YDR`2:E8/02P2:E8/00`00
0000W6>=09aSS@0;09aSS@030000002/Khh0[6n>00D0[6n>3`0000070;YkSP0300000037QXd0ahJ=
00/0ahJ=00<000000=FBR`3ETX/0203ETX/2000000H0iI9^0`0000000`3cWU`000000>V1:@020>V1
:@800000103om^h00`000000ooK^0?ofkP040?ofkP<000000P3om^h00`000000ooK^0?ofkP080?of
kP040000003om^h0ooK^0?ofkP@000000`3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0
ooK^00<000001P3om^h00`000000ooK^0?ofkP070?ofkP030000003om^h0ooK^03P0ooK^0@3oool0
0180ooK^00<000000?ofkP3om^h0203om^h4000000L0ooK^00<000000?ofkP3om^h01`3om^h30000
00X0ooK^00<000000?ofkP3om^h01P3om^h3000000T0ooK^0P0000060?ofkP8000000P3om^h00`00
0000ooK^0?ofkP080?ofkP030000003om^h0ooK^00@0ooK^0P0000020?ofkP030000003om^h0ooK^
00T0ooK^00<000000?ofkP3om^h00`0000050?ofkP030000003om^h0ooK^00D0ooK^00<000000000
0@0000001@0000000`0g1F80000006<YL00306<YL0800000101b@XP00`000000RUB;08YDR`0:08YD
R`030000002LHhd0W6>=00P0W6>=2`0000070:ijV`030000002kQI/0^hFK00D0^hFK2P00000;0<N6
S@030000003ETX/0eI:;00T0eI:;0`0000020>FBKP8000000`3UTVh300000080jH4Y0`0000040?of
kP030000003om^h0ooK^00<000001P3om^h00`000000ooK^0?ofkP070?ofkP@00000203om^h00`00
0000ooK^0?ofkP070?ofkP<000002@3om^h00`000000ooK^0?ofkP060?ofkP<00000>@3om^h10?oo
o`004`3om^h2000000H0ooK^0P0000020?ofkP030000003om^h0ooK^00L0ooK^0P0000050?ofkP80
00000P3om^h00`000000ooK^0?ofkP090?ofkP040000003om^h0ooK^0?ofkP@000000P3om^h00`00
0000ooK^0?ofkP090?ofkP030000003om^h0ooK^00<000001@3om^h00`000000ooK^0?ofkP080?of
kP030000003om^h0ooK^00<000001@3om^h00`000000ooK^0?ofkP080?ofkP<00000203om^h00`00
0000ooK^0?ofkP050?ofkPD00000100g1F800`000000HbU`06<YL002000000H0LT:800<0000008YD
R`2:E8/02P2:E8/010000000W6>=09aSS@2LHhd7000000<0X72K00<000000:ijV`2^NY/0302^NY/0
0`000000^hFK0;^5V`0<0;^5V`0300000037T9/0ai2K00@000001`37QXd00`000000eI:;0=FBR`09
0=FBR`030000003TWhL00000008000001@3UTVh00`000000liiL00000002000000030>V1:@000000
000000@0ooK^0`0000090?ofkP030000003om^h0ooK^00@0ooK^0`0000020?ofkP030000003om^h0
ooK^00L0ooK^00<000000?ofkP3om^h0103om^h300000080ooK^00<000000?ofkP3om^h0203om^h0
10000000ooK^0?ofkP3om^h4000000<0ooK^00<000000?ofkP3om^h0=P3om^h10?ooo`005@3om^h0
0`000000ooK^0?ofkP03000000D0ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP02
000000D0ooK^00<000000?ofkP3om^h0203om^h4000000L0ooK^00<000000?ofkP3om^h0203om^h3
000000T0ooK^0P0000080?ofkP<000002@3om^h00`000000ooK^0?ofkP040?ofkP<000000P3om^h0
0`000000ooK^0?ofkP070?ofkP030000003om^h0ooK^00<0ooK^0`00000203L5HP030000000g1F80
=`ER0080=`ER0`0000080792R0030000002:E8/0RUB;00T0RUB;1@00000:0:1`V`030000002^NY/0
[WZK00`0[WZK00<000000;^5V`2kQI/0302kQI/00`000000ai2K0<N@V`040<N@V`D000000P37QXd0
0`000000eI:;0=FBR`090=FBR`030000003TWhL000000080i9n70P0000030>FBKP050000003cWU`0
liiL0000003cWU`00P0000000`3CLP0000000000000200000080ooK^00<000000?ofkP3om^h0203o
m^h00`000000ooK^0?ofkP03000000D0ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?of
kP03000000H0ooK^00<000000?ofkP3om^h01`3om^h4000000L0ooK^00<000000?ofkP3om^h0=P3o
m^h10?ooo`005P3om^h2000000T0ooK^00<000000?ofkP3om^h01`3om^h3000000P0ooK^0P000006
0?ofkP8000000P3om^h00`000000ooK^0?ofkP070?ofkP8000001P3om^h200000080ooK^00<00000
0?ofkP3om^h02@3om^h010000000ooK^0?ofkP3om^h400000080ooK^00<000000?ofkP3om^h0203o
m^h00`000000ooK^0?ofkP03000000H0ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^0?of
kP05000000<0=`ER00D0000003L5HP0g1F80=`ER0000000:0792R0030000002:E8/0RUB;00H0RUB;
0`0000000`2@I9X000000:1`V`0<0:1`V`030000002^NY/0[WZK00`0[WZK00<000000;^5V`2kQI/0
302kQI/00`000000ai2K0<N@V`090<N@V`@000002P3ETX/00`000000i9n70>BOQ`040>BOQ`800000
00D0iI9^0000003cWU`0liiL000000020?>NG0<000001P3om^h00`000000ooK^0?ofkP070?ofkP<0
00002@3om^h00`000000ooK^0?ofkP070?ofkP<000002@3om^h00`000000ooK^0?ofkP040?ofkP<0
000000<0ooK^0000003om^h02@3om^h00`000000ooK^0?ofkP0e0?ofkP40oooo000G0?ofkP030000
003om^h0ooK^00P0ooK^00<000000?ofkP3om^h0103om^h200000080ooK^00<000000?ofkP3om^h0
203om^h00`000000ooK^0?ofkP03000000D0ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^
0?ofkP03000000D0ooK^00<000000?ofkP3om^h0203om^h4000000L0ooK^00<000000?ofkP3om^h0
1`3om^h3000000X0ooK^00<000000?ofkP3om^h01P3om^h3000000030?ofkP000000000100800000
100g1F8010000000=`ER0000000000030792R0030000001b@XP0LT:800@0LT:800<0000008YDR`2:
E8/00P2:E8/4000000@0T6BJ00<000000:1`V`2PL9/02`2PL9/00`000000[WZK0:ijV`0<0:ijV`03
0000002kQI/0^hFK00`0^hFK00<000000<N@V`37T9/02`37T9/010000000e9^J0000000000080=FB
R`030000003TWhL0i9n700H0i9n70`000000203cWU`00000000000000000liiL0000003CLP000000
1@3om^h00`000000ooK^0?ofkP040?ofkP<000000P3om^h00`000000ooK^0?ofkP080?ofkP030000
003om^h0ooK^00<0ooK^0`0000020?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h0
0`0000050?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h0=@3om^h10?ooo`00603o
m^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00<000001@3om^h00`000000ooK^0?of
kP070?ofkP<000002@3om^h00`000000ooK^0?ofkP070?ofkP<000002@3om^h00`000000ooK^0?of
kP040?ofkP<000000P3om^h00`000000ooK^0?ofkP070?ofkP030000003om^h0ooK^00@0ooK^0P00
00020?ofkP030000003om^h0ooK^00T0ooK^00@000000?ofkP3om^h0ooK^100000020?ofkP060000
003om^h000000000000004@00000100g1F820000000304lXP@000000LT:800T0LT:800<0000008YD
R`0000000P000008091TVP030000002PL9/0X72K00/0X72K00<000000:ijV`2^NY/0302^NY/00`00
0000^hFK0;^5V`0;0;^5V`0300000037T9/0ai2K00`0ai2K00@000000=BKVP3DViX0e9^J0P000006
0=FBR`050000003TWhL0i9n70>BOQ`0000001P3TWhL200000080liiL00<000000?>NG00000000P00
00060?ofkP030000003om^h0ooK^00<000001@3om^h00`000000ooK^0?ofkP080?ofkP030000003o
m^h0ooK^00<000001P3om^h00`000000ooK^0?ofkP070?ofkP<00000203om^h00`000000ooK^0?of
kP070?ofkP800000=P3om^h10?ooo`006@3om^h00`000000ooK^0?ofkP070?ofkP<000002@3om^h0
0`000000ooK^0?ofkP040?ofkP8000000P3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0
ooK^00@0ooK^0P0000020?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h00`000006
0?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h00`0000050?ofkP030000003om^h0
ooK^00P0ooK^100000070?ofkP80000000<000140000000g1F800`0g1F801@000000CbR104lXP@1?
:840000000X0LT:80P00000;091TVP030000002PL9/0X72K00/0X72K00<000000:ijV`2^NY/0302^
NY/00`000000^hFK0;^5V`0;0;^5V`0300000037T9/0ai2K00`0ai2K00<000000=BKVP3DViX00`3D
ViX3000000<0eI:;00<000000>BOQ`3TWhL0203TWhL2000000<0liiL0`0000000`3CLP0000000?of
kP040?ofkP<000002@3om^h00`000000ooK^0?ofkP070?ofkP<000002@3om^h00`000000ooK^0?of
kP040?ofkP<0000000<0ooK^0000003om^h02@3om^h00`000000ooK^0?ofkP030?ofkP<000000P3o
m^h00`000000ooK^0?ofkP0c0?ofkP40oooo000J0?ofkP030000003om^h0ooK^00@0ooK^0P000002
0?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h00`0000050?ofkP030000003om^h0
ooK^00P0ooK^00<000000?ofkP3om^h00`0000050?ofkP030000003om^h0ooK^00L0ooK^0`000009
0?ofkP030000003om^h0ooK^00L0ooK^0`0000090?ofkP8000001P3om^h200000080ooK^00<00000
0?ofkP3om^h01P3om^h2000000030000A0000000=`ER0080=`ER00<0000004lXP@1?:8400P1?:840
0`000000LT:80792R0060792R0<00000302@I9X00`000000X72K0:1`V`0;0:1`V`030000002^NY/0
[WZK00`0[WZK00<000000;^5V`2kQI/02`2kQI/00`000000ai2K0<N@V`0<0<N@V`030000003DViX0
e9^J00H0e9^J0P0000000`3ETX/000000>BOQ`090>BOQ`030000003c[gh000000080liiL0P000000
0`3dXSL00000000000020?ofkP<000000P3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0
ooK^00<0ooK^0`0000020?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h00`000005
0?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h00`0000060?ofkP030000003om^h0
ooK^0380ooK^0@3oool001/0ooK^00<000000?ofkP3om^h00`0000050?ofkP030000003om^h0ooK^
00L0ooK^0`0000090?ofkP030000003om^h0ooK^00L0ooK^0`0000090?ofkP030000003om^h0ooK^
00@0ooK^0P0000020?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h0103om^h20000
0080ooK^00<000000000o`3om^h02@3om^h00`000000ooK^0?ofkP03000000D0ooK^00<000000?of
kP3om^h01@3om^h01@0000000014000000000000=`ER008000001@1?:8400`000000LT:80792R004
0792R08000000P1lEYX00`000000T6BJ091TVP0;091TVP030000002PL9/0X72K00X0X72K00<00000
0:ijV`2^NY/0302^NY/00`000000^hFK0;^5V`0;0;^5V`0300000037T9/0ai2K00/0ai2K00<00000
0=BKVP3DViX02@3DViX2000000X0i9n700@000000?>_OP3c[gh000000P3cWU`00`000000m:8g0000
0003000000H0ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP03000000H0ooK^00<0
00000?ofkP3om^h01`3om^h3000000P0ooK^00<000000?ofkP3om^h01`3om^h3000000T0ooK^00<0
00000?ofkP3om^h0<P3om^h10?ooo`00703om^h2000000T0ooK^00<000000?ofkP3om^h0103om^h2
00000080ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP040?ofkP8000000P3om^h0
0`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00<000001@3om^h00`000000ooK^0?ofkP08
0?ofkP030000003om^h0ooK^00<0000000<0003o0?ofkP000?l00P000?l00`000000003o0000o`05
0000o`<0ooK^0`0000080?ofkP030000003om^h0ooK^00@0ooK^0P000000100004@0000000000000
000704lXP@030000001b@XP0LT:80080LT:80P00000407aFVP030000002@I9X0T6BJ00/0T6BJ00<0
00000:1`V`2PL9/02P2PL9/00`000000[WZK0:ijV`050:ijV`h000001`2kQI/00`000000ai2K0<N@
V`0;0<N@V`030000003DViX0e9^J00X0e9^J0`0000080>BOQ`050000003c[gh0ljmn0?>_OP000000
0P3cWU`4000000L0ooK^00<000000?ofkP3om^h01P3om^h4000000T0ooK^00<000000?ofkP3om^h0
103om^h300000080ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP030?ofkP<00000
0P3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^0340ooK^0@3oool001d0ooK^00<0
00000?ofkP3om^h0203om^h00`000000ooK^0?ofkP03000000D0ooK^00<000000?ofkP3om^h0203o
m^h00`000000ooK^0?ofkP03000000D0ooK^00<000000?ofkP3om^h01`3om^h3000000T0ooK^0P00
00080?ofkP<0000000<0ooK^0000o`000?l01P000?l00`000000003o0000o`040000o`<000000P3o
m^h00`000000ooK^0?ofkP070?ofkP030000003om^h0ooK^00<0ooK^0`0000000`0004@000000000
000704lXP@030000001b@XP0LT:8008000001P1lEYX00`000000T6BJ091TVP0;091TVP030000002P
L9/0X72K00L0X72K2`0000070;24YP030000002kSJH0^hfV00@0^hfV2P00000;0<N@V`030000003D
ViX0e9^J00X0e9^J00<000000>6YV@3QZIT00P0000050>BOQ`030000003c[gh0ljmn00<0ljmn1000
00000`3dXSL000000?ofkP070?ofkP040000003om^h0ooK^0?ofkP@000000`3om^h00`000000ooK^
0?ofkP080?ofkP030000003om^h0ooK^00<000001P3om^h00`000000ooK^0?ofkP060?ofkP030000
003om^h0ooK^00<000001P3om^h00`000000ooK^0?ofkP070?ofkP800000<P3om^h10?ooo`007P3o
m^h00`000000ooK^0?ofkP070?ofkP<000002@3om^h2000000P0ooK^0`0000090?ofkP030000003o
m^h0ooK^00@0ooK^0P0000020?ofkP030000003om^h0ooK^00T0ooK^00@000000?ofkP3om^h0ooK^
100000020?ofkP03000000000?l0003o00@0003o103om^h00`000000ooK^0?ofkP03000000H0ooK^
00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP030000008000140P00000804lXP@<00000
201lEYX00`000000T6BJ091TVP0;091TVP040000002PL9/0X72K0:1`V`H000000`2SNZH00`000000
/8BV0;24YP0<0;24YP030000002kSJH0^hfV00/0^hfV00<000000<JGYP36UjH0100000070<N@V`03
0000003DViX0e9^J00X0e9^J00<000000>6YV@3QZIT00P3QZIT00`000000i9n70>BOQ`020>BOQ`03
0000003c[gh0ljmn00@0ljmn0P000000103dXSL000000000000000070?ofkP@00000203om^h00`00
0000ooK^0?ofkP070?ofkP<000002@3om^h00`000000ooK^0?ofkP060?ofkP<000002@3om^h00`00
0000ooK^0?ofkP040?ofkP<000000P3om^h00`000000ooK^0?ofkP0_0?ofkP40oooo000O0?ofkP80
00001@3om^h200000080ooK^00<000000?ofkP3om^h02@3om^h010000000ooK^0?ofkP3om^h40000
0080ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP03000000D0ooK^00<000000?of
kP3om^h0203om^h4000000H0ooK^00<0003o000000000?l0203om^h3000000X0ooK^00<000000?of
kP3om^h01P3om^h3000000030?ofkP0000000000008000140P00000804lXP@030000001lEYX0O5JJ
00T0O5JJ00<00000091TVP2@I9X02@2@I9X5000000T0XgZV00<000000;24YP2`Q:H0302`Q:H00`00
0000^hfV0;^=YP0;0;^=YP0300000036UjH0aYNV00@0aYNV1@0000020<N@V`030000003DViX0e9^J
00X0e9^J00<000000>6YV@3QZIT00`3QZIT200000080i9n700<000000?>_OP3c[gh01@3c[gh01@00
0000m:8g0000003dXSL0000000@0ooK^0`0000020?ofkP030000003om^h0ooK^00L0ooK^00<00000
0?ofkP3om^h0103om^h300000080ooK^00<000000?ofkP3om^h0203om^h010000000ooK^0?ofkP3o
m^h400000080ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP03000000H0ooK^00<0
00000?ofkP3om^h0;P3om^h10?ooo`008@3om^h00`000000ooK^0?ofkP02000000D0ooK^00<00000
0?ofkP3om^h0203om^h4000000L0ooK^00<000000?ofkP3om^h01`3om^h3000000T0ooK^0P000006
0?ofkP8000000P3om^h00`000000ooK^0?ofkP050?ofkP<0003o1P3om^h200000080ooK^00<00000
0?ofkP3om^h02@3om^h010000000ooK^0?ofkP3om^h400000080ooK^00P000000?ofkP0000000000
0000A0000000601b000000L0CbR10P00000;07aFVP030000002@I9X0T6BJ00L0T6BJ0P0000000`2E
LJL000000:=jYP0;0:=jYP030000002`Q:H0/8BV00`0/8BV00<000000;^=YP2kSJH02`2kSJH00`00
0000aYNV0<JGYP090<JGYP@000002P3DViX00`000000hJVI0>6YV@060>6YV@<000001`3c[gh20000
00040?BR=`00000000000?ofkP<000001@3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0
ooK^00<000001P3om^h00`000000ooK^0?ofkP070?ofkP@000001`3om^h00`000000ooK^0?ofkP07
0?ofkP<000002@3om^h00`000000ooK^0?ofkP0^0?ofkP40oooo000R0?ofkP800000203om^h20000
00H0ooK^0P0000020?ofkP030000003om^h0ooK^00L0ooK^0P0000050?ofkP8000000P3om^h00`00
0000ooK^0?ofkP090?ofkP030000003om^h0ooK^00<000001@3om^h00`000000ooK^0?ofkP040?of
kP<0003o00<000000?ofkP3om^h00`0000050?ofkP030000003om^h0ooK^00P0ooK^100000070?of
kP80000000D000140000000H0780601b0000000604lXP@030000001Q@iL0000000/0O5JJ00<00000
091TVP2@I9X0102@I9X3000000<0UG6W00<000000:=jYP2SNZH02P2SNZH00`000000/8BV0;24YP0<
0;24YP030000002kSJH0^hfV00/0^hfV00<000000<JGYP36UjH02`36UjH010000000dJ:W00000000
00080=BKVP030000003QZIT0hJVI00P0hJVI00<000000?>_OP3c[gh01@3c[gh200000080m:8g0P00
00090?ofkP030000003om^h0ooK^00L0ooK^0`0000090?ofkP030000003om^h0ooK^00@0ooK^0`00
00020?ofkP030000003om^h0ooK^00H0ooK^00<000000?ofkP3om^h0103om^h300000080ooK^00<0
00000?ofkP3om^h0203om^h00`000000ooK^0?ofkP0]0?ofkP40oooo000S0?ofkP030000003om^h0
ooK^00P0ooK^00<000000?ofkP3om^h00`0000050?ofkP030000003om^h0ooK^00P0ooK^00<00000
0?ofkP3om^h00P0000050?ofkP030000003om^h0ooK^00P0ooK^0`0000080?ofkP030000003om^h0
ooK^00H0ooK^0P000?l2000000T0ooK^0P0000060?ofkP8000000P3om^h00`000000ooK^0?ofkP06
0?ofkP80000000<000140000000H07800P0H07800`000000CbR104lXP@0204lXP@050000001Q@iL0
HD>G0653U`0000002P1lEYX010000000T6BJ091TVP2@I9X3000000H0UG6W00<000000:=jYP2SNZH0
2P2SNZH00`000000/8BV0;24YP0<0;24YP030000002kSJH0^hfV00/0^hfV00<000000<JGYP36UjH0
2`36UjH010000000dJ:W0=6RY`3AXZL2000000H0e9^J00<000000>6YV@3QZIT0203QZIT2000000H0
ljmn00<000000?fmJ`0000000`00000:0?ofkP030000003om^h0ooK^00<0ooK^0`0000020?ofkP03
0000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h00`0000050?ofkP030000003om^h0ooK^00L0
ooK^00<000000?ofkP3om^h00`0000060?ofkP030000003om^h0ooK^00L0ooK^0P00000^0?ofkP40
oooo000T0?ofkP030000003om^h0ooK^00L0ooK^0`0000090?ofkP800000203om^h3000000P0ooK^
0P0000060?ofkP8000000P3om^h00`000000ooK^0?ofkP070?ofkP030000003om^h0ooK^00@0ooK^
00<000000000o`000?l00P000?l;0?ofkP030000003om^h0ooK^00<000001@3om^h00`000000ooK^
0?ofkP050?ofkP<000000`0H078200000080CbR10P0000040653U`030000001lEYX0O5JJ00P0O5JJ
00@00000091TVP00000000002@2ELJL00`000000XgZV0:=jYP0;0:=jYP030000002`Q:H0/8BV00/0
/8BV00<000000;^=YP2kSJH02P2kSJH00`000000aYNV0<JGYP0;0<JGYP030000003AXZL0dJ:W00@0
dJ:W0`0000030=BKVP030000003QZIT0hJVI00P0hJVI00<000000>niUP0000001@3c[gh010000000
oKe[0000003dXSL3000000T0ooK^00<000000?ofkP3om^h00`0000060?ofkP030000003om^h0ooK^
00L0ooK^0`0000090?ofkP030000003om^h0ooK^00D0ooK^100000090?ofkP030000003om^h0ooK^
00@0ooK^0`0000020?ofkP030000003om^h0ooK^02/0ooK^0@3oool002D0ooK^00<000000?ofkP3o
m^h0103om^h200000080ooK^00<000000?ofkP3om^h02@3om^h010000000ooK^0?ofkP3om^h40000
0080ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP03000000D0ooK^00<000000?of
kP3om^h01`3om^h00`000000ooK^0?ofkP0300000080ooK^10000?l:0?ofkP<000002@3om^h00`00
0000ooK^0?ofkP030?ofkP@00000100H07800`000000CbR1000000060653U`030000001lEYX0O5JJ
00P0O5JJ0P00000;09EaY`030000002SNZH0XgZV00/0XgZV00<000000;24YP2`Q:H02`2`Q:H00`00
0000^hfV0;^=YP0:0;^=YP0300000036UjH0aYNV00/0aYNV00<000000=6RY`3AXZL01`3AXZL20000
00030=BKVP000000hJVI00P0hJVI00D000000>niUP3_^IH0kkVF000000040?>_OP080000003m_F/0
oKe[0000003dXSL000000?ofkP0000080?ofkP<000002@3om^h00`000000ooK^0?ofkP040?ofkP<0
00000P3om^h00`000000ooK^0?ofkP070?ofkP040000003om^h0ooK^0?ofkP@000000`3om^h00`00
0000ooK^0?ofkP080?ofkP030000003om^h0ooK^00<000001@3om^h00`000000ooK^0?ofkP0[0?of
kP40oooo000V0?ofkP030000003om^h0ooK^00<000001@3om^h00`000000ooK^0?ofkP080?ofkP@0
00001`3om^h00`000000ooK^0?ofkP070?ofkP<000002@3om^h00`000000ooK^0?ofkP060?ofkP<0
00001`3om^h40000o`D0ooK^0`0000020?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3o
m^h00`0000000`0000L0000001P0LP0401P0LP8000001`1Q@iL00`000000O5JJ07aFVP0607aFVP<0
00003@2ELJL00`000000XgZV0:=jYP0:0:=jYP030000002`Q:H0/8BV00/0/8BV00<000000;^=YP2k
SJH02P2kSJH00`000000aYNV0<JGYP0;0<JGYP030000003AXZL0dJ:W00T0dJ:W0P0000090>6YV@03
0000003_^IH0kkVF0080kkVF0P0000020?>_OP040000003m_F/0oKe[0?fmJ`8000000P3om^h01000
0000ooK^0?ofkP3om^h400000080ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP03
000000H0ooK^00<000000?ofkP3om^h01P3om^h4000000P0ooK^00<000000?ofkP3om^h01`3om^h3
000000T0ooK^00<000000?ofkP3om^h0:P3om^h10?ooo`009`3om^h2000000T0ooK^0P0000060?of
kP8000000P3om^h00`000000ooK^0?ofkP070?ofkP030000003om^h0ooK^00@0ooK^0P0000020?of
kP030000003om^h0ooK^00P0ooK^00@000000?ofkP3om^h0ooK^100000020?ofkP030000003om^h0
ooK^00H0ooK^10000?l0103om^h000000000000000060?ofkP030000003om^h0ooK^00L0ooK^0`00
00020?ofkP030000000000L0000000D0601b00<000000653U`1Q@iL01P1Q@iL00`000000O5JJ07aF
VP0407aFVP8000000P24IJL00`000000UG6W09EaY`0;09EaY`030000002SNZH0XgZV00X0XgZV00<0
00000;24YP2`Q:H02`2`Q:H00`000000^hfV0;^=YP0:0;^=YP0300000036UjH0aYNV00/0aYNV00<0
00000=6RY`3AXZL02P3AXZL3000000L0hJVI00<000000>niUP3_^IH0103_^IH00`000000ljmn0000
00030?fmJ`<0000000<0ooK^0000000000000P0000070?ofkP030000003om^h0ooK^00L0ooK^0`00
00090?ofkP030000003om^h0ooK^00@0ooK^0P0000020?ofkP030000003om^h0ooK^00L0ooK^00<0
00000?ofkP3om^h0103om^h300000080ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^0?of
kP0Z0?ofkP40oooo000X0?ofkP030000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h00`000005
0?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h00`0000050?ofkP030000003om^h0
ooK^00L0ooK^100000070?ofkP030000003om^h0ooK^00L0ooK^10000?l90?ofkP030000003om^h0
ooK^00@0ooK^0P0000020?ofkP030000003om^h0ooK^00<00000100H0782000000T0HD>G00@00000
07aFVP1lEYX0O5JJ0P00000508AUY`030000002ELJL0UG6W00X0UG6W00<000000:=jYP2SNZH02P2S
NZH00`000000/8BV0;24YP050;24YPd000001P2kSJH00`000000aYNV0<JGYP0;0<JGYP030000003A
XZL0dJ:W00T0dJ:W00D000000=f_Y`3M[jL0gJnW000000060>6YV@030000003_^IH0kkVF00D0kkVF
0P0000040?fmJ`<000000P3om^h00`000000ooK^0?ofkP060?ofkP030000003om^h0ooK^00@0ooK^
0`0000020?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h00`0000050?ofkP030000
003om^h0ooK^00L0ooK^00<000000?ofkP3om^h00`0000050?ofkP030000003om^h0ooK^00L0ooK^
0P00000[0?ofkP40oooo000Y0?ofkP030000003om^h0ooK^00P0ooK^0`0000090?ofkP030000003o
m^h0ooK^00H0ooK^0`0000090?ofkP030000003om^h0ooK^00@0ooK^0P0000020?ofkP030000003o
m^h0ooK^00L0ooK^00<000000?ofkP3om^h0103om^h2000000030?ofkP000?l0003o00<0003o203o
m^h00`000000ooK^0?ofkP03000000D0ooK^00<000000?ofkP0000000P00000301P0LP030000000g
9i40000000T0HD>G00@0000007aFVP00000000001`24IJL00`000000UG6W09EaY`0:09EaY`030000
002SNZH0XgZV00L0XgZV2`0000060;6</0030000002kUK00^iF`00@0^iF`2@00000;0<JGYP030000
003AXZL0dJ:W00T0dJ:W00<000000=f_Y`3M[jL00P3M[jL2000000@0hJVI00<000000>niUP3_^IH0
1P3_^IH01@000000oKe[0?fmJ`000000oKe[00800000103om^h00`000000ooK^0?ofkP060?ofkP03
0000003om^h0ooK^00<000001P3om^h00`000000ooK^0?ofkP070?ofkP<00000203om^h00`000000
ooK^0?ofkP060?ofkP@000002@3om^h00`000000ooK^0?ofkP030?ofkP<000000P3om^h00`000000
ooK^0?ofkP0X0?ofkP40oooo000Z0?ofkP8000001P3om^h200000080ooK^00<000000?ofkP3om^h0
203om^h010000000ooK^0?ofkP3om^h400000080ooK^00<000000?ofkP3om^h0203om^h00`000000
ooK^0?ofkP03000000D0ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP03000000D0
ooK^1P000?l50?ofkP<00000203om^h00`000000ooK^00000002000000<0601b00<0000003LWT@00
00002@1Q@iL2000000T0Q6FW00<0000009EaY`2ELJL02P2ELJL010000000XgZV0:=jYP2SNZH60000
00<0YXB`00<000000;6</02aS;002`2aS;000`000000^iF`0;^E/00:0;^E/00300000035W[00aIj`
00@000001P36UjH00`000000dJ:W0=6RY`0:0=6RY`030000003M[jL0gJnW00@0gJnW00@000000>6Y
V@3QZIT000002@3_^IH2000000<0oKe[0P0000040?ofkP030000003om^h0ooK^00H0ooK^0`000009
0?ofkP030000003om^h0ooK^00@0ooK^0`0000020?ofkP030000003om^h0ooK^00L0ooK^00@00000
0?ofkP3om^h0ooK^100000030?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h00`00
00060?ofkP030000003om^h0ooK^02L0ooK^0@3oool002`0ooK^00<000000?ofkP3om^h00`000005
0?ofkP030000003om^h0ooK^00L0ooK^100000070?ofkP030000003om^h0ooK^00L0ooK^0`000009
0?ofkP8000001`3om^h3000000T0ooK^00<000000000o`000?l010000?l00`3om^h0000000000002
0?ofkP030000003om^h0ooK^00L0ooK^0P0000001@0004h0000001P0LP0H078000000080=bNA00<0
00000653U`1Q@iL01P1Q@iL2000000X0Q6FW00<0000009EaY`2ELJL02@2ELJL5000000T0YXB`00<0
00000;6</02aS;002`2aS;000`000000^iF`0;^E/00:0;^E/00300000035W[00aIj`00@0aIj`1000
00020<JGYP030000003AXZL0dJ:W00T0dJ:W00<000000=f_Y`3M[jL01P3M[jL3000000T0kkVF0P00
00030?fmJ`8000001@3om^h010000000ooK^0?ofkP3om^h400000080ooK^00<000000?ofkP3om^h0
203om^h00`000000ooK^0?ofkP03000000D0ooK^00<000000?ofkP3om^h01`3om^h4000000P0ooK^
00<000000?ofkP3om^h01P3om^h3000000T0ooK^00<000000?ofkP3om^h09`3om^h10?ooo`00;@3o
m^h2000000T0ooK^00<000000?ofkP3om^h0103om^h200000080ooK^00<000000?ofkP3om^h01`3o
m^h00`000000ooK^0?ofkP040?ofkP8000000P3om^h00`000000ooK^0?ofkP090?ofkP030000003o
m^h0ooK^00@000000P3om^h00`000000ooK^0?ofkP090?ofkP030000003om^h0003o00D0003o0`3o
m^h00`000000ooK^0?ofkP060?ofkP80000000@0001>0000000H078000000`0g9i400`000000HD>G
0653U`040653U`80000000<0KURX00000024IJL02@24IJL00`000000UG6W09EaY`0609EaY`<00000
00<0VGba0000002VQ;002`2VQ;000`000000/Hb`0;6</00;0;6</0030000002kUK00^iF`00X0^iF`
00<000000<FN/035W[002035W[04000000X0dJ:W00<000000=f_Y`3M[jL0203M[jL00`000000kkVF
0>niUP060>niUP040000003lbhh0o<^>00000080oKe[0P0000050?ofkP@000001`3om^h00`000000
ooK^0?ofkP070?ofkP<000002@3om^h00`000000ooK^0?ofkP030?ofkP<000000P3om^h00`000000
ooK^0?ofkP070?ofkP030000003om^h0ooK^00@0ooK^0P0000020?ofkP030000003om^h0ooK^00P0
ooK^00<000000?ofkP3om^h09P3om^h10?ooo`00;P3om^h00`000000ooK^0?ofkP080?ofkP030000
003om^h0ooK^00<000001@3om^h00`000000ooK^0?ofkP070?ofkP030000003om^h0ooK^00<00000
1@3om^h00`000000ooK^0?ofkP080?ofkP<000001`3om^h00`000000ooK^0?ofkP080?ofkP<00000
00<0ooK^0000o`000?l01@000?l00`3om^h000000?ofkP050?ofkP<0000000<0001>000000000000
1@0g9i400`000000HD>G0653U`020653U`030000001^F:P0KURX0080KURX00<0000008AUY`24IJL0
2024IJL00`000000UG6W09EaY`0209EaY`<00000102IO;400`000000YXB`0:J4/00:0:J4/0030000
002aS;00/Hb`00/0/Hb`00<000000;^E/02kUK002P2kUK000`000000aIj`0<FN/00:0<FN/0030000
003?Z;800000008000001`3AXZL00`000000gJnW0=f_Y`080=f_Y`8000001`3_^IH010000000o<^>
0?c;SP0000020?fmJ`L000000P3om^h00`000000ooK^0?ofkP060?ofkP030000003om^h0ooK^00@0
ooK^0`0000020?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h00`0000060?ofkP03
0000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h00`0000050?ofkP030000003om^h0ooK^00L0
ooK^0P00000W0?ofkP40oooo000_0?ofkP030000003om^h0ooK^00L0ooK^0`0000090?ofkP800000
1`3om^h3000000T0ooK^0P0000060?ofkP8000000P3om^h00`000000ooK^0?ofkP060?ofkP800000
1P3om^h200000080ooK^00<000000?ofkP3om^h00P3om^h70000o`80ooK^0`000000103om^h00000
0000CP0004h2000000D0=bNA00D000000653U`1Q@iL0HD>G0000000506iHZ00300000024IJL0Q6FW
00P0Q6FW00<0000009EaY`0000000P00000809Ul/@030000002VQ;00YXB`00T0YXB`00<000000;6<
/02aS;002P2aS;000`000000^iF`0;^E/00;0;^E/00300000035W[00aIj`00T0aIj`00<000000<nX
/P3?Z;800`3?Z;82000000D0dJ:W00<000000=f_Y`3M[jL01`3M[jL010000000j[nX0>ZoZ0000006
0>niUP060000003lbhh0o<^>0?c;SP000000oKe[0`0000070?ofkP030000003om^h0ooK^00H0ooK^
00<000000?ofkP3om^h00`0000060?ofkP030000003om^h0ooK^00H0ooK^0`0000090?ofkP030000
003om^h0ooK^00H0ooK^100000080?ofkP030000003om^h0ooK^00@0ooK^0`0000020?ofkP030000
003om^h0ooK^02@0ooK^0@3oool00300ooK^0P0000050?ofkP8000000P3om^h00`000000ooK^0?of
kP090?ofkP030000003om^h0ooK^00@000000P3om^h00`000000ooK^0?ofkP090?ofkP030000003o
m^h0ooK^00<000001@3om^h00`000000ooK^0?ofkP070?ofkP030000003om^h0ooK^00<000001@3o
m^h00`000000ooK^0?ofkP040?ofkPH0003o103om^h010000000001>0000CP00000603LWT@040000
001Q@iL00000000000H0KURX00<0000008AUY`24IJL02024IJL2000000/0VGba00<000000:J4/02V
Q;002P2VQ;000`000000/Hb`0;6</0090;6</0030000002kUK00^iF`00X0^iF`00<000000<FN/035
W[002P35W[000`000000cjRb0<nX/P050<nX/P<0000000<0dJ:W0000003M[jL02@3M[jL01@000000
j[nX0>ZoZ03Z_jP0000000D0kkVF00<000000?c;SP3lbhh00P3lbhh2000000030>bk?P000000ooK^
00H0ooK^00<000000?ofkP3om^h01P3om^h3000000T0ooK^00<000000?ofkP3om^h0103om^h20000
0080ooK^00<000000?ofkP3om^h0203om^h010000000ooK^0?ofkP3om^h4000000<0ooK^00<00000
0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP03000000D0ooK^00<000000?ofkP3om^h0903om^h1
0?ooo`00<P3om^h00`000000ooK^0?ofkP02000000D0ooK^00<000000?ofkP3om^h0203om^h30000
00L0ooK^00<000000?ofkP3om^h0203om^h3000000T0ooK^00<000000?ofkP3om^h01P3om^h30000
00T0ooK^00<000000?ofkP3om^h0103om^h2000000H0003o00D0ooK^0000000004h0001>00000006
03LWT@800000201^F:P00`000000Q6FW08AUY`0608AUY`<00000302IO;400`000000YXB`0:J4/00:
0:J4/0030000002aS;00/Hb`00T0/Hb`00<000000;^E/02kUK002P2kUK000`000000aIj`0<FN/00:
0<FN/0030000003?Z;80cjRb00P0cjRb0P00000:0=f_Y`030000003Z_jP0j[nX0080j[nX0P000003
0>niUP030000003lbhh0o<^>0080o<^>0P0000000`3/^ch000000?ofkP070?ofkP040000003om^h0
ooK^0?ofkP@000000P3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00<000001@3o
m^h00`000000ooK^0?ofkP070?ofkP@000001`3om^h00`000000ooK^0?ofkP070?ofkP<000002@3o
m^h00`000000ooK^0?ofkP0S0?ofkP40oooo000c0?ofkP800000203om^h2000000H0ooK^0P000002
0?ofkP030000003om^h0ooK^00H0ooK^0P0000060?ofkP8000000P3om^h00`000000ooK^0?ofkP08
0?ofkP040000003om^h0ooK^0?ofkP@000000P3om^h00`000000ooK^0?ofkP080?ofkP030000003o
m^h0ooK^00<00000103om^h50000o`040000000004h00000000000H0=bNA00<0000006iHZ01^F:P0
1`1^F:P00`000000Q6FW08AUY`0408AUY`8000000`2;Lk<00`000000VGba09Ul/@0909Ul/@030000
002VQ;00YXB`00X0YXB`00<000000;6</02aS;002@2aS;000`000000^iF`0;^E/00:0;^E/0030000
0035W[00aIj`00X0aIj`00<000000<nX/P3?Z;802@3?Z;83000000L0gJnW00<000000>ZoZ03Z_jP0
1@3Z_jP00`000000kkVF000000060?c;SP<00000203om^h4000000L0ooK^00<000000?ofkP3om^h0
1P3om^h4000000P0ooK^00<000000?ofkP3om^h0103om^h300000080ooK^00<000000?ofkP3om^h0
1`3om^h00`000000ooK^0?ofkP030?ofkP<000000P3om^h00`000000ooK^0?ofkP070?ofkP030000
003om^h0ooK^02<0ooK^0@3oool003@0ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?of
kP03000000D0ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP03000000D0ooK^00<0
00000?ofkP3om^h01`3om^h4000000L0ooK^0P0000080?ofkP<000002@3om^h020000000003o0?of
kP000000001>0000000008000000100g9i42000000X0KURX00@0000008AUY`24IJL0Q6FW0P000005
08]c/`030000002IO;40VGba00T0VGba00<000000:J4/02VQ;002P2VQ;000`000000/Hb`0;6</009
0;6</0030000002kUK00^iF`00X0^iF`00<000000<FN/035W[002@35W[000`000000cjRb0<nX/P09
0<nX/P050000003I];<0fKBc0=Vd/`0000001P3M[jL00`000000j[nX0>ZoZ0060>ZoZ08000001P3l
bhh00`000000k;/n000000050?ofkP<000000P3om^h00`000000ooK^0?ofkP070?ofkP040000003o
m^h0ooK^0?ofkP@000000`3om^h00`000000ooK^0?ofkP070?ofkP030000003om^h0ooK^00<00000
1@3om^h00`000000ooK^0?ofkP070?ofkP030000003om^h0ooK^00<000001@3om^h00`000000ooK^
0?ofkP070?ofkP800000903om^h10?ooo`00=@3om^h00`000000ooK^0?ofkP070?ofkP<000002@3o
m^h00`000000ooK^0?ofkP060?ofkP<000002@3om^h00`000000ooK^0?ofkP040?ofkP8000000P3o
m^h00`000000ooK^0?ofkP080?ofkP040000003om^h0ooK^0?ofkP@000000P3om^h00`000000ooK^
0?ofkP080?ofkP040000003om^h0000000000080002000<0000003LWT@0g9i400P0g9i400`000000
CDFW0000000906iHZ00400000024IJL00000000000L0Rg>c00<0000009Ul/@2IO;402@2IO;400`00
0000YXB`0:J4/00:0:J4/0030000002aS;00/Hb`00T0/Hb`00<000000;^E/02kUK002P2kUK000`00
0000aIj`0<FN/0090<FN/0030000003?Z;80cjRb00T0cjRb00<000000=Vd/`3I];<00P3I];<20000
00@0gJnW00<000000>ZoZ03Z_jP01`3Z_jP00`000000o<^>0?c;SP040?c;SP030000003/^ch00000
0080ooK^0`0000050?ofkP030000003om^h0ooK^00L0ooK^100000070?ofkP030000003om^h0ooK^
00L0ooK^0`0000090?ofkP030000003om^h0ooK^00D0ooK^100000090?ofkP030000003om^h0ooK^
00<0ooK^0`0000020?ofkP030000003om^h0ooK^0240ooK^0@3oool003H0ooK^00<000000?ofkP3o
m^h0103om^h200000080ooK^00<000000?ofkP3om^h0203om^h010000000ooK^0?ofkP3om^h40000
0080ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP03000000D0ooK^00<000000?of
kP3om^h01`3om^h4000000L0ooK^00<000000?ofkP3om^h01`3om^h400000080002000D0000003LW
T@0g9i40=bNA0000000204e5Y`030000001^F:P0KURX00L0KURX0P00000:08]c/`030000002IO;40
VGba00T0VGba00<000000:J4/02VQ;001`2VQ;0E000000H0^iF`00<000000<FN/035W[002@35W[00
0`000000cjRb0<nX/P090<nX/P030000003I];<0fKBc00@0fKBc00D000000=f_Y`3M[jL0gJnW0000
00090>ZoZ0800000103lbhh2000000040>bk?P0000000000000000T0ooK^00<000000?ofkP3om^h0
0`3om^h300000080ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP030?ofkP<00000
0P3om^h00`000000ooK^0?ofkP070?ofkP040000003om^h0ooK^0?ofkP@000000`3om^h00`000000
ooK^0?ofkP070?ofkP030000003om^h0ooK^00<000001P3om^h00`000000ooK^0?ofkP0P0?ofkP40
oooo000g0?ofkP030000003om^h0ooK^00<000001@3om^h00`000000ooK^0?ofkP070?ofkP@00000
1`3om^h2000000P0ooK^0`0000090?ofkP030000003om^h0ooK^00@0ooK^0P0000020?ofkP030000
003om^h0ooK^00L0ooK^00<000000?ofkP3om^h0103om^h200000080ooK^0P0000020000P0040000
000g9i40=bNA000000@0CDFW00<0000006iHZ01^F:P01@1^F:P2000000/0Rg>c00<0000009Ul/@2I
O;402@2IO;4010000000YXB`0:J4/02VQ;0600000080Yhfi00<000000;6D^@2aU;T02@2aU;T00`00
0000^Y^i0;ZK^@040;ZK^@T000002@35W[000`000000cjRb0<nX/P090<nX/P030000003I];<0fKBc
00D0fKBc0`0000090>ZoZ0030000003fdJL0000000@0o<^>0P000000103/^ch000000?ofkP000009
0?ofkP030000003om^h0ooK^00<000001P3om^h00`000000ooK^0?ofkP060?ofkP030000003om^h0
ooK^00<000001P3om^h00`000000ooK^0?ofkP060?ofkP@00000203om^h00`000000ooK^0?ofkP06
0?ofkP<000002@3om^h00`000000ooK^0?ofkP0P0?ofkP40oooo000h0?ofkP8000002@3om^h00`00
0000ooK^0?ofkP040?ofkP8000000P3om^h00`000000ooK^0?ofkP080?ofkP040000003om^h0ooK^
0?ofkP@000000P3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00<000001@3om^h0
0`000000ooK^0?ofkP070?ofkP030000003om^h0ooK^00<00000103om^h00`00000000200000P002
0000P08000001@1=AJL00`000000KURX06iHZ00406iHZ0040000001hJKD0N6Ve000000/0Rg>c00<0
000009Ul/@2IO;401`2IO;45000000P0Yhfi00<000000;6D^@2aU;T02@2aU;T00`000000^Y^i0;ZK
^@0:0;ZK^@0300000033Y;X0`jBj00H000000P35W[000`000000cjRb0<nX/P090<nX/P030000003I
];<0fKBc00P0fKBc00<000000>ZoZ03Z_jP01`3Z_jP010000000m]6W0?KAY`0000030?c;SP030000
003lf7P0000000<0ooK^00<000000?ofkP3om^h01P3om^h3000000T0ooK^00<000000?ofkP3om^h0
1P3om^h3000000T0ooK^00<000000?ofkP3om^h0103om^h200000080ooK^00<000000?ofkP3om^h0
203om^h010000000ooK^0?ofkP3om^h400000080ooK^00<000000?ofkP3om^h0203om^h00`000000
ooK^0?ofkP0O0?ofkP40oooo000i0?ofkP8000002@3om^h00`000000ooK^0?ofkP03000000D0ooK^
00<000000?ofkP3om^h01`3om^h4000000L0ooK^00<000000?ofkP3om^h01`3om^h3000000T0ooK^
00<000000?ofkP3om^h01P3om^h3000000L0ooK^00<000000000P00008000P000802000000H0CDFW
00@0000006iHZ01^F:P0KURX0P00000307QY]@030000002;Lk<0Rg>c00T0Rg>c00<0000009Ul/@2I
O;401@2IO;420000000309b6^`000000Yhfi00X0Yhfi00<000000;6D^@2aU;T02@2aU;T00`000000
^Y^i0;ZK^@0:0;ZK^@0300000033Y;X0`jBj00H0`jBj1000000:0<nX/P030000003I];<0fKBc00P0
fKBc0P0000070>ZoZ0030000003fdJL0m]6W0080m]6W00H000000?c;SP3lbhh000000?cHN0000003
0?ofkP030000003om^h0ooK^00@0ooK^0P0000020?ofkP030000003om^h0ooK^00P0ooK^00@00000
0?ofkP3om^h0ooK^100000020?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h00`00
00050?ofkP030000003om^h0ooK^00L0ooK^100000070?ofkP030000003om^h0ooK^00L0ooK^0P00
000P0?ofkP40oooo000k0?ofkP030000003om^h0ooK^00H0ooK^0`0000090?ofkP030000003om^h0
ooK^00@0ooK^0P0000020?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h0103om^h2
00000080ooK^00<000000?ofkP3om^h0203om^h010000000ooK^0?ofkP3om^h400000080ooK^00<0
00000?ofkP3om^h01@3om^h00`00000000200000P0020000P0030000001=AJL0CDFW00D0CDFW00@0
000006iHZ01^F:P000001P1hJKD00`000000Rg>c08]c/`0808]c/`030000002IO;40VGba0080VGba
0`00000409b6^`030000002WSKT0Yhfi00T0Yhfi00<000000;6D^@2aU;T0202aU;T00`000000^Y^i
0;ZK^@090;ZK^@0300000033Y;X0`jBj00T0`jBj00<000000<b]^`0000000P0000070<nX/P030000
003I];<0fKBc00L0fKBc00@000000>C3]P3T`kH000001P3Z_jP00`000000m]6W0?KAY`030?KAY`80
00000P3lf7P00`000000ooK^0?ofkP020?ofkP030000003om^h0ooK^00<000001@3om^h00`000000
ooK^0?ofkP070?ofkP@000001`3om^h00`000000ooK^0?ofkP060?ofkP@00000203om^h00`000000
ooK^0?ofkP040?ofkP<000000P3om^h00`000000ooK^0?ofkP060?ofkP030000003om^h0ooK^00@0
ooK^0`0000020?ofkP030000003om^h0ooK^01d0ooK^0@3oool003`0ooK^0P0000020?ofkP@00000
0P3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00<000001@3om^h00`000000ooK^
0?ofkP070?ofkP030000003om^h0ooK^00<000001@3om^h00`000000ooK^0?ofkP070?ofkP@00000
1`3om^h2000000D0ooK^00<000000000P00008000P0008000`000000CDFW04e5Y`0604e5Y`800000
1`1hJKD00`000000Rg>c08]c/`0908]c/`040000002IO;400000000000L0W8Jk00<000000:N=^@2W
SKT02@2WSKT00`000000/IBi0;6D^@080;6D^@030000002jVkT0^Y^i00T0^Y^i00<000000<>T^P33
Y;X02033Y;X00`000000c:fk0<b]^`030<b]^`8000001@3?Z;800`000000fKBc0=Vd/`070=Vd/`04
0000003T`kH0i<>f0>C3]P8000000`3Z_jP00`000000m]6W0?KAY`040?KAY`8000000P3lf7P01@00
0000003o0000o`000?l0ooK^00<00000203om^h00`000000ooK^0?ofkP040?ofkP<000000P3om^h0
0`000000ooK^0?ofkP070?ofkP040000003om^h0ooK^0?ofkP@000000`3om^h00`000000ooK^0?of
kP070?ofkP030000003om^h0ooK^00<000001@3om^h00`000000ooK^0?ofkP070?ofkP030000003o
m^h0ooK^00<000001@3om^h00`000000ooK^0?ofkP0M0?ofkP40oooo000n0?ofkP8000001`3om^h0
0`000000ooK^0?ofkP070?ofkP<000002@3om^h00`000000ooK^0?ofkP060?ofkP<000002@3om^h0
0`000000ooK^0?ofkP040?ofkP8000000P3om^h00`000000ooK^0?ofkP080?ofkP040000003om^h0
ooK^0?ofkP<000000P0008000`0000006bRR0000000704e5Y`030000001hJKD0N6Ve00L0N6Ve00<0
000008]c/`2;Lk<01`2;Lk<3000000T0W8Jk00<000000:N=^@2WSKT02@2WSKT00`000000/IBi0;6D
^@060;6D^@H00000202jVkT00`000000`jBj0<>T^P080<>T^P030000003<[K/0c:fk00D0c:fk0`00
00000`3?Z;8000000=Vd/`080=Vd/`030000003T`kH0i<>f00@0i<>f00@000000>ZoZ03Z_jP00000
1`3fdJL01@000000o=Qh0?cHN0000000003o00<000000P000?l00`000000ooK^0?ofkP070?ofkP03
0000003om^h0ooK^00<000001P3om^h00`000000ooK^0?ofkP060?ofkP@000001`3om^h00`000000
ooK^0?ofkP070?ofkP<000002@3om^h00`000000ooK^0?ofkP050?ofkP@000002@3om^h00`000000
ooK^0?ofkP0L0?ofkP40oooo000o0?ofkP030000003om^h0ooK^00H0ooK^0P0000050?ofkP800000
0P3om^h00`000000ooK^0?ofkP080?ofkP040000003om^h0ooK^0?ofkP@000000P3om^h00`000000
ooK^0?ofkP080?ofkP030000003om^h0ooK^00<000001@3om^h00`000000ooK^0?ofkP070?ofkP@0
000000<0ooK^0000000000000P0008000`0000006bRR0000000604e5Y`8000002@1hJKD00`000000
Rg>c08]c/`0508]c/`80000000<0T7nm0000002LQ[/02@2LQ[/00`000000Yhfi0:N=^@070:N=^@/0
00000P2aSK0010000000/Hf`0;6=/02aSK0;000000P0`jBj00<000000<b]^`3<[K/0203<[K/20000
00T0fKBc00<000000>C3]P3T`kH01@3T`kH2000000P0m]6W00<000000?cHN03lf7P00P0000000`3o
m^h0003o0000o`030000o`03000000000?l0ooK^00H0ooK^0`0000090?ofkP030000003om^h0ooK^
00@0ooK^0P0000020?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h00`3om^h30000
0080ooK^00<000000?ofkP3om^h01`3om^h010000000ooK^0?ofkP3om^h4000000<0ooK^00<00000
0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP0L0?ofkP40oooo00100?ofkP030000003om^h0ooK^
00L0ooK^00<000000?ofkP3om^h00P0000050?ofkP030000003om^h0ooK^00L0ooK^100000070?of
kP800000203om^h3000000T0ooK^00<000000?ofkP3om^h0103om^h200000080ooK^00L000000?of
kP3om^h0ooK^000000000800000000<06bRR00<0000004e5Y`1=AJL00`1=AJL00`000000Gebh0000
000907QY]@030000002;Lk<0Rg>c0080Rg>c0P000004091o_@030000002LQ[/0W8Jk00P0W8Jk00@0
00000:N=^@2WSKT0Yhfi1@0000040;ZD/0030000002jU;00^YB`00<0^YB`00<000000;6=/02aSK00
100000050;6=/0040000002XQ[40Z8Ja00000080Z8Ja1@0000020<>T^P030000003<[K/0c:fk00T0
c:fk00@000000=Bi_P00000000001`3I];<00`000000i<>f0>C3]P060>C3]P030000003fdJL0m]6W
00D0m]6W0P0000000`3lf7P00000000000050?ofkP<0003o00@000000000o`000?l0ooK^10000002
0?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h00`0000050?ofkP030000003om^h0
ooK^00H0ooK^00<000000?ofkP3om^h00`0000060?ofkP030000003om^h0ooK^00H0ooK^10000007
0?ofkP030000003om^h0ooK^00H0ooK^0`00000M0?ofkP40oooo00110?ofkP030000003om^h0ooK^
00H0ooK^0`0000080?ofkP8000001@3om^h200000080ooK^00<000000?ofkP3om^h0203om^h01000
0000ooK^0?ofkP3om^h400000080ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP03
000000D0ooK^00H000000?ofkP3om^h000000000P000000301/XXP030000001=AJL0CDFW0080CDFW
00@0000005mL^01OG;P000002@1hJKD00`000000Rg>c08]c/`02000000H0T7nm00<0000009b6^`2L
Q[/01`2LQ[/?000000D0^YB`0`0000020;6=/0030000002aSK00/Hf`00@0/Hf`00<000000:R6/@2X
Q[403000000:0<b]^`050000003D^Kh0e;Vn0=Bi_P0000001@3I];<00`000000i<>f0>C3]P070>C3
]P8000001P3fdJL2000000030?cHN0000000000000P0ooK^100000020000o`D0ooK^00<000000?of
kP3om^h01`3om^h3000000P0ooK^00<000000?ofkP3om^h01P3om^h3000000T0ooK^00<000000?of
kP3om^h0103om^h200000080ooK^00<000000?ofkP3om^h01`3om^h010000000ooK^0?ofkP3om^h4
000000<0ooK^00<000000?ofkP3om^h06P3om^h10?ooo`00@P3om^h010000000ooK^0?ofkP3om^h4
00000080ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP02000000D0ooK^00<00000
0?ofkP3om^h01`3om^h4000000L0ooK^00<000000?ofkP3om^h01`3om^h3000000T0ooK^00<00000
0?ofkP0000000P00000401/XXP040000001=AJL0CDFW000000@0Gebh00<0000007QY]@1hJKD01`1h
JKD2000000P0T7nm00<0000009b6^`2LQ[/00`2LQ[/700000080a9NX00D000000<BGZ034UjP0a9NX
000000050;Z>Z1H000000P2VOZP300000080YWjX00<0000009YfZ@2JMZT00`0000060<b]^`030000
003D^Kh0e;Vn00<0e;Vn0P0000030=Vd/`030000003T`kH0i<>f00H0i<>f00<000000>kD^0000000
1@3fdJL010000000o>FO0000003lf7P2000000H0ooK^0P0000020?ofkP03000000000?l0003o00<0
003o0`3om^h00`000000ooK^0?ofkP040?ofkP<000000P3om^h00`000000ooK^0?ofkP070?ofkP04
0000003om^h0ooK^0?ofkP@000000P3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^
00<000001@3om^h00`000000ooK^0?ofkP060?ofkP@000001`3om^h00`000000ooK^0?ofkP0J0?of
kP40oooo00130?ofkP<000001`3om^h2000000P0ooK^0`0000080?ofkP030000003om^h0ooK^00@0
ooK^0P0000020?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h0103om^h200000080
ooK^00<000000?ofkP3om^h0203om^h3000000D06bRR00<0000004e5Y`0000001@1OG;P00`000000
N6Ve07QY]@0607QY]@8000002P2@Okd00`000000W8Jk00000005000000L0a9NX00@000000<BGZ034
UjP000001@2jSZP300000080^XjX00<000000;26Z02`QZP0102`QZP00`000000/8JX0;26Z0020;26
Z0040000002VOZP0YWjX0:InZ0<000001@2VOZP010000000VWJY09YfZ@00000209YfZ@800000103<
[K/00`000000e;Vn0=Bi_P050=Bi_P<000002@3T`kH010000000k]Bh0>kD^00000040?KAY`030000
003liIl0o>FO0080000000@0ooK^0000003om^h0ooK^0`0000050?ofkP030000003om^h0003o00@0
003o0P3om^h00`000000ooK^0?ofkP03000000D0ooK^00<000000?ofkP3om^h01`3om^h4000000L0
ooK^00<000000?ofkP3om^h01P3om^h4000000P0ooK^00<000000?ofkP3om^h0103om^h200000080
ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP0I0?ofkP40oooo00140?ofkP030000
003om^h0ooK^00P0ooK^00@000000?ofkP3om^h0ooK^100000020?ofkP030000003om^h0ooK^00L0
ooK^00<000000?ofkP3om^h00`0000050?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3o
m^h00`0000050?ofkP030000003om^h0ooK^00L0ooK^0`00000601/XXP8000001P1OG;P00`000000
N6Ve07QY]@0407QY]@0400000021N<00PGS0000000T0T7nm100000000`3>XJT00000000000080<BG
Z00400000034UjP0a9NX000000<0^XjX0P0000020;Z>Z0040000002jSZP0^XjX000000L0/8JX00@0
00000;26Z02`QZP0/8JX100000020:InZ0030000002VOZP0YWjX00<0YWjX00D0000009YfZ@2JMZT0
VWJY0000000209YfZ@<0000000<0c:fk0000003D^Kh02@3D^Kh00`000000i<>f0>C3]P060>C3]P03
0000003^e;P0k]Bh0080k]Bh00@000000?KAY`3fdJL000000`3liIl2000000040?ofkP0000000000
000000P0ooK^00@000000?ofkP3om^h0ooK^1@000?l3000000T0ooK^00<000000?ofkP3om^h00`3o
m^h300000080ooK^00<000000?ofkP3om^h01`3om^h010000000ooK^0?ofkP3om^h4000000<0ooK^
00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP03000000D0ooK^00<000000?ofkP3om^h0
1P3om^h00`000000ooK^0?ofkP0I0?ofkP40oooo00150?ofkP030000003om^h0ooK^00L0ooK^1000
00070?ofkP030000003om^h0ooK^00H0ooK^0`0000090?ofkP030000003om^h0ooK^00H0ooK^0`00
00090?ofkP030000003om^h0ooK^00@0ooK^0P0000000`3om^h000000000000601/XXP030000001O
G;P0Gebh00D0Gebh00<0000007QY]@1hJKD00P1hJKD2000000<0PGS000<00000091o_@2@Okd01@2@
Okd4000000<0cZ6Y00<000000<BGZ00000002034UjP00`000000a9NX00000003000000D0^XjX00<0
00000;Z>Z00000001`2`QZP5000000H0YWjX00<000000:InZ02VOZP00`2VOZP00`000000VWJY09Yf
Z@03000000<0VWJY0P0000090=Bi_P030000003MaL40000000L0i<>f00<000000>kD^03^e;P00`3^
e;P00`000000m]6W000000030?cUW`<000000P3om^h00`000000ooK^0?ofkP070?ofkP040000003o
m^h0ooK^0?ofkP@000000P000?l00`000000ooK^0?ofkP070?ofkP030000003om^h0ooK^00<00000
1@3om^h00`000000ooK^0?ofkP070?ofkP@000001`3om^h00`000000ooK^0?ofkP070?ofkP<00000
203om^h00`000000ooK^0?ofkP060?ofkP8000006P3om^h10?ooo`00AP3om^h00`000000ooK^0?of
kP040?ofkP8000000P3om^h00`000000ooK^0?ofkP070?ofkP030000003om^h0ooK^00<0ooK^0P00
00020?ofkP030000003om^h0ooK^00P0ooK^00@000000?ofkP3om^h0ooK^100000020?ofkP030000
003om^h0ooK^00P0ooK^00<000000?ofkP3om^h00`0000030?ofkP<000001@0K::82000000L0Gebh
00@0000007QY]@1hJKD000001P21N<000`000000T7nm091o_@02091o_@@000001@3>XJT00`000000
a9NX000000080<BGZ0<000002@2jSZP2000000D0/8JX0P0000020;26Z0030000002`QZP0000000L0
YWjX00@000000:InZ02VOZP0YWjX1000000209YfZ@030000002JMZT0VWJY0080VWJY0`0000070=Bi
_P040000003MaL40gLG1000000H0i<>f00<000000>kD^03^e;P00`3^e;P2000000@0o>FO0P000003
0?ofkP030000003om^h0ooK^00L0ooK^100000050?ofkP80003o00<000000000o`3om^h01P3om^h3
000000T0ooK^00<000000?ofkP3om^h00`3om^h300000080ooK^00<000000?ofkP3om^h01`3om^h0
0`000000ooK^0?ofkP030?ofkP<000000P3om^h00`000000ooK^0?ofkP070?ofkP040000003om^h0
ooK^0?ofkP@000000P3om^h00`000000ooK^0?ofkP0G0?ofkP40oooo00170?ofkP030000003om^h0
ooK^00<000001@3om^h00`000000ooK^0?ofkP070?ofkP030000003om^h0ooK^008000001@3om^h0
0`000000ooK^0?ofkP070?ofkP@000001`3om^h2000000P0ooK^0`0000070?ofkP800000100K::80
0`000000>T^i0000000705mL^0030000001hJKD0000000L0PGS000<00000091o_@2@Okd00P000002
0=2KW`030000003@Vil0000000<0000000D0cZ6Y00000034UjP0a9NX000000030<BGZ0@0000000<0
a9NX0000000000002P2jSZP00`000000/8JX0;26Z003000000D0/8JX00<000000;26Z00000001P2V
OZP4000000030:InZ0000000VWJY00@0VWJY100000000`2FK9l0000008IQW`02000000@0e;Vn00<0
00000=g5`@3MaL400P3MaL42000000<0i<>f00<000000>kD^03^e;P01@3^e;P00`000000o>FO0?cU
W`020?cUW`800000103om^h00`000000ooK^0?ofkP030?ofkP<000000P3om^h00`000000ooK^0?of
kP050?ofkP80003o00@000000000o`3om^h0ooK^100000020?ofkP030000003om^h0ooK^00L0ooK^
00<000000?ofkP3om^h00`0000050?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h0
0`0000050?ofkP030000003om^h0ooK^00L0ooK^100000060?ofkP030000003om^h0ooK^01L0ooK^
0@3oool004P0ooK^0P0000090?ofkP030000003om^h0ooK^00H0ooK^0`0000080?ofkP8000001@3o
m^h200000080ooK^00<000000?ofkP3om^h0203om^h010000000ooK^0?ofkP3om^h400000080ooK^
00<000000?ofkP3om^h01@3om^h00`000000002=0000000301/XXP040000000jBkT0>T^i000000L0
Gebh00<00000085h`021N<001`21N<02000000D0d9^O00<000000=2KW`3@Vil00P3@Vil300000003
0<BGZ00000000000008000001@34UjP010000000^XjX0000000000080;Z>Z0<00000202`QZP00`00
0000/8JX000000040:InZ08000000P2VOZP01@000000YWjX0:InZ0000000VWJY00@0000000<0UVbO
0000002FK9l00P2FK9l600000080e;Vn00<000000=g5`@3MaL40103MaL4010000000i<>f0>C3]P00
00060>kD^08000000`3liIl2000000D0ooK^00<000000?ofkP3om^h00`0000060?ofkP030000003o
m^h0ooK^00H0ooK^100000070?ofkP030000003om^h0ooK^00H0ooK^0`0000090?ofkP030000003o
m^h0ooK^00D0ooK^100000090?ofkP030000003om^h0ooK^00<0ooK^0`0000020?ofkP030000003o
m^h0ooK^00H0ooK^00<000000?ofkP3om^h05P3om^h10?ooo`00B@3om^h00`000000ooK^0?ofkP08
0?ofkP040000003om^h0ooK^0?ofkP@000000P3om^h00`000000ooK^0?ofkP080?ofkP030000003o
m^h0ooK^008000001@3om^h00`000000ooK^0?ofkP070?ofkP@000001`3om^h2000000D0ooK^0`00
000201/XXP050000000jBkT0>T^i03Y;^@0000001P1OG;P00`000000KG3400000006085h`0800000
00<0fjJO0000003@Vil0103@Vil00`000000d9^O0=2KW`030=2KW`H000001P34UjP01@000000^XjX
0;Z>Z02jSZP0000000<0^XjX1@0000000`2`QZP000000;26Z0080;26Z080000000@0YWjX00000000
000000001@2VOZP4000000D0UVbO100000000`2FK9l0000008IQW`0308IQW`800000203MaL420000
00L0k]Bh0P0000030?cUW`8000001@3om^h3000000T0ooK^00<000000?ofkP3om^h0103om^h20000
00030?ofkP000?l0003o00<0003o1P3om^h010000000ooK^0?ofkP3om^h400000080ooK^00<00000
0?ofkP3om^h01`3om^h010000000ooK^0?ofkP3om^h4000000<0ooK^00<000000?ofkP3om^h01`3o
m^h00`000000ooK^0?ofkP03000000D0ooK^00<000000?ofkP3om^h01P3om^h2000001L0ooK^0@3o
ool004X0ooK^00<000000?ofkP3om^h01`3om^h4000000L0ooK^0P0000080?ofkP<00000203om^h0
0`000000ooK^0?ofkP040?ofkP8000000P3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0
ooK^00@0000000@0002=0000000K::800000100jBkT00`000000Gebh05mL^00205mL^0040000001]
L<@0KG34000000D0PGS00P0000020=^VW`030000003@Vil0d9^O00@0d9^O00<000000=2KW`3@Vil0
0`0000050<F@W`@000000P34UjP010000000^XjX0;Z>Z02jSZP4000000@0^XjX00@000000;26Z02`
QZP00000202`QZP300000080YWjX1`0000000`2TMIl0000009I/W`0309I/W`8000000P2FK9l01000
0000UVbO09I/W`00000608IQW`030000003MaL40gLG100H0gLG100<000000>kD^03^e;P0103^e;P0
10000000mNRh0?GX^00000020?cUW`80000000<0ooK^0000000000000P0000020?ofkP030000003o
m^h0ooK^00P0ooK^00<000000?ofkP3om^h00`0000050?ofkP@0003o1@3om^h4000000L0ooK^00<0
00000?ofkP3om^h01P3om^h4000000L0ooK^00<000000?ofkP3om^h01P3om^h4000000T0ooK^00<0
00000?ofkP3om^h00`3om^h200000080ooK^00<000000?ofkP3om^h0503om^h10?ooo`00B`3om^h2
000000D0ooK^0P0000020?ofkP030000003om^h0ooK^00P0ooK^00@000000?ofkP3om^h0ooK^1000
00020?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h00`0000050?ofkP030000003o
m^h0ooK^00L0ooK^0`0000030?ofkP050000000008d0000001/XXP000000100jBkT01@000000Gebh
05mL^01OG;P0000000@0KG3400D00000085h`021N<00PGS0000000020=^VW`030000003KYYl00000
00H0d9^O0`0000000`3@Vil000000<F@W`060<F@W`0300000035T9l0aI2O00T000001@2jSZP01@00
0000/8JX0;26Z02`QZP000000080/8JX2P0000070:AeW`80000000@0UVbO00000000000000001@2F
K9l00`000000UVbO0000000708IQW`030000003MaL40gLG100@0gLG100<000000>GEaP0000001@3^
e;P01@000000mNRh0?GX^0000000o>FO00@000001`3om^h00`000000ooK^0?ofkP060?ofkP@00000
203om^h00`000000ooK^0000o`020000o`80ooK^0P0000020?ofkP030000003om^h0ooK^00H0ooK^
00<000000?ofkP3om^h0103om^h200000080ooK^00<000000?ofkP3om^h01`3om^h010000000ooK^
0?ofkP3om^h4000000<0ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP03000000D0
ooK^00<000000?ofkP3om^h04`3om^h10?ooo`00C@3om^h00`000000ooK^0?ofkP02000000D0ooK^
00<000000?ofkP3om^h01`3om^h4000000L0ooK^0P0000070?ofkP<000002@3om^h00`000000ooK^
0?ofkP040?ofkP8000000P3om^h01@000000ooK^0?ofkP3om^h000000080002=00<0000003Y;^@0j
BkT0100jBkT010000000Gebh05mL^000000406e`a00300000021N<00000000<000000P3KYYl01000
0000d9^O0=2KW`3@Vil400000080d9^O00<000000=2KW`0000002035T9l00`000000aI2O0<F@W`03
000000@0^XNN3P0000050:mnWP030000002TMIl0000000P0Y7FO0`00000909I/W`8000001P26HIl3
000000@0gLG100@000000>GEaP3UeLH00000103^e;P01P000000mNRh0?GX^03ej;P000000?cUW`<0
00002@3om^h010000000ooK^0?ofkP3om^h4000000<0ooK^00<000000?ofkP3om^h01`3om^h00`00
0000ooK^0000o`020000o`030000003om^h0ooK^00<0ooK^00<000000?ofkP3om^h01P3om^h00`00
0000ooK^0?ofkP03000000D0ooK^00<000000?ofkP3om^h01P3om^h4000000L0ooK^00<000000?of
kP3om^h01P3om^h4000000P0ooK^00<000000?ofkP3om^h04`3om^h10?ooo`00CP3om^h2000000P0
ooK^00<000000?ofkP3om^h0103om^h200000080ooK^00<000000?ofkP3om^h0203om^h00`000000
ooK^0?ofkP0400000080ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP03000000D0
ooK^00@000000?ofkP3om^h000000P0008d00`000000>T^i03Y;^@0403Y;^@030000001OG;P00000
00H0KG3400<000000=fOT@3MWi400P3MWi46000000L0d9^O0P0000080<F@W`<0000000<0aI2O0000
002jQih01@2jQih00`000000^XNN0;Z7WP020;Z7WP040000002_OYh0000000000080[gjN00<00000
0:mnWP2_OYh0102_OYh010000000Y7FO0:AeW`0000030:AeW`@0000000<0Y7FO0000000000002P2F
K9l200000080QV6O1000000207mBT@050000003MaL40gLG10=g5`@0000000`3UeLH01@000000k]Bh
0>kD^03^e;P0000000<0mNRh00H000000?cUW`00000000000?ofkP0000080?ofkP@000001`3om^h0
0`000000ooK^0?ofkP060?ofkP@000000`000?l50?ofkP030000003om^h0ooK^00H0ooK^0`000008
0?ofkP030000003om^h0ooK^00@0ooK^0P0000020?ofkP030000003om^h0ooK^00L0ooK^00@00000
0?ofkP3om^h0ooK^100000030?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h04P3o
m^h10?ooo`00C`3om^h00`000000ooK^0?ofkP070?ofkP030000003om^h0ooK^00<000001@3om^h0
0`000000ooK^0?ofkP070?ofkP<000001`3om^h2000000P0ooK^0`0000080?ofkP060000003om^h0
ooK^0?ofkP000000002=0P00000603Y;^@030000001]L<@0KG3400@0KG3400<000000=fOT@3MWi40
0`3MWi45000000T0d9^O0P0000030<F@W`@000000P35T9l00`000000aI2O000000070;Z7WP030000
002jQih0^XNN00<000001@2_OYh00`000000[gjN0:mnWP030:mnWP030000002TMIl0Y7FO00@00000
1P2TMIl2000000T0UVbO1@00000607mBT@030000003MaL40000000D0iMG600<000000>kD^0000000
1@3ej;P01@000000inR20000003om^h0000000H0ooK^0P0000020?ofkP030000003om^h0ooK^00L0
ooK^00@000000?ofkP3om^h0ooK^100000030?ofkP04000000000?l0003o0000o`H0ooK^00@00000
0?ofkP3om^h0ooK^100000020?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h00`00
00050?ofkP030000003om^h0ooK^00H0ooK^100000070?ofkP030000003om^h0ooK^00H0ooK^0`00
000C0?ofkP40oooo001@0?ofkP8000001`3om^h3000000T0ooK^00<000000?ofkP3om^h0103om^h2
00000080ooK^00<000000?ofkP3om^h01`3om^h010000000ooK^0?ofkP3om^h400000080ooK^00<0
00000?ofkP3om^h01`3om^h01@000000ooK^0?ofkP000000002=008000001P0jBkT2000000D0KG34
0P0000020=fOT@8000000P3MWi400`000000dI>C00000002000000L0d9^O1@0000070<F@W`800000
1`2jQih3000000030;Z7WP000000[gjN00D0[gjN00<000000:mnWP2_OYh00`2_OYh300000080Y7FO
00<000000:AeW`2TMIl01@2TMIl00`000000UVbO0000000609I/W`D000002@1oDY400`000000iMG6
0>GEaP040>GEaP030000003^e;P0000000D0mNRh00<000000>OXPP0000000P3om^h00`000000ooK^
0?ofkP03000000D0ooK^00<000000?ofkP3om^h01P3om^h4000000L0ooK^0`000?l60?ofkPD00000
1`3om^h00`000000ooK^0?ofkP060?ofkP<00000203om^h00`000000ooK^0?ofkP040?ofkP800000
0P3om^h00`000000ooK^0?ofkP070?ofkP040000003om^h0ooK^0?ofkP@000000`3om^h00`000000
ooK^0?ofkP0@0?ofkP40oooo001B0?ofkP030000003om^h0ooK^00@000000P3om^h00`000000ooK^
0?ofkP080?ofkP030000003om^h0ooK^00<000001@3om^h00`000000ooK^0?ofkP060?ofkP@00000
1`3om^h2000000L0ooK^1P0000000`02<;<0000003Y;^@0303Y;^@040000001BI/T0DVK9000000<0
KG341@0000040=fOT@040000003ATi<0dI>C0=6CT`<00000103@Vil200000080aI2O00<000000<F@
W`35T9l01P35T9l2000000<0^XNN100000020;Z7WP030000002jQih0000000L0[gjN00<000000:mn
WP2_OYh00`0000050:AeW`030000002TMIl0Y7FO00@0Y7FO00@0000009I/W`2FK9l000000P2FK9l5
00000004099OT`000000Oe:A000000P0Oe:A0P0000060>GEaP030000003ej;P0mNRh00<0mNRh0`00
00030?ofkP<00000203om^h00`000000ooK^0?ofkP040?ofkP8000000P3om^h00`000000ooK^0?of
kP040?ofkP@0003o0`3om^h4000000<0ooK^00<000000?ofkP3om^h01`3om^h010000000ooK^0?of
kP3om^h400000080ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP03000000D0ooK^
00<000000?ofkP3om^h01P3om^h4000000L0ooK^00<000000?ofkP3om^h0403om^h10?ooo`00D`3o
m^h2000000L0ooK^0P0000080?ofkP<000002@3om^h00`000000ooK^0?ofkP030?ofkP8000000P3o
m^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00@000000P3om^h01`000000ooK^0000
000008d00000008`/`0000000`0jBkT010000000DVK9059Vb@00000206e`a08000000`3MWi400`00
0000gInA0=fOT@020=fOT@030000003ATi<0dI>C0080dI>C00<000000=6CT`000000100000040<F@
W`0300000035T9l0aI2O00D0aI2O1@0000070;Z7WP8000001`2_OYh300000080[gjN00<000000:Ae
W`2TMIl00`2TMIl00`000000Y7FO0:AeW`040:AeW`030000002FK9l0000000@000001@2BGi<00`00
0000Oe:A0000000607mBT@@000001@3UeLH2000000@0mNRh00<000000>kg[`000000100000020?of
kP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h00`0000050?ofkP030000003om^h0003o
00H0003o100000070?ofkP030000003om^h0ooK^00L0ooK^100000060?ofkP030000003om^h0ooK^
00H0ooK^100000080?ofkP030000003om^h0ooK^00@0ooK^0P0000020?ofkP030000003om^h0ooK^
00L0ooK^00<000000?ofkP3om^h03`3om^h10?ooo`00E03om^h00`000000ooK^0?ofkP070?ofkP04
0000003om^h0ooK^0?ofkP@000000P3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^
008000001@3om^h00`000000ooK^0?ofkP070?ofkP<000001`3om^h4000000800S2c00@0000003Y;
^@0jBkT000000`1BI/T010000000KG340000000000040=fOT@040000003MWi40gInA000000D0dI>C
0`0000020=6CT`D0000000<0aI2O00000035T9l01@35T9l200000080^XNN00<000000;Z7WP2jQih0
1`2jQih010000000[gjN0:mnWP2_OYh400000080[gjN00@000000:mnWP2_OYh000001P2TMIl01000
0000Y7FO0:AeW`2TMIl500000080TUnC00<00000099OT`2BGi<0102BGi<010000000Oe:A07mBT@00
000207mBT@<000000P1oDY43000000<0iMG600<000000>_WbP000000103ej;P00`000000k_N_0000
00070?ofkP030000003om^h0ooK^00H0ooK^0`0000080?ofkP030000003om^h0003o00@0003o0P00
00020?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h00`3om^h300000080ooK^00<0
00000?ofkP3om^h01P3om^h010000000ooK^0?ofkP3om^h4000000<0ooK^00<000000?ofkP3om^h0
1`3om^h00`000000ooK^0?ofkP03000000@0ooK^00<000000?ofkP3om^h01`3om^h200000100ooK^
0@3oool005D0ooK^00<000000?ofkP3om^h01P3om^h4000000L0ooK^0P0000080?ofkP<00000203o
m^h00`000000ooK^0?ofkP040?ofkP8000000P3om^h00`000000ooK^0?ofkP070?ofkP8000000P02
<;<010000000>T^i03Y;^@000004059Vb@030000003OUGl0giEo008000000`3MWi4010000000gInA
0000003ATi<400000080dI>C00D000000=6CT`3ATi<0dI>C000000030<F9T`P0000000<0aI2O0000
002jQih00P2jQih00`000000^XNN0;Z7WP060;Z7WP@000001`2_OYh3000000H0Y7FO100000020:5[
T`030000002BGi<0TUnC00<0TUnC00<00000099OT`2BGi<00`2BGi<00`000000Oe:A07mBT@030000
00D0Oe:A00@0000005LWN@1G9gT000000P3UeLH00`000000jnO:000000030?GX^0040000003^mjl0
0000000000P0ooK^00@000000?ofkP3om^h0ooK^100000020?ofkP030000003om^h0ooK^00L0ooK^
00<000000?ofkP3om^h00`0000050?ofkP030000003om^h0ooK^00H0ooK^00<000000?ofkP3om^h0
0`0000050?ofkP030000003om^h0ooK^00H0ooK^100000070?ofkP030000003om^h0ooK^00H0ooK^
100000080?ofkP030000003om^h0ooK^00<0ooK^0`0000020?ofkP030000003om^h0ooK^00d0ooK^
0@3oool005H0ooK^00<000000?ofkP3om^h00`3om^h200000080ooK^00<000000?ofkP3om^h0203o
m^h010000000ooK^0?ofkP3om^h400000080ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^
0?ofkP03000000D0ooK^00<000000?ofkP3om^h01P3om^h2000000<00S2c0P000005059Vb@030000
003OUGl0giEo0080giEo0P0000020=fOT@<000001`3ATi<010000000dI>C0=6CT`0000050<F9T`<0
000000<0aHVC000000000000200000040;Z7WP<0000000<0[gjN0000002_OYh02@2_OYh00`000000
Y7FO0:AeW`0400000080XF^C00D000000:5[T`2QJi<0XF^C00000006099OT`040000002BGi<0TUnC
099OT`@000000P1oDY4010000000Oe:A07mBT@1oDY4300000080EbMi00<000000>GEaP0000000`3[
ilX00`000000mNRh000000020>kg[`800000203om^h4000000L0ooK^00<000000?ofkP3om^h01P3o
m^h3000000P0ooK^00<000000?ofkP3om^h01P3om^h3000000T0ooK^00<000000?ofkP3om^h00`3o
m^h200000080ooK^00<000000?ofkP3om^h01`3om^h010000000ooK^0?ofkP3om^h4000000<0ooK^
00<000000?ofkP3om^h01P3om^h00`000000ooK^0?ofkP03000000D0ooK^00<000000?ofkP3om^h0
3@3om^h10?ooo`00E`3om^h00`000000ooK^0?ofkP02000000D0ooK^00<000000?ofkP3om^h01`3o
m^h4000000L0ooK^00<000000?ofkP3om^h01P3om^h3000000P0ooK^00<000000?ofkP3om^h0103o
m^h2000000030?ofkP000000000000<00S2c00<00000059Vb@1BI/T00P1BI/T2000000H0giEo0P00
00000`3MWi4000000=6CT`080=6CT`040000003ATi<000000<F9T`@000000P35RI<00`000000aHVC
0<F9T`020<F9T`030000002iOi@0^GnD0080^GnD00<000000;UoU00000005@0000070:5[T`800000
00<0XF^C0000002BGi<01@2BGi<400000080TUnC00<0000007mBT@1oDY400P1oDY4300000080MSn0
00D0000005LWN@1G9gT0EbMi000000040>_WbP8000000`3^mjl2000000H0ooK^0P0000020?ofkP03
0000003om^h0ooK^00L0ooK^00@000000?ofkP3om^h0ooK^100000020?ofkP030000003om^h0ooK^
00L0ooK^00@000000?ofkP3om^h0ooK^100000020?ofkP030000003om^h0ooK^00L0ooK^00<00000
0?ofkP3om^h00`0000050?ofkP030000003om^h0ooK^00H0ooK^100000070?ofkP030000003om^h0
ooK^00H0ooK^0`0000090?ofkP030000003om^h0ooK^00`0ooK^0@3oool005P0ooK^0P0000080?of
kP030000003om^h0ooK^00@0ooK^0P0000020?ofkP030000003om^h0ooK^00L0ooK^00@000000?of
kP3om^h0ooK^100000020?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h00`000003
0?ofkP8000000`02<;<2000000<0DVK90P0000080=nEO`<00000203ATi<4000000L0aHVC0P000002
0<F9T`030000002iOi@0^GnD0080^GnD0`0000050;UoU0050000002^MI@0[WFD0:ieU00000001P2^
MI@3000000030:5[T`000000XF^C00P0XF^C0P000002099OT`@000000P2BGi<01@000000TUnC099O
T`2BGi<0000000<0Oe:A0P00000407HoP0050000001G9gT0EbMi05LWN@000000103[ilX2000000<0
k_N_00<000000?ofkP0000000P3om^h3000000D0ooK^00<000000?ofkP3om^h01P3om^h4000000L0
ooK^00<000000?ofkP3om^h01P3om^h4000000L0ooK^00<000000?ofkP3om^h01P3om^h3000000P0
ooK^00<000000?ofkP3om^h0103om^h200000080ooK^00<000000?ofkP3om^h01`3om^h010000000
ooK^0?ofkP3om^h400000080ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP0<0?of
kP40oooo001I0?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h00`0000050?ofkP03
0000003om^h0ooK^00H0ooK^100000070?ofkP8000001`3om^h3000000L0ooK^0P000002008`/`03
0000000/F</000000080DVK90P0000090=nEO`030000003ARX<00000008000000P3ATi<300000080
dI>C00<000000<F9T`35RI<02035RI<00`000000aHVC0000000400000080^GnD00<000000;UoU02i
Oi@00`2iOi@00`000000[WFD0:ieU0020:ieU0030000002^MI@0[WFD00<000000P2^MI@010000000
XF^C0:5[T`0000080:5[T`@000001P2BGi<01P000000TUnC099OT`2BGi<0000007mBT@8000000P1f
?h001@000000MSn007HoP01f?h00000000@0EbMi00D000000>_WbP3[ilX0jnO:000000030>kg[`03
0000003om^h0ooK^00<00000203om^h00`000000ooK^0?ofkP040?ofkP8000000P3om^h00`000000
ooK^0?ofkP070?ofkP040000003om^h0ooK^0?ofkP@000000P3om^h00`000000ooK^0?ofkP070?of
kP040000003om^h0ooK^0?ofkP@000000P3om^h00`000000ooK^0?ofkP070?ofkP030000003om^h0
ooK^00<00000103om^h00`000000ooK^0?ofkP070?ofkP@000001`3om^h00`000000ooK^0?ofkP06
0?ofkP8000003@3om^h10?ooo`00FP3om^h2000000L0ooK^0`0000090?ofkP030000003om^h0ooK^
00<0ooK^0P0000020?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h0100000020?of
kP030000003om^h0ooK^00D0ooK^0`0000001002<;<0000002aHb`0/F</4000000T0giEo00<00000
0=6:P`3ARX<00P3ARX<3000000@0dI>C0P0000090<F9T`<000001`2iOi@2000000<0^GnD00<00000
0:ieU02^MI@00P2^MI@3000000D0[WFD00@000000:5[T`2QJi<000001P2QJi<2000000030:5[T`00
0000000000P0TUnC1@00000807HoP0040000001G9gT0EbMi05LWN@8000000P3[ilX200000080k_N_
100000020?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h00`0000040?ofkP030000
003om^h0ooK^00L0ooK^100000060?ofkP030000003om^h0ooK^00H0ooK^1@0000060?ofkP030000
003om^h0ooK^00H0ooK^100000080?ofkP030000003om^h0ooK^00<0ooK^0`0000020?ofkP030000
003om^h0ooK^00L0ooK^00@000000?ofkP3om^h0ooK^1000000?0?ofkP40oooo001L0?ofkP030000
003om^h0ooK^00@000000P3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00800000
1@3om^h00`000000ooK^0?ofkP070?ofkP<000001`3om^h2000000H0ooK^00@000000007V@000000
00000`0/F</00`000000k95F000000090=nEO`030000003ARX<0dHZ300D0dHZ30`000000103ATi<0
00000<F9T`0000060<F9T`8000000P35RI<00`000000^GnD0;UoU0070;UoU0030000002iOi@0^GnD
00D000000P2^MI@00`000000[WFD0:ieU0030:ieU0050000002QJi<0XF^C0:5[T`0000000P2QJi<3
000000<0XF^C0P000005099OT`D0000000<0S5640000001f?h00201f?h002`000000EbMi05LWN@00
0000@PMK0000003[ilX000000>Whb`000000k_N_008000001P3om^h00`000000ooK^0?ofkP060?of
kP<00000203om^h00`000000ooK^0?ofkP030?ofkP<000000P3om^h00`000000ooK^0?ofkP060?of
kP040000003om^h0ooK^0?ofkP@000000`3om^h00`000000ooK^0?ofkP060?ofkP040000003om^h0
ooK^0?ofkP@000000`3om^h00`000000ooK^0?ofkP060?ofkP030000003om^h0ooK^00<000001@3o
m^h00`000000ooK^0?ofkP070?ofkP@000004`3om^h10?ooo`00G@3om^h2000000L0ooK^0P000008
0?ofkP<00000203om^h00`000000ooK^0?ofkP040?ofkP8000000P3om^h00`000000ooK^0?ofkP07
0?ofkP040000003om^h0ooK^0?ofkPH000000`0/F</00`000000k95F00000002000000L0giEo00<0
00000=6:P`3ARX<0203ARX<500000080aHVC0`0000040<F9T`800000202iOi@4000000L0[WFD00<0
00000:ieU02^MI@00`2^MI@00`000000XF^C0:5[T`03000000H0XF^C00<00000099OT`0000001000
000308aAQ0040000002<DH@0S564000000T0MSn00`0000020487F`80000000@0jOS;0000003^mjl0
k_N_0P0000070?ofkP040000003om^h0ooK^0?ofkP@000000P3om^h00`000000ooK^0?ofkP060?of
kP030000003om^h0ooK^00<000001@3om^h00`000000ooK^0?ofkP060?ofkP@000001`3om^h00`00
0000ooK^0?ofkP060?ofkP@000001`3om^h00`000000ooK^0?ofkP060?ofkP<000002@3om^h00`00
0000ooK^0?ofkP030?ofkP<000005`3om^h10?ooo`00GP3om^h00`000000ooK^0?ofkP070?ofkP04
0000003om^h0ooK^0?ofkP@000000P3om^h00`000000ooK^0?ofkP070?ofkP030000003om^h0ooK^
00<000001@3om^h00`000000ooK^0?ofkP060?ofkP@000000`3om^h00`00000000NI0000000302aH
b`030000003/TEH000000080gXMV0P0000050=nEO`030000003ARX<0dHZ300T0dHZ300<000000<Eo
QP35OhH0100000060<F9T`8000001P2iOi@200000080^GnD0P0000080:ieU0040000002^MI@0[WFD
0:ieU0@000000P2QJi<00`000000XF^C0:5[T`020:5[T`H000002@2<DH@00`000000MSn007HoP006
07HoP080000010121e/01@000000jOS;0>Whb`000000k_N_00800000203om^h4000000H0ooK^00<0
00000?ofkP3om^h01P3om^h3000000T0ooK^00<000000?ofkP3om^h00`3om^h200000080ooK^00<0
00000?ofkP3om^h01`3om^h010000000ooK^0?ofkP3om^h400000080ooK^00<000000?ofkP3om^h0
1`3om^h010000000ooK^0?ofkP3om^h400000080ooK^00<000000?ofkP3om^h01`3om^h00`000000
ooK^0?ofkP03000001X0ooK^0@3oool005l0ooK^0P0000070?ofkP@000001`3om^h2000000L0ooK^
0`0000090?ofkP030000003om^h0ooK^00<0ooK^0P0000020?ofkP030000003om^h0ooK^00<0ooK^
0`00000202aHb`040000003/TEH0k95F000000<0gXMV00<000000=nEO`3OUGl00P3OUGl00`000000
dHZ30=6:P`040=6:P`030000003ARX<0dHZ30080dHZ300<000000<EoQP35OhH01035OhH400000080
aHVC00<000000;UoU00000000P2iOi@3000000@0^GnD0P0000080:ieU0@0000000<0[WFD0000002Q
Ji<00P2QJi<600000080W5j600<0000008aAQ02<DH@02@2<DH@00`000000MSn007HoP00507HoP080
000000<0JBMY000000121e/00`121e/00`000000jOS;0>Whb`02000000030<3[S@000000ooK^00D0
ooK^0P0000020?ofkP030000003om^h0ooK^00H0ooK^00@000000?ofkP3om^h0ooK^100000020?of
kP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h00`0000050?ofkP030000003om^h0ooK^
00H0ooK^100000070?ofkP030000003om^h0ooK^00H0ooK^100000070?ofkP030000003om^h0ooK^
00H0ooK^0`00000M0?ofkP40oooo001Q0?ofkP030000003om^h0ooK^00@000000P3om^h00`000000
ooK^0?ofkP080?ofkP030000003om^h0ooK^00@000000P3om^h00`000000ooK^0?ofkP080?ofkP03
0000003om^h0ooK^008000001@3om^h00`000000ooK^0?ofkP020?ofkP06000000001iT000000000
000/F</000000P3/TEH00`000000gXMV0=j7IP020=j7IP8000000P3OUGl00`000000dHZ30=6:P`09
0=6:P`0300000035OhH0aGn600P0aGn62@0000060;UoU0030000002^MI@0[WFD00@0[WFD2`000008
09aNQP030000002<DH@0S56400T0S56400<0000007HoP01f?h000`1f?h02000000<0JBMY00<00000
0487F`121e/00P121e/020000000jOS;0>Whb`000000`>^=0000003om^h000000P3om^h3000000@0
ooK^00<000000?ofkP3om^h01P3om^h4000000L0ooK^00<000000?ofkP3om^h01P3om^h3000000P0
ooK^00<000000?ofkP3om^h0103om^h200000080ooK^00<000000?ofkP3om^h01`3om^h010000000
ooK^0?ofkP3om^h400000080ooK^00<000000?ofkP3om^h01`3om^h010000000ooK^0?ofkP3om^h4
00000200ooK^0@3oool00680ooK^0P0000070?ofkP800000203om^h3000000L0ooK^0P0000080?of
kP<00000203om^h00`000000ooK^0?ofkP020?ofkP80000000<004?50000000000000P3/TEH00`00
0000gXMV0=j7IP040=j7IP<000002`3ARX<00`000000aGn60<EoQP0:0<EoQP030000002hM8L0^7B7
00@0^7B73P0000040:]ZQ`030000002[JXL0000000/0W5j600<0000008aAQ02<DH@02@2<DH@01000
0000MSn007HoP01f?h02000000D0JBMY00@000000487F`121e/0@PMK0P000000103Yn</000000<3[
S@0000020?ofkP<00000203om^h00`000000ooK^0?ofkP030?ofkP8000000P3om^h00`000000ooK^
0?ofkP070?ofkP040000003om^h0ooK^0?ofkP@000000P3om^h00`000000ooK^0?ofkP070?ofkP03
0000003om^h0ooK^00<000001@3om^h00`000000ooK^0?ofkP060?ofkP@000001P3om^h00`000000
ooK^0?ofkP060?ofkPD00000903om^h10?ooo`00H`3om^h00`000000ooK^0?ofkP070?ofkP040000
003om^h0ooK^0?ofkP@000000P3om^h00`000000ooK^0?ofkP070?ofkP040000003om^h0ooK^0?of
kP@000000P3om^h00`000000ooK^0?ofkP070?ofkP030000003om^h0ooK^00@0000000D004?50000
00000000k95F000000080=j7IP8000002P3ARX<00`000000aGn60<EoQP0:0<EoQP030000002hM8L0
^7B700X0^7B700<000000:]ZQ`2[JXL02`2[JXL00`000000W5j609aNQP0909aNQP030000002<DH@0
S56400T0S56400@0000007HoP000000000001P1Y9fT01P000000@PMK0487F`121e/0000002@0;`L0
00000P3om^h00`000000ooK^0?ofkP060?ofkP030000003om^h0ooK^00<000001@3om^h00`000000
ooK^0?ofkP060?ofkP@000001`3om^h00`000000ooK^0?ofkP060?ofkP<00000203om^h00`000000
ooK^0?ofkP040?ofkP8000000P3om^h00`000000ooK^0?ofkP060?ofkP040000003om^h0ooK^0?of
kP@00000:@3om^h10?ooo`00I03om^h00`000000ooK^0?ofkP060?ofkP@000001`3om^h2000000L0
ooK^100000070?ofkP030000003om^h0ooK^00H0ooK^0`0000030?ofkP0400000000@lD000000>9d
9P<000001`3NQfH00`000000d7e_00000003000000H0dHZ300<000000<EoQP35OhH02P35OhH00`00
0000^7B70;QdQ`0:0;QdQ`030000002[JXL0ZfZ700/0ZfZ700<0000009aNQP2LGXH02@2LGXH00`00
0000S56408aAQ00808aAQ0<00000201Y9fT01@000000@PMK0487F`000000900_00<0000000<0`>^=
0?ofkP3om^h0103om^h00`000000ooK^0?ofkP060?ofkP<00000203om^h00`000000ooK^0?ofkP04
0?ofkP8000000P3om^h00`000000ooK^0?ofkP070?ofkP040000003om^h0ooK^0?ofkP@000000P3o
m^h00`000000ooK^0?ofkP070?ofkP030000003om^h0ooK^00<00000103om^h00`000000ooK^0?of
kP060?ofkP@00000;@3om^h10?ooo`00I@3om^h00`000000ooK^0?ofkP030?ofkP8000000P3om^h0
0`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^00@000000P3om^h00`000000ooK^0?ofkP07
0?ofkP040000003om^h0ooK^0?ofkP@000000P3om^h010000000ooK^0?ofkP3om^h2000000050013
a@000000hW@V0>9d9P000000203NQfH00`000000d7e_0=1mK`020=1mK`@000000P3ARX<00`000000
aGn60<EoQP0:0<EoQP030000002hM8L0^7B700X0^7B700<000000:]ZQ`2[JXL02P2[JXL00`000000
W5j609aNQP0:09aNQP030000002<DH@0S56400@0S564100000000`23?G00000006TWJ@0806TWJ@<0
00000P0T02l010000000d_k00000000000070?ofkP040000003om^h0ooK^0?ofkP@000000P3om^h0
0`000000ooK^0?ofkP070?ofkP030000003om^h0ooK^00<000001@3om^h00`000000ooK^0?ofkP06
0?ofkP@000001P3om^h00`000000ooK^0?ofkP060?ofkP@00000203om^h00`000000ooK^0?ofkP03
0?ofkP800000<@3om^h10?ooo`00IP3om^h00`000000ooK^0?ofkP02000000D0ooK^00<000000?of
kP3om^h01`3om^h3000000L0ooK^0P0000070?ofkP@000001`3om^h01`000000ooK^0?ofkP3om^h0
00000013a@0000000P3RM2H3000000H0gXMV00<000000=1mK`3@OFl01P3@OFl5000000X0aGn600<0
00000;QdQ`2hM8L02P2hM8L00`000000ZfZ70:]ZQ`0:0:]ZQ`030000002LGXH0W5j600X0W5j600<0
000008aAQ02<DH@01000000508<mL0030000001Y9fT0JBMY00H0JBMY0P00000402@0;`<00000203o
m^h4000000L0ooK^00<000000?ofkP3om^h01P3om^h3000000T0ooK^00@000000?ofkP3om^h0ooK^
100000020?ofkP030000003om^h0ooK^00H0ooK^00@000000?ofkP3om^h0ooK^100000030?ofkP03
0000003om^h0ooK^00H0ooK^00<000000?ofkP3om^h00`00000c0?ofkP40oooo001W0?ofkP800000
203om^h00`000000ooK^0?ofkP040?ofkP8000000P3om^h00`000000ooK^0?ofkP070?ofkP030000
003om^h0ooK^00@000000P3om^h00`000000ooK^0?ofkP070?ofkP040000003om^h0ooK^0?ofkP80
00000`3RM2H010000000fG530000000000040=j7IP030000003@OFl0d7e_00P0d7e_00<000000<=b
L`33LW<0100000060<EoQP030000002hM8L0^7B700X0^7B700<000000:]ZQ`2[JXL02P2[JXL00`00
0000W5j609aNQP0709aNQPH000002@23?G000`000000JBMY06TWJ@0406TWJ@80000000<0E@I80000
000T02l00P0T02l01@000000d_k00000003om^h0000000<0ooK^100000020?ofkP030000003om^h0
ooK^00L0ooK^00@000000?ofkP3om^h0ooK^100000020?ofkP030000003om^h0ooK^00L0ooK^1000
00060?ofkP030000003om^h0ooK^00H0ooK^100000070?ofkP030000003om^h0ooK^00H0ooK^0`00
000f0?ofkP40oooo001X0?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h00`000005
0?ofkP030000003om^h0ooK^00H0ooK^0`0000070?ofkP8000001`3om^h700000080hW@V00@00000
0=Ua@`3ILD<0fG530P0000020=j7IP030000003@OFl0d7e_00P0d7e_00<000000<=bL`33LW<01033
LW<400000080aGn600<000000;QdQ`2hM8L02P2hM8L00`000000ZfZ70:]ZQ`0:0:]ZQ`040000002L
GXH0W5j609aNQPH000000`2GCW@00`000000Pce`08<mL00808<mL0030000001Y9fT0JBMY00<0JBMY
0P00000205D6B0030000000T02l0900_0080900_0P0000020?ofkP@000001`3om^h00`000000ooK^
0?ofkP060?ofkP@000001`3om^h00`000000ooK^0?ofkP040?ofkP8000000P3om^h00`000000ooK^
0?ofkP060?ofkP040000003om^h0ooK^0?ofkP@000000P3om^h00`000000ooK^0?ofkP070?ofkP04
0000003om^h0ooK^0?ofkP@00000>@3om^h10?ooo`00J@3om^h2000000L0ooK^0`0000080?ofkP03
0000003om^h0ooK^00@0ooK^0P0000020?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3o
m^h0100000020?ofkP030000003om^h0ooK^00<0000000<0hW@V0000003ILD<0103ILD<200000003
0=j7IP000000d7e_00P0d7e_00<000000<=bL`33LW<02033LW<9000000H0^7B700<000000:]ZQ`2[
JXL0102[JXL:000000T0Udid00<0000008<mL023?G002023?G0010000000JBMY06TWJ@1Y9fT20000
00@0E@I800<0000002@0;`0T02l00`0000000`3om^h00000000000020?ofkP030000003om^h0ooK^
00L0ooK^00@000000?ofkP3om^h0ooK^100000020?ofkP030000003om^h0ooK^00L0ooK^00<00000
0?ofkP3om^h00`0000040?ofkP030000003om^h0ooK^00H0ooK^100000070?ofkP030000003om^h0
ooK^00H0ooK^1000000m0?ofkP40oooo001[0?ofkP030000003om^h0ooK^00@000000P3om^h00`00
0000ooK^0?ofkP070?ofkP030000003om^h0ooK^00<000001@3om^h00`000000ooK^0?ofkP060?of
kP<000001`3om^h2000000030?ofkP000000000000<000001P3ILD<3000000P0d7e_00<000000<=b
L`33LW<02P33LW<00`000000]FMf0;EWMP040;EWMPd000001P2WG7H00`000000Udid09M>M00:09M>
M00300000023?G00Pce`00P0Pce`00@0000006TWJ@00000000001@1E1TP00`000000900_02@0;`05
000000D0ooK^00<000000?ofkP3om^h01P3om^h4000000L0ooK^00<000000?ofkP3om^h01P3om^h3
000000P0ooK^00<000000?ofkP3om^h00`3om^h200000080ooK^00<000000?ofkP3om^h01`3om^h0
10000000ooK^0?ofkP3om^h400000440ooK^0@3oool006`0ooK^0P0000070?ofkP8000001`3om^h3
000000P0ooK^00<000000?ofkP3om^h0103om^h200000080ooK^00<000000?ofkP3om^h01`3om^h3
00000080a4<000<000000=Ua@`3ILD<01@3ILD<00`000000c6UB00000002000000H0d7e_00<00000
0<=bL`33LW<02@33LW<00`000000]FMf0;EWMP0:0;EWMP030000002WG7H0Yeaf00X0Yeaf00<00000
09M>M02GCW@02P2GCW@00`000000Pce`08<mL00708<mL0<000001`1E1TP00`000000900_00000003
000000P0ooK^00@000000?ofkP3om^h0ooK^100000020?ofkP030000003om^h0ooK^00L0ooK^00@0
00000?ofkP3om^h0ooK^100000020?ofkP030000003om^h0ooK^00H0ooK^00<000000?ofkP3om^h0
0`0000050?ofkP030000003om^h0ooK^00H0ooK^100000150?ofkP40oooo001]0?ofkP030000003o
m^h0ooK^00L0ooK^00<000000?ofkP3om^h0100000020?ofkP030000003om^h0ooK^00L0ooK^00<0
00000?ofkP3om^h00`0000050?ofkP030000003om^h0ooK^00H0ooK^100000020<A3008000001P3I
LD<010000000c6UB0<aYDP3<JE82000000@0d7e_00<000000<=bL`33LW<02@33LW<00`000000]FMf
0;EWMP0:0;EWMP030000002WG7H0Yeaf00X0Yeaf00<0000009M>M02GCW@02P2GCW@00`000000Pce`
08<mL00308<mL0@0000000<0MR=E0000001E1TP01P1E1TP6000000T0ooK^100000070?ofkP030000
003om^h0ooK^00H0ooK^100000060?ofkP030000003om^h0ooK^00H0ooK^0`0000080?ofkP030000
003om^h0ooK^00@0ooK^0P0000190?ofkP40oooo001^0?ofkP8000001`3om^h3000000L0ooK^0P00
00070?ofkP<00000203om^h00`000000ooK^0?ofkP040?ofkP8000000P3om^h3000000030<A30000
0000bD`=00800000103ILD<00`000000c6UB0<aYDP030<aYDP<0000000<0d7e_00000033LW<02P33
LW<00`000000]FMf0;EWMP0:0;EWMP030000002WG7H0Yeaf00X0Yeaf00<0000009M>M02GCW@02P2G
CW@00`000000Pce`00000003000000@0MR=E00<0000005D6B01E1TP01@1E1TP40000000409SUW@00
0000ooK^000000H0ooK^0P0000020?ofkP030000003om^h0ooK^00L0ooK^00@000000?ofkP3om^h0
ooK^100000020?ofkP030000003om^h0ooK^00H0ooK^00@000000?ofkP3om^h0ooK^100000020?of
kP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h00`00001;0?ofkP40oooo001`0?ofkP03
0000003om^h0ooK^00@000000P3om^h00`000000ooK^0?ofkP070?ofkP030000003om^h0ooK^00@0
00000P3om^h00`000000ooK^0?ofkP070?ofkP030000003om^h0ooK^00<000001@3om^h300000004
0<A300000000bD`=0<U<3@8000000P3ILD<00`000000c6UB0<aYDP060<aYDP@000002@33LW<00`00
0000]FMf0;EWMP0:0;EWMP030000002WG7H0Yeaf00X0Yeaf00<0000009M>M02GCW@01`2GCW@50000
00P0MR=E00<0000005D6B01E1TP00`1E1TP50000000309SUW@000000ooK^0080ooK^00<000000?of
kP3om^h00`0000050?ofkP030000003om^h0ooK^00H0ooK^100000060?ofkP030000003om^h0ooK^
00H0ooK^100000070?ofkP030000003om^h0ooK^00H0ooK^0`00001>0?ofkP40oooo001a0?ofkP80
00001`3om^h2000000L0ooK^0`0000070?ofkP8000001`3om^h3000000T0ooK^00D000000?ofkP00
0000a4<0000000030<U<3@80000000<0fG530000003<JE801`3<JE800`000000_V1J0;iPFP060000
00<0`g9c00<000000;EWMP2eIgH02P2eIgH00`000000Yeaf0:MLMP0:0:MLMP040000002GCW@0Udid
09M>M0H000000`2=>5`00`000000MR=E07HSE@0707HSE@030000001E1TP0E@I800<0000000<0=P0E
0000000000000`0000040?ofkP<00000203om^h00`000000ooK^0?ofkP040?ofkP8000000P3om^h0
0`000000ooK^0?ofkP060?ofkP040000003om^h0ooK^0?ofkP@000000P3om^h00`000000ooK^0?of
kP070?ofkP040000003om^h0ooK^0?ofkP@00000D@3om^h10?ooo`00LP3om^h00`000000ooK^0?of
kP070?ofkP030000003om^h0ooK^00@000000P3om^h00`000000ooK^0?ofkP070?ofkP030000003o
m^h0ooK^00@000000P3om^h00`000000ooK^0?ofkP070?ofkPD000001@39C0d3000000L0c6UB00<0
00000;iPFP2nH5X01P2nH5X:000000H0]FMf00<000000:MLMP2WG7H0102WG7H:000000P0SCQL00<0
000007HSE@1f8eD01`1f8eD010000000E@I800000000000403H05@<000000P3om^h400000080ooK^
00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP03000000@0ooK^00<000000?ofkP3om^h0
1P3om^h4000000L0ooK^00<000000?ofkP3om^h01P3om^h4000005D0ooK^0@3oool007<0ooK^00<0
00000?ofkP3om^h01P3om^h3000000L0ooK^0P0000070?ofkP<000001`3om^h2000000D0ooK^0P00
00020?ofkP030000003om^h0ooK^008000001@39C0d3000000D0c6UB00<000000;iPFP2nH5X02@2n
H5X00`000000/5EN0;1EGP040;1EGPd000001P2PB5l00`000000SCQL08dhG00908dhG0030000001f
8eD0MR=E00H0MR=E0`00000503H05@H000001`3om^h00`000000ooK^0?ofkP060?ofkP<00000203o
m^h00`000000ooK^0?ofkP030?ofkP8000000P3om^h00`000000ooK^0?ofkP070?ofkP040000003o
m^h0ooK^0?ofkP@00000F@3om^h10?ooo`00M03om^h010000000ooK^0?ofkP3om^h400000080ooK^
00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP0400000080ooK^00<000000?ofkP3om^h0
1`3om^h00`000000ooK^0?ofkP02000000D0ooK^00<000000?ofkP3om^h00`0000030<U<3@030000
0031BbL0`D/W00<000000`3<JE800`000000_V1J0;iPFP080;iPFP030000002`EEh0/5EN00X0/5EN
00<000000:18G`2PB5l02P2PB5l00`000000SCQL08dhG00908dhG0030000001f8eD0MR=E0080MR=E
100000000`1P02`0000003H05@0403H05@@000000P3om^h00`000000ooK^0?ofkP060?ofkP040000
003om^h0ooK^0?ofkP@000000P3om^h00`000000ooK^0?ofkP060?ofkP030000003om^h0ooK^00<0
00001@3om^h00`000000ooK^0?ofkP060?ofkP@00000G@3om^h10?ooo`00M@3om^h3000000L0ooK^
00<000000?ofkP3om^h01P3om^h3000000L0ooK^00<000000?ofkP3om^h01P3om^h3000000P0ooK^
00@000000?ofkP3om^h0ooK^0`0000020<U<3@0300000031BbL0`D/W0080`D/W0P0000000`3<JE80
00000;iPFP090;iPFP030000002`EEh0/5EN00X0/5EN00<000000:18G`2PB5l02@2PB5l00`000000
SCQL08dhG00908dhG0030000001f8eD0000000<00000101P02`00`000000=P0E03H05@0203H05@@0
0000103om^h00`000000ooK^0?ofkP060?ofkP@000001`3om^h00`000000ooK^0?ofkP050?ofkP<0
00002@3om^h010000000ooK^0?ofkP3om^h400000640ooK^0@3oool007H0ooK^00<000000?ofkP3o
m^h01`3om^h010000000ooK^0?ofkP3om^h400000080ooK^00<000000?ofkP3om^h01P3om^h01000
0000ooK^0?ofkP3om^h400000080ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP06
000000H0`D/W100000090;iPFP030000002`EEh0/5EN00T0/5EN00<000000:18G`2PB5l02@2PB5l0
0`000000SCQL08dhG00708dhG0@00000201P02`010000000=P0E03H05@00000200@0008000001P3o
m^h010000000ooK^0?ofkP3om^h400000080ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^
0?ofkP0400000080ooK^00<000000?ofkP3om^h01`3om^h4000006D0ooK^0@3oool007L0ooK^00<0
00000?ofkP3om^h01P3om^h4000000L0ooK^00<000000?ofkP3om^h01@3om^h4000000L0ooK^00<0
00000?ofkP3om^h01P3om^h3000000<0ooK^1@0000060<5;9`030000002dA3D0000000D000000`2n
H5X00`000000/5EN0;1EGP090;1EGP030000002PB5l0X4QO00T0X4QO00@0000008dhG02=>5`0SCQL
1P00000207dH=`030000001P02`0H00/00H0H00/00<0000003H05@0000000P040003000000L0ooK^
100000070?ofkP030000003om^h0ooK^00H0ooK^0`0000070?ofkP030000003om^h0ooK^00@0ooK^
0P00001Y0?ofkP40oooo001h0?ofkP030000003om^h0ooK^00<0ooK^0P0000020?ofkP030000003o
m^h0ooK^00L0ooK^00<000000?ofkP3om^h0100000020?ofkP030000003om^h0ooK^00L0ooK^00@0
00000?ofkP3om^h0ooK^100000020?ofkP030000003om^h0ooK^00<0ooK^1P0000030<5;9`030000
002dA3D0]4@e00D0]4@e2@0000060;1EGP030000002PB5l0X4QO00@0X4QO2@00000707dH=`030000
001P02`0H00/00H0H00/0P00000200@0008000000`3om^h00`000000ooK^0?ofkP0400000080ooK^
00<000000?ofkP3om^h01`3om^h010000000ooK^0?ofkP3om^h400000080ooK^00<000000?ofkP3o
m^h01P3om^h00`000000ooK^0?ofkP03000006/0ooK^0@3oool007T0ooK^00<000000?ofkP3om^h0
0P0000050?ofkP8000001`3om^h3000000L0ooK^0P0000070?ofkP@000001`3om^h00`000000ooK^
0?ofkP040?ofkP8000000P2U6@05000000T0]4@e00<000000:Dj>`2U>S/00`2U>S/=000000D0Tb`l
00<0000007dH=`1m63L0201m63L00`000000H00/0600;0020600;0@0000000@01000000000000000
00001@3om^h3000000L0ooK^00<000000?ofkP3om^h01P3om^h4000000H0ooK^00<000000?ofkP3o
m^h01P3om^h3000006h0ooK^0@3oool007X0ooK^0P0000090?ofkP030000003om^h0ooK^00@00000
0P3om^h00`000000ooK^0?ofkP070?ofkP030000003om^h0ooK^00@000000P3om^h00`000000ooK^
0?ofkP070?ofkP030000003om^h0ooK^00@0000000<0ooK^000000000000102U6@04000000H0]4@e
00<000000:Dj>`2U>S/02@2U>S/00`000000Tb`l09</?00909</?0030000001m63L0OAPg00L0OAPg
00<000000600;00000000`0000000`0j0000000000000002000000H0ooK^0P0000020?ofkP030000
003om^h0ooK^00H0ooK^00@000000?ofkP3om^h0ooK^100000020?ofkP030000003om^h0ooK^00H0
ooK^00@000000?ofkP3om^h0ooK^1000001a0?ofkP40oooo001k0?ofkP030000003om^h0ooK^00L0
ooK^0`0000070?ofkP8000001`3om^h3000000L0ooK^0P0000070?ofkP<000001`3om^h400000004
0:DI00000000WAL009dG00D000000P2dA3D00`000000YCXk0:Dj>`080:Dj>`030000002C;3`0Tb`l
00T0Tb`l00<0000007dH=`1m63L01@1m63L4000000<0>P000P0000040?ofkP030000003om^h0ooK^
00<00000103om^h00`000000ooK^0?ofkP060?ofkP@000001`3om^h00`000000ooK^0?ofkP050?of
kP@00000M@3om^h10?ooo`00O03om^h2000000D0ooK^0P0000020?ofkP030000003om^h0ooK^00L0
ooK^00<000000?ofkP3om^h0100000020?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3o
m^h0100000020?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP0000000P00000609dG00P0
00001@2U>S/00`000000Tb`l09</?00909</?0030000001m63L0OAPg00D0000000@0H0000000000j
0000>P000`0000060?ofkP<00000203om^h010000000ooK^0?ofkP3om^h400000080ooK^00<00000
0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP04000007T0ooK^0@3oool007h0ooK^00<000000?of
kP3om^h00P0000050?ofkP030000003om^h0ooK^00H0ooK^0`0000070?ofkP030000003om^h0ooK^
00H0ooK^0`0000070?ofkP030000003om^h0ooK^00H0ooK^0`0000040?ofkPD0000000<0WAL00000
002>3P@0102>3P@D000000@0H0001@0000000`3om^h000000?ofkP020?ofkP@000000P3om^h00`00
0000ooK^0?ofkP060?ofkP@000001`3om^h00`000000ooK^0?ofkP060?ofkP<00000O@3om^h10?oo
o`00O`3om^h2000000P0ooK^00@000000?ofkP3om^h0ooK^100000020?ofkP030000003om^h0ooK^
00H0ooK^00@000000?ofkP3om^h0ooK^100000020?ofkP030000003om^h0ooK^00H0ooK^00@00000
0?ofkP3om^h0ooK^100000020?ofkP030000003om^h0ooK^00H0ooK^1P00000708h>10030000001k
00D0N`0500P0N`0500<000000600001P00001@0000060?ofkP@000001`3om^h00`000000ooK^0?of
kP030?ofkP8000000P3om^h00`000000ooK^0?ofkP070?ofkP040000003om^h0ooK^0?ofkP@00000
P03om^h10?ooo`00P03om^h00`000000ooK^0?ofkP060?ofkP@000001`3om^h00`000000ooK^0?of
kP050?ofkP@000001`3om^h00`000000ooK^0?ofkP050?ofkP@000001`3om^h00`000000ooK^0?of
kP030?ofkP8000000P3om^h010000000ooK^0?ofkP3om^hE000000@0ooK^00<000000?ofkP3om^h0
100000020?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h00P0000050?ofkP030000
003om^h0ooK^00H0ooK^100000240?ofkP40oooo00210?ofkP030000003om^h0ooK^00<0ooK^0P00
00020?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h0100000020?ofkP030000003o
m^h0ooK^00L0ooK^00<000000?ofkP3om^h0100000020?ofkP030000003om^h0ooK^00L0ooK^00<0
00000?ofkP3om^h00P0000050?ofkP030000003om^h0ooK^00H0ooK^0`0000070?ofkP030000003o
m^h0ooK^00H0ooK^0`0000070?ofkP030000003om^h0ooK^00H0ooK^0`0000080?ofkP040000003o
m^h0ooK^0?ofkP@00000R03om^h10?ooo`00PP3om^h00`000000ooK^0?ofkP02000000D0ooK^0P00
00070?ofkP<000001`3om^h2000000L0ooK^0`0000070?ofkP030000003om^h0ooK^00H0ooK^0`00
00080?ofkP040000003om^h0ooK^0?ofkP@000000P3om^h00`000000ooK^0?ofkP060?ofkP040000
003om^h0ooK^0?ofkP@000000P3om^h00`000000ooK^0?ofkP060?ofkP040000003om^h0ooK^0?of
kP@000000P3om^h00`000000ooK^0?ofkP060?ofkP@00000S03om^h10?ooo`00P`3om^h2000000T0
ooK^00<000000?ofkP3om^h0100000020?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3o
m^h0100000020?ofkP030000003om^h0ooK^00H0ooK^00@000000?ofkP3om^h0ooK^100000020?of
kP030000003om^h0ooK^00H0ooK^100000070?ofkP030000003om^h0ooK^00D0ooK^100000070?of
kP030000003om^h0ooK^00D0ooK^100000070?ofkP030000003om^h0ooK^00<0ooK^0P00002@0?of
kP40oooo00240?ofkP030000003om^h0ooK^00L0ooK^0`0000070?ofkP030000003om^h0ooK^00H0
ooK^0`0000070?ofkP030000003om^h0ooK^00D0ooK^100000070?ofkP030000003om^h0ooK^00<0
ooK^0P0000020?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h0100000020?ofkP03
0000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h0100000020?ofkP030000003om^h0ooK^00L0
ooK^00<000000?ofkP3om^h00P00002B0?ofkP40oooo00250?ofkP8000001@3om^h200000080ooK^
00<000000?ofkP3om^h01P3om^h010000000ooK^0?ofkP3om^h400000080ooK^00<000000?ofkP3o
m^h01P3om^h00`000000ooK^0?ofkP0400000080ooK^00<000000?ofkP3om^h01`3om^h00`000000
ooK^0?ofkP02000000D0ooK^00<000000?ofkP3om^h01P3om^h3000000L0ooK^00<000000?ofkP3o
m^h01P3om^h3000000L0ooK^00<000000?ofkP3om^h01P3om^h3000009@0ooK^0@3oool008L0ooK^
00<000000?ofkP3om^h00P0000050?ofkP030000003om^h0ooK^00D0ooK^100000070?ofkP030000
003om^h0ooK^00D0ooK^0`0000070?ofkP8000001`3om^h3000000P0ooK^00@000000?ofkP3om^h0
ooK^100000020?ofkP030000003om^h0ooK^00H0ooK^00@000000?ofkP3om^h0ooK^100000020?of
kP030000003om^h0ooK^00H0ooK^00@000000?ofkP3om^h0ooK^1000002G0?ofkP40oooo00280?of
kP800000203om^h00`000000ooK^0?ofkP0400000080ooK^00<000000?ofkP3om^h01`3om^h00`00
0000ooK^0?ofkP0400000080ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP040000
0080ooK^00<000000?ofkP3om^h01P3om^h4000000L0ooK^00<000000?ofkP3om^h01@3om^h40000
00L0ooK^00<000000?ofkP3om^h01@3om^h4000009/0ooK^0@3oool008T0ooK^00<000000?ofkP3o
m^h01P3om^h3000000L0ooK^0P0000070?ofkP<000001`3om^h00`000000ooK^0?ofkP060?ofkP<0
00001`3om^h200000080ooK^100000020?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3o
m^h0100000020?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h01000002O0?ofkP40
oooo002:0?ofkP8000000P3om^h400000080ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^
0?ofkP0400000080ooK^00<000000?ofkP3om^h01P3om^h010000000ooK^0?ofkP3om^h400000080
ooK^00<000000?ofkP3om^h01P3om^h3000000L0ooK^00<000000?ofkP3om^h01P3om^h3000000L0
ooK^00<000000?ofkP3om^h01P3om^h300000:<0ooK^0@3oool008`0ooK^0P0000070?ofkP030000
003om^h0ooK^00H0ooK^0`0000070?ofkP030000003om^h0ooK^00D0ooK^100000070?ofkP030000
003om^h0ooK^00<0ooK^0P0000020?ofkP030000003om^h0ooK^00H0ooK^00@000000?ofkP3om^h0
ooK^100000020?ofkP030000003om^h0ooK^00H0ooK^00@000000?ofkP3om^h0ooK^1000002V0?of
kP40oooo002=0?ofkP030000003om^h0ooK^00H0ooK^00@000000?ofkP3om^h0ooK^100000020?of
kP030000003om^h0ooK^00H0ooK^00<000000?ofkP3om^h0100000020?ofkP030000003om^h0ooK^
00L0ooK^00<000000?ofkP3om^h00P0000050?ofkP030000003om^h0ooK^00D0ooK^100000070?of
kP030000003om^h0ooK^00D0ooK^1000002Z0?ofkP40oooo002>0?ofkP030000003om^h0ooK^00D0
ooK^100000070?ofkP030000003om^h0ooK^00D0ooK^0`0000070?ofkP8000001`3om^h3000000P0
ooK^00<000000?ofkP3om^h0100000020?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3o
m^h01000002^0?ofkP40oooo002?0?ofkP030000003om^h0ooK^00@000000P3om^h00`000000ooK^
0?ofkP070?ofkP030000003om^h0ooK^00@000000P3om^h00`000000ooK^0?ofkP070?ofkP030000
003om^h0ooK^00@000000P3om^h00`000000ooK^0?ofkP060?ofkP<000001`3om^h00`000000ooK^
0?ofkP060?ofkP<00000/P3om^h10?ooo`00T03om^h2000000L0ooK^0P0000070?ofkP<000001`3o
m^h00`000000ooK^0?ofkP060?ofkP<000001`3om^h200000080ooK^100000020?ofkP030000003o
m^h0ooK^00H0ooK^00@000000?ofkP3om^h0ooK^1000002e0?ofkP40oooo002A0?ofkP030000003o
m^h0ooK^00L0ooK^00<000000?ofkP3om^h0100000020?ofkP030000003om^h0ooK^00H0ooK^00@0
00000?ofkP3om^h0ooK^100000020?ofkP030000003om^h0ooK^00H0ooK^0`0000070?ofkP030000
003om^h0ooK^00D0ooK^1000002i0?ofkP40oooo002B0?ofkP8000001`3om^h3000000L0ooK^00<0
00000?ofkP3om^h01@3om^h4000000L0ooK^00<000000?ofkP3om^h00`3om^h200000080ooK^00<0
00000?ofkP3om^h01P3om^h00`000000ooK^0?ofkP0400000;d0ooK^0@3oool009@0ooK^00<00000
0?ofkP3om^h0100000020?ofkP030000003om^h0ooK^00H0ooK^00<000000?ofkP3om^h010000002
0?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h00P0000050?ofkP030000003om^h0
ooK^00D0ooK^0`0000310?ofkP40oooo002E0?ofkP8000001`3om^h00`000000ooK^0?ofkP050?of
kP<000001`3om^h00`000000ooK^0?ofkP060?ofkP<00000203om^h00`000000ooK^0?ofkP040000
0<@0ooK^0@3oool009H0ooK^00<000000?ofkP3om^h01P3om^h00`000000ooK^0?ofkP0400000080
ooK^00<000000?ofkP3om^h01P3om^h010000000ooK^0?ofkP3om^h400000080ooK^00<000000?of
kP3om^h01P3om^h300000<P0ooK^0@3oool009L0ooK^00<000000?ofkP3om^h01@3om^h3000000L0
ooK^00<000000?ofkP3om^h01@3om^h4000000L0ooK^0P0000020?ofkP@00000b`3om^h10?ooo`00
V03om^h00`000000ooK^0?ofkP0400000080ooK^00<000000?ofkP3om^h01P3om^h00`000000ooK^
0?ofkP0400000080ooK^0P0000080?ofkP<00000c`3om^h10?ooo`00V@3om^h2000000L0ooK^00<0
00000?ofkP3om^h01@3om^h3000000P0ooK^0P0000020?ofkP@00000dP3om^h10?ooo`00VP3om^h0
0`000000ooK^0?ofkP060?ofkP030000003om^h0ooK^00@000000P3om^h00`000000ooK^0?ofkP07
0?ofkP<00000eP3om^h10?ooo`00V`3om^h00`000000ooK^0?ofkP050?ofkP<000001`3om^h20000
00<0ooK^1000003I0?ofkP40oooo002L0?ofkP030000003om^h0ooK^00@000000P3om^h00`000000
ooK^0?ofkP060?ofkP@00000g@3om^h10?ooo`00W@3om^h2000000L0ooK^0P0000020?ofkP@00000
h@3om^h10?ooo`00WP3om^h00`000000ooK^0?ofkP060?ofkP<00000i@3om^h10?ooo`00W`3om^h2
00000080ooK^1000003X0?ofkP40oooo002Q0?ofkP800000k03om^h10?ooo`00o`3om^j@0?ofkP40
oooo003o0?ofkY00ooK^0@3oool00?l0ooK^T03om^h10?ooo`00o`3om^j@0?ofkP40oooo003o0?of
kY00ooK^0@3oool00?l0ooK^T03om^h10?ooo`00o`3om^j@0?ofkP40oooo003o0?ofkY00ooK^0@3o
ool00?l0ooK^T03om^h10?ooo`00o`3om^j@0?ofkP40oooo003o0?ofkY00ooK^0@3oool00?l0ooK^
T03om^h10?ooo`00o`3om^j@0?ofkP40oooo003o0?ofkY00ooK^0@3oool00?l0ooK^T03om^h10?oo
o`00o`3om^j@0?ofkP40oooo003o0?ofkY00ooK^0@3oool00?l0ooK^T03om^h10?ooo`00o`3om^j@
0?ofkP40oooo003o0?ofkY00ooK^0@3oool00?l0ooK^T03om^h10?ooo`00o`3om^j@0?ofkP40oooo
003o0?ofkY00ooK^0@3oool00?l0ooK^T03om^h10?ooo`00o`3om^j@0?ofkP40oooo003o0?ofkY00
ooK^0@3oool00?l0ooK^T03om^h10?ooo`00o`3om^j@0?ofkP40oooo003o0?ofkY00ooK^0@3oool0
0?l0ooK^T03om^h10?ooo`00o`3om^j@0?ofkP40oooo003o0?ofkY00ooK^0@3oool00?l0ooK^T03o
m^h10?ooo`00o`3om^j@0?ofkP40oooo003o0?ofkY00ooK^0@3oool00?l0ooK^T03om^h10?ooo`00
o`3om^j@0?ofkP40oooo003o0?ofkY00ooK^0@3oool00001\
\>"],
  ImageRangeCache->{{{0, 399}, {306.188, 0}} -> {-0.000379037, 0.0849506, \
0.00239023, 0.00239023}}]
}, Open  ]],

Cell[TextData[{
  "There are also examples of ParametricDraw3D in the examples for ",
  ButtonBox["Draw3DItems",
    ButtonData:>{"Draw3DItems"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["DrawingTransform3D",
    ButtonData:>{"DrawingTransform3D"},
    ButtonStyle->"AddOnsLink"],
  ", ",
  ButtonBox["IteratorSubstitution",
    ButtonData:>{"IteratorSubstitution"},
    ButtonStyle->"AddOnsLink"],
  " and ",
  ButtonBox["NeutralLighting",
    ButtonData:>{"NeutralLighting"},
    ButtonStyle->"AddOnsLink"],
  "."
}], "Text"]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"5.0 for Microsoft Windows",
ScreenRectangle->{{0, 1024}, {0, 677}},
WindowToolbars->{},
WindowSize->{494, 639},
WindowMargins->{{1, Automatic}, {Automatic, 0}},
StyleDefinitions -> "HelpBrowser.nb"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "Function?"->{
    Cell[1776, 53, 63, 1, 41, "ObjectName",
      CellTags->"Function?"],
    Cell[1842, 56, 501, 18, 50, "Usage",
      CellTags->"Function?"],
    Cell[2346, 76, 94, 3, 41, "MathCaption",
      CellTags->"Function?"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"Function?", 245308, 9930}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 63, 1, 41, "ObjectName",
  CellTags->"Function?"],
Cell[1842, 56, 501, 18, 50, "Usage",
  CellTags->"Function?"],
Cell[2346, 76, 94, 3, 41, "MathCaption",
  CellTags->"Function?"],
Cell[2443, 81, 177, 3, 58, "MathCaption"],
Cell[2623, 86, 103, 2, 41, "MathCaption"],
Cell[2729, 90, 553, 21, 58, "MathCaption"],

Cell[CellGroupData[{
Cell[3307, 115, 33, 0, 39, "ExampleSection"],
Cell[3343, 117, 97, 2, 29, "Input"],
Cell[3443, 121, 157, 3, 42, "Text"],

Cell[CellGroupData[{
Cell[3625, 128, 954, 18, 329, "Input"],
Cell[4582, 148, 239494, 9740, 314, 114251, 8190, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]],
Cell[244091, 9891, 538, 18, 42, "Text"]
}, Open  ]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

