(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     36432,        942]*)
(*NotebookOutlinePosition[     37560,        982]*)
(*  CellTagsIndexPosition[     37516,        978]*)
(*WindowFrame->Palette*)



Notebook[{
Cell[BoxData[GridBox[{
        {
          ButtonBox[" ",
            ButtonData:>"LampBlack",
            Background->RGBColor[0.179995, 0.280003, 0.229999],
            ButtonNote->"LampBlack"], 
          ButtonBox[" ",
            ButtonData:>"SeaGreen",
            Background->RGBColor[0.180392, 0.545113, 0.341192],
            ButtonNote->"SeaGreen"], 
          ButtonBox[" ",
            ButtonData:>"EmeraldGreen",
            Background->RGBColor[0, 0.790005, 0.340002],
            ButtonNote->"EmeraldGreen"], 
          ButtonBox[" ",
            ButtonData:>"ManganeseBlue",
            Background->RGBColor[0.00999466, 0.659998, 0.620005],
            ButtonNote->"ManganeseBlue"], 
          ButtonBox[" ",
            ButtonData:>"TurquoiseBlue",
            Background->RGBColor[0, 0.780011, 0.550011],
            ButtonNote->"TurquoiseBlue"], 
          ButtonBox[" ",
            ButtonData:>"MediumSeaGreen",
            Background->RGBColor[0.235294, 0.702007, 0.443091],
            ButtonNote->"MediumSeaGreen"], 
          ButtonBox[" ",
            ButtonData:>"LightSeaGreen",
            Background->RGBColor[0.125505, 0.698009, 0.666712],
            ButtonNote->"LightSeaGreen"]},
        {
          ButtonBox[" ",
            ButtonData:>"SpringGreen",
            Background->RGBColor[0, 1, 0.497993],
            ButtonNote->"SpringGreen"], 
          ButtonBox[" ",
            ButtonData:>"ColdGray",
            Background->RGBColor[0.500008, 0.540002, 0.530007],
            ButtonNote->"ColdGray"], 
          ButtonBox[" ",
            ButtonData:>"MediumSpringGreen",
            Background->RGBColor[0, 0.980407, 0.603906],
            ButtonNote->"MediumSpringGreen"], 
          ButtonBox[" ",
            ButtonData:>"MediumAquamarine",
            Background->RGBColor[0.4, 0.803906, 0.666712],
            ButtonNote->"MediumAquamarine"], 
          ButtonBox[" ",
            ButtonData:>"MediumTurquoise",
            Background->RGBColor[0.282399, 0.819608, 0.8],
            ButtonNote->"MediumTurquoise"], 
          ButtonBox[" ",
            ButtonData:>"Turquoise",
            Background->RGBColor[0.250996, 0.878401, 0.815702],
            ButtonNote->"Turquoise"], 
          ButtonBox[" ",
            ButtonData:>"Aquamarine",
            Background->RGBColor[0.497993, 1, 0.831403],
            ButtonNote->"Aquamarine"]},
        {
          ButtonBox[" ",
            ButtonData:>"MintCream",
            Background->RGBColor[0.9608, 1, 0.980407],
            ButtonNote->"MintCream"], 
          ButtonBox[" ",
            ButtonData:>"DarkGreen",
            Background->RGBColor[0, 0.392187, 0],
            ButtonNote->"DarkGreen"], 
          ButtonBox[" ",
            ButtonData:>"TerreVerte",
            Background->RGBColor[0.219989, 0.370001, 0.0599985],
            ButtonNote->"TerreVerte"], 
          ButtonBox[" ",
            ButtonData:>"SapGreen",
            Background->RGBColor[0.18999, 0.500008, 0.0800031],
            ButtonNote->"SapGreen"], 
          ButtonBox[" ",
            ButtonData:>"Olive",
            Background->RGBColor[0.229999, 0.370001, 0.170001],
            ButtonNote->"Olive"], 
          ButtonBox[" ",
            ButtonData:>"ForestGreen",
            Background->RGBColor[0.133303, 0.545113, 0.133303],
            ButtonNote->"ForestGreen"], 
          ButtonBox[" ",
            ButtonData:>"DarkOliveGreen",
            Background->RGBColor[0.333288, 0.419593, 0.184298],
            ButtonNote->"DarkOliveGreen"]},
        {
          ButtonBox[" ",
            ButtonData:>"ChromeOxideGreen",
            Background->RGBColor[0.4, 0.500008, 0.0800031],
            ButtonNote->"ChromeOxideGreen"], 
          ButtonBox[" ",
            ButtonData:>"PermanentGreen",
            Background->RGBColor[0.0399939, 0.790005, 0.170001],
            ButtonNote->"PermanentGreen"], 
          ButtonBox[" ",
            ButtonData:>"Green",
            Background->RGBColor[0, 1, 0],
            ButtonNote->"Green"], 
          ButtonBox[" ",
            ButtonData:>"CobaltGreen",
            Background->RGBColor[0.239994, 0.570001, 0.250004],
            ButtonNote->"CobaltGreen"], 
          ButtonBox[" ",
            ButtonData:>"OliveDrab",
            Background->RGBColor[0.419593, 0.556909, 0.137301],
            ButtonNote->"OliveDrab"], 
          ButtonBox[" ",
            ButtonData:>"LimeGreen",
            Background->RGBColor[0.196094, 0.803906, 0.196094],
            ButtonNote->"LimeGreen"], 
          ButtonBox[" ",
            ButtonData:>"CinnabarGreen",
            Background->RGBColor[0.379995, 0.700008, 0.159991],
            ButtonNote->"CinnabarGreen"]},
        {
          ButtonBox[" ",
            ButtonData:>"WarmGray",
            Background->RGBColor[0.500008, 0.500008, 0.409995],
            ButtonNote->"WarmGray"], 
          ButtonBox[" ",
            ButtonData:>"LawnGreen",
            Background->RGBColor[0.48629, 0.988205, 0],
            ButtonNote->"LawnGreen"], 
          ButtonBox[" ",
            ButtonData:>"Chartreuse",
            Background->RGBColor[0.497993, 1, 0],
            ButtonNote->"Chartreuse"], 
          ButtonBox[" ",
            ButtonData:>"YellowGreen",
            Background->RGBColor[0.603906, 0.803906, 0.196094],
            ButtonNote->"YellowGreen"], 
          ButtonBox[" ",
            ButtonData:>"Gold",
            Background->RGBColor[1, 0.843107, 0],
            ButtonNote->"Gold"], 
          ButtonBox[" ",
            ButtonData:>"DarkSeaGreen",
            Background->RGBColor[0.5608, 0.737301, 0.5608],
            ButtonNote->"DarkSeaGreen"], 
          ButtonBox[" ",
            ButtonData:>"GreenYellow",
            Background->RGBColor[0.678401, 1, 0.184298],
            ButtonNote->"GreenYellow"]},
        {
          ButtonBox[" ",
            ButtonData:>"LightViridian",
            Background->RGBColor[0.429999, 1, 0.439994],
            ButtonNote->"LightViridian"], 
          ButtonBox[" ",
            ButtonData:>"DarkKhaki",
            Background->RGBColor[0.741207, 0.717601, 0.419593],
            ButtonNote->"DarkKhaki"], 
          ButtonBox[" ",
            ButtonData:>"CadmiumLemon",
            Background->RGBColor[1, 0.889998, 0.00999466],
            ButtonNote->"CadmiumLemon"], 
          ButtonBox[" ",
            ButtonData:>"Yellow",
            Background->RGBColor[1, 1, 0],
            ButtonNote->"Yellow"], 
          ButtonBox[" ",
            ButtonData:>"Banana",
            Background->RGBColor[0.889998, 0.81001, 0.340002],
            ButtonNote->"Banana"], 
          ButtonBox[" ",
            ButtonData:>"PaleGreen",
            Background->RGBColor[0.596109, 0.984298, 0.596109],
            ButtonNote->"PaleGreen"], 
          ButtonBox[" ",
            ButtonData:>"LightGoldenrod",
            Background->RGBColor[0.933303, 0.866697, 0.509789],
            ButtonNote->"LightGoldenrod"]},
        {
          ButtonBox[" ",
            ButtonData:>"Khaki",
            Background->RGBColor[0.941207, 0.902007, 0.549004],
            ButtonNote->"Khaki"], 
          ButtonBox[" ",
            ButtonData:>"PaleGoldenrod",
            Background->RGBColor[0.933303, 0.909804, 0.666712],
            ButtonNote->"PaleGoldenrod"], 
          ButtonBox[" ",
            ButtonData:>"Mint",
            Background->RGBColor[0.740001, 0.990005, 0.790005],
            ButtonNote->"Mint"], 
          ButtonBox[" ",
            ButtonData:>"LightBeige",
            Background->RGBColor[0.9608, 0.9608, 0.862699],
            ButtonNote->"LightBeige"], 
          ButtonBox[" ",
            ButtonData:>"LemonChiffon",
            Background->RGBColor[1, 0.980407, 0.803906],
            ButtonNote->"LemonChiffon"], 
          ButtonBox[" ",
            ButtonData:>"Cornsilk",
            Background->RGBColor[1, 0.972503, 0.862699],
            ButtonNote->"Cornsilk"], 
          ButtonBox[" ",
            ButtonData:>"LightYellow",
            Background->RGBColor[1, 1, 0.878401],
            ButtonNote->"LightYellow"]},
        {
          ButtonBox[" ",
            ButtonData:>"Honeydew",
            Background->RGBColor[0.941207, 1, 0.941207],
            ButtonNote->"Honeydew"], 
          ButtonBox[" ",
            ButtonData:>"Titanium",
            Background->RGBColor[0.990005, 1, 0.940002],
            ButtonNote->"Titanium"], 
          ButtonBox[" ",
            ButtonData:>"Ivory",
            Background->RGBColor[1, 1, 0.941207],
            ButtonNote->"Ivory"], 
          ButtonBox[" ",
            ButtonData:>"VanDykeBrown",
            Background->RGBColor[0.370001, 0.149996, 0.0200046],
            ButtonNote->"VanDykeBrown"], 
          ButtonBox[" ",
            ButtonData:>"Sepia",
            Background->RGBColor[0.370001, 0.149996, 0.0699931],
            ButtonNote->"Sepia"], 
          ButtonBox[" ",
            ButtonData:>"DeepOchre",
            Background->RGBColor[0.449989, 0.239994, 0.0999924],
            ButtonNote->"DeepOchre"], 
          ButtonBox[" ",
            ButtonData:>"RawUmber",
            Background->RGBColor[0.449989, 0.289998, 0.0699931],
            ButtonNote->"RawUmber"]},
        {
          ButtonBox[" ",
            ButtonData:>"BurntSienna",
            Background->RGBColor[0.540002, 0.209995, 0.0599985],
            ButtonNote->"BurntSienna"], 
          ButtonBox[" ",
            ButtonData:>"Brown",
            Background->RGBColor[0.500008, 0.164691, 0.164691],
            ButtonNote->"Brown"], 
          ButtonBox[" ",
            ButtonData:>"BurntUmber",
            Background->RGBColor[0.540002, 0.2, 0.140002],
            ButtonNote->"BurntUmber"], 
          ButtonBox[" ",
            ButtonData:>"SaddleBrown",
            Background->RGBColor[0.545113, 0.270604, 0.0744945],
            ButtonNote->"SaddleBrown"], 
          ButtonBox[" ",
            ButtonData:>"IndianRed",
            Background->RGBColor[0.689998, 0.0899977, 0.119997],
            ButtonNote->"IndianRed"], 
          ButtonBox[" ",
            ButtonData:>"BrownOchre",
            Background->RGBColor[0.530007, 0.259998, 0.119997],
            ButtonNote->"BrownOchre"], 
          ButtonBox[" ",
            ButtonData:>"MarsOrange",
            Background->RGBColor[0.590005, 0.269993, 0.0800031],
            ButtonNote->"MarsOrange"]},
        {
          ButtonBox[" ",
            ButtonData:>"Peach",
            Background->RGBColor[0.439994, 0.259998, 0.259998],
            ButtonNote->"Peach"], 
          ButtonBox[" ",
            ButtonData:>"Firebrick",
            Background->RGBColor[0.698009, 0.133303, 0.133303],
            ButtonNote->"Firebrick"], 
          ButtonBox[" ",
            ButtonData:>"Red",
            Background->RGBColor[1, 0, 0],
            ButtonNote->"Red"], 
          ButtonBox[" ",
            ButtonData:>"Raspberry",
            Background->RGBColor[0.530007, 0.149996, 0.340002],
            ButtonNote->"Raspberry"], 
          ButtonBox[" ",
            ButtonData:>"DeepCadmiumRed",
            Background->RGBColor[0.889998, 0.0899977, 0.0500038],
            ButtonNote->"DeepCadmiumRed"], 
          ButtonBox[" ",
            ButtonData:>"VenetianRed",
            Background->RGBColor[0.829999, 0.0999924, 0.119997],
            ButtonNote->"VenetianRed"], 
          ButtonBox[" ",
            ButtonData:>"LightCadmiumRed",
            Background->RGBColor[1, 0.00999466, 0.0500038],
            ButtonNote->"LightCadmiumRed"]},
        {
          ButtonBox[" ",
            ButtonData:>"Sienna",
            Background->RGBColor[0.627512, 0.321599, 0.176501],
            ButtonNote->"Sienna"], 
          ButtonBox[" ",
            ButtonData:>"Brick",
            Background->RGBColor[0.61001, 0.4, 0.119997],
            ButtonNote->"Brick"], 
          ButtonBox[" ",
            ButtonData:>"GeraniumLake",
            Background->RGBColor[0.889998, 0.0699931, 0.18999],
            ButtonNote->"GeraniumLake"], 
          ButtonBox[" ",
            ButtonData:>"EnglishRed",
            Background->RGBColor[0.829999, 0.239994, 0.0999924],
            ButtonNote->"EnglishRed"], 
          ButtonBox[" ",
            ButtonData:>"BrownMadder",
            Background->RGBColor[0.859998, 0.159991, 0.159991],
            ButtonNote->"BrownMadder"], 
          ButtonBox[" ",
            ButtonData:>"RawSienna",
            Background->RGBColor[0.780011, 0.379995, 0.0800031],
            ButtonNote->"RawSienna"], 
          ButtonBox[" ",
            ButtonData:>"AlizarinCrimson",
            Background->RGBColor[0.889998, 0.149996, 0.209995],
            ButtonNote->"AlizarinCrimson"]},
        {
          ButtonBox[" ",
            ButtonData:>"Maroon",
            Background->RGBColor[0.690211, 0.18819, 0.376501],
            ButtonNote->"Maroon"], 
          ButtonBox[" ",
            ButtonData:>"DeepMadderLake",
            Background->RGBColor[0.889998, 0.179995, 0.18999],
            ButtonNote->"DeepMadderLake"], 
          ButtonBox[" ",
            ButtonData:>"OrangeRed",
            Background->RGBColor[1, 0.270604, 0],
            ButtonNote->"OrangeRed"], 
          ButtonBox[" ",
            ButtonData:>"PermanentRedViolet",
            Background->RGBColor[0.859998, 0.149996, 0.269993],
            ButtonNote->"PermanentRedViolet"], 
          ButtonBox[" ",
            ButtonData:>"GreenishUmber",
            Background->RGBColor[1, 0.239994, 0.0500038],
            ButtonNote->"GreenishUmber"], 
          ButtonBox[" ",
            ButtonData:>"DarkGoldenrod",
            Background->RGBColor[0.721599, 0.525505, 0.0431067],
            ButtonNote->"DarkGoldenrod"], 
          ButtonBox[" ",
            ButtonData:>"RoseMadder",
            Background->RGBColor[0.889998, 0.209995, 0.219989],
            ButtonNote->"RoseMadder"]},
        {
          ButtonBox[" ",
            ButtonData:>"Chocolate",
            Background->RGBColor[0.823499, 0.411795, 0.117601],
            ButtonNote->"Chocolate"], 
          ButtonBox[" ",
            ButtonData:>"MediumVioletRed",
            Background->RGBColor[0.780407, 0.0823987, 0.521614],
            ButtonNote->"MediumVioletRed"], 
          ButtonBox[" ",
            ButtonData:>"CadmiumOrange",
            Background->RGBColor[1, 0.379995, 0.00999466],
            ButtonNote->"CadmiumOrange"], 
          ButtonBox[" ",
            ButtonData:>"GoldOchre",
            Background->RGBColor[0.780011, 0.469993, 0.149996],
            ButtonNote->"GoldOchre"], 
          ButtonBox[" ",
            ButtonData:>"MarsYellow",
            Background->RGBColor[0.889998, 0.439994, 0.0999924],
            ButtonNote->"MarsYellow"], 
          ButtonBox[" ",
            ButtonData:>"Apricot",
            Background->RGBColor[1, 0.340002, 0.129992],
            ButtonNote->"Apricot"], 
          ButtonBox[" ",
            ButtonData:>"YellowOchre",
            Background->RGBColor[0.889998, 0.510002, 0.0899977],
            ButtonNote->"YellowOchre"]},
        {
          ButtonBox[" ",
            ButtonData:>"Orange",
            Background->RGBColor[1, 0.500008, 0],
            ButtonNote->"Orange"], 
          ButtonBox[" ",
            ButtonData:>"VioletRed",
            Background->RGBColor[0.815702, 0.125505, 0.564706],
            ButtonNote->"VioletRed"], 
          ButtonBox[" ",
            ButtonData:>"DarkOrange",
            Background->RGBColor[1, 0.549004, 0],
            ButtonNote->"DarkOrange"], 
          ButtonBox[" ",
            ButtonData:>"Peru",
            Background->RGBColor[0.803906, 0.521614, 0.247089],
            ButtonNote->"Peru"], 
          ButtonBox[" ",
            ButtonData:>"Goldenrod",
            Background->RGBColor[0.854902, 0.647105, 0.125505],
            ButtonNote->"Goldenrod"], 
          ButtonBox[" ",
            ButtonData:>"Carrot",
            Background->RGBColor[0.930007, 0.570001, 0.129992],
            ButtonNote->"Carrot"], 
          ButtonBox[" ",
            ButtonData:>"DeepPink",
            Background->RGBColor[1, 0.0784009, 0.576501],
            ButtonNote->"DeepPink"]},
        {
          ButtonBox[" ",
            ButtonData:>"Tomato",
            Background->RGBColor[1, 0.38819, 0.278401],
            ButtonNote->"Tomato"], 
          ButtonBox[" ",
            ButtonData:>"CadmiumYellow",
            Background->RGBColor[1, 0.6, 0.0699931],
            ButtonNote->"CadmiumYellow"], 
          ButtonBox[" ",
            ButtonData:>"Beige",
            Background->RGBColor[0.640009, 0.580011, 0.500008],
            ButtonNote->"Beige"], 
          ButtonBox[" ",
            ButtonData:>"DeepNaplesYellow",
            Background->RGBColor[1, 0.659998, 0.0699931],
            ButtonNote->"DeepNaplesYellow"], 
          ButtonBox[" ",
            ButtonData:>"Oak",
            Background->RGBColor[1, 0.489998, 0.250004],
            ButtonNote->"Oak"], 
          ButtonBox[" ",
            ButtonData:>"LightCadmiumYellow",
            Background->RGBColor[1, 0.689998, 0.0599985],
            ButtonNote->"LightCadmiumYellow"], 
          ButtonBox[" ",
            ButtonData:>"AureolineYellow",
            Background->RGBColor[1, 0.659998, 0.140002],
            ButtonNote->"AureolineYellow"]},
        {
          ButtonBox[" ",
            ButtonData:>"Coral",
            Background->RGBColor[1, 0.497993, 0.313695],
            ButtonNote->"Coral"], 
          ButtonBox[" ",
            ButtonData:>"RosyBrown",
            Background->RGBColor[0.737301, 0.5608, 0.5608],
            ButtonNote->"RosyBrown"], 
          ButtonBox[" ",
            ButtonData:>"PaleVioletRed",
            Background->RGBColor[0.858808, 0.4392, 0.576501],
            ButtonNote->"PaleVioletRed"], 
          ButtonBox[" ",
            ButtonData:>"YellowBrown",
            Background->RGBColor[0.859998, 0.579995, 0.439994],
            ButtonNote->"YellowBrown"], 
          ButtonBox[" ",
            ButtonData:>"Salmon",
            Background->RGBColor[0.980407, 0.502007, 0.447089],
            ButtonNote->"Salmon"], 
          ButtonBox[" ",
            ButtonData:>"LightCoral",
            Background->RGBColor[0.941207, 0.502007, 0.502007],
            ButtonNote->"LightCoral"], 
          ButtonBox[" ",
            ButtonData:>"Melon",
            Background->RGBColor[0.889998, 0.659998, 0.409995],
            ButtonNote->"Melon"]},
        {
          ButtonBox[" ",
            ButtonData:>"SandyBrown",
            Background->RGBColor[0.956893, 0.643107, 0.376501],
            ButtonNote->"SandyBrown"], 
          ButtonBox[" ",
            ButtonData:>"LightSalmon",
            Background->RGBColor[1, 0.627512, 0.478386],
            ButtonNote->"LightSalmon"], 
          ButtonBox[" ",
            ButtonData:>"HotPink",
            Background->RGBColor[1, 0.411795, 0.705898],
            ButtonNote->"HotPink"], 
          ButtonBox[" ",
            ButtonData:>"Burlywood",
            Background->RGBColor[0.870604, 0.721599, 0.529412],
            ButtonNote->"Burlywood"], 
          ButtonBox[" ",
            ButtonData:>"LightPink",
            Background->RGBColor[1, 0.71371, 0.756909],
            ButtonNote->"LightPink"], 
          ButtonBox[" ",
            ButtonData:>"Wheat",
            Background->RGBColor[0.9608, 0.870604, 0.702007],
            ButtonNote->"Wheat"], 
          ButtonBox[" ",
            ButtonData:>"Navajo",
            Background->RGBColor[1, 0.870604, 0.678401],
            ButtonNote->"Navajo"]},
        {
          ButtonBox[" ",
            ButtonData:>"Pink",
            Background->RGBColor[1, 0.752911, 0.796109],
            ButtonNote->"Pink"], 
          ButtonBox[" ",
            ButtonData:>"PeachPuff",
            Background->RGBColor[1, 0.854902, 0.725505],
            ButtonNote->"PeachPuff"], 
          ButtonBox[" ",
            ButtonData:>"Moccasin",
            Background->RGBColor[1, 0.894102, 0.709804],
            ButtonNote->"Moccasin"], 
          ButtonBox[" ",
            ButtonData:>"Bisque",
            Background->RGBColor[1, 0.898054, 0.771847],
            ButtonNote->"Bisque"], 
          ButtonBox[" ",
            ButtonData:>"Eggshell",
            Background->RGBColor[0.990005, 0.900008, 0.790005],
            ButtonNote->"Eggshell"], 
          ButtonBox[" ",
            ButtonData:>"BlanchedAlmond",
            Background->RGBColor[1, 0.921599, 0.803906],
            ButtonNote->"BlanchedAlmond"], 
          ButtonBox[" ",
            ButtonData:>"Antique",
            Background->RGBColor[0.980575, 0.922332, 0.844663],
            ButtonNote->"Antique"]},
        {
          ButtonBox[" ",
            ButtonData:>"PapayaWhip",
            Background->RGBColor[1, 0.937301, 0.835309],
            ButtonNote->"PapayaWhip"], 
          ButtonBox[" ",
            ButtonData:>"MistyRose",
            Background->RGBColor[1, 0.894102, 0.882399],
            ButtonNote->"MistyRose"], 
          ButtonBox[" ",
            ButtonData:>"Linen",
            Background->RGBColor[0.980407, 0.941207, 0.902007],
            ButtonNote->"Linen"], 
          ButtonBox[" ",
            ButtonData:>"OldLace",
            Background->RGBColor[0.992203, 0.9608, 0.902007],
            ButtonNote->"OldLace"], 
          ButtonBox[" ",
            ButtonData:>"Seashell",
            Background->RGBColor[1, 0.9608, 0.933303],
            ButtonNote->"Seashell"], 
          ButtonBox[" ",
            ButtonData:>"LavenderBlush",
            Background->RGBColor[1, 0.941207, 0.9608],
            ButtonNote->"LavenderBlush"], 
          ButtonBox[" ",
            ButtonData:>"Floral",
            Background->RGBColor[1, 0.980407, 0.941207],
            ButtonNote->"Floral"]},
        {
          ButtonBox[" ",
            ButtonData:>"NavyBlue",
            Background->RGBColor[0, 0, 0.502007],
            ButtonNote->"NavyBlue"], 
          ButtonBox[" ",
            ButtonData:>"Navy",
            Background->RGBColor[0, 0, 0.502007],
            ButtonNote->"Navy"], 
          ButtonBox[" ",
            ButtonData:>"MidnightBlue",
            Background->RGBColor[0.0979934, 0.0979934, 0.4392],
            ButtonNote->"MidnightBlue"], 
          ButtonBox[" ",
            ButtonData:>"Ultramarine",
            Background->RGBColor[0.0699931, 0.0399939, 0.560006],
            ButtonNote->"Ultramarine"], 
          ButtonBox[" ",
            ButtonData:>"PrussianBlue",
            Background->RGBColor[0.179995, 0.179995, 0.310002],
            ButtonNote->"PrussianBlue"], 
          ButtonBox[" ",
            ButtonData:>"MediumBlue",
            Background->RGBColor[0, 0, 0.803906],
            ButtonNote->"MediumBlue"], 
          ButtonBox[" ",
            ButtonData:>"UltramarineViolet",
            Background->RGBColor[0.359991, 0.140002, 0.429999],
            ButtonNote->"UltramarineViolet"]},
        {
          ButtonBox[" ",
            ButtonData:>"Blue",
            Background->RGBColor[0, 0, 1],
            ButtonNote->"Blue"], 
          ButtonBox[" ",
            ButtonData:>"DarkSlateBlue",
            Background->RGBColor[0.282399, 0.2392, 0.545113],
            ButtonNote->"DarkSlateBlue"], 
          ButtonBox[" ",
            ButtonData:>"Cobalt",
            Background->RGBColor[0.239994, 0.349996, 0.670008],
            ButtonNote->"Cobalt"], 
          ButtonBox[" ",
            ButtonData:>"DeepCobaltViolet",
            Background->RGBColor[0.570001, 0.129992, 0.620005],
            ButtonNote->"DeepCobaltViolet"], 
          ButtonBox[" ",
            ButtonData:>"DarkViolet",
            Background->RGBColor[0.580407, 0, 0.827497],
            ButtonNote->"DarkViolet"], 
          ButtonBox[" ",
            ButtonData:>"Violet",
            Background->RGBColor[0.560006, 0.370001, 0.6],
            ButtonNote->"Violet"], 
          ButtonBox[" ",
            ButtonData:>"RoyalBlue",
            Background->RGBColor[0.254902, 0.411795, 0.882399],
            ButtonNote->"RoyalBlue"]},
        {
          ButtonBox[" ",
            ButtonData:>"SlateBlue",
            Background->RGBColor[0.415686, 0.352895, 0.803906],
            ButtonNote->"SlateBlue"], 
          ButtonBox[" ",
            ButtonData:>"DarkOrchid",
            Background->RGBColor[0.6, 0.196094, 0.8],
            ButtonNote->"DarkOrchid"], 
          ButtonBox[" ",
            ButtonData:>"BlueViolet",
            Background->RGBColor[0.541207, 0.168597, 0.886305],
            ButtonNote->"BlueViolet"], 
          ButtonBox[" ",
            ButtonData:>"Purple",
            Background->RGBColor[0.627512, 0.125505, 0.941207],
            ButtonNote->"Purple"], 
          ButtonBox[" ",
            ButtonData:>"MediumSlateBlue",
            Background->RGBColor[0.482399, 0.407797, 0.933303],
            ButtonNote->"MediumSlateBlue"], 
          ButtonBox[" ",
            ButtonData:>"MediumPurple",
            Background->RGBColor[0.576501, 0.4392, 0.858808],
            ButtonNote->"MediumPurple"], 
          ButtonBox[" ",
            ButtonData:>"MediumOrchid",
            Background->RGBColor[0.729412, 0.333288, 0.827497],
            ButtonNote->"MediumOrchid"]},
        {
          ButtonBox[" ",
            ButtonData:>"LightSlateBlue",
            Background->RGBColor[0.517601, 0.4392, 1],
            ButtonNote->"LightSlateBlue"], 
          ButtonBox[" ",
            ButtonData:>"Magenta",
            Background->RGBColor[1, 0, 1],
            ButtonNote->"Magenta"], 
          ButtonBox[" ",
            ButtonData:>"Orchid",
            Background->RGBColor[0.854902, 0.4392, 0.8392],
            ButtonNote->"Orchid"], 
          ButtonBox[" ",
            ButtonData:>"Plum",
            Background->RGBColor[0.866697, 0.627512, 0.866697],
            ButtonNote->"Plum"], 
          ButtonBox[" ",
            ButtonData:>"Thistle",
            Background->RGBColor[0.847105, 0.749004, 0.847105],
            ButtonNote->"Thistle"], 
          ButtonBox[" ",
            ButtonData:>"Lavender",
            Background->RGBColor[0.902007, 0.902007, 0.980407],
            ButtonNote->"Lavender"], 
          ButtonBox[" ",
            ButtonData:>"Indigo",
            Background->RGBColor[0.0299992, 0.179995, 0.329992],
            ButtonNote->"Indigo"]},
        {
          ButtonBox[" ",
            ButtonData:>"DarkSlateGray",
            Background->RGBColor[0.184298, 0.309789, 0.309789],
            ButtonNote->"DarkSlateGray"], 
          ButtonBox[" ",
            ButtonData:>"SteelBlue",
            Background->RGBColor[0.274495, 0.509789, 0.705898],
            ButtonNote->"SteelBlue"], 
          ButtonBox[" ",
            ButtonData:>"SlateGray",
            Background->RGBColor[0.4392, 0.502007, 0.564706],
            ButtonNote->"SlateGray"], 
          ButtonBox[" ",
            ButtonData:>"Cerulean",
            Background->RGBColor[0.0200046, 0.719997, 0.8],
            ButtonNote->"Cerulean"], 
          ButtonBox[" ",
            ButtonData:>"LightSlateGray",
            Background->RGBColor[0.466697, 0.533303, 0.6],
            ButtonNote->"LightSlateGray"], 
          ButtonBox[" ",
            ButtonData:>"CadetBlue",
            Background->RGBColor[0.372488, 0.619608, 0.627512],
            ButtonNote->"CadetBlue"], 
          ButtonBox[" ",
            ButtonData:>"Peacock",
            Background->RGBColor[0.2, 0.629999, 0.790005],
            ButtonNote->"Peacock"]},
        {
          ButtonBox[" ",
            ButtonData:>"DarkTurquoise",
            Background->RGBColor[0, 0.807797, 0.819608],
            ButtonNote->"DarkTurquoise"], 
          ButtonBox[" ",
            ButtonData:>"DodgerBlue",
            Background->RGBColor[0.117601, 0.564706, 1],
            ButtonNote->"DodgerBlue"], 
          ButtonBox[" ",
            ButtonData:>"DeepSkyBlue",
            Background->RGBColor[0, 0.749004, 1],
            ButtonNote->"DeepSkyBlue"], 
          ButtonBox[" ",
            ButtonData:>"CornflowerBlue",
            Background->RGBColor[0.392187, 0.584314, 0.929397],
            ButtonNote->"CornflowerBlue"], 
          ButtonBox[" ",
            ButtonData:>"Cyan",
            Background->RGBColor[0, 1, 1],
            ButtonNote->"Cyan"], 
          ButtonBox[" ",
            ButtonData:>"SkyBlue",
            Background->RGBColor[0.529412, 0.807797, 0.921599],
            ButtonNote->"SkyBlue"], 
          ButtonBox[" ",
            ButtonData:>"LightSkyBlue",
            Background->RGBColor[0.529412, 0.807797, 0.980407],
            ButtonNote->"LightSkyBlue"]},
        {
          ButtonBox[" ",
            ButtonData:>"LightSteelBlue",
            Background->RGBColor[0.690211, 0.768597, 0.870604],
            ButtonNote->"LightSteelBlue"], 
          ButtonBox[" ",
            ButtonData:>"LightBlue",
            Background->RGBColor[0.678401, 0.847105, 0.902007],
            ButtonNote->"LightBlue"], 
          ButtonBox[" ",
            ButtonData:>"PowderBlue",
            Background->RGBColor[0.690211, 0.878401, 0.902007],
            ButtonNote->"PowderBlue"], 
          ButtonBox[" ",
            ButtonData:>"PaleTurquoise",
            Background->RGBColor[0.686305, 0.933303, 0.933303],
            ButtonNote->"PaleTurquoise"], 
          ButtonBox[" ",
            ButtonData:>"CyanWhite",
            Background->RGBColor[0.878401, 1, 1],
            ButtonNote->"CyanWhite"], 
          ButtonBox[" ",
            ButtonData:>"AliceBlue",
            Background->RGBColor[0.941207, 0.972503, 1],
            ButtonNote->"AliceBlue"], 
          ButtonBox[" ",
            ButtonData:>"Azure",
            Background->RGBColor[0.941741, 1, 1],
            ButtonNote->"Azure"]},
        {
          ButtonBox[" ",
            ButtonData:>"Black",
            Background->GrayLevel[0],
            ButtonNote->"Black"], 
          ButtonBox[" ",
            ButtonData:>"IvoryBlack",
            Background->RGBColor[0.159991, 0.140002, 0.129992],
            ButtonNote->"IvoryBlack"], 
          ButtonBox[" ",
            ButtonData:>"DimGray",
            Background->GrayLevel[0.333333],
            ButtonNote->"DimGray"], 
          ButtonBox[" ",
            ButtonData:>"LightGray",
            Background->GrayLevel[0.666667],
            ButtonNote->"LightGray"], 
          ButtonBox[" ",
            ButtonData:>"Gray",
            Background->GrayLevel[0.752911],
            ButtonNote->"Gray"], 
          ButtonBox[" ",
            ButtonData:>"Gainsboro",
            Background->GrayLevel[0.862699],
            ButtonNote->"Gainsboro"], 
          ButtonBox[" ",
            ButtonData:>"Smoke",
            Background->GrayLevel[0.9608],
            ButtonNote->"Smoke"]},
        {
          ButtonBox[" ",
            ButtonData:>"Ghost",
            Background->RGBColor[0.972503, 0.972503, 1],
            ButtonNote->"Ghost"], 
          ButtonBox[" ",
            ButtonData:>"Zinc",
            Background->RGBColor[0.990005, 0.970001, 1],
            ButtonNote->"Zinc"], 
          ButtonBox[" ",
            ButtonData:>"Snow",
            Background->RGBColor[1, 0.980407, 0.980407],
            ButtonNote->"Snow"], 
          ButtonBox[" ",
            ButtonData:>"White",
            Background->GrayLevel[1],
            ButtonNote->"White"], 
          ButtonBox[
            StyleBox["C",
              FontFamily->"Helvetica",
              FontSize->10,
              FontWeight->"Bold"],
            ButtonData:>BoxData[ 
                RowBox[ {
                  RowBox[ {"ColorMix", "[", 
                    
                    RowBox[ {"\[SelectionPlaceholder]", ",", 
                      "\[Placeholder]"}], "]"}], "[", "\[Placeholder]", 
                  "]"}]],
            Active->True,
            ButtonStyle->"Paste",
            Background->RGBColor[1, 0.843107, 0],
            ButtonNote->"ColorMix"], 
          ButtonBox[
            StyleBox["D",
              FontFamily->"Helvetica",
              FontSize->10,
              FontWeight->"Bold"],
            ButtonFunction:>Module[ {
                Set[ nb1, 
                  InputNotebook[ ]]}, 
                CompoundExpression[ 
                  NotebookFind[ nb1, "Graphics", All, CellStyle], 
                  NotebookDelete[ nb1]]],
            ButtonEvaluator->Automatic,
            Active->True,
            Background->RGBColor[1, 0.843107, 0],
            ButtonNote->"Delete Graphics"], 
          ButtonBox[
            StyleBox["A",
              FontFamily->"Helvetica",
              FontSize->10,
              FontWeight->"Bold"],
            ButtonData:>BoxData[ {
                RowBox[ {"SelectionMove", "[", 
                  RowBox[ {
                    RowBox[ {"EvaluationNotebook", "[", "]"}], ",", "All", 
                    ",", "GeneratedCell"}], "]"}], "\n", 
                RowBox[ {
                  
                  RowBox[ {"FrontEndTokenExecute", "[", "\"OpenCloseGroup\"", 
                    "]"}], ";", 
                  RowBox[ {"Pause", "[", "0.5", "]"}], ";"}], "\n", 
                RowBox[ {"FrontEndExecute", "[", 
                  RowBox[ {"{", 
                    RowBox[ {"FrontEnd`SelectionAnimate", "[", 
                      RowBox[ {"200", ",", 
                        RowBox[ {"AnimationDisplayTime", "\[Rule]", "0.1"}], 
                        ",", 
                        
                        RowBox[ {"AnimationDirection", "\[Rule]", 
                          "Forward"}]}], "]"}], "}"}], "]"}]}],
            Active->True,
            ButtonStyle->"Paste",
            Background->RGBColor[1, 0.843107, 0],
            ButtonNote->"Animate Commands"]}
        },
      RowSpacings->0.2,
      ColumnSpacings->0.2,
      ColumnWidths->1.7,
      ColumnAlignments->{Center},
      RowMinHeight->1.3,
      RowsEqual->True,
      ColumnsEqual->True]], NotebookDefault,
  CellMargins->{{Inherited, Inherited}, {5, Inherited}},
  Evaluatable->True,
  CellGroupingRules->"InputGrouping",
  CellHorizontalScrolling->True,
  PageBreakAbove->True,
  PageBreakWithin->False,
  GroupPageBreakWithin->False,
  GeneratedCell->True,
  CellAutoOverwrite->True,
  CellLabelMargins->{{23, Inherited}, {Inherited, Inherited}},
  DefaultFormatType->DefaultInputFormatType,
  LineSpacing->{1.25, 0},
  AutoItalicWords->{},
  FormatType->InputForm,
  ScriptMinSize->9,
  ShowStringCharacters->True,
  NumberMarks->True,
  CounterIncrements->"Input",
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->10,
  FontWeight->"Plain"]
},
FrontEndVersion->"5.0 for Microsoft Windows",
ScreenRectangle->{{0, 1024}, {0, 677}},
ClosingAutoSave->True,
WindowToolbars->{},
PageWidth->335,
WindowSize->{Fit, Fit},
WindowMargins->{{Automatic, 408}, {Automatic, 30}},
WindowFrame->"Palette",
WindowElements->"StatusArea",
WindowFrameElements->"CloseBox",
WindowClickSelect->False,
ScrollingOptions->{"PagewiseScrolling"->True,
"VerticalScrollRange"->Fit},
ShowCellBracket->False,
CellMargins->{{0, 0}, {Inherited, 0}},
Active->True,
CellOpen->True,
ShowCellLabel->False,
ShowCellTags->False,
ImageMargins->{{0, Inherited}, {Inherited, 0}},
Background->GrayLevel[0.900008],
Magnification->1
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1755, 51, 34673, 889, 510, NotebookDefault,
  Evaluatable->True,
  CellGroupingRules->"InputGrouping",
  PageBreakAbove->True,
  PageBreakWithin->False,
  CounterIncrements->"Input"]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

